=== modified file 'CHANGES'
--- CHANGES	2009-11-12 16:17:40 +0000
+++ CHANGES	2010-06-10 18:02:54 +0000
@@ -2,12 +2,183 @@
 that have been applied in released versions.  Please see the NEWS file for
 a summary of the major changes, and the ChangeLog file for a comprehensive
 listing of all changes made to the code. 
-
-* 5.4.2.1 *
-    snmpd:
-      - SECURITY ISSUE: A bug in the getbulk handling code could let
-        anyone with even minimal access crash the agent.
       
+* 5.4.3 *
+
+    snmplib:
+      - [BUG 2838243]: Correct the output of unsigned values.
+      - [BUG 2919320]: Avoid accessing freed memory
+      - [BUG 2922390]: Fix test for missing contextName parameter
+      - [PATCH 2043018]: fix recvfrom hangs
+      - [PATCH 2258229]: Remove misleading comment
+      - [PATCH 2479700]: Fix zoned IP address used as table indices
+      - [PATCH 2492377]: Fix typo/bug in snmp_enable_callback()
+      - [PATCH 2505488]: Fix alarm behaviour on large clock skews
+      - [PATCH 2538169]: Prevent infinite retries for invalid error-index
+      - [PATCH 2688345]: Fix netsnmp_assert() for Visual Studio
+      - [PATCH 2689362]: Fix handling of IPv6 hostnames
+      - [PATCH 2713841]: Fix runtime errors triggered by high-ASCII chars
+      - [PATCH 2780411]: Fix compiler warnings
+      - [PATCH 2797251]: Fix memory leaks
+      - [PATCH 2871747]: Fix memory leak in OID processing
+      - [PATCH 2952140]: Overflow counter32 and gauge32
+      - [PATCH 2952034]: Return of the Great SuSE 'sprintf' Hunt
+      - Change the parsing of ranges to accept all valid values
+      - Ensure O_CREATE mask is always specified
+      - Fix extern "C" wrapping
+      - Make -LN stop dumping core.
+      - Make bad debug levels report the offending symbol
+      - Remove inline declarations for non-inline defined functions
+
+    snmpd:
+      - [BUG 1693039]: Be silent when insert fails.
+      - [BUG 2822360]: Fix memory leak when building table OIDs
+      - [BUG 2841008]: Protect against crash following failed AgentX response
+      - [BUG 2873858]: Fix handling of schedOwner index.
+      - [BUG 2894059]: Handle errors when counting interfaces
+      - [BUG 2897000]: Suppress 32-bit counter truncation warnings.
+      - [BUG 2914410]: Fix crash on empty command lines
+      - [BUG 2924140]: Fix termination of CPU/FPU types
+      - [PATCH 1257347]: Non-fixed size connection buffer
+      - [PATCH 1550730]: Report errors from iterator-based handlers
+      - [PATCH 1977439]: Fix pass/_persist bug with SET oid value
+      - [PATCH 2012402]: Handle failure to look up interface error counters
+      - [PATCH 2082726]: correctly report NIC speeds higher than 4Gbit/s
+      - [PATCH 2124288]: Fix setting of usmUserPrivProtocol at creation
+      - [PATCH 2162652]: Fix simple hrfs checks when NFS is in use
+      - [PATCH 2384779]: Fix handling of GetBulk with N>0,M==0
+      - [PATCH 2686280]: Report duplicate registrations as an error
+      - [PATCH 2693670]: Don't open AgentX sockets if other transports fail
+      - [PATCH 2791417]: Fix snmpd segfault when run with -DALL
+      - [PATCH 2797251]: Support multiple initialisation and shutdown
+      - [PATCH 2822337]: Fix memory leak in ipAddressPrefixTable
+      - [PATCH 2877518]: Fix handling of scoped AgentX variables
+      - [PATCH 2883155]: Fix memory leak in proxy handling.
+      - [PATCH 2887816]: Protect against division-by-zero crash
+      - [PATCH 2901029]: Fix compiler warning on CloseHandle()
+      - [PATCH 2911323]: Fix agent lockup when monitoring AgentX-delegated information
+      - [PATCH 2912584]: Fix null OID handling in Agentx on 64bit
+      - [PATCH 2950845]: Fix ifHighSpeed calculation
+      - [PATCH 2952034]: Return of the Great SuSE 'sprintf' Hunt
+      - [PATCH 2956657]: Handle over-length AgentX OIDs
+      - [PATCH 2968642]: Catch overflow of pass-through command buffer
+      - Allow "monitor" to handle negative threshold values
+      - Change default AgentX target from 0.0.0.0:705 to localhost:705
+      - Clean up notification
+      - Ensure O_CREATE mask is always specified
+      - Fix agent crash when sending encrypted SNMPv3 traps
+      - Fix CVE-2008-4309 (GETBULK issue reported by Oscar Mira-Sanchez)
+      - Fix creation of views using snmpusm
+      - Fix handling of multiple matching VACM entries
+      - Fix invalid access to memory in TCP-MIB
+      - Fix logging of 'truncating integer values' in IP-MIB and TCP-MIB
+      - Fix memory leak when multiple interfaces have the same IPv6 address
+      - Fix possible crash when 64-bit counters exceed 2^32
+      - Fix two bugs with smux password support
+      - Fix udpTable indexes on big-endian 64bit Linux.
+      - Improve parsing of -LS command line argument
+      - Latch large-disk statistics at 2Tb (rather than wrapping)
+      - Register CPU/memory hardware modules with nsCacheTable
+      - Remove inline declarations for non-inline defined functions
+      - Report ifSpeed of down network interfaces
+      - Support large HW addresses (>6bytes)
+
+    snmptrapd:
+      - [PATCH 2726302]: Pass results of Perl trap handlers to trap daemon
+      - Remove glibc-specific printf-formatting tokens
+
+    snmptable:
+      - [BUG 2837998]: Handle missing instance subidentifiers in results
+      - [PATCH 2850067]: Suppress extraneous "index" header token
+
+    apps:
+      - [BUG 2811577]: Fix bug in GetBulk handling
+      - [PATCH 2937996]: Add Date: header to email send by traptoemail
+      - Improve parsing of -LS command line argument
+
+    build:
+      - [BUG 2095983]: Fix errors in find-requires helper script
+      - [BUG 2782700]: Build failure when using --with-pkcs on Solaris
+      - [PATCH 2184039]: Misc fixes for freeing memory
+      - [PATCH 2952020]: Set permission on testing directories
+      - 'make test TESTOPTS="-P tcp"' works fine now
+
+    docs:
+      - [PATCH 2788072]: Document 'logmatch' functionality.
+      - [PATCH 2795739]: Fix incorrect disk/file size descriptions & unit specifiers
+
+    mib2c:
+      - [BUG 2827269]: Suppress non-ordered TODO comments
+      - [BUG 2888569]: Fix generation of table columns array
+      - [PATCH 2136437]: Improve 64-bit handling of large table FLAG defines 
+      - [PATCH 2316127]: Fix bug in iterate_access generated code.
+
+    mibs:
+      - [BUG 2973890]: Fix imports, DiskIOEntry list and revision histories
+
+    perl:
+      - [BUG 1554817]: Fix class assigment so getRootOID works properly
+      - [PATCH 2022948]: Fix for Counter64 in perl subagent
+      - [PATCH 2182079]: Fix various warnings & allow use of "use strict"
+      - [PATCH 2361712]: Fix getbulk optimization during walks
+      - [PATCH 2793857]: Report failed asynchronous requests
+      - [PATCH 2890931]: Better handling of Counter64 values.
+
+    python:
+      - [BUG 2258935]: Python Extension Module fails on Solaris
+      - [BUG 2919379]: Initialise SNMP sessions properly
+      - [PATCH 2074817]: Fix regexp engine CPU performance issues
+      - [PATCH 2260828]: Fix python snmpwalk memory leak
+      - [PATCH 2580979]: Fix python session pointers on 64-bit systems
+      - [PATCH 2667415]: Support "UseNumeric" option
+      - Support null-bytes in octet strings
+
+
+    AIX:
+      - [BUG 2712670]: Agent crashes on AIX with hrStorage
+
+    *BSD:
+      - [PATCH 2435793]: Support 64-bit IF-MIB counters on sysctl systems
+      - Fix a make test
+
+    HP-UX:
+      - [BUG 2779472]: Filesystems missing in hrStorage table (HP-UX 11.31)
+      - [PATCH 2088726]: Fix an issue reporting negative memory values
+
+    Linux:
+      - [BUG 2822355]: Fix memory leaks on udpEndpointTable
+      - [PATCH 2926374]: Fix /proc/net/if_inet6 reading of ipAddressTable
+      - Fix build on modern distributions (using rpm-4.6)
+      - fix rare race condition when reading RPM database
+
+    Solaris:
+      - [PATCH 2012404]: Deal with more than 10 interfaces
+      - [PATCH 2406378]: Fix hrSWRunPerfMem on 64-bit Solaris systems
+      - [PATCH 2751588]: Inconsistent data (e.g. UDP/TCP MIB scalar values
+	of zero) can be reported on Solaris 10U4+
+      - Protect against missing package version
+
+    Windows:
+      - [BUG 2997492]: byte order of udpLocalPort is now correct
+      - [BUG 2971257]: Fixed winExtDLL handling of multi-varbind getNext requests.
+      - [BUG 2779541]: Fixed handle leak in pass_persist
+      - [PATCH 2686248]: Applied patch by Bart Van Assche
+      - [PATCH 2688342]: Fix various VS2005 compiler warnings
+      - [PATCH 2691876]: Applied patch by rdiez to allow
+      - [PATCH 2693746]: improved socket startup support
+      - Detect free UDP ports correctly for use in test infrastructure.
+      - Fix batch build using recent versions of Visual Studio.
+      - Fix builds with IPv6 support enabled
+      - Fix build under MinGW
+      - Fix winExtDLL build on Windows Vista, Windows 7
+      - Fix winExtDLL build with MinGW
+      - Simplify building Net-SNMP + winExtDLL with MSVC
+      - winExtDLL: Fixed a memory leak when SnmpExtensionQuery(Ex) fails
+      - winExtDLL: Log errors when loading an extension DLL fails
+      - winExtDLL: Use RFC-compliant error codes in SNMP response PDUs
+      - winExtDLL: Fix handling of multiple varbind SET requests
+
+
 * 5.4.2 *
 
     snmplib:

=== modified file 'COPYING'
--- COPYING	2009-11-12 16:17:40 +0000
+++ COPYING	2010-06-10 18:02:54 +0000
@@ -135,7 +135,7 @@
 
 ---- Part 5: Sparta, Inc copyright notice (BSD) -----
 
-Copyright (c) 2003-2008, Sparta, Inc
+Copyright (c) 2003-2010, Sparta, Inc
 All rights reserved.
  
 Redistribution and use in source and binary forms, with or without

=== modified file 'ChangeLog'
--- ChangeLog	2009-11-12 16:17:40 +0000
+++ ChangeLog	2010-06-10 18:02:54 +0000
@@ -1,14 +1,2496 @@
 -------------------------------------------------------------------------------
-
-Changes: V5.4.1 -> V5.4.2.1
-
-2008-10-31 15:16  hardaker
+Changes: V5.4.2 -> V5.4.3
+
+2010-05-23 20:42  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2010-05-23 20:39  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      snmplib/parse.c, snmplib/snmp_version.c:
+
+   Version number update
+
+2010-05-14 12:46  dts12
+
+   * CHANGES, NEWS:
+
+   version update
+
+2010-05-14 12:41  dts12
+
+   * ChangeLog:
+
+   version update
+
+2010-05-14 12:28  dts12
+
+   * snmplib/Makefile.depend:
+
+   make depend
+
+2010-05-14 12:19  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2010-05-14 12:10  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      snmplib/snmp_version.c:
+
+   Version number update
+
+2010-05-11 17:26  bvassche
+
+   * perl/agent/agent.xs:
+
+   Builds again with the Microsoft Visual C compilers, which do not
+   recognize the C99 ULL suffix.
+
+2010-05-11 15:46  dts12
+
+   * win32/libsnmp_dll/libsnmp.def, win32/libsnmp_dll/libsnmp.def.in:
+
+   Ensure 'netsnmp_read_module' is available for perl build.
+
+2010-05-11 15:44  dts12
+
+   * perl/agent/agent.xs:
+
+   Fix perl build under Windows (strtoull not available)
+
+2010-05-09 16:34  bvassche
+
+   * include/net-snmp/system/cygwin.h:
+
+   CHANGES: Cygwin: BUG: 2997492: byte order of udpLocalPort is now correct
+   (Backported r18074 from trunk.)
+
+2010-05-06 14:49  dts12
+
+   * snmplib/inet_ntop.c, snmplib/inet_pton.c:
+
+   Don't assume the presence of <string.h>
+   (bring into line with all other occurances)
+
+2010-05-06 14:44  dts12
+
+   * win32/win32.dsw, win32/win32sdk.dsw:
+
+   Add project dependencies for MSVC builds.
+
+2010-05-06 06:33  bvassche
+
+   *  net-snmp-config.in, testing/TESTCONF.sh,   
+      testing/tests/T030snmpv3usercreation,   
+      testing/tests/T115agentxperl:
+
+   CHANGES: Cygwin: Detect free UDP ports correctly for use in test infrastructure.
+   (Backported trunk r18073 and r18080).
+
+2010-04-30 19:10  bvassche
+
+   *  agent/mibgroup/mibII/system_mib.c, apps/snmptrapd.c,   
+      apps/snmptrapd_log.c, snmplib/callback.c:
+
+   CHANGES: Windows: Fix build under MinGW
+
+2010-04-30 18:44  bvassche
+
+   * configure:
+
+   Should have been included in r18627.
+
+2010-04-30 18:27  bvassche
+
+   * configure.in:
+
+   made sure that cross-compiling without specifying the endianness
+   does not trigger a syntax error in the configure script.
+
+2010-04-28 10:48  bvassche
+
+   * configure, configure.in:
+
+   left out inet_ntop() and inet_pton() from libnetsnmp since these
+   functions are already present in Cygwins C library.
+
+2010-04-28 10:26  bvassche
+
+   * README.win32:
+
+   Fixed a documentation bug with regard to the Cygwin build:
+   linking with ws2_32 is only necessary for really ancient Cygwin versions.
+
+2010-04-28 07:29  bvassche
+
+   *  snmplib/inet_ntop.c, snmplib/inet_pton.c,   
+      snmplib/snmpTCPIPv6Domain.c, snmplib/snmpUDPIPv6Domain.c:
+
+   CHANGES: Cygwin: builds now with IPv6 support enabled.
+
+2010-04-27 16:55  bvassche
+
+   *  win32/net-snmp/net-snmp-config.h,   
+      win32/net-snmp/net-snmp-config.h.in:
+
+   CHANGES: Win32: builds again with IPv6 support enabled.
+
+2010-04-27 15:42  dts12
+
+   *  win32/net-snmp/agent/mib_module_config.h,   
+      win32/netsnmpmibssdk/Makefile.in:
+
+   Re-instate Notification-Log MIB support when building with
+   Windows Platform SDK.
+
+2010-04-25 17:37  bvassche
+
+   * README.win32:
+
+   Documentation update.
+
+2010-04-21 11:05  bvassche
+
+   * snmplib/strtoull.c:
+
+   Copied the source file snmplib/strtoull.c from the trunk to the
+   V5.4 branch.
+
+2010-04-18 13:40  bvassche
+
+   * snmplib/winpipe.c:
+
+   Added #include <net-snmp/net-snmp-config.h> in file
+   snmplib/winpipe.c such
+   that building on Windows doesn't trigger a warning about
+   including both
+   <stdargs.h> and <varargs.h> in the same source file.
+
+2010-04-18 13:24  bvassche
+
+   *  win32/net-snmp/net-snmp-config.h,   
+      win32/net-snmp/net-snmp-config.h.in:
+
+   Reverted another change that was introduced in r18495 and that's
+   obviously broken.
+
+2010-04-15 16:55  bvassche
+
+   * win32/net-snmp/net-snmp-config.h:
+
+   Partially reverted r18496:
+   - Commented out #define NETSNMP_USE_DLL again in file
+   win32/net-snmp/net-snmp-config.h on the 5.4 branch. This change
+   had been committed unintentionally.
+   - Re-enabled #define
+   USING_NOTIFICATION_LOG_MIB_NOTIFICATION_LOG_MODULE in
+   win32/net-snmp/agent/mib_module_config.h on the trunk and the
+   V5.5 branch. While build.bat reports an error on earlier branches
+   with this symbol enabled, there is no such problem on the trunk
+   or V5.5 branches and hence there was no reason to disable this
+   preprocessor symbol.
+
+2010-04-14 09:47  dts12
+
+   *  win32, win32/bin, win32/dist, win32/dist/htmlhelp,   
+      win32/dist/installer, win32/dist/scripts, win32/encode_keychange, 
+        win32/lib, win32/libagent, win32/libhelpers,   
+      win32/libnetsnmptrapd, win32/libsnmp, win32/libsnmp_dll,   
+      win32/libucdmibs, win32/local, win32/net-snmp,   
+      win32/net-snmp/agent, win32/net-snmp/library, win32/netsnmpmibs,  
+       win32/netsnmpmibssdk, win32/snmpbulkget, win32/snmpbulkwalk,   
+      win32/snmpd, win32/snmpdelta, win32/snmpdf, win32/snmpdsdk,   
+      win32/snmpget, win32/snmpgetnext, win32/snmpnetstat,   
+      win32/snmpset, win32/snmpstatus, win32/snmptable, win32/snmptest, 
+        win32/snmptranslate, win32/snmptrap, win32/snmptrapd,   
+      win32/snmpusm, win32/snmpvacm, win32/snmpwalk:
+
+   Don't try to SVN-manage the Windows batch build infrastructure
+   (add release, debug, Makefile to the previous ignore list)
+
+2010-04-14 08:16  dts12
+
+   * win32/libsnmp_dll/libsnmp.def, win32/libsnmp_dll/libsnmp.def.in:
+
+   Fix Windows batch build using Visual Studio with dynamic linking.
+   Unreferenced symbol introduced by SVN revision 18393
+
+2010-04-14 08:11  dts12
+
+   *  agent/mibgroup/mibII/interfaces.c,   
+      agent/mibgroup/mibII/interfaces.h:
+
+   Fix Windows batch build using Visual Studio 2008 with Platform
+   SDK enabled.
+
+2010-04-14 08:08  dts12
+
+   *  win32/build.pl, win32/net-snmp/agent/mib_module_config.h,   
+      win32/net-snmp/net-snmp-config.h,   
+      win32/net-snmp/net-snmp-config.h.in:
+
+   CHANGES: Win32: Fix batch build using recent versions of Visual Studio.
+   Partial back port of SVN revisions 17573 and 17696.
+
+2010-04-07 14:37  dts12
+
+   * CHANGES, NEWS:
+
+   version update
+
+2010-04-07 14:22  dts12
+
+   * agent/Makefile.depend, agent/mibgroup/Makefile.depend:
+
+   make depend
+
+2010-04-07 14:12  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2010-04-07 14:08  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      snmplib/snmp_version.c:
+
+   Version number update
+
+2010-04-07 14:05  dts12
+
+   * local/mib2c.table_data.conf:
+
+   Insert the cache helper correctly.
+
+2010-04-06 11:03  dts12
+
+   * FAQ:
+
+   Python is apparently client-side only.
+
+2010-04-06 08:56  dts12
+
+   * agent/mibgroup/ucd-snmp/disk.c, mibs/UCD-SNMP-MIB.txt:
+
+   NEWS: snmpd: Latch large-disk statistics at 2Tb (rather than
+   wrapping.
+
+2010-03-29 15:26  dts12
+
+   * agent/mibgroup/mibII/vacm_conf.c, snmplib/parse.c:
+
+   Include MIB directory search path in reports of missing MIB
+   files.
+   Include config file search path in reports of missing access
+   control settings.
+
+2010-03-29 15:20  dts12
+
+   * snmplib/vacm.c:
+
+   NEWS: snmpd: Fix handling of multiple matching VACM entries.
+   (Use the "best" match, rather than the first one).
+   Reported by Adam Lewis.
+   Note that this could potentially affect the behaviour of
+   existing access control configurations.
+
+2010-03-29 15:15  dts12
+
+   * snmplib/snmpusm.c:
+
+   CHANGES: snmplib: Fix agent crash when sending encrypted SNMPv3
+   traps.
+   Reported by Srikapilan Gandhi
+
+2010-03-25 20:07  bvassche
+
+   * agent/mibgroup/agentx/agentx_config.c:
+
+   CHANGES: agentx: changed default TCP target from 0.0.0.0:705 to
+   localhost:705. This is not only a more secure choice but it also
+   makes it possible on Windows systems to let an AgentX subagent
+   connect to an AgentX master agent running on the same system
+   without having to set the variable NETSNMP_DS_AGENT_X_SOCKET.
+
+2010-03-22 16:10  dts12
+
+   * mibs/NET-SNMP-PASS-MIB.txt:
+
+   Fix typo in default IpAddress value
+   (See Bug #2972141)
+
+2010-03-22 15:24  bvassche
+
+   * mibs/UCD-DISKIO-MIB.txt:
+
+   Follow-up for r18349: added missing comma such that it is again
+   possible to compile UCD-DISKIO-MIB.
+
+2010-03-22 13:49  dts12
+
+   *  mibs/UCD-DISKIO-MIB.txt, mibs/UCD-DLMOD-MIB.txt,   
+      mibs/UCD-IPFILTER-MIB.txt, mibs/UCD-SNMP-MIB.txt:
+
+   CHANGES: mibs: BUG: 2973890: Fix imports, DiskIOEntry list and
+   revision histories
+
+2010-03-22 11:55  bvassche
+
+   * agent/mibgroup/winExtDLL.c, include/net-snmp/library/snmp_api.h:
+
+   Win32, winExtDLL: solved the mystery of "ASN type zero". The
+   winExtDLL code does now no longer trigger conversions of Windows
+   ASN varbinds with ASN type zero. Note: this code change does not
+   change the agent behavior.
+
+2010-03-20 19:16  bvassche
+
+   * agent/mibgroup/winExtDLL.c:
+
+   Fixed the compiler warnings reported by gcc (MinGW).
+
+2010-03-19 12:40  bvassche
+
+   *  agent/mibgroup/winExtDLL.c, win32/libsnmp_dll/libsnmp.def,   
+      win32/libsnmp_dll/libsnmp.def.in:
+
+   CHANGES: Win32: winExtDLL: multiple varbind set requests are now
+   processed correctly.
+   CHANGES: Win32: winExtDLL: made error codes in SNMP response PDUs
+   as RFC-compliant as possible.
+   CHANGES: Win32: winExtDLL: if loading an extension DLL fails, the
+   reason why loading failed is now logged.
+   CHANGES: Win32: winExtDLL: fixed a memory leak that occurred when
+   SnmpExtensionQuery(Ex) failed. This memory leak has been found
+   via source reading. Note: it is not clear whether it was possible
+   to trigger this memory leak. This leak is certainly not triggered
+   by every request for which a response with non-zero error status
+   is sent back.
+
+2010-03-19 11:41  bvassche
+
+   * agent/snmp_agent.c:
+
+   Reverted r18324 since the 5.4 branch is in RC stage and a
+   leak-at-exit is not a showstopper.
+
+2010-03-17 13:41  bvassche
+
+   * mibs/NET-SNMP-AGENT-MIB.txt, mibs/NET-SNMP-EXTEND-MIB.txt:
+
+   Minor MIB fixes (backported r18320, r18321 and r18325).
+
+2010-03-17 13:29  bvassche
+
+   * agent/snmp_agent.c:
+
+   CHANGES: snmpd: fixed one leak-at-exit.
+
+2010-03-17 12:44  bvassche
+
+   * agent/mibgroup/winExtDLL.c:
+
+   CHANGES: BUG: 2971257: Fixed winExtDLL handling of multi-varbind
+   getNext requests with OIDs in reverse lexicographical order.
+
+2010-03-14 22:56  dts12
+
+   * CHANGES, NEWS:
+
+   version update
+
+2010-03-14 22:31  dts12
+
+   * ChangeLog:
+
+   version update
+
+2010-03-14 22:28  dts12
+
+   * agent/Makefile.depend, agent/mibgroup/Makefile.depend:
+
+   make depend
+
+2010-03-14 22:19  dts12
+
+   * agent/Makefile.depend, agent/mibgroup/Makefile.depend:
+
+   make depend
+
+2010-03-14 22:19  dts12
+
+   * agent/Makefile.depend, agent/mibgroup/Makefile.depend:
+
+   make depend
+
+2010-03-14 22:10  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2010-03-14 22:07  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      snmplib/snmp_version.c:
+
+   Version number update
+
+2010-03-12 11:53  dts12
+
+   * apps/snmptable.c:
+
+   CHANGES: snmptable: PATCH: 2850067: Suppress extraneous "index"
+   header token
+   Patch supplied by Dan Nelson
+
+2010-03-11 16:52  dts12
+
+   * man/snmpcmd.1.def:
+
+   Document the format of the -e/-E command line options.
+
+2010-03-11 16:47  dts12
+
+   * agent/helpers/table_dataset.c:
+
+   Remove mention of the (abandoned) 'dataset2' helper.
+
+2010-03-11 16:03  dts12
+
+   * testing/eval_suite.sh:
+
+   Use SNMP_TMPDIR instead of TMPDIR
+   Backport of revision 18262
+
+2010-03-11 15:08  dts12
+
+   *  agent/auto_nlist.c, agent/mibgroup/examples/ucdDemoPublic.c,   
+      apps/snmptest.c, snmplib/parse.c, snmplib/tools.c:
+
+   CHANGES: PATCH: 2952034: Return of the Great SuSE 'sprintf'
+   Hunt...
+   Patch supplied by Leonardo Chiquitto
+
+2010-03-11 14:55  dts12
+
+   * local/traptoemail:
+
+   CHANGES: PATCH: 2937996: Add Date: header to email send by
+   traptoemail
+
+2010-03-11 14:23  dts12
+
+   * agent/mibgroup/ucd-snmp/pass.c:
+
+   CHANGES: snmpd: PATCH: 2968642: Catch overflow of pass-through
+   command buffer.
+   Patch from Andreas Jaeger/Leonardo Chiquitto
+
+2010-03-11 12:37  dts12
+
+   * agent/mibgroup/agentx/protocol.c:
+
+   CHANGES: snmpd: PATCH: 2956657: Handle over-length AgentX OIDs.
+   Patch provided by Rob West
+
+2010-03-11 12:19  dts12
+
+   * agent/mibgroup/ucd-snmp/pass.c:
+
+   Suppress warnings of possible buffer overflow.
+   This doesn't _actually_ protect against such an overflow,
+   since the target buffer is non-empty, so strncat can't
+   use it all anyway. But this should at least mislead the
+   compiler sufficiently to shut it up!
+   
+   Patch provided by Andreas Jaeger.
+
+2010-03-11 11:57  dts12
+
+   * configure, configure.in:
+
+   Replace backquote with single quote in configure output message.
+   While this change is probably not strictly necessary, it feels
+   sensible to avoid this particular use of backquotes, Just In
+   Case.
+   See discussion in Patch #2952169
+
+2010-03-11 11:43  dts12
+
+   * snmplib/mib.c:
+
+   CHANGES: library: PATCH: 2952140: Overflow counter32 and gauge32
+   on 64bit systems correctly
+   Patch provided by Leonardo Chiquitto
+
+2010-03-11 11:36  dts12
+
+   * testing/TESTCONF.sh, testing/eval_suite.sh:
+
+   CHANGES: build: PATCH: 2952020: Explicitly set permission on
+   temporary testing output directories.
+   Patch provided by Leonardo Chiquitto.
+
+2010-03-11 11:26  dts12
+
+   * agent/mibgroup/if-mib/ifXTable/ifXTable.c:
+
+   CHANGES: snmpd: PATCH: 2950845: Fix ifHighSpeed calculation
+   Patch provided by Leonardo Chiquitto
+
+2010-03-03 16:11  jsafranek
+
+   * configure, include/net-snmp/net-snmp-config.h.in:
+
+   Regerate configure script after rev. 18193 (automatic RPM version
+   detection).
+   Net-SNMP should compile with rpm-4.6 automatically.
+
+2010-02-23 12:27  jsafranek
+
+   * configure.in:
+
+   CHANGES: building: Fixed compilation with rpm-4.6.
+   Turn on the legacy API when rpm-4.6 is detected.
+
+2010-02-10 10:04  dts12
+
+   * python/netsnmp/client_intf.c:
+
+   CHANGES: python: Support null-bytes in octet strings
+   Patch supplied by Tommy Beadle
+
+2010-02-09 15:05  bvassche
+
+   *  ., README.win32, agent/mibgroup/winExtDLL.c,   
+      agent/mibgroup/winExtDLL.h, win32/MgmtApi-winExtDLL.h,   
+      win32/Snmp-winExtDLL.h:
+
+   CHANGES: Win32: winExtDLL: works now on Windows Vista, Windows 7
+   and Windows 2008 too.
+   CHANGES: Win32: simplified building Net-SNMP + winExtDLL with
+   MSVC.
+   CHANGES: MinGW: winExtDLL: builds now.
+   Note: all these changes have been backported from the trunk.
+
+2010-02-09 14:29  bvassche
+
+   * include/net-snmp/library/snmp_logging.h:
+
+   CHANGES: Win32: added #include <stdio.h> in
+   include/net-snmp/library/snmp_logging.h such that Net-SNMP 5.5
+   builds again with Microsoft Visual Studio 6.
+
+2010-02-08 19:47  bvassche
+
+   *  ., agent/agent_handler.c, agent/helpers/table_dataset.c,   
+      include/net-snmp/agent/agent_handler.h,   
+      include/net-snmp/agent/snmp_agent.h,   
+      include/net-snmp/agent/table_data.h,   
+      include/net-snmp/agent/table_dataset.h,   
+      include/net-snmp/library/data_list.h:
+
+   CHANGES: snmpd, snmplib: Remove the inline declarations for
+   functions that lack an inline definition.
+   
+   Backported r16926 from the trunk to the 5.4 branch because Mario
+   Gartner posted
+   patch 2945202 in which he reported that gcc printed several
+   warnings like the
+   following for the code on the 5.4 branch:
+   include/net-snmp/agent/agent_handler.h:241: warning: inline
+   function 'void*
+   netsnmp_request_get_list_data(netsnmp_request_info*, const
+   char*)' used but
+   never defined
+
+2010-02-05 09:48  jsafranek
+
+   *  agent/mibgroup/if-mib/data_access/interface_linux.c,   
+      agent/mibgroup/mibII/interfaces.c,   
+      include/net-snmp/data_access/interface.h:
+
+   CHANGES: snmpd: report real ifSpeed of network interface even it
+   is down.
+   Some interfaces can report their real speed, even they are down.
+   And if they can't, the fallback to 10Mbps is still there.
+
+2010-02-01 01:07  tanders
+
+   * testing/tests/T055agentv1mintrap:
+
+   Follow-up for r18093: same changes for all branches
+
+2010-02-01 01:05  tanders
+
+   *  testing/tests/T053agentv1trap, testing/tests/T054agentv2ctrap,   
+      testing/tests/T056agentv2cmintrap, testing/tests/T113agentxtrap:
+
+   CHANGES: building: 'make test TESTOPTS="-P tcp"' works fine now
+
+2010-01-31 01:42  tanders
+
+   * man/Makefile.in:
+
+   Follow-up for r17710 / backport of r17712: remove an obsolete
+   manual
+   page from the set of files that should be installed
+
+2010-01-29 20:07  jsafranek
+
+   * testing/tests/T059trapdtraphandle:
+
+   Elaborate on rev. 18089 and adjust the temporary directory to the
+   *    *really working one*.  2010-01-29 19:11  jsafranek
+
+
+   * testing/tests/T059trapdtraphandle:
+
+   Fix test 35 when configure option '--with-temp-file-pattern' was
+   used and the directory for temp. files does not exist yet.
+
+2010-01-26 09:27  jsafranek
+
+   * agent/mibgroup/host/hr_swinst.c:
+
+   CHANGES: snmpd: fix rare race condition when reading RPM
+   database.
+   Old rpm versions return NULL instead of Header when another RPM
+   instance holds
+   database locks. I.e. snmpd sometimes crashes when reading
+   hr_swInst and rpm is
+   installing/updating/removing another package. As a solution,
+   whole RPM cache
+   is thrown away and re-read when we got an error from librpm. The
+   whole process
+   is restarted only three times, to prevent endless loop.
+
+2010-01-22 00:39  hardaker
+
+   * COPYING:
+
+   Copyright file update for SPARTA, Inc.
+
+2010-01-21 14:55  jsafranek
+
+   * agent/mibgroup/ip-mib/data_access/ipaddress_linux.c:
+
+   CHANGES: PATCH: 2926374: from Ed Swierk: fixed reading of
+   ipAddressTable from /proc/net/if_inet6 on Linux
+   
+   The kernel might provide longer fields, especially on 64-bit
+   systems.
+
+2010-01-20 08:53  jsafranek
+
+   * man/snmpnetstat.1.def:
+
+   Fix minor typo in man page, it's snmpnetstat -Cp, not -CP.
+
+2010-01-07 19:42  hardaker
+
+   *  agent/mibgroup/hardware/cpu/cpu_sysctl.c,   
+      agent/mibgroup/host/hr_swinst.c:
+
+   Patch from Stephen Hemminger to fix a minor memleak in cpu
+   sysctrl fetching
+
+2010-01-06 17:56  dts12
+
+   * CHANGES:
+
+   version update
+
+2010-01-06 17:25  dts12
+
+   * ChangeLog:
+
+   version update
+
+2010-01-06 17:06  dts12
+
+   *  agent/Makefile.depend, agent/helpers/Makefile.depend,   
+      agent/mibgroup/Makefile.depend, apps/Makefile.depend,   
+      apps/snmpnetstat/Makefile.depend, snmplib/Makefile.depend:
+
+   make depend
+
+2010-01-06 17:06  dts12
+
+   *  agent/Makefile.depend, agent/helpers/Makefile.depend,   
+      agent/mibgroup/Makefile.depend, apps/Makefile.depend,   
+      apps/snmpnetstat/Makefile.depend, snmplib/Makefile.depend:
+
+   make depend
+
+2010-01-06 16:55  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2010-01-06 16:43  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      snmplib/snmp_version.c:
+
+   Version number update
+
+2010-01-06 13:33  jsafranek
+
+   * agent/mibgroup/mibII/at.c, agent/mibgroup/mibII/at.h:
+
+   Add support of network interfaces with HW address bigger than 6
+   bytes to atTable. Some HW, like InfiniBand, uses HW addresses
+   with 9 and more bytes.
+
+2010-01-06 12:45  dts12
+
+   * agent/mibgroup/hardware/cpu/cpu_kstat.c:
+
+   CHANGES: snmpd: BUGS: 2924140: Fix termination of CPU/FPU types
+
+2010-01-06 12:33  dts12
+
+   * snmplib/snmpUnixDomain.c:
+
+   CHANGES: snmplib: BUGS: 2922390: Fix test for missing contextName parameter
+
+2010-01-05 22:33  dts12
+
+   * python/netsnmp/client_intf.c:
+
+   CHANGES: python: BUGS: 2919379: Initialise SNMP sessions properly
+   Provided by Diego Billi
+
+2010-01-05 22:20  dts12
+
+   * snmplib/snmpCallbackDomain.c:
+
+   CHANGES: snmplib: BUGS: 2919320: Avoid accessing freed memory
+   Reported by Tomasz Lis
+
+2010-01-05 18:58  dts12
+
+   * agent/mibgroup/ucd-snmp/proc.c:
+
+   CHANGES: snmpd: BUGS: 2914410: Fix crash on empty command lines
+
+2010-01-05 15:31  dts12
+
+   * agent/mibgroup/agentx/protocol.c:
+
+   CHANGES: snmpd: PATCH: 2912584: Fix null OID handling in Agentx on 64bit
+   Patch supplied by Lutz Jaenicke
+
+2009-12-22 07:59  bvassche
+
+   * snmplib/read_config.c:
+
+   Reverted r17926, which made the string returned by
+   read_config_read_octet_string() zero-terminated. A new patch will
+   follow
+   that fixes the callers of read_config_read_octet_string() that
+   were
+   assuming that read_config_read_octet_string() zero-terminates the
+   string
+   read by this function.
+
+2009-12-21 13:52  bvassche
+
+   * snmplib/read_config.c:
+
+   Follow-up for r17928: while r17928 fixed a dangling pointer
+   dereference
+   detected by running the Net-SNMP software on Windows, that patch
+   introduced
+   a dangling pointer dereference about which only Valgrind on Linux
+   complained.
+   This follow-up patch fixes both dangling pointer dereferences
+   triggered by
+   parsing the persistentDir keyword.
+
+2009-12-21 12:23  bvassche
+
+   * snmplib/read_config.c:
+
+   Applied a slightly modified version of patch #2912055: make sure
+   that
+   parsing the "persistentDir" keyword in snmp.conf does not trigger
+   a
+   dangling pointer. To my surprise BoundsChecker complained about
+   this
+   (on Windows), but Valgrind did not report this issue (on Linux).
+
+2009-12-21 12:08  bvassche
+
+   * agent/mibgroup/notification-log-mib/notification_log.c:
+
+   Follow-up for r17925 (fix memory leak during startup): while
+   r17925 fixed
+   only the leak triggered from inside the for-loop, this patch does
+   now also
+   fix the leak triggered by the netsnmp_table_dataset_add_row()
+   call near
+   the end of log_notification().
+
+2009-12-21 12:01  bvassche
+
+   * snmplib/read_config.c:
+
+   Applied patch #2912062: make sure that the string returned by
+   read_config_read_octet_string() is properly terminated, such that
+   the
+   callers of this function do not trigger past-end-of-buffer reads.
+   Found
+   this issue via BoundsChecker.
+
+2009-12-21 11:06  bvassche
+
+   * agent/mibgroup/notification-log-mib/notification_log.c:
+
+   Applied patch #2912068, which fixes a memory leak during startup.
+   The function log_notification() adds a row to the table
+   nlmLogVarTable, but
+   this function can be called before that table has been
+   initialized. If
+   that happens, memory is allocated for a row but that memory is
+   never
+   added to the cached table data. The BoundsChecker tool reported
+   this as
+   a "memory leak leaving scope".
+
+2009-12-21 10:54  bvassche
+
+   * README.win32:
+
+   Added the following text to the "Limitations" section of
+   README.win32:
+   "When using winExtDLL, there is an offset of up to one second
+   between the
+   value of the sysUpTime varbind included in the traps generated by
+   SNMP
+   extension DLLs (e.g. linkUp and linkDown) and the value of the
+   sysUpTime
+   varbind included in traps generated by Net-SNMP itself (e.g.
+   coldStart)."
+
+2009-12-21 10:50  bvassche
+
+   * README.win32:
+
+   Backported r17901 (spelling fixes and hrSystemUptime documentation).
+
+2009-12-17 10:03  dts12
+
+   * man/snmptest.1.def:
+
+   Fix typo.
+
+2009-12-11 14:06  bvassche
+
+   * README.win32, agent/mibgroup/winExtDLL.c:
+
+   winExtDLL bugs fixed:
+   - sysUpTime.0 does now report the correct value.
+   - a linkUp or linkDown trap is now sent after the status of a
+   network interface
+   has changed.
+   - the value of the sysUpTime.0 varbind in linkUp and linkDown
+   traps is now
+   correct.
+
+2009-12-10 15:43  dts12
+
+   *  agent/mibgroup/disman/mteTriggerTable.c,   
+      agent/mibgroup/utilities/iquery.c:
+
+   CHANGES: snmpd: PATCHES: 2911323: Fix agent lockup when monitoring AgentX-delegated information
+
+2009-12-10 12:54  bvassche
+
+   * agent/mibgroup/winExtDLL.c:
+
+   Fixed the following winExtDLL bugs:
+   - Fixed bug in trap forwarding: linkDown traps were sent as
+   warmStart traps
+   and linkUp traps were sent as linkDown traps.
+   - Fixed a memory leak triggered by extension DLL loading.
+   - A debug trace statement is now invoked whenever a serious error
+   has been
+   detected.
+
+2009-12-09 14:37  jsafranek
+
+   *  agent/mibgroup/ip-mib/data_access/arp_linux.c,   
+      include/net-snmp/data_access/arp.h:
+
+   CHANGES: snmpd: Add support of network interfaces with HW address bigger than 6 bytes to ipNetToMediaTable and ipNetToPhysicalTable.
+   Some HW, like InfiniBand, uses HW addresses with 9 and more
+   bytes. Snmpd on Linux was not able to parse /proc/net/arp then
+   and produced ugly 'ioctl 35123 returned -1' to log.
+
+2009-12-08 21:54  magfr
+
+   * agent/mibgroup/util_funcs.c, snmplib/system.c:
+
+   CHANGES: snmplib, snmpd: Make sure that a mask is given to open when O_CREAT is specified
+
+2009-12-07 10:46  dts12
+
+   * apps/snmptable.c:
+
+   Tweak missing subidentifier processing to be more type-aware.
+   (An issue with AIX, at least)
+
+2009-12-05 17:42  tanders
+
+   * perl/SNMP/SNMP.xs:
+
+   call netsnmp_read_module instead of read_module to make it
+   compile with NETSNMP_CLEAN_NAMESPACE
+
+2009-12-05 17:19  tanders
+
+   * agent/mibgroup/disman/schedule/schedCore.c:
+
+   apply r17854 build fix to all affected branches
+
+2009-12-02 15:39  jsafranek
+
+   *  agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.c,   
+      agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.c,
+         agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.c,   
+      agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.c:
+
+   CHANGES: snmpd: Fixed invalid access to memory in TCP-MIB
+   This partly reverts patch 17719 - the entries *are* used after
+   raw_data container is freed. These entries should be freed when
+   associated rowreq_ctx is freed.
+
+2009-12-02 08:30  jsafranek
+
+   * agent/mibgroup/mibII/udpTable.c:
+
+   CHANGES: snmpd: Fixed udpTable indexes on big-endian 64bit Linux.
+   The index was always '0.0.0.0' instead of real local IP address.
+
+2009-12-01 12:36  dts12
+
+   * include/net-snmp/library/snmp_api.h:
+
+   Update a redundant (and probably inaccurate) comment.
+
+2009-12-01 12:31  dts12
+
+   * agent/helpers/table.c:
+
+   CHANGES: agent: BUGS: 2822360: Fix memory leak when building table OIDs
+
+2009-12-01 12:08  dts12
+
+   * apps/snmptable.c:
+
+   CHANGES: snmptable: BUGS: 2837998: Handle missing instance subidentifiers in results
+
+2009-12-01 11:56  dts12
+
+   * agent/mibgroup/agentx/client.c:
+
+   CHANGES: agent: BUGS: 2841008: Protect against crash following failed AgentX response
+
+2009-11-30 16:55  dts12
+
+   * agent/mibgroup/disman/schedule/schedCore.c:
+
+   CHANGES: agent: BUGS: 2873858: Fix handling of schedOwner index.
+   Patch provided by Max Schubert.
+
+2009-11-30 16:46  dts12
+
+   * local/mib2c.old-api.conf:
+
+   CHANGES: mib2c: BUGS: 2888569: Fix generation of table columns array
+
+2009-11-30 16:30  dts12
+
+   * agent/mibgroup/ip-mib/data_access/ipaddress_ioctl.c:
+
+   CHANGES: agent: BUGS: 2894059: Handle errors when counting interfaces
+
+2009-11-30 16:07  dts12
+
+   * agent/mibgroup/ucd-snmp/vmstat.c:
+
+   CHANGES: agent: BUG: 2897000: Suppress 32-bit counter truncation warnings.
+
+2009-11-30 15:19  dts12
+
+   * agent/mibgroup/ucd-snmp/pass_persist.c:
+
+   CHANGES: agent: PATCH: 2901029: Fix compiler warning on CloseHandle()
+   Endian problems already addressed by patch #2835576
+
+2009-11-30 15:13  dts12
+
+   * perl/agent/agent.xs:
+
+   CHANGES: perl: PATCH: 2890931: Better handling of Counter64 values.
+   Patch provided by Max Romanov.
+
+2009-11-30 15:07  dts12
+
+   * agent/mibgroup/ucd-snmp/vmstat_solaris2.c:
+
+   CHANGES: agent: PATCH: 2887816: Protect against division-by-zero crash
+
+2009-11-30 14:49  dts12
+
+   * agent/mibgroup/ucd-snmp/proxy.c:
+
+   CHANGES: agent: PATCH: 2883155: Fix memory leak in proxy handling.
+   Patch supplied by Gowtham Thommandra.
+
+2009-11-30 14:12  dts12
+
+   * agent/mibgroup/agentx/subagent.c:
+
+   CHANGES: agent: PATCH: 2877518: Fix handling of scoped AgentX variables
+
+2009-11-27 08:54  jsafranek
+
+   * agent/helpers/table_row.c:
+
+   Remove executable attribute from source files.
+
+2009-11-13 12:59  jsafranek
+
+   * agent/mibgroup/mibII/ip.c, agent/mibgroup/mibII/tcp.c:
+
+   CHANGES: snmpd: Fixed logging of 'truncating integer value > 32 bits' in IP-MIB and TCP-MIB
+   The counters, which grow fast are now cut to 32bits.
+
+2009-11-11 09:00  dts12
+
+   * local/mib2c.iterate.conf, local/mib2c.table_data.conf:
+
+   Fix cache free routine to match header declaration.
+   Return success/failure values from cache load routine.
+   Problem identified by Xuan.
+
+2009-10-29 16:05  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      perl/ASN/ASN.pm, perl/AnyData_SNMP/Storage.pm, perl/OID/OID.pm,   
+      perl/SNMP/SNMP.pm, perl/TrapReceiver/TrapReceiver.pm,   
+      perl/agent/Support/Support.pm, perl/agent/agent.pm,   
+      perl/agent/default_store/default_store.pm,   
+      perl/default_store/default_store.pm, sedscript.in,   
+      snmplib/snmp_version.c:
+
+   - version tag ( 5.4.3.pre1 )
+
+2009-10-29 14:24  dts12
+
+   * CHANGES, NEWS:
+
+   version update
+
+2009-10-29 11:46  dts12
+
+   * ChangeLog:
+
+   version update
+
+2009-10-29 10:30  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2009-10-29 10:28  dts12
+
+   * doxygen.conf:
+
+   - version tag ( 5.4.3.pre1 )
+
+2009-10-29 09:55  dts12
+
+   * Makefile.top:
+
+   version update
+
+2009-10-09 12:38  jsafranek
+
+   * snmplib/snmp_client.c:
+
+   CHANGES: snmplib: PATCH: 2871747: plug memory leak in OID processing.
+   The memory leaked when small OID, which could fit pre-allocated
+   vp->name_loc, was placed in different (allocated) one.
+
+2009-10-09 05:31  magfr
+
+   * snmplib/mib.c, snmplib/parse.c:
+
+   CHANGES: BUG: 2838243: Correct the output of unsigned values.
+   Thanks to Jack Huang of Qualcomm who pointed out this bug.
+
+2009-10-09 05:00  magfr
+
+   * snmplib/parse.c:
+
+   CHANGES: snmplib: Change the parsing of ranges to accept all
+   valid values.
+
+2009-10-07 12:50  jsafranek
+
+   * agent/mibgroup/mibII/vacm_vars.c:
+
+   CHANGES: snmpd: Fixed creation of views using snmpusm, OIDs with
+   indexes > 255 are allowed now.
+   This reverts SVN commit #7492.
+
+2009-10-05 19:19  magfr
+
+   *  include/net-snmp/library/file_utils.h,   
+      include/net-snmp/library/text_utils.h:
+
+   CHANGES: snmplib: Correct the spelling of __cplusplus when
+   checking if the file should be wrapped in extern "C".
+
+2009-09-30 10:12  dts12
+
+   * agent/mibgroup/host/hr_swinst.c:
+
+   CHANGES: Solaris: Protect against missing package version
+   information crashing the agent.
+   Problem reported by Inyaven Sakarai.
+
+2009-09-23 23:40  hardaker
+
+   * FAQ:
+
+   proper project capitalization
+
+2009-09-22 21:51  tanders
+
+   * README.solaris:
+
+   fix typos
+
+2009-08-26 14:50  dts12
+
+   * snmplib/snmp_api.c:
+
+   Protect against bogus failures (returning 0) and subsequent
+   double-frees,
+   due to 15-/31-bit masking when selecting request IDs. Identified
+   by kromesky.
+
+2009-08-05 20:07  dts12
+
+   *  agent/mibgroup/udp-mib/data_access/udp_endpoint_linux.c,   
+      snmplib/file_utils.c:
+
+   CHANGES: snmpd: BUG: 2822355: Fix memory leaks on
+   udpEndpointTable (linux)
+   Patch supplied by Frank Lichtenheld
+
+2009-08-05 19:05  dts12
+
+   * 
+      agent/mibgroup/ip-mib/ipAddressPrefixTable/ipAddressPrefixTable_data_access.c:
+
+   CHANGES: snmpd: PATCHES: 2822337: Fix memory leak in
+   ipAddressPrefixTable
+
+2009-08-05 15:12  jsafranek
+
+   * 
+      agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.c,
+        
+      agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.c,
+        
+      agent/mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.c:
+
+   Fix memory leak in UDP- and TCP-MIB.
+   The data from raw_data are copied to cache, so it should be
+   freed.
+
+2009-08-05 10:16  dts12
+
+   * apps/snmptable.c:
+
+   CHANGES: apps: BUG: 2811577: Fix bug in GetBulk handling.
+   Don't get confused by index values that contain a ':' character.
+
+2009-08-04 21:59  dts12
+
+   * local/mib2c-conf.d/mfd-access-unsorted-external-defines.m2i:
+
+   CHANGES: mib2c: BUG: 2827269: Suppress non-ordered TODO comments.
+
+2009-08-04 21:35  dts12
+
+   * local/mib2c.old-api.conf:
+
+   Handle generating code for a single table,
+   as well as a larger group.
+   Also addresses bug 2150285
+
+2009-08-04 10:57  jsafranek
+
+   * agent/mibgroup/ip-mib/data_access/systemstats_common.c:
+
+   CHANGES: snmpd: from "Marcus Rckert": fix possible crash when
+   64-bit counters in ipSystemStatsTable get bigger than 2^32
+
+2009-07-27 12:13  hardaker
+
+   * man/netsnmp_Container_iterator.3:
+
+   remove outdate case-conflicting manual page
+
+2009-07-27 12:06  hardaker
+
+   * perl/SNMP/t/bulkwalk.t:
+
+   CHANGES: freebsd: patch from Cezary Morga to fix a make test on
+   freebsd
+
+2009-07-23 21:29  alex_b
+
+   * README:
+
+   Update email address in README.
+
+2009-07-21 12:13  dts12
+
+   * local/mib2c.table_data.conf:
+
+   Fix missing semicolon typos.
+
+2009-07-21 09:15  dts12
+
+   * FAQ:
+
+   New suggested entries.
+
+2009-07-20 19:24  dts12
+
+   * FAQ:
+
+   Updates to CODING section.
+
+2009-07-19 15:09  dts12
+
+   * FAQ:
+
+   Updates to COMPILING section.
+
+2009-07-10 07:46  jsafranek
+
+   * 
+      agent/mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.c,
+         local/mib2c:
+
+   Fix another IPv4 address size - long has 8 bytes on 64bit Linux.
+   Also fix the default type fo^CASN_IPADDRESS in mib2c, so the
+   ipCidrRouteTable_interface.c can be safely regenerated.
+
+2009-07-07 15:46  jsafranek
+
+   *  agent/mibgroup/mibII/ipCidrRouteTable_access.c,   
+      agent/mibgroup/ucd-snmp/pass.c,   
+      agent/mibgroup/ucd-snmp/pass_persist.c:
+
+   Fix IP address length on 64 bit systems in mibII, pass and
+   pass_persist modules.
+
+2009-07-07 15:24  jsafranek
+
+   * agent/mibgroup/mibII/at.c:
+
+   Use correctly sized IP addresses in address translation table
+   processing - u_long can make problems on bin endian 64 bit
+   systems
+
+2009-06-16 15:19  rstory
+
+   * snmplib/container.c:
+
+   check for null pointer before deref
+
+2009-06-15 15:25  dts12
+
+   * FAQ:
+
+   Updates to AGENT section.
+
+2009-06-14 22:01  tanders
+
+   * agent/mibgroup/host/hr_swrun.c:
+
+   portability fix (sync with 5.5)
+
+2009-06-11 23:09  hardaker
+
+   *  apps/snmptrapd.c, snmplib/winpipe.c,   
+      win32/libnetsnmptrapd/libnetsnmptrapd.dsp,   
+      win32/net-snmp/agent/mib_module_config.h,   
+      win32/netsnmpmibssdk/netsnmpmibssdk.dsp:
+
+   CHANGES: win32: PATCH: 2693746: from bvassche: improved socket startup support
+
+2009-06-11 22:57  hardaker
+
+   * agent/mibgroup/kernel_sunos5.c:
+
+   CHANGES: snmpd: PATCH: 2012402: don't fail on failure to look up interface error counters.
+
+2009-06-03 12:35  dts12
+
+   * perl/SNMP/SNMP.xs:
+
+   CHANGES: perl: PATCHES: 2793857: Report failed asynchronous requests.
+
+2009-06-03 11:46  dts12
+
+   * agent/mibgroup/agentx/master_admin.c:
+
+   Remove patch #2182592 - revert to SVN revision 17646
+   The cleanup routines don't appear to exist.
+
+2009-06-03 10:16  dts12
+
+   * agent/mibgroup/agentx/master_admin.c:
+
+   PATCH: 2182592: Clean up vacmContextTable after unregistrations
+   Patch supplied by John Forsyth
+
+2009-06-03 10:12  dts12
+
+   *  agent/agent_handler.c, agent/helpers/stash_cache.c,   
+      agent/mibgroup/agentx/subagent.c, agent/snmp_agent.c,   
+      agent/snmp_vars.c, include/net-snmp/agent/agent_handler.h,   
+      include/net-snmp/agent/snmp_agent.h, snmplib/snmpUDPDomain.c,   
+      snmplib/snmp_api.c, snmplib/snmpv3.c:
+
+   CHANGES: PATCH: 2797251: Support multiple initialisation and shutdown, fix memory leaks
+   Patch supplied by Ivosh
+
+2009-06-01 15:53  dts12
+
+   * man/snmpd.conf.5.def:
+
+   CHANGES: docs: PATCHES: 2788072: Document 'logmatch' functionality.
+
+2009-06-01 15:50  dts12
+
+   *  agent/mibgroup/utilities/iquery.c, snmplib/mib.c,   
+      snmplib/system.c, win32/net-snmp/net-snmp-config.h,   
+      win32/net-snmp/net-snmp-config.h.in:
+
+   CHANGES: snmplib: PATCHES: 2780411: Fix compiler warnings
+
+2009-06-01 15:37  dts12
+
+   *  aclocal.m4, configure, local/snmpconf.dir/snmpd-data/monitor,   
+      man/snmpd.conf.5.def, man/snmpd.examples.5.def:
+
+   CHANGES: docs: PATCH: 2795739: Fix incorrect disk/file size descriptions & unit specifiers
+
+2009-06-01 13:11  dts12
+
+   * EXAMPLE.conf.def:
+
+   Rework example configuration file to match current snmpd.conf(5)
+   structure, and more clearly illustrate current best practise.
+
+2009-05-29 09:14  dts12
+
+   * agent/mibgroup/ucd-snmp/pass.h:
+
+   Automatically load the example passtest MIB
+
+2009-05-29 09:08  dts12
+
+   * local/passtest.pl, mibs/Makefile.in, mibs/NET-SNMP-PASS-MIB.txt:
+
+   Rework "passtest" examples to fully validate GETNEXT requests,
+   and use a legitimate MIB structure for output.
+   Add an example MIB to define that structure.
+
+2009-05-28 12:55  dts12
+
+   * FAQ:
+
+   Synchronise with latest FAQ
+   (including 5.5 revisions up to MIBs section)
+
+2009-05-19 17:50  alex_b
+
+   * perl/TrapReceiver/TrapReceiver.pm:
+
+   Update Perl TrapReceiver example to properly output the
+   securityEngineID and contextEngineID.
+
+2009-05-18 10:03  jsafranek
+
+   * agent/mibgroup/host/hr_proc.c:
+
+   Avoid division by zero.
+
+2009-05-15 19:22  tanders
+
+   * snmplib/scapi.c:
+
+   CHANGES: build: BUG: 2782700: build failure when using --with-pkcs on Solaris
+
+2009-05-15 14:59  jsafranek
+
+   * dist/net-snmp.spec:
+
+   Fix compilation of rpm packages on Fedora >= 10 - it has newer
+   RPM and the old API needs to be explicitly enabled by a macro.
+
+2009-05-14 13:39  jsafranek
+
+   * snmplib/snmp_logging.c:
+
+   The snmpcmd man page is not specific how range of log priorities
+   should be specified on command line,
+   i.e. both -LO 4-0 and -LO 0-4 are valid. All snmp commands (incl.
+   snmpd) should recognize that.
+
+2009-05-14 08:30  dts12
+
+   * agent/mibgroup/disman/event/mteTriggerConf.c:
+
+   CHANGES: snmpd: Allow "monitor" to handle negative threshold values.
+   Reported by Richard Gipps.
+
+2009-05-13 22:32  tanders
+
+   * snmplib/vacm.c:
+
+   CHANGES: snmpd: PATCH: 2791417: fix snmpd segfault when run with -DALL
+   Patch supplied by Ron Roskens.
+
+2009-05-13 08:02  dts12
+
+   * man/snmpd.conf.5.def:
+
+   Bring documentation of notificationEvent syntax into line with reality.
+   (Uses "-m" rather than "-n" to register standard MIB payload objects)
+   Inconsistency reported by Richard Gipps.
+
+2009-05-12 23:26  alex_b
+
+   * include/net-snmp/data_access/interface.h, perl/agent/agent.xs:
+
+   Win32: Build fixes - change unsigned long long to uint64_t.
+
+2009-05-07 23:00  tanders
+
+   * agent/mibgroup/hardware/memory/memory_hpux.c:
+
+   build fix for HP-UX: include <sys/param.h> for DEV_BSIZE
+
+2009-04-26 13:06  alex_b
+
+   * agent/mibgroup/winExtDLL.c:
+
+   Win32: Update build instructions in comments.
+
+2009-04-24 07:31  tanders
+
+   * configure, configure.in:
+
+   CHANGES: HP-UX: BUG: 2779472: Filesystems missing in hrStorage table on HP-UX 11.31
+   (allow for mnttab that is a character special device)
+
+2009-04-24 01:36  alex_b
+
+   *  agent/mibgroup/ucd-snmp/pass_persist.c,   
+      agent/mibgroup/util_funcs.c:
+
+   CHANGES: Win32: BUG: 2779541 Fixed handle leak in pass_persist.
+
+2009-04-23 23:14  tanders
+
+   * agent/mibgroup/host/hr_storage.c:
+
+   CHANGES: AIX: BUG: 2712670: Agent crashes on AIX with hrStorage
+
+2009-04-23 22:53  hardaker
+
+   * snmplib/snmp_alarm.c:
+
+   fix C++ style comments
+
+2009-04-23 22:16  tanders
+
+   * agent/mibgroup/host/hr_filesys.c:
+
+   improve error message when failing to open mnttab
+
+2009-04-23 22:10  tanders
+
+   * configure, configure.in:
+
+   CHANGES: HP-UX: BUG: 2779472: Filesystems missing in hrStorage table on HP-UX 11.31
+
+2009-04-23 21:48  tanders
+
+   * agent/mibgroup/kernel_sunos5.c:
+
+   CHANGES: Solaris: PATCH: 2751588: Inconsistent data (e.g. UDP/TCP MIB scalar values of zero) can be reported on Solaris 10U4+
+   Patch provided by Anders Persson
+
+2009-04-23 16:57  hardaker
+
+   * agent/mibgroup/kernel_sunos5.c:
+
+   CHANGES: solaris: PATCH: 2012404: deal with more than 10 interfaces. New hardcoded limit is 50. A better scaling patch would be appreciated :-)
+
+2009-04-23 16:35  hardaker
+
+   * local/mib2c-conf.d/generic-table-oids.m2c:
+
+   CHANGES: mib2c: PATCH: 2136437: make FLAG defines more 64bit friendly when huge tables are encountered
+
+2009-04-23 16:27  hardaker
+
+   * agent/mibgroup/hardware/memory/memory_hpux.c:
+
+   CHANGES: hpux: PATCH: 2088726: from ravindra1103 to fix an issue
+   with hpux reporting memory in negative values.
+
+2009-04-23 16:21  hardaker
+
+   * python/netsnmp/client.py:
+
+   CHANGES: python: PATCH: 2074817: from fenner to fix regexp engine CPU performance issues
+
+2009-04-23 16:14  hardaker
+
+   * agent/mibgroup/host/hr_storage.c:
+
+   CHANGES: snmpd: PATCH: 2162652: patch to fix simple hrfs checks when NFS is in use.
+
+2009-04-23 16:11  hardaker
+
+   *  perl/ASN/ASN.pm, perl/AnyData_SNMP/Format.pm,   
+      perl/AnyData_SNMP/Storage.pm, perl/OID/OID.pm, perl/SNMP/SNMP.pm, 
+        perl/agent/Support/Support.pm, perl/agent/agent.pm,   
+      perl/agent/default_store/default_store.pm,   
+      perl/default_store/default_store.pm, perl/manager/manager.pm:
+
+   CHANGES: perl: PATCH: 2182079: apply patch from int32 to fix a
+   number of perl warnings and fix the modules so that use strict is
+   possible
+
+2009-04-23 15:58  hardaker
+
+   *  agent/helpers/table_data.c, agent/helpers/table_dataset.c,   
+      agent/mibgroup/mibII/ipv6.c, agent/mibgroup/mibII/vacm_context.c, 
+        apps/encode_keychange.c, snmplib/container_binary_array.c,   
+      snmplib/keytools.c, snmplib/mib.c, snmplib/parse.c,   
+      snmplib/snmpUDPIPv6Domain.c, snmplib/snmpv3.c:
+
+   CHANGES: build: PATCH: 2184039: misc fixes for freeing memory
+   during error conditions.
+
+2009-04-23 15:47  hardaker
+
+   * perl/SNMP/SNMP.xs:
+
+   CHANGES: perl: PATCH: 2361712: from kbrint to fix getbulk
+   optimization during walks where end conditionns are met on middle
+   OIDs first.
+
+2009-04-23 15:35  alex_b
+
+   * README:
+
+   README Thanks update
+
+2009-04-23 15:04  hardaker
+
+   * agent/mibgroup/disman/event/mteTriggerConf.c:
+
+   CHANGES: snmpd: patch from Tushar Gohad to clean up notification
+   registerations during disman event mib cleanup processing.
+
+2009-04-23 14:55  jsafranek
+
+   * agent/mibgroup/sctp-mib/sctpTables_common.c:
+
+   Fix memory leak in SCTP containers.
+
+2009-04-23 03:27  hardaker
+
+   * snmplib/snmp_alarm.c:
+
+   CHANGES: snmplib: PATCH: 2505488: from dabokey to fix alarms not
+   being triggered at the right times due to large clock skews.
+
+2009-04-22 23:49  hardaker
+
+   *  agent/mibgroup/agent/extend.c, apps/snmpnetstat/inet.c,   
+      apps/snmpnetstat/route.c, apps/snmptrapd_handlers.c,   
+      apps/snmptrapd_handlers.h, snmplib/system.c:
+
+   CHANGES: ports: PATCH: 2688342: from ahmake to fix various
+   compiler warning
+
+2009-04-22 22:11  alex_b
+
+   * README, README.win32:
+
+   Update THANKS section.
+
+2009-04-22 10:08  dts12
+
+   * man/mib_api.3.def:
+
+   Correct a seriously misleading (i.e. wrong) description of the
+   purpose and behaviour of the print_description family of calls.
+
+2009-04-10 23:18  alex_b
+
+   * include/net-snmp/library/winservice.h, snmplib/winservice.c:
+
+   CHANGES: Win32: PATCH 2691876: Applied patch by rdiez to allow
+   compiling the services using unicode.
+
+2009-04-10 22:55  alex_b
+
+   *  win32/encode_keychange/encode_keychange.dsp,   
+      win32/libagent/libagent.dsp, win32/libhelpers/libhelpers.dsp,   
+      win32/libnetsnmptrapd/libnetsnmptrapd.dsp,   
+      win32/libsnmp/libsnmp.dsp, win32/libsnmp_dll/libsnmp_dll.dsp,   
+      win32/netsnmpmibs/netsnmpmibs.dsp,   
+      win32/netsnmpmibssdk/netsnmpmibssdk.dsp,   
+      win32/snmpbulkget/snmpbulkget.dsp,   
+      win32/snmpbulkwalk/snmpbulkwalk.dsp, win32/snmpd/snmpd.dsp,   
+      win32/snmpdelta/snmpdelta.dsp, win32/snmpdf/snmpdf.dsp,   
+      win32/snmpdsdk/snmpd.dsp, win32/snmpget/snmpget.dsp,   
+      win32/snmpgetnext/snmpgetnext.dsp,   
+      win32/snmpnetstat/snmpnetstat.dsp, win32/snmpset/snmpset.dsp,   
+      win32/snmpstatus/snmpstatus.dsp, win32/snmptable/snmptable.dsp,   
+      win32/snmptest/snmptest.dsp,   
+      win32/snmptranslate/snmptranslate.dsp,   
+      win32/snmptrap/snmptrap.dsp, win32/snmptrapd/snmptrapd.dsp,   
+      win32/snmpusm/snmpusm.dsp, win32/snmpvacm/snmpvacm.dsp,   
+      win32/snmpwalk/snmpwalk.dsp:
+
+   Win32: PATCH 2688309: Applied patch by Bart Van Assche to remove
+   MSVC 2005/2008 compiler warnings.
+
+2009-04-10 21:45  alex_b
+
+   * win32/Configure:
+
+   Win32: Minor build and readme updates.
+
+2009-04-10 21:38  alex_b
+
+   *  agent/mibgroup/winExtDLL.c, win32/libsnmp_dll/libsnmp.def,   
+      win32/libsnmp_dll/libsnmp.def.in:
+
+   NEWS: Win32: PATCH 2686248: Applied patch by Bart Van Assche
+   which fixes several winExtDLL bugs.
+
+2009-04-10 20:14  rstory
+
+   * agent/mibgroup/ucd-snmp/diskio.c:
+
+   restore annoying log message, but fix cause of it on !freebsd systems
+
+2009-04-09 12:28  dts12
+
+   * agent/helpers/table_iterator.c:
+
+   CHANGES: snmpd: PATCH: 1550730: Report errors from iterator-based handlers.
+   Based on a patch provided by Wayne Glantz
+
+2009-04-09 11:41  dts12
+
+   * agent/mibgroup/snmpv3/usmUser.c:
+
+   CHANGES: snmpd: PATCH: 2124288: Fix setting of usmUserPrivProtocol at creation.
+   Logic bug, reported by Ramesh Kotabagi
+
+2009-04-09 09:12  dts12
+
+   * snmplib/snmpusm.c:
+
+   CHANGES: snmplib: PATCH: 2258229: Remove misleading comment
+   Patch provided by Dan Anderson
+
+2009-04-09 09:08  dts12
+
+   * python/netsnmp/client_intf.c:
+
+   CHANGES: python: PATCH: 2260828: Fix python snmpwalk memory leak
+   Patch provided by Gabriele Messineo
+
+2009-04-09 08:54  dts12
+
+   * local/mib2c.iterate_access.conf:
+
+   CHANGES: mib2c: PATCH: 2316127: Fix bug in iterate_access generated code.
+
+2009-04-09 08:44  dts12
+
+   * agent/mibgroup/if-mib/data_access/interface_sysctl.c:
+
+   CHANGES: snmpd: PATCH: 2435793: Support 64-bit IF-MIB counters on sysctl (*BSD) systems.
+   Patch provided by Jan Andres
+
+2009-04-08 16:00  dts12
+
+   * agent/snmp_agent.c:
+
+   CHANGES: snmpd: PATCH: 2384779: Fix handling of GetBulk with N>0,M==0
+   Patch provided by Angus Salkeld
+
+2009-04-08 15:52  dts12
+
+   * agent/mibgroup/host/hr_swrun.c:
+
+   CHANGES: snmpd: PATCH: 2406378: Fix hrSWRunPerfMem on 64-bit Solaris systems
+   Patch provided by NTwoO
+
+2009-04-08 15:48  dts12
+
+   * snmplib/mib.c:
+
+   CHANGES: snmplib: PATCH: 2479700: Fix zoned IP address used as table indices
+   Patch provided by Brian Retford.
+
+2009-04-08 15:33  dts12
+
+   * snmplib/snmp_logging.c:
+
+   CHANGES: snmplib: PATCH: 2492377: Fix typo/bug in snmp_enable_callback()
+   Reported by joyceanmachine
+
+2009-04-08 15:16  dts12
+
+   * snmplib/snmp_client.c:
+
+   CHANGES: snmplib: PATCH: 2538169: Prevent infinite retries for an
+   invalid error-index.
+   Patch provided by Doug Manley
+
+2009-04-08 14:58  dts12
+
+   * python/netsnmp/client_intf.c:
+
+   CHANGES: python: PATCH: 2580979: Fix python session pointers on 64-bit systems.
+   Patch provided by John Khvatov.
+
+2009-04-08 14:49  dts12
+
+   * python/netsnmp/client.py:
+
+   CHANGES: python: PATCH: 2667415: Support "UseNumeric" option.
+   Remove debugging output in "snmpwalk" command.
+   Patch provided by Diego Billi
+
+2009-04-08 14:34  dts12
+
+   *  perl/TrapReceiver/TrapReceiver.pm,   
+      perl/TrapReceiver/TrapReceiver.xs, perl/TrapReceiver/const-c.inc, 
+        perl/TrapReceiver/const-xs.inc:
+
+   CHANGES: snmptrapd: PATCH: 2726302: Pass results of Perl trap
+   handlers to trap daemon
+   Patch provided by Michael Schmitz
+
+2009-04-08 14:30  dts12
+
+   * snmplib/read_config.c, snmplib/snmpUDPIPv6Domain.c:
+
+   CHANGES: snmplib: PATCH: 2713841: Fix runtime errors triggered by
+   high-ASCII chars
+   Patch provided by Bart Van Assche
+
+2009-04-08 14:16  dts12
+
+   * snmplib/snmpUDPIPv6Domain.c:
+
+   CHANGES: snmplib: PATCH: 2689362: Fix handling of IPv6 hostnames.
+   Patch provided by Nestor Melo.
+
+2009-04-08 14:05  dts12
+
+   * include/net-snmp/library/snmp_assert.h:
+
+   CHANGES: library: PATCH: 2688345: Fix netsnmp_assert() for Visual
+   Studio
+   Patch provided by Bart Van Assche
+
+2009-04-08 13:35  dts12
+
+   * agent/agent_registry.c:
+
+   CHANGES: snmpd: PATCH: 2686280: Report duplicate registrations as
+   an error (rather than a failed assertion).
+   Fix provided by Bart Van Assche
+   
+   Qn: Does this even qualify as an error? Wouldn't a warning be
+   sufficient?
+
+2009-04-06 18:22  dts12
+
+   * agent/mibgroup/host/hr_swrun.c:
+
+   Proper check for empty process status file.
+   (Avoids truncated walk of hrSWRunPath on SuSE systems)
+   Reported by Kamil Kisiel.
+
+2009-04-06 12:05  tanders
+
+   * perl/agent/agent.xs, perl/agent/typemap:
+
+   CHANGES: perl: BUG 1554817: from xanco: revised fix for the class
+   assigment so
+   getRootOID works properly. Now passes "make test" and "make
+   perltest".
+
+2009-04-06 12:02  dts12
+
+   * agent/mibgroup/hardware/memory/memory_linux.c:
+
+   Fix typo
+
+2009-04-02 21:24  hardaker
+
+   * agent/snmp_agent.c:
+
+   CHANGES: BUG 112694: Patch from Bill Fenner: don't open (and
+   clobber) an agentx socket if the other transports fail to open
+
+2009-03-31 15:12  dts12
+
+   * local/mib2c.table_data.conf:
+
+   Balance parentheses in cache-based registration code.
+
+2009-03-31 15:07  dts12
+
+   * local/mib2c.table_data.conf:
+
+   But they're not C comments at all, Dave.
+   They are mib2c template comments,
+   and should be omitted from the generated code.
+   <sigh>
+
+2009-03-31 15:00  dts12
+
+   * local/mib2c.table_data.conf:
+
+   C comments use /* ... */, not #
+
+2009-03-18 10:52  dts12
+
+   * agent/mibgroup/hardware/cpu/cpu_linux.c:
+
+   cpu_linux: avoid reading past end of buffer
+   Patch provided by Stephen Hemminger
+
+2009-03-18 10:43  dts12
+
+   *  agent/mibgroup/hardware/cpu/cpu_linux.c,   
+      agent/mibgroup/hardware/memory/memory_linux.c:
+
+   linux: increase size of initial proc i/o buffer
+   Patch provided by Stephen Hemmings
+
+2009-03-18 10:31  dts12
+
+   * agent/mibgroup/hardware/memory/memory_linux.c:
+
+   memory_linux: avoid reading past end of buffer.
+   Patch provided by Stephen Hemminger
+
+2009-03-18 10:25  dts12
+
+   * agent/mibgroup/if-mib/data_access/interface_linux.c:
+
+   Fix valgrind warning.
+   Patch provided by Stephen Hemminger
+
+2009-03-13 21:23  dts12
+
+   *  agent/mibgroup/hardware/cpu/cpu.c,   
+      agent/mibgroup/hardware/memory/hw_mem.c:
+
+   CHANGES: snmpd: Register CPU/memory hardware modules with
+   nsCacheTable.
+   Allows monitoring frequency to be configured dynamically.
+
+2009-03-13 21:20  dts12
+
+   * agent/mibgroup/host/hr_proc.c:
+
+   Avoid div0 crash.
+   Problem reported by Nick Hindley
+
+2009-03-13 21:17  dts12
+
+   * agent/mibgroup/hardware/cpu/cpu_kstat.c:
+
+   Skip new CPUs, that have appeared since the agent first started.
+   (An alternative might be to create a new entry instead).
+   Problem reported by Nick Hindley
+
+2009-02-27 13:20  jsafranek
+
+   * agent/mibgroup/ucd-snmp/diskio.c:
+
+   Get rid of annoying 'diskio.c: don't know how to handle 9
+   request' in log.
+   It's being written to log everytime someone queries
+   UCD-SNMP-DISKIO MIB.
+
+2009-02-24 07:26  magfr
+
+   * snmplib/snmp_logging.c:
+
+   CHANGES: Make -LN stop dumping core. Make bad debug levels report
+   the offending symbol.
+
+2009-02-18 15:27  jsafranek
+
+   *  agent/mibgroup/sctp-mib/sctpAssocLocalAddrTable.c,   
+      agent/mibgroup/sctp-mib/sctpAssocRemAddrTable.c,   
+      agent/mibgroup/sctp-mib/sctpAssocTable.c,   
+      agent/mibgroup/sctp-mib/sctpLookupLocalPortTable.c,   
+      agent/mibgroup/sctp-mib/sctpLookupRemHostNameTable.c,   
+      agent/mibgroup/sctp-mib/sctpLookupRemIPAddrTable.c,   
+      agent/mibgroup/sctp-mib/sctpLookupRemPortTable.c,   
+      agent/mibgroup/sctp-mib/sctpLookupRemPrimIPAddrTable.c,   
+      agent/mibgroup/sctp-mib/sctpTables_common.c,   
+      agent/mibgroup/sctp-mib/sctpTables_common.h,   
+      agent/mibgroup/sctp-mib/sctpTables_linux.c:
+
+   Fix sctp-mib compilation problems
+
+2009-02-18 15:27  jsafranek
+
+   * agent/mibgroup/util_funcs.c, agent/mibgroup/util_funcs.h:
+
+   Backport get_pid_from_inode from trunk, it's needed by sctp-mib
+
+2009-02-16 21:24  hardaker
+
+   * perl/agent/agent.xs:
+
+   CHANGES: perl: BUG 1554817: Patch from xanco: fix the class
+   assigment so getRootOID works properly.
+
+2009-01-29 08:38  dts12
+
+   * snmplib/snmp_api.c:
+
+   Return a less misleading error when adding an unrecognised value.
+
+2009-01-28 10:10  dts12
+
+   * snmplib/snmpUDPDomain.c:
+
+   Fix src/dst confusion
+   Patch provided by Krzysztof Oldzki
+
+2009-01-28 09:29  dts12
+
+   * agent/mibgroup/smux/smux.c:
+
+   CHANGES: Fix two bugs with smux password support.
+   Patch supplied by Krzysztof Oldzki
+
+2009-01-23 14:53  jsafranek
+
+   * snmplib/snmp_logging.c:
+
+   Fix parsing of level ranges in '-L<capital>'.
+
+2009-01-13 09:17  jsafranek
+
+   * snmplib/asn1.c:
+
+   Check encoding of OIDs.
+   
+   BER encoded OIDs should have high bit clear in the last byte of
+   each subidentifier. This is now checked and parsing of OID fails,
+   if this condition is not met.
+
+2009-01-08 10:45  jsafranek
+
+   * snmplib/snmp_logging.c:
+
+   CHANGES: snmpd, apps: Parser of -LS command line argument now
+   accepts both '-LS <level> <facility>' and '-LS
+   <level><facility>'.
+   
+   Before patch #1806336 the first syntax was the only one
+   supported. The patch
+   changed the syntax to the second one, causing incompatibilities
+   in stable
+   branches. We now support both of them.
+
+2009-01-06 22:23  hardaker
+
+   * COPYING:
+
+   update SPARTA for 2009
+
+2008-12-15 23:25  hardaker
+
+   * agent/mibgroup/disman/expression/expValueTable.c:
+
+   Patch to change a typedef name from link to nodelink to avoid
+   naming conflict issues.
+
+2008-12-09 01:01  hardaker
+
+   * include/net-snmp/library/snmplocalsm.h, snmplib/snmplocalsm.c:
+
+   As agreed in the admin meeting, remove the older snmplocalsm
+   security model
+
+2008-12-04 11:44  jsafranek
+
+   *  snmplib/snmpTCPDomain.c, snmplib/snmpTCPIPv6Domain.c,   
+      snmplib/snmpUDPDomain.c:
+
+   Print ports as unsigned numbers.
+
+2008-11-20 20:51  magfr
+
+   * snmplib/snmpSTDDomain.c:
+
+   Make log refer to the right function.
+
+2008-11-20 20:46  magfr
+
+   * apps/snmptrapd.c:
+
+   CHANGES: Do not use %m in printf-formatted strings since %m in
+   printf is a glibc extension.
+
+2008-11-13 00:30  tanders
+
+   * python/netsnmp/client_intf.c:
+
+   CHANGES: python: BUG: 2258935: Python Extension Module fails on
+   Solaris
+
+2008-11-13 00:26  tanders
+
+   * configure.in:
+
+   fix typo
+
+2008-11-13 00:24  tanders
+
+   * dist/extractnews:
+
+   make scripts executable
+
+2008-11-12 17:38  hardaker
+
+   * agent/snmp_perl.c:
+
+   fix typo/spelling in an embedded perl error message
+
+2008-11-11 13:13  jsafranek
+
+   * agent/mibgroup/if-mib/data_access/interface_linux.c:
+
+   Fix compilation on older Linuxes without SPEED_10000 and
+   SPEED_2500.
+
+2008-11-01 19:25  hardaker
 
    * agent/snmp_agent.c:
 
    NEWS: snmpd: Applying patch from Magnus Fromreide to fix the
    getbulk issue reported by Oscar Mira-Sanchez
 
+2008-10-22 07:29  dts12
+
+   * snmplib/snmp_client.c:
+
+   Don't clear session flags when testing one bit.
+
+2008-10-16 09:56  jsafranek
+
+   *  agent/mibgroup/if-mib/data_access/interface.c,   
+      agent/mibgroup/if-mib/data_access/interface_linux.c,   
+      include/net-snmp/data_access/interface.h:
+
+   CHANGES: snmpd: PATCH: 2082726: correctly report NIC speeds
+   higher than 4Gbit/s
+
+2008-10-14 18:55  dts12
+
+   * snmplib/snmpUDPDomain.c:
+
+   CHANGES: snmplib: PATCH: 2043018: fix recvfrom hangs
+   Also addresses (closed) bugs 1171904 and 1345296
+
+2008-10-14 09:44  jsafranek
+
+   * agent/mibgroup/ip-mib/data_access/ipaddress_linux.c:
+
+   CHANGES: snmpd: fix memory leak when multiple interfaces have the
+   same IPv6 address
+
+2008-10-14 09:37  jsafranek
+
+   * include/net-snmp/library/container.h, snmplib/container.c:
+
+   CHANGES: snmpd: BUG: 1693039: be silent when insert fails.
+
+2008-10-13 19:01  dts12
+
+   *  agent/mibgroup/ucd-snmp/pass.c,   
+      agent/mibgroup/ucd-snmp/pass_persist.c:
+
+   CHANGES: snmpd: PATCH: 1977439: Fix pass/_persist bug with SET
+   oid value
+
+2008-10-07 08:50  jsafranek
+
+   * dist/find-requires:
+
+   CHANGES: building: BUG: 2095983: fix syntax error in
+   find-requires helper script and make it executable
+
+2008-09-30 22:11  dts12
+
+   * perl/agent/agent.xs:
+
+   CHANGES: perl: PATCH: 2022948: Fix for Counter64 in perl subagent
+
+2008-09-30 21:08  dts12
+
+   * agent/snmp_agent.c:
+
+   CHANGES: agent: PATCH: 1257347: Non-fixed size connection buffer
+
+2008-09-24 12:53  jsafranek
+
+   *  agent/mibgroup/sctp-mib/sctpScalars_linux.c,   
+      agent/mibgroup/sctp-mib/sctpTables_linux.c:
+
+   Use the longest integer for inode numbers and (possibly 64 bit)
+   counters.
+
+2008-09-05 09:27  dts12
+
+   *  FAQ, README, configure, configure.in, dist/net-snmp.spec,   
+      sedscript.in, snmplib/snmp_version.c:
+
+   - version tag ( 5.4.2 )
+
+2008-09-05 09:27  dts12
+
+   * CHANGES:
+
+   version update
+
+2008-09-05 09:25  dts12
+
+   * ChangeLog:
+
+   version update
+
+2008-09-05 09:20  dts12
+
+   *  man/netsnmp_agent.3, man/netsnmp_agent_registry.3,   
+      man/netsnmp_agent_trap.3, man/netsnmp_asn1_packet_parse.3,   
+      man/netsnmp_baby_steps.3, man/netsnmp_bulk_to_next.3,   
+      man/netsnmp_cache_handler.3, man/netsnmp_callback.3,   
+      man/netsnmp_container.3, man/netsnmp_data_list.3,   
+      man/netsnmp_debug.3, man/netsnmp_default_store.3,   
+      man/netsnmp_handler.3, man/netsnmp_instance.3,   
+      man/netsnmp_iterator_info_s.3, man/netsnmp_leaf.3,   
+      man/netsnmp_library.3, man/netsnmp_mib_maintenance.3,   
+      man/netsnmp_mib_utilities.3, man/netsnmp_mode_end_call.3,   
+      man/netsnmp_multiplexer.3,   
+      man/netsnmp_netsnmp_agent_request_info_s.3,   
+      man/netsnmp_netsnmp_column_info_t.3,   
+      man/netsnmp_netsnmp_data_list_s.3,   
+      man/netsnmp_netsnmp_handler_registration_s.3,   
+      man/netsnmp_netsnmp_iterator_info_s.3,   
+      man/netsnmp_netsnmp_mib_handler_access_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_methods.3,   
+      man/netsnmp_netsnmp_mib_handler_s.3,   
+      man/netsnmp_netsnmp_request_info_s.3,   
+      man/netsnmp_netsnmp_table_registration_info_s.3,   
+      man/netsnmp_netsnmp_table_request_info_s.3,   
+      man/netsnmp_oid_stash.3, man/netsnmp_old_api.3,   
+      man/netsnmp_read_config.3, man/netsnmp_read_only.3,   
+      man/netsnmp_row_merge.3, man/netsnmp_scalar.3,   
+      man/netsnmp_scalar_group_group.3, man/netsnmp_serialize.3,   
+      man/netsnmp_snmp_agent.3, man/netsnmp_snmp_alarm.3,   
+      man/netsnmp_snmp_client.3, man/netsnmp_snmp_logging.3,   
+      man/netsnmp_snmp_pdu.3, man/netsnmp_snmp_session.3,   
+      man/netsnmp_stash_cache.3, man/netsnmp_stash_to_next.3,   
+      man/netsnmp_table.3, man/netsnmp_table_array.3,   
+      man/netsnmp_table_container.3, man/netsnmp_table_data.3,   
+      man/netsnmp_table_dataset.3, man/netsnmp_table_generic.3,   
+      man/netsnmp_table_indexes.3, man/netsnmp_table_iterator.3,   
+      man/netsnmp_table_iterator.h.3, man/netsnmp_table_maintenance.3,  
+       man/netsnmp_table_rows.3, man/netsnmp_tdata.3,   
+      man/netsnmp_util.3, man/netsnmp_utilities.3,   
+      man/netsnmp_variable_list.3, man/netsnmp_watcher.3:
+
+   documentation update
+
+2008-09-05 09:16  dts12
+
+   * doxygen.conf:
+
+   - version tag ( 5.4.2 )
+
 -------------------------------------------------------------------------------
 
 Changes: V5.4.1 -> V5.4.2

=== modified file 'EXAMPLE.conf.def'
--- EXAMPLE.conf.def	2007-12-08 14:59:50 +0000
+++ EXAMPLE.conf.def	2010-06-10 18:02:54 +0000
@@ -1,408 +1,193 @@
 ###############################################################################
 #
 # EXAMPLE.conf:
-#   An example configuration file for configuring the ucd-snmp snmpd agent.
-#
-###############################################################################
-#
-# This file is intended to only be an example.  If, however, you want
-# to use it, it should be placed in SYSCONFDIR/snmp/snmpd.conf.
-# When the snmpd agent starts up, this is where it will look for it.
-#
-# You might be interested in generating your own snmpd.conf file using
-# the "snmpconf" program (perl script) instead.  It's a nice menu
-# based interface to writing well commented configuration files.  Try it!
-#
-# Note: This file is automatically generated from EXAMPLE.conf.def.
-# Do NOT read the EXAMPLE.conf.def file! Instead, after you have run
-# configure & make, and then make sure you read the EXAMPLE.conf file
-# instead, as it will tailor itself to your configuration.
-
-# All lines beginning with a '#' are comments and are intended for you
-# to read.  All other lines are configuration commands for the agent.
-
-#
-# PLEASE: read the snmpd.conf(5) manual page as well!
-#
-
-
-###############################################################################
-# Access Control
-###############################################################################
-
-# YOU SHOULD CHANGE THE "COMMUNITY" TOKEN BELOW TO A NEW KEYWORD ONLY
-# KNOWN AT YOUR SITE.  YOU *MUST* CHANGE THE NETWORK TOKEN BELOW TO
-# SOMETHING REFLECTING YOUR LOCAL NETWORK ADDRESS SPACE.
-
-# By far, the most common question I get about the agent is "why won't
-# it work?", when really it should be "how do I configure the agent to
-# allow me to access it?"
-#
-# By default, the agent responds to the "public" community for read
-# only access, if run out of the box without any configuration file in 
-# place.  The following examples show you other ways of configuring
-# the agent so that you can change the community names, and give
-# yourself write access as well.
-#
-# The following lines change the access permissions of the agent so
-# that the COMMUNITY string provides read-only access to your entire
-# NETWORK (EG: 10.10.10.0/24), and read/write access to only the
-# localhost (127.0.0.1, not its real ipaddress).
-#
-# For more information, read the FAQ as well as the snmpd.conf(5)
-# manual page.
-
-####
-# First, map the community name (COMMUNITY) into a security name
-# (local and mynetwork, depending on where the request is coming
-# from):
-
-#       sec.name  source          community
-com2sec local     localhost       COMMUNITY
-com2sec mynetwork NETWORK/24      COMMUNITY
-
-####
-# Second, map the security names into group names:
-
-#             	sec.model  sec.name
-group MyRWGroup	v1         local
-group MyRWGroup	v2c        local
-group MyRWGroup	usm        local
-group MyROGroup v1         mynetwork
-group MyROGroup v2c        mynetwork
-group MyROGroup usm        mynetwork
-
-####
-# Third, create a view for us to let the groups have rights to:
-
-#           incl/excl subtree                          mask
-view all    included  .1                               80
-
-####
-# Finally, grant the 2 groups access to the 1 view with different
-# write permissions:
-
-#                context sec.model sec.level match  read   write  notif
-access MyROGroup ""      any       noauth    exact  all    none   none
-access MyRWGroup ""      any       noauth    exact  all    all    none
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# System contact information
-#
-
-# It is also possible to set the sysContact and sysLocation system
-# variables through the snmpd.conf file.  **PLEASE NOTE** that setting
-# the value of these objects here makes these objects READ-ONLY
-# (regardless of any access control settings).  Any attempt to set the
-# value of an object whose value is given here will fail with an error
-# status of notWritable.
-
-syslocation Right here, right now.
-syscontact Me <me@somewhere.org>
-
-# Example output of snmpwalk:
-#   % snmpwalk -v 1 -c public localhost system
-#   system.sysDescr.0 = "SunOS name sun4c"
-#   system.sysObjectID.0 = OID: enterprises.ucdavis.ucdSnmpAgent.sunos4
-#   system.sysUpTime.0 = Timeticks: (595637548) 68 days, 22:32:55
-#   system.sysContact.0 = "Me <me@somewhere.org>"
-#   system.sysName.0 = "name"
-#   system.sysLocation.0 = "Right here, right now."
-#   system.sysServices.0 = 72
-
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# Process checks.
-#
-#  The following are examples of how to use the agent to check for
-#  processes running on the host.  The syntax looks something like:
-#
-#  proc NAME [MAX=0] [MIN=0]
-#
-#  NAME:  the name of the process to check for.  It must match
-#         exactly (ie, http will not find httpd processes).
-#  MAX:   the maximum number allowed to be running.  Defaults to 0.
-#  MIN:   the minimum number to be running.  Defaults to 0.
-
-#
-#  Examples:
-#
-
-#  Make sure mountd is running
-proc mountd
-
-#  Make sure there are no more than 4 ntalkds running, but 0 is ok too.
-proc ntalkd 4
-
-#  Make sure at least one sendmail, but less than or equal to 10 are running.
-proc sendmail 10 1
-
-#  A snmpwalk of the prTable would look something like this:
-# 
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.PROCMIBNUM
-# enterprises.ucdavis.procTable.prEntry.prIndex.1 = 1
-# enterprises.ucdavis.procTable.prEntry.prIndex.2 = 2
-# enterprises.ucdavis.procTable.prEntry.prIndex.3 = 3
-# enterprises.ucdavis.procTable.prEntry.prNames.1 = "mountd"
-# enterprises.ucdavis.procTable.prEntry.prNames.2 = "ntalkd"
-# enterprises.ucdavis.procTable.prEntry.prNames.3 = "sendmail"
-# enterprises.ucdavis.procTable.prEntry.prMin.1 = 0
-# enterprises.ucdavis.procTable.prEntry.prMin.2 = 0
-# enterprises.ucdavis.procTable.prEntry.prMin.3 = 1
-# enterprises.ucdavis.procTable.prEntry.prMax.1 = 0
-# enterprises.ucdavis.procTable.prEntry.prMax.2 = 4
-# enterprises.ucdavis.procTable.prEntry.prMax.3 = 10
-# enterprises.ucdavis.procTable.prEntry.prCount.1 = 0
-# enterprises.ucdavis.procTable.prEntry.prCount.2 = 0
-# enterprises.ucdavis.procTable.prEntry.prCount.3 = 1
-# enterprises.ucdavis.procTable.prEntry.prErrorFlag.1 = 1
-# enterprises.ucdavis.procTable.prEntry.prErrorFlag.2 = 0
-# enterprises.ucdavis.procTable.prEntry.prErrorFlag.3 = 0
-# enterprises.ucdavis.procTable.prEntry.prErrMessage.1 = "No mountd process running."
-# enterprises.ucdavis.procTable.prEntry.prErrMessage.2 = ""
-# enterprises.ucdavis.procTable.prEntry.prErrMessage.3 = ""
-# enterprises.ucdavis.procTable.prEntry.prErrFix.1 = 0
-# enterprises.ucdavis.procTable.prEntry.prErrFix.2 = 0
-# enterprises.ucdavis.procTable.prEntry.prErrFix.3 = 0
-#
-#  Note that the errorFlag for mountd is set to 1 because one is not
-#  running (in this case an rpc.mountd is, but thats not good enough),
-#  and the ErrMessage tells you what's wrong.  The configuration
-#  imposed in the snmpd.conf file is also shown.  
-# 
-#  Special Case:  When the min and max numbers are both 0, it assumes
-#  you want a max of infinity and a min of 1.
-#
-
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# Executables/scripts
-#
-
-#
-#  You can also have programs run by the agent that return a single
-#  line of output and an exit code.  Here are two examples.
-#
-#  exec NAME PROGRAM [ARGS ...]
-#
-#  NAME:     A generic name.
-#  PROGRAM:  The program to run.  Include the path!
-#  ARGS:     optional arguments to be passed to the program
-
-# a simple hello world
-exec echotest /bin/echo hello world
-
-# Run a shell script containing:
-#
-# #!/bin/sh
-# echo hello world
-# echo hi there
-# exit 35
-#
-# Note:  this has been specifically commented out to prevent
-# accidental security holes due to someone else on your system writing
-# a /tmp/shtest before you do.  Uncomment to use it.
-#
-#exec shelltest /bin/sh /tmp/shtest
-
-# Then, 
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.SHELLMIBNUM
-# enterprises.ucdavis.extTable.extEntry.extIndex.1 = 1
-# enterprises.ucdavis.extTable.extEntry.extIndex.2 = 2
-# enterprises.ucdavis.extTable.extEntry.extNames.1 = "echotest"
-# enterprises.ucdavis.extTable.extEntry.extNames.2 = "shelltest"
-# enterprises.ucdavis.extTable.extEntry.extCommand.1 = "/bin/echo hello world"
-# enterprises.ucdavis.extTable.extEntry.extCommand.2 = "/bin/sh /tmp/shtest"
-# enterprises.ucdavis.extTable.extEntry.extResult.1 = 0
-# enterprises.ucdavis.extTable.extEntry.extResult.2 = 35
-# enterprises.ucdavis.extTable.extEntry.extOutput.1 = "hello world."
-# enterprises.ucdavis.extTable.extEntry.extOutput.2 = "hello world."
-# enterprises.ucdavis.extTable.extEntry.extErrFix.1 = 0
-# enterprises.ucdavis.extTable.extEntry.extErrFix.2 = 0
-
-# Note that the second line of the /tmp/shtest shell script is cut
-# off.  Also note that the exit status of 35 was returned.
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# disk checks
-#
-
-# The agent can check the amount of available disk space, and make
-# sure it is above a set limit.  
-
-# disk PATH [MIN=DEFDISKMINIMUMSPACE]
-#
-# PATH:  mount path to the disk in question.
-# MIN:   Disks with space below this value will have the Mib's errorFlag set.
-#        Default value = DEFDISKMINIMUMSPACE.
-
-# Check the / partition and make sure it contains at least 10 megs.
-
-disk / 10000
-
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.DISKMIBNUM
-# enterprises.ucdavis.diskTable.dskEntry.diskIndex.1 = 0
-# enterprises.ucdavis.diskTable.dskEntry.diskPath.1 = "/" Hex: 2F 
-# enterprises.ucdavis.diskTable.dskEntry.diskDevice.1 = "/dev/dsk/c201d6s0"
-# enterprises.ucdavis.diskTable.dskEntry.diskMinimum.1 = 10000
-# enterprises.ucdavis.diskTable.dskEntry.diskTotal.1 = 837130
-# enterprises.ucdavis.diskTable.dskEntry.diskAvail.1 = 316325
-# enterprises.ucdavis.diskTable.dskEntry.diskUsed.1 = 437092
-# enterprises.ucdavis.diskTable.dskEntry.diskPercent.1 = 58
-# enterprises.ucdavis.diskTable.dskEntry.diskErrorFlag.1 = 0
-# enterprises.ucdavis.diskTable.dskEntry.diskErrorMsg.1 = ""
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# load average checks
-#
-
-# load [1MAX=DEFMAXLOADAVE] [5MAX=DEFMAXLOADAVE] [15MAX=DEFMAXLOADAVE]
-#
-# 1MAX:   If the 1 minute load average is above this limit at query
-#         time, the errorFlag will be set.
-# 5MAX:   Similar, but for 5 min average.
-# 15MAX:  Similar, but for 15 min average.
-
-# Check for loads:
-load 12 14 14
-
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.LOADAVEMIBNUM
-# enterprises.ucdavis.loadTable.laEntry.loadaveIndex.1 = 1
-# enterprises.ucdavis.loadTable.laEntry.loadaveIndex.2 = 2
-# enterprises.ucdavis.loadTable.laEntry.loadaveIndex.3 = 3
-# enterprises.ucdavis.loadTable.laEntry.loadaveNames.1 = "Load-1"
-# enterprises.ucdavis.loadTable.laEntry.loadaveNames.2 = "Load-5"
-# enterprises.ucdavis.loadTable.laEntry.loadaveNames.3 = "Load-15"
-# enterprises.ucdavis.loadTable.laEntry.loadaveLoad.1 = "0.49" Hex: 30 2E 34 39 
-# enterprises.ucdavis.loadTable.laEntry.loadaveLoad.2 = "0.31" Hex: 30 2E 33 31 
-# enterprises.ucdavis.loadTable.laEntry.loadaveLoad.3 = "0.26" Hex: 30 2E 32 36 
-# enterprises.ucdavis.loadTable.laEntry.loadaveConfig.1 = "12.00"
-# enterprises.ucdavis.loadTable.laEntry.loadaveConfig.2 = "14.00"
-# enterprises.ucdavis.loadTable.laEntry.loadaveConfig.3 = "14.00"
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrorFlag.1 = 0
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrorFlag.2 = 0
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrorFlag.3 = 0
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrMessage.1 = ""
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrMessage.2 = ""
-# enterprises.ucdavis.loadTable.laEntry.loadaveErrMessage.3 = ""
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# Extensible sections.
-# 
-
-# This alleviates the multiple line output problem found in the
-# previous executable mib by placing each mib in its own mib table:
-
-# Run a shell script containing:
-#
-# #!/bin/sh
-# echo hello world
-# echo hi there
-# exit 35
-#
-# Note:  this has been specifically commented out to prevent
-# accidental security holes due to someone else on your system writing
-# a /tmp/shtest before you do.  Uncomment to use it.
-#
-# exec .EXTENSIBLEDOTMIB.50 shelltest /bin/sh /tmp/shtest
-
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.50
-# enterprises.ucdavis.50.1.1 = 1
-# enterprises.ucdavis.50.2.1 = "shelltest"
-# enterprises.ucdavis.50.3.1 = "/bin/sh /tmp/shtest"
-# enterprises.ucdavis.50.100.1 = 35
-# enterprises.ucdavis.50.101.1 = "hello world."
-# enterprises.ucdavis.50.101.2 = "hi there."
-# enterprises.ucdavis.50.102.1 = 0
-
-# Now the Output has grown to two lines, and we can see the 'hi
-# there.' output as the second line from our shell script.
-#
-# Note that you must alter the mib.txt file to be correct if you want
-# the .50.* outputs above to change to reasonable text descriptions.
-
-# Other ideas:
-# 
-# exec .EXTENSIBLEDOTMIB.51 ps /bin/ps 
-# exec .EXTENSIBLEDOTMIB.52 top /usr/local/bin/top
-# exec .EXTENSIBLEDOTMIB.53 mailq /usr/bin/mailq
-
-# -----------------------------------------------------------------------------
-
-
-###############################################################################
-# Pass through control.
-# 
-
-# Usage:
-#   pass MIBOID EXEC-COMMAND
-#
-# This will pass total control of the mib underneath the MIBOID
-# portion of the mib to the EXEC-COMMAND.  
-#
-# Note:  You'll have to change the path of the passtest script to your
-# source directory or install it in the given location.
-# 
-# Example:  (see the script for details)
-#           (commented out here since it requires that you place the
-#           script in the right location. (its not installed by default))
-
-# pass .EXTENSIBLEDOTMIB.255 /bin/sh PREFIX/local/passtest
-
-# % snmpwalk -v 1 -c public localhost .EXTENSIBLEDOTMIB.255
-# enterprises.ucdavis.255.1 = "life the universe and everything"
-# enterprises.ucdavis.255.2.1 = 42
-# enterprises.ucdavis.255.2.2 = OID: 42.42.42
-# enterprises.ucdavis.255.3 = Timeticks: (363136200) 42 days, 0:42:42
-# enterprises.ucdavis.255.4 = IpAddress: 127.0.0.1
-# enterprises.ucdavis.255.5 = 42
-# enterprises.ucdavis.255.6 = Gauge: 42
-#
-# % snmpget -v 1 -c public localhost .EXTENSIBLEDOTMIB.255.5
-# enterprises.ucdavis.255.5 = 42
-#
-# % snmpset -v 1 -c public localhost .EXTENSIBLEDOTMIB.255.1 s "New string"
-# enterprises.ucdavis.255.1 = "New string"
-#
-
-# For specific usage information, see the man/snmpd.conf.5 manual page
-# as well as the local/passtest script used in the above example.
-
-###############################################################################
-# Subagent control
-#
-
-# The agent can support subagents using a number of extension mechanisms.
-# From the 4.2.1 release, AgentX support is being compiled in by default.
-# To use this mechanism, simply uncomment the following directive.
-#
-#  master  agentx
-#
-#   Please see the file README.agentx for more details.
-#
-
-
-###############################################################################
-# Further Information
-#
-#  See the snmpd.conf manual page, and the output of "snmpd -H".
-#  MUCH more can be done with the snmpd.conf than is shown as an
-#  example here.
+#   An example configuration file for configuring the Net-SNMP agent ('snmpd')
+#   See the 'snmpd.conf(5)' man page for details
+#
+#  Some entries are deliberately commented out, and will need to be explicitly activated
+#
+###############################################################################
+#
+#  AGENT BEHAVIOUR
+#
+
+#  Listen for connections from the local system only
+agentAddress  udp:127.0.0.1:161
+#  Listen for connections on all interfaces (both IPv4 *and* IPv6)
+#agentAddress udp:161,udp6:[::1]:161
+
+
+
+###############################################################################
+#
+#  SNMPv3 AUTHENTICATION
+#
+#  Note that these particular settings don't actually belong here.
+#  They should be copied to the file /var/net-snmp/snmpd.conf
+#     and the passwords changed, before being uncommented in that file *only*.
+#  Then restart the agent
+
+#  createUser authOnlyUser  MD5 "remember to change this password"
+#  createUser authPrivUser  SHA "remember to change this one too"  DES
+#  createUser internalUser  MD5 "this is only ever used internally, but still change the password"
+
+#  If you also change the usernames (which might be sensible),
+#  then remember to update the other occurances in this example config file to match.
+
+
+
+###############################################################################
+#
+#  ACCESS CONTROL
+#
+
+                                                 #  system + hrSystem groups only
+view   systemonly  included   .1.3.6.1.2.1.1
+view   systemonly  included   .1.3.6.1.2.1.25.1
+
+                                                 #  Full access from the local host
+#rocommunity public  localhost
+                                                 #  Default access to basic system info
+ rocommunity public  default    -V systemonly
+
+                                                 #  Full access from an example network
+                                                 #     Adjust this network address to match your local
+                                                 #     settings, change the community string,
+                                                 #     and check the 'agentAddress' setting above
+#rocommunity secret  10.0.0.0/16
+
+                                                 #  Full read-only access for SNMPv3
+ rouser   authOnlyUser
+                                                 #  Full write access for encrypted requests
+                                                 #     Remember to activate the 'createUser' lines above
+#rwuser   authPrivUser   priv
+
+#  It's no longer typically necessary to use the full 'com2sec/group/access' configuration
+#  r[ou]user and r[ow]community, together with suitable views, should cover most requirements
+
+
+
+###############################################################################
+#
+#  SYSTEM INFORMATION
+#
+
+#  Note that setting these values here, results in the corresponding MIB objects being 'read-only'
+#  See snmpd.conf(5) for more details
+sysLocation    Sitting on the Dock of the Bay
+sysContact     Me <me@example.org>
+                                                 # Application + End-to-End layers
+sysServices    72
+
+
+#
+#  Process Monitoring
+#
+                               # At least one  'mountd' process
+proc  mountd
+                               # No more than 4 'ntalkd' processes - 0 is OK
+proc  ntalkd    4
+                               # At least one 'sendmail' process, but no more than 10
+proc  sendmail 10 1
+
+#  Walk the UCD-SNMP-MIB::prTable to see the resulting output
+#  Note that this table will be empty if there are no "proc" entries in the snmpd.conf file
+
+
+#
+#  Disk Monitoring
+#
+                               # 10MBs required on root disk, 5% free on /var, 10% free on all other disks
+disk       /     10000
+disk       /var  5%
+includeAllDisks  10%
+
+#  Walk the UCD-SNMP-MIB::dskTable to see the resulting output
+#  Note that this table will be empty if there are no "disk" entries in the snmpd.conf file
+
+
+#
+#  System Load
+#
+                               # Unacceptable 1-, 5-, and 15-minute load averages
+load   12 10 5
+
+#  Walk the UCD-SNMP-MIB::laTable to see the resulting output
+#  Note that this table *will* be populated, even without a "load" entry in the snmpd.conf file
+
+
+
+###############################################################################
+#
+#  ACTIVE MONITORING
+#
+
+                                    #   send SNMPv1  traps
+ trapsink     localhost public
+                                    #   send SNMPv2c traps
+#trap2sink    localhost public
+                                    #   send SNMPv2c INFORMs
+#informsink   localhost public
+
+#  Note that you typically only want *one* of these three lines
+#  Uncommenting two (or all three) will result in multiple copies of each notification.
+
+
+#
+#  Event MIB - automatically generate alerts
+#
+                                   # Remember to activate the 'createUser' lines above
+iquerySecName   internalUser       
+rouser          internalUser
+                                   # generate traps on UCD error conditions
+defaultMonitors          yes
+                                   # generate traps on linkUp/Down
+linkUpDownNotifications  yes
+
+
+
+###############################################################################
+#
+#  EXTENDING THE AGENT
+#
+
+#
+#  Arbitrary extension commands
+#
+ extend    test1   /bin/echo  Hello, world!
+ extend-sh test2   echo Hello, world! ; echo Hi there ; exit 35
+#extend-sh test3   /bin/sh /tmp/shtest
+
+#  Note that this last entry requires the script '/tmp/shtest' to be created first,
+#    containing the same three shell commands, before the line is uncommented
+
+#  Walk the NET-SNMP-EXTEND-MIB tables (nsExtendConfigTable, nsExtendOutput1Table
+#     and nsExtendOutput2Table) to see the resulting output
+
+#  Note that the "extend" directive supercedes the previous "exec" and "sh" directives
+#  However, walking the UCD-SNMP-MIB::extTable should still returns the same output,
+#     as well as the fuller results in the above tables.
+
+
+#
+#  "Pass-through" MIB extension command
+#
+#pass .1.3.6.1.4.1.8072.2.255  /bin/sh       PREFIX/local/passtest
+#pass .1.3.6.1.4.1.8072.2.255  /usr/bin/perl PREFIX/local/passtest.pl
+
+# Note that this requires one of the two 'passtest' scripts to be installed first,
+#    before the appropriate line is uncommented.
+# These scripts can be found in the 'local' directory of the source distribution,
+#     and are not installed automatically.
+
+#  Walk the NET-SNMP-PASS-MIB::netSnmpPassExamples subtree to see the resulting output
+
+
+#
+#  AgentX Sub-agents
+#
+                                           #  Run as an AgentX master agent
+ master          agentx
+                                           #  Listen for network connections (from localhost)
+                                           #    rather than the default named socket /var/agentx/master
+#agentXSocket    tcp:localhost:705

=== modified file 'FAQ'
--- FAQ	2009-11-12 16:17:40 +0000
+++ FAQ	2010-06-10 18:02:54 +0000
@@ -1,8 +1,8 @@
       Frequently Asked Questions (FAQ) for the UCD/Net-SNMP package
       =============================================================
 		       FAQ Author: Dave Shield
-	        net-snmp Version: 5.4.2.1 SVN branch
-	    net-snmp/ucd-snmp Project Leader: Wes Hardaker
+	        Net-SNMP Version: 5.4.3 SVN branch
+	    Net-SNMP/UCD-SNMP Project Leader: Wes Hardaker
 	     Email: net-snmp-coders@lists.sourceforge.net
 
 TABLE OF CONTENTS
@@ -26,7 +26,9 @@
    What's the difference between SNMPv2 and SNMPv2c?
    Which versions of SNMP are supported in this package?
    Can I use SNMPv1 requests with an SNMPv2 MIB (or vice versa)?
+   How can I monitor my system with SNMP?
    Where can I find more information about network management?
+   What ports does SNMP use?
    Is Net-SNMP thread safe?
  APPLICATIONS
    How do I add a MIB?
@@ -44,15 +46,21 @@
    Variables seem to disappear when I try to set them.  Why?
    Why can't I change sysLocation (or sysContact)?
    I get an error when trying to set a negative value - why?
-   I get an error when trying to get a string-indexed table value - why?
+   I get an error when trying to query a string-indexed table value - why?
+   How should I specify string-indexed table values?
    How do I send traps and notifications?
-   How do I handle traps and notifications?
+   How do I receive traps and notifications?
+   How do I receive SNMPv1 traps?
+   Why don't I receive incoming traps?
    My traphandler script doesn't work when run like this - why not?
+   How can the agent receive traps and notifications?
    How big can an SNMP request (or reply) be?
    How can I monitor my systems (disk, memory, etc)?
    Applications complain about entries in your example 'snmp.conf' file.  Why?
    OK, what should I put in snmp.conf?
+   How do I specify IPv6 addresses in tools command line arguments?
  PERL
+   What is the purpose of the Perl SNMP module?
    Where can I get the Perl SNMP package?
    How do I install the Perl SNMP modules?
    But compiling this fails! Why?
@@ -64,10 +72,11 @@
    I've got a problem with the Net-SNMP module.  Can you help?
  MIBS
    Where can I find a MIB compiler?
-   Why aren't my mib files being read in?
+   Why aren't my MIB files being read in?
+   Where should I put my MIB files?
+   What does "Cannot find module (XXX-MIB)" mean?
    I'm getting answers, but they're all numbers. Why?
-   What does "Cannot find module (XXX-MIB)" mean?
-   What about "unlinked OID"?
+   What does "unlinked OID" mean?
    The parser doesn't handle comments properly. Why not?
    How can I get more information about problems with MIB files?
    What's this about "too many imported symbols"?
@@ -81,10 +90,9 @@
    How do I add a MIB to the agent?
    What's the difference between 'exec', 'sh', 'extend' and 'pass'?
    What's the difference between AgentX, SMUX and proxied SNMP?
-   What about 'dlmod' - what's that about?
+   What is the purpose of 'dlmod'?
    Which should I use?
    Can I use AgentX when running under Windows?
-   Can I use AgentX (or an embedded SNMP agent) in a threaded application?
    How can I run AgentX with a different socket address?
    How can I turn off SMUX support?
    How can I combine two copies of the 'mib2' tree from separate subagents?
@@ -95,12 +103,14 @@
    After a while the agent stops responding, and starts eating CPU time.  Why?
    How can I stop other people getting at my agent?
    How can I listen on just one particular interface?
+   The agent is complaining about 'snmpd.conf'.  Where is this?
+   Why does the agent complain about 'no access control information'?
    How do I configure access control?
-   I don't understand the new access control stuff - what does it mean?
    How do I configure SNMPv3 users?
    The 'createUser' line disappears when I start the agent.  Why?
    What's the difference between /var/net-snmp and /usr/local/share/snmp?
    My new agent is ignoring the old snmpd.conf file. Why?
+   Where should the snmpd.conf file go?
    Why am I getting "Connection refused"?
    Why can't I see values in the UCDavis 'extensible' or 'disk' trees?
    Why can't I see values in the UCDavis 'memory' or 'vmstat' tree?
@@ -112,19 +122,19 @@
    Does the agent support the RMON-MIB?
    What does "klread:  bad address" mean?
    What does "nlist err:  wombat not found" (or similar) mean?
-   How about "Can't open /dev/kmem"?
-   The agent is complaining about 'snmpd.conf'.  Where is this?
+   What does "Can't open /dev/kmem" mean?
    The system uptime (sysUpTime) returned is wrong!
    Can the agent run multi-threaded?
+   Can I use AgentX (or an embedded SNMP agent) in a threaded application?
  COMPILING
-   How do I compile with 'cc' instead of 'gcc'?
-   The compilation is complaining about missing libraries. Why?
-   I'm getting an error "autoheader: not found" - what's wrong?
+   How do I control the environment used to compile the software?
+   How do I control the environment used to compile the software under Windows?
+   Why does the compilation complain about missing libraries?
    How can I reduce the memory footprint?
    How can I reduce the installation footprint or speed up compilation?
+   How can I compile the project for use on an embedded system?
    How can I compile the project to use static linking?
-   Why is the project workspace empty under Visual C++?
-   Why does 'make test' skip five tests?
+   Why does 'make test' skip various tests?
    Why does 'make test' complain about a pid file?
  CODING
    How do I write C code to integrate with the agent?
@@ -136,18 +146,17 @@
    What's the difference between the various mib2c configuration files?
    Which mib2c configuration file should I use?
    How can I have mib2c generate code for both scalars and tables?
-   Are there any examples, or documentation?
+   Are there any examples, or documentation for developing MIB modules?
    Where should I put the files produced by 'mib2c'?
-   I've created a new module with 'mib2c' but it doesn't work.  Why not?
-   I've added my code to this template and it still doesn't work.  Why not?
+   Why doesn't my new MIB module report anything?
    Why does the iterator call my get_{first,next} routines so often?
    How can I get the agent to generate a trap (or inform)?
+   How can I get an AgentX sub-agent to generate a trap (or inform)?
    How can I get the agent to send an SNMPv1 (or SNMPv2c) trap?
    How can I get the agent to include varbinds with an SNMPv1 trap?
    How can I get the agent to send an SNMPv1 enterprise-specific trap?
    How can I get the agent to send an SNMPv3 trap (or inform)?
    Why does calling 'send_v2trap' generate an SNMPv1 trap (or vice versa)?
-   What if I'm using an AgentX sub-agent instead?
    How can I register a MIB module in a different (SNMPv3) context?
  MISC
    What ASN.1 parser is used?
@@ -250,15 +259,14 @@
   and all releases on this line have been been bug-fixes only.  Release
   5.0 was the first version released under the Net-SNMP name, and all
   further development is being done on the 5.x code base.  The 4.2.x
-  code line is now almost completely dormant, and is due to be closed
-  down altogether.
+  code line is now effectively closed down, as are the older 5.x branches.
 
     Much of the work done for the various 5.x releases has involved
   some fairly significant changes to the code - in particular the
   architecture of the agent.  However attempts have been made to retain
   backwards compatibility as much as possible, and most code written
-  for earlier releases should continue to work.  The most significant
-  change from the 4.2.x ucd suite to the 5.x Net-SNMP releases was a
+  for earlier releases should continue to work.  The most visible
+  change from the 4.2.x UCD suite to the 5.x Net-SNMP releases was a
   restructuring of the header file organisation - not least a change
   from <ucd-snmp/xxx.h> to <net-snmp/yyy.h>.
 
@@ -369,14 +377,19 @@
   	net-snmp-announce@lists.sourceforge.net
 
   To be added to (or removed from) this list, visit
-  http://www.net-snmp.org/lists/net-snmp-announce/.  Or you can send a
-  message to the address
-  'net-snmp-announce-request@lists.sourceforge.net' with a subject
-  line of 'subscribe' (or 'unsubscribe' as appropriate).
-
-  Major code revisions may be announced more widely (e.g. on the
-  SNMP mailing lists, or comp.protocols.snmp) but this list is the most
-  reliable way to keep in touch with the status of this package.
+        http://www.net-snmp.org/lists/net-snmp-announce/
+  Or you can send a message to the address
+        net-snmp-announce-request@lists.sourceforge.net
+  with a subject line of 'subscribe' (or 'unsubscribe' as appropriate).
+
+  Advance notice of upcoming releases are also made on the
+  net-snmp-users list (for "release candidates") for a week
+  or two before the full release, and on the net-snmp-coders
+  list (for "pre-releases") during the period prior to this.
+
+  Major code revisions may be announced more widely, but these
+  lists are the most reliable way to keep in touch with the
+  status of the package.
 
   Patches to fix known problems are also made available via the web site:
 
@@ -392,17 +405,20 @@
   	net-snmp-users@lists.sourceforge.net
 
   To be added to (or removed from) this list, visit
-  http://www.net-snmp.org/lists/net-snmp-users.  Or you can send a
-  message to the address 'net-snmp-users-request@lists.sourceforge.net'
+        http://www.net-snmp.org/lists/net-snmp-users/
+  Or you can send a message to the address
+        net-snmp-users-request@lists.sourceforge.net
   with a subject line of 'subscribe' (or 'unsubscribe' as appropriate).
 
-  To find out what the developers are doing, and to help them out, please
-  read the PORTING file enclosed with the package.
+  To find out what the developers are doing, and to help them
+  out, please read the PORTING file enclosed with the package.
 
-  There is also an net-snmp IRC channel set up on the freenode.net IRC
-  chat servers (you can use irc.freenode.net to connect and/or see
-  http://www.freenode.net/ for getting started with irc).  Several
-  core developers hang out there on a regular basis.
+  There is also a #net-snmp IRC channel set up on the freenode.net
+  chat system.  You can connect to this via chat.freenode.net.
+  See http://www.freenode.net/ for more information on getting
+  started with IRC.
+    Several core developers hang out on this channel on a fairly
+  regular basis.
 
 
 
@@ -410,16 +426,11 @@
 -------------------------------------
 
   The best way to submit a bug report is via the bug database through
-  the interface found at http://www.net-snmp.org/bugs/.  Be sure to
-  include the version of the package that you've been working with,
-  the output of the command 'uname -a', the precise configuration or
-  command that triggers the problem and a copy of any output produced.
-
-    All patches should be submitted to the patch manager at
-  http://www.net-snmp.org/patches/.  If possible, submit a
-  bug report describing the patch as well (referencing it by its patch
-  number) since the patch manager doesn't contain a decent description
-  field.
+  the interface found at
+         http://www.net-snmp.org/bugs/
+  Be sure to include the version of the package that you've been working
+  with, the output of the command 'uname -a', the precise configuration
+  or command that triggers the problem and a copy of any output produced.
 
     Questions about using the package should be directed at the
   net-snmp-users@lists.sourceforge.net mailing list.  Note that this
@@ -436,15 +447,24 @@
           (most developers read both anyway)
      - don't mail the developers privately - keep everything on the list
 
-  Remember that this is basically an unsupported package.  Fundamentally
-  it's Open Source, so you have the source code.  If you need something
-  fixing badly enough, it's up to you to do the work.
-
     We can't promise to be able to solve all problems, but we'll
   certainly try and help.  But remember that this is basically an
   unsupported package.  It's Open Source, so if you need something
   fixing badly enough,  fundamentally it's up to you to do the work.
 
+    All patches should be submitted to the patch manager at
+         http://www.net-snmp.org/patches/
+  If possible, submit a bug report describing the patch as well
+  (referencing it by its patch number) since the patch manager
+  doesn't contain a decent description field.
+
+  The best way to submit patch (diff) information is by checking out
+  the current code from the development SVN trunk, making your changes
+  and then running "svn diff" after you're done.
+
+  If you're working from a source code distribution, and comparing old
+  and new versions of a code file, use "diff -u OLDFILE NEWFILE" 
+
 
 
 Can I reuse the code in my commercial application?
@@ -487,8 +507,8 @@
   in RFC 1905, and most recently in RFC 3416) that is "SNMPv2".
 
   The only framework based on this protocol that saw a significant
-  level of use was "Community-based SNMPv2" or "SNMPv2c" (defined in
-  RFCs 1901-1908). This retained the same administrative framework
+  level of use was "Community-based SNMPv2" or "SNMPv2c" (defined
+  in RFC 1901). This retained the same administrative framework
   as SNMPv1 (with all of the accompanying limitations), but using
   the new protocol operations.
 
@@ -522,8 +542,8 @@
 Which versions of SNMP are supported in this package?
 ----------------------------------------------------
 
-  This package currently supports the original SNMPv1, Community-based
-  SNMPv2 (i.e. RFCs 1901-1908), and SNMPv3 (i.e. RFCs 3411-3418).
+  This package currently supports the original SNMPv1 (RFC 1157),
+  Community-based SNMPv2 (RFCs 1901-1908), and SNMPv3 (RFCs 3411-3418).
     The agent will respond to requests using any of these protocols,
   and all the tools take a command-line option to determine which
   version to use.
@@ -550,8 +570,35 @@
   only accessible using SNMPv2 or higher.  SNMPv1 requests will
   either treat such objects as an error, or skip them completely.
 
+  Note that SMIv1 is effectively obsolete, and all new MIBs
+  should be written using SMIv2.
+
   
 
+How can I monitor my system with SNMP?
+-------------------------------------
+
+  There are two main methods of using SNMP for monitoring.  One is to regularly
+  query the SNMP agent for information of interest, graphing these values and/or
+  saving them for later analysis.  That's not really the focus of the Net-SNMP
+  project - our tools are more low-level, single-shot commands.  For this sort
+  of high-level management, you're really looking at a management console
+  application (such as Nagios or OpenNMS), or a data logging application
+  (such as RRDtool, or one of its front-ends - MRTG, Cacti, etc).
+
+  The other approach is to configure the SNMP agent to monitor the relevant
+  information itself, and issue an alert when the values pass suitable limits.
+  See the section ACTIVE MONITORING in the snmpd.conf(5) man page for details.
+
+  Note that this entry makes no reference as to _what_ you should monitor, or
+  what values might be significant.  That's because it is impossible to provide
+  a universal answer to these questions.  The information to monitor, and the
+  normal operating values will ultimately depend on your local environment.
+  SNMP is simply a tool to _help_ you manage your systems - it isn't a magic
+  panacea - you still have to think for yourself!
+
+
+
 Where can I find more information about network management?
 ----------------------------------------------------------
 
@@ -562,16 +609,10 @@
       http://www.snmplink.org/
       http://www.mibdepot.com/
 
-  There are two Usenet newsgroups which are relevant.
-	'comp.dcom.net-management'
-		which discusses general issues relating to network management
-	'comp.protocols.snmp'
-		which is specifically concerned with use of SNMP in particular
-
-  (though there is a large overlap between these two groups).
-  The SNMP group also has an FAQ (split into two parts) which discusses more
-  general issues related to SNMP, including books, software, other sites,
-  how to get an enterprise number, etc, etc.
+  The SNMP Usenet newsgroup is now mostly defunct, but although the
+  FAQ hasn't been updated for a while, it still contains a large
+  amount of useful information relating to SNMP, including books,
+  software, other sites, how to get an enterprise number, etc, etc.
   This is available from
 
       ftp://rtfm.mit.edu/pub/usenet/comp.protocols.snmp/
@@ -580,13 +621,29 @@
 
 
 
+What ports does SNMP use?
+------------------------
+
+  There are three main network ports (and one named socket), which are 
+  typically used by SNMP.  These are:
+
+    - UDP port 161       - SNMP requests (GET* and SET)
+    - UDP port 162       - SNMP notifications  (Traps/Informs)
+    - TCP port 705       - AgentX
+    - /var/agentx/master - AgentX
+
+  However, these are simply the default "well-known" ports for these purposes,
+  and it is perfectly possible to accept requests on other ports.
+
+
+
 Is Net-SNMP thread safe?
 -----------------------
 
-  Strictly speaking, no.  However, it should be possible to use the
-  library in a thread-safe manner.  This is covered in detail in the file
-  README.thread (shipped with the standard distribution), but can be
-  summarised as follows:
+  Strictly speaking, no.  However, it is possible to use the library within
+  a multi-threaded management application.  This is covered in detail in
+  the file README.thread (shipped with the standard distribution), but can
+  be summarised as follows:
 
     -	Call 'snmp_sess_init()' prior to activating any threads.
 	This reads in and parses MIB information (which isn't thread-safe)
@@ -599,11 +656,17 @@
     -	Resource locking is not handled within the library, and is the
 	responsibility of the main application.
 
-  The applications and the agent have not been designed for threaded use.
-  It should be safe to use the agent library to embed a subagent within
-  a threaded application as long as *all* SNMP-related activity (including
+  The Net-SNMP agent has not been designed for multi-threaded use.  It
+  should be safe to use the agent library to embed a subagent within a
+  threaded application as long as *all* SNMP-related activity (including
   generating traps, and parsing MIBs) is handled within a single thread.
 
+  The command-line tools shipped as part of the Net-SNMP distribution
+  are simple single-threaded applications, and are not designed for
+  multi-threaded use.  Adapting these to a threaded model is left as
+  an exercise for the student.
+    The same holds true for the notification receiver (snmptrapd).
+
   Unfortunately, the SNMPv3 support was added about the same time as
   the thread support and since they occurred in parallel the SNMPv3
   support was never checked for multi-threading correctness.  It is
@@ -634,124 +697,164 @@
        also showing named enumeration values, and interpreting table
        indexes properly (particularly for string and OID index values).
        
-    Most of the tools (apart from 'snmptable') will work quite happily
-  without any MIB files at all - although the results won't be displayed
-  in quite the same way.
-    The same holds true for the agent - see the AGENT section for details.
-
-
   There are two steps required to add a new MIB file to the tools.
-  Firstly, copy the MIB file into the appropiate location:
+  Firstly, copy the MIB file into the appropriate location:
 
 	cp MY-MIB.txt /usr/local/share/snmp/mibs
             (which makes it available to everyone on the system)
-
-          or
-
+    or
         mkdir $HOME/.snmp
         mkdir $HOME/.snmp/mibs
 	cp MY-MIB.txt $HOME/.snmp/mibs
             (which makes it available to you only)
 
   Note that the location of the shared MIB directory may be different
-  from that given here - particularly if you're working with a vendor
-  supplied distribution.  See where the MIBs are currently installed,
-  and copy the new MIB to the same place.
+  from that given here - see the FAQ entry "Where should I put my MIB
+  files?" for more information.
 
 
   Secondly, tell the tools to load this MIB:
 
+        snmpwalk -m +MY-MIB .....
+            (load it for this command only)
+    or
 	export MIBS=+MY-MIB
             (load it for this session only)
-
-          or
-
+    or
         echo "mibs +MY-MIB" >> $HOME/.snmp/snmp.conf
             (load it every time)
 
-  This will add the new MIB to the list of MIBs loaded by default.
-  Omitting the '+' will *replace* the list of MIBs to be loaded by
-  the specified (colon-separated) list - together with any MIBs that
-  they explicitly rely on.
-     Note that the value for this variable is the name of the MIB
+  Note that the value for this variable is the name of the MIB
   module, *not* the name of the MIB file.   These are typically the
   same (apart from the .txt suffix), but if in doubt, check the contents
   of the file.  The value to use is the token immediately before the
   word DEFINITIONS at the start of the file.
 
-    If you prefer to have the tools load all available MIBs (which
-  may slow them down), then set the MIBS environmental variable
-  (or the snmp.conf token "mibs") to the special value "ALL".
+  Or use the special value "all" to have the tools load all available
+  MIBs (which may slow them down, particularly if you have a large
+  number of MIB files.
 
   Note that you need *both* steps.
 
 
+  Adding a MIB in this way does *not* mean that the agent will
+  automatically return values from this MIB.  The agent needs to be
+  explicitly extended to support the new MIB objects, which typically
+  involves writing new code.
+    See the AGENT section for details.
+
+  Most of the tools (apart from 'snmptable') will work quite happily
+  without any MIB files at all - although the results won't be displayed
+  in quite the same way.  Similarly, the agent doesn't need MIB files
+  either (other than to handle MIB object names in the configuration file).
+
+
 
 Why can't I see anything from the agent?
 ---------------------------------------
 
-  There are two main general causes of problems retrieving information
-  from the agent.  Either the client tool may not like the request (and
-  refuse to send it at all), or the agent may not respond with anything
-  useful.  The simplest way to distinguish between the two is to run the
-  command with the command-line option '-d'.
+  Fundamentally, there are two basic reasons why a request may go
+  unanswered.  Either the management application does not like the
+  request (so never sends it), or the agent does not like the request
+  (so never responds).  The simplest way to distinguish between the
+  two is to run the command with the command-line option '-d'.
 
   If this doesn't display a hex dump of the raw outgoing packet, then
   it's the client side which is dropping the request.  Hopefully you
-  should see some form of error message, to help identify what's wrong.
+  should also see an error message, to help identify what's wrong.
 
   If this displays one or more outgoing dumps (but nothing coming back),
   then the request is failing at the agent end.  See the next entry for
   more details.
 
-  If you see dumps of both the outgoing request, and a response, but
-  no results are displayed, then either there may be a problem with
-  decoding the response (in which case you should see an error message),
-  or the agent may simply not support the requested information (and the
-  response is being discarded as irrelevant).
+
+    There are three further possibilities to consider:
+
+  One is that the agent may return a response to the original query,
+  but the management application may not like this response, and refuse
+  to display it.  This is relatively unusual, and typically indicates
+  a flaw with the remote agent.  (I hope you're not contemplating the
+  suggestion that the Net-SNMP command-line tools might contain bugs!)
+
+    The typical symptoms of this would be that the '-d' option would
+  display a sequence of sending and received packet dumps, with the
+  same contents each time.  Ask on the mailing list for advice.
+
+
+  Alternatively, the agent may simply not support the MIB objects being
+  requested.  This is most commonly seen when using the "snmpwalk" tool
+  (particularly with SNMPv1).
+
+  The symptoms here would be that '-d' would show two pairs of raw
+  packet dumps - one a GETNEXT request (A1 in the sending packet),
+  followed by a GET request (A0).  Repeating the same request with the
+  "snmpgetnext" command-line tool should show the information (if any)
+  that the agent returned, which was then discarded by snmpwalk as
+  irrelevant.
+
+  Note that this is how snmpwalk was designed to work.  It is not an error.
+
+
+  Finally, it may be that the agent is simply taking too long to respond.
+  The easiest way to test for this is to add the command-line options
+  "-t 60 -r 0", which will send a single request (with no repetitions)
+  and wait for a minute before giving up.  This ought to be long enough
+  for all but the most-overloaded agent, or inefficient MIB module!
+
+  If this turns out to be the cause, then ask on the mailing list for
+  advice on options for improving the performance.
 
 
 
 Why doesn't the agent respond?
 -----------------------------
 
-  Assuming that the client application is actually sending the request
- (see the previous entry), there are two main likely causes for the agent
-  not to respond.  Either it doesn't receive the request (e.g. it's being
-  blocked by a firewall or packet filtering), or it receives the request,
-  but is unwilling (or unable) to process it.  Note that if an agent
-  receives an SNMPv1 or SNMPv2c request with an unknown community string,
-  then it will not return an error response - the request simply times out.
+  Assuming that the tests outlined in the previous entry indicate that
+  the problem lies with the agent not responding, the obvious question 
+  is "why not".
 
-    If the remote system is running the Net-SNMP agent, then the easiest
-  way to check what's going wrong is to shut down the agent, and re-start
-  it using the options:
+  Again, there are two basic possibilities - either the agent never
+  sees the request, or it receives it but is unwilling (or unable) to
+  process it.  If the remote system is running the Net-SNMP agent,
+  then the easiest way to distinguish between these two cases is to
+  shut down the agent, and re-start it manually using the options
               -f -Le -d
-  This will display raw dumps of packets seen (or sent) by the agent,
-  just as the '-d' flag did for the client side in the previous entry.
-
-  Restart the agent with these flags, and send the same query as before.
-  If the agent doesn't display anything in response to this request, then
-  it's probably some form of firewall settings, which are preventing the
-  agent from ever seeing the request.
+  Then send the same query as before.  This should display raw dumps of
+  packets seen (or sent) by the agent, just as with the client side in
+  the previous entry.
+
+
+  If the agent does not display anything, then it is simply not receiving
+  the requests.  This may be because they are being blocked by network
+  or local firewall settings ('iptables -L'),  or the agent may not be
+  listening on the expected interfaces ('netstat -a').
+
+  This is most commonly encountered when running queries from a remote
+  host, particularly if the same request succeeds when run on the same
+  system as the agent itself.
+
 
   If the agent displays a dump of the incoming request, but nothing going
   out, then the most likely cause is access control settings.  See the
-  relevant entries in the AGENT section for details.
-
-  A third possibility is that the agent *is* responding to the request,
-  but only after a long delay.  This would be indicated by a series of
-  incoming packet dumps (showing various retries from the client side),
-  followed by several outgoing dumps - possibly long after the client
-  tool has given up in disgust.
+  relevant entries in the AGENT section for details.  Note that if the agent
+  receives an SNMPv1 or SNMPv2c request with a unknown community string,
+  then it will not return an error response - the request is simply discarded.
+
+  Another possibility is that the request may be rejected by settings in
+  /etc/hosts.{allow,deny}.  Again, '-d' will display an incoming packet
+  dump but no corresponding outgoing response.  However in this situation,
+  the agent should also log a message that the request is being refused.
+
+
+  Running the agent with '-d' can also help identify situations where the
+  agent *is* responding to the request, but only after a long delay.  This
+  would be indicated by a series of incoming packet dumps (showing various
+  retries from the client side), followed by several outgoing dumps - possibly
+  long after the client tool has given up in disgust.
     See the entry
       The agent worked for a while, then stopped responding.  Why?
   later in this section.
 
-  The same basic causes could also affect other vendors' SNMP agents.
-  Please consult the relevant documentation for how to investigate and
-  address such problems.
-
 
 
 I can see the system group, but nothing else.  Why?
@@ -762,42 +865,65 @@
   allow access to the system group by default, and need to be configured
   to enable more general access.
 
-    The easiest way to test this is to try a GETNEXT request that ought
-  to return the entry of interest.
+    The easiest way to test this is to try a GETNEXT request on one of
+  the other standard groups
   e.g.
-	snmpgetnext -v1 -c public localhost UCD-SNMP-MIB::versionTag
-  instead of
-	snmpget     -v1 -c public localhost UCD-SNMP-MIB::versionTag.0
-
-  If the agent responds with "end of MIB" or a different object, then
-  either the agent doesn't implement that particular object at all, or
-  the access control won't allow you access to it.
-
-  See the entries on access control in the AGENT section for how to
-  configure the Net-SNMP agent, or consult the agent's own documentation.
+	snmpgetnext  .....  interfaces
+
+  If the agent responds with "hrSystemUptime.0" or "end of MIB", then it
+  is clearly configured in this way.  See the entries on access control
+  in the AGENT section for more information.
 
 
 
 Why can't I see values in the <ENTERPRISE> tree?
------------------------------------------------------------
-
-  If you're walking a specific tree, but failing to see anything in
-  it, then the most likely cause is that the agent simply does not
-  implement those particular MIB objects.  Or if it does, that the
-  access control or other configuration settings mean that there's
-  nothing for you to see there.
-
-  However, if you're trying a basic "snmpwalk" with no explicit OID
-  specified, then this would also explain why you're not seeing any
-  enterprise-specific results.
-
-  By default, unless given an explicit starting OID, then the 'snmpwalk'
-  command will display the contents of the 'mib-2' tree, containing most
-  of the IETF-standard management information supported by the agent.
+-----------------------------------------------
+
+  If you can see most of the standard information (not just the system and
+  hrSystem groups), but not in the vendor-specific 'enterprises' tree, then
+  once again there are several possible causes.
+
+  Firstly, it's possible that the agent does not implement this particular
+  enterprise tree.  Remember that adding a MIB to the client tools does
+  *not* automatically add support for these object to the agent.  See the
+  AGENT section for more information.
+
+
+  Alternatively, it may be that the agent does implement some or all of this
+  enterprise tree, but the access control settings are configured to block
+  access to it.
+
+  The simplest way to checks whether the agent implements a given portion
+  of the OID tree is to run
+
+	snmpwalk .... nsModuleName
+
+  and look for index values that fall in the area of interest.
+  (Always assuming that you have access to this particular section
+  of the Net-SNMP enterprise tree, of course!)
+ 
+  Checking the access control settings can be done by examining the tables
+  vacmAccessTable and vacmViewTreeFamilyTable.   Note that these are used
+  to configure access control for *all* versions of SNMP - not just SNMPv3.
+
+
+  The third possibility is that simply isn't any information in the specified
+  tree.  For example, several of the tables in the UCDavis enterprise tree
+  (such as prTable, extTable, dskTable and fileTable) require explicit
+  configuration in the snmpd.conf file.  If you query this particular tables
+  without the necessary configuration entries, then they will be empty.
+
+
+  Finally, if you can't see anything from *any* enterprise-specific tree,
+  then this may be down to how you are asking for the information.  By
+  default, if "snmpwalk" is run without an explicitly starting OID, then
+  it will display the contents of the 'mib-2' tree, containing most of the
+  IETF-standard management information supported by the agent.
+ 
   When the agent reaches the end of this tree, it will return the first
-  enterprise-specific value, and 'snmpwalk' will recognise that this
-  marks the end of the (implicit) request tree, and stop.  No
-  enterprise-specific information will be displayed.
+  enterprise-specific value, 'snmpwalk' will recognise that this marks the
+  end of the (implicit) requested tree, and stop.  No enterprise-specific
+  information will be displayed.
 
     To walk the whole tree, and see *all* the information that the
   agent supports, specify a starting point of '.iso' or '.1'.
@@ -862,25 +988,25 @@
 	snmpget -v1 -c public myhost SNMPv2-MIB::sysUpTime.0
 
   Note that this uses the name of the *module*, not the name of the file.
-  See the second entry in this section for the distinction.  However,
-  if 'snmpwalk' displays the object by name, this is unlikely to be the
-  cause, and you should look closely at the exact object name you are using.
+  However, if 'snmpwalk' displays the object by name, this is unlikely to
+  be the cause, and you should look closely at the exact object name you
+  are using.  In particular, see the next entry.
 
 
 
 Why do I get "noSuchName" when asking for "sysUpTime" (or similar)?
 ------------------------------------------------------------------
 
-  Assuming that you do have access to this object, the most likely
-  cause is forgetting the "instance subidentifier".
-
-  If you try walking the 'system' group, you should notice that all
-  of the results have a number after the MIB object name.  This is
-  the "instance subidentifier" of that particular MIB instance.
-
-  For values from the sysORTable, this basically provides an index into
-  the table, and should be very familiar.  But the other values in the
-  system group also have an instance number displayed.  For non-table
+  Assuming that you do have access to this object, the most likely cause
+  is forgetting the instance subidentifier.
+
+  If you try walking the 'system' group (or any other part of the MIB tree),
+  you should notice that all of the results have a number after the object
+  name.  This is the "instance subidentifier" of that particular MIB instance.
+
+  For values in tables (such as the sysORTable), this acts as an index into
+  the table - a very familiar concept.  But *all* SNMP values will display an
+  instance number, whether or not they are part of a table.  For non-table
   objects ("scalars"), this instance subidentifier will always be '0',
   and it *must* be included when making a GET request.
 
@@ -890,6 +1016,7 @@
 	Error in packet
 	Reason: (noSuchName) There is no such variable name in this MIB.
 	This name doesn't exist: system.sysUpTime
+
 	$ snmpget -v1 -c public localhost sysUpTime.0
 	system.sysUpTime.0 = Timeticks: (69189271) 8 days, 0:11:32.71
 
@@ -927,29 +1054,32 @@
 How do I use SNMPv3?
 -------------------
 
-    The simplest form of SNMPv3 request is unauthenticated and unencrypted
-  (noAuthNoPriv). It still requires a user name (and the agent must be
-  configured to allow unauthenticated requests from that user). Such a
-  request would look something like:
+  The simplest form of SNMPv3 request is unauthenticated and unencrypted
+  (noAuthNoPriv).  It simply requires a user name, and would look something
+  like:
 
 	snmpget -v 3 -l noAuthNoPriv -u dave localhost sysUpTime.0
 
-    An authenticated request (authNoPriv) would specify a pass phrase to
-  authenticate with:
+  However this approach foregoes the security protection which is the
+  main advantage of using SNMPv3 (and the agent must also be explicitly
+  configured to allow unauthenticated requests from that user).
+
+  The most common form of SNMPv3 request is authenticated but not encrypted
+  (authNoPriv).  This specifies the pass phrase to authenticate with:
 
 	snmpget -v 3 -l authNoPriv -u dave -A "Open the Door"
 				localhost sysUpTime.0
 
-    A fully secure request (authPriv) would also specify the privacy
-  pass phrase:
+  A fully secure (i.e. encrypted) request (authPriv) would also specify
+  the privacy pass phrase:
 
 	snmpget -v 3 -l authPriv -u dave -A "Open the Door"
 			-X "Bet you can't see me"  localhost sysUpTime.0
 
   In practise, most of these would probably be set via configuration
   directives in a personal $HOME/.snmp/snmp.conf file (note, *not* the
-  agent's snmpd.conf file).  The equivalent settings for the third
-  example would be:
+  agent's snmpd.conf file).
+    The equivalent settings for the third example would be:
 
 	defSecurityName		dave
 	defSecurityLevel	authPriv
@@ -971,7 +1101,7 @@
   There are three possible reasons for this:
 
   Many MIB objects are defined as "read-only" and inherently cannot be
-  changed via SET requests.  Attempts to do so will typically be dropped
+  changed via SET requests.  Attempts to do so will typically be rejected
   by the 'snmpset' command without ever being sent to the agent.
 
   Of those objects that can in principle be changed, the agent may not
@@ -1001,17 +1131,17 @@
   particularly obvious, particularly when using SNMPv1.  A typical
   example of this effect would be
 
-	$ snmpget -v1 -c public localhost system.sysLocation.0
-	system.sysLocation.0 = somewhere nearby
+	$ snmpget -v1 -c public localhost sysLocation.0
+	sysLocation.0 = somewhere nearby
 
-	$ snmpset -v1 -c public localhost system.sysLocation.0 s "right here"
+	$ snmpset -v1 -c public localhost sysLocation.0 s "right here"
 	Error in packet.
 	Reason: (noSuchName) There is no such variable name in this MIB.
-	This name doesn't exist: system.sysLocation.0
+	This name doesn't exist: sysLocation.0
 
   Trying the same request using SNMPv2 or above is somewhat more informative:
 
-	$ snmpset -v 2c -c public localhost system.sysLocation.0 s "right here"
+	$ snmpset -v 2c -c public localhost sysLocation.0 s "right here"
         Error in packet.
         Reason: notWritable
 
@@ -1019,35 +1149,42 @@
 
 	"You can't do that to this variable"
 
-  rather than "this variable doesn't exist".  It may be the case that it
-  doesn't exist at all.  It may exist but you don't have access to it
-  (although someone else with different administrative credentials might do).
-  Or it may exist, but you simply can't perform that particular operation
-  (e.g. changing it).
-    Similarly, the SNMPv2 error 'notWritable' means "not writable in
-  this particular case" rather than "not writable under any circumstances".
+  rather than "this variable doesn't exist".
+  It may be the case that it doesn't exist at all.  It may exist but you
+  don't have access to it (although different administrative credentials
+  might be accepted).  Or it may exist, but you simply can't perform that
+  particular operation (e.g. changing it).
+    Similarly, the SNMPv2 error 'notWritable' means "not writable in this
+  particular case" rather than "not writable under any circumstances".
 
-  If you are sure that the object is writable (and has been implemented
-  as such), then you probably need to look at the agent access control.
-  See the AGENT section for more details.
+  If you are sure that the object is both defined as writable, and has been
+  implemented as such, then you probably need to look at the agent access
+  control. See the AGENT section for more details.
+    But see the next entry first.
 
 
 
 Why can't I change sysLocation (or sysContact)?
 ----------------------------------------------
 
-  Assuming that the access control settings should allow this, another
-  possibility for the 'sysLocation' and 'sysContact' objects is that
-  you've got a configuration option in the 'snmpd.conf' file which
-  already sets the corresponding value there.
-
-    Earlier versions of the Net-SNMP agent would allow you to write to
-  these objects, but the new value would be forgotten the next time the
-  agent was re-started.  More recent versions of the agent reject such
-  write requests if there's a value configured via the 'snmpd.conf' file.
-  If there isn't such a config setting, then the write request will succeed
-  (assuming suitable access control settings), and the new value will be
-  retained the next time the agent restarts.
+  There is one final possibility to consider for why a SET request might
+  be rejected.
+
+  The values for certain MIB objects (including 'sysLocation' and 'sysContact')
+  can be configured via the snmpd.conf file.  If this is done, then these
+  particular objects become read-only, and cannot be updated via SET commands,
+  even if the access control settings would otherwise allow it.
+
+  This may seem perverse, but there is good reason for it.  If there is a
+  configuration setting for one of these objects, then that value will be
+  used whenever the agent re-starts.  If the object was allowed to be updated
+  using SET, this new value would be forgotten the next time the agent was
+  re-started.
+
+  Hence the Net-SNMP agent rejects such requests if there's a value configured
+  via the 'snmpd.conf' file.  If there isn't such a config setting, then the
+  write request will succeed (assuming suitable access control settings), and
+  the new value will be retained the next time the agent restarts.
 
 
 
@@ -1066,30 +1203,90 @@
 
 	snmpset -v 2c -c public localhost -- versionRestartAgent.0 i -1
 
-  (This will also fail, since -1 isn't an acceptable value for this
-  particular object, but that's not the point here!)
-
-
-
-I get an error when trying to get a string-indexed table value - why?
---------------------------------------------------------------------
-
-    This is probably due to the shell swallowing the quotes, before
-  they ever get to the SNMP command's OID parser.  Try escaping them:
-
-	snmpget .....   vacmGroupName.3.\"wes\"
-  or	snmpget .....  'vacmGroupName.3."wes"'
-
-
-  
+  (This command will still fail, since -1 isn't an acceptable value for
+  this particular object, but that's not the point here!)
+
+
+
+I get an error when trying to query a string-indexed table value - why?
+----------------------------------------------------------------------
+
+  The Net-SNMP library will normally try to interpret string-based
+  index values, and display them in a meaningful manner:
+
+      $ snmpgetnext .... vacmGroupName
+      vacmGroupName.3."dave" = theWorkers
+
+  The command-line tools will also accept string-valued indexes within
+  an OID, and convert them into the appropriate numeric form before
+  sending an SNMP request.  However the Unix shell will typically
+  swallow the quotes around the string index value, before the SNMP
+  tools can get a chance to interpret them.
+
+  The answer is to escape the quotes, to protect them from the shell,
+  and allow them to be passed through to the OID parser:
+
+      snmpget ....   vacmGroupName.3.\"dave\"
+  or
+      snmpget ....  'vacmGroupName.3."dave"'
+
+
+  Another alternative is to avoid trying to specify the index value as
+  a string, and provide the numeric subidentifiers directly:
+
+      snmpget .... vacmGroupName.3.4.100.97.118.101
+
+  (where '3' indicates SNMPv3, '4' is the length of the string index,
+  followed by the ASCII values of the individual characters).
+
+  The command-line option '-Ob' will display the results of querying
+  a string-indexed table in this format:
+
+      $ snmpgetnext -Ob .... vacmGroupName
+      vacmGroupName.3.4.100.97.118.101 = theWorkers
+
+
+
+How should I specify string-indexed table values?
+------------------------------------------------
+
+  There's one other aspect of string-indexed tables that can cause
+  problems - the difference between implicit- and explicit-length
+  strings, and how to represent these when making an SNMP query.
+
+  The most common style of string index uses an explicit length,
+  followed by the individual ASCII character values:
+
+      "dave"  =  4.'d'.'a'.'v'.'e'
+
+  (as shown in the previous entry).
+
+  However if the string index is defined in the MIB file as IMPLIED
+  (or if it has a fixed length, such as a physical ethernet address),
+  then the length subidentifier is omitted, and the index simply
+  consists of the character values:
+
+      "dave"  =  'd'.'a'.'v'.'e'
+
+  Note that IMPLIED index objects can only appear as the *last* index
+  for a table.
+ 
+  The Net-SNMP library uses double quotes (i.e. "dave) to indicate an
+  explicit length string index value, and single quotes (i.e. 'dave')
+  to indicate an implicit length one.  If you use the wrong style of
+  quotes, then the resulting OID will be incorrect, and you'll get
+  confusing results to your query.
+
+
+
 How do I send traps and notifications?
 ---------------------------------------
 
     Traps and notifications can be sent using the command 'snmptrap'.
-  The following examples generate the generic trap 'coldStart' and a
+  The following examples generate the generic trap 'warmStart(1)' and a
   (dummy) enterprise specific trap '99' respectively:
 
-	snmptrap -v 1 -c public localhost "" "" 0 0  ""
+	snmptrap -v 1 -c public localhost "" "" 1 0  ""
 	snmptrap -v 1 -c public localhost "" "" 6 99 ""
   
   The empty parameters "" will use suitable defaults for the relevant 
@@ -1101,15 +1298,17 @@
 	snmptrap -v 2c -c public localhost "" UCD-SNMP-MIB::ucdStart
 	snmptrap -v 2c -c public localhost "" .1.3.6.1.4.1.2021.251.1
 
-  (These two are equivalent ways of specifying the same trap).
+  (These two are equivalent ways of specifying the same trap).  Again,
+  the empty parameter "" will use a suitable default for the relevant
+  value (sysUptime).
 
   Any of these commands can be followed by one or more varbinds,
   using the same (OID/type/value) syntax as for 'snmpset':
 
 	snmptrap -v 2c -c public localhost "" ucdStart sysContact.0 s "Dave"
 
-  Generating traps from within the agent is covered in the AGENT and
-  CODING sections.
+  Generating traps from within the agent, or other applications, is
+  covered in the AGENT and CODING sections.
 
   You should also read the snmptrap tutorial at
 	http://www.net-snmp.org/tutorial-5/commands/snmptrap.html
@@ -1117,34 +1316,57 @@
 
 
 
-How do I handle traps and notifications?
----------------------------------------
-
-    Handling received traps is done using the tool 'snmptrapd'.
-  This can log these traps via the syslog mechanism:
-
-	snmptrapd -Ls 7		(log to 'LOCAL7')
-
-  printed to standard output
-
-	snmptrapd -f -Lo
-
-  or pass them to an external command.  This last approach uses
-  a 'traphandle' directive in the configuration file 'snmptrapd.conf'.
-  A typical file might look something like:
-
-	traphandle .1.3.6.1.6.3.1.5.1       page_me up
-	traphandle .1.3.6.1.4.1.2021.251.1  page_me up
-	traphandle .1.3.6.1.4.1.2021.251.2  page_me down
-	traphandle default                  log_it
-
-  where 'page_me' and 'log_it' are the command to be run.  (You probably
-  need to specify full pathnames, to ensure that the commands will be
-  found.  They're just short here for readability).
-
-  Note that the first entry uses the OID corresponding to the SNMPv1
-  'coldStart' trap.  See the co-existence RFC (RFC 2576) for details
-  of mapping SNMPv1 traps to SNMPv2 OIDs.
+How do I receive traps and notifications?
+----------------------------------------
+
+    Handling incoming traps is the job of a "notification receiver".
+  The Net-SNMP suite include the tool 'snmptrapd' to act in this role.
+  This can log traps to a file or via the syslog mechanism, forward them
+  to another notification receiver and/or invoke a specified command
+  whenever a particular notification is received.
+
+  Logging notifications would be done by starting snmptrapd as:
+	snmptrapd -Ls 7		(log to syslog using 'LOCAL7')
+  or
+	snmptrapd -f -Lo        (log to standard output)
+
+  Invoking a command to process a received notification uses one or
+  more 'traphandle' directives in the configuration file 'snmptrapd.conf'.
+  A typical configuration might look something like:
+
+	traphandle .1.3.6.1.6.3.1.5.1       /path/to/page_me up
+	traphandle .1.3.6.1.4.1.2021.251.1  /path/to/page_me up
+	traphandle .1.3.6.1.4.1.2021.251.2  /path/to/page_me down
+	traphandle default                  /path/to/log_it
+
+  where 'page_me' and 'log_it' are the commands to be run.
+
+  Forwarding notifications to another receiver would be done using
+  similar 'snmptrapd.conf' directives:
+
+        forward .1.3.6.1.4.1.8072.4.0.3  10.0.0.1
+        forward default                  10.0.0.2
+
+  There's a tutorial with more details on the web site at
+	http://www.net-snmp.org/tutorial-5/commands/snmptrap.html
+
+
+
+How do I receive SNMPv1 traps?
+-----------------------------
+
+  Directives in the 'snmptrapd.conf' file use the (SNMPv2) snmpTrapOID
+  value to identify individual notifications.  This applies to *all*
+  versions of SNMP - including SNMPv1 traps.  See the co-existence spec
+  (RFC 2576) for details of mapping SNMPv1 traps to SNMPv2 OIDs.
+
+  Note that the first traphandle directive in the previous entry uses
+  the OID corresponding to the SNMPv1 'coldStart' trap. 
+
+
+
+Why don't I receive incoming traps?
+----------------------------------
 
   Starting with net-snmp 5.3, snmptrapd will no longer automatically
   accept all incoming traps. It must be configured with authorized
@@ -1152,9 +1374,6 @@
   traps/informs will be dropped.
     Please refer to the snmptrapd.conf(5) manual page for details.
 
-  There's a tutorial with more details on the web site at
-	http://www.net-snmp.org/tutorial-5/commands/snmptrap.html
-  
 
 
 My traphandler script doesn't work when run like this - why not?
@@ -1184,6 +1403,23 @@
 
 
 
+How can the agent receive traps and notifications?
+-------------------------------------------------
+
+  It can't.
+
+  The primary purpose of an SNMP agent is to handle requests for
+  information from management applications.  In SNMP terminology,
+  it acts as a "command responder".
+
+  It may also issue traps to report significant events or conditions
+  ("notification generator").  But responding to such notifications
+  is a significantly different role, and this is handled by a separate
+  application ('snmptrapd').  Note that it is perfectly possible (even
+  normal) for both agent and trap receiver to run on the same host.
+
+
+
 How big can an SNMP request (or reply) be?
 -----------------------------------------
 
@@ -1238,6 +1474,9 @@
     Rename (or merge) the 'snmp.conf' file to 'snmpd.conf', and this
   should fix the problem.
 
+  See the AGENT section or the 'snmpd.conf(5)' man page for more information
+  about what should go in this file.
+
 
 
 OK, what should I put in snmp.conf?
@@ -1250,12 +1489,12 @@
   and the default SNMP version, port and (if appropriate) community
   string to use.
 
-    Some of these (such as the MIB file location), might be best put in
-  a shared snmp.conf file (typically /usr/local/share/snmp/snmp.conf or
+    Some of these (such as MIB information), might be best put in a
+  shared snmp.conf file (typically /usr/local/share/snmp/snmp.conf or
   /etc/snmp/snmp.conf) to apply to all users of the system.  Others
   (particularly the SNMPv3 security settings), are more likely to refer
-  to a particular user, and should go in a personal snmp.conf file
-  (typically $HOME/.snmp/snmp.conf).
+  to a particular user, and should probably go in a personal snmp.conf
+  file (typically $HOME/.snmp/snmp.conf).
 
     See 'snmpget -H' and/or the snmp.conf(5) man page for more details.
 
@@ -1264,9 +1503,54 @@
 
 
 
+How do I specify IPv6 addresses in tools command line arguments?
+---------------------------------------------------------------
+
+    IPv6 addresses pose a particular problem for the Net-SNMP command
+  line tools, which parse host names into pieces. In particular, normally
+  if you specify a simple host name, it assumes you want UDP in IPv4 on
+  port 161.   By default, these two commands are actually the same:
+
+            snmpget     127.0.0.1     sysUpTime.0
+            snmpget udp:127.0.0.1:161 sysUpTime.0
+
+  However, for IPv6 this causes a problem because IPv6 addresses also use
+  a colon to separate addressing parts. Thus you need to enclose the address
+  in square brackets ( [ and ] ).
+     Because most shells use these brackets too, you also likely need to quote it:
+
+            snmpget 'udp6:[::1]:161' sysUpTime.0
+
+
+
 PERL
 ====
 
+What is the purpose of the Perl SNMP module?
+-------------------------------------------
+
+  Short, comprehensive (but ultimately unhelpful) anwer - to provide a
+  perl interface for SNMP operations.
+
+  Longer, incomplete (but more useful) answer - there are probably two
+  main uses for the Perl SNMP module.  The first is for developing client
+  management applications, using perl to send SNMP requests, and manipulating
+  or displaying the results.  As such, this is a straight alternative to
+  various other SNMP toolkits currently available (for both perl and other
+  programming languages).
+
+  The second is as a means for extending the functionality of the Net-SNMP
+  agent, by implementing new MIB modules.  This is an alternative to the
+  other script-based extension mechanisms, but is more tightly bound to the
+  Net-SNMP agent (and hence more efficient), while still avoiding the need
+  to write C code.
+
+  It is also possible to use the perl SNMP module in the snmpd.conf file,
+  or to process incoming notifications,  but the above are probably the
+  two primary uses.
+
+
+
 Where can I get the Perl SNMP package?
 -------------------------------------
 
@@ -1390,8 +1674,8 @@
 
 
 
-I'm trying to install your RPM, but it complains about missing Perl modules. Why?
---------------------------------------------------------------------------------
+Why does your RPM complain about missing Perl modules?
+-----------------------------------------------------
 
   This has been particularly noted on RedHat 9, complaining about the
   module "perl(Term::ReadKey)" - even if this is actually present (e.g.
@@ -1443,74 +1727,75 @@
   That depends what you mean by a "MIB compiler".  There are at least two
   types of tool that are commonly referred to by this name.
 
-  The first is a tool to check MIB files for validity.  This functionality
-  is mostly integrated within the MIB parser (part of the Net-SNMP library)
+  The first is a tool to check MIB files for validity.  With the Net-SNMP
+  software, this functionality is mostly integrated within the MIB parser,
   and hence included in all the applications.  The tool 'snmptranslate' is
   probably the most appropriate for this purpose.
-    Note that the parser is fairly forgiving (see 'What ASN.1 parser is used'
-  below), so this should not be regarded as a stamp of approval.
-
-    The second type of tool is one to turn a MIB specification into C code,
-  specifically one designed to aid agent implementation.  The command 'mib2c'
-  is an example of such a tool for the Net-SNMP agent.  
+
+  Note that the parser is fairly forgiving (see 'What ASN.1 parser is used'
+  below), so this should not be regarded as a stamp of approval.  For a
+  more rigourous validation, use a tool such as 'smilint', or the on-line
+  interface at http://wwwsnmp.cs.utwente.nl/ietf/mibs/validate/
+
+    The second type of "MIB compiler" is one to turn a MIB specification
+  into C code, specifically one designed to aid agent implementation.  The
+  command 'mib2c' is an example of such a tool for the Net-SNMP agent.  
   See the CODING section for more information.
 
 
 
-Why aren't my mib files being read in?
+Why aren't my MIB files being read in?
 -------------------------------------
 
-    The Net-SNMP library only loads a specific subset of MIB files by default.
-  This list is set at when the suite is first configured and compiled,
-  and basically corresponds to the list of modules that the agent supports.
-  (This is a simplification, but is a reasonable first approximation).
-
-    You can override this by using the command-line option '-m', the
-  environmental variable 'MIBS' or the snmp.conf directive 'mibs'.
-  Each of these take a (colon-separated) list of MIB module names
-  to load.   Starting the list with a '+' character will add them to
-  the default list - otherwise it replaces the defaults.
-
-    Using the special value 'ALL' will load all the MIB files that
-  the library can find.
-
-
-    Alternatively, the tools may be looking in the wrong place.
-  The default location for the mib files is /usr/local/share/snmp/mibs.
-  Again, this is set when the suite is first configured and compiled.
-  This can be changed using the environmental variable 'MIBDIRS'
-  or the snmp.conf directive 'mibdirs'.
-
-    Note that this may very well affect you if you've installed a
-  new version of the suite manually, replacing one provided by the
-  supplier (which typically would use a more 'central' location).
-
-
-    Finally, are you sure that you've installed the MIB files?
-  If you've compiled the suite from scratch, you need to run
-  "make install" at least once, before the tools will be able to
-  find the MIB files.  This is unlikely to be a problem if you've
-  been working with the tools for a while, but can bite those working
-  with a fresh installation.
-
-
-
-I'm getting answers, but they're all numbers. Why?
--------------------------------------------------
-
-  This is related to the previous question.  The results that you
-  receive do not depend on which MIBs are loaded - just on how the
-  agent was compiled and configured.
-
-  Because the tools don't read in every MIB module they can find (and
-  the relevant MIB file may not be installed anyway), it is quite possible
-  for results from an agent to refer to modules that have not been loaded
-  (particularly with GETNEXT requests, or when walking a tree).
-
-  The results will be reported quite correctly, but won't be translated
-  to use named identifiers or enumerations.  To fix this, use the
-  environmental variables MIBS or MIBFILES (or the '-m' and '-M' flags)
-  to read in the relevant module files (assuming these are available).
+  There are two basic likely causes - either the library isn't attemping to
+  load these particular MIB files, or it's trying to load them but can't
+  locate them.
+
+  By default, the Net-SNMP library loads a specific subset of MIB files.
+  This list is set when the suite is first configured and compiled, and
+  basically corresponds to the list of modules that the agent supports.
+    (This is a simplification, but is a reasonable first approximation).
+
+  In order to load additional MIB files, it is necessary to add them to this
+  default list.  See the FAQ entry "How do I add a MIB to the tools?" for
+  more information about how to do this.
+
+
+  Alternatively, the tools may be looking in the wrong place.  The directory
+  where the library looks for MIB files is also set when the software is
+  first configured and compiled.  If you put new MIB files in the wrong
+  location, then the library won't be able to find them (and will complain).
+
+  This problem may arise when switching from a vendor-supplied distribution
+  to one compiled from source (or vice versa).
+    See the next entry for more information.
+
+
+
+Where should I put my MIB files?
+-------------------------------
+
+  If you've compiled the package from source (or are using binaries
+  from the project website), then you should probably put new MIB
+  files in the directory /usr/local/share/snmp/mibs
+
+  If you are using vendor-supplied binaries, then the MIB files
+  may well be located somewhere else (e.g. /usr/share/snmp/mibs,
+  /opt/snmp/mibs, or /etc/sma/snmp/mibs).  Have a look for where
+  existing MIB files are installed, and try adding your MIBs to
+  the same directory.
+
+  If you compiled the source yourself, but specified a different
+  --prefix value when running configure, then the location of the
+  MIB directory will be {prefix}/share/snmp/mibs.
+
+  If you're still not sure where to put your MIB files, try running
+  the command
+
+     snmpget  -Dparse-mibs  2>&1 | grep directory
+
+  This will display the location(s) where the library is looking
+  for MIB files.
 
 
 
@@ -1520,21 +1805,45 @@
     If this error is only generated for one or two modules, then it's
   likely that the named modules are not being found - perhaps they're
   not installed in the correct location, are not readable, or the
-  name being used is incorrect.  Note that the name reported is the
-  name of the MIB module, which is not necessarily the same as the
-  name of the file. See the question 'How do I add a MIB to the tools?'
-  for more details on this.
+  name being used is incorrect.  See the previous entries and the entry
+  "How do I add a MIB to the tools?" for more details.
+
+  Note that the name reported is the name of the MIB *module*, which is
+  not necessarily the same as the name of the file.
+
 
     If there are a large number of such errors, then it's more likely
-  that either the MIB files haven't been installed at all, or the 
-  library is looking in the wrong place for them.
-    Try running "snmptranslate -Dparse-mibs" to see where the MIB files
-  are expected to be found.
-
-
-
-What about "unlinked OID"?
--------------------------
+  that either the MIB files haven't been installed at all.  If you are
+  compiling from source, then it is necessary to run "make install" in
+  order to set up the full run-time environment.
+
+  Otherwise, see the previous entry to check whether the MIBs are installed
+  in the correct location for the tools to find them.
+
+
+
+I'm getting answers, but they're all numbers. Why?
+-------------------------------------------------
+
+  This is related to the previous questions.  Remember, the results that
+  you receive from an agent do not depend on which MIBs are loaded by the
+  client tools - purely on how the agent was compiled and configured.
+
+  Because the tools don't necessarily read in every MIB file they can find
+  (and the relevant MIB file may not be available anyway), it is quite
+  possible for results from an agent to refer to modules that have not
+  been loaded (particularly with GETNEXT requests, or when walking a tree).
+
+  The results will be reported correctly, but won't be translated to use
+  named identifiers (or display the values in the most appropriate manner).
+  To fix this, add the missing MIB files to the list of MIBs to be loaded.
+  See the previous entries and the entry "How do I add a MIB to the tools?"
+  for more information.
+
+
+
+What does "unlinked OID" mean?
+-----------------------------
 
     This means that the library has been able to find the MIB module,
   and parse the individual objects defined in it, but is having problems
@@ -1553,9 +1862,13 @@
 The parser doesn't handle comments properly. Why not?
 ----------------------------------------------------
 
-  The most likely reason is that the line in question contains two
-  (or more) sequences of pairs of dashes.  This is often used to try
-  and "comment out" an unwanted line that already contains a comment:
+  The way that comments are handled in a MIB file is subtly different
+  to the equivalent syntax in most typical programming languages, and
+  this difference can catch out the unwary.  In particular, there are
+  two common situations which can lead to problems.
+
+  The first scenario is where the MIB designer has attempted to "comment
+  out" an unwanted line that already contains a comment:
 
 	--   broken ::= { myMIB 1 }   -- This isn't working yet
 
@@ -1564,16 +1877,21 @@
   the end of the line, *or* the next occurance of a pair of dashes.
 
     Thus in this case, the definition of "broken" is commented out (as
-  intended) but the following text is treated as an active part of the
-  MIB, and will generate an error.
-
-    A similar effect can be obtained when a line of dashes has been used
-  to try and mark separate parts of a MIB file.
-
-    Most of the applications have a command-line option (-Pc) which will
-  work around this problem by treating the whole line as a comment.  But
-  this is not strictly legal, and the offending MIB file should really be
-  corrected.
+  intended) but the following text ("This isn't working yet") is treated
+  as an active part of the MIB, and will generate an error.
+
+
+  The second scenario is where a line of dashes has been used to mark
+  out separate parts of a MIB file.  Depending on the exact number of
+  dashes used, this may still result in a syntactically valid MIB file,
+  but has a 1-in-4 possibility of triggering an error.  This means that
+  this particular situation can be particularly difficult to spot!
+
+
+    Most of the Net-SNMP applications have a command-line option (-Pc) which
+  will work around this problem by treating the whole line as a comment.
+  But this is not strictly legal, and the offending MIB file should really
+  be corrected.
 
 
 
@@ -1598,6 +1916,9 @@
   or the tutorial at
 	http://www.net-snmp.org/tutorial-5/commands/snmptranslate.html
 
+  For a more rigourous validation, use a tool such as 'smilint', or the
+  on-line interface at http://wwwsnmp.cs.utwente.nl/ietf/mibs/validate/
+
 
 
 What's this about "too many imported symbols"?
@@ -1646,6 +1967,15 @@
   This requires having the relevant MIB files installed and loaded.
 
 
+  Since the agent needs MIBs the least and some systems are memory
+  restricted, it is possible to completely disable loading these MIBs
+  as well as remove the code that does the parsing by using the
+  --disable-mib-loading flag to configure.
+
+  However, note that certain snmpd.conf tokens actually make use
+  of mib information so they won't be as easily usable. 
+
+
 
 AGENT
 =====
@@ -1665,15 +1995,15 @@
 	- MTA-MIB (sendmail)
 	- private UCD/Net-SNMP agent extensions
 		(monitor specified processes and disks,
-		 memory, CPU, load average, plus extend
+		 memory, CPU, load average, + extending
 		 the agent using shell commands)
 
   See README.agent-mibs for details.
 
-  Not all MIB modules are included by default on all systems, and some of
+  Not all MIB modules are included by default on all systems.  Some of
   these may need to be explicitly requested when the software is first
-  configured and built.  From Net-SNMP 5.3 and above, this primarily
-  applies to the MTA-MIB of those listed above.
+  configured and built, while others may not be available on all
+  architectures.
 
   There are a few other MIB implementations distributed as part of the
   source tarball, but these are basically unsupported and most of the
@@ -1694,9 +2024,8 @@
 How do I configure the agent?
 ----------------------------
 
-  That depends on what you want it to do, and what stage of the process
-  you have in mind.  There are actually two very distinct ways you can
-  configure the agent.
+  That's a somewhat ambiguous question, as there are two very different
+  stages where it is possible to "configure" the agent.
 
   Firstly, you can determine what capabilities and defaults are included
   within the library and agent, at the time that the software is first
@@ -1727,63 +2056,62 @@
     1) re-run 'configure' to exclude the given MIB module(s) from the
        build configuration, then recompile and reinstall:
 
-	  ./configure --with-out-mib-modules=host   ....
+	  ./configure --with-out-mib-modules=path/to/unwanted   ....
 	  make
 	  make install
 
-    2) use access control to exclude the mib from the view used to
-       query the agent:
-                                                                                
-	  com2sec public  default public
-
-	  group   public  v1      public
-	  group   public  v2c     public
-
-	  view    ourmib  included  system
-	  view    ourmib  included  printmib
-	  view    ourmib  excluded  host
-	  view    ourmib  included  privatemib
-
-	  access  public  "" any noauth exact ourmib none none
-
-       With v5.3 and above, this can also be done by supplying the
-       relevant view name to the "rocommunity" or similar directive:
-
-          rocommunity public default -V ourmib 
-                                                                                
-    3) disable the MIB at runtime
-
-	  snmpd -I -hr_system,hr_storage,hr_device,hr_other,....
+       This specifies the path to the module code file, relative to
+       the 'agent/mibgroup' directory.  Clearly, this approach is
+       only possible if you are working with a source distribution.
+ 
+    2) disable the MIB at runtime
+
+	  snmpd -I -unwanted
 
        Note that this relies on knowing which modules are used to
        implement the relevant MIB objects.  If you're not sure,
-       you can check which MIB modules are loaded by getting the
-       agent to report them as they are initialised:
+       you could try walking the 'nsModuleName' MIB object, which
+       indicates the module responsible for each particular range
+       of OIDs.
+       You can also check which MIB modules are loaded by getting
+       the agent to report them as they are initialised:
 
 	  snmpd -Dmib_init -H
 
-       Hopefully it should then be fairly obvious which ones to turn off.
-
+       From this information, it should then be fairly obvious which
+       modules to disable.
+
+    3) use access control to exclude the mib from the view used to
+       query the agent:
+
+          view    almostEverything  included   .1
+          view    almostEverything  excluded   unwantedMib
+
+          rocommunity  public  default  -V almostEverything
+
+       This approach can also be used with the full com2sec/group/access
+       configuration directives (e.g. with versions earlier than 5.3,
+       which don't support the above mechanism).
 
 
 
 I've installed a new MIB file.  Why can't I query it?
 ----------------------------------------------------
 
-  Similarly, installing a new MIB file isn't sufficient for the
-  agent to automatically support this MIB.  It's necessary to have
-  some form of code which can provide the corresponding information.
-  The next few entries, and the following section (CODING) address
-  this issue in some detail.
+  Installing a new MIB file will not magically enable the agent to know
+  what values to report for the objects defined in that MIB.  It's
+  necessary to have some code which can provide the relevant information.
+  The next few entries, and the CODING section address this issue in more
+  detail.
 
 
 
 How do I add a MIB to the agent?
 -------------------------------
 
-  As indicated above, this basically involves writing some code to
-  implement the objects defined in the new MIB.  There are three basic
-  approaches that can be used to do this:
+  Adding a MIB essentially involves writing some code to implement the
+  objects defined in the new MIB.  There are three basic approaches that
+  can be used to do this:
 
     -  The agent can invoke an external command or shell script to
        return the necessary information.  There are several possible
@@ -1797,7 +2125,7 @@
     -  You can write code to implement the new MIB objects, and
        include this within the agent.  This is most commonly C
        (or C++) code, although the agent can also support MIB modules
-       implemented in perl or (from 5.4) python.
+       implemented in perl.
          See the next section (CODING) for more details.
 
   Note that there is no visible difference between external commands,
@@ -1809,8 +2137,9 @@
 What's the difference between 'exec', 'sh', 'extend' and 'pass'?
 ---------------------------------------------------------------
 
-    'exec' will fork off the specified command and return the exit status
-  and/or the output.  Any arguments are passed directly to the command.
+  'exec' will run the specified command and return the exit status and
+  output.  Any arguments are passed directly to the command, with no
+  special interpretation.
 
   'sh' is similar, but invokes a shell to run the command line given.
   This means that quoted arguments will be recognised as such, and also
@@ -1822,18 +2151,20 @@
   displaying the results.
 
   None of these mechanisms require the command to have any knowledge of
-  the fact that they are being used in this manner.  But the output is
-  returned in a fixed format, and it is up to the receiving application
-  to interpret this appropriately.
+  SNMP, or the fact that they are being used in this manner.  But the
+  output is returned in a fixed format, and it is up to the receiving
+  application to interpret this appropriately.
 
 
   'pass' is a more general mechanism for implementing arbitrary MIB
   objects.  The specified command will be invoked for any request within
-  the named MIB subtree, and should return the information relevant to
-  the requested OID.
+  the named MIB subtree, and passed details of the requested OID.  It
+  should return the information relevant to the requested OID.
 
     'pass-persist' is similar, but the command will continue running
-  even after the initial request has been answered.
+  even after the initial request has been answered.  These two mechanisms
+  can be used to implement a particular MIB, following the correct MIB
+  structure (as opposed to the fixed format of exec/sh/extend).
 
   All of these mechanisms are described in the 'snmpd.conf(5)' man page,
   in the section entitled "Extending Agent Functionality".
@@ -1853,19 +2184,20 @@
     SMUX and proxy SNMP both essentially use the standard SNMP packet format.
   The main difference is that a proxy SNMP subagent need not be aware that
   it is acting in such a role.  It typically listens on a non-standard port,
-  and simply receives requests as usual, forwarded from the master agent. 
-  The main issue to be aware of is that such requests will appear to come
-  from the local host, and this may affect how the access control mechanisms
-  need to be set up.
+  and simply receives requests as usual, forwarded from the master agent
+  (rather than directly).  The main issue to be aware of is that such requests
+  will appear to come from the local host, and this may affect how the access
+  control mechanisms need to be set up.
 
     SMUX uses a similar packet format, but the subagent "registers" with
   the master agent, providing a suitable password.  The Net-SNMP (and UCD)
   agent includes the possibility of acting as a SMUX master agent, but the
-  suite does not include a subagent API.   Note that the SMUX protocol has
-  essentially been superceded by AgentX, but is still provided in order to
-  support existing SMUX subagents.  However the core developers have little
-  experience (and even less interest!) in this code, so assistance with
-  SMUX-related problems is likely to be somewhat limited.
+  suite does not include a subagent API.   Note that support for SMUX is not
+  included by default, and needs to be explicitly enabled by running:
+
+		--with-mib-modules=smux
+
+  before re-compiling the agent.
     See the file 'agent/mibgroup/README.smux' for details.
 
     AgentX uses a more compact (and simpler) packet format, with a richer
@@ -1875,11 +2207,6 @@
   subagent within another application.
     See the file 'README.agentx' for details.
 
-  Note that support for SMUX is not configured in by default.  You will
-  need to run configure with the option
-
-		--with-mib-modules=smux
-
   AgentX support is included by default, but needs to be explicitly
   activated in the master agent.  Do this by adding the line
 
@@ -1889,11 +2216,12 @@
 
 
 
-What about 'dlmod' - what's that about?
---------------------------------------
+What is the purpose of 'dlmod'?
+------------------------------
 
-  The choice of which C-coded modules to include within an agent (or
-  subagent) is usually made when the agent is first built.  Adding new
+  Most of the MIB information supplied by the Net-SNMP agent is provided
+  by C-coded implementation modules, and the choice of which modules to
+  include is usually made when the agent is first built.  Adding new
   MIB modules would therefore require re-compiling the agent.  This is
   not always convenient - particularly when working with a production
   system, and/or pre-installed binaries.
@@ -1908,42 +2236,35 @@
 
 
 
-Which should I use?
-------------------
+Which extension mechanism should I use?
+--------------------------------------
 
   That's not easy to answer in general.
 
   If there's an existing agent that already implements the desired new
   MIB, then it makes sense to re-use that, via whatever extension protocol
-  it might support.  Ideally, this would be an AgentX sub-agent, since the
-  AgentX protocol is deliberately designed for this purpose, and provides
-  a fuller and more reliable mechanism than either SMUX or proxied SNMP.
+  that agent might support.  Note that the SMUX protocol has essentially
+  been superceded by AgentX, which provides a fuller and more reliable
+  mechanism than either SMUX or proxied SNMP.  So ideally, this would
+  be the preferred extension approach.
   But if the target subagent only supports SMUX or basic SNMP, then that
   would dictate the extension protocol to use.
 
-  Implementing the module directly within the main agent (or via dlmod)
-  is probably the most efficient and reliable (since there's minimal
-  overheads between the code implementing the MIB module, and the agent
-  framework).  But it does assume that there's a suitable mechanism for
-  retrieving the necessary information.
+  Implementing the module in C within the main agent (directly or via
+  dlmod) is probably the most efficient and reliable, closely followed
+  by embedded perl (or python) extensions.  These have the advantage of
+  minimal overheads between the code implementing the MIB module, and
+  the agent framework, and no inter-process communication issues.  But
+  this does assume that there's a suitable mechanism for retrieving the
+  necessary information.
 
   If the new MIB is monitoring or managing some other subsystem, external
   to the agent, then it may be necessary to embed a subagent within the
   subsystem itself - particularly if there's no suitable public API to
   retrieve the necessary information.  In this case, AgentX is probably
   the most appropriate way forward.
-    Unless you prefer to implement the missing public management API,
-  and develop a module within the main agent instead.
-
-
-  In terms of writing C code for the Net-SNMP agent, the way that the
-  (sub-)agent receives the request is more or less irrelevant.  The
-  MIB module API was deliberately designed to be independent of any
-  extension mechanism being used - so the exact same module code could
-  be included as part of a pure-SNMP master agent, or an AgentX subagent,
-  either compiled in or dynamically loaded.   No modifications should be
-  needed to the MIB module code itself - just to how it's compiled into
-  the appropriate application.
+    Alternatively, you could implement the missing public management API
+  for that subsystem, and develop a module within the main agent instead.
 
 
 
@@ -1968,30 +2289,6 @@
 
 
 
-Can I use AgentX (or an embedded SNMP agent) in a threaded application?
------------------------------------------------------------------------
-
-  With care.
-
-  As mentioned in the earlier "thread-safe" FAQ entry, the Net-SNMP
-  agent (including the AgentX subagent) has not been designed for
-  threaded operation.  In particular, it makes use of various global
-  variables without attempting to protect them against simultaneous
-  use.  This means that it is *NOT* safe to have SNMP or AgentX
-  related processing in two separate threads.  This also applies to
-  handling GET (and SET) processing in one thread, and generating traps
-  in another.  This is still vulnerable to the usual threading problems.
-
-    However, as long as *all* of the SNMP-related activity is limited
-  to the one thread, then there should be no reason why this cannot
-  safely communicate with other threads within the same application,
-  using private (thread-safe) mechanisms.
-
-    But in terms of the Net-SNMP-provided code, the agent (and AgentX
-  subagent) should *not* be regarded as thread-safe.
-
-
-
 How can I run AgentX with a different socket address?
 ----------------------------------------------------
 
@@ -2003,7 +2300,7 @@
   registrations (and send appropriate requests) can be specified using
   the option '-x'.
     The command
-		"snmpd -x localhost:705 ...."
+		"snmpd -x tcp:localhost:705 ...."
   would start the agent listening on the TCP port 705 for connections
   from the local system.
     The same effect can also be obtained by adding the line
@@ -2011,25 +2308,23 @@
   to the file 'snmpd.conf'.
 
   The same option can be used with the Net-SNMP agent when running in
+  This also holds when the Net-SNMP agent is running in
   "subagent" mode, to specify the socket to register with (and receive
   requests from).
     So a subagent might connect to the master agent above (both running
   on the same host), using: 
-		"snmpd -X -x localhost:705 ...."
+		"snmpd -X -x tcp:localhost:705 ...."
 
   A subagent running embedded within some other application will
   typically not understand the same command-line options, so would
   need to set the same configuration programmatically:
 
      netsnmp_ds_set_string(NETSNMP_DS_APPLICATION_ID,
-                           NETSNMP_DS_AGENT_X_SOCKET, "localhost:705");
+                           NETSNMP_DS_AGENT_X_SOCKET, "tcp:localhost:705");
 
   With the example subagent code from the Net-SNMP tutorial, this line
   would be added immediately before the 'init_agent' call.
 
-  But also see the mention of AgentX security (or the lack of it!)
-  in the earlier entry.
-
   The same approach can also be used to listen on a different named
   socket, using:
 		agentxsocket /tmp/agentx
@@ -2051,17 +2346,18 @@
   agent.  Unfortunately, it's not currently possible to turn off SMUX
   support this way.
 
-  The safest approach is to re-run configure with the option
-  "--with-out-mib-modules=smux", and recompile the agent.  If this
-  is not possible, an alternative workaround might be to have the
-  agent bind to an invalid IP address.
+  The safest approach is to run
+	configure --with-out-mib-modules=smux
+  and recompile the agent.
 
-  If you put a line such as
+  If this is not possible, an alternative workaround might be to have
+  the agent bind the SMUX socket to an invalid IP address, using a
+  snmpd.conf line such as:
 
 	smuxsocket  1.0.0.0
 
-  in the snmpd.conf file, the agent will whinge at startup,
-  but won't accept any incoming SMUX requests.
+  The agent may complain at startup, but it won't accept any incoming
+  SMUX requests.
 
   If the agent complains about not recognising the "smuxsocket"
   token, then you're out of luck.  You'll either have to recompile
@@ -2104,13 +2400,13 @@
 What traps are sent by the agent?
 --------------------------------
 
-  The agent sends a 'coldStart(0)' trap when it first starts up, and an
-  enterprise-specific trap 'nsNotifyShutdown' (or 'ucdShutdown') when it
-  stops.  It can also be configured to send an 'authenticationFailure(4)'
-  trap when it receives an SNMPv1 request using an unknown community name.
-  The Net-SNMP agent generates an enterprise-specific trap 'nsNotifyRestart'
-  (rather than the standard 'coldStart(0)' or 'warmStart(1)' traps) on
-  receiving a HUP signal - typically after being re-configured.
+  The Net-SNMP agent sends a 'coldStart(0)' trap when it first starts up,
+  and an enterprise-specific trap 'nsNotifyShutdown' when it stops.  It
+  generates an enterprise-specific trap 'nsNotifyRestart' (rather than
+  the standard 'coldStart(0)' or 'warmStart(1)' traps) on receiving a HUP
+  signal - typically after being re-configured.  It can also be configured
+  to send an 'authenticationFailure(4)' trap when it receives an SNMPv1 
+  (or SNMPv2c) request using an unknown community name.
 
     The agent does not send 'linkUp' or 'linkDown' traps by default. It can
   be configured to do this using the directive 'linkUpDownNotifications'.
@@ -2121,9 +2417,6 @@
   leaves an error state.  This can be configured using the 'defaultMonitors'
   directive (again documented under ACTIVE MONITORING).
 
-  Note that these facilities are only available with the v5 Net-SNMP
-  agent, and are not supported by the v4 UCD agent.
-
 
 
 Where are these traps sent to?
@@ -2140,14 +2433,16 @@
   directives - irrespective of which API call was used to trigger sending
   the trap.  See the trap-related entries in the CODING section for details.
 
-    A configuration block such as
+  Note also that you typically only want *one* of the settings:
 
         trapsink   localhost
         trap2sink  localhost
         informsink localhost
 
-  will result in *three* notifications being sent for each call to
-  'send_easy_trap()' (or 'send_v2trap()').  Probably not what was wanted!
+  Including two (or all three) of these lines in the snmpd.conf file will
+  will result in multiple copies of every notifications being sent for
+  each call to 'send_easy_trap()' (or 'send_v2trap()').
+    This is probably not what was intended!
  
 
 
@@ -2172,23 +2467,23 @@
 
   Firstly, are you certain that this is what is happening?
 
-  The normal operation of the agent is to 'fork' itself into the
-  background, detaching itself so that it will continue running even
-  when you log out, and freeing the command line for subsequent use.
-  This looks at first sight as if the agent has died, but using 'ps'
+  The normal operation of the agent is to 'fork' itself into the background,
+  detaching itself from the controlling terminal so that it will continue
+  running even when you log out, and freeing the command line for subsequent
+  use.  This looks at first sight as if the agent has died, but using 'ps'
   to show all processes should reveal that the agent is still running.
 
-  To prevent this behaviour (such as when attempting to debug the
-  agent), you can start it with the '-f' flag.  This suppresses the
-  fork, and the agent will run as a 'normal' command.  It's also often
-  useful to use the '-Le' (or '-L') flag, to log messages to stderr.
+  To prevent this behaviour (such as when attempting to debug the agent),
+  you can start it with the '-f' flag.  This suppresses the fork, and the
+  agent will run as a 'normal' command.  It's also often useful to use the
+  '-Le' (or '-L') flag, to log messages to stderr.
 
   On the other hand, if 'ps' shows that the agent is not running, then
   this is an error, and probably show that something went wrong in
   starting the agent up.  Check the agent log file for any error messages,
   or run it with '-f -Le' and see what it reports.
 
-  Another possible cause might be an existing agent (or some other process)
+  One possible cause might be an existing agent (or some other process)
   that's already listening on the SNMP port.  Trying to start a second
   agent will fail with an error about "opening the specified endpoint".
 
@@ -2278,6 +2573,50 @@
 
 
 
+The agent is complaining about 'snmpd.conf'.  Where is this?
+-----------------------------------------------------------
+
+  It doesn't exist in the distribution as shipped.  You need to
+  create it to reflect your local requirement.
+    To get started, you can either just create this file manually,
+  or run snmpconf to help you create one.  At the very least, you
+  will need some form of access control configuration, if the agent
+  is to be of any use whatsoever.  This can be as simple as:
+
+       rocommunity public
+
+    See the snmpd.conf(5) manual page or relevant entries in this
+  FAQ for further details.
+
+
+
+Why does the agent complain about 'no access control information'?
+------------------------------------------------------------------
+
+  Although an SNMP agent may support a wide range of management
+  information, it is not necessarily appropriate to report the whole
+  of this to every SNMP management station who asks for it.  Some
+  information may be sensitive, and should restricted to authorized
+  administrators only.   SNMP therefore includes mechanisms for
+  controlling who has access to what information - both in terms of
+  what can be seen, and (even more importantly) what can be changed.
+
+  By default, the Net-SNMP agent starts up with a completely empty
+  access control configuration.  This means that *no* SNMP request
+  would be successful.  It is necessary to explicitly configure
+  suitable access control settings, based on who should be granted
+  access in that particular environment.
+
+  If there are no access control entries configured (perhaps because
+  no snmpd.conf configuration file has been loaded, or it contains no
+  access control settings), then the agent will not respond to any
+  SNMP requests whatsoever.  This is almost certainly not what was
+  intended, so the agent reports this situation.
+
+  See the next entry for how to configure access control settings.
+
+
+
 How do I configure access control?
 ---------------------------------
 
@@ -2305,124 +2644,6 @@
   from particular sources, and all four can be restricted to a particular
   subtrees or (from v5.3) a named view.  See 'snmpd.conf(5)' for details.
 
-  These directives are effectively wrappers round the core access control
-  mechanism, which uses the four directives 'com2sec', 'group', 'view'
-  and 'access' to provide a more efficient and flexible control
-  over who can access which portions of the tree.
-
-    See the next entry for the gory details.
-
-
-
-I don't understand the new access control stuff - what does it mean?
--------------------------------------------------------------------
-
-  The idea behind the new access control model is to give a more flexible
-  way of specifying who can see and do what within the MIB tree.
-  It's more complicated to understand than the simple example above, but
-  that's because it can do a whole lot more.
-
-    There are four configuration keywords in the new scheme:
-	'com2sec', 'group', 'view', and 'access'
-
-  We'll consider these one at a time, starting with 'access'.
-  (Because I feel like starting with the last one, that's why - OK?)
-
-
-  The "access" keyword has the job of specifying who has access to
-  which bits of the MIB tree.  This has eight parameters, so can look
-  rather offputting. Most of these can be safely left with default values
-  in most cases (so don't you worry your pretty little head about them).
-  The syntax is
-
-	access {group} "" any noauth exact {read-tree} {write-tree} {notify-tree}
-
-  where the entries in braces need to be defined elsewhere (I'm coming
-  to that - be patient!), and the rest can be left as shown here.
-
-	[ If you really want to know, the 'sec.model' field can 
-	  be used to have an access line that's only relevant to
-	  specific versions of SNMP (such v1 or v2c) rather than
-	  "any" version, and the 'sec.level' field to ensure that
-	  the request must be authenticated or encrypted.
-	    The context and prefix fields can be used to distinguish
-	  between parallel versions of the same overall OID tree
-	]
-
-
-  The "view" keyword is used to define particular bits of the MIB tree,
-  for use in the last three fields of the access entry.
-  This has the syntax
-
-	view  {name}  included/excluded  {subtree}   {mask}
-
-  where {name} is the identifier to be used for this view (i.e. what should
-  appear in the access entry), and {subtree} is the portion of the MIB tree
-  that this name refers to (in either numeric or named form).
-    Note that the name of the view does not have to have anything to do
-  with the MIB sub-identifier names - it's purely an identifying tag for
-  use within the config file (though choosing a meaningful name is, as
-  always, a very good idea).
-  
-    The {mask} field can be used to control which elements of the OID subtree
-  should be regarded as relevant when determining which view an OID is in.
-  This is most relevant when defining "unusual" views, such as a single
-  row of a table.  In most cases, this field should be omitted.
-
-  The third field can be used to include or exclude particular portions
-  of the MIB from the named view.  A single view can be built up using
-  several 'view' lines (with the same view name), including or excluding
-  OID subtrees as appropriate.
-
-    The three view fields in the access line are used to control which
-  portions of the MIB tree a particular {group} can see (GET et al),
-  alter (SET), or request NOTIFYs on.
-
-
-
-    That's dealt with the "what" - now for the "who".
-  This is the role of the "group" and "com2sec" entries.
-
-  The "group" keyword gives general control, by mapping between a "security
-  name" (for a particular protocol version), and the internal name used in the
-  access line.  Note that the token "any" is no longer acceptable for the
-  security model - the original support for this was due due to a misreading
-  of the RFC.  You should replace any such line with separate versions for
-  each of the desired security models ('v1', 'v2c' & 'usm').
-
-    For SNMPv1 and SNMPv2c, the group line is just an intermediate step
-  between the "access" line and the "com2sec" line, which is the last bit
-  of the jigsaw.  The "com2sec" entry is used to determine a "security name"
-  from the traditional community string, taking into account where the request
-  has come from.  Thus the same community string can give access to  different
-  portions of the tree, depending on where the request is sent from.
-
-     For example, in an earlier version of the example config file, there
-  were two com2sec lines with the community string "public" - one was valid
-  from anywhere (with the security name "public") and one was only valid
-  from the local network (using the security name "mynet").
-     The group lines converted these security names into the groups "public"
-  and "mygroup" respectively, and the access lines gave these two groups
-  the ability to GET values in the 'system' sub-tree (from anywhere) or
-  the 'mib-2' sub-tree (from the local network).  Neither of these could
-  SET any values though, (since the write-tree was "none" in both cases).
-    Someone on the local machine, using the community string "private",
-  had the security name "local" and the group name "local", and hence had
-  full access (both GET and SET, as well as NOTIFY) to the whole of the
-  MIB tree (or at least everything under .1, which covers most things!)
-
-     Note that the three occurrences of "public", as community string,
-  security name and group name, were three totally separate things.
-  You can't use a community string in a security name field, or either
-  of these as a group name (or vice versa), unless you set up suitable
-  entries to map one name onto the other.
-
-    With SNMPv3, the security name is part of the basic protocol (or
-  near enough), and can be used directly in a group definition.
-
-  And here concludes our tour of the view-based access control mechanism.
-  Phew!
-
 
 
 How do I configure SNMPv3 users?
@@ -2430,49 +2651,50 @@
 
   There are three ways to configure SNMPv3 users:
 
-  1) Stop the agent, and create a file /var/net-snmp/snmpd.conf,
-     containing the line
+  1) Stop the agent, and add the line
 
 	createUser {myUser} MD5 {myPassword} DES
 
-    (where {myUser} and {myPassword} are the appropriate values,
+    to the file /var/net-snmp/snmpd.conf (where {myUser} and
+    {myPassword} are the appropriate values for username and password,
     _without_ the braces!).  Then re-start the snmpd agent.
 
   2) Stop the agent, run the command
 
         net-snmp-config --create-snmpv3-user
 
-     and follow the instructions.  This will create an entry
+     and follow the prompts given.  This will create an entry
      in the /var/net-snmp/snmpd.conf file similar to the above.
      Then re-start the snmpd agent.
 
-  3) Make sure the agent is running, and will respond to a suitable
-     existing SNMPv3 user (with the same Authentication and Encryption
-     protocols as required for the new user).  Then use the 'snmpusm'
-     command to clone this template user, and change the password.
+  3) Make sure the agent is running, and will respond to an SNMPv3
+     request (using an existing user with the desired authentication
+     and privacy protocols).  Then use the 'snmpusm' command to clone
+     this template user, and change the password.
 
 
   See the access control entries above and the file 'README.snmpv3'
   for more details about how to use SNMPv3 users,
 
   Note that simply having a 'rouser' or 'rwuser' line does *not*
-  automatically create the corresponding user.  You will need the
-  above 'createUser' line (or an equivalent 'usmUser') as well.
+  automatically create the corresponding SNMPv3 user.  You will need
+  the above 'createUser' line (or an equivalent 'usmUser') as well.
 
 
 
 The 'createUser' line disappears when I start the agent.  Why?
 -------------------------------------------------------------
 
-    That's deliberate.
+  This is deliberate.
+
   The agent removes the (human-readable) 'createUser' directive, and
   replaces it with an equivalent 'usmUser' entry.  This contains the
   same information, but in a form that's only meaningful internally.
   Not only is the passphrase no longer visible in the config file, it
-  has actually been converted to a key that is only valid on the local
-  machine.  If someone stole the new usmUser line from this system,
-  they could not use that information to access any of your other agents
-  (even if the usernames and passwords were the same).
+  has actually been converted to a key that is only valid on this
+  particular system.  If someone stole the configuration file, they
+  could not use the information from the usmUser entry to access any
+  of your other agents (even if the usernames and passwords were the same).
 
 
 
@@ -2497,16 +2719,25 @@
   experienced when replacing a ready-installed version (e.g. from a vendor
   distribution), with the current release installed from the source.
 
+  Try moving the old config file to the new location, and restart the agent.
+  If you're not sure where this should go, see the next entry.
+
+
+
+Where should the snmpd.conf file go?
+-----------------------------------
+
     The default location for this file with the basic distribution is
   /usr/local/share/snmp/snmpd.conf (or PREFIX/share/snmp/snmpd.conf).
   Ready-installed versions often look for the file as /etc/snmpd.conf,
-  or /etc/snmp/snmpd.conf.  Try moving the old config file to the new
-  location, and restart the agent.
-
-    With release 5.0, the name of the package changed from "ucd-snmp"
-  to "net-snmp", and this change was reflected in the name of the persistent
-  /var directory.  So a v5 Net-SNMP agent will not look in
-  /var/ucd-snmp/snmpd.conf for settings from a v4 UCD agent.
+  or /etc/snmp/snmpd.conf.
+
+  If you are still not sure, try running the command
+
+      snmpd -f -Le -Dread_config 2>&1 | grep "config path"
+
+  The first line of output will display the list of locations where
+  the agent is looking for configuration information.
 
 
 
@@ -2518,7 +2749,9 @@
   the TCP wrapper mechanism using the files 'hosts.allow' and 'hosts.deny'
   to control access to the service.  Some distributions may come with
   this enabled automatically - otherwise you need to explicitly activate
-  this by configuring using '--with-libwrap'.
+  this by running
+         configure --with-libwrap
+  and recompiling the agent.
 
   If TCP wrappers are enabled, and both hosts.allow and hosts.deny are
   empty, then all requests will be rejected (with "Connection refused").
@@ -2527,10 +2760,10 @@
 
 		snmpd: ALL
 
-  to the file /etc/hosts.allow (or wherever this file is on your system).
-  Though be aware that doing this removes one level of protection and allows
-  anyone to try and query your agent (though the agent's own access control
-  mechanisms can still be used to restrict what - if anything - they can see).
+  to the file /etc/hosts.allow.  Be aware that doing this removes one
+  level of protection and allows anyone to try and query your agent.
+  The agent's own access control mechanisms can still be used to restrict
+  what - if anything - they can see.
 
   If you do wish to use the TCP wrappers to restrict access, it's sensible
   to have an explicit entry:
@@ -2546,20 +2779,21 @@
 
   which will allow connections from localhost, and nothing else.
 
-  Note that personal firewalls (such as Linux' ipchains or iptables
-  mechanism) may have a similar effect (though typically this won't
-  be logged).  See the earlier entry
+  Note that personal firewalls, such as the Linux iptables mechanism,
+  may have a similar effect (though typically this won't be logged).
+  See the earlier entry
     Requests always seem to timeout, and don't give me anything back.  Why?
 
 
  
-Why can't I see values in the UCDavis 'extensible' or 'disk' trees?
+Why can't I see values in the UCDavis 'proc' or 'disk' trees?
 ------------------------------------------------------------------
 
-  Both these trees are designed to report things you ask it to report
-  on.  If you don't declare anything in the snmpd.conf file for it to
-  monitor, it will not report anything.  See the snmpd.conf manual page
-  and the EXAMPLE.conf file for details on configuring the agent.
+  Both these trees are designed to report precisely those things that
+  have been explicitly configured for monitoring.  If there are no
+  relevant configuration entries in the snmpd.conf file, then these
+  tables will be empty.  See the snmpd.conf manual page and the
+  EXAMPLE.conf file for details on configuring the agent.
 
   Optionally, run snmpconf -g monitoring to help you set up this
   section of the snmpd.conf file.
@@ -2569,10 +2803,15 @@
 Why can't I see values in the UCDavis 'memory' or 'vmstat' trees?
 ----------------------------------------------------------------
 
-  These mib modules are not supported on all operating systems, and
-  will not be included on any other system.  Currently, they are only
-  supported on Linux, HP-UX (memory only), Solaris, BSDi (vmstat on
-  BSDi4 only), Dynix, FreeBSD, NetBSD and OpenBSD.
+  These trees do not need any explicit configuration, and should
+  be present automatically.
+
+  However the C code necessary to implement these particular MIB
+  modules are not supported on all operating systems.  These trees
+  will be omitted on any system for which there is no underlying
+  code.   Currently, they are only supported on Linux, HP-UX (memory
+  only), Solaris, BSDi (vmstat on BSDi4 only), Dynix, FreeBSD, NetBSD
+  and OpenBSD.
     If you want to help port it to other systems, let us know.
 
   Note that these subtrees only report the current usage when
@@ -2580,7 +2819,7 @@
   when the usage strays outside the configured bounds.
   See the earlier FAQ entry
     What traps are sent by the agent?
-  for more information.
+  or the snmpd.conf section on active monitoring, for more information.
 
 
 
@@ -2628,7 +2867,7 @@
   monitor the overall CPU activity of a system, and typically reflect
   whatever the underlying operating system reports for the (single)
   CPU statistics information.  How these are handled for a multi-CPU
-  system will probably differ from one O/S to another, and will need
+  system will differ from one O/S to another, and will need
   to be investigated for each system individually.
 
   The htProcessorTable was designed to handle monitoring multi-CPU
@@ -2672,7 +2911,7 @@
   statistics for the physical interface itself.
 
     There's no easy way around this problem - the agent can only
-  report such values as it can find out.  If the kernel doesn't
+  report such information as is available.  If the kernel doesn't
   keep track of these figures, the agent can't report them.
 
     Sorry!
@@ -2741,8 +2980,8 @@
 
 
 
-How about "Can't open /dev/kmem"?
---------------------------------
+What does "Can't open /dev/kmem" mean?
+-------------------------------------
 
   This device is normally restricted to just being accessible by root
   (or possibly by a special group such as 'kmem' or 'sys').  The agent
@@ -2756,23 +2995,6 @@
 
  
 
-The agent is complaining about 'snmpd.conf'.  Where is this?
------------------------------------------------------------
-
-  It doesn't exist in the distribution as shipped.  You need to
-  create it to reflect your local requirement.
-    To get started, you can either just create this file manually,
-  or run snmpconf to help you create one.  At the very least, you
-  will need some form of access control configuration, if the agent
-  is to be of any use whatsoever.  This can be as simple as:
-
-       rocommunity public
-
-    See the snmpd.conf(5) manual page or relevant entries in this
-  FAQ for further details.
-
-
-
 The system uptime (sysUpTime) returned is wrong!
 -----------------------------------------------
 
@@ -2836,35 +3058,99 @@
 
 
 
+Can I use AgentX (or an embedded SNMP agent) in a threaded application?
+-----------------------------------------------------------------------
+
+  With care.
+
+  As mentioned in the earlier "thread-safe" FAQ entry, the Net-SNMP
+  agent (including the AgentX subagent) has not been designed for
+  threaded operation.  In particular, it makes use of various global
+  variables without attempting to protect them against simultaneous
+  use.  This means that it is *NOT* safe to have SNMP or AgentX
+  related processing in two separate threads.  This also applies to
+  handling GET (and SET) processing in one thread, and generating traps
+  in another.  This is still vulnerable to the usual threading problems.
+
+    However, as long as *all* of the SNMP-related activity is limited
+  to the one thread, then there should be no reason why this cannot
+  safely communicate with other threads within the same application,
+  using private (thread-safe) mechanisms.
+
+    But in terms of the Net-SNMP-provided code, the agent (and AgentX
+  subagent) should *not* be regarded as thread-safe.
+
+
+
 COMPILING
 =========
 
-How do I compile with 'cc' instead of 'gcc'?
--------------------------------------------
-
-  Run configure with --with-cc=cc
-
-  Note that if you've already run configure once, it will probably have
-  detected the presence of 'gcc', cached this information, and may still
-  try to use this anyway.   In which case, simply remove the 'config.cache'
-  file before re-running configure.
+How do I control the environment used to compile the software?
+-------------------------------------------------------------
+
+  The basic mechanism for compiling the Net-SNMP project software is to
+  run "configure", followed by "make" (to compile it), "make test" (to
+  check that it's working properly) and then "make install" (to install
+  the files into the correct locations - which typicalyl needs to be done
+  as root.
+
+  The primary role of "configure" is to determines various aspects about
+  the system that the software is being compiled on.  However there are
+  also a number of options to configure which can be used to control
+  various aspects of the compilation environment.
+
+  The most common options are "--with-mib-modules" and "--with-out-mib-modules"
+  which control the set of MIB module code files that are included within
+  the agent binary.  Adding or removing these modules will affect what MIB
+  information the agent can return.
+     See the entry "How do I add a MIB to the agent?" for more details.
+
+  
+  The configure script can also specify the compiler to use for compiling
+  the source code  (e.g. "configure --with-cc=cc"), the flags passed to
+  this compiler (e.g. "configure --with-cflags=-g"), or to the linker
+  (e.g. "configure --with-ldflags=-Bstatic"), and various other aspects of
+  the build environment.
+     Run "configure --help" for a full list.
  
 
 
-The compilation is complaining about missing libraries. Why?
------------------------------------------------------------
-
-  This has been seen in a number of guises over the years - most
-  commonly on Linux systems (although the problem may also occur
-  elsewhere).  A typical installation may not always include the full
-  set of library links required for building the Net-SNMP software.
+How do I control the environment used to compile the software under Windows?
+---------------------------------------------------------------------------
+
+  If you are compiling the project within the MinGW or Cygwin environments,
+  then these use the same "configure" mechanism as Unix-based systems.  See
+  the previous entry for more information.
+
+  If you are compiling the project from within Visual Studio, then this does
+  not use the standard configure mechanism.  Instead, there is a separate
+  "Configure" script within the 'win32' directory.  This can be used enable
+  or disable various aspects of the build environment, such as support for
+  encryption or IPv6.
+    Run "Configure --help" for more information
+
+  Note that this script does not include an equivalent of "--with-mib-modules"
+  for extending the MIB information supported by the agent.  Instead, this
+  needs to be done by tweaking the build environment manually.  See the file
+  README.win32 for more details of this, and various other aspects of building
+  the project on Windows systems.
+
+
+
+Why does the compilation complain about missing libraries?
+---------------------------------------------------------
+
+  This has been seen in a number of guises over the years - most commonly
+  on Linux systems (although the problem may also occur elsewhere).  The
+  underlying problem is that typical installation may not always include
+  the full set of library links required for building the Net-SNMP software.
 
   This problem can usually be fixed by installing the missing packages
   (typically the development version of a package that is already there).
 
   Examples of this that we have come across include:
 
-     -lelf       elfutils-devel 
+     -lelf       elfutils-devel      (later renamed to elfutils-libelf-devel)
      -lbz2       bzip2-devel
      -lselinux   libselinux-devel
      -lcrypto    openssl/openssl-devel
@@ -2888,20 +3174,6 @@
 
 
 
-I'm getting an error "autoheader: not found" - what's wrong?
------------------------------------------------------------
-
-    This usually appears when compiling the current development source
-  version, obtained via CVS.  Unfortunately, the timestamps on some of
-  the configure files are such that make assumes (mistakenly) that the
-  configure script needs to be re-generated.
-    A similar problem may arise relating to 'autoconf'.
-
-    In both cases, this can be corrected by running the command
-  "make -k touchit" before attempting to make the main package.
-
-
-
 How can I reduce the memory footprint?
 --------------------------------------
 
@@ -2959,6 +3231,77 @@
 
 
 
+How can I compile the project for use on an embedded system?
+-----------------------------------------------------------
+
+  Although this is definitely a Frequently Asked Question on the project
+  mailing lists, it hasn't really been a Frequently _Answered_ Question.
+  The basic problem is that none of the core development team have much
+  involvement or experience with embedded systems.  And although we have
+  repeatedly put out a plea for implementation reports and advice, this
+  has not so far been particularly successful.  So the first thing to say
+  is that the following suggestions should be treated with a greater than
+  usual level of suspicion.
+
+  The second thing to say is that compiling the Net-SNMP project for use
+  on an embedded system typically means compiling the *agent* (rather than
+  the trap receiver, or command-line tools).  So that is what this entry
+  will concentrate on.
+
+  There are three main aspects to consider:
+     - how to compile the code,
+     - *what* code to compile, and
+     - how to install the resulting agent binary.
+
+  The Net-SNMP project uses the standard "configure" mechanism, so the
+  usual cross-compilation options are available - in particular "--host"
+  and "--target".  It is also possible to specify the compiler and linker
+  to use ("--with-cc" and "--with-ld"), and any special flags to pass
+  to them ("--with-cflags" and "--with-ldflags").   There shouldn't be
+  anything particularly special about compiling the Net-SNMP code, so
+  see the documentation for your target environment for more information.
+  (And please let us know if there *is* anything special that should be
+  mentioned here!)
+
+  If the aim is simply to generate an SNMP agent to run on the target
+  system, it's probably not necessary to compile the command-line tools
+  or trap receiver.  The configure option "--disable-applications" will
+  omit these elements.  See the previous entry for other potentially
+  relevant useful options.
+
+  Unfortunately, the SNMP agent (and in particular, the code for individual
+  MIB modules) is the most system-specific part of the Net-SNMP software.
+  It may prove necessary to disable particular MIB modules if they do not
+  compile successfully, or attempt to use the wrong system-specific APIs.
+  This can be done using the configure option "--with-out-mib-modules".
+  Alternatively, the option "--enable-mini-agent" will omit all but the
+  core MIB module code.  Additional modules can then be added individually
+  using "--with-mib-modules".
+
+  Further information about how to deal with problems with individual MIB
+  modules is reliant on suitable reports being forthcoming from the wider
+  Net-SNMP community.  The ball is in your court!
+
+  Finally, installing the agent binary is _not_ simply a matter of copying
+  the "snmpd" file onto the target system.  The agent typically relies on
+  a number of additional libraries (and possibly the presence of assorted
+  MIB files, unless this has been explicitly omitted).  It is normally
+  necessary to run "make install", before copying the installed framework
+  to the target system.
+
+  If the install destination needs to be different to the eventual location
+  on the target system, this can be handled using the configure options
+  "--prefix" (for the target location) and "--with-install-prefix" (for the
+  temporary install location).  Alternatively, this can be handled as part
+  of the install command:
+       make install prefix={target location} INSTALL_PREFIX={temp location}
+
+  Alternatively, if the agent is compiled with static linking (and no MIB
+  files), then it may be possible to simply copy the agent binary across to
+  the target system.  See the next entry for details.
+
+
+  
 How can I compile the project to use static linking?
 ---------------------------------------------------
 
@@ -3002,26 +3345,23 @@
 
 
 
-Why is the project workspace empty under Visual C++?
----------------------------------------------------
-
-    This is probably due to the different ways that Unix and Windows
-  handle text file line termination.  Older versions of WinZip don't
-  handle this properly, and Visual C++ gets confused (poor dear!).
-  The latest version of WinZip is reported to unpack this correctly.
-
-
-
-Why does 'make test' skip five tests?
------------------------------------
-
-    You mean T053agentv1trap, T054agentv2ctrap, T055agentv1mintrap,
-  T056agentv2cmintrap and T113agentxtrap?
-
-    These tests rely upon functionality in the NET-SNMP-EXAMPLES-MIB
-  which is not implemented in the default agent configuration.  To
-  include these tests, invoke the `configure` script to include
-      '--with-mib-modules="examples/example".
+Why does 'make test' skip various tests?
+---------------------------------------
+
+  Some of the tests are only relevant to particular operating systems,
+  or rely on specific areas of functionality.  The test framework will
+  check whether the relevant elements are available before running the
+  relevant tests, and will skip them if these modules have been omitted
+  from the build environment (or do not apply to the current system).
+
+  One example of this are the tests T053agentv1trap, T054agentv2ctrap,
+  T055agentv1mintrap, T056agentv2cmintrap and T113agentxtrap,  which
+  rely upon functionality from the NET-SNMP-EXAMPLES-MIB implementation.
+  This module is not included in the default agent configuration, so the
+  test framework will skip these tests.
+    To include them, run
+        "configure --with-mib-modules=examples/example"
+  and re-compile.
 
 
 
@@ -3094,7 +3434,10 @@
   information held elsewhere, perhaps in the operating system kernel or
   some other application.  Handling this is much more complex - since
   a lot depends on what mechanisms are provided for retrieving (and
-  possibly updating) this information.
+  possibly updating) this information.  The mib2c tool can generate code
+  for processing SNMP requests, based on some internal cache of management
+  information, but it cannot help with populating this cache with the
+  underlying data.  That is up to the MIB implementer.
 
   See the existing MIB modules in the Net-SNMP source tree for various
   examples of assorted approaches to this task.
@@ -3108,7 +3451,8 @@
   the definition of the MIB subtree you're trying to implement.  This
   might be because it hasn't been installed, the name is wrong, or
   (most likely), because it isn't in the default list.  See the MIBS
-  section for more details.
+  section for more details, or the next entry for suitable invocations
+  of 'mib2c'.
 
 
 
@@ -3139,9 +3483,9 @@
 Why doesn't mib2c like the MIB file I'm giving it?
 -------------------------------------------------
 
-    This is most likely the same problem as above.  Mib2c takes the
-  name of a MIB object, not the name of a file (or a MIB module).
-  Try using the name of the MODULE-IDENTITY definition.
+  This is most likely the same problem as the previous entry.  Mib2c
+  takes the name of a MIB _object_, not the name of a file (or MIB
+  module).  Try using the name of the MODULE-IDENTITY definition.
 
     Another possibility is that the MIB may contain syntax errors.
   Try running it through 'snmptranslate' or a dedicated SMI
@@ -3153,15 +3497,14 @@
 Mib2c ignores my MIB and generates a pair of 'mib-2' code files.  Why?
 ---------------------------------------------------------------------
 
-    This is usually a sign of the same problem as above - giving
-  mib2c the name of the file containing the MIB (or of the MIB
+    This is usually a sign of the same problem as the previous entries,
+  giving mib2c the name of the file containing the MIB (or of the MIB
   itself), rather than an object within it.
 
-  Earlier versions of mib2c didn't detect this situation, and
-  rather than report an error, it merrily constructed a template
-  for a default starting point of the mib-2 node.
+  Earlier versions of mib2c didn't detect this situation, and merrily
+  constructed a template for a default starting point of the mib-2 node.
 
-  More recent versions issue the error mentioned above instead.
+  More recent versions complain about not having a valid OID instead.
 
 
 
@@ -3255,7 +3598,10 @@
 
     For implementing a group of scalar objects, then the choice is
   simple - use 'mib2c.scalar.conf'.  Similarly, for generating traps
-  or informs, use 'mib2c.notify.conf'.
+  or informs, use 'mib2c.notify.conf'.  But note that this only assists
+  with the code to actually generate the trap.  It does not address the
+  issue of _when_ to send the trap.  See the FAQ entry "How can I get
+  the agent to generate a trap?" for more information.
 
 
 
@@ -3264,21 +3610,20 @@
 
     This uses a very powerful tool called a "text editor" :-)
 
-    The v5 Net-SNMP mib2c tool uses separate configuration files to
-  generate code for scalar objects, and for tables.  This means that
-  it's not possible to automatically generate a single code file
-  that supports both scalars and tables.
+    The mib2c tool uses separate configuration files to generate code
+  for scalar objects, and for tables.  This means that it's not possible
+  to automatically generate a single code file that supports both scalars
+  and tables.
 
     Instead, the two code files need to be generated separately, and
-  then combined manually.  The handler and supporting routines from
-  one file can simply be included in the other with no changes needed.
-  The corresponding registration of these handlers can then be copied
-  from the first initialisation routine into the second.
-
-
-
-Are there any examples, or documentation?
--------------------------------------------
+  then combined manually.  This will typically mean copying the handler
+  routines for the scalar object(s) into the table file, and adding the
+  code to register these handler(s) to the table initialisation routine.
+
+
+
+Are there any examples, or documentation for developing MIB modules?
+-------------------------------------------------------------------
 
     Many of the MIB modules shipped with the Net-SNMP agent still
   use the v4 "traditional" MIB module API, but an increasing number
@@ -3292,21 +3637,19 @@
   Log MIB (see 'notification-log-mib/*'), used by 'snmptrapd' to
   log incoming traps.
  
-    The basic iterator handler is used in a number of modules, such
-  as the TCP and UDP table implementations (mibII/tcpTable &
-  mibII/udpTable), VACM context handling (mibII/vacm_context) and
-  various tables relating to agent internals (agent/*).  These show
-  a number of different approaches to using the iterator helper, so
-  it's worth comparing them.
+    The basic iterator handler is used in the TCP and UDP table
+  implementations (mibII/tcpTable & mibII/udpTable), VACM context
+  handling (mibII/vacm_context) and various tables relating to agent
+  internals (agent/*).  These show a number of different approaches
+  to using the iterator helper, so it's worth comparing them.
 
     The two examples/netSnmpHostsTable* modules provide a contrast
   between the iterator and iterator_access helpers.
 
-    There are an ever-increasing number of examples based on the
-  MfD framework (see '{if,ip,tcp,udp}-mib/').  Much of this code
-  is not intended to be viewed directly, but individual files are
-  clearly commented to distinguish between internal implementation
-  and public code.
+    There are several examples based on the MfD framework (see
+  '{if,ip,tcp,udp}-mib/').  Much of this code is not intended to
+  be viewed directly, but individual files are clearly commented
+  to distinguish between internal implementation and public code.
 
     The Net-SNMP agent does not currently include any MIB modules
   using the array-user container-based helper.  The best examples
@@ -3321,7 +3664,8 @@
   If you're using the main source tree to compile your new module, then
   put these two files (mymib.[ch]) in the directory 'agent/mibgroup'.
   You should then re-run configure to add in your new module
-  ("configure --with-mib-modules=mymib") and recompile.
+        configure --with-mib-modules=mymib
+  and recompile.
 
     If you've got a number of new modules to add, it might be
   sensible to put them all into a single subdirectory of 'mibgroup'.
@@ -3333,61 +3677,72 @@
 		config_require(mymib/myOtherTable)
 
   If this was saved as the file 'mymib.h', then the same configure
-  line given above, would pull in all three modules.  See the
-  current contents of 'agent/mibgroup' for examples of this.
-
-
-
-I've created a new module with 'mib2c' but it doesn't work.  Why not?
---------------------------------------------------------------------
-
-    Remember that 'mib2c' generates a template for the MIB implementation.
-  It doesn't fill in all the details for you.  In particular, it cannot
-  know how to obtain the information needed to answer particular queries.
-  That's the job of the MIB module programmer (you!) -  See the previous
-  question for how to proceed.
-
-    Essentially mib2c handles the syntax of the MIB implementation,
-  leaving you to concentrate on the semantics.
-
-
-
-I've added my code to this template and it still doesn't work.  Why not?
------------------------------------------------------------------------
-
-    It's difficult to provide a definitive answer to that.  The
-  best we can do is suggest a checklist that might help pinpoint
-  the source of the problem.  Try looking at the following:
-
-    - Is the new module being compiled?
-        (Delete any .o files, and re-run 'make'
-         Are the .o files re-created?)
-
-    - Is it being included in the agent library?
-        (Run 'nm' on the library and look for the names
-         of the initialisation routine and variable handlers)
-
-    - Is the initialisation routine being run?
-        (Activate the debugging code that you put into
-         this routine.  You *do* include debugging code 
-         as a matter of course, don't you?)
-
-    - Has the module been registered with the agent?
-        (Try walking the NET-SNMP-MIB::nsModuleTable.
-        This will also check whether the agent accepts
-        requests for enterprise-specific OIDs)
-
-    - Is the module handler actually being called at all?
-        (Activate the debugging code that you put into this
-         handler, and do a single 'snmpget' or 'snmpgetnext'
-         for a suitable instance.  You *do* include debugging
-         code as a matter of course, don't you?)
-
-    - Is it returning success or an error?
-        (Activate the debugging code.... but you get the idea!)
-
-  That won't actually solve the problem, but at least you'll
-  have some idea where to look.
+  line given above, would pull in all three modules.  See the current
+  contents of 'agent/mibgroup' for examples of this.  Note that the
+  MfD framework will generate a similar grouping automatically.
+
+
+
+Why doesn't my new MIB module report anything?
+---------------------------------------------
+
+    There are probably four main reasons why a new MIB module isn't working.
+  Either it hasn't been included in the running agent,  the code is present
+  but hasn't been initialised,  the module has been initialised but the
+  handler isn't being called, or there's a problem with the module code itself.
+
+  To check whether the code files are being compiled, the easiest approach is
+  simply to look at the directory where the code is located.  When the agent is
+  compiled, this should produce .o files (and probably .lo files) corresponding
+  to the C code files for this module.  Alternatively, run 'nm' (or 'strings')
+  on the MIB module library (libnetsnmpmibs), and look for the names of the
+  initialisation routines or handlers (or the text of any messages displayed by
+  the module code).
+
+  One other thing to check is whether you have multiple copies of the software
+  installed on the system.  This is a particular problem when compiling from
+  source (to include your new module), without first removing any vendor-supplied
+  version of the agent (which won't include this new code).
+
+
+  Assuming that you have confirmed that the module code is present in the agent,
+  the next step is to check whether the initialisation routine is being called
+  to register the MIB objects.  The simplest way to do this is to include a
+  suitable debugging statement within the initialisation routine, and start
+  the agent with the corresponding '-Dtoken'.  Alternatively, try walking the
+  nsModuleName column object, and look for mention of the new MIB module.
+
+
+  Assuming the module has been registered, the next step is to check whether
+  the handler is being called, when the agent receives a suitable SNMP request.
+  Again, the simplest way to do this is to include debugging statements within
+  the handler routine, and start the agent with the corresponding '-Dtoken'.
+  Then issue an "snmpget" request for an instance within the new MIB module.
+  (This command is preferable to the usual "snmpwalk" command, as it is more
+  closely focused on the MIB module in question).
+
+  If this indicates that the handler routine isn't being called, then there are
+  two main likely causes.  Firstly, check the access control settings.  If these
+  are configured to block access to this portion of the OID tree, then the MIB
+  handler will never be called.  Secondly, several of the table helpers are
+  designed to know which rows of the table are valid, and will call the main
+  MIB handler with information about the relevant row.  If the requested row is
+  not valid (or the table is empty), then the handler will not be called.
+
+
+  Finally, if the handler _is_ being called, but is still not returning any
+  information, then the cause probably lies with your MIB module code.  In which
+  case, it's really up to you to find the problem and fix it!  Either activate
+  any debugging code that you have included within the handler routine, or run
+  the agent under a source code debugger, and step through the handler processing.
+  In either case, it's much easier to debug these problems when processing an
+  "snmpget" request, rather than "snmpgetnext" or "snmpwalk".
+
+  Remember that 'mib2c' simply generates template code for your MIB module.
+  It's up to you to fill in the details, to report the actual information from
+  whatever underlying subsystem is being monitored.   Mib2c cannot help with
+  the semantics of the MIB module - it's purely there to provide an initial
+  code framework, based on the _syntax_ of the MIB module objects.
 
 
 
@@ -3395,7 +3750,7 @@
 -----------------------------------------------------------------------
 
     The first thing to realise is that the 'get_first' and 'get_next'
-  hook routines are concerned with processing a single request, not
+  hook routines are concerned with processing a single SNMP request, not
   with walking the whole table.  A full "snmpwalk" command will typically
   involve a series of individual 'GetNext' requests, and every one of
   these will trigger a separate 'get_first/get_next/get_next/....' cycle.
@@ -3448,13 +3803,14 @@
 
     But if the trap is intended to report on a change of status
   (e.g. a network interface going up or down, or a disk filling up),
-  then actually detecting this is non-trivial.   It's necessary to
-  poll the value(s) on a regular basis, save the results and compare
-  them with the new values the next time round.
+  then actually detecting this is non-trivial.   Unless the underlying
+  system can signal this situation to the agent, then it's typically
+  necessary to poll the value(s) on a regular basis, save the results
+  and compare them with the new values the next time round.
 
     The simplest way to handle this is via the DisMan Event MIB,
   which is designed for exactly this purpose.  As long as you can
-  specify MIB object(s) to monitor, and the values or thresholds
+  specify a MIB object to monitor, and the value or thresholds
   that should trigger a notification, then this module can check
   these values regularly, and automatically send a suitable trap
   when appropriate.  See the 'snmpd.conf(5)' man page (under
@@ -3462,12 +3818,31 @@
   
     Otherwise, you'd need to use the routines documented in
   'snmp_alarm(3)' to regularly invoke a monitoring routine. This
-  could check the necessary conditions (which need not be MIB
+  would check the necessary conditions (which need not be MIB
   objects), and call the 'send_xxx_trap()' routine (as generated
   by 'mib2c.notify.conf') when appropriate.
 
 
 
+How can I get an AgentX sub-agent to generate a trap (or inform)?
+----------------------------------------------------------------
+
+  This is done in exactly the same manner as with the main SNMP agent.
+  Calling one of the routines described in 'snmp_trap_api(3)' will cause
+  the AgentX sub-agent to send a notification to the master agent, which
+  will then pass this on to the configured trap destination(s).
+  
+  One of the original design aims of the Net-SNMP AgentX support was that
+  the agent (or subagent) framework should be transparent to a MIB module
+  implementer. The interface between the agent framework and a MIB module
+  should be independent of the protocol used to receive the original request.
+  So the exact same MIB module code could be used within a traditional
+  SNMP-only agent, or an AgentX subagent, with no changes needed.
+
+    This also holds for sending traps.
+
+
+
 How can I get the agent to send an SNMPv1 (or SNMPv2c) trap?
 -----------------------------------------------------------
 
@@ -3567,24 +3942,6 @@
 
 
 
-What if I'm using an AgentX sub-agent instead?
----------------------------------------------
-
-    That doesn't matter - the routines described in 'snmp_trap_api(3)'
-  can still be used, and the subagent will do the Right Thing.
-  
-  One of the original design aims of the AgentX support was that this
-  should be transparent to a MIB module implementer.  The agent-module
-  interface should be independent of the protocol used to receive the
-  original request.  So the exact same MIB module code could be used
-  within a traditional SNMP-only agent, or an AgentX subagent, with no
-  changes needed.
-    In fact, the main agent supplied as part of the package can indeed
-  be run as an SNMP agent or an AgentX subagent, simply based on command
-  line flags (or similar configuration options).
-
-
-
 How can I register a MIB module in a different (SNMPv3) context?
 ---------------------------------------------------------------
 
@@ -3592,13 +3949,15 @@
   an agent can support parallel versions of the same MIB objects,
   referring to different underlying data sets.  By default, a MIB
   module registrations will use the default empty context of "".
-  But it's also possible to explicitly register an individual MIB
-  module using a different context.
+  But it's also possible to provide MIB information using a different
+  (non-default) context.
 
-    With the v4 API, this uses the call 'register_mib_context()'
-  rather than the REGISTER_MIB macro.  This is significantly more
-  detailed, but most of the additional parameters can take fixed
-  values, if all that's needed is to change the registration context.
+    There are three aspects involved in doing this.  Firsly, it's necessary
+  to register the MIB module in this non-default context.  With the v4 API,
+  this uses the call 'register_mib_context()' rather than the REGISTER_MIB
+  macro.  This is significantly more detailed, but most of the additional
+  parameters can take fixed values, if all that's needed is to change the
+  registration context.
 
   Instead of the macro call:
         REGISTER_MIB("my_token", my_variables, variable1, my_variables_oid);
@@ -3619,20 +3978,37 @@
         reg->contextName = strdup("my_context");
         netsnmp_register_handler(reg);
 
-    In either case, it will also be necessary to define suitable
-  access control entries to cover requests using the new context.
-  This can either list each context explicitly:
+
+  Secondly, it is necessary to configure the access control settings to allow
+  access to information in the new context.  This is handled automatically
+  when using the simple "rouser" or "rwuser" directives.  But if access control
+  is configured using the fuller com2sec/group/view/access mechanism, then the
+  "access" line must specify the appropriate context(s), either explicitly:
 
 	access {group} "my_context" any noauth exact  ......
 
-  or use a single entry to cover all possible contexts:
+  or using a single entry to cover all possible contexts:
 
 	access {group} ""           any noauth prefix ......
 
-  But note that *both* steps are required.  Changing the access
-  control settings won't affect the default context used for MIB
-  registrations, and registering a MIB in a non-default context
-  won't automatically configure the necessary access control settings.
+
+  Finally, the SNMP request used to retrieve (or update) the information
+  must also specify the required context.  With SNMPv3 requests, the context
+  is part of the protocol, so this can be done using a command-line option:
+
+      snmpwalk -v 3 -n my_context .....
+
+  With community-based requests (SNMPv1 and SNMPv2c), things aren't so simple.
+  Although the "rocommunity" and "rwcommunity" settings also configure access
+  for all possible contexts, there's no way to specify a non-default context
+  as part of the request.
+
+  The only way to handle non-default contexts with community-based SNMP requests
+  is to set up a mapping from the community string to the desired context.  This
+  uses the "com2sec" directive, with an additional "-Cn" parameter.   Note that
+  this also means that the access control must be configured using the full
+  com2sec/group/view/access mechanism.  The short-form access control directives
+  do not handle the mapping of community strings to non-default contexts.
 
 
 

=== modified file 'NEWS'
--- NEWS	2009-11-12 16:17:40 +0000
+++ NEWS	2010-06-10 18:02:54 +0000
@@ -3,12 +3,26 @@
 that have been fixed/applied, and the ChangeLog file for a comprehensive
 listing of all changes made to the code.
 
-*5.4.2.1*
+*5.4.3*
+
     snmpd:
-      - SECURITY ISSUE: A bug in the getbulk handling code could let
-        anyone with even minimal access crash the agent.
+      - Change default AgentX target from 0.0.0.0:705 to localhost:705
+      - Fix CVE-2008-4309 (GETBULK issue reported by Oscar Mira-Sanchez)
+      - Fix handling of multiple matching VACM entries
+        (Use the "best" match, rather than the first one).
+            Note that this could potentially affect the behaviour of
+            existing access control configurations.
+      - Latch large-disk statistics at 2Tb (rather than wrapping)
+
+    Linux:
+      - Fix build on modern distributions (using rpm-4.6)
+
+    Windows:
+      - Fix various builds (recent MSVC, MinGW, IPv6, winExtDLL)
+
 
 *5.4.2*
+
     snmplib:
       - [PATCH 1921861]: Avoid endless loop after truncating 64bit int
       - Better handling of CONTAINER_INSERT failures with multiple indices

=== modified file 'README'
--- README	2009-11-12 16:17:40 +0000
+++ README	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-	       README file for net-snmp Version: 5.4.2.1
+	       README file for net-snmp Version: 5.4.3
 
 DISCLAIMER
 
@@ -349,6 +349,7 @@
     Peter Martin <pnmartin@users.sourceforge.net>
     Thomas Lackey <telackey@users.sourceforge.net>
     Joe Buehler <jbuehler@spirentcom.com>
+    Bart Van Assche <bart.vanassche@gmail.com>
 
   We've probably forgotten people on this list.  Let us know if you've
   contributed code and we've left you out.

=== modified file 'README.solaris'
--- README.solaris	2007-12-08 14:59:50 +0000
+++ README.solaris	2010-06-10 18:02:54 +0000
@@ -1,5 +1,5 @@
 README.solaris
-$Id: README.solaris 16569 2007-06-29 22:18:27Z tanders $
+$Id: README.solaris 17763 2009-09-22 21:51:42Z tanders $
 
 This document describes issues relating to compiling,
 installing and using net-snmp on Solaris.
@@ -214,7 +214,7 @@
       smux mibII/mta_sendmail" --with-cc=gcc
 
 (note, see the long discussion about Perl below)
-(note, subtitute "cc" for "gcc" as appropriate)
+(note, substitute "cc" for "gcc" as appropriate)
 (note, for LM-SENSORS-MIB support, see discussion below)
 
 then call this script from the net-snmp directory ie ../bcc.sh
@@ -672,8 +672,7 @@
 xstatus=1
 
 and save the file.  Sometime in the next 60 seconds, a trap will be generated.
-Change the value
-back to 0, then modify another file.
+Change the value back to 0, then modify another file.
 
 If you are unsure of the correct row number within a specific table, do an snmpwalk eg.
 
@@ -1143,7 +1142,7 @@
 in net-snmp 5.4 and later. If you still have problems, please let us know
 and consider:
 
-- installing GNU sed and putting in in front of your PATH
+- installing GNU sed and putting it in front of your PATH
 - installing the available Sun patches for the various sed versions
   (/usr/bin/sed, /usr/xpg4/bin/sed, /usr/ucb/sed)
 - try the suggestions below

=== modified file 'README.win32'
--- README.win32	2009-11-12 16:17:40 +0000
+++ README.win32	2010-06-10 18:02:54 +0000
@@ -70,7 +70,7 @@
 
   -  All Visual Studio project (.dsp) files are cleaned, and 
      a) Generate code to use Multi-Threaded DLL (/MD) "C" run-time library;
-     b) Provide the same preprocesor defines (WIN32,_CONSOLE,_MBCS);
+     b) Provide the same preprocessor defines (WIN32,_CONSOLE,_MBCS);
      c) Remove unnecessary references to GDI, ODBC, and "C" libraries;
      d) Debug versions build source browsing and debugging information;
      e) Provide consistent include search paths.
@@ -135,17 +135,18 @@
 Limitations
 -----------
 
-- For an unknown reason, linkUp/Down generic traps are not received from the 
-  Windows SNMP RFC1156Agent extension.  The DLL has an exported function called
-  Mib2DLLEntry, but the use for this function is not known so this may or may 
-  not be related.  Other extensions are able to send traps without any issues.
-
 - When using HP Insight Agents, some parts of the enterprises.232 tree are not
   accessible.  The cause of this is not known.
 
-- sysUpTime.0 does not report the correct uptime for the agent.  This is
-  because the Windows extension checks for the uptime of the SNMP service,
-  which is not running when Net-SNMP is running.
+- When using winExtDLL, there is an offset of up to one second between the
+  value of the sysUpTime varbind included in the traps generated by SNMP
+  extension DLLs (e.g. linkUp and linkDown) and the value of the sysUpTime
+  varbind included in traps generated by Net-SNMP itself (e.g. coldStart).
+ 
+- When using winExtDLL, hrSystemUptime.0 reports the system uptime in thousands
+  of a second instead of hundreds of a second. This is well known behavior of
+  the Microsoft DLL that implements this MIB object. For more information,
+  see also https://connect.microsoft.com/onecare/feedback/ViewFeedback.aspx?FeedbackID=504908.
 
 
 Enabling the Windows SNMP extension agents
@@ -188,7 +189,7 @@
 service and then run snmpd.exe from the command line with winExtDLL 
 debugging enabled using (all on one line):
 
- snmpd.exe -I-udp,udpTable,tcp,tcpTable,icmp,ip,interfaces,system_mib,
+ snmpd.exe -Lo -I-udp,udpTable,tcp,tcpTable,icmp,ip,interfaces,system_mib,
  sysORTable -DwinExtDLL
 
 The Windows DLL snmpmib.dll (SNMPMIB) contains SNMP traffic statistics
@@ -234,7 +235,7 @@
 Compiling Net-SNMP with the winExtDLL extension (MSVC)
 ------------------------------------------------------
 
-Microsoft PSDK required.
+When building with MSVC 6, the Microsoft Platform SDK is required.
 
 Configure / nmake:
 
@@ -242,29 +243,10 @@
 
 Workspace:
 
--modify win32\net-snmp\net-snmp-config.h and add:
+-in file win32\net-snmp\net-snmp-config.h modify
+ /* #undef USING_WINEXTDLL_MODULE */ into the following:
  #define USING_WINEXTDLL_MODULE 1
 
--modify win32\netsnmpmibssdk\netsnmpmibssdk.dsp:
- uncomment winExtDLL lines
-
- add to lines that contain # ADD LIB32 (line that contains iphlpapi.lib): 
-  MgmtAPI.lib snmpapi.lib 
- 
- add near the bottom of the file:
-
-  # Begin Source File
-
-  SOURCE=..\..\agent\mibgroup\winExtDLL.c
-  # End Source File
-
-
--This extension requires the PSDK including the Snmp.h header file.
- Including Snmp.h will conflict with existing Net-SNMP defines for
- ASN_OCTETSTRING etc.  To resolve this, create a copy of Snmp.h in
- the PSDK include/ folder called Snmp-winExtDLL.h and change all
- occurances of ASN_ to MS_ASN_
-
 
 ***************************************************************************
 *
@@ -281,7 +263,7 @@
 default TCP/IP port of 162.
 
 It is not a requirement to install the Net-SNMP agent (snmpd) or trap receiver
-(snmptrapd).  All the command line utilties such as snmpget.exe, snmpset.exe 
+(snmptrapd).  All the command line utilities such as snmpget.exe, snmpset.exe 
 and the Perl modules will work without the Net-SNMP services.  All the 
 utilities will work against any SNMP agent.
 
@@ -368,7 +350,7 @@
             The above will enable proxy, pass and pass_persist support.  See the
             snmpd man page for more information on the -I switch.
  
-            If you are forwarding a section of the tree that is not immplemented
+            If you are forwarding a section of the tree that is not implemented
             in Net-SNMP such as 'host', you do not need to use the -I switch as
             Net-SNMP will forward the request.  This may cause issues in the 
             future if newer versions of Net-SNMP implement the section of the
@@ -1296,7 +1278,7 @@
 
 ./configure \
 	--with-mib-modules="host agentx disman/event-mib examples/example" \
-	--with-out-mib-modules=host/hr_network --with-libs="-lws2_32" \
+	--with-out-mib-modules=host/hr_network \
         --disable-embedded-perl --without-perl-modules \
 
 If you want to use SNMPv3 auth and privacy features, add:
@@ -1378,8 +1360,9 @@
 	--with-mib-modules="agentx disman/event-mib examples/example" \
         --disable-embedded-perl --without-perl-modules \
 
-    [Sorry. the host resources MIB is not supported by MinGW]
-
+    Note: while the Net-SNMP implementation of the host resources MIB is not
+    supported when using MinGW, winExtDLL is supported. Via winExtDLL you can
+    use Microsoft's implementation of the host resources MIB.
 
 4.1. If you want to use IPv6 transports, add:
 	--enable-ipv6 --with-transports="TCPIPv6 UDPIPv6" \
@@ -1756,5 +1739,5 @@
 
 David Perkins, Joe Marzot, Wes Hardaker, Niels Baggesen, Dave Shield,
 Robert Story, Suvrit Sra, Mike Slifcak, Latha Prabhu, Nikolai Devereaux,
-Alex Burger, Bernhard Penz, and Andy Smith.
+Alex Burger, Bernhard Penz, Andy Smith and Bart Van Assche.
 

=== modified file 'aclocal.m4'
--- aclocal.m4	2009-11-12 16:17:40 +0000
+++ aclocal.m4	2010-06-10 18:02:54 +0000
@@ -444,7 +444,7 @@
 if test "X${echo_test_string+set}" != Xset; then
 # find a string as large as possible, as long as the shell can cope with it
   for cmd in 'sed 50q "[$]0"' 'sed 20q "[$]0"' 'sed 10q "[$]0"' 'sed 2q "[$]0"' 'echo test'; do
-    # expected sizes: less than 2Kb, 1Kb, 512 bytes, 16 bytes, ...
+    # expected sizes: less than 2kB, 1kB, 512 bytes, 16 bytes, ...
     if (echo_test_string=`eval $cmd`) 2>/dev/null &&
        echo_test_string=`eval $cmd` &&
        (test "X$echo_test_string" = "X$echo_test_string") 2>/dev/null

=== modified file 'agent/Makefile.depend'
--- agent/Makefile.depend	2009-11-12 16:17:40 +0000
+++ agent/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -6,7 +6,7 @@
 ./agent_handler.lo: ../include/net-snmp/system/generic.h
 ./agent_handler.lo: ../include/net-snmp/machine/generic.h
 ./agent_handler.lo: ../include/net-snmp/net-snmp-includes.h
-./agent_handler.lo:  ../include/net-snmp/definitions.h
+./agent_handler.lo: ../include/net-snmp/definitions.h
 ./agent_handler.lo: ../include/net-snmp/types.h 
 ./agent_handler.lo: ../include/net-snmp/library/snmp_api.h
 ./agent_handler.lo: ../include/net-snmp/library/asn1.h
@@ -1357,13 +1357,244 @@
 ./snmp_agent.lo: ../agent/mibgroup/agentx/protocol.h
 ./snmp_agent.lo: ../agent/mibgroup/agentx/master.h
 ./snmp_agent.lo: ../agent/mibgroup/smux/smux.h
+./snmpd.lo: ../include/net-snmp/net-snmp-config.h
+./snmpd.lo: ../include/net-snmp/system/linux.h
+./snmpd.lo: ../include/net-snmp/system/sysv.h
+./snmpd.lo: ../include/net-snmp/system/generic.h
+./snmpd.lo: ../include/net-snmp/machine/generic.h 
+./snmpd.lo: ../include/net-snmp/net-snmp-includes.h
+./snmpd.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
+./snmpd.lo:  ../include/net-snmp/library/snmp_api.h
+./snmpd.lo: ../include/net-snmp/library/asn1.h
+./snmpd.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpd.lo: ../include/net-snmp/library/snmp.h
+./snmpd.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpd.lo: ../include/net-snmp/utilities.h
+./snmpd.lo: ../include/net-snmp/library/snmp_client.h
+./snmpd.lo: ../include/net-snmp/library/system.h
+./snmpd.lo: ../include/net-snmp/library/tools.h
+./snmpd.lo: ../include/net-snmp/library/int64.h
+./snmpd.lo: ../include/net-snmp/library/mt_support.h
+./snmpd.lo: ../include/net-snmp/library/snmp_alarm.h
+./snmpd.lo: ../include/net-snmp/library/callback.h
+./snmpd.lo: ../include/net-snmp/library/data_list.h
+./snmpd.lo: ../include/net-snmp/library/oid_stash.h
+./snmpd.lo: ../include/net-snmp/library/check_varbind.h
+./snmpd.lo: ../include/net-snmp/library/container.h
+./snmpd.lo: ../include/net-snmp/library/factory.h
+./snmpd.lo: ../include/net-snmp/library/snmp_logging.h 
+./snmpd.lo: ../include/net-snmp/library/container_binary_array.h
+./snmpd.lo: ../include/net-snmp/library/container_list_ssll.h
+./snmpd.lo: ../include/net-snmp/library/container_iterator.h
+./snmpd.lo: ../include/net-snmp/library/container.h
+./snmpd.lo: ../include/net-snmp/library/snmp_assert.h
+./snmpd.lo: ../include/net-snmp/version.h ../include/net-snmp/session_api.h
+./snmpd.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpd.lo: ../include/net-snmp/library/snmp_service.h
+./snmpd.lo: ../include/net-snmp/library/snmpCallbackDomain.h
+./snmpd.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./snmpd.lo:  ../include/net-snmp/library/snmpUDPDomain.h
+./snmpd.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./snmpd.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./snmpd.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
+./snmpd.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./snmpd.lo: ../include/net-snmp/library/ucd_compat.h
+./snmpd.lo: ../include/net-snmp/pdu_api.h ../include/net-snmp/mib_api.h
+./snmpd.lo: ../include/net-snmp/library/mib.h
+./snmpd.lo: ../include/net-snmp/library/parse.h
+./snmpd.lo: ../include/net-snmp/varbind_api.h
+./snmpd.lo: ../include/net-snmp/config_api.h
+./snmpd.lo: ../include/net-snmp/library/read_config.h
+./snmpd.lo: ../include/net-snmp/library/default_store.h
+./snmpd.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpd.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpd.lo: ../include/net-snmp/library/vacm.h
+./snmpd.lo: ../include/net-snmp/output_api.h
+./snmpd.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpd.lo: ../include/net-snmp/snmpv3_api.h
+./snmpd.lo: ../include/net-snmp/library/snmpv3.h
+./snmpd.lo: ../include/net-snmp/library/transform_oids.h
+./snmpd.lo: ../include/net-snmp/library/keytools.h
+./snmpd.lo: ../include/net-snmp/library/scapi.h
+./snmpd.lo: ../include/net-snmp/library/lcd_time.h
+./snmpd.lo: ../include/net-snmp/library/snmp_secmod.h
+./snmpd.lo: ../include/net-snmp/library/snmpv3-security-includes.h
+./snmpd.lo: ../include/net-snmp/library/snmpusm.h
+./snmpd.lo: ../include/net-snmp/agent/net-snmp-agent-includes.h
+./snmpd.lo: ../include/net-snmp/agent/mib_module_config.h
+./snmpd.lo: ../include/net-snmp/agent/agent_module_config.h
+./snmpd.lo: ../include/net-snmp/agent/snmp_agent.h
+./snmpd.lo: ../include/net-snmp/agent/snmp_vars.h
+./snmpd.lo: ../include/net-snmp/agent/agent_handler.h
+./snmpd.lo: ../include/net-snmp/agent/var_struct.h
+./snmpd.lo: ../include/net-snmp/agent/agent_registry.h
+./snmpd.lo: ../include/net-snmp/library/fd_event_manager.h
+./snmpd.lo: ../include/net-snmp/agent/ds_agent.h
+./snmpd.lo: ../include/net-snmp/agent/agent_read_config.h
+./snmpd.lo: ../include/net-snmp/agent/agent_trap.h
+./snmpd.lo: ../include/net-snmp/agent/all_helpers.h
+./snmpd.lo: ../include/net-snmp/agent/instance.h
+./snmpd.lo: ../include/net-snmp/agent/baby_steps.h
+./snmpd.lo: ../include/net-snmp/agent/scalar.h
+./snmpd.lo: ../include/net-snmp/agent/scalar_group.h
+./snmpd.lo: ../include/net-snmp/agent/watcher.h
+./snmpd.lo: ../include/net-snmp/agent/multiplexer.h
+./snmpd.lo: ../include/net-snmp/agent/null.h
+./snmpd.lo: ../include/net-snmp/agent/debug_handler.h
+./snmpd.lo: ../include/net-snmp/agent/cache_handler.h
+./snmpd.lo: ../include/net-snmp/agent/old_api.h
+./snmpd.lo: ../include/net-snmp/agent/read_only.h
+./snmpd.lo: ../include/net-snmp/agent/row_merge.h
+./snmpd.lo: ../include/net-snmp/agent/serialize.h
+./snmpd.lo: ../include/net-snmp/agent/bulk_to_next.h
+./snmpd.lo: ../include/net-snmp/agent/mode_end_call.h
+./snmpd.lo: ../include/net-snmp/agent/table.h
+./snmpd.lo: ../include/net-snmp/agent/table_data.h
+./snmpd.lo: ../include/net-snmp/agent/table_dataset.h
+./snmpd.lo: ../include/net-snmp/agent/table_tdata.h
+./snmpd.lo: ../include/net-snmp/agent/table_iterator.h
+./snmpd.lo: ../include/net-snmp/agent/table_container.h
+./snmpd.lo: ../include/net-snmp/agent/table_array.h
+./snmpd.lo: ../include/net-snmp/agent/mfd.h m2m.h snmpd.h mibgroup/struct.h
+./snmpd.lo: ../include/net-snmp/agent/mib_modules.h mibgroup/util_funcs.h
+./snmpd.lo: mibgroup/struct.h ../agent/mibgroup/mib_module_includes.h
+./snmpd.lo: mibgroup/examples/example.h mibgroup/testhandler.h
+./snmpd.lo: mibgroup/host/hr_system.h mibgroup/host/hr_storage.h
+./snmpd.lo: mibgroup/host/hr_device.h mibgroup/host/hr_other.h
+./snmpd.lo: mibgroup/host/hr_proc.h mibgroup/host/hr_network.h
+./snmpd.lo: mibgroup/host/hr_print.h mibgroup/host/hr_disk.h
+./snmpd.lo: mibgroup/host/hr_partition.h mibgroup/host/hr_filesys.h
+./snmpd.lo: mibgroup/host/hr_swrun.h mibgroup/host/hr_swinst.h
+./snmpd.lo: mibgroup/examples/scalar_int.h mibgroup/examples/watched.h
+./snmpd.lo: mibgroup/examples/data_set.h mibgroup/examples/delayed_instance.h
+./snmpd.lo: mibgroup/Rmon/rows.h mibgroup/Rmon/agutil.h
+./snmpd.lo: mibgroup/Rmon/statistics.h mibgroup/Rmon/alarm.h
+./snmpd.lo: mibgroup/Rmon/history.h mibgroup/Rmon/event.h
+./snmpd.lo: mibgroup/disman/event/mteScalars.h
+./snmpd.lo: mibgroup/disman/event/mteTrigger.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerTable.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerDeltaTable.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerExistenceTable.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerBooleanTable.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerThresholdTable.h
+./snmpd.lo: mibgroup/disman/event/mteTriggerConf.h
+./snmpd.lo: mibgroup/disman/event/mteEvent.h
+./snmpd.lo: ../agent/mibgroup/disman/event/mteTrigger.h
+./snmpd.lo: mibgroup/disman/event/mteEventTable.h
+./snmpd.lo: mibgroup/disman/event/mteEventSetTable.h
+./snmpd.lo: mibgroup/disman/event/mteEventNotificationTable.h
+./snmpd.lo: mibgroup/disman/event/mteEventConf.h
+./snmpd.lo: mibgroup/disman/event/mteObjects.h
+./snmpd.lo: mibgroup/disman/event/mteObjectsTable.h
+./snmpd.lo: mibgroup/disman/event/mteObjectsConf.h
+./snmpd.lo: mibgroup/snmpv3/snmpEngine.h mibgroup/snmpv3/snmpMPDStats.h
+./snmpd.lo: mibgroup/snmpv3/usmStats.h mibgroup/snmpv3/usmUser.h
+./snmpd.lo: mibgroup/mibII/system_mib.h mibgroup/mibII/sysORTable.h
+./snmpd.lo: mibgroup/mibII/at.h mibgroup/mibII/ip.h
+./snmpd.lo: mibgroup/mibII/var_route.h mibgroup/mibII/route_write.h
+./snmpd.lo: mibgroup/mibII/at.h mibgroup/mibII/snmp_mib.h
+./snmpd.lo: mibgroup/mibII/tcp.h mibgroup/mibII/icmp.h mibgroup/mibII/udp.h
+./snmpd.lo: mibgroup/mibII/vacm_vars.h mibgroup/mibII/setSerialNo.h
+./snmpd.lo: mibgroup/mibII/ipv6.h mibgroup/ucd-snmp/proc.h
+./snmpd.lo: ../agent/mibgroup/mibdefs.h mibgroup/ucd-snmp/versioninfo.h
+./snmpd.lo: mibgroup/ucd-snmp/pass.h mibgroup/ucd-snmp/pass_persist.h
+./snmpd.lo: mibgroup/ucd-snmp/disk.h mibgroup/ucd-snmp/loadave.h
+./snmpd.lo: mibgroup/agent/extend.h mibgroup/ucd-snmp/errormib.h
+./snmpd.lo: mibgroup/ucd-snmp/file.h mibgroup/ucd-snmp/dlmod.h
+./snmpd.lo: mibgroup/ucd-snmp/proxy.h mibgroup/ucd-snmp/logmatch.h
+./snmpd.lo:  mibgroup/ucd-snmp/memory.h
+./snmpd.lo: mibgroup/ucd-snmp/vmstat.h
+./snmpd.lo: mibgroup/notification/snmpNotifyTable.h
+./snmpd.lo: mibgroup/notification/snmpNotifyFilterProfileTable.h
+./snmpd.lo: mibgroup/notification-log-mib/notification_log.h
+./snmpd.lo: mibgroup/target/snmpTargetAddrEntry.h
+./snmpd.lo: mibgroup/target/snmpTargetParamsEntry.h
+./snmpd.lo: mibgroup/target/target_counters.h
+./snmpd.lo: mibgroup/agent/nsTransactionTable.h
+./snmpd.lo: mibgroup/agent/nsModuleTable.h mibgroup/agent/nsDebug.h
+./snmpd.lo: mibgroup/agent/nsCache.h mibgroup/agent/nsLogging.h
+./snmpd.lo: mibgroup/agent/nsVacmAccessTable.h
+./snmpd.lo: mibgroup/disman/schedule/schedCore.h
+./snmpd.lo: mibgroup/disman/schedule/schedConf.h
+./snmpd.lo: mibgroup/disman/schedule/schedTable.h
+./snmpd.lo: mibgroup/utilities/override.h mibgroup/hardware/memory/hw_mem.h
+./snmpd.lo: mibgroup/hardware/cpu/cpu.h mibgroup/hardware/cpu/cpu_linux.h
+./snmpd.lo: mibgroup/mibII/var_route.h mibgroup/mibII/tcpTable.h
+./snmpd.lo: mibgroup/mibII/udpTable.h mibgroup/mibII/vacm_context.h
+./snmpd.lo: mibgroup/ip-mib/ip_scalars.h
+./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable.h
+./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_constants.h
+./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_interface.h
+./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable.h
+./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_data_access.h
+./snmpd.lo: mibgroup/if-mib/ifTable/ifTable.h
+./snmpd.lo: ../include/net-snmp/data_access/interface.h
+./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_constants.h
+./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_interface.h
+./snmpd.lo: mibgroup/if-mib/ifTable/ifTable.h
+./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_data_access.h
+./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable.h
+./snmpd.lo: ../agent/mibgroup/if-mib/ifTable/ifTable.h
+./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_constants.h
+./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_interface.h
+./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable.h
+./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_data_access.h
+./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable.h
+./snmpd.lo: ../include/net-snmp/data_access/ipaddress.h
+./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_constants.h
+./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_interface.h
+./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable.h
+./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_data_access.h
+./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable.h
+./snmpd.lo: ../include/net-snmp/data_access/arp.h
+./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_constants.h
+./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_interface.h
+./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable.h
+./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_data_access.h
+./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable.h
+./snmpd.lo: ../include/net-snmp/data_access/ipstats.h
+./snmpd.lo: ../include/net-snmp/data_access/systemstats.h
+./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_constants.h
+./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_interface.h
+./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable.h
+./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_data_access.h
+./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable.h
+./snmpd.lo: ../include/net-snmp/data_access/route.h
+./snmpd.lo: ../agent/mibgroup/mibII/route_headers.h 
+./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_constants.h
+./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.h
+./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable.h
+./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_data_access.h
+./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable.h
+./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_constants.h
+./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_interface.h
+./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable.h
+./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_data_access.h
+./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.h
+./snmpd.lo: ../include/net-snmp/data_access/tcpConn.h
+./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_constants.h
+./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_interface.h
+./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.h
+./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.h
+./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.h
+./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_constants.h
+./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_interface.h
+./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.h
+./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.h
+./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable.h
+./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_constants.h
+./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_interface.h
+./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable.h
+./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.h
+./snmpd.lo: mibgroup/if-mib/data_access/interface.h mibgroup/smux/smux.h
 ./snmp_perl.lo: ../include/net-snmp/net-snmp-config.h
 ./snmp_perl.lo: ../include/net-snmp/system/linux.h
 ./snmp_perl.lo: ../include/net-snmp/system/sysv.h
 ./snmp_perl.lo: ../include/net-snmp/system/generic.h
 ./snmp_perl.lo: ../include/net-snmp/machine/generic.h
 ./snmp_perl.lo: ../include/net-snmp/net-snmp-includes.h 
-./snmp_perl.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
+./snmp_perl.lo:  ../include/net-snmp/definitions.h
+./snmp_perl.lo: ../include/net-snmp/types.h 
 ./snmp_perl.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_perl.lo: ../include/net-snmp/library/asn1.h
 ./snmp_perl.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1696,236 +1927,6 @@
 ./snmp_vars.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.h
 ./snmp_vars.lo: mibgroup/if-mib/data_access/interface.h
 ./snmp_vars.lo: ../agent/mibgroup/agent_module_inits.h
-./snmpd.lo: ../include/net-snmp/net-snmp-config.h
-./snmpd.lo: ../include/net-snmp/system/linux.h
-./snmpd.lo: ../include/net-snmp/system/sysv.h
-./snmpd.lo: ../include/net-snmp/system/generic.h
-./snmpd.lo: ../include/net-snmp/machine/generic.h 
-./snmpd.lo: ../include/net-snmp/net-snmp-includes.h
-./snmpd.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
-./snmpd.lo:  ../include/net-snmp/library/snmp_api.h
-./snmpd.lo: ../include/net-snmp/library/asn1.h
-./snmpd.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpd.lo: ../include/net-snmp/library/snmp.h
-./snmpd.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpd.lo: ../include/net-snmp/utilities.h
-./snmpd.lo: ../include/net-snmp/library/snmp_client.h
-./snmpd.lo: ../include/net-snmp/library/system.h
-./snmpd.lo: ../include/net-snmp/library/tools.h
-./snmpd.lo: ../include/net-snmp/library/int64.h
-./snmpd.lo: ../include/net-snmp/library/mt_support.h
-./snmpd.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmpd.lo: ../include/net-snmp/library/callback.h
-./snmpd.lo: ../include/net-snmp/library/data_list.h
-./snmpd.lo: ../include/net-snmp/library/oid_stash.h
-./snmpd.lo: ../include/net-snmp/library/check_varbind.h
-./snmpd.lo: ../include/net-snmp/library/container.h
-./snmpd.lo: ../include/net-snmp/library/factory.h
-./snmpd.lo: ../include/net-snmp/library/snmp_logging.h 
-./snmpd.lo: ../include/net-snmp/library/container_binary_array.h
-./snmpd.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmpd.lo: ../include/net-snmp/library/container_iterator.h
-./snmpd.lo: ../include/net-snmp/library/container.h
-./snmpd.lo: ../include/net-snmp/library/snmp_assert.h
-./snmpd.lo: ../include/net-snmp/version.h ../include/net-snmp/session_api.h
-./snmpd.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpd.lo: ../include/net-snmp/library/snmp_service.h
-./snmpd.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./snmpd.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./snmpd.lo:  ../include/net-snmp/library/snmpUDPDomain.h
-./snmpd.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./snmpd.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmpd.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./snmpd.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./snmpd.lo: ../include/net-snmp/library/ucd_compat.h
-./snmpd.lo: ../include/net-snmp/pdu_api.h ../include/net-snmp/mib_api.h
-./snmpd.lo: ../include/net-snmp/library/mib.h
-./snmpd.lo: ../include/net-snmp/library/parse.h
-./snmpd.lo: ../include/net-snmp/varbind_api.h
-./snmpd.lo: ../include/net-snmp/config_api.h
-./snmpd.lo: ../include/net-snmp/library/read_config.h
-./snmpd.lo: ../include/net-snmp/library/default_store.h
-./snmpd.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpd.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpd.lo: ../include/net-snmp/library/vacm.h
-./snmpd.lo: ../include/net-snmp/output_api.h
-./snmpd.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpd.lo: ../include/net-snmp/snmpv3_api.h
-./snmpd.lo: ../include/net-snmp/library/snmpv3.h
-./snmpd.lo: ../include/net-snmp/library/transform_oids.h
-./snmpd.lo: ../include/net-snmp/library/keytools.h
-./snmpd.lo: ../include/net-snmp/library/scapi.h
-./snmpd.lo: ../include/net-snmp/library/lcd_time.h
-./snmpd.lo: ../include/net-snmp/library/snmp_secmod.h
-./snmpd.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./snmpd.lo: ../include/net-snmp/library/snmpusm.h
-./snmpd.lo: ../include/net-snmp/agent/net-snmp-agent-includes.h
-./snmpd.lo: ../include/net-snmp/agent/mib_module_config.h
-./snmpd.lo: ../include/net-snmp/agent/agent_module_config.h
-./snmpd.lo: ../include/net-snmp/agent/snmp_agent.h
-./snmpd.lo: ../include/net-snmp/agent/snmp_vars.h
-./snmpd.lo: ../include/net-snmp/agent/agent_handler.h
-./snmpd.lo: ../include/net-snmp/agent/var_struct.h
-./snmpd.lo: ../include/net-snmp/agent/agent_registry.h
-./snmpd.lo: ../include/net-snmp/library/fd_event_manager.h
-./snmpd.lo: ../include/net-snmp/agent/ds_agent.h
-./snmpd.lo: ../include/net-snmp/agent/agent_read_config.h
-./snmpd.lo: ../include/net-snmp/agent/agent_trap.h
-./snmpd.lo: ../include/net-snmp/agent/all_helpers.h
-./snmpd.lo: ../include/net-snmp/agent/instance.h
-./snmpd.lo: ../include/net-snmp/agent/baby_steps.h
-./snmpd.lo: ../include/net-snmp/agent/scalar.h
-./snmpd.lo: ../include/net-snmp/agent/scalar_group.h
-./snmpd.lo: ../include/net-snmp/agent/watcher.h
-./snmpd.lo: ../include/net-snmp/agent/multiplexer.h
-./snmpd.lo: ../include/net-snmp/agent/null.h
-./snmpd.lo: ../include/net-snmp/agent/debug_handler.h
-./snmpd.lo: ../include/net-snmp/agent/cache_handler.h
-./snmpd.lo: ../include/net-snmp/agent/old_api.h
-./snmpd.lo: ../include/net-snmp/agent/read_only.h
-./snmpd.lo: ../include/net-snmp/agent/row_merge.h
-./snmpd.lo: ../include/net-snmp/agent/serialize.h
-./snmpd.lo: ../include/net-snmp/agent/bulk_to_next.h
-./snmpd.lo: ../include/net-snmp/agent/mode_end_call.h
-./snmpd.lo: ../include/net-snmp/agent/table.h
-./snmpd.lo: ../include/net-snmp/agent/table_data.h
-./snmpd.lo: ../include/net-snmp/agent/table_dataset.h
-./snmpd.lo: ../include/net-snmp/agent/table_tdata.h
-./snmpd.lo: ../include/net-snmp/agent/table_iterator.h
-./snmpd.lo: ../include/net-snmp/agent/table_container.h
-./snmpd.lo: ../include/net-snmp/agent/table_array.h
-./snmpd.lo: ../include/net-snmp/agent/mfd.h m2m.h snmpd.h mibgroup/struct.h
-./snmpd.lo: ../include/net-snmp/agent/mib_modules.h mibgroup/util_funcs.h
-./snmpd.lo: mibgroup/struct.h ../agent/mibgroup/mib_module_includes.h
-./snmpd.lo: mibgroup/examples/example.h mibgroup/testhandler.h
-./snmpd.lo: mibgroup/host/hr_system.h mibgroup/host/hr_storage.h
-./snmpd.lo: mibgroup/host/hr_device.h mibgroup/host/hr_other.h
-./snmpd.lo: mibgroup/host/hr_proc.h mibgroup/host/hr_network.h
-./snmpd.lo: mibgroup/host/hr_print.h mibgroup/host/hr_disk.h
-./snmpd.lo: mibgroup/host/hr_partition.h mibgroup/host/hr_filesys.h
-./snmpd.lo: mibgroup/host/hr_swrun.h mibgroup/host/hr_swinst.h
-./snmpd.lo: mibgroup/examples/scalar_int.h mibgroup/examples/watched.h
-./snmpd.lo: mibgroup/examples/data_set.h mibgroup/examples/delayed_instance.h
-./snmpd.lo: mibgroup/Rmon/rows.h mibgroup/Rmon/agutil.h
-./snmpd.lo: mibgroup/Rmon/statistics.h mibgroup/Rmon/alarm.h
-./snmpd.lo: mibgroup/Rmon/history.h mibgroup/Rmon/event.h
-./snmpd.lo: mibgroup/disman/event/mteScalars.h
-./snmpd.lo: mibgroup/disman/event/mteTrigger.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerTable.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerDeltaTable.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerExistenceTable.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerBooleanTable.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerThresholdTable.h
-./snmpd.lo: mibgroup/disman/event/mteTriggerConf.h
-./snmpd.lo: mibgroup/disman/event/mteEvent.h
-./snmpd.lo: ../agent/mibgroup/disman/event/mteTrigger.h
-./snmpd.lo: mibgroup/disman/event/mteEventTable.h
-./snmpd.lo: mibgroup/disman/event/mteEventSetTable.h
-./snmpd.lo: mibgroup/disman/event/mteEventNotificationTable.h
-./snmpd.lo: mibgroup/disman/event/mteEventConf.h
-./snmpd.lo: mibgroup/disman/event/mteObjects.h
-./snmpd.lo: mibgroup/disman/event/mteObjectsTable.h
-./snmpd.lo: mibgroup/disman/event/mteObjectsConf.h
-./snmpd.lo: mibgroup/snmpv3/snmpEngine.h mibgroup/snmpv3/snmpMPDStats.h
-./snmpd.lo: mibgroup/snmpv3/usmStats.h mibgroup/snmpv3/usmUser.h
-./snmpd.lo: mibgroup/mibII/system_mib.h mibgroup/mibII/sysORTable.h
-./snmpd.lo: mibgroup/mibII/at.h mibgroup/mibII/ip.h
-./snmpd.lo: mibgroup/mibII/var_route.h mibgroup/mibII/route_write.h
-./snmpd.lo: mibgroup/mibII/at.h mibgroup/mibII/snmp_mib.h
-./snmpd.lo: mibgroup/mibII/tcp.h mibgroup/mibII/icmp.h mibgroup/mibII/udp.h
-./snmpd.lo: mibgroup/mibII/vacm_vars.h mibgroup/mibII/setSerialNo.h
-./snmpd.lo: mibgroup/mibII/ipv6.h mibgroup/ucd-snmp/proc.h
-./snmpd.lo: ../agent/mibgroup/mibdefs.h mibgroup/ucd-snmp/versioninfo.h
-./snmpd.lo: mibgroup/ucd-snmp/pass.h mibgroup/ucd-snmp/pass_persist.h
-./snmpd.lo: mibgroup/ucd-snmp/disk.h mibgroup/ucd-snmp/loadave.h
-./snmpd.lo: mibgroup/agent/extend.h mibgroup/ucd-snmp/errormib.h
-./snmpd.lo: mibgroup/ucd-snmp/file.h mibgroup/ucd-snmp/dlmod.h
-./snmpd.lo: mibgroup/ucd-snmp/proxy.h mibgroup/ucd-snmp/logmatch.h
-./snmpd.lo:  mibgroup/ucd-snmp/memory.h
-./snmpd.lo: mibgroup/ucd-snmp/vmstat.h
-./snmpd.lo: mibgroup/notification/snmpNotifyTable.h
-./snmpd.lo: mibgroup/notification/snmpNotifyFilterProfileTable.h
-./snmpd.lo: mibgroup/notification-log-mib/notification_log.h
-./snmpd.lo: mibgroup/target/snmpTargetAddrEntry.h
-./snmpd.lo: mibgroup/target/snmpTargetParamsEntry.h
-./snmpd.lo: mibgroup/target/target_counters.h
-./snmpd.lo: mibgroup/agent/nsTransactionTable.h
-./snmpd.lo: mibgroup/agent/nsModuleTable.h mibgroup/agent/nsDebug.h
-./snmpd.lo: mibgroup/agent/nsCache.h mibgroup/agent/nsLogging.h
-./snmpd.lo: mibgroup/agent/nsVacmAccessTable.h
-./snmpd.lo: mibgroup/disman/schedule/schedCore.h
-./snmpd.lo: mibgroup/disman/schedule/schedConf.h
-./snmpd.lo: mibgroup/disman/schedule/schedTable.h
-./snmpd.lo: mibgroup/utilities/override.h mibgroup/hardware/memory/hw_mem.h
-./snmpd.lo: mibgroup/hardware/cpu/cpu.h mibgroup/hardware/cpu/cpu_linux.h
-./snmpd.lo: mibgroup/mibII/var_route.h mibgroup/mibII/tcpTable.h
-./snmpd.lo: mibgroup/mibII/udpTable.h mibgroup/mibII/vacm_context.h
-./snmpd.lo: mibgroup/ip-mib/ip_scalars.h
-./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable.h
-./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_constants.h
-./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_interface.h
-./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable.h
-./snmpd.lo: mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_data_access.h
-./snmpd.lo: mibgroup/if-mib/ifTable/ifTable.h
-./snmpd.lo: ../include/net-snmp/data_access/interface.h
-./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_constants.h
-./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_interface.h
-./snmpd.lo: mibgroup/if-mib/ifTable/ifTable.h
-./snmpd.lo: mibgroup/if-mib/ifTable/ifTable_data_access.h
-./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable.h
-./snmpd.lo: ../agent/mibgroup/if-mib/ifTable/ifTable.h
-./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_constants.h
-./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_interface.h
-./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable.h
-./snmpd.lo: mibgroup/if-mib/ifXTable/ifXTable_data_access.h
-./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable.h
-./snmpd.lo: ../include/net-snmp/data_access/ipaddress.h
-./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_constants.h
-./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_interface.h
-./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable.h
-./snmpd.lo: mibgroup/ip-mib/ipAddressTable/ipAddressTable_data_access.h
-./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable.h
-./snmpd.lo: ../include/net-snmp/data_access/arp.h
-./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_constants.h
-./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_interface.h
-./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable.h
-./snmpd.lo: mibgroup/ip-mib/inetNetToMediaTable/inetNetToMediaTable_data_access.h
-./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable.h
-./snmpd.lo: ../include/net-snmp/data_access/ipstats.h
-./snmpd.lo: ../include/net-snmp/data_access/systemstats.h
-./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_constants.h
-./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_interface.h
-./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable.h
-./snmpd.lo: mibgroup/ip-mib/ipSystemStatsTable/ipSystemStatsTable_data_access.h
-./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable.h
-./snmpd.lo: ../include/net-snmp/data_access/route.h
-./snmpd.lo: ../agent/mibgroup/mibII/route_headers.h 
-./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_constants.h
-./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.h
-./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable.h
-./snmpd.lo: mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_data_access.h
-./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable.h
-./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_constants.h
-./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_interface.h
-./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable.h
-./snmpd.lo: mibgroup/ip-forward-mib/inetCidrRouteTable/inetCidrRouteTable_data_access.h
-./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.h
-./snmpd.lo: ../include/net-snmp/data_access/tcpConn.h
-./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_constants.h
-./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_interface.h
-./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.h
-./snmpd.lo: mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.h
-./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.h
-./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_constants.h
-./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_interface.h
-./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.h
-./snmpd.lo: mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.h
-./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable.h
-./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_constants.h
-./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_interface.h
-./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable.h
-./snmpd.lo: mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.h
-./snmpd.lo: mibgroup/if-mib/data_access/interface.h mibgroup/smux/smux.h
 ./helpers/all_helpers.lo: ../include/net-snmp/net-snmp-config.h
 ./helpers/all_helpers.lo: ../include/net-snmp/system/linux.h
 ./helpers/all_helpers.lo: ../include/net-snmp/system/sysv.h
@@ -2748,7 +2749,7 @@
 ./helpers/null.lo: ../include/net-snmp/system/generic.h
 ./helpers/null.lo: ../include/net-snmp/machine/generic.h
 ./helpers/null.lo: ../include/net-snmp/net-snmp-includes.h
-./helpers/null.lo: ../include/net-snmp/definitions.h
+./helpers/null.lo:  ../include/net-snmp/definitions.h
 ./helpers/null.lo: ../include/net-snmp/types.h 
 ./helpers/null.lo: ../include/net-snmp/library/snmp_api.h
 ./helpers/null.lo: ../include/net-snmp/library/asn1.h
@@ -3665,108 +3666,6 @@
 ./helpers/stash_to_next.lo: ../include/net-snmp/agent/mfd.h
 ./helpers/stash_to_next.lo: ../include/net-snmp/agent/stash_cache.h
 ./helpers/stash_to_next.lo: ../include/net-snmp/agent/stash_to_next.h
-./helpers/table.lo: ../include/net-snmp/net-snmp-config.h
-./helpers/table.lo: ../include/net-snmp/system/linux.h
-./helpers/table.lo: ../include/net-snmp/system/sysv.h
-./helpers/table.lo: ../include/net-snmp/system/generic.h
-./helpers/table.lo: ../include/net-snmp/machine/generic.h
-./helpers/table.lo: ../include/net-snmp/net-snmp-includes.h
-./helpers/table.lo:  ../include/net-snmp/definitions.h
-./helpers/table.lo: ../include/net-snmp/types.h 
-./helpers/table.lo: ../include/net-snmp/library/snmp_api.h
-./helpers/table.lo: ../include/net-snmp/library/asn1.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_impl.h
-./helpers/table.lo: ../include/net-snmp/library/snmp.h
-./helpers/table.lo: ../include/net-snmp/library/snmp-tc.h
-./helpers/table.lo: ../include/net-snmp/utilities.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_client.h
-./helpers/table.lo: ../include/net-snmp/library/system.h
-./helpers/table.lo: ../include/net-snmp/library/tools.h
-./helpers/table.lo: ../include/net-snmp/library/int64.h
-./helpers/table.lo: ../include/net-snmp/library/mt_support.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_alarm.h
-./helpers/table.lo: ../include/net-snmp/library/callback.h
-./helpers/table.lo: ../include/net-snmp/library/data_list.h
-./helpers/table.lo: ../include/net-snmp/library/oid_stash.h
-./helpers/table.lo: ../include/net-snmp/library/check_varbind.h
-./helpers/table.lo: ../include/net-snmp/library/container.h
-./helpers/table.lo: ../include/net-snmp/library/factory.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_logging.h
-./helpers/table.lo: ../include/net-snmp/library/container_binary_array.h
-./helpers/table.lo: ../include/net-snmp/library/container_list_ssll.h
-./helpers/table.lo: ../include/net-snmp/library/container_iterator.h
-./helpers/table.lo: ../include/net-snmp/library/container.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_assert.h
-./helpers/table.lo: ../include/net-snmp/version.h
-./helpers/table.lo: ../include/net-snmp/session_api.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_transport.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_service.h
-./helpers/table.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./helpers/table.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./helpers/table.lo: ../include/net-snmp/library/ucd_compat.h
-./helpers/table.lo: ../include/net-snmp/pdu_api.h
-./helpers/table.lo: ../include/net-snmp/mib_api.h
-./helpers/table.lo: ../include/net-snmp/library/mib.h
-./helpers/table.lo: ../include/net-snmp/library/parse.h
-./helpers/table.lo: ../include/net-snmp/varbind_api.h
-./helpers/table.lo: ../include/net-snmp/config_api.h
-./helpers/table.lo: ../include/net-snmp/library/read_config.h
-./helpers/table.lo: ../include/net-snmp/library/default_store.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_parse_args.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_enum.h
-./helpers/table.lo: ../include/net-snmp/library/vacm.h
-./helpers/table.lo: ../include/net-snmp/output_api.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_debug.h
-./helpers/table.lo: ../include/net-snmp/snmpv3_api.h
-./helpers/table.lo: ../include/net-snmp/library/snmpv3.h
-./helpers/table.lo: ../include/net-snmp/library/transform_oids.h
-./helpers/table.lo: ../include/net-snmp/library/keytools.h
-./helpers/table.lo: ../include/net-snmp/library/scapi.h
-./helpers/table.lo: ../include/net-snmp/library/lcd_time.h
-./helpers/table.lo: ../include/net-snmp/library/snmp_secmod.h
-./helpers/table.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./helpers/table.lo: ../include/net-snmp/library/snmpusm.h
-./helpers/table.lo: ../include/net-snmp/agent/net-snmp-agent-includes.h
-./helpers/table.lo: ../include/net-snmp/agent/mib_module_config.h
-./helpers/table.lo: ../include/net-snmp/agent/agent_module_config.h
-./helpers/table.lo: ../include/net-snmp/agent/snmp_agent.h
-./helpers/table.lo: ../include/net-snmp/agent/snmp_vars.h
-./helpers/table.lo: ../include/net-snmp/agent/agent_handler.h
-./helpers/table.lo: ../include/net-snmp/agent/var_struct.h
-./helpers/table.lo: ../include/net-snmp/agent/agent_registry.h
-./helpers/table.lo: ../include/net-snmp/library/fd_event_manager.h
-./helpers/table.lo: ../include/net-snmp/agent/ds_agent.h
-./helpers/table.lo: ../include/net-snmp/agent/agent_read_config.h
-./helpers/table.lo: ../include/net-snmp/agent/agent_trap.h
-./helpers/table.lo: ../include/net-snmp/agent/all_helpers.h
-./helpers/table.lo: ../include/net-snmp/agent/instance.h
-./helpers/table.lo: ../include/net-snmp/agent/baby_steps.h
-./helpers/table.lo: ../include/net-snmp/agent/scalar.h
-./helpers/table.lo: ../include/net-snmp/agent/scalar_group.h
-./helpers/table.lo: ../include/net-snmp/agent/watcher.h
-./helpers/table.lo: ../include/net-snmp/agent/multiplexer.h
-./helpers/table.lo: ../include/net-snmp/agent/null.h
-./helpers/table.lo: ../include/net-snmp/agent/debug_handler.h
-./helpers/table.lo: ../include/net-snmp/agent/cache_handler.h
-./helpers/table.lo: ../include/net-snmp/agent/old_api.h
-./helpers/table.lo: ../include/net-snmp/agent/read_only.h
-./helpers/table.lo: ../include/net-snmp/agent/row_merge.h
-./helpers/table.lo: ../include/net-snmp/agent/serialize.h
-./helpers/table.lo: ../include/net-snmp/agent/bulk_to_next.h
-./helpers/table.lo: ../include/net-snmp/agent/mode_end_call.h
-./helpers/table.lo: ../include/net-snmp/agent/table.h
-./helpers/table.lo: ../include/net-snmp/agent/table_data.h
-./helpers/table.lo: ../include/net-snmp/agent/table_dataset.h
-./helpers/table.lo: ../include/net-snmp/agent/table_tdata.h
-./helpers/table.lo: ../include/net-snmp/agent/table_iterator.h
-./helpers/table.lo: ../include/net-snmp/agent/table_container.h
-./helpers/table.lo: ../include/net-snmp/agent/table_array.h
-./helpers/table.lo: ../include/net-snmp/agent/mfd.h
 ./helpers/table_array.lo: ../include/net-snmp/net-snmp-config.h
 ./helpers/table_array.lo: ../include/net-snmp/system/linux.h
 ./helpers/table_array.lo: ../include/net-snmp/system/sysv.h
@@ -3869,6 +3768,108 @@
 ./helpers/table_array.lo: ../include/net-snmp/agent/table_container.h
 ./helpers/table_array.lo: ../include/net-snmp/agent/table_array.h
 ./helpers/table_array.lo: ../include/net-snmp/agent/mfd.h
+./helpers/table.lo: ../include/net-snmp/net-snmp-config.h
+./helpers/table.lo: ../include/net-snmp/system/linux.h
+./helpers/table.lo: ../include/net-snmp/system/sysv.h
+./helpers/table.lo: ../include/net-snmp/system/generic.h
+./helpers/table.lo: ../include/net-snmp/machine/generic.h
+./helpers/table.lo: ../include/net-snmp/net-snmp-includes.h
+./helpers/table.lo: ../include/net-snmp/definitions.h
+./helpers/table.lo: ../include/net-snmp/types.h 
+./helpers/table.lo: ../include/net-snmp/library/snmp_api.h
+./helpers/table.lo: ../include/net-snmp/library/asn1.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_impl.h
+./helpers/table.lo: ../include/net-snmp/library/snmp.h
+./helpers/table.lo: ../include/net-snmp/library/snmp-tc.h
+./helpers/table.lo: ../include/net-snmp/utilities.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_client.h
+./helpers/table.lo: ../include/net-snmp/library/system.h
+./helpers/table.lo: ../include/net-snmp/library/tools.h
+./helpers/table.lo: ../include/net-snmp/library/int64.h
+./helpers/table.lo: ../include/net-snmp/library/mt_support.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_alarm.h
+./helpers/table.lo: ../include/net-snmp/library/callback.h
+./helpers/table.lo: ../include/net-snmp/library/data_list.h
+./helpers/table.lo: ../include/net-snmp/library/oid_stash.h
+./helpers/table.lo: ../include/net-snmp/library/check_varbind.h
+./helpers/table.lo: ../include/net-snmp/library/container.h
+./helpers/table.lo: ../include/net-snmp/library/factory.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_logging.h
+./helpers/table.lo: ../include/net-snmp/library/container_binary_array.h
+./helpers/table.lo: ../include/net-snmp/library/container_list_ssll.h
+./helpers/table.lo: ../include/net-snmp/library/container_iterator.h
+./helpers/table.lo: ../include/net-snmp/library/container.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_assert.h
+./helpers/table.lo: ../include/net-snmp/version.h
+./helpers/table.lo: ../include/net-snmp/session_api.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_transport.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_service.h
+./helpers/table.lo: ../include/net-snmp/library/snmpCallbackDomain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
+./helpers/table.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./helpers/table.lo: ../include/net-snmp/library/ucd_compat.h
+./helpers/table.lo: ../include/net-snmp/pdu_api.h
+./helpers/table.lo: ../include/net-snmp/mib_api.h
+./helpers/table.lo: ../include/net-snmp/library/mib.h
+./helpers/table.lo: ../include/net-snmp/library/parse.h
+./helpers/table.lo: ../include/net-snmp/varbind_api.h
+./helpers/table.lo: ../include/net-snmp/config_api.h
+./helpers/table.lo: ../include/net-snmp/library/read_config.h
+./helpers/table.lo: ../include/net-snmp/library/default_store.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_parse_args.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_enum.h
+./helpers/table.lo: ../include/net-snmp/library/vacm.h
+./helpers/table.lo: ../include/net-snmp/output_api.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_debug.h
+./helpers/table.lo: ../include/net-snmp/snmpv3_api.h
+./helpers/table.lo: ../include/net-snmp/library/snmpv3.h
+./helpers/table.lo: ../include/net-snmp/library/transform_oids.h
+./helpers/table.lo: ../include/net-snmp/library/keytools.h
+./helpers/table.lo: ../include/net-snmp/library/scapi.h
+./helpers/table.lo: ../include/net-snmp/library/lcd_time.h
+./helpers/table.lo: ../include/net-snmp/library/snmp_secmod.h
+./helpers/table.lo: ../include/net-snmp/library/snmpv3-security-includes.h
+./helpers/table.lo: ../include/net-snmp/library/snmpusm.h
+./helpers/table.lo: ../include/net-snmp/agent/net-snmp-agent-includes.h
+./helpers/table.lo: ../include/net-snmp/agent/mib_module_config.h
+./helpers/table.lo: ../include/net-snmp/agent/agent_module_config.h
+./helpers/table.lo: ../include/net-snmp/agent/snmp_agent.h
+./helpers/table.lo: ../include/net-snmp/agent/snmp_vars.h
+./helpers/table.lo: ../include/net-snmp/agent/agent_handler.h
+./helpers/table.lo: ../include/net-snmp/agent/var_struct.h
+./helpers/table.lo: ../include/net-snmp/agent/agent_registry.h
+./helpers/table.lo: ../include/net-snmp/library/fd_event_manager.h
+./helpers/table.lo: ../include/net-snmp/agent/ds_agent.h
+./helpers/table.lo: ../include/net-snmp/agent/agent_read_config.h
+./helpers/table.lo: ../include/net-snmp/agent/agent_trap.h
+./helpers/table.lo: ../include/net-snmp/agent/all_helpers.h
+./helpers/table.lo: ../include/net-snmp/agent/instance.h
+./helpers/table.lo: ../include/net-snmp/agent/baby_steps.h
+./helpers/table.lo: ../include/net-snmp/agent/scalar.h
+./helpers/table.lo: ../include/net-snmp/agent/scalar_group.h
+./helpers/table.lo: ../include/net-snmp/agent/watcher.h
+./helpers/table.lo: ../include/net-snmp/agent/multiplexer.h
+./helpers/table.lo: ../include/net-snmp/agent/null.h
+./helpers/table.lo: ../include/net-snmp/agent/debug_handler.h
+./helpers/table.lo: ../include/net-snmp/agent/cache_handler.h
+./helpers/table.lo: ../include/net-snmp/agent/old_api.h
+./helpers/table.lo: ../include/net-snmp/agent/read_only.h
+./helpers/table.lo: ../include/net-snmp/agent/row_merge.h
+./helpers/table.lo: ../include/net-snmp/agent/serialize.h
+./helpers/table.lo: ../include/net-snmp/agent/bulk_to_next.h
+./helpers/table.lo: ../include/net-snmp/agent/mode_end_call.h
+./helpers/table.lo: ../include/net-snmp/agent/table.h
+./helpers/table.lo: ../include/net-snmp/agent/table_data.h
+./helpers/table.lo: ../include/net-snmp/agent/table_dataset.h
+./helpers/table.lo: ../include/net-snmp/agent/table_tdata.h
+./helpers/table.lo: ../include/net-snmp/agent/table_iterator.h
+./helpers/table.lo: ../include/net-snmp/agent/table_container.h
+./helpers/table.lo: ../include/net-snmp/agent/table_array.h
+./helpers/table.lo: ../include/net-snmp/agent/mfd.h
 ./helpers/table_container.lo: ../include/net-snmp/net-snmp-config.h
 ./helpers/table_container.lo: ../include/net-snmp/system/linux.h
 ./helpers/table_container.lo: ../include/net-snmp/system/sysv.h
@@ -4906,102 +4907,4 @@
 ./mibgroup/winExtDLL.lo: ../include/net-snmp/system/sysv.h
 ./mibgroup/winExtDLL.lo: ../include/net-snmp/system/generic.h
 ./mibgroup/winExtDLL.lo: ../include/net-snmp/machine/generic.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/net-snmp-includes.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/definitions.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/types.h 
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/asn1.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_impl.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp-tc.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/utilities.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_client.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/system.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/tools.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/int64.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/mt_support.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_alarm.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/callback.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/data_list.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/oid_stash.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/check_varbind.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/container.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/factory.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_logging.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/container_binary_array.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/container_list_ssll.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/container_iterator.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/container.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_assert.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/version.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/session_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_transport.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_service.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/ucd_compat.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/pdu_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/mib_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/mib.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/parse.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/varbind_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/config_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/read_config.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/default_store.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_parse_args.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_enum.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/vacm.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/output_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_debug.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/snmpv3_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpv3.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/transform_oids.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/keytools.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/scapi.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/lcd_time.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmp_secmod.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/snmpusm.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/net-snmp-agent-includes.h
 ./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/mib_module_config.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/agent_module_config.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/snmp_agent.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/snmp_vars.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/agent_handler.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/var_struct.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/agent_registry.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/library/fd_event_manager.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/ds_agent.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/agent_read_config.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/agent_trap.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/all_helpers.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/instance.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/baby_steps.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/scalar.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/scalar_group.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/watcher.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/multiplexer.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/null.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/debug_handler.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/cache_handler.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/old_api.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/read_only.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/row_merge.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/serialize.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/bulk_to_next.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/mode_end_call.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_data.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_dataset.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_tdata.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_iterator.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_container.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/table_array.h
-./mibgroup/winExtDLL.lo: ../include/net-snmp/agent/mfd.h
-./mibgroup/winExtDLL.lo: ./mibgroup/util_funcs.h mibgroup/struct.h
-./mibgroup/winExtDLL.lo: ./mibgroup/winExtDLL.h

=== modified file 'agent/agent_handler.c'
--- agent/agent_handler.c	2007-12-08 14:59:50 +0000
+++ agent/agent_handler.c	2010-06-10 18:02:54 +0000
@@ -579,6 +579,10 @@
          *  defined. About 30 functions down the stack, starting
          *  in clear_context() -> clear_subtree()
          */
+        if ((handler->myvoid != NULL) && (handler->data_free != NULL))
+        {
+            handler->data_free(handler->myvoid);
+        }
         SNMP_FREE(handler->handler_name);
         SNMP_FREE(handler);
     }
@@ -600,6 +604,7 @@
 
     if (h != NULL) {
         h->myvoid = handler->myvoid;
+        h->data_free = handler->data_free;
 
         if (handler->next != NULL) {
             h->next = netsnmp_handler_dup(handler->next);
@@ -806,7 +811,7 @@
  *         returned if request is NULL or request->parent_data is NULL or
  *         request->parent_data object is not found.
  */
-NETSNMP_INLINE void    *
+void    *
 netsnmp_request_get_list_data(netsnmp_request_info *request,
                               const char *name)
 {

=== modified file 'agent/agent_registry.c'
--- agent/agent_registry.c	2009-11-12 16:17:40 +0000
+++ agent/agent_registry.c	2010-06-10 18:02:54 +0000
@@ -533,7 +533,7 @@
 	    if (next && (next->namelen  == new_sub->namelen) &&
 		(next->priority == new_sub->priority)) {
                 if (new_sub->namelen != 1) /* ignore root OID dups */
-                    netsnmp_assert(!"registration != duplicate"); /* always false */
+                    snmp_log(LOG_ERR, "duplicate registration (%s, %s)", next->label_a, new_sub->label_a);
 		return MIB_DUPLICATE_REGISTRATION;
 	    }
 

=== modified file 'agent/auto_nlist.c'
--- agent/auto_nlist.c	2009-11-12 16:17:40 +0000
+++ agent/auto_nlist.c	2010-06-10 18:02:54 +0000
@@ -64,6 +64,7 @@
         it->nl[0].n_name = (char *) malloc(strlen(string) + 2);
 #if defined(aix4) || defined(aix5) || defined(aix6)
         strcpy(it->nl[0].n_name, string);
+        it->nl[0].n_name[strlen(string)+1] = '\0';
 #else
         sprintf(it->nl[0].n_name, "_%s", string);
 #endif
@@ -72,6 +73,7 @@
 #if !(defined(aix4) || defined(aix5) || defined(aix6)) 
         if (it->nl[0].n_type == 0) {
             strcpy(it->nl[0].n_name, string);
+            it->nl[0].n_name[strlen(string)+1] = '\0';
             init_nlist(it->nl);
         }
 #endif

=== modified file 'agent/helpers/Makefile.depend'
--- agent/helpers/Makefile.depend	2009-11-12 16:17:40 +0000
+++ agent/helpers/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -516,7 +516,7 @@
 ./instance.lo: ../../include/net-snmp/system/generic.h
 ./instance.lo: ../../include/net-snmp/machine/generic.h 
 ./instance.lo: ../../include/net-snmp/net-snmp-includes.h
-./instance.lo:  ../../include/net-snmp/definitions.h
+./instance.lo: ../../include/net-snmp/definitions.h
 ./instance.lo: ../../include/net-snmp/types.h 
 ./instance.lo: ../../include/net-snmp/library/snmp_api.h
 ./instance.lo: ../../include/net-snmp/library/asn1.h
@@ -822,7 +822,7 @@
 ./null.lo: ../../include/net-snmp/system/generic.h
 ./null.lo: ../../include/net-snmp/machine/generic.h 
 ./null.lo: ../../include/net-snmp/net-snmp-includes.h 
-./null.lo: ../../include/net-snmp/definitions.h
+./null.lo:  ../../include/net-snmp/definitions.h
 ./null.lo: ../../include/net-snmp/types.h 
 ./null.lo: ../../include/net-snmp/library/snmp_api.h
 ./null.lo: ../../include/net-snmp/library/asn1.h
@@ -1229,7 +1229,7 @@
 ./scalar.lo: ../../include/net-snmp/system/sysv.h
 ./scalar.lo: ../../include/net-snmp/system/generic.h
 ./scalar.lo: ../../include/net-snmp/machine/generic.h 
-./scalar.lo:  ../../include/net-snmp/net-snmp-includes.h
+./scalar.lo: ../../include/net-snmp/net-snmp-includes.h 
 ./scalar.lo:  ../../include/net-snmp/definitions.h
 ./scalar.lo: ../../include/net-snmp/types.h 
 ./scalar.lo: ../../include/net-snmp/library/snmp_api.h
@@ -1738,107 +1738,6 @@
 ./stash_to_next.lo: ../../include/net-snmp/agent/mfd.h
 ./stash_to_next.lo: ../../include/net-snmp/agent/stash_cache.h
 ./stash_to_next.lo: ../../include/net-snmp/agent/stash_to_next.h
-./table.lo: ../../include/net-snmp/net-snmp-config.h
-./table.lo: ../../include/net-snmp/system/linux.h
-./table.lo: ../../include/net-snmp/system/sysv.h
-./table.lo: ../../include/net-snmp/system/generic.h
-./table.lo: ../../include/net-snmp/machine/generic.h 
-./table.lo: ../../include/net-snmp/net-snmp-includes.h 
-./table.lo: ../../include/net-snmp/definitions.h
-./table.lo: ../../include/net-snmp/types.h 
-./table.lo: ../../include/net-snmp/library/snmp_api.h
-./table.lo: ../../include/net-snmp/library/asn1.h
-./table.lo: ../../include/net-snmp/library/snmp_impl.h
-./table.lo: ../../include/net-snmp/library/snmp.h
-./table.lo: ../../include/net-snmp/library/snmp-tc.h
-./table.lo: ../../include/net-snmp/utilities.h
-./table.lo: ../../include/net-snmp/library/snmp_client.h
-./table.lo: ../../include/net-snmp/library/system.h
-./table.lo: ../../include/net-snmp/library/tools.h
-./table.lo: ../../include/net-snmp/library/int64.h
-./table.lo: ../../include/net-snmp/library/mt_support.h
-./table.lo: ../../include/net-snmp/library/snmp_alarm.h
-./table.lo: ../../include/net-snmp/library/callback.h
-./table.lo: ../../include/net-snmp/library/data_list.h
-./table.lo: ../../include/net-snmp/library/oid_stash.h
-./table.lo: ../../include/net-snmp/library/check_varbind.h
-./table.lo: ../../include/net-snmp/library/container.h
-./table.lo: ../../include/net-snmp/library/factory.h
-./table.lo: ../../include/net-snmp/library/snmp_logging.h
-./table.lo: ../../include/net-snmp/library/container_binary_array.h
-./table.lo: ../../include/net-snmp/library/container_list_ssll.h
-./table.lo: ../../include/net-snmp/library/container_iterator.h
-./table.lo: ../../include/net-snmp/library/container.h
-./table.lo: ../../include/net-snmp/library/snmp_assert.h
-./table.lo: ../../include/net-snmp/version.h
-./table.lo: ../../include/net-snmp/session_api.h
-./table.lo: ../../include/net-snmp/library/snmp_transport.h
-./table.lo: ../../include/net-snmp/library/snmp_service.h
-./table.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./table.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./table.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./table.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./table.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./table.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./table.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./table.lo: ../../include/net-snmp/library/ucd_compat.h
-./table.lo: ../../include/net-snmp/pdu_api.h ../../include/net-snmp/mib_api.h
-./table.lo: ../../include/net-snmp/library/mib.h
-./table.lo: ../../include/net-snmp/library/parse.h
-./table.lo: ../../include/net-snmp/varbind_api.h
-./table.lo: ../../include/net-snmp/config_api.h
-./table.lo: ../../include/net-snmp/library/read_config.h
-./table.lo: ../../include/net-snmp/library/default_store.h
-./table.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./table.lo: ../../include/net-snmp/library/snmp_enum.h
-./table.lo: ../../include/net-snmp/library/vacm.h
-./table.lo: ../../include/net-snmp/output_api.h
-./table.lo: ../../include/net-snmp/library/snmp_debug.h
-./table.lo: ../../include/net-snmp/snmpv3_api.h
-./table.lo: ../../include/net-snmp/library/snmpv3.h
-./table.lo: ../../include/net-snmp/library/transform_oids.h
-./table.lo: ../../include/net-snmp/library/keytools.h
-./table.lo: ../../include/net-snmp/library/scapi.h
-./table.lo: ../../include/net-snmp/library/lcd_time.h
-./table.lo: ../../include/net-snmp/library/snmp_secmod.h
-./table.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./table.lo: ../../include/net-snmp/library/snmpusm.h
-./table.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./table.lo: ../../include/net-snmp/agent/mib_module_config.h
-./table.lo: ../../include/net-snmp/agent/agent_module_config.h
-./table.lo: ../../include/net-snmp/agent/snmp_agent.h
-./table.lo: ../../include/net-snmp/agent/snmp_vars.h
-./table.lo: ../../include/net-snmp/agent/agent_handler.h
-./table.lo: ../../include/net-snmp/agent/var_struct.h
-./table.lo: ../../include/net-snmp/agent/agent_registry.h
-./table.lo: ../../include/net-snmp/library/fd_event_manager.h
-./table.lo: ../../include/net-snmp/agent/ds_agent.h
-./table.lo: ../../include/net-snmp/agent/agent_read_config.h
-./table.lo: ../../include/net-snmp/agent/agent_trap.h
-./table.lo: ../../include/net-snmp/agent/all_helpers.h
-./table.lo: ../../include/net-snmp/agent/instance.h
-./table.lo: ../../include/net-snmp/agent/baby_steps.h
-./table.lo: ../../include/net-snmp/agent/scalar.h
-./table.lo: ../../include/net-snmp/agent/scalar_group.h
-./table.lo: ../../include/net-snmp/agent/watcher.h
-./table.lo: ../../include/net-snmp/agent/multiplexer.h
-./table.lo: ../../include/net-snmp/agent/null.h
-./table.lo: ../../include/net-snmp/agent/debug_handler.h
-./table.lo: ../../include/net-snmp/agent/cache_handler.h
-./table.lo: ../../include/net-snmp/agent/old_api.h
-./table.lo: ../../include/net-snmp/agent/read_only.h
-./table.lo: ../../include/net-snmp/agent/row_merge.h
-./table.lo: ../../include/net-snmp/agent/serialize.h
-./table.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./table.lo: ../../include/net-snmp/agent/mode_end_call.h
-./table.lo: ../../include/net-snmp/agent/table.h
-./table.lo: ../../include/net-snmp/agent/table_data.h
-./table.lo: ../../include/net-snmp/agent/table_dataset.h
-./table.lo: ../../include/net-snmp/agent/table_tdata.h
-./table.lo: ../../include/net-snmp/agent/table_iterator.h
-./table.lo: ../../include/net-snmp/agent/table_container.h
-./table.lo: ../../include/net-snmp/agent/table_array.h
-./table.lo: ../../include/net-snmp/agent/mfd.h
 ./table_array.lo: ../../include/net-snmp/net-snmp-config.h
 ./table_array.lo: ../../include/net-snmp/system/linux.h
 ./table_array.lo: ../../include/net-snmp/system/sysv.h
@@ -1941,6 +1840,107 @@
 ./table_array.lo: ../../include/net-snmp/agent/table_container.h
 ./table_array.lo: ../../include/net-snmp/agent/table_array.h
 ./table_array.lo: ../../include/net-snmp/agent/mfd.h
+./table.lo: ../../include/net-snmp/net-snmp-config.h
+./table.lo: ../../include/net-snmp/system/linux.h
+./table.lo: ../../include/net-snmp/system/sysv.h
+./table.lo: ../../include/net-snmp/system/generic.h
+./table.lo: ../../include/net-snmp/machine/generic.h 
+./table.lo: ../../include/net-snmp/net-snmp-includes.h 
+./table.lo:  ../../include/net-snmp/definitions.h
+./table.lo: ../../include/net-snmp/types.h 
+./table.lo: ../../include/net-snmp/library/snmp_api.h
+./table.lo: ../../include/net-snmp/library/asn1.h
+./table.lo: ../../include/net-snmp/library/snmp_impl.h
+./table.lo: ../../include/net-snmp/library/snmp.h
+./table.lo: ../../include/net-snmp/library/snmp-tc.h
+./table.lo: ../../include/net-snmp/utilities.h
+./table.lo: ../../include/net-snmp/library/snmp_client.h
+./table.lo: ../../include/net-snmp/library/system.h
+./table.lo: ../../include/net-snmp/library/tools.h
+./table.lo: ../../include/net-snmp/library/int64.h
+./table.lo: ../../include/net-snmp/library/mt_support.h
+./table.lo: ../../include/net-snmp/library/snmp_alarm.h
+./table.lo: ../../include/net-snmp/library/callback.h
+./table.lo: ../../include/net-snmp/library/data_list.h
+./table.lo: ../../include/net-snmp/library/oid_stash.h
+./table.lo: ../../include/net-snmp/library/check_varbind.h
+./table.lo: ../../include/net-snmp/library/container.h
+./table.lo: ../../include/net-snmp/library/factory.h
+./table.lo: ../../include/net-snmp/library/snmp_logging.h
+./table.lo: ../../include/net-snmp/library/container_binary_array.h
+./table.lo: ../../include/net-snmp/library/container_list_ssll.h
+./table.lo: ../../include/net-snmp/library/container_iterator.h
+./table.lo: ../../include/net-snmp/library/container.h
+./table.lo: ../../include/net-snmp/library/snmp_assert.h
+./table.lo: ../../include/net-snmp/version.h
+./table.lo: ../../include/net-snmp/session_api.h
+./table.lo: ../../include/net-snmp/library/snmp_transport.h
+./table.lo: ../../include/net-snmp/library/snmp_service.h
+./table.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./table.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./table.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./table.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./table.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./table.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./table.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./table.lo: ../../include/net-snmp/library/ucd_compat.h
+./table.lo: ../../include/net-snmp/pdu_api.h ../../include/net-snmp/mib_api.h
+./table.lo: ../../include/net-snmp/library/mib.h
+./table.lo: ../../include/net-snmp/library/parse.h
+./table.lo: ../../include/net-snmp/varbind_api.h
+./table.lo: ../../include/net-snmp/config_api.h
+./table.lo: ../../include/net-snmp/library/read_config.h
+./table.lo: ../../include/net-snmp/library/default_store.h
+./table.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./table.lo: ../../include/net-snmp/library/snmp_enum.h
+./table.lo: ../../include/net-snmp/library/vacm.h
+./table.lo: ../../include/net-snmp/output_api.h
+./table.lo: ../../include/net-snmp/library/snmp_debug.h
+./table.lo: ../../include/net-snmp/snmpv3_api.h
+./table.lo: ../../include/net-snmp/library/snmpv3.h
+./table.lo: ../../include/net-snmp/library/transform_oids.h
+./table.lo: ../../include/net-snmp/library/keytools.h
+./table.lo: ../../include/net-snmp/library/scapi.h
+./table.lo: ../../include/net-snmp/library/lcd_time.h
+./table.lo: ../../include/net-snmp/library/snmp_secmod.h
+./table.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./table.lo: ../../include/net-snmp/library/snmpusm.h
+./table.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./table.lo: ../../include/net-snmp/agent/mib_module_config.h
+./table.lo: ../../include/net-snmp/agent/agent_module_config.h
+./table.lo: ../../include/net-snmp/agent/snmp_agent.h
+./table.lo: ../../include/net-snmp/agent/snmp_vars.h
+./table.lo: ../../include/net-snmp/agent/agent_handler.h
+./table.lo: ../../include/net-snmp/agent/var_struct.h
+./table.lo: ../../include/net-snmp/agent/agent_registry.h
+./table.lo: ../../include/net-snmp/library/fd_event_manager.h
+./table.lo: ../../include/net-snmp/agent/ds_agent.h
+./table.lo: ../../include/net-snmp/agent/agent_read_config.h
+./table.lo: ../../include/net-snmp/agent/agent_trap.h
+./table.lo: ../../include/net-snmp/agent/all_helpers.h
+./table.lo: ../../include/net-snmp/agent/instance.h
+./table.lo: ../../include/net-snmp/agent/baby_steps.h
+./table.lo: ../../include/net-snmp/agent/scalar.h
+./table.lo: ../../include/net-snmp/agent/scalar_group.h
+./table.lo: ../../include/net-snmp/agent/watcher.h
+./table.lo: ../../include/net-snmp/agent/multiplexer.h
+./table.lo: ../../include/net-snmp/agent/null.h
+./table.lo: ../../include/net-snmp/agent/debug_handler.h
+./table.lo: ../../include/net-snmp/agent/cache_handler.h
+./table.lo: ../../include/net-snmp/agent/old_api.h
+./table.lo: ../../include/net-snmp/agent/read_only.h
+./table.lo: ../../include/net-snmp/agent/row_merge.h
+./table.lo: ../../include/net-snmp/agent/serialize.h
+./table.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./table.lo: ../../include/net-snmp/agent/mode_end_call.h
+./table.lo: ../../include/net-snmp/agent/table.h
+./table.lo: ../../include/net-snmp/agent/table_data.h
+./table.lo: ../../include/net-snmp/agent/table_dataset.h
+./table.lo: ../../include/net-snmp/agent/table_tdata.h
+./table.lo: ../../include/net-snmp/agent/table_iterator.h
+./table.lo: ../../include/net-snmp/agent/table_container.h
+./table.lo: ../../include/net-snmp/agent/table_array.h
+./table.lo: ../../include/net-snmp/agent/mfd.h
 ./table_container.lo: ../../include/net-snmp/net-snmp-config.h
 ./table_container.lo: ../../include/net-snmp/system/linux.h
 ./table_container.lo: ../../include/net-snmp/system/sysv.h
@@ -2049,7 +2049,7 @@
 ./table_data.lo: ../../include/net-snmp/system/generic.h
 ./table_data.lo: ../../include/net-snmp/machine/generic.h
 ./table_data.lo: ../../include/net-snmp/net-snmp-includes.h
-./table_data.lo: ../../include/net-snmp/definitions.h
+./table_data.lo:  ../../include/net-snmp/definitions.h
 ./table_data.lo: ../../include/net-snmp/types.h 
 ./table_data.lo: ../../include/net-snmp/library/snmp_api.h
 ./table_data.lo: ../../include/net-snmp/library/asn1.h
@@ -2560,7 +2560,7 @@
 ./watcher.lo: ../../include/net-snmp/system/generic.h
 ./watcher.lo: ../../include/net-snmp/machine/generic.h 
 ./watcher.lo: ../../include/net-snmp/net-snmp-includes.h 
-./watcher.lo: ../../include/net-snmp/definitions.h
+./watcher.lo:  ../../include/net-snmp/definitions.h
 ./watcher.lo: ../../include/net-snmp/types.h 
 ./watcher.lo: ../../include/net-snmp/library/snmp_api.h
 ./watcher.lo: ../../include/net-snmp/library/asn1.h

=== modified file 'agent/helpers/stash_cache.c'
--- agent/helpers/stash_cache.c	2009-11-12 16:17:40 +0000
+++ agent/helpers/stash_cache.c	2010-06-10 18:02:54 +0000
@@ -66,6 +66,7 @@
     }
 
     handler->myvoid = cinfo;
+    handler->data_free = free;
 
     return handler;
 }

=== modified file 'agent/helpers/table.c'
--- agent/helpers/table.c	2007-12-08 14:59:50 +0000
+++ agent/helpers/table.c	2010-06-10 18:02:54 +0000
@@ -837,10 +837,7 @@
     memcpy(&tmpoid[len], table_info->index_oid,
            table_info->index_oid_len * sizeof(oid));
     len += table_info->index_oid_len;
-    if (var->name && var->name != var->name_loc)
-        SNMP_FREE(var->name);
-    snmp_clone_mem((void **) &var->name, tmpoid, len * sizeof(oid));
-    var->name_length = len;
+    snmp_set_var_objid( var, tmpoid, len );
 
     return SNMPERR_SUCCESS;
 }

=== modified file 'agent/helpers/table_data.c'
--- agent/helpers/table_data.c	2007-05-10 22:20:23 +0000
+++ agent/helpers/table_data.c	2010-06-10 18:02:54 +0000
@@ -80,16 +80,20 @@
 
     if (row->indexes) {
         newrow->indexes = snmp_clone_varbind(newrow->indexes);
-        if (!newrow->indexes)
+        if (!newrow->indexes) {
+            free (newrow);
             return NULL;
+        }
     }
 
     if (row->index_oid) {
         memdup((u_char **) & newrow->index_oid,
                (u_char *) row->index_oid,
                row->index_oid_len * sizeof(oid));
-        if (!newrow->index_oid)
+        if (!newrow->index_oid) {
+            free (newrow);
             return NULL;
+        }
     }
 
     return newrow;

=== modified file 'agent/helpers/table_dataset.c'
--- agent/helpers/table_dataset.c	2007-12-08 14:59:50 +0000
+++ agent/helpers/table_dataset.c	2010-06-10 18:02:54 +0000
@@ -36,9 +36,6 @@
  *  Helps you implement a table with automatted storage.
  *  @ingroup table_data
  *
- *  This helper is obsolete.  If you are writing a new module, please
- *  consider using the table_dataset2 helper instead.
- *
  *  This handler helps you implement a table where all the data is
  *  expected to be stored within the agent itself and not in some
  *  external storage location.  It handles all MIB requests including
@@ -563,7 +560,7 @@
             data = (netsnmp_table_data_set_storage *) row->data;
 
         if (!row || !table_info || !data) {
-            if (!MODE_IS_SET(reqinfo->mode)) {
+            if (!MODE_IS_SET(reqinfo->mode) || !table_info) {
                 netsnmp_set_request_error(reqinfo, request,
                                           SNMP_NOSUCHINSTANCE);
                 continue;
@@ -993,6 +990,7 @@
         if (!snmp_parse_oid(tp->augments, name, &name_length)) {
             config_pwarn("I can't parse the augment tabel name");
             snmp_log(LOG_WARNING, "  can't parse %s\n", tp->augments);
+            SNMP_FREE (table_set);
             return;
         }
         if(NULL == (tp2 = get_tree(name, name_length, get_tree_head()))) {
@@ -1000,6 +998,7 @@
                          "I can't find mib information about augment table");
             snmp_log(LOG_WARNING, "  table %s not found in tree\n",
                      tp->augments);
+            SNMP_FREE (table_set);
             return;
         }
         _table_set_add_indexes(table_set, tp2);
@@ -1016,6 +1015,7 @@
         type = mib_to_asn_type(tp->type);
         if (type == (u_char) - 1) {
             config_pwarn("unknown column type");
+	    SNMP_FREE (table_set);
             return;             /* xxx mem leak */
         }
 
@@ -1091,6 +1091,7 @@
          vb = vb->next_variable) {
         if (!line) {
             config_pwarn("missing an index value");
+            SNMP_FREE (row);
             return;
         }
 
@@ -1110,6 +1111,7 @@
                          "All columns must be specified.");
             snmp_log(LOG_WARNING,"  can't find value for column %d\n",
                      dr->column - 1);
+            SNMP_FREE (row);
             return;
         }
 
@@ -1272,7 +1274,7 @@
  * ================================== */
 
 /** adds an index to the table.  Call this repeatly for each index. */
-NETSNMP_INLINE void
+void
 netsnmp_table_dataset_add_index(netsnmp_table_data_set *table, u_char type)
 {
     if (!table)
@@ -1303,13 +1305,12 @@
     tset = va_arg(debugargs, netsnmp_table_data_set *);
 #endif
 
-    while ((type = va_arg(debugargs, int)) != 0) {
-        netsnmp_table_dataset_add_index(tset, (u_char)type);
-    }
+    if (tset)
+        while ((type = va_arg(debugargs, int)) != 0)
+            netsnmp_table_data_add_index(tset->table, type);
 
     va_end(debugargs);
 }
 
 /** @} 
  */
-

=== modified file 'agent/helpers/table_iterator.c'
--- agent/helpers/table_iterator.c	2009-11-12 16:17:40 +0000
+++ agent/helpers/table_iterator.c	2010-06-10 18:02:54 +0000
@@ -386,7 +386,7 @@
     netsnmp_table_request_info *table_info = NULL;
     oid             coloid[MAX_OID_LEN];
     size_t          coloid_len;
-    int             ret;
+    int             ret = SNMP_ERR_NOERROR;
     static oid      myname[MAX_OID_LEN];
     size_t          myname_len;
     int             oldmode = 0;
@@ -807,7 +807,7 @@
     if (free_this_index_search)
         snmp_free_varbind(free_this_index_search);
 
-    return SNMP_ERR_NOERROR;
+    return ret;
 }
 
 /* ==================================

=== modified file 'agent/helpers/table_row.c' (properties changed: +x to -x)
--- agent/helpers/table_row.c	2007-12-08 14:59:50 +0000
+++ agent/helpers/table_row.c	2010-06-10 18:02:54 +0000
@@ -3,7 +3,7 @@
  *
  * Helper for registering single row slices of a shared table
  *
- * $Id: table_row.c 15254 2006-09-19 10:24:14Z dts12 $
+ * $Id: table_row.c 17839 2009-11-27 08:54:26Z jsafranek $
  */
 #define TABLE_ROW_DATA  "table_row"
 

=== modified file 'agent/mibgroup/Makefile.depend'
--- agent/mibgroup/Makefile.depend	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -312,729 +312,13 @@
 ./util_funcs.lo: ../../include/net-snmp/agent/table_array.h
 ./util_funcs.lo: ../../include/net-snmp/agent/mfd.h struct.h util_funcs.h
 ./util_funcs.lo: utilities/execute.h 
-./util_funcs.lo: ucd-snmp/errormib.h mibdefs.h
+./util_funcs.lo:  ucd-snmp/errormib.h mibdefs.h
 ./winExtDLL.lo: ../../include/net-snmp/net-snmp-config.h
 ./winExtDLL.lo: ../../include/net-snmp/system/linux.h
 ./winExtDLL.lo: ../../include/net-snmp/system/sysv.h
 ./winExtDLL.lo: ../../include/net-snmp/system/generic.h
 ./winExtDLL.lo: ../../include/net-snmp/machine/generic.h
-./winExtDLL.lo: ../../include/net-snmp/net-snmp-includes.h
-./winExtDLL.lo: ../../include/net-snmp/definitions.h
-./winExtDLL.lo: ../../include/net-snmp/types.h 
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/asn1.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_impl.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp-tc.h
-./winExtDLL.lo: ../../include/net-snmp/utilities.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_client.h
-./winExtDLL.lo: ../../include/net-snmp/library/system.h
-./winExtDLL.lo: ../../include/net-snmp/library/tools.h
-./winExtDLL.lo: ../../include/net-snmp/library/int64.h
-./winExtDLL.lo: ../../include/net-snmp/library/mt_support.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_alarm.h
-./winExtDLL.lo: ../../include/net-snmp/library/callback.h
-./winExtDLL.lo: ../../include/net-snmp/library/data_list.h
-./winExtDLL.lo: ../../include/net-snmp/library/oid_stash.h
-./winExtDLL.lo: ../../include/net-snmp/library/check_varbind.h
-./winExtDLL.lo: ../../include/net-snmp/library/container.h
-./winExtDLL.lo: ../../include/net-snmp/library/factory.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_logging.h
-./winExtDLL.lo: ../../include/net-snmp/library/container_binary_array.h
-./winExtDLL.lo: ../../include/net-snmp/library/container_list_ssll.h
-./winExtDLL.lo: ../../include/net-snmp/library/container_iterator.h
-./winExtDLL.lo: ../../include/net-snmp/library/container.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_assert.h
-./winExtDLL.lo: ../../include/net-snmp/version.h
-./winExtDLL.lo: ../../include/net-snmp/session_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_transport.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_service.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./winExtDLL.lo: ../../include/net-snmp/library/ucd_compat.h
-./winExtDLL.lo: ../../include/net-snmp/pdu_api.h
-./winExtDLL.lo: ../../include/net-snmp/mib_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/mib.h
-./winExtDLL.lo: ../../include/net-snmp/library/parse.h
-./winExtDLL.lo: ../../include/net-snmp/varbind_api.h
-./winExtDLL.lo: ../../include/net-snmp/config_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/read_config.h
-./winExtDLL.lo: ../../include/net-snmp/library/default_store.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_enum.h
-./winExtDLL.lo: ../../include/net-snmp/library/vacm.h
-./winExtDLL.lo: ../../include/net-snmp/output_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_debug.h
-./winExtDLL.lo: ../../include/net-snmp/snmpv3_api.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpv3.h
-./winExtDLL.lo: ../../include/net-snmp/library/transform_oids.h
-./winExtDLL.lo: ../../include/net-snmp/library/keytools.h
-./winExtDLL.lo: ../../include/net-snmp/library/scapi.h
-./winExtDLL.lo: ../../include/net-snmp/library/lcd_time.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmp_secmod.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./winExtDLL.lo: ../../include/net-snmp/library/snmpusm.h
-./winExtDLL.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
 ./winExtDLL.lo: ../../include/net-snmp/agent/mib_module_config.h
-./winExtDLL.lo: ../../include/net-snmp/agent/agent_module_config.h
-./winExtDLL.lo: ../../include/net-snmp/agent/snmp_agent.h
-./winExtDLL.lo: ../../include/net-snmp/agent/snmp_vars.h
-./winExtDLL.lo: ../../include/net-snmp/agent/agent_handler.h
-./winExtDLL.lo: ../../include/net-snmp/agent/var_struct.h
-./winExtDLL.lo: ../../include/net-snmp/agent/agent_registry.h
-./winExtDLL.lo: ../../include/net-snmp/library/fd_event_manager.h
-./winExtDLL.lo: ../../include/net-snmp/agent/ds_agent.h
-./winExtDLL.lo: ../../include/net-snmp/agent/agent_read_config.h
-./winExtDLL.lo: ../../include/net-snmp/agent/agent_trap.h
-./winExtDLL.lo: ../../include/net-snmp/agent/all_helpers.h
-./winExtDLL.lo: ../../include/net-snmp/agent/instance.h
-./winExtDLL.lo: ../../include/net-snmp/agent/baby_steps.h
-./winExtDLL.lo: ../../include/net-snmp/agent/scalar.h
-./winExtDLL.lo: ../../include/net-snmp/agent/scalar_group.h
-./winExtDLL.lo: ../../include/net-snmp/agent/watcher.h
-./winExtDLL.lo: ../../include/net-snmp/agent/multiplexer.h
-./winExtDLL.lo: ../../include/net-snmp/agent/null.h
-./winExtDLL.lo: ../../include/net-snmp/agent/debug_handler.h
-./winExtDLL.lo: ../../include/net-snmp/agent/cache_handler.h
-./winExtDLL.lo: ../../include/net-snmp/agent/old_api.h
-./winExtDLL.lo: ../../include/net-snmp/agent/read_only.h
-./winExtDLL.lo: ../../include/net-snmp/agent/row_merge.h
-./winExtDLL.lo: ../../include/net-snmp/agent/serialize.h
-./winExtDLL.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./winExtDLL.lo: ../../include/net-snmp/agent/mode_end_call.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_data.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_dataset.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_tdata.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_iterator.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_container.h
-./winExtDLL.lo: ../../include/net-snmp/agent/table_array.h
-./winExtDLL.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./winExtDLL.lo: winExtDLL.h
-./Rmon/agutil.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/agutil.lo: ../../include/net-snmp/system/linux.h
-./Rmon/agutil.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/agutil.lo: ../../include/net-snmp/system/generic.h
-./Rmon/agutil.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/agutil.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/agutil.lo: ../../include/net-snmp/definitions.h
-./Rmon/agutil.lo: ../../include/net-snmp/types.h 
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/agutil.lo: ../../include/net-snmp/utilities.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/system.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/tools.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/int64.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/callback.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/container.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/factory.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/container.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/agutil.lo: ../../include/net-snmp/version.h
-./Rmon/agutil.lo: ../../include/net-snmp/session_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/agutil.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/mib_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/mib.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/parse.h
-./Rmon/agutil.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/config_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/agutil.lo: ../../include/net-snmp/output_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/agutil.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/agutil.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/null.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/agutil.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./Rmon/agutil.lo: ./Rmon/agutil.h ./Rmon/agutil_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/alarm.lo: ../../include/net-snmp/system/linux.h
-./Rmon/alarm.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/alarm.lo: ../../include/net-snmp/system/generic.h
-./Rmon/alarm.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/alarm.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/alarm.lo: ../../include/net-snmp/definitions.h
-./Rmon/alarm.lo: ../../include/net-snmp/types.h 
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/alarm.lo: ../../include/net-snmp/utilities.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/system.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/tools.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/int64.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/callback.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/container.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/factory.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/container.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/alarm.lo: ../../include/net-snmp/version.h
-./Rmon/alarm.lo: ../../include/net-snmp/session_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/alarm.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/mib_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/mib.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/parse.h
-./Rmon/alarm.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/config_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/alarm.lo: ../../include/net-snmp/output_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/alarm.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/alarm.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/null.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/alarm.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./Rmon/alarm.lo: ./Rmon/alarm.h ./Rmon/agutil_api.h ./Rmon/row_api.h
-./Rmon/event.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/event.lo: ../../include/net-snmp/system/linux.h
-./Rmon/event.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/event.lo: ../../include/net-snmp/system/generic.h
-./Rmon/event.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/event.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/event.lo: ../../include/net-snmp/definitions.h
-./Rmon/event.lo: ../../include/net-snmp/types.h 
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/event.lo: ../../include/net-snmp/utilities.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/event.lo: ../../include/net-snmp/library/system.h
-./Rmon/event.lo: ../../include/net-snmp/library/tools.h
-./Rmon/event.lo: ../../include/net-snmp/library/int64.h
-./Rmon/event.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/event.lo: ../../include/net-snmp/library/callback.h
-./Rmon/event.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/event.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/event.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/event.lo: ../../include/net-snmp/library/container.h
-./Rmon/event.lo: ../../include/net-snmp/library/factory.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/event.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/event.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/event.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/event.lo: ../../include/net-snmp/library/container.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/event.lo: ../../include/net-snmp/version.h
-./Rmon/event.lo: ../../include/net-snmp/session_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/event.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/event.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/event.lo: ../../include/net-snmp/mib_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/mib.h
-./Rmon/event.lo: ../../include/net-snmp/library/parse.h
-./Rmon/event.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/event.lo: ../../include/net-snmp/config_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/event.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/event.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/event.lo: ../../include/net-snmp/output_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/event.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/event.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/event.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/event.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/event.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/event.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/event.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/event.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/event.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/event.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/event.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/event.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/event.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/event.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/event.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/event.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/event.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/event.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/event.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/event.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/event.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/event.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/event.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/event.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/event.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/event.lo: ../../include/net-snmp/agent/null.h
-./Rmon/event.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/event.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/event.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/event.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/event.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/event.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/event.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/event.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/event.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/event.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./Rmon/event.lo: ./Rmon/event.h ./Rmon/agutil_api.h ./Rmon/row_api.h
-./Rmon/history.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/history.lo: ../../include/net-snmp/system/linux.h
-./Rmon/history.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/history.lo: ../../include/net-snmp/system/generic.h
-./Rmon/history.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/history.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/history.lo: ../../include/net-snmp/definitions.h
-./Rmon/history.lo: ../../include/net-snmp/types.h 
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/history.lo: ../../include/net-snmp/utilities.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/history.lo: ../../include/net-snmp/library/system.h
-./Rmon/history.lo: ../../include/net-snmp/library/tools.h
-./Rmon/history.lo: ../../include/net-snmp/library/int64.h
-./Rmon/history.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/history.lo: ../../include/net-snmp/library/callback.h
-./Rmon/history.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/history.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/history.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/history.lo: ../../include/net-snmp/library/container.h
-./Rmon/history.lo: ../../include/net-snmp/library/factory.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/history.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/history.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/history.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/history.lo: ../../include/net-snmp/library/container.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/history.lo: ../../include/net-snmp/version.h
-./Rmon/history.lo: ../../include/net-snmp/session_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/history.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/history.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/history.lo: ../../include/net-snmp/mib_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/mib.h
-./Rmon/history.lo: ../../include/net-snmp/library/parse.h
-./Rmon/history.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/history.lo: ../../include/net-snmp/config_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/history.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/history.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/history.lo: ../../include/net-snmp/output_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/history.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/history.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/history.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/history.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/history.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/history.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/history.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/history.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/history.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/history.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/history.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/history.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/history.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/history.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/history.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/history.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/history.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/history.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/history.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/history.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/history.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/history.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/history.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/history.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/history.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/history.lo: ../../include/net-snmp/agent/null.h
-./Rmon/history.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/history.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/history.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/history.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/history.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/history.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/history.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/history.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/history.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/history.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./Rmon/history.lo: ./Rmon/history.h ./Rmon/agutil_api.h ./Rmon/row_api.h
-./Rmon/rows.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/rows.lo: ../../include/net-snmp/system/linux.h
-./Rmon/rows.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/rows.lo: ../../include/net-snmp/system/generic.h
-./Rmon/rows.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/rows.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/rows.lo:  ../../include/net-snmp/definitions.h
-./Rmon/rows.lo: ../../include/net-snmp/types.h 
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/rows.lo: ../../include/net-snmp/utilities.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/rows.lo: ../../include/net-snmp/library/system.h
-./Rmon/rows.lo: ../../include/net-snmp/library/tools.h
-./Rmon/rows.lo: ../../include/net-snmp/library/int64.h
-./Rmon/rows.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/rows.lo: ../../include/net-snmp/library/callback.h
-./Rmon/rows.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/rows.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/rows.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/rows.lo: ../../include/net-snmp/library/container.h
-./Rmon/rows.lo: ../../include/net-snmp/library/factory.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/rows.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/rows.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/rows.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/rows.lo: ../../include/net-snmp/library/container.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/rows.lo: ../../include/net-snmp/version.h
-./Rmon/rows.lo: ../../include/net-snmp/session_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/rows.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/rows.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/rows.lo: ../../include/net-snmp/mib_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/mib.h
-./Rmon/rows.lo: ../../include/net-snmp/library/parse.h
-./Rmon/rows.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/rows.lo: ../../include/net-snmp/config_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/rows.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/rows.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/rows.lo: ../../include/net-snmp/output_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/rows.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/rows.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/rows.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/rows.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/rows.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/rows.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/rows.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/null.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/rows.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
-./Rmon/rows.lo: ./Rmon/agutil_api.h ./Rmon/rows.h ./Rmon/row_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/net-snmp-config.h
-./Rmon/statistics.lo: ../../include/net-snmp/system/linux.h
-./Rmon/statistics.lo: ../../include/net-snmp/system/sysv.h
-./Rmon/statistics.lo: ../../include/net-snmp/system/generic.h
-./Rmon/statistics.lo: ../../include/net-snmp/machine/generic.h
-./Rmon/statistics.lo: ../../include/net-snmp/net-snmp-includes.h
-./Rmon/statistics.lo: ../../include/net-snmp/definitions.h
-./Rmon/statistics.lo: ../../include/net-snmp/types.h 
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/asn1.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_impl.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp-tc.h
-./Rmon/statistics.lo: ../../include/net-snmp/utilities.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_client.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/system.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/tools.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/int64.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/mt_support.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_alarm.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/callback.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/data_list.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/oid_stash.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/check_varbind.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/container.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/factory.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_logging.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/container_binary_array.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/container_list_ssll.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/container_iterator.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/container.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_assert.h
-./Rmon/statistics.lo: ../../include/net-snmp/version.h
-./Rmon/statistics.lo: ../../include/net-snmp/session_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_transport.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_service.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/ucd_compat.h
-./Rmon/statistics.lo: ../../include/net-snmp/pdu_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/mib_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/mib.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/parse.h
-./Rmon/statistics.lo: ../../include/net-snmp/varbind_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/config_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/read_config.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/default_store.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_enum.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/vacm.h
-./Rmon/statistics.lo: ../../include/net-snmp/output_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_debug.h
-./Rmon/statistics.lo: ../../include/net-snmp/snmpv3_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpv3.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/transform_oids.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/keytools.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/scapi.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/lcd_time.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_secmod.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/snmpusm.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/mib_module_config.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_module_config.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/snmp_agent.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/snmp_vars.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_handler.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/var_struct.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_registry.h
-./Rmon/statistics.lo: ../../include/net-snmp/library/fd_event_manager.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/ds_agent.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_read_config.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_trap.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/all_helpers.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/instance.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/baby_steps.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/scalar.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/scalar_group.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/watcher.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/multiplexer.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/null.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/debug_handler.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/cache_handler.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/old_api.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/read_only.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/row_merge.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/serialize.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/mode_end_call.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_data.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_dataset.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_tdata.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_iterator.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_container.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/table_array.h
-./Rmon/statistics.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
-./Rmon/statistics.lo: struct.h ./Rmon/statistics.h ./Rmon/agutil_api.h
-./Rmon/statistics.lo: ./Rmon/row_api.h
 ./agent/extend.lo: ../../include/net-snmp/net-snmp-config.h
 ./agent/extend.lo: ../../include/net-snmp/system/linux.h
 ./agent/extend.lo: ../../include/net-snmp/system/sysv.h
@@ -1966,109 +1250,6 @@
 ./agentx/client.lo: ../../include/net-snmp/agent/mfd.h
 ./agentx/client.lo: ../../include/net-snmp/agent/agent_index.h
 ./agentx/client.lo: agentx/protocol.h agentx/client.h agentx/subagent.h
-./agentx/master.lo: ../../include/net-snmp/net-snmp-config.h
-./agentx/master.lo: ../../include/net-snmp/system/linux.h
-./agentx/master.lo: ../../include/net-snmp/system/sysv.h
-./agentx/master.lo: ../../include/net-snmp/system/generic.h
-./agentx/master.lo: ../../include/net-snmp/machine/generic.h
-./agentx/master.lo: ../../include/net-snmp/net-snmp-includes.h
-./agentx/master.lo: ../../include/net-snmp/definitions.h
-./agentx/master.lo: ../../include/net-snmp/types.h 
-./agentx/master.lo: ../../include/net-snmp/library/snmp_api.h
-./agentx/master.lo: ../../include/net-snmp/library/asn1.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_impl.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp-tc.h
-./agentx/master.lo: ../../include/net-snmp/utilities.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_client.h
-./agentx/master.lo: ../../include/net-snmp/library/system.h
-./agentx/master.lo: ../../include/net-snmp/library/tools.h
-./agentx/master.lo: ../../include/net-snmp/library/int64.h
-./agentx/master.lo: ../../include/net-snmp/library/mt_support.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_alarm.h
-./agentx/master.lo: ../../include/net-snmp/library/callback.h
-./agentx/master.lo: ../../include/net-snmp/library/data_list.h
-./agentx/master.lo: ../../include/net-snmp/library/oid_stash.h
-./agentx/master.lo: ../../include/net-snmp/library/check_varbind.h
-./agentx/master.lo: ../../include/net-snmp/library/container.h
-./agentx/master.lo: ../../include/net-snmp/library/factory.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_logging.h
-./agentx/master.lo: ../../include/net-snmp/library/container_binary_array.h
-./agentx/master.lo: ../../include/net-snmp/library/container_list_ssll.h
-./agentx/master.lo: ../../include/net-snmp/library/container_iterator.h
-./agentx/master.lo: ../../include/net-snmp/library/container.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_assert.h
-./agentx/master.lo: ../../include/net-snmp/version.h
-./agentx/master.lo: ../../include/net-snmp/session_api.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_transport.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_service.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./agentx/master.lo: ../../include/net-snmp/library/ucd_compat.h
-./agentx/master.lo: ../../include/net-snmp/pdu_api.h
-./agentx/master.lo: ../../include/net-snmp/mib_api.h
-./agentx/master.lo: ../../include/net-snmp/library/mib.h
-./agentx/master.lo: ../../include/net-snmp/library/parse.h
-./agentx/master.lo: ../../include/net-snmp/varbind_api.h
-./agentx/master.lo: ../../include/net-snmp/config_api.h
-./agentx/master.lo: ../../include/net-snmp/library/read_config.h
-./agentx/master.lo: ../../include/net-snmp/library/default_store.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_enum.h
-./agentx/master.lo: ../../include/net-snmp/library/vacm.h
-./agentx/master.lo: ../../include/net-snmp/output_api.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_debug.h
-./agentx/master.lo: ../../include/net-snmp/snmpv3_api.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpv3.h
-./agentx/master.lo: ../../include/net-snmp/library/transform_oids.h
-./agentx/master.lo: ../../include/net-snmp/library/keytools.h
-./agentx/master.lo: ../../include/net-snmp/library/scapi.h
-./agentx/master.lo: ../../include/net-snmp/library/lcd_time.h
-./agentx/master.lo: ../../include/net-snmp/library/snmp_secmod.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./agentx/master.lo: ../../include/net-snmp/library/snmpusm.h
-./agentx/master.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./agentx/master.lo: ../../include/net-snmp/agent/mib_module_config.h
-./agentx/master.lo: ../../include/net-snmp/agent/agent_module_config.h
-./agentx/master.lo: ../../include/net-snmp/agent/snmp_agent.h
-./agentx/master.lo: ../../include/net-snmp/agent/snmp_vars.h
-./agentx/master.lo: ../../include/net-snmp/agent/agent_handler.h
-./agentx/master.lo: ../../include/net-snmp/agent/var_struct.h
-./agentx/master.lo: ../../include/net-snmp/agent/agent_registry.h
-./agentx/master.lo: ../../include/net-snmp/library/fd_event_manager.h
-./agentx/master.lo: ../../include/net-snmp/agent/ds_agent.h
-./agentx/master.lo: ../../include/net-snmp/agent/agent_read_config.h
-./agentx/master.lo: ../../include/net-snmp/agent/agent_trap.h
-./agentx/master.lo: ../../include/net-snmp/agent/all_helpers.h
-./agentx/master.lo: ../../include/net-snmp/agent/instance.h
-./agentx/master.lo: ../../include/net-snmp/agent/baby_steps.h
-./agentx/master.lo: ../../include/net-snmp/agent/scalar.h
-./agentx/master.lo: ../../include/net-snmp/agent/scalar_group.h
-./agentx/master.lo: ../../include/net-snmp/agent/watcher.h
-./agentx/master.lo: ../../include/net-snmp/agent/multiplexer.h
-./agentx/master.lo: ../../include/net-snmp/agent/null.h
-./agentx/master.lo: ../../include/net-snmp/agent/debug_handler.h
-./agentx/master.lo: ../../include/net-snmp/agent/cache_handler.h
-./agentx/master.lo: ../../include/net-snmp/agent/old_api.h
-./agentx/master.lo: ../../include/net-snmp/agent/read_only.h
-./agentx/master.lo: ../../include/net-snmp/agent/row_merge.h
-./agentx/master.lo: ../../include/net-snmp/agent/serialize.h
-./agentx/master.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./agentx/master.lo: ../../include/net-snmp/agent/mode_end_call.h
-./agentx/master.lo: ../../include/net-snmp/agent/table.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_data.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_dataset.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_tdata.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_iterator.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_container.h
-./agentx/master.lo: ../../include/net-snmp/agent/table_array.h
-./agentx/master.lo: ../../include/net-snmp/agent/mfd.h ../../agent/snmpd.h
-./agentx/master.lo: agentx/protocol.h agentx/master_admin.h
 ./agentx/master_admin.lo: ../../include/net-snmp/net-snmp-config.h
 ./agentx/master_admin.lo: ../../include/net-snmp/system/linux.h
 ./agentx/master_admin.lo: ../../include/net-snmp/system/sysv.h
@@ -2175,6 +1356,109 @@
 ./agentx/master_admin.lo: ../../include/net-snmp/agent/agent_index.h
 ./agentx/master_admin.lo: ../../include/net-snmp/agent/agent_callbacks.h
 ./agentx/master_admin.lo: mibII/sysORTable.h ./agentx/master.h
+./agentx/master.lo: ../../include/net-snmp/net-snmp-config.h
+./agentx/master.lo: ../../include/net-snmp/system/linux.h
+./agentx/master.lo: ../../include/net-snmp/system/sysv.h
+./agentx/master.lo: ../../include/net-snmp/system/generic.h
+./agentx/master.lo: ../../include/net-snmp/machine/generic.h
+./agentx/master.lo: ../../include/net-snmp/net-snmp-includes.h
+./agentx/master.lo: ../../include/net-snmp/definitions.h
+./agentx/master.lo: ../../include/net-snmp/types.h 
+./agentx/master.lo: ../../include/net-snmp/library/snmp_api.h
+./agentx/master.lo: ../../include/net-snmp/library/asn1.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_impl.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp-tc.h
+./agentx/master.lo: ../../include/net-snmp/utilities.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_client.h
+./agentx/master.lo: ../../include/net-snmp/library/system.h
+./agentx/master.lo: ../../include/net-snmp/library/tools.h
+./agentx/master.lo: ../../include/net-snmp/library/int64.h
+./agentx/master.lo: ../../include/net-snmp/library/mt_support.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_alarm.h
+./agentx/master.lo: ../../include/net-snmp/library/callback.h
+./agentx/master.lo: ../../include/net-snmp/library/data_list.h
+./agentx/master.lo: ../../include/net-snmp/library/oid_stash.h
+./agentx/master.lo: ../../include/net-snmp/library/check_varbind.h
+./agentx/master.lo: ../../include/net-snmp/library/container.h
+./agentx/master.lo: ../../include/net-snmp/library/factory.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_logging.h
+./agentx/master.lo: ../../include/net-snmp/library/container_binary_array.h
+./agentx/master.lo: ../../include/net-snmp/library/container_list_ssll.h
+./agentx/master.lo: ../../include/net-snmp/library/container_iterator.h
+./agentx/master.lo: ../../include/net-snmp/library/container.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_assert.h
+./agentx/master.lo: ../../include/net-snmp/version.h
+./agentx/master.lo: ../../include/net-snmp/session_api.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_transport.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_service.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./agentx/master.lo: ../../include/net-snmp/library/ucd_compat.h
+./agentx/master.lo: ../../include/net-snmp/pdu_api.h
+./agentx/master.lo: ../../include/net-snmp/mib_api.h
+./agentx/master.lo: ../../include/net-snmp/library/mib.h
+./agentx/master.lo: ../../include/net-snmp/library/parse.h
+./agentx/master.lo: ../../include/net-snmp/varbind_api.h
+./agentx/master.lo: ../../include/net-snmp/config_api.h
+./agentx/master.lo: ../../include/net-snmp/library/read_config.h
+./agentx/master.lo: ../../include/net-snmp/library/default_store.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_enum.h
+./agentx/master.lo: ../../include/net-snmp/library/vacm.h
+./agentx/master.lo: ../../include/net-snmp/output_api.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_debug.h
+./agentx/master.lo: ../../include/net-snmp/snmpv3_api.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpv3.h
+./agentx/master.lo: ../../include/net-snmp/library/transform_oids.h
+./agentx/master.lo: ../../include/net-snmp/library/keytools.h
+./agentx/master.lo: ../../include/net-snmp/library/scapi.h
+./agentx/master.lo: ../../include/net-snmp/library/lcd_time.h
+./agentx/master.lo: ../../include/net-snmp/library/snmp_secmod.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./agentx/master.lo: ../../include/net-snmp/library/snmpusm.h
+./agentx/master.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./agentx/master.lo: ../../include/net-snmp/agent/mib_module_config.h
+./agentx/master.lo: ../../include/net-snmp/agent/agent_module_config.h
+./agentx/master.lo: ../../include/net-snmp/agent/snmp_agent.h
+./agentx/master.lo: ../../include/net-snmp/agent/snmp_vars.h
+./agentx/master.lo: ../../include/net-snmp/agent/agent_handler.h
+./agentx/master.lo: ../../include/net-snmp/agent/var_struct.h
+./agentx/master.lo: ../../include/net-snmp/agent/agent_registry.h
+./agentx/master.lo: ../../include/net-snmp/library/fd_event_manager.h
+./agentx/master.lo: ../../include/net-snmp/agent/ds_agent.h
+./agentx/master.lo: ../../include/net-snmp/agent/agent_read_config.h
+./agentx/master.lo: ../../include/net-snmp/agent/agent_trap.h
+./agentx/master.lo: ../../include/net-snmp/agent/all_helpers.h
+./agentx/master.lo: ../../include/net-snmp/agent/instance.h
+./agentx/master.lo: ../../include/net-snmp/agent/baby_steps.h
+./agentx/master.lo: ../../include/net-snmp/agent/scalar.h
+./agentx/master.lo: ../../include/net-snmp/agent/scalar_group.h
+./agentx/master.lo: ../../include/net-snmp/agent/watcher.h
+./agentx/master.lo: ../../include/net-snmp/agent/multiplexer.h
+./agentx/master.lo: ../../include/net-snmp/agent/null.h
+./agentx/master.lo: ../../include/net-snmp/agent/debug_handler.h
+./agentx/master.lo: ../../include/net-snmp/agent/cache_handler.h
+./agentx/master.lo: ../../include/net-snmp/agent/old_api.h
+./agentx/master.lo: ../../include/net-snmp/agent/read_only.h
+./agentx/master.lo: ../../include/net-snmp/agent/row_merge.h
+./agentx/master.lo: ../../include/net-snmp/agent/serialize.h
+./agentx/master.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./agentx/master.lo: ../../include/net-snmp/agent/mode_end_call.h
+./agentx/master.lo: ../../include/net-snmp/agent/table.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_data.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_dataset.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_tdata.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_iterator.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_container.h
+./agentx/master.lo: ../../include/net-snmp/agent/table_array.h
+./agentx/master.lo: ../../include/net-snmp/agent/mfd.h ../../agent/snmpd.h
+./agentx/master.lo: agentx/protocol.h agentx/master_admin.h
 ./agentx/protocol.lo: ../../include/net-snmp/net-snmp-config.h
 ./agentx/protocol.lo: ../../include/net-snmp/system/linux.h
 ./agentx/protocol.lo: ../../include/net-snmp/system/sysv.h
@@ -3498,6 +2782,110 @@
 ./examples/example.lo: ../../include/net-snmp/agent/table_array.h
 ./examples/example.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
 ./examples/example.lo: struct.h ./examples/example.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/net-snmp-config.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/linux.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/sysv.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/generic.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/machine/generic.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/net-snmp-includes.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/definitions.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/types.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/asn1.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_impl.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp-tc.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/utilities.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_client.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/system.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/tools.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/int64.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/mt_support.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_alarm.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/callback.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/data_list.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/oid_stash.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/check_varbind.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/factory.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_logging.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_binary_array.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_list_ssll.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_iterator.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_assert.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/version.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/session_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_transport.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_service.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/ucd_compat.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/pdu_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/mib_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/mib.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/parse.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/varbind_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/config_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/read_config.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/default_store.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_enum.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/vacm.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/output_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_debug.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/snmpv3_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpv3.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/transform_oids.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/keytools.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/scapi.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/lcd_time.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_secmod.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpusm.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mib_module_config.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_module_config.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/snmp_agent.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/snmp_vars.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_handler.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/var_struct.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_registry.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/fd_event_manager.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/ds_agent.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_read_config.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_trap.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/all_helpers.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/instance.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/baby_steps.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/scalar.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/scalar_group.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/watcher.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/multiplexer.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/null.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/debug_handler.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/cache_handler.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/old_api.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/read_only.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/row_merge.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/serialize.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mode_end_call.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_data.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_dataset.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_tdata.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_iterator.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_container.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_array.h
+./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mfd.h
+./examples/netSnmpHostsTable_access.lo: ./examples/netSnmpHostsTable_access.h
+./examples/netSnmpHostsTable_access.lo: ./examples/netSnmpHostsTable_enums.h
 ./examples/netSnmpHostsTable.lo: ../../include/net-snmp/net-snmp-config.h
 ./examples/netSnmpHostsTable.lo: ../../include/net-snmp/system/linux.h
 ./examples/netSnmpHostsTable.lo: ../../include/net-snmp/system/sysv.h
@@ -3605,110 +2993,6 @@
 ./examples/netSnmpHostsTable.lo: ./examples/netSnmpHostsTable_enums.h
 ./examples/netSnmpHostsTable.lo: ./examples/netSnmpHostsTable_checkfns.h
 ./examples/netSnmpHostsTable.lo: ./examples/netSnmpHostsTable_access.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/net-snmp-config.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/linux.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/sysv.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/system/generic.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/machine/generic.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/net-snmp-includes.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/definitions.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/types.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/asn1.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_impl.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp-tc.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/utilities.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_client.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/system.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/tools.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/int64.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/mt_support.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_alarm.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/callback.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/data_list.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/oid_stash.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/check_varbind.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/factory.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_logging.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_binary_array.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_list_ssll.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container_iterator.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/container.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_assert.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/version.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/session_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_transport.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_service.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/ucd_compat.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/pdu_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/mib_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/mib.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/parse.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/varbind_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/config_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/read_config.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/default_store.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_enum.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/vacm.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/output_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_debug.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/snmpv3_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpv3.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/transform_oids.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/keytools.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/scapi.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/lcd_time.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmp_secmod.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/snmpusm.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mib_module_config.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_module_config.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/snmp_agent.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/snmp_vars.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_handler.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/var_struct.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_registry.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/library/fd_event_manager.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/ds_agent.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_read_config.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/agent_trap.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/all_helpers.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/instance.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/baby_steps.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/scalar.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/scalar_group.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/watcher.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/multiplexer.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/null.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/debug_handler.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/cache_handler.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/old_api.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/read_only.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/row_merge.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/serialize.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mode_end_call.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_data.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_dataset.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_tdata.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_iterator.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_container.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/table_array.h
-./examples/netSnmpHostsTable_access.lo: ../../include/net-snmp/agent/mfd.h
-./examples/netSnmpHostsTable_access.lo: ./examples/netSnmpHostsTable_access.h
-./examples/netSnmpHostsTable_access.lo: ./examples/netSnmpHostsTable_enums.h
 ./examples/netSnmpHostsTable_checkfns.lo: ../../include/net-snmp/net-snmp-config.h
 ./examples/netSnmpHostsTable_checkfns.lo: ../../include/net-snmp/system/linux.h
 ./examples/netSnmpHostsTable_checkfns.lo: ../../include/net-snmp/system/sysv.h
@@ -4260,7 +3544,7 @@
 ./host/hr_device.lo: ../../include/net-snmp/system/sysv.h
 ./host/hr_device.lo: ../../include/net-snmp/system/generic.h
 ./host/hr_device.lo: ../../include/net-snmp/machine/generic.h
-./host/hr_device.lo: host_res.h 
+./host/hr_device.lo:  host_res.h 
 ./host/hr_device.lo: ../../include/net-snmp/net-snmp-includes.h
 ./host/hr_device.lo: ../../include/net-snmp/definitions.h
 ./host/hr_device.lo: ../../include/net-snmp/types.h 
@@ -5054,10 +4338,10 @@
 ./host/hr_swinst.lo: ../../include/net-snmp/system/sysv.h
 ./host/hr_swinst.lo: ../../include/net-snmp/system/generic.h
 ./host/hr_swinst.lo: ../../include/net-snmp/machine/generic.h
-./host/hr_swinst.lo:  host_res.h
+./host/hr_swinst.lo: host_res.h 
 ./host/hr_swinst.lo: ../../include/net-snmp/net-snmp-includes.h
 ./host/hr_swinst.lo: ../../include/net-snmp/definitions.h
-./host/hr_swinst.lo: ../../include/net-snmp/types.h
+./host/hr_swinst.lo: ../../include/net-snmp/types.h 
 ./host/hr_swinst.lo: ../../include/net-snmp/library/snmp_api.h
 ./host/hr_swinst.lo: ../../include/net-snmp/library/asn1.h
 ./host/hr_swinst.lo: ../../include/net-snmp/library/snmp_impl.h
@@ -5727,6 +5011,113 @@
 ./mibII/interfaces.lo: ../../include/net-snmp/data_access/interface.h
 ./mibII/interfaces.lo: ./mibII/interfaces.h struct.h util_funcs.h
 ./mibII/interfaces.lo: ./mibII/sysORTable.h
+./mibII/ipAddr.lo: ../../include/net-snmp/net-snmp-config.h
+./mibII/ipAddr.lo: ../../include/net-snmp/system/linux.h
+./mibII/ipAddr.lo: ../../include/net-snmp/system/sysv.h
+./mibII/ipAddr.lo: ../../include/net-snmp/system/generic.h
+./mibII/ipAddr.lo: ../../include/net-snmp/machine/generic.h
+./mibII/ipAddr.lo:  ../../agent/kernel.h
+./mibII/ipAddr.lo: ../../include/net-snmp/net-snmp-includes.h
+./mibII/ipAddr.lo: ../../include/net-snmp/definitions.h
+./mibII/ipAddr.lo: ../../include/net-snmp/types.h 
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/asn1.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_impl.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp-tc.h
+./mibII/ipAddr.lo: ../../include/net-snmp/utilities.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_client.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/system.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/tools.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/int64.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/mt_support.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_alarm.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/callback.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/data_list.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/oid_stash.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/check_varbind.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/container.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/factory.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_logging.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/container_binary_array.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/container_list_ssll.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/container_iterator.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/container.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_assert.h
+./mibII/ipAddr.lo: ../../include/net-snmp/version.h
+./mibII/ipAddr.lo: ../../include/net-snmp/session_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_transport.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_service.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/ucd_compat.h
+./mibII/ipAddr.lo: ../../include/net-snmp/pdu_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/mib_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/mib.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/parse.h
+./mibII/ipAddr.lo: ../../include/net-snmp/varbind_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/config_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/read_config.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/default_store.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_enum.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/vacm.h
+./mibII/ipAddr.lo: ../../include/net-snmp/output_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_debug.h
+./mibII/ipAddr.lo: ../../include/net-snmp/snmpv3_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpv3.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/transform_oids.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/keytools.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/scapi.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/lcd_time.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_secmod.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpusm.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/mib_module_config.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_module_config.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/snmp_agent.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/snmp_vars.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_handler.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/var_struct.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_registry.h
+./mibII/ipAddr.lo: ../../include/net-snmp/library/fd_event_manager.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/ds_agent.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_read_config.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_trap.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/all_helpers.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/instance.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/baby_steps.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/scalar.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/scalar_group.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/watcher.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/multiplexer.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/null.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/debug_handler.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/cache_handler.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/old_api.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/read_only.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/row_merge.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/serialize.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/mode_end_call.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_data.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_dataset.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_tdata.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_iterator.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_container.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_array.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/mfd.h
+./mibII/ipAddr.lo: ../../include/net-snmp/agent/auto_nlist.h
+./mibII/ipAddr.lo: ../../include/net-snmp/data_access/interface.h
+./mibII/ipAddr.lo: ./mibII/ip.h ./mibII/var_route.h ./mibII/route_write.h
+./mibII/ipAddr.lo: ./mibII/at.h ./mibII/interfaces.h ./mibII/sysORTable.h
 ./mibII/ip.lo: ../../include/net-snmp/net-snmp-config.h
 ./mibII/ip.lo: ../../include/net-snmp/system/linux.h
 ./mibII/ip.lo: ../../include/net-snmp/system/sysv.h
@@ -5835,113 +5226,111 @@
 ./mibII/ip.lo: struct.h ./mibII/ip.h ./mibII/var_route.h
 ./mibII/ip.lo: ./mibII/route_write.h ./mibII/at.h ./mibII/ipAddr.h
 ./mibII/ip.lo: ./mibII/interfaces.h ./mibII/sysORTable.h
-./mibII/ipAddr.lo: ../../include/net-snmp/net-snmp-config.h
-./mibII/ipAddr.lo: ../../include/net-snmp/system/linux.h
-./mibII/ipAddr.lo: ../../include/net-snmp/system/sysv.h
-./mibII/ipAddr.lo: ../../include/net-snmp/system/generic.h
-./mibII/ipAddr.lo: ../../include/net-snmp/machine/generic.h
-./mibII/ipAddr.lo:  ../../agent/kernel.h
-./mibII/ipAddr.lo: ../../include/net-snmp/net-snmp-includes.h
-./mibII/ipAddr.lo: ../../include/net-snmp/definitions.h
-./mibII/ipAddr.lo: ../../include/net-snmp/types.h 
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/asn1.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_impl.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp-tc.h
-./mibII/ipAddr.lo: ../../include/net-snmp/utilities.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_client.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/system.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/tools.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/int64.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/mt_support.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_alarm.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/callback.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/data_list.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/oid_stash.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/check_varbind.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/container.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/factory.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_logging.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/container_binary_array.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/container_list_ssll.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/container_iterator.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/container.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_assert.h
-./mibII/ipAddr.lo: ../../include/net-snmp/version.h
-./mibII/ipAddr.lo: ../../include/net-snmp/session_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_transport.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_service.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/ucd_compat.h
-./mibII/ipAddr.lo: ../../include/net-snmp/pdu_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/mib_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/mib.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/parse.h
-./mibII/ipAddr.lo: ../../include/net-snmp/varbind_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/config_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/read_config.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/default_store.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_enum.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/vacm.h
-./mibII/ipAddr.lo: ../../include/net-snmp/output_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_debug.h
-./mibII/ipAddr.lo: ../../include/net-snmp/snmpv3_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpv3.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/transform_oids.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/keytools.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/scapi.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/lcd_time.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmp_secmod.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/snmpusm.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/mib_module_config.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_module_config.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/snmp_agent.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/snmp_vars.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_handler.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/var_struct.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_registry.h
-./mibII/ipAddr.lo: ../../include/net-snmp/library/fd_event_manager.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/ds_agent.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_read_config.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/agent_trap.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/all_helpers.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/instance.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/baby_steps.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/scalar.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/scalar_group.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/watcher.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/multiplexer.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/null.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/debug_handler.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/cache_handler.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/old_api.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/read_only.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/row_merge.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/serialize.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/mode_end_call.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_data.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_dataset.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_tdata.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_iterator.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_container.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/table_array.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/mfd.h
-./mibII/ipAddr.lo: ../../include/net-snmp/agent/auto_nlist.h
-./mibII/ipAddr.lo: ../../include/net-snmp/data_access/interface.h
-./mibII/ipAddr.lo: ./mibII/ip.h ./mibII/var_route.h ./mibII/route_write.h
-./mibII/ipAddr.lo: ./mibII/at.h ./mibII/interfaces.h ./mibII/sysORTable.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/net-snmp-config.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/linux.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/sysv.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/generic.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/machine/generic.h
+./mibII/ipCidrRouteTable_access.lo: ./mibII/route_headers.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/net-snmp-includes.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/definitions.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/types.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/asn1.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_impl.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp-tc.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/utilities.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_client.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/system.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/tools.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/int64.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/mt_support.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_alarm.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/callback.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/data_list.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/oid_stash.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/check_varbind.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/factory.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_logging.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_binary_array.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_list_ssll.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_iterator.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_assert.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/version.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/session_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_transport.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_service.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/ucd_compat.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/pdu_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/mib_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/mib.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/parse.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/varbind_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/config_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/read_config.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/default_store.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_enum.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/vacm.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/output_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_debug.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/snmpv3_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpv3.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/transform_oids.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/keytools.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/scapi.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/lcd_time.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_secmod.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpusm.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mib_module_config.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_module_config.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/snmp_agent.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/snmp_vars.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_handler.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/var_struct.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_registry.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/fd_event_manager.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/ds_agent.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_read_config.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_trap.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/all_helpers.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/instance.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/baby_steps.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/scalar.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/scalar_group.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/watcher.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/multiplexer.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/null.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/debug_handler.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/cache_handler.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/old_api.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/read_only.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/row_merge.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/serialize.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mode_end_call.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_data.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_dataset.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_tdata.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_iterator.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_container.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_array.h
+./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mfd.h
+./mibII/ipCidrRouteTable_access.lo: ./mibII/ipCidrRouteTable_access.h
+./mibII/ipCidrRouteTable_access.lo: ./mibII/ipCidrRouteTable_enums.h
 ./mibII/ipCidrRouteTable.lo: ../../include/net-snmp/net-snmp-config.h
 ./mibII/ipCidrRouteTable.lo: ../../include/net-snmp/system/linux.h
 ./mibII/ipCidrRouteTable.lo: ../../include/net-snmp/system/sysv.h
@@ -6051,111 +5440,6 @@
 ./mibII/ipCidrRouteTable.lo: ./mibII/ipCidrRouteTable_checkfns.h
 ./mibII/ipCidrRouteTable.lo: ./mibII/ipCidrRouteTable_access.h
 ./mibII/ipCidrRouteTable.lo: ./mibII/var_route.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/net-snmp-config.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/linux.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/sysv.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/system/generic.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/machine/generic.h
-./mibII/ipCidrRouteTable_access.lo: ./mibII/route_headers.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/net-snmp-includes.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/definitions.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/types.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/asn1.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_impl.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp-tc.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/utilities.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_client.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/system.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/tools.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/int64.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/mt_support.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_alarm.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/callback.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/data_list.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/oid_stash.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/check_varbind.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/factory.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_logging.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_binary_array.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_list_ssll.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container_iterator.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/container.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_assert.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/version.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/session_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_transport.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_service.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/ucd_compat.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/pdu_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/mib_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/mib.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/parse.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/varbind_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/config_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/read_config.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/default_store.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_enum.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/vacm.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/output_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_debug.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/snmpv3_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpv3.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/transform_oids.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/keytools.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/scapi.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/lcd_time.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmp_secmod.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/snmpusm.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mib_module_config.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_module_config.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/snmp_agent.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/snmp_vars.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_handler.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/var_struct.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_registry.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/library/fd_event_manager.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/ds_agent.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_read_config.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/agent_trap.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/all_helpers.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/instance.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/baby_steps.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/scalar.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/scalar_group.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/watcher.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/multiplexer.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/null.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/debug_handler.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/cache_handler.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/old_api.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/read_only.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/row_merge.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/serialize.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mode_end_call.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_data.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_dataset.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_tdata.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_iterator.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_container.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/table_array.h
-./mibII/ipCidrRouteTable_access.lo: ../../include/net-snmp/agent/mfd.h
-./mibII/ipCidrRouteTable_access.lo: ./mibII/ipCidrRouteTable_access.h
-./mibII/ipCidrRouteTable_access.lo: ./mibII/ipCidrRouteTable_enums.h
 ./mibII/ipCidrRouteTable_checkfns.lo: ../../include/net-snmp/net-snmp-config.h
 ./mibII/ipCidrRouteTable_checkfns.lo: ../../include/net-snmp/system/linux.h
 ./mibII/ipCidrRouteTable_checkfns.lo: ../../include/net-snmp/system/sysv.h
@@ -8327,6 +7611,625 @@
 ./notification/snmpNotifyTable.lo: snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_data_access.h
 ./notification/snmpNotifyTable.lo: ../../include/net-snmp/agent/agent_callbacks.h
 ./notification/snmpNotifyTable.lo: notification-log-mib/notification_log.h
+./Rmon/agutil.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/agutil.lo: ../../include/net-snmp/system/linux.h
+./Rmon/agutil.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/agutil.lo: ../../include/net-snmp/system/generic.h
+./Rmon/agutil.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/agutil.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/agutil.lo: ../../include/net-snmp/definitions.h
+./Rmon/agutil.lo: ../../include/net-snmp/types.h 
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/agutil.lo: ../../include/net-snmp/utilities.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/system.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/tools.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/int64.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/callback.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/container.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/factory.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/container.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/agutil.lo: ../../include/net-snmp/version.h
+./Rmon/agutil.lo: ../../include/net-snmp/session_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/agutil.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/mib_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/mib.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/parse.h
+./Rmon/agutil.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/config_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/agutil.lo: ../../include/net-snmp/output_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/agutil.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/agutil.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/null.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/agutil.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
+./Rmon/agutil.lo: ./Rmon/agutil.h ./Rmon/agutil_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/alarm.lo: ../../include/net-snmp/system/linux.h
+./Rmon/alarm.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/alarm.lo: ../../include/net-snmp/system/generic.h
+./Rmon/alarm.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/alarm.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/alarm.lo: ../../include/net-snmp/definitions.h
+./Rmon/alarm.lo: ../../include/net-snmp/types.h 
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/alarm.lo: ../../include/net-snmp/utilities.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/system.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/tools.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/int64.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/callback.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/container.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/factory.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/container.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/alarm.lo: ../../include/net-snmp/version.h
+./Rmon/alarm.lo: ../../include/net-snmp/session_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/alarm.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/mib_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/mib.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/parse.h
+./Rmon/alarm.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/config_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/alarm.lo: ../../include/net-snmp/output_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/alarm.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/alarm.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/null.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/alarm.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
+./Rmon/alarm.lo: ./Rmon/alarm.h ./Rmon/agutil_api.h ./Rmon/row_api.h
+./Rmon/event.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/event.lo: ../../include/net-snmp/system/linux.h
+./Rmon/event.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/event.lo: ../../include/net-snmp/system/generic.h
+./Rmon/event.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/event.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/event.lo:  ../../include/net-snmp/definitions.h
+./Rmon/event.lo: ../../include/net-snmp/types.h 
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/event.lo: ../../include/net-snmp/utilities.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/event.lo: ../../include/net-snmp/library/system.h
+./Rmon/event.lo: ../../include/net-snmp/library/tools.h
+./Rmon/event.lo: ../../include/net-snmp/library/int64.h
+./Rmon/event.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/event.lo: ../../include/net-snmp/library/callback.h
+./Rmon/event.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/event.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/event.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/event.lo: ../../include/net-snmp/library/container.h
+./Rmon/event.lo: ../../include/net-snmp/library/factory.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/event.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/event.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/event.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/event.lo: ../../include/net-snmp/library/container.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/event.lo: ../../include/net-snmp/version.h
+./Rmon/event.lo: ../../include/net-snmp/session_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/event.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/event.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/event.lo: ../../include/net-snmp/mib_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/mib.h
+./Rmon/event.lo: ../../include/net-snmp/library/parse.h
+./Rmon/event.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/event.lo: ../../include/net-snmp/config_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/event.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/event.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/event.lo: ../../include/net-snmp/output_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/event.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/event.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/event.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/event.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/event.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/event.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/event.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/event.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/event.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/event.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/event.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/event.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/event.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/event.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/event.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/event.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/event.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/event.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/event.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/event.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/event.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/event.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/event.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/event.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/event.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/event.lo: ../../include/net-snmp/agent/null.h
+./Rmon/event.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/event.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/event.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/event.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/event.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/event.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/event.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/event.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/event.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/event.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
+./Rmon/event.lo: ./Rmon/event.h ./Rmon/agutil_api.h ./Rmon/row_api.h
+./Rmon/history.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/history.lo: ../../include/net-snmp/system/linux.h
+./Rmon/history.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/history.lo: ../../include/net-snmp/system/generic.h
+./Rmon/history.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/history.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/history.lo: ../../include/net-snmp/definitions.h
+./Rmon/history.lo: ../../include/net-snmp/types.h 
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/history.lo: ../../include/net-snmp/utilities.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/history.lo: ../../include/net-snmp/library/system.h
+./Rmon/history.lo: ../../include/net-snmp/library/tools.h
+./Rmon/history.lo: ../../include/net-snmp/library/int64.h
+./Rmon/history.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/history.lo: ../../include/net-snmp/library/callback.h
+./Rmon/history.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/history.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/history.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/history.lo: ../../include/net-snmp/library/container.h
+./Rmon/history.lo: ../../include/net-snmp/library/factory.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/history.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/history.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/history.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/history.lo: ../../include/net-snmp/library/container.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/history.lo: ../../include/net-snmp/version.h
+./Rmon/history.lo: ../../include/net-snmp/session_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/history.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/history.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/history.lo: ../../include/net-snmp/mib_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/mib.h
+./Rmon/history.lo: ../../include/net-snmp/library/parse.h
+./Rmon/history.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/history.lo: ../../include/net-snmp/config_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/history.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/history.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/history.lo: ../../include/net-snmp/output_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/history.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/history.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/history.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/history.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/history.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/history.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/history.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/history.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/history.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/history.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/history.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/history.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/history.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/history.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/history.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/history.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/history.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/history.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/history.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/history.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/history.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/history.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/history.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/history.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/history.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/history.lo: ../../include/net-snmp/agent/null.h
+./Rmon/history.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/history.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/history.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/history.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/history.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/history.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/history.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/history.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/history.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/history.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
+./Rmon/history.lo: ./Rmon/history.h ./Rmon/agutil_api.h ./Rmon/row_api.h
+./Rmon/rows.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/rows.lo: ../../include/net-snmp/system/linux.h
+./Rmon/rows.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/rows.lo: ../../include/net-snmp/system/generic.h
+./Rmon/rows.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/rows.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/rows.lo: ../../include/net-snmp/definitions.h
+./Rmon/rows.lo: ../../include/net-snmp/types.h 
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/rows.lo: ../../include/net-snmp/utilities.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/rows.lo: ../../include/net-snmp/library/system.h
+./Rmon/rows.lo: ../../include/net-snmp/library/tools.h
+./Rmon/rows.lo: ../../include/net-snmp/library/int64.h
+./Rmon/rows.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/rows.lo: ../../include/net-snmp/library/callback.h
+./Rmon/rows.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/rows.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/rows.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/rows.lo: ../../include/net-snmp/library/container.h
+./Rmon/rows.lo: ../../include/net-snmp/library/factory.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/rows.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/rows.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/rows.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/rows.lo: ../../include/net-snmp/library/container.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/rows.lo: ../../include/net-snmp/version.h
+./Rmon/rows.lo: ../../include/net-snmp/session_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/rows.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/rows.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/rows.lo: ../../include/net-snmp/mib_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/mib.h
+./Rmon/rows.lo: ../../include/net-snmp/library/parse.h
+./Rmon/rows.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/rows.lo: ../../include/net-snmp/config_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/rows.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/rows.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/rows.lo: ../../include/net-snmp/output_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/rows.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/rows.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/rows.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/rows.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/rows.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/rows.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/rows.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/null.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/rows.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
+./Rmon/rows.lo: ./Rmon/agutil_api.h ./Rmon/rows.h ./Rmon/row_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/net-snmp-config.h
+./Rmon/statistics.lo: ../../include/net-snmp/system/linux.h
+./Rmon/statistics.lo: ../../include/net-snmp/system/sysv.h
+./Rmon/statistics.lo: ../../include/net-snmp/system/generic.h
+./Rmon/statistics.lo: ../../include/net-snmp/machine/generic.h
+./Rmon/statistics.lo: ../../include/net-snmp/net-snmp-includes.h
+./Rmon/statistics.lo: ../../include/net-snmp/definitions.h
+./Rmon/statistics.lo: ../../include/net-snmp/types.h 
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/asn1.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_impl.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp-tc.h
+./Rmon/statistics.lo: ../../include/net-snmp/utilities.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_client.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/system.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/tools.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/int64.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/mt_support.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_alarm.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/callback.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/data_list.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/oid_stash.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/check_varbind.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/container.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/factory.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_logging.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/container_binary_array.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/container_list_ssll.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/container_iterator.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/container.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_assert.h
+./Rmon/statistics.lo: ../../include/net-snmp/version.h
+./Rmon/statistics.lo: ../../include/net-snmp/session_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_transport.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_service.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/ucd_compat.h
+./Rmon/statistics.lo: ../../include/net-snmp/pdu_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/mib_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/mib.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/parse.h
+./Rmon/statistics.lo: ../../include/net-snmp/varbind_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/config_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/read_config.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/default_store.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_enum.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/vacm.h
+./Rmon/statistics.lo: ../../include/net-snmp/output_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_debug.h
+./Rmon/statistics.lo: ../../include/net-snmp/snmpv3_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpv3.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/transform_oids.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/keytools.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/scapi.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/lcd_time.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmp_secmod.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/snmpusm.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/mib_module_config.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_module_config.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/snmp_agent.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/snmp_vars.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_handler.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/var_struct.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_registry.h
+./Rmon/statistics.lo: ../../include/net-snmp/library/fd_event_manager.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/ds_agent.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_read_config.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/agent_trap.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/all_helpers.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/instance.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/baby_steps.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/scalar.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/scalar_group.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/watcher.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/multiplexer.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/null.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/debug_handler.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/cache_handler.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/old_api.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/read_only.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/row_merge.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/serialize.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/mode_end_call.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_data.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_dataset.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_tdata.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_iterator.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_container.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/table_array.h
+./Rmon/statistics.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
+./Rmon/statistics.lo: struct.h ./Rmon/statistics.h ./Rmon/agutil_api.h
+./Rmon/statistics.lo: ./Rmon/row_api.h
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ../../include/net-snmp/net-snmp-config.h
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ../../include/net-snmp/system/linux.h
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ../../include/net-snmp/system/sysv.h
@@ -8431,8 +8334,11 @@
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ../../include/net-snmp/agent/mfd.h
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ./sctp-mib/sctpAssocLocalAddrTable.h
 ./sctp-mib/sctpAssocLocalAddrTable.lo: ./sctp-mib/sctpTables_common.h
-./sctp-mib/sctpAssocLocalAddrTable.lo: ../../include/net-snmp/net-snmp-config.h
 ./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpAssocRemAddrTable.lo: ../../include/net-snmp/types.h
@@ -8533,6 +8439,10 @@
 ./sctp-mib/sctpAssocRemAddrTable.lo: ./sctp-mib/sctpAssocRemAddrTable.h
 ./sctp-mib/sctpAssocRemAddrTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpAssocTable.lo: ../../include/net-snmp/types.h
@@ -8633,6 +8543,10 @@
 ./sctp-mib/sctpAssocTable.lo: ./sctp-mib/sctpAssocTable.h
 ./sctp-mib/sctpAssocTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpLookupLocalPortTable.lo: ../../include/net-snmp/types.h
@@ -8733,6 +8647,10 @@
 ./sctp-mib/sctpLookupLocalPortTable.lo: ./sctp-mib/sctpLookupLocalPortTable.h
 ./sctp-mib/sctpLookupLocalPortTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ../../include/net-snmp/types.h
@@ -8833,6 +8751,10 @@
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ./sctp-mib/sctpLookupRemHostNameTable.h
 ./sctp-mib/sctpLookupRemHostNameTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ../../include/net-snmp/types.h
@@ -8933,6 +8855,10 @@
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ./sctp-mib/sctpLookupRemIPAddrTable.h
 ./sctp-mib/sctpLookupRemIPAddrTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpLookupRemPortTable.lo: ../../include/net-snmp/types.h
@@ -9033,6 +8959,10 @@
 ./sctp-mib/sctpLookupRemPortTable.lo: ./sctp-mib/sctpLookupRemPortTable.h
 ./sctp-mib/sctpLookupRemPortTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ../../include/net-snmp/types.h
@@ -9133,6 +9063,10 @@
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ./sctp-mib/sctpLookupRemPrimIPAddrTable.h
 ./sctp-mib/sctpLookupRemPrimIPAddrTable.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpScalars.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpScalars.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpScalars.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpScalars.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpScalars.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpScalars.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpScalars.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpScalars.lo: ../../include/net-snmp/types.h
@@ -9233,6 +9167,10 @@
 ./sctp-mib/sctpScalars.lo: ./sctp-mib/sctpScalars.h
 ./sctp-mib/sctpScalars.lo: ./sctp-mib/sctpScalars_common.h
 ./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/types.h
@@ -9332,6 +9270,10 @@
 ./sctp-mib/sctpScalars_common.lo: ../../include/net-snmp/agent/mfd.h
 ./sctp-mib/sctpScalars_common.lo: ./sctp-mib/sctpScalars_common.h
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/types.h
@@ -9430,8 +9372,11 @@
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/agent/table_array.h
 ./sctp-mib/sctpScalars_linux.lo: ../../include/net-snmp/agent/mfd.h
 ./sctp-mib/sctpScalars_linux.lo: ./sctp-mib/sctpScalars_common.h
-./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/types.h
@@ -9529,6 +9474,7 @@
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/agent/table_container.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/agent/table_array.h
 ./sctp-mib/sctpTables_common.lo: ../../include/net-snmp/agent/mfd.h
+./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpAssocTable.h
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpAssocRemAddrTable.h
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpAssocLocalAddrTable.h
@@ -9537,9 +9483,11 @@
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpLookupRemHostNameTable.h
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpLookupRemPrimIPAddrTable.h
 ./sctp-mib/sctpTables_common.lo: ./sctp-mib/sctpLookupRemIPAddrTable.h
-./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpAssocTable.h
-./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/net-snmp-config.h
+./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/system/linux.h
+./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/system/sysv.h
+./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/system/generic.h
+./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/machine/generic.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/definitions.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/types.h
@@ -9637,10 +9585,16 @@
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/agent/table_container.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/agent/table_array.h
 ./sctp-mib/sctpTables_linux.lo: ../../include/net-snmp/agent/mfd.h
+./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpAssocTable.h
+./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpTables_common.h
 ./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpAssocLocalAddrTable.h
 ./sctp-mib/sctpTables_linux.lo: ./sctp-mib/sctpAssocRemAddrTable.h
 ./sctp-mib/sctpTables_linux.lo: util_funcs.h struct.h
 ./smux/smux.lo: ../../include/net-snmp/net-snmp-config.h
+./smux/smux.lo: ../../include/net-snmp/system/linux.h
+./smux/smux.lo: ../../include/net-snmp/system/sysv.h
+./smux/smux.lo: ../../include/net-snmp/system/generic.h
+./smux/smux.lo: ../../include/net-snmp/machine/generic.h
 ./smux/smux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./smux/smux.lo: ../../include/net-snmp/definitions.h
 ./smux/smux.lo: ../../include/net-snmp/types.h 
@@ -9740,6 +9694,10 @@
 ./smux/smux.lo: ../../include/net-snmp/agent/mfd.h smux.h util_funcs.h
 ./smux/smux.lo: struct.h mibdefs.h ../../agent/snmpd.h
 ./smux/snmp_bgp.lo: ../../include/net-snmp/net-snmp-config.h
+./smux/snmp_bgp.lo: ../../include/net-snmp/system/linux.h
+./smux/snmp_bgp.lo: ../../include/net-snmp/system/sysv.h
+./smux/snmp_bgp.lo: ../../include/net-snmp/system/generic.h
+./smux/snmp_bgp.lo: ../../include/net-snmp/machine/generic.h
 ./smux/snmp_bgp.lo: ../../include/net-snmp/net-snmp-includes.h
 ./smux/snmp_bgp.lo: ../../include/net-snmp/definitions.h
 ./smux/snmp_bgp.lo: ../../include/net-snmp/types.h 
@@ -9839,6 +9797,10 @@
 ./smux/snmp_bgp.lo: ../../include/net-snmp/agent/mfd.h smux.h
 ./smux/snmp_bgp.lo: ./smux/snmp_bgp.h
 ./smux/snmp_ospf.lo: ../../include/net-snmp/net-snmp-config.h
+./smux/snmp_ospf.lo: ../../include/net-snmp/system/linux.h
+./smux/snmp_ospf.lo: ../../include/net-snmp/system/sysv.h
+./smux/snmp_ospf.lo: ../../include/net-snmp/system/generic.h
+./smux/snmp_ospf.lo: ../../include/net-snmp/machine/generic.h
 ./smux/snmp_ospf.lo: ../../include/net-snmp/net-snmp-includes.h
 ./smux/snmp_ospf.lo: ../../include/net-snmp/definitions.h
 ./smux/snmp_ospf.lo: ../../include/net-snmp/types.h 
@@ -9938,6 +9900,10 @@
 ./smux/snmp_ospf.lo: ../../include/net-snmp/agent/mfd.h smux.h
 ./smux/snmp_ospf.lo: ./smux/snmp_ospf.h
 ./smux/snmp_rip2.lo: ../../include/net-snmp/net-snmp-config.h
+./smux/snmp_rip2.lo: ../../include/net-snmp/system/linux.h
+./smux/snmp_rip2.lo: ../../include/net-snmp/system/sysv.h
+./smux/snmp_rip2.lo: ../../include/net-snmp/system/generic.h
+./smux/snmp_rip2.lo: ../../include/net-snmp/machine/generic.h
 ./smux/snmp_rip2.lo: ../../include/net-snmp/net-snmp-includes.h
 ./smux/snmp_rip2.lo: ../../include/net-snmp/definitions.h
 ./smux/snmp_rip2.lo: ../../include/net-snmp/types.h 
@@ -10037,6 +10003,10 @@
 ./smux/snmp_rip2.lo: ../../include/net-snmp/agent/mfd.h smux.h
 ./smux/snmp_rip2.lo: ./smux/snmp_rip2.h
 ./snmpv3/snmpEngine.lo: ../../include/net-snmp/net-snmp-config.h
+./snmpv3/snmpEngine.lo: ../../include/net-snmp/system/linux.h
+./snmpv3/snmpEngine.lo: ../../include/net-snmp/system/sysv.h
+./snmpv3/snmpEngine.lo: ../../include/net-snmp/system/generic.h
+./snmpv3/snmpEngine.lo: ../../include/net-snmp/machine/generic.h
 ./snmpv3/snmpEngine.lo: ../../include/net-snmp/net-snmp-includes.h
 ./snmpv3/snmpEngine.lo: ../../include/net-snmp/definitions.h
 ./snmpv3/snmpEngine.lo: ../../include/net-snmp/types.h
@@ -10136,6 +10106,10 @@
 ./snmpv3/snmpEngine.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
 ./snmpv3/snmpEngine.lo: struct.h mibII/sysORTable.h ./snmpv3/snmpEngine.h
 ./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/net-snmp-config.h
+./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/system/linux.h
+./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/system/sysv.h
+./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/system/generic.h
+./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/machine/generic.h
 ./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/net-snmp-includes.h
 ./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/definitions.h
 ./snmpv3/snmpMPDStats.lo: ../../include/net-snmp/types.h
@@ -10236,6 +10210,10 @@
 ./snmpv3/snmpMPDStats.lo: mibII/sysORTable.h ./snmpv3/snmpMPDStats.h
 ./snmpv3/snmpMPDStats.lo: util_funcs.h struct.h
 ./snmpv3/usmConf.lo: ../../include/net-snmp/net-snmp-config.h
+./snmpv3/usmConf.lo: ../../include/net-snmp/system/linux.h
+./snmpv3/usmConf.lo: ../../include/net-snmp/system/sysv.h
+./snmpv3/usmConf.lo: ../../include/net-snmp/system/generic.h
+./snmpv3/usmConf.lo: ../../include/net-snmp/machine/generic.h
 ./snmpv3/usmConf.lo: ../../include/net-snmp/net-snmp-includes.h
 ./snmpv3/usmConf.lo: ../../include/net-snmp/definitions.h
 ./snmpv3/usmConf.lo: ../../include/net-snmp/types.h 
@@ -10334,6 +10312,10 @@
 ./snmpv3/usmConf.lo: ../../include/net-snmp/agent/table_array.h
 ./snmpv3/usmConf.lo: ../../include/net-snmp/agent/mfd.h
 ./snmpv3/usmStats.lo: ../../include/net-snmp/net-snmp-config.h
+./snmpv3/usmStats.lo: ../../include/net-snmp/system/linux.h
+./snmpv3/usmStats.lo: ../../include/net-snmp/system/sysv.h
+./snmpv3/usmStats.lo: ../../include/net-snmp/system/generic.h
+./snmpv3/usmStats.lo: ../../include/net-snmp/machine/generic.h
 ./snmpv3/usmStats.lo: ../../include/net-snmp/net-snmp-includes.h
 ./snmpv3/usmStats.lo: ../../include/net-snmp/definitions.h
 ./snmpv3/usmStats.lo: ../../include/net-snmp/types.h 
@@ -10433,6 +10415,10 @@
 ./snmpv3/usmStats.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
 ./snmpv3/usmStats.lo: struct.h mibII/sysORTable.h ./snmpv3/usmStats.h
 ./snmpv3/usmUser.lo: ../../include/net-snmp/net-snmp-config.h
+./snmpv3/usmUser.lo: ../../include/net-snmp/system/linux.h
+./snmpv3/usmUser.lo: ../../include/net-snmp/system/sysv.h
+./snmpv3/usmUser.lo: ../../include/net-snmp/system/generic.h
+./snmpv3/usmUser.lo: ../../include/net-snmp/machine/generic.h
 ./snmpv3/usmUser.lo: ../../include/net-snmp/net-snmp-includes.h
 ./snmpv3/usmUser.lo: ../../include/net-snmp/definitions.h
 ./snmpv3/usmUser.lo: ../../include/net-snmp/types.h 
@@ -10532,6 +10518,10 @@
 ./snmpv3/usmUser.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h struct.h
 ./snmpv3/usmUser.lo: ./snmpv3/usmUser.h
 ./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/net-snmp-config.h
+./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/system/linux.h
+./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/system/sysv.h
+./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/system/generic.h
+./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/machine/generic.h
 ./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/net-snmp-includes.h
 ./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/definitions.h
 ./target/snmpTargetAddrEntry.lo: ../../include/net-snmp/types.h
@@ -10632,6 +10622,10 @@
 ./target/snmpTargetAddrEntry.lo: ./target/snmpTargetAddrEntry.h util_funcs.h
 ./target/snmpTargetAddrEntry.lo: struct.h
 ./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/net-snmp-config.h
+./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/system/linux.h
+./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/system/sysv.h
+./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/system/generic.h
+./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/machine/generic.h
 ./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/net-snmp-includes.h
 ./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/definitions.h
 ./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/types.h
@@ -10731,6 +10725,10 @@
 ./target/snmpTargetParamsEntry.lo: ../../include/net-snmp/agent/mfd.h
 ./target/snmpTargetParamsEntry.lo: ./target/snmpTargetParamsEntry.h
 ./target/target.lo: ../../include/net-snmp/net-snmp-config.h
+./target/target.lo: ../../include/net-snmp/system/linux.h
+./target/target.lo: ../../include/net-snmp/system/sysv.h
+./target/target.lo: ../../include/net-snmp/system/generic.h
+./target/target.lo: ../../include/net-snmp/machine/generic.h
 ./target/target.lo: ../../include/net-snmp/net-snmp-includes.h
 ./target/target.lo: ../../include/net-snmp/definitions.h
 ./target/target.lo: ../../include/net-snmp/types.h 
@@ -10831,6 +10829,10 @@
 ./target/target.lo: ./target/snmpTargetAddrEntry.h
 ./target/target.lo: ./target/snmpTargetParamsEntry.h target.h
 ./target/target_counters.lo: ../../include/net-snmp/net-snmp-config.h
+./target/target_counters.lo: ../../include/net-snmp/system/linux.h
+./target/target_counters.lo: ../../include/net-snmp/system/sysv.h
+./target/target_counters.lo: ../../include/net-snmp/system/generic.h
+./target/target_counters.lo: ../../include/net-snmp/machine/generic.h
 ./target/target_counters.lo: ../../include/net-snmp/net-snmp-includes.h
 ./target/target_counters.lo: ../../include/net-snmp/definitions.h
 ./target/target_counters.lo: ../../include/net-snmp/types.h
@@ -10930,6 +10932,10 @@
 ./target/target_counters.lo: ../../include/net-snmp/agent/mfd.h
 ./target/target_counters.lo: ./target/target_counters.h
 ./tunnel/tunnel.lo: ../../include/net-snmp/net-snmp-config.h
+./tunnel/tunnel.lo: ../../include/net-snmp/system/linux.h
+./tunnel/tunnel.lo: ../../include/net-snmp/system/sysv.h
+./tunnel/tunnel.lo: ../../include/net-snmp/system/generic.h
+./tunnel/tunnel.lo: ../../include/net-snmp/machine/generic.h
 ./tunnel/tunnel.lo: ../../include/net-snmp/net-snmp-includes.h
 ./tunnel/tunnel.lo: ../../include/net-snmp/definitions.h
 ./tunnel/tunnel.lo: ../../include/net-snmp/types.h 
@@ -11035,6 +11041,10 @@
 ./tunnel/tunnel.lo: if-mib/ifTable/ifTable_data_access.h
 ./tunnel/tunnel.lo: if-mib/ifTable/ifTable_defs.h
 ./ucd-snmp/disk.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/disk.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/disk.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/disk.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/disk.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/disk.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/disk.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/disk.lo: ../../include/net-snmp/types.h 
@@ -11136,6 +11146,10 @@
 ./ucd-snmp/disk.lo: ./ucd-snmp/disk.h mibdefs.h util_funcs.h
 ./ucd-snmp/disk.lo: ./ucd-snmp/errormib.h
 ./ucd-snmp/diskio.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/diskio.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/diskio.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/diskio.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/diskio.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/diskio.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/diskio.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/diskio.lo: ../../include/net-snmp/types.h 
@@ -11235,6 +11249,10 @@
 ./ucd-snmp/diskio.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
 ./ucd-snmp/diskio.lo: struct.h ./ucd-snmp/diskio.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/dlmod.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/dlmod.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/dlmod.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/dlmod.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/types.h 
@@ -11332,7 +11350,12 @@
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/agent/table_container.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/agent/table_array.h
 ./ucd-snmp/dlmod.lo: ../../include/net-snmp/agent/mfd.h struct.h util_funcs.h
+./ucd-snmp/dlmod.lo: ./ucd-snmp/dlmod.h
 ./ucd-snmp/errormib.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/errormib.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/errormib.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/errormib.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/errormib.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/errormib.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/errormib.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/errormib.lo: ../../include/net-snmp/types.h
@@ -11433,6 +11456,10 @@
 ./ucd-snmp/errormib.lo: ../../include/net-snmp/agent/auto_nlist.h struct.h
 ./ucd-snmp/errormib.lo: ./ucd-snmp/errormib.h mibdefs.h util_funcs.h
 ./ucd-snmp/extensible.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/extensible.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/extensible.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/extensible.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/extensible.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/extensible.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/extensible.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/extensible.lo: ../../include/net-snmp/types.h
@@ -11535,6 +11562,10 @@
 ./ucd-snmp/extensible.lo: struct.h ./ucd-snmp/extensible.h mibdefs.h
 ./ucd-snmp/extensible.lo: utilities/execute.h util_funcs.h
 ./ucd-snmp/file.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/file.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/file.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/file.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/file.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/file.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/file.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/file.lo: ../../include/net-snmp/types.h 
@@ -11634,6 +11665,10 @@
 ./ucd-snmp/file.lo: ../../include/net-snmp/agent/mfd.h struct.h
 ./ucd-snmp/file.lo: ./ucd-snmp/file.h mibdefs.h util_funcs.h
 ./ucd-snmp/hpux.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/hpux.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/hpux.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/hpux.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/hpux.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/hpux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/hpux.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/hpux.lo: ../../include/net-snmp/types.h 
@@ -11733,6 +11768,10 @@
 ./ucd-snmp/hpux.lo: ../../include/net-snmp/agent/mfd.h ./ucd-snmp/hpux.h
 ./ucd-snmp/hpux.lo: mibdefs.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/lmSensors.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/lmSensors.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/lmSensors.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/lmSensors.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/types.h
@@ -11830,8 +11869,13 @@
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/agent/table_container.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/agent/table_array.h
 ./ucd-snmp/lmSensors.lo: ../../include/net-snmp/agent/mfd.h util_funcs.h
-./ucd-snmp/lmSensors.lo: struct.h ./ucd-snmp/lmSensors.h
+./ucd-snmp/lmSensors.lo: struct.h 
+./ucd-snmp/lmSensors.lo: ./ucd-snmp/lmSensors.h
 ./ucd-snmp/loadave.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/loadave.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/loadave.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/loadave.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/loadave.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/loadave.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/loadave.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/loadave.lo: ../../include/net-snmp/types.h 
@@ -11933,107 +11977,113 @@
 ./ucd-snmp/loadave.lo: ./ucd-snmp/loadave.h mibdefs.h util_funcs.h
 ./ucd-snmp/loadave.lo: ../../agent/kernel.h
 ./ucd-snmp/logmatch.lo: ../../include/net-snmp/net-snmp-config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/net-snmp-config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/net-snmp-includes.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/definitions.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/types.h 
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/asn1.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_impl.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp-tc.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/utilities.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_client.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/system.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/tools.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/int64.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/mt_support.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_alarm.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/callback.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/data_list.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/oid_stash.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/check_varbind.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/container.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/factory.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_logging.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_binary_array.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_list_ssll.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_iterator.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/container.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_assert.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/version.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/session_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_transport.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_service.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/ucd_compat.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/pdu_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/mib_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/mib.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/parse.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/varbind_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/config_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/read_config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/default_store.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_enum.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/vacm.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/output_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_debug.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/snmpv3_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpv3.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/transform_oids.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/keytools.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/scapi.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/lcd_time.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_secmod.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpusm.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mib_module_config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_module_config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/snmp_agent.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/snmp_vars.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_handler.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/var_struct.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_registry.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/library/fd_event_manager.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/ds_agent.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_read_config.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_trap.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/all_helpers.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/instance.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/baby_steps.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/scalar.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/scalar_group.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/watcher.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/multiplexer.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/null.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/debug_handler.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/cache_handler.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/old_api.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/read_only.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/row_merge.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/serialize.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mode_end_call.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_data.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_dataset.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_tdata.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_iterator.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_container.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_array.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mfd.h
-./ucd-snmp/memory.lo: ../../include/net-snmp/agent/hardware/memory.h
-./ucd-snmp/memory.lo: ./ucd-snmp/memory.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/machine/generic.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/net-snmp-includes.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/definitions.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/types.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/asn1.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_impl.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp-tc.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/utilities.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_client.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/system.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/tools.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/int64.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/mt_support.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_alarm.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/callback.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/data_list.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/oid_stash.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/check_varbind.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/factory.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_logging.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/container_binary_array.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/container_list_ssll.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/container_iterator.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_assert.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/version.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/session_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_transport.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_service.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/ucd_compat.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/pdu_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/mib_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/mib.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/parse.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/varbind_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/config_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/read_config.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/default_store.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_enum.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/vacm.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/output_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_debug.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/snmpv3_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpv3.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/transform_oids.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/keytools.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/scapi.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/lcd_time.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmp_secmod.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/snmpusm.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/mib_module_config.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/agent_module_config.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/snmp_agent.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/snmp_vars.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/agent_handler.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/var_struct.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/agent_registry.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/library/fd_event_manager.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/ds_agent.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/agent_read_config.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/agent_trap.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/all_helpers.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/instance.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/baby_steps.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/scalar.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/scalar_group.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/watcher.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/multiplexer.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/null.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/debug_handler.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/cache_handler.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/old_api.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/read_only.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/row_merge.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/serialize.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/mode_end_call.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_data.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_dataset.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_tdata.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_iterator.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_container.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/table_array.h
+./ucd-snmp/logmatch.lo: ../../include/net-snmp/agent/mfd.h struct.h
+./ucd-snmp/logmatch.lo: util_funcs.h ./ucd-snmp/logmatch.h mibdefs.h
 ./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/types.h
@@ -12134,7 +12184,115 @@
 ./ucd-snmp/memory_aix4.lo: ../../include/net-snmp/agent/auto_nlist.h
 ./ucd-snmp/memory_aix4.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_aix4.lo: ./ucd-snmp/memory_aix4.h mibdefs.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/machine/generic.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/net-snmp-includes.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/definitions.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/types.h 
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/asn1.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_impl.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp-tc.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/utilities.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_client.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/system.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/tools.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/int64.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/mt_support.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_alarm.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/callback.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/data_list.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/oid_stash.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/check_varbind.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/factory.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_logging.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_binary_array.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_list_ssll.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/container_iterator.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_assert.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/version.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/session_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_transport.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_service.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/ucd_compat.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/pdu_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/mib_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/mib.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/parse.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/varbind_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/config_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/read_config.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/default_store.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_enum.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/vacm.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/output_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_debug.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/snmpv3_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpv3.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/transform_oids.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/keytools.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/scapi.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/lcd_time.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmp_secmod.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/snmpusm.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mib_module_config.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_module_config.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/snmp_agent.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/snmp_vars.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_handler.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/var_struct.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_registry.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/library/fd_event_manager.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/ds_agent.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_read_config.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/agent_trap.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/all_helpers.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/instance.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/baby_steps.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/scalar.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/scalar_group.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/watcher.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/multiplexer.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/null.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/debug_handler.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/cache_handler.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/old_api.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/read_only.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/row_merge.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/serialize.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mode_end_call.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_data.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_dataset.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_tdata.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_iterator.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_container.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/table_array.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/mfd.h
+./ucd-snmp/memory.lo: ../../include/net-snmp/agent/hardware/memory.h
+./ucd-snmp/memory.lo: ./ucd-snmp/memory.h
 ./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_darwin7.lo: ../../include/net-snmp/types.h
@@ -12236,6 +12394,10 @@
 ./ucd-snmp/memory_darwin7.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_darwin7.lo: ./ucd-snmp/memory_darwin7.h mibdefs.h
 ./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_dynix.lo: ../../include/net-snmp/types.h
@@ -12337,6 +12499,10 @@
 ./ucd-snmp/memory_dynix.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_dynix.lo: ./ucd-snmp/memory_dynix.h mibdefs.h
 ./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_freebsd2.lo: ../../include/net-snmp/types.h
@@ -12438,6 +12604,10 @@
 ./ucd-snmp/memory_freebsd2.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_freebsd2.lo: ./ucd-snmp/memory_freebsd2.h mibdefs.h
 ./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_hpux.lo: ../../include/net-snmp/types.h
@@ -12539,6 +12709,10 @@
 ./ucd-snmp/memory_hpux.lo: ./ucd-snmp/memory.h ./ucd-snmp/memory_hpux.h
 ./ucd-snmp/memory_hpux.lo: mibdefs.h
 ./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_netbsd1.lo: ../../include/net-snmp/types.h
@@ -12640,6 +12814,10 @@
 ./ucd-snmp/memory_netbsd1.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_netbsd1.lo: ./ucd-snmp/memory_netbsd1.h mibdefs.h
 ./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/memory_solaris2.lo: ../../include/net-snmp/types.h
@@ -12741,6 +12919,10 @@
 ./ucd-snmp/memory_solaris2.lo: util_funcs.h struct.h ./ucd-snmp/memory.h
 ./ucd-snmp/memory_solaris2.lo: ./ucd-snmp/memory_solaris2.h mibdefs.h
 ./ucd-snmp/pass.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/pass.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/pass.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/pass.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/pass.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/pass.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/pass.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/pass.lo: ../../include/net-snmp/types.h 
@@ -12841,6 +13023,10 @@
 ./ucd-snmp/pass.lo: ./ucd-snmp/pass.h mibdefs.h ./ucd-snmp/extensible.h
 ./ucd-snmp/pass.lo: util_funcs.h
 ./ucd-snmp/pass_persist.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/pass_persist.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/pass_persist.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/pass_persist.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/pass_persist.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/pass_persist.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/pass_persist.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/pass_persist.lo: ../../include/net-snmp/types.h
@@ -12941,6 +13127,10 @@
 ./ucd-snmp/pass_persist.lo: ./ucd-snmp/pass_persist.h mibdefs.h
 ./ucd-snmp/pass_persist.lo: ./ucd-snmp/extensible.h util_funcs.h
 ./ucd-snmp/proc.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/proc.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/proc.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/proc.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/proc.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/proc.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/proc.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/proc.lo: ../../include/net-snmp/types.h 
@@ -13039,8 +13229,12 @@
 ./ucd-snmp/proc.lo: ../../include/net-snmp/agent/table_array.h
 ./ucd-snmp/proc.lo: ../../include/net-snmp/agent/mfd.h struct.h
 ./ucd-snmp/proc.lo: ./ucd-snmp/proc.h mibdefs.h ./ucd-snmp/errormib.h
-./ucd-snmp/proc.lo: util_funcs.h ../../agent/kernel.h 
+./ucd-snmp/proc.lo: util_funcs.h ../../agent/kernel.h
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/proxy.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/proxy.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/proxy.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/proxy.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/types.h 
@@ -13139,6 +13333,10 @@
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/agent/table_array.h
 ./ucd-snmp/proxy.lo: ../../include/net-snmp/agent/mfd.h ./ucd-snmp/proxy.h
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/versioninfo.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/versioninfo.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/versioninfo.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/versioninfo.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/types.h
@@ -13237,108 +13435,11 @@
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/agent/table_array.h
 ./ucd-snmp/versioninfo.lo: ../../include/net-snmp/agent/mfd.h struct.h
 ./ucd-snmp/versioninfo.lo: ./ucd-snmp/versioninfo.h mibdefs.h util_funcs.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/net-snmp-config.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/net-snmp-includes.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/definitions.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/types.h 
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/asn1.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_impl.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp-tc.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/utilities.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_client.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/system.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/tools.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/int64.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/mt_support.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_alarm.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/callback.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/data_list.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/oid_stash.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/check_varbind.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/factory.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_logging.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_binary_array.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_list_ssll.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_iterator.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_assert.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/version.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/session_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_transport.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_service.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/ucd_compat.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/pdu_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/mib_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/mib.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/parse.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/varbind_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/config_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/read_config.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/default_store.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_enum.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/vacm.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/output_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_debug.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/snmpv3_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpv3.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/transform_oids.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/keytools.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/scapi.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/lcd_time.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_secmod.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpusm.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mib_module_config.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_module_config.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/snmp_agent.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/snmp_vars.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_handler.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/var_struct.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_registry.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/fd_event_manager.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/ds_agent.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_read_config.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_trap.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/all_helpers.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/instance.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/baby_steps.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/scalar.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/scalar_group.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/watcher.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/multiplexer.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/null.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/debug_handler.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/cache_handler.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/old_api.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/read_only.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/row_merge.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/serialize.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/bulk_to_next.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mode_end_call.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_data.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_dataset.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_tdata.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_iterator.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_container.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_array.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mfd.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/auto_nlist.h
-./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/hardware/cpu.h
-./ucd-snmp/vmstat.lo: ./ucd-snmp/vmstat.h mibdefs.h
 ./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_aix4.lo: ../../include/net-snmp/types.h
@@ -13439,6 +13540,10 @@
 ./ucd-snmp/vmstat_aix4.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_aix4.lo: ./ucd-snmp/vmstat_aix4.h
 ./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/types.h
@@ -13539,7 +13644,116 @@
 ./ucd-snmp/vmstat_bsdi4.lo: ../../include/net-snmp/agent/auto_nlist.h
 ./ucd-snmp/vmstat_bsdi4.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_bsdi4.lo: mibdefs.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/machine/generic.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/net-snmp-includes.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/definitions.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/types.h 
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/asn1.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_impl.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp-tc.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/utilities.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_client.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/system.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/tools.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/int64.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/mt_support.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_alarm.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/callback.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/data_list.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/oid_stash.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/check_varbind.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/factory.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_logging.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_binary_array.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_list_ssll.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container_iterator.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/container.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_assert.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/version.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/session_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_transport.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_service.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/ucd_compat.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/pdu_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/mib_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/mib.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/parse.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/varbind_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/config_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/read_config.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/default_store.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_enum.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/vacm.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/output_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_debug.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/snmpv3_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpv3.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/transform_oids.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/keytools.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/scapi.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/lcd_time.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmp_secmod.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/snmpusm.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/net-snmp-agent-includes.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mib_module_config.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_module_config.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/snmp_agent.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/snmp_vars.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_handler.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/var_struct.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_registry.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/library/fd_event_manager.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/ds_agent.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_read_config.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/agent_trap.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/all_helpers.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/instance.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/baby_steps.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/scalar.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/scalar_group.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/watcher.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/multiplexer.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/null.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/debug_handler.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/cache_handler.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/old_api.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/read_only.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/row_merge.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/serialize.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/bulk_to_next.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mode_end_call.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_data.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_dataset.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_tdata.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_iterator.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_container.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/table_array.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/mfd.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/auto_nlist.h
+./ucd-snmp/vmstat.lo: ../../include/net-snmp/agent/hardware/cpu.h
+./ucd-snmp/vmstat.lo: ./ucd-snmp/vmstat.h mibdefs.h
 ./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_darwin7.lo: ../../include/net-snmp/types.h
@@ -13641,6 +13855,10 @@
 ./ucd-snmp/vmstat_darwin7.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_darwin7.lo: mibdefs.h ./ucd-snmp/vmstat_darwin7.h
 ./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_dynix.lo: ../../include/net-snmp/types.h
@@ -13741,6 +13959,10 @@
 ./ucd-snmp/vmstat_dynix.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_dynix.lo: ./ucd-snmp/vmstat_dynix.h
 ./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_freebsd2.lo: ../../include/net-snmp/types.h
@@ -13842,6 +14064,10 @@
 ./ucd-snmp/vmstat_freebsd2.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_freebsd2.lo: mibdefs.h ./ucd-snmp/vmstat_freebsd2.h
 ./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_hpux.lo: ../../include/net-snmp/types.h
@@ -13942,6 +14168,10 @@
 ./ucd-snmp/vmstat_hpux.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_hpux.lo: ./ucd-snmp/vmstat_hpux.h
 ./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_linux.lo: ../../include/net-snmp/types.h
@@ -14044,6 +14274,10 @@
 ./ucd-snmp/vmstat_linux.lo: mibdefs.h struct.h util_funcs.h
 ./ucd-snmp/vmstat_linux.lo: ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_netbsd1.lo: ../../include/net-snmp/types.h
@@ -14145,6 +14379,10 @@
 ./ucd-snmp/vmstat_netbsd1.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_netbsd1.lo: mibdefs.h
 ./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/net-snmp-config.h
+./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/system/linux.h
+./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/system/sysv.h
+./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/system/generic.h
+./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/machine/generic.h
 ./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/net-snmp-includes.h
 ./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/definitions.h
 ./ucd-snmp/vmstat_solaris2.lo: ../../include/net-snmp/types.h
@@ -14245,6 +14483,10 @@
 ./ucd-snmp/vmstat_solaris2.lo: util_funcs.h struct.h ./ucd-snmp/vmstat.h
 ./ucd-snmp/vmstat_solaris2.lo: ./ucd-snmp/vmstat_solaris2.h
 ./utilities/execute.lo: ../../include/net-snmp/net-snmp-config.h
+./utilities/execute.lo: ../../include/net-snmp/system/linux.h
+./utilities/execute.lo: ../../include/net-snmp/system/sysv.h
+./utilities/execute.lo: ../../include/net-snmp/system/generic.h
+./utilities/execute.lo: ../../include/net-snmp/machine/generic.h
 ./utilities/execute.lo: ../../include/net-snmp/net-snmp-includes.h
 ./utilities/execute.lo: ../../include/net-snmp/definitions.h
 ./utilities/execute.lo: ../../include/net-snmp/types.h
@@ -14344,6 +14586,10 @@
 ./utilities/execute.lo: ../../include/net-snmp/agent/mfd.h
 ./utilities/execute.lo: ucd-snmp/errormib.h mibdefs.h util_funcs.h struct.h
 ./utilities/iquery.lo: ../../include/net-snmp/net-snmp-config.h
+./utilities/iquery.lo: ../../include/net-snmp/system/linux.h
+./utilities/iquery.lo: ../../include/net-snmp/system/sysv.h
+./utilities/iquery.lo: ../../include/net-snmp/system/generic.h
+./utilities/iquery.lo: ../../include/net-snmp/machine/generic.h
 ./utilities/iquery.lo: ../../include/net-snmp/net-snmp-includes.h
 ./utilities/iquery.lo: ../../include/net-snmp/definitions.h
 ./utilities/iquery.lo: ../../include/net-snmp/types.h 
@@ -14442,6 +14688,10 @@
 ./utilities/iquery.lo: ../../include/net-snmp/agent/table_array.h
 ./utilities/iquery.lo: ../../include/net-snmp/agent/mfd.h utilities/iquery.h
 ./utilities/override.lo: ../../include/net-snmp/net-snmp-config.h
+./utilities/override.lo: ../../include/net-snmp/system/linux.h
+./utilities/override.lo: ../../include/net-snmp/system/sysv.h
+./utilities/override.lo: ../../include/net-snmp/system/generic.h
+./utilities/override.lo: ../../include/net-snmp/machine/generic.h
 ./utilities/override.lo: ../../include/net-snmp/net-snmp-includes.h
 ./utilities/override.lo: ../../include/net-snmp/definitions.h
 ./utilities/override.lo: ../../include/net-snmp/types.h

=== modified file 'agent/mibgroup/agent/extend.c'
--- agent/mibgroup/agent/extend.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/agent/extend.c	2010-06-10 18:02:54 +0000
@@ -1242,7 +1242,7 @@
             snmp_set_var_value( table_info->indexes,
                                 eptr->token, strlen(eptr->token));
             snmp_set_var_value( table_info->indexes->next_variable,
-                                &line_idx, sizeof(line_idx));
+                                (const u_char*)&line_idx, sizeof(line_idx));
         }
         return eptr;  /* Finally, signal success */
     }

=== modified file 'agent/mibgroup/agentx/agentx_config.c'
--- agent/mibgroup/agentx/agentx_config.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/agentx/agentx_config.c	2010-06-10 18:02:54 +0000
@@ -203,7 +203,8 @@
     netsnmp_register_default_domain("agentx", "unix tcp");
     netsnmp_register_default_target("agentx", "unix", NETSNMP_AGENTX_SOCKET);
 #define val(x) __STRING(x)
-    netsnmp_register_default_target("agentx", "tcp", ":" val(AGENTX_PORT));
+    netsnmp_register_default_target("agentx", "tcp",
+                                    "localhost:" val(AGENTX_PORT));
 #undef val
     agentx_register_config_handler("agentxsocket",
                                   agentx_parse_agentx_socket, NULL,

=== modified file 'agent/mibgroup/agentx/client.c'
--- agent/mibgroup/agentx/client.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/agentx/client.c	2010-06-10 18:02:54 +0000
@@ -65,7 +65,7 @@
     struct synch_state *state = (struct synch_state *) magic;
     struct timeval  now, diff;
 
-    if (reqid != state->reqid) {
+    if (!state || reqid != state->reqid) {
         return handle_agentx_packet(op, session, reqid, pdu, magic);
     }
 
@@ -139,6 +139,9 @@
     if (agentx_synch_response(ss, pdu, &response) != STAT_SUCCESS)
         return 0;
 
+    if (!response)
+        return 0;
+
     if (response->errstat != SNMP_ERR_NOERROR) {
         snmp_free_pdu(response);
         return 0;

=== modified file 'agent/mibgroup/agentx/protocol.c'
--- agent/mibgroup/agentx/protocol.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/agentx/protocol.c	2010-06-10 18:02:54 +0000
@@ -1105,13 +1105,14 @@
 {
     u_int           n_subid;
     u_int           prefix;
+    u_int           tmp_oid_len;
     int             i;
     int             int_offset;
     u_int          *int_ptr = (u_int *)oid_buf;
     u_char         *buf_ptr = data;
 
     if (*length < 4) {
-        DEBUGMSGTL(("agentx", "Incomplete Object ID"));
+        DEBUGMSGTL(("agentx", "Incomplete Object ID\n"));
         return NULL;
     }
 
@@ -1144,10 +1145,7 @@
         /*
          * Null OID 
          */
-        *int_ptr = 0;
-        int_ptr++;
-        *int_ptr = 0;
-        int_ptr++;
+        memset(int_ptr, 0, 2 * sizeof(oid));
         *oid_len = 2;
         DEBUGPRINTINDENT("dumpv_recv");
         DEBUGMSG(("dumpv_recv", "OID: NULL (0.0)\n"));
@@ -1155,6 +1153,14 @@
         return buf_ptr;
     }
 
+    /*
+     * Check that the expanded OID will fit in the buffer provided
+     */
+    tmp_oid_len = (prefix ? n_subid + 5 : n_subid);
+    if (*oid_len < tmp_oid_len) {
+        DEBUGMSGTL(("agentx", "Oversized Object ID\n"));
+        return NULL;
+    }
 
 #ifdef WORDS_BIGENDIAN
 # define endianoff 1
@@ -1162,7 +1168,7 @@
 # define endianoff 0
 #endif
     if (*length < 4 * n_subid) {
-        DEBUGMSGTL(("agentx", "Incomplete Object ID"));
+        DEBUGMSGTL(("agentx", "Incomplete Object ID\n"));
         return NULL;
     }
 
@@ -1199,7 +1205,7 @@
         *length -= 4;
     }
 
-    *oid_len = (prefix ? n_subid + 5 : n_subid);
+    *oid_len = tmp_oid_len;
 
     DEBUGINDENTLESS();
     DEBUGPRINTINDENT("dumpv_recv");
@@ -1220,19 +1226,19 @@
     u_int           len;
 
     if (*length < 4) {
-        DEBUGMSGTL(("agentx", "Incomplete string (too short: %d)",
+        DEBUGMSGTL(("agentx", "Incomplete string (too short: %d)\n",
                     *length));
         return NULL;
     }
 
     len = agentx_parse_int(data, network_byte_order);
     if (*length < len + 4) {
-        DEBUGMSGTL(("agentx", "Incomplete string (still too short: %d)",
+        DEBUGMSGTL(("agentx", "Incomplete string (still too short: %d)\n",
                     *length));
         return NULL;
     }
     if (len > *str_len) {
-        DEBUGMSGTL(("agentx", "String too long (too long)"));
+        DEBUGMSGTL(("agentx", "String too long (too long)\n"));
         return NULL;
     }
     memmove(string, data + 4, len);
@@ -1902,7 +1908,7 @@
      */
     len1 = BUFSIZ;
     if (agentx_build(&sess, pdu1, packet1, &len1) < 0) {
-        DEBUGMSGTL(("agentx", "First build failed"));
+        DEBUGMSGTL(("agentx", "First build failed\n"));
         exit(1);
     }
 

=== modified file 'agent/mibgroup/agentx/subagent.c'
--- agent/mibgroup/agentx/subagent.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/agentx/subagent.c	2010-06-10 18:02:54 +0000
@@ -111,6 +111,7 @@
     return 0;
 }
 
+static int subagent_init_init = 0;
 /**
  * init subagent callback (local) session and connect to master agent
  *
@@ -119,12 +120,11 @@
 int
 subagent_init(void)
 {
-    static int init = 0;
     int rc = 0;
 
     DEBUGMSGTL(("agentx/subagent", "initializing....\n"));
 
-    if (++init != 1)
+    if (++subagent_init_init != 1)
         return 0;
 
     netsnmp_assert(netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID,
@@ -505,7 +505,7 @@
              u = u->next_variable, v = v->next_variable) {
             if (snmp_oid_compare
                 (u->val.objid, u->val_len / sizeof(oid), nullOid,
-                 nullOidLen) != 0) {
+                 nullOidLen/sizeof(oid)) != 0) {
                 /*
                  * The master agent requested scoping for this variable.  
                  */
@@ -679,8 +679,13 @@
     }
     agentx_close_session(thesession, AGENTX_CLOSE_SHUTDOWN);
     snmp_close(thesession);
-    main_session = NULL;
+    if (main_session != NULL) {
+        remove_trap_session(main_session);
+        main_session = NULL;
+    }
     DEBUGMSGTL(("agentx/subagent", "shut down finished.\n"));
+
+    subagent_init_init = 0;
     return 1;
 }
 

=== modified file 'agent/mibgroup/disman/event/mteTriggerConf.c'
--- agent/mibgroup/disman/event/mteTriggerConf.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/disman/event/mteTriggerConf.c	2010-06-10 18:02:54 +0000
@@ -502,7 +502,6 @@
                     memcpy(oid_name_buf, buf, SPRINT_MAX_LEN);
                     memset(         buf,   0, SPRINT_MAX_LEN);
                     cp  = copy_nword(cp, buf, SPRINT_MAX_LEN);
-                    if ( buf[0] != '-' )
                         value = strtol(buf, NULL, 0);
     
                     /*
@@ -512,7 +511,7 @@
                     memcpy( buf, cp, strlen(cp));
                     cp = NULL;  /* To terminate the processing loop */
                     DEBUGMSGTL(("disman:event:conf", "%s: Thresh (%s, %d, %s)\n",
-                                              tname, oid_name_buf, op, buf));
+                                              tname, oid_name_buf, value, buf));
                     break;
                 }
             }
@@ -634,7 +633,6 @@
         }
         break;
     case MTE_TRIGGER_THRESHOLD:
-        if ( buf[0] != '-' ) {
             entry->mteTThFallValue  = value;
             value = strtol(buf, NULL, 0);
             entry->mteTThRiseValue  = value;
@@ -679,10 +677,7 @@
                 memcpy(entry->mteTThFallEvent,  "_mteTriggerFalling", 18);
             }
             cp = skip_token(buf);   /* skip riseThreshold value */
-        } else {
-            /* Skip absolute threshold placeholders */
-            cp = skip_token(buf);
-        }
+
         /*
          * Parse and set (optional) Delta thresholds & events
          */
@@ -1472,9 +1467,18 @@
 clear_mteTTable(int majorID, int minorID, void *serverarg, void *clientarg)
 {
     netsnmp_tdata_row *row;
-
+   
     while (( row = netsnmp_tdata_row_first( trigger_table_data ))) {
-        netsnmp_tdata_remove_and_delete_row( trigger_table_data, row );
+        struct mteTrigger *entry = (struct mteTrigger *)
+            netsnmp_tdata_remove_and_delete_row(trigger_table_data, row);
+        if (entry) {
+            /* Remove from the callbacks list and disable triggers */
+            snmp_unregister_callback( SNMP_CALLBACK_LIBRARY,
+                                      SNMP_CALLBACK_POST_READ_CONFIG,
+                                      _mteTrigger_callback_enable, entry, 0 ); 
+            mteTrigger_disable( entry );
+            SNMP_FREE(entry);
+        }
     }
     return SNMPERR_SUCCESS;
 }

=== modified file 'agent/mibgroup/disman/expression/expValueTable.c'
--- agent/mibgroup/disman/expression/expValueTable.c	2005-11-25 14:17:40 +0000
+++ agent/mibgroup/disman/expression/expValueTable.c	2010-06-10 18:02:54 +0000
@@ -63,9 +63,9 @@
     unsigned        data;
     struct s_node  *next;
 };
-typedef struct s_node link;
-link           *operater = NULL;
-link           *operand = NULL;
+typedef struct s_node nodelink;
+nodelink           *operater = NULL;
+nodelink           *operand = NULL;
 
 /*
  * variable2 expObjectTable_variables:
@@ -731,10 +731,10 @@
 
 
 void
-push(link ** stack, unsigned long value)
+push(nodelink ** stack, unsigned long value)
 {
-    link           *newnode;
-    newnode = (link *) malloc(sizeof(link));
+    nodelink           *newnode;
+    newnode = (nodelink *) malloc(sizeof(nodelink));
     if (!newnode) {
         printf("\nMemory allocation failure!");
         return;
@@ -745,10 +745,10 @@
 }
 
 unsigned long
-pop(link ** stack)
+pop(nodelink ** stack)
 {
     unsigned long   value;
-    link           *top;
+    nodelink           *top;
     top = *stack;
     *stack = (*stack)->next;
     value = top->data;

=== modified file 'agent/mibgroup/disman/mteTriggerTable.c'
--- agent/mibgroup/disman/mteTriggerTable.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/disman/mteTriggerTable.c	2010-06-10 18:02:54 +0000
@@ -192,17 +192,6 @@
     se_add_pair_to_slist("mteBooleanOperators", strdup(">="),
                          MTETRIGGERBOOLEANCOMPARISON_GREATEROREQUAL);
 
-#ifdef NETSNMP_TRANSPORT_CALLBACK_DOMAIN
-    /*
-     * open a 'callback' session to the main agent 
-     */
-    if (mte_callback_sess == NULL) {
-        mte_callback_sess = netsnmp_callback_open(callback_master_num,
-                                                  NULL, NULL, NULL);
-        DEBUGMSGTL(("mteTriggerTable", "created callback session = %08x\n",
-                    mte_callback_sess));
-    }
-#endif
     DEBUGMSGTL(("mteTriggerTable", "done.\n"));
 }
 
@@ -3063,6 +3052,11 @@
          * send to the local agent 
          */
 
+        if (mte_callback_sess == NULL)
+            mte_callback_sess =  netsnmp_query_get_default_session();
+        if (!mte_callback_sess)
+            return NULL;
+
         status = snmp_synch_response(mte_callback_sess, pdu, &response);
 
         if (status != SNMP_ERR_NOERROR ||

=== modified file 'agent/mibgroup/disman/schedule/schedCore.c'
--- agent/mibgroup/disman/schedule/schedCore.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/disman/schedule/schedCore.c	2010-06-10 18:02:54 +0000
@@ -463,13 +463,15 @@
      */
     if (schedOwner) {
         memcpy(entry->schedOwner, schedOwner, strlen(schedOwner));
+        netsnmp_tdata_row_add_index(row, ASN_OCTET_STR,
+                           entry->schedOwner, strlen(schedOwner));
     }
+    else
+        netsnmp_tdata_row_add_index(row, ASN_OCTET_STR, "", 0 );
+
     memcpy(    entry->schedName,  schedName,  strlen(schedName));
     netsnmp_tdata_row_add_index(row, ASN_OCTET_STR,
-                                (entry->schedOwner || ""),
-                                ((schedOwner) ? strlen(schedOwner) : 0));
-    netsnmp_tdata_row_add_index(row, ASN_OCTET_STR,
-                                entry->schedName,  strlen(schedName));
+                           entry->schedName,  strlen(schedName));
     /*
      * Set the (non-zero) default values in the row data structure.
      */

=== modified file 'agent/mibgroup/examples/ucdDemoPublic.c'
--- agent/mibgroup/examples/ucdDemoPublic.c	2004-09-13 12:06:21 +0000
+++ agent/mibgroup/examples/ucdDemoPublic.c	2010-06-10 18:02:54 +0000
@@ -219,8 +219,13 @@
     }
     if (action == COMMIT) {
         if (var_val_len != 0) {
-            strcpy(publicString, var_val);
-            publicString[var_val_len] = '\0';
+            strncpy(publicString, var_val, sizeof(publicString)-1);
+            /* some sanity checks */
+            if (strlen(var_val) > sizeof(publicString)-1 ||
+                    strlen(var_val) != var_val_len)
+                publicString[sizeof(publicString)-1] = '\0';
+            else
+                publicString[var_val_len] = '\0';
         } else
             publicString[0] = '\0';
     }

=== modified file 'agent/mibgroup/hardware/cpu/cpu.c'
--- agent/mibgroup/hardware/cpu/cpu.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/hardware/cpu/cpu.c	2010-06-10 18:02:54 +0000
@@ -15,6 +15,7 @@
 static netsnmp_cache    *_cpu_cache = NULL;
 
 void init_cpu( void ) {
+    oid nsCPU[] = { 1, 3, 6, 1, 4, 1, 8072, 1, 33 };
     /*
      * If we're sampling the CPU statistics automatically,
      *   then arrange for this to be triggered regularly,
@@ -35,8 +36,8 @@
         if ( _cpu_head )
             _cpu_update_stats( 0, NULL );
     } else
-        _cpu_cache = netsnmp_cache_create( 5, netsnmp_cpu_arch_load,
-                                           NULL, NULL, 0 );
+        _cpu_cache = netsnmp_cache_create( 5, netsnmp_cpu_arch_load, NULL,
+                                              nsCPU, OID_LENGTH(nsCPU));
 }
 
 void shutdown_cpu( void ) {

=== modified file 'agent/mibgroup/hardware/cpu/cpu_kstat.c'
--- agent/mibgroup/hardware/cpu/cpu_kstat.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/hardware/cpu/cpu_kstat.c	2010-06-10 18:02:54 +0000
@@ -54,10 +54,10 @@
                     state_begin = ks_data->value.i32;
                 } else if ( strcmp( ks_data->name, "cpu_type" ) == 0 ) {
                     strncpy( ctype, ks_data->value.c, sizeof(ctype));
-                    state[sizeof(ctype)-1] = '\0';
+                    ctype[sizeof(ctype)-1] = '\0';
                 } else if ( strcmp( ks_data->name, "fpu_type" ) == 0 ) {
                     strncpy( ftype, ks_data->value.c, sizeof(ftype));
-                    state[sizeof(ftype)-1] = '\0';
+                    ftype[sizeof(ftype)-1] = '\0';
                 } else if ( strcmp( ks_data->name, "clock_MHz" ) == 0 ) {
                     clock = ks_data->value.i32;
                 }
@@ -103,6 +103,8 @@
         if (strcmp(ksp->ks_module, "cpu_stat") == 0) {
             i    = ksp->ks_instance;
             cpu2 = netsnmp_cpu_get_byIdx( i, 0 );
+            if ( !cpu2 )  
+                break;   /* or continue ? */    /* Skip new CPUs */
             if ((ksp->ks_type != KSTAT_TYPE_RAW) ||
                 (ksp->ks_data_size != sizeof(cs))||
                 (kstat_read(kstat_fd, ksp, &cs) == -1)) {

=== modified file 'agent/mibgroup/hardware/cpu/cpu_linux.c'
--- agent/mibgroup/hardware/cpu/cpu_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/hardware/cpu/cpu_linux.c	2010-06-10 18:02:54 +0000
@@ -100,7 +100,7 @@
     static int   bsize = 0;
     static int   first = 1;
     static int   has_cpu_26 = 1;
-    int          statfd, i;
+    int          bytes_read, statfd, i;
     char        *b1, *b2;
     unsigned long long cusell = 0, cicell = 0, csysll = 0, cidell = 0,
                        ciowll = 0, cirqll = 0, csoftll = 0;
@@ -111,18 +111,24 @@
         return -1;
     }
     if (bsize == 0) {
-        bsize = 256;
-        buff = malloc(bsize);
+        bsize = getpagesize()-1;
+        buff = malloc(bsize+1);
     }
-    while (read(statfd, buff, bsize) == bsize) {
-        bsize += 256;
-        buff = realloc(buff, bsize);
+    while ((bytes_read = read(statfd, buff, bsize)) == bsize) {
+        bsize += BUFSIZ;
+        buff = realloc(buff, bsize+1);
         DEBUGMSGTL(("cpu", "/proc/stat buffer increased to %d\n", bsize));
         close(statfd);
         statfd = open(STAT_FILE, O_RDONLY, 0);
     }
     close(statfd);
 
+    if ( bytes_read < 0 ) {
+        snmp_log_perror(STAT_FILE "read error");
+        return -1;
+    }
+    buff[bytes_read] = '\0';
+
         /*
          * CPU statistics (overall and per-CPU)
          */
@@ -194,23 +200,29 @@
     static char *vmbuff  = NULL;
     static int   vmbsize = 0;
     static int   first   = 1;
-    int          vmstatfd;
+    int          bytes_read, vmstatfd;
     char        *b;
     unsigned long long pin, pout, swpin, swpout;
     unsigned long long itot, iticks, ctx;
 
     if (has_vmstat && (vmstatfd = open(VMSTAT_FILE, O_RDONLY, 0)) != -1) {
         if (vmbsize == 0) {
-	    vmbsize = 256;
-	    vmbuff = malloc(vmbsize);
+	    vmbsize = getpagesize()-1;
+	    vmbuff = malloc(vmbsize+1);
         }
-        while (read(vmstatfd, vmbuff, vmbsize) == vmbsize) {
-	    vmbsize += 256;
-	    vmbuff = realloc(vmbuff, vmbsize);
+        while ((bytes_read = read(vmstatfd, vmbuff, vmbsize)) == vmbsize) {
+	    vmbsize += BUFSIZ;
+	    vmbuff = realloc(vmbuff, vmbsize+1);
 	    close(vmstatfd);
 	    vmstatfd = open(VMSTAT_FILE, O_RDONLY, 0);
         }
         close(vmstatfd);
+
+        if ( bytes_read < 0 ) {
+            snmp_log_perror(STAT_FILE "read error");
+            return -1;
+        }
+        vmbuff[bytes_read] = '\0';
     }
     else
         has_vmstat = 0;

=== modified file 'agent/mibgroup/hardware/cpu/cpu_sysctl.c'
--- agent/mibgroup/hardware/cpu/cpu_sysctl.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/hardware/cpu/cpu_sysctl.c	2010-06-10 18:02:54 +0000
@@ -196,6 +196,7 @@
         cpu = netsnmp_cpu_get_byIdx( i, 0 );
         /* XXX - per-CPU statistics - mcpu_mib[i].??? */
     }
+    free(mcpu_stats);
 #else
         /* Copy "overall" figures to cpu0 entry */
     _cpu_copy_stats( cpu );

=== modified file 'agent/mibgroup/hardware/memory/hw_mem.c'
--- agent/mibgroup/hardware/memory/hw_mem.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/hardware/memory/hw_mem.c	2010-06-10 18:02:54 +0000
@@ -9,7 +9,9 @@
 netsnmp_cache       *_mem_cache = NULL;
 
 void init_hw_mem( void ) {
-    _mem_cache = netsnmp_cache_create( 5, netsnmp_mem_arch_load, NULL, NULL, 0);
+    oid nsMemory[] = { 1, 3, 6, 1, 4, 1, 8072, 1, 31 };
+    _mem_cache = netsnmp_cache_create( 5, netsnmp_mem_arch_load, NULL,
+                                          nsMemory, OID_LENGTH(nsMemory));
 }
 
 

=== modified file 'agent/mibgroup/hardware/memory/memory_hpux.c'
--- agent/mibgroup/hardware/memory/memory_hpux.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/hardware/memory/memory_hpux.c	2010-06-10 18:02:54 +0000
@@ -3,6 +3,7 @@
 #include <net-snmp/agent/net-snmp-agent-includes.h>
 #include <net-snmp/agent/hardware/memory.h>
 
+#include <sys/param.h>
 #include <sys/pstat.h>
 
 
@@ -117,13 +118,13 @@
                 sprintf(buf, "swap #%d %s", i, pss.pss_mntpt);
                 mem->descr = strdup( buf );
             }
-            mem->units = pss.pss_swapchunk;
-            mem->size  = pss.pss_nblksenabled;    /* Or pss_nblks      ? */
-            mem->free  = pss.pss_nfpgs;           /* Or pss_nblksavail ? */
+            mem->units = 1024;
+            mem->size  = (pss.pss_nblksavail * (DEV_BSIZE/512)) / 2;    /* Or pss_nblks      ? */
+            mem->free  = 4*pss.pss_nfpgs;           /* Or pss_nblksavail ? */
             mem->other = -1;
-            *total += mem->size;
-            *free  += mem->other;
-            *size   = pss.pss_swapchunk;  /* Hopefully consistent! */
+            *total +=mem->size;
+            *free  +=mem->free;
+            *size   = mem->units;  /* Hopefully consistent! */
             i++;
         } else
             return;

=== modified file 'agent/mibgroup/hardware/memory/memory_linux.c'
--- agent/mibgroup/hardware/memory/memory_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/hardware/memory/memory_linux.c	2010-06-10 18:02:54 +0000
@@ -10,8 +10,11 @@
  * Try to use an initial size that will cover default cases. We aren't talking
  * about huge files, so why fiddle about with reallocs?
  * I checked /proc/meminfo sizes on 3 different systems: 598, 644, 654
+ * 
+ * On newer systems, the size is up to around 930 (2.6.27 kernel)
+ *   or 1160  (2.6.28 kernel)
  */
-#define MEMINFO_INIT_SIZE   768
+#define MEMINFO_INIT_SIZE   1279
 #define MEMINFO_STEP_SIZE   256
 #define MEMINFO_FILE   "/proc/meminfo"
 
@@ -40,14 +43,14 @@
     }
     if (bsize == 0) {
         bsize = MEMINFO_INIT_SIZE;
-        buff = malloc(bsize);
+        buff = malloc(bsize+1);
         if (NULL == buff) {
             snmp_log(LOG_ERR, "malloc failed\n");
             return -1;
         }
     }
     while ((bytes_read = read(statfd, buff, bsize)) == bsize) {
-        b = realloc(buff, bsize + MEMINFO_STEP_SIZE);
+        b = realloc(buff, bsize + MEMINFO_STEP_SIZE + 1);
         if (NULL == b) {
             snmp_log(LOG_ERR, "malloc failed\n");
             return -1;
@@ -65,6 +68,8 @@
     close(statfd);
     if (bytes_read <= 0) {
         snmp_log_perror(MEMINFO_FILE);
+    } else {
+        buff[bytes_read] = '\0';
     }
 
     /*

=== modified file 'agent/mibgroup/host/hr_filesys.c'
--- agent/mibgroup/host/hr_filesys.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/host/hr_filesys.c	2010-06-10 18:02:54 +0000
@@ -618,7 +618,7 @@
     fp = fopen(ETC_MNTTAB, "r");
     if (!fp) {
       char tmpbuf[STRINGMAX];
-      snprintf( tmpbuf, sizeof(tmpbuf), "Can't open %s\n", ETC_MNTTAB );
+      snprintf( tmpbuf, sizeof(tmpbuf), "Can't open mnttab %s\n", ETC_MNTTAB );
       config_perror(tmpbuf);
     }
 #endif

=== modified file 'agent/mibgroup/host/hr_proc.c'
--- agent/mibgroup/host/hr_proc.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/host/hr_proc.c	2010-06-10 18:02:54 +0000
@@ -175,11 +175,15 @@
         return (u_char *) nullOid;
     case HRPROC_LOAD:
         cpu = netsnmp_cpu_get_byIdx( proc_idx & HRDEV_TYPE_MASK, 0 );
-        if ( !cpu || !cpu->history || !cpu->history[0].total_hist )
+        if ( !cpu || !cpu->history || !cpu->history[0].total_hist ||
+           ( cpu->history[0].total_hist == cpu->total_ticks ))
             return NULL;
 
         long_return  = (cpu->idle_ticks  - cpu->history[0].idle_hist)*100;
-        long_return /= (cpu->total_ticks - cpu->history[0].total_hist);
+        if (cpu->total_ticks > cpu->history[0].total_hist) /* avoid div. by 0 */
+            long_return /= (cpu->total_ticks - cpu->history[0].total_hist);
+        else
+            long_return = 0; 
         long_return  = 100 - long_return;
         if (long_return < 0)
             long_return = 0;

=== modified file 'agent/mibgroup/host/hr_storage.c'
--- agent/mibgroup/host/hr_storage.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/host/hr_storage.c	2010-06-10 18:02:54 +0000
@@ -524,6 +524,7 @@
 
         store_idx = name[ HRSTORE_ENTRY_NAME_LENGTH ];
         if (HRFS_entry &&
+	    store_idx > NETSNMP_MEM_TYPE_MAX &&
             netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID,
                                    NETSNMP_DS_AGENT_SKIPNFSINHOSTRESOURCES) &&
             Check_HR_FileSys_NFS())
@@ -556,7 +557,11 @@
         if (store_idx > NETSNMP_MEM_TYPE_MAX)
             if (storageUseNFS && Check_HR_FileSys_NFS())
                 storage_type_id[storage_type_len - 1] = 10;     /* Network Disk */
-#if HAVE_HASMNTOPT
+#if HAVE_HASMNTOPT && !(defined(aix4) || defined(aix5) || defined(aix6))
+            /* 
+             * hasmntopt takes "const struct mntent*", but HRFS_entry has been
+             * defined differently for AIX, so skip this for AIX
+             */
             else if (hasmntopt(HRFS_entry, "loop") != NULL)
                 storage_type_id[storage_type_len - 1] = 5;      /* Removable Disk */
 #endif

=== modified file 'agent/mibgroup/host/hr_swinst.c'
--- agent/mibgroup/host/hr_swinst.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/host/hr_swinst.c	2010-06-10 18:02:54 +0000
@@ -136,7 +136,7 @@
 extern void     Init_HR_SWInst(void);
 extern int      Get_Next_HR_SWInst(void);
 extern void     End_HR_SWInst(void);
-extern void     Save_HR_SW_info(int ix);
+extern int      Save_HR_SW_info(int ix);
 
 #ifdef HAVE_LIBRPM
 static void     Mark_HRSW_token(void);
@@ -288,6 +288,7 @@
     oid             newname[MAX_OID_LEN];
     int             swinst_idx, LowIndex = -1;
     int             result;
+    int             err = 0, errcount = 0;
 
     DEBUGMSGTL(("host/hr_swinst", "var_hrswinstEntry: "));
     DEBUGMSGOID(("host/hr_swinst", name, *length));
@@ -298,29 +299,38 @@
      * Find "next" installed software entry 
      */
 
-    Init_HR_SWInst();
-    while ((swinst_idx = Get_Next_HR_SWInst()) != -1) {
-        DEBUGMSG(("host/hr_swinst", "(index %d ....", swinst_idx));
+    do {
+        Init_HR_SWInst();
+        while ((swinst_idx = Get_Next_HR_SWInst()) != -1) {
+            DEBUGMSG(("host/hr_swinst", "(index %d ....", swinst_idx));
 
-        newname[HRSWINST_ENTRY_NAME_LENGTH] = swinst_idx;
-        DEBUGMSGOID(("host/hr_swinst", newname, *length));
-        DEBUGMSG(("host/hr_swinst", "\n"));
-        result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
-        if (exact && (result == 0)) {
-            LowIndex = swinst_idx;
-            Save_HR_SW_info(LowIndex);
-            break;
-        }
-        if ((!exact && (result < 0)) &&
-            (LowIndex == -1 || swinst_idx < LowIndex)) {
-            LowIndex = swinst_idx;
-            Save_HR_SW_info(LowIndex);
+            newname[HRSWINST_ENTRY_NAME_LENGTH] = swinst_idx;
+            DEBUGMSGOID(("host/hr_swinst", newname, *length));
+            DEBUGMSG(("host/hr_swinst", "\n"));
+            result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
+            if (exact && (result == 0)) {
+                LowIndex = swinst_idx;
+                err = Save_HR_SW_info(LowIndex);
+                break;
+            }
+            if ((!exact && (result < 0)) &&
+                (LowIndex == -1 || swinst_idx < LowIndex)) {
+                LowIndex = swinst_idx;
+                err = Save_HR_SW_info(LowIndex);
 #ifdef HRSWINST_MONOTONICALLY_INCREASING
-            break;
+                break;
 #endif
+            }
         }
+        if (err != 0 )
+            errcount++;
+    /* restart until Save_HR_SW_info() succeeds,max. 3 times */
+    } while (err != 0 && errcount < 3); 
+    if (err != 0) {
+        DEBUGMSGTL(("host/hr_swinst", "restart did not help, bailing out\n"));
+        return (MATCH_FAILED);
     }
-
+	    
     Mark_HRSW_token();
     End_HR_SWInst();
 
@@ -417,7 +427,8 @@
 #ifdef HAVE_PKGINFO
             pver = pkgparam(swi->swi_name, "VERSION");
             /* 1 spot for the terminating null and one for the dash */
-            if (strlen(pver) + 2 + strlen(string) <= sizeof(string)) {
+            if (pver &&
+               (strlen(pver) + 2 + strlen(string) <= sizeof(string))) {
                 strcat(string, "-");
                 strcat(string, pver);
             }
@@ -477,7 +488,7 @@
     case HRSWINST_DATE:
         {
 #ifdef HAVE_LIBRPM
-            int_32         *rpm_data;
+            int         *rpm_data;
             if ( headerGetEntry(swi->swi_h, RPMTAG_INSTALLTIME, NULL, (void **) &rpm_data, NULL) ) {
                 time_t          installTime = *rpm_data;
                 ret = date_n_time(&installTime, var_len);
@@ -634,7 +645,7 @@
     return -1;
 }
 
-void
+int
 Save_HR_SW_info(int ix)
 {
     SWI_t          *swi = &_myswi;      /* XXX static for now */
@@ -663,8 +674,13 @@
         h = rpmdbGetRecord(swi->swi_rpmdb, offset);
 #endif
 
-        if (h == NULL)
-            return;
+        if (h == NULL) {
+            DEBUGMSGTL(("host/hr_swinst",
+                    "RPM cache has probably expired when reading entry %d, "
+                    "reloading...\n", ix));
+            swi->swi_timestamp = 0;
+            return -1;
+        }
         if (swi->swi_h != NULL)
             headerFree(swi->swi_h);
         swi->swi_h = h;
@@ -682,6 +698,7 @@
     snprintf(swi->swi_name, sizeof(swi->swi_name), swi->swi_dep->d_name);
     swi->swi_name[ sizeof(swi->swi_name)-1 ] = 0;
 #endif
+    return 0;
 }
 
 #ifdef	HAVE_LIBRPM

=== modified file 'agent/mibgroup/host/hr_swrun.c'
--- agent/mibgroup/host/hr_swrun.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/host/hr_swrun.c	2010-06-10 18:02:54 +0000
@@ -84,6 +84,11 @@
 #include <net-snmp/agent/auto_nlist.h>
 #include "kernel.h"
 #ifdef solaris2
+#if _SLASH_PROC_METHOD_ && defined _ILP32
+#include <net-snmp/agent/cache_handler.h>
+#include <net-snmp/agent/hardware/memory.h>
+#endif
+
 #include "kernel_sunos5.h"
 #endif
 #if defined(aix4) || defined(aix5) || defined(aix6)
@@ -742,8 +747,7 @@
             sprintf(string, "/proc/%d/status", pid);
             if ((fp = fopen(string, "r")) == NULL)
                 return NULL;
-            fgets(buf, sizeof(buf), fp);        /* Name: process name */
-            if ( cp == NULL ) {
+            if (!fgets(buf, sizeof(buf), fp)) {
                 fclose(fp);
                 return NULL;    /* the process probably died */
             }
@@ -1151,7 +1155,32 @@
         long_return = (lowpsinfo.pr_rssize * MMU_PAGESIZE) / 1024;
 #elif defined(solaris2)
 #if _SLASH_PROC_METHOD_
+#ifdef _ILP32
+        if(NULL != proc_buf && 0 == proc_buf->pr_rssize)
+        { /* Odds on that we are looking with a 32 bit app at a 64 bit psinfo.*/
+            netsnmp_memory_info *mem;
+            netsnmp_memory_load();
+            mem = netsnmp_memory_get_byIdx( NETSNMP_MEM_TYPE_PHYSMEM, 0 );
+            if (!mem) 
+            {
+                snmp_log(LOG_INFO, "netsnmp_memory_get_byIdx returned NULL pointer\n");
+                long_return = 0;/* Tried my best, giving up.*/
+            } 
+            else 
+            {/* 0x8000 is the maximum range of pr_pctmem. devision of 1024 is to go from B to kB*/
+                uint32_t pct_unit = (mem->size/0x8000) * (mem->units/1024);
+                long_return = proc_buf ? proc_buf->pr_pctmem * pct_unit : 0;
+            }
+        }
+        else
+        {    
+            long_return = proc_buf ? proc_buf->pr_rssize : 0;
+        
+        }
+#else /*_LP64*/
         long_return = proc_buf ? proc_buf->pr_rssize : 0;
+#endif /*_LP64*/
+
 #else
         long_return = proc_buf->p_swrss;
 #endif

=== modified file 'agent/mibgroup/if-mib/data_access/interface.c'
--- agent/mibgroup/if-mib/data_access/interface.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/if-mib/data_access/interface.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Interface MIB architecture support
  *
- * $Id: interface.c 16830 2008-02-22 23:52:33Z hardaker $
+ * $Id: interface.c 17263 2008-10-16 09:56:01Z jsafranek $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -665,6 +665,7 @@
         entry->speed = 4000000;
     else
         entry->speed = 0;
+    entry->speed_high = entry->speed / 1000000LL;
 }
 
 netsnmp_conf_if_list *
@@ -702,7 +703,12 @@
         netsnmp_access_interface_entry_overrides_get(entry->name);
     if (if_ptr) {
         entry->type = if_ptr->type;
-        entry->speed = if_ptr->speed;
+        if (if_ptr->speed > 0xffffffff) {
+            entry->speed = 0xffffffff;
+        } else {
+            entry->speed = if_ptr->speed;
+        }
+        entry->speed_high = if_ptr->speed / 1000000LL;
     }
 }
 
@@ -747,7 +753,7 @@
         config_perror("Out of memory");
         return;
     }
-    if_new->speed = strtoul(speed, &ecp, 0);
+    if_new->speed = strtoull(speed, &ecp, 0);
     if (*ecp) {
         config_perror("Bad SPEED value");
         free(if_new);

=== modified file 'agent/mibgroup/if-mib/data_access/interface_linux.c'
--- agent/mibgroup/if-mib/data_access/interface_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/if-mib/data_access/interface_linux.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Interface MIB architecture support
  *
- * $Id: interface_linux.c 16944 2008-05-14 13:35:40Z tanders $
+ * $Id: interface_linux.c 18100 2010-02-05 09:48:46Z jsafranek $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -41,11 +41,13 @@
 #define IF_NAMESIZE 16
 #endif
 
-unsigned int
-netsnmp_linux_interface_get_if_speed(int fd, const char *name);
+unsigned long long
+netsnmp_linux_interface_get_if_speed(int fd, const char *name,
+        unsigned long long defaultspeed);
 #ifdef HAVE_LINUX_ETHTOOL_H
-unsigned int
-netsnmp_linux_interface_get_if_speed_mii(int fd, const char *name);
+unsigned long long
+netsnmp_linux_interface_get_if_speed_mii(int fd, const char *name,
+        unsigned long long defaultspeed);
 #endif
 
 #define PROC_SYS_NET_IPVx_NEIGH_RETRANS_TIME_MS "/proc/sys/net/ipv%d/neigh/%s/retrans_time_ms"
@@ -635,9 +637,24 @@
                 entry->type = IANAIFTYPE_OTHER;
         }
 
-        if (IANAIFTYPE_ETHERNETCSMACD == entry->type)
-            entry->speed =
-                netsnmp_linux_interface_get_if_speed(fd, entry->name);
+        if (IANAIFTYPE_ETHERNETCSMACD == entry->type) {
+            unsigned long long speed;
+            unsigned long long defaultspeed = NOMINAL_LINK_SPEED;
+            if (!(entry->os_flags & IFF_RUNNING)) {
+                /*
+                 * use speed 0 if the if speed cannot be determined *and* the
+                 * interface is down
+                 */
+                defaultspeed = 0;
+            }
+            speed = netsnmp_linux_interface_get_if_speed(fd,
+                    entry->name, defaultspeed);
+            if (speed > 0xffffffffL) {
+                entry->speed = 0xffffffff;
+            } else
+                entry->speed = speed;
+            entry->speed_high = speed / 1000000LL;
+        }
 #ifdef APPLIED_PATCH_836390   /* xxx-rks ifspeed fixes */
         else if (IANAIFTYPE_PROPVIRTUAL == entry->type)
             entry->speed = _get_bonded_if_speed(entry);
@@ -680,8 +697,6 @@
 
         netsnmp_access_interface_entry_overrides(entry);
 
-        entry->speed_high = entry->speed / 1000000;
-
         if (! (load_flags & NETSNMP_ACCESS_INTERFACE_LOAD_NO_STATS))
             _parse_stats(entry, stats, scan_expected);
 
@@ -727,14 +742,16 @@
 /**
  * Determines network interface speed from ETHTOOL_GSET
  */
-unsigned int
-netsnmp_linux_interface_get_if_speed(int fd, const char *name)
+unsigned long long
+netsnmp_linux_interface_get_if_speed(int fd, const char *name,
+            unsigned long long defaultspeed)
 {
     struct ifreq ifr;
     struct ethtool_cmd edata;
 
     memset(&ifr, 0, sizeof(ifr));
     edata.cmd = ETHTOOL_GSET;
+    edata.speed = 0;
     
     strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name)-1);
     ifr.ifr_data = (char *) &edata;
@@ -742,35 +759,43 @@
     if (ioctl(fd, SIOCETHTOOL, &ifr) == -1) {
         DEBUGMSGTL(("mibII/interfaces", "ETHTOOL_GSET on %s failed\n",
                     ifr.ifr_name));
-        return netsnmp_linux_interface_get_if_speed_mii(fd,name);
+        return netsnmp_linux_interface_get_if_speed_mii(fd,name,defaultspeed);
     }
     
-    if (edata.speed != SPEED_10 && edata.speed != SPEED_100 &&
-        edata.speed != SPEED_1000) {
+    if (edata.speed != SPEED_10 && edata.speed != SPEED_100
+#ifdef SPEED_10000
+        && edata.speed != SPEED_10000
+#endif
+#ifdef SPEED_2500
+        && edata.speed != SPEED_2500
+#endif
+        && edata.speed != SPEED_1000 ) {
         DEBUGMSGTL(("mibII/interfaces", "fallback to mii for %s\n",
                     ifr.ifr_name));
         /* try MII */
-        return netsnmp_linux_interface_get_if_speed_mii(fd,name);
+        return netsnmp_linux_interface_get_if_speed_mii(fd,name,defaultspeed);
     }
 
     /* return in bps */
     DEBUGMSGTL(("mibII/interfaces", "ETHTOOL_GSET on %s speed = %d\n",
                 ifr.ifr_name, edata.speed));
-    return edata.speed*1000*1000;
+    return edata.speed*1000LL*1000LL;
 }
 #endif
  
 /**
  * Determines network interface speed from MII
  */
-unsigned int
+unsigned long long
 #ifdef HAVE_LINUX_ETHTOOL_H
-netsnmp_linux_interface_get_if_speed_mii(int fd, const char *name)
+netsnmp_linux_interface_get_if_speed_mii(int fd, const char *name,
+        unsigned long long  defaultspeed)
 #else
-netsnmp_linux_interface_get_if_speed(int fd, const char *name)
+netsnmp_linux_interface_get_if_speed(int fd, const char *name,
+        unsigned long long defaultspeed)
 #endif
 {
-    unsigned int retspeed = 10000000;
+    unsigned long long retspeed = defaultspeed;
     struct ifreq ifr;
 
     /* the code is based on mii-diag utility by Donald Becker
@@ -781,7 +806,7 @@
     int mii_reg, i;
     ushort mii_val[32];
     ushort bmcr, bmsr, nway_advert, lkpar;
-    const unsigned int media_speeds[] = {10000000, 10000000, 100000000, 100000000, 10000000, 0};	
+    const unsigned long long media_speeds[] = {10000000, 10000000, 100000000, 100000000, 10000000, 0};
     /* It corresponds to "10baseT", "10baseT-FD", "100baseTx", "100baseTx-FD", "100baseT4", "Flow-control", 0, */
 
     strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));

=== modified file 'agent/mibgroup/if-mib/data_access/interface_sysctl.c'
--- agent/mibgroup/if-mib/data_access/interface_sysctl.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/if-mib/data_access/interface_sysctl.c	2010-06-10 18:02:54 +0000
@@ -3,7 +3,7 @@
  *
  *  Based on patch 1362403, submited by Rojer
  *
- * $Id: interface_sysctl.c 16552 2007-06-20 21:34:24Z tanders $
+ * $Id: interface_sysctl.c 17481 2009-04-09 08:44:41Z dts12 $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -451,22 +451,22 @@
             NETSNMP_INTERFACE_FLAGS_HAS_V6_REASMMAX;
 
         /* get counters */
-        entry->stats.ibytes.low = ifp->ifm_data.ifi_ibytes;
-        entry->stats.ibytes.high = 0;
-        entry->stats.iucast.low = ifp->ifm_data.ifi_ipackets;
-        entry->stats.iucast.high = 0;
-        entry->stats.imcast.low = ifp->ifm_data.ifi_imcasts;
-        entry->stats.imcast.high = 0;
+        entry->stats.ibytes.low  = ifp->ifm_data.ifi_ibytes   & 0xffffffff;
+        entry->stats.ibytes.high = ifp->ifm_data.ifi_ibytes   >> 32;
+        entry->stats.iucast.low  = ifp->ifm_data.ifi_ipackets & 0xffffffff;
+        entry->stats.iucast.high = ifp->ifm_data.ifi_ipackets >> 32;
+        entry->stats.imcast.low  = ifp->ifm_data.ifi_imcasts  & 0xffffffff;
+        entry->stats.imcast.high = ifp->ifm_data.ifi_imcasts  >> 32;
         entry->stats.ierrors = ifp->ifm_data.ifi_ierrors;
         entry->stats.idiscards = ifp->ifm_data.ifi_iqdrops;
         entry->stats.iunknown_protos = ifp->ifm_data.ifi_noproto;
 
-        entry->stats.obytes.low = ifp->ifm_data.ifi_obytes;
-        entry->stats.obytes.high = 0;
-        entry->stats.oucast.low = ifp->ifm_data.ifi_opackets;
-        entry->stats.oucast.high = 0;
-        entry->stats.omcast.low = ifp->ifm_data.ifi_omcasts;
-        entry->stats.omcast.high = 0;
+        entry->stats.obytes.low  = ifp->ifm_data.ifi_obytes   & 0xffffffff;
+        entry->stats.obytes.high = ifp->ifm_data.ifi_obytes   >> 32;
+        entry->stats.oucast.low  = ifp->ifm_data.ifi_opackets & 0xffffffff;
+        entry->stats.oucast.high = ifp->ifm_data.ifi_opackets >> 32;
+        entry->stats.omcast.low  = ifp->ifm_data.ifi_omcasts  & 0xffffffff;
+        entry->stats.omcast.high = ifp->ifm_data.ifi_omcasts  >> 32;
         entry->stats.oerrors = ifp->ifm_data.ifi_oerrors;
         entry->ns_flags |=  NETSNMP_INTERFACE_FLAGS_HAS_BYTES |
                             NETSNMP_INTERFACE_FLAGS_HAS_DROPS |

=== modified file 'agent/mibgroup/if-mib/ifXTable/ifXTable.c'
--- agent/mibgroup/if-mib/ifXTable/ifXTable.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/if-mib/ifXTable/ifXTable.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.48 $ of : mfd-top.m2c,v $ 
  *
- * $Id: ifXTable.c 15462 2006-10-19 21:42:46Z hardaker $
+ * $Id: ifXTable.c 18249 2010-03-11 11:26:48Z dts12 $
  */
 /** \page MFD helper for ifXTable
  *
@@ -1261,7 +1261,7 @@
      * copy (* ifHighSpeed_val_ptr ) from rowreq_ctx->data
      */
     if (0 == rowreq_ctx->data.ifHighSpeed)
-        (*ifHighSpeed_val_ptr) = rowreq_ctx->data.ifSpeed / 100000;
+        (*ifHighSpeed_val_ptr) = rowreq_ctx->data.ifSpeed / 1000000;
     else
         (*ifHighSpeed_val_ptr) = rowreq_ctx->data.ifHighSpeed;
 

=== modified file 'agent/mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.c'
--- agent/mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ip-forward-mib/ipCidrRouteTable/ipCidrRouteTable_interface.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.67 $ of : mfd-interface.m2c,v $ 
  *
- * $Id: ipCidrRouteTable_interface.c 15781 2007-01-23 22:55:06Z rstory $
+ * $Id: ipCidrRouteTable_interface.c 17684 2009-07-10 07:46:43Z jsafranek $
  */
 /*
  * *********************************************************************
@@ -860,7 +860,7 @@
          */
     case COLUMN_IPCIDRROUTEDEST:
         var->type = ASN_IPADDRESS;
-        var->val_len = sizeof(u_long);
+        var->val_len = sizeof(in_addr_t);
         (*var->val.integer) = rowreq_ctx->tbl_idx.ipCidrRouteDest;
         break;
 
@@ -869,7 +869,7 @@
          */
     case COLUMN_IPCIDRROUTEMASK:
         var->type = ASN_IPADDRESS;
-        var->val_len = sizeof(u_long);
+        var->val_len = sizeof(in_addr_t);
         (*var->val.integer) = rowreq_ctx->tbl_idx.ipCidrRouteMask;
         break;
 
@@ -887,7 +887,7 @@
          */
     case COLUMN_IPCIDRROUTENEXTHOP:
         var->type = ASN_IPADDRESS;
-        var->val_len = sizeof(u_long);
+        var->val_len = sizeof(in_addr_t);
         (*var->val.integer) = rowreq_ctx->tbl_idx.ipCidrRouteNextHop;
         break;
 

=== modified file 'agent/mibgroup/ip-mib/data_access/arp_linux.c'
--- agent/mibgroup/ip-mib/data_access/arp_linux.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ip-mib/data_access/arp_linux.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Interface MIB architecture support
  *
- * $Id: arp_linux.c 16381 2007-05-17 21:53:28Z hardaker $
+ * $Id: arp_linux.c 17892 2009-12-09 14:37:16Z jsafranek $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -59,7 +59,10 @@
     char            line[128];
     int             rc = 0;
     netsnmp_arp_entry *entry;
-    
+    char           arp[3*NETSNMP_ACCESS_ARP_PHYSADDR_BUF_SIZE+1];
+    char           *arp_token;
+    int             i;
+
     netsnmp_assert(NULL != container);
 
 #define PROCFILE "/proc/net/arp"
@@ -79,23 +82,22 @@
      */
     while (fgets(line, sizeof(line), in)) {
         
-        int             za, zb, zc, zd, ze, zf, zg, zh, zi, zj;
+        int             za, zb, zc, zd;
         int             tmp_flags;
         char            ifname[21];
 
         rc = sscanf(line,
-                    "%d.%d.%d.%d 0x%*x 0x%x %x:%x:%x:%x:%x:%x %*[^ ] %20s\n",
-                    &za, &zb, &zc, &zd, &tmp_flags, &ze, &zf, &zg, &zh, &zi,
-                    &zj, ifname);
-        if (12 != rc) {            
+                    "%d.%d.%d.%d 0x%*x 0x%x %96s %*[^ ] %20s\n",
+                    &za, &zb, &zc, &zd, &tmp_flags, arp, ifname);
+        if (7 != rc) {
             snmp_log(LOG_ERR, PROCFILE " data format error (%d!=12)\n", rc);
             snmp_log(LOG_ERR, " line ==|%s|\n", line);
             continue;
         }
         DEBUGMSGTL(("access:arp:container",
                     "ip addr %d.%d.%d.%d, flags 0x%X, hw addr "
-                    "%x:%x:%x:%x:%x:%x, name %s\n",
-                    za,zb,zc,zd, tmp_flags, ze,zf,zg,zh,zi,zj, ifname ));
+                    "%s, name %s\n",
+                    za,zb,zc,zd, tmp_flags, arp, ifname ));
 
         /*
          */
@@ -134,13 +136,10 @@
         /*
          * parse hw addr
          */
-        entry->arp_physaddress[0] = ze;
-        entry->arp_physaddress[1] = zf;
-        entry->arp_physaddress[2] = zg;
-        entry->arp_physaddress[3] = zh;
-        entry->arp_physaddress[4] = zi;
-        entry->arp_physaddress[5] = zj;
-        entry->arp_physaddress_len = 6;
+        for (arp_token = strtok(arp, ":"), i=0; arp_token != NULL; arp_token = strtok(NULL, ":"), i++) {
+            entry->arp_physaddress[i] = strtol(arp_token, NULL, 16);
+        }
+        entry->arp_physaddress_len = i;
 
         /*
          * what can we do with hw? from arp manpage:

=== modified file 'agent/mibgroup/ip-mib/data_access/ipaddress_ioctl.c'
--- agent/mibgroup/ip-mib/data_access/ipaddress_ioctl.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/ip-mib/data_access/ipaddress_ioctl.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Interface MIB architecture support
  *
- * $Id: ipaddress_ioctl.c 16778 2008-01-17 00:09:33Z magfr $
+ * $Id: ipaddress_ioctl.c 17850 2009-11-30 16:30:12Z dts12 $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -532,7 +532,7 @@
                  */
                 snmp_log(LOG_ERR, "bad rc from ioctl, errno %d", errno);
                 SNMP_FREE(ifc->ifc_buf);
-                break;
+                return -1;
             }
             /*
              * Otherwise, it could just be that the buffer is too small.  

=== modified file 'agent/mibgroup/ip-mib/data_access/ipaddress_linux.c'
--- agent/mibgroup/ip-mib/data_access/ipaddress_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/ip-mib/data_access/ipaddress_linux.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Interface MIB architecture support
  *
- * $Id: ipaddress_linux.c 17155 2008-08-13 13:02:12Z jsafranek $
+ * $Id: ipaddress_linux.c 18009 2010-01-21 14:55:34Z jsafranek $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -220,7 +220,7 @@
          * F: flags (see include/linux/rtnetlink.h, net/ipv6/addrconf.c)
          * I: interface
          */
-        rc = sscanf(line, "%39s %04x %02x %02x %02x %" SNMP_MACRO_VAL_TO_STR(IFNAMSIZ) "s\n",
+        rc = sscanf(line, "%39s %08x %08x %04x %02x %" SNMP_MACRO_VAL_TO_STR(IFNAMSIZ) "s\n",
                     addr, &if_index, &pfx_len, &scope, &flags, if_name);
         if( 6 != rc ) {
             snmp_log(LOG_ERR, PROCFILE " data format error (%d!=6), line ==|%s|\n",
@@ -325,7 +325,11 @@
         /*
          * add entry to container
          */
-        CONTAINER_INSERT(container, entry);
+        if (CONTAINER_INSERT(container, entry) < 0) {
+            DEBUGMSGTL(("access:ipaddress:container","error with ipaddress_entry: insert into container failed.\n"));
+            netsnmp_access_ipaddress_entry_free(entry);
+            continue;
+        }
     }
 
     fclose(in);

=== modified file 'agent/mibgroup/ip-mib/data_access/systemstats_common.c'
--- agent/mibgroup/ip-mib/data_access/systemstats_common.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ip-mib/data_access/systemstats_common.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  Systemstats MIB architecture support
  *
- * $Id: systemstats_common.c 11913 2005-02-08 21:58:36Z nba $
+ * $Id: systemstats_common.c 17714 2009-08-04 10:57:52Z jsafranek $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -340,13 +340,13 @@
     if (0 == need_wrap_check) {
         SNMP_FREE(prev_vals->old_stats);
     }
-    
-    /*
-     * update old stats from new stats.
-     * careful - old_stats is a pointer to stats...
-     */
-    memcpy(prev_vals->old_stats, &new_vals->stats, sizeof(new_vals->stats));
-    
+    else {
+        /*
+         * update old stats from new stats.
+         * careful - old_stats is a pointer to stats...
+         */
+        memcpy(prev_vals->old_stats, &new_vals->stats, sizeof(new_vals->stats));
+    }
     return 0;
 }
 

=== modified file 'agent/mibgroup/ip-mib/ipAddressPrefixTable/ipAddressPrefixTable_data_access.c'
--- agent/mibgroup/ip-mib/ipAddressPrefixTable/ipAddressPrefixTable_data_access.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ip-mib/ipAddressPrefixTable/ipAddressPrefixTable_data_access.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.17 $ of : mfd-data-access.m2c,v $ 
  *
- * $Id: ipAddressPrefixTable_data_access.c 14169 2006-01-25 16:28:12Z dts12 $
+ * $Id: ipAddressPrefixTable_data_access.c 17722 2009-08-05 19:05:47Z dts12 $
  */
 /*
  * standard Net-SNMP includes 
@@ -289,6 +289,7 @@
         rowreq_ctx = NULL;
         ++count;
     }
+    ITERATOR_RELEASE(addr_it);
 
     DEBUGMSGT(("verbose:ipAddressPrefixTable:ipAddressPrefixTable_container_load", "inserted %d records\n", count));
 

=== modified file 'agent/mibgroup/kernel_sunos5.c'
--- agent/mibgroup/kernel_sunos5.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/kernel_sunos5.c	2010-06-10 18:02:54 +0000
@@ -81,7 +81,7 @@
 static
 mibcache        Mibcache[MIBCACHE_SIZE+1] = {
     {MIB_SYSTEM, 0, (void *) -1, 0, 0, 0, 0},
-    {MIB_INTERFACES, 10 * sizeof(mib2_ifEntry_t), (void *) -1, 0, 30, 0,
+    {MIB_INTERFACES, 50 * sizeof(mib2_ifEntry_t), (void *) -1, 0, 30, 0,
      0},
     {MIB_AT, 0, (void *) -1, 0, 0, 0, 0},
     {MIB_IP, sizeof(mib2_ip_t), (void *) -1, 0, 60, 0, 0},
@@ -904,7 +904,16 @@
     req = (struct opthdr *)(tor + 1);
     req->level = groupname;
     req->name = subgroupname;
+    /*
+     * non-zero len field is used to request extended MIB statistics
+     * on Solaris 10 Update 4 and later. The LEGACY_MIB_SIZE macro is only
+     * available for S10U4+, so we use that to see what action to take.
+     */
+#ifdef LEGACY_MIB_SIZE
+    req->len = 1;	/* ask for extended MIBs */
+#else
     req->len = 0;
+#endif
     strbuf.len = tor->OPT_length + tor->OPT_offset;
     flags = 0;
     if ((rc = putmsg(sd, &strbuf, NULL, flags))) {
@@ -1746,13 +1755,9 @@
     if (ifp->ifType == 24)  /* Loopback */
         return (0);
 
-    if (getKstatInt(NULL, name, "ierrors", &ifp->ifInErrors) != 0) {
-        return (-1);
-    }
-
-    if (getKstatInt(NULL, name, "oerrors", &ifp->ifOutErrors) != 0) {
-        return (-1);
-    }
+    /* some? VLAN interfaces don't have error counters, so ignore failure */
+    getKstatInt(NULL, name, "ierrors", &ifp->ifInErrors);
+    getKstatInt(NULL, name, "oerrors", &ifp->ifOutErrors);
 
     /* Try to grab some additional information */
     getKstatInt(NULL, name, "collisions", &ifp->ifCollisions); 

=== modified file 'agent/mibgroup/mibII/at.c'
--- agent/mibgroup/mibII/at.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/at.c	2010-06-10 18:02:54 +0000
@@ -128,9 +128,9 @@
 #ifndef solaris2
 static void     ARP_Scan_Init(void);
 #ifdef ARP_SCAN_FOUR_ARGUMENTS
-static int      ARP_Scan_Next(u_long *, char *, u_long *, u_short *);
+static int      ARP_Scan_Next(in_addr_t *, char *, int *, u_long *, u_short *);
 #else
-static int      ARP_Scan_Next(u_long *, char *, u_long *);
+static int      ARP_Scan_Next(in_addr_t *, char *, int *, u_long *);
 #endif
 #endif
 #endif
@@ -205,8 +205,10 @@
     oid            *op;
     oid             lowest[16];
     oid             current[16];
-    static char     PhysAddr[6], LowPhysAddr[6];
-    u_long          Addr, LowAddr, foundone;
+    static char     PhysAddr[MAX_MAC_ADDR_LEN], LowPhysAddr[MAX_MAC_ADDR_LEN];
+    static int      PhysAddrLen, LowPhysAddrLen;
+    in_addr_t       Addr, LowAddr;
+    int             foundone;
     static in_addr_t      addr_ret;
 #ifdef ARP_SCAN_FOUR_ARGUMENTS
     u_short         ifIndex, lowIfIndex = 0;
@@ -232,7 +234,7 @@
     ARP_Scan_Init();
     for (;;) {
 #ifdef ARP_SCAN_FOUR_ARGUMENTS
-        if (ARP_Scan_Next(&Addr, PhysAddr, &ifType, &ifIndex) == 0)
+        if (ARP_Scan_Next(&Addr, PhysAddr, &PhysAddrLen, &ifType, &ifIndex) == 0)
             break;
         current[10] = ifIndex;
 
@@ -243,7 +245,7 @@
             op = current + 11;
         }
 #else                           /* ARP_SCAN_FOUR_ARGUMENTS */
-        if (ARP_Scan_Next(&Addr, PhysAddr, &ifType) == 0)
+        if (ARP_Scan_Next(&Addr, PhysAddr, &PhysAddrLen, &ifType) == 0)
             break;
         current[10] = 1;
 
@@ -270,6 +272,7 @@
                 lowIfIndex = ifIndex;
 #endif                          /*  ARP_SCAN_FOUR_ARGUMENTS */
                 memcpy(LowPhysAddr, PhysAddr, sizeof(PhysAddr));
+                LowPhysAddrLen = PhysAddrLen;
                 lowIfType = ifType;
                 break;          /* no need to search further */
             }
@@ -291,6 +294,7 @@
                 lowIfIndex = ifIndex;
 #endif                          /*  ARP_SCAN_FOUR_ARGUMENTS */
                 memcpy(LowPhysAddr, PhysAddr, sizeof(PhysAddr));
+                LowPhysAddrLen = PhysAddrLen;
                 lowIfType = ifType;
             }
         }
@@ -314,7 +318,7 @@
 #endif                          /* ARP_SCAN_FOUR_ARGUMENTS */
         return (u_char *) & long_return;
     case IPMEDIAPHYSADDRESS:   /* also ATPHYSADDRESS */
-        *var_len = sizeof(LowPhysAddr);
+        *var_len = LowPhysAddrLen;
         return (u_char *) LowPhysAddr;
     case IPMEDIANETADDRESS:    /* also ATNETADDRESS */
         *var_len = sizeof(addr_ret);
@@ -600,10 +604,12 @@
 
     static time_t   tm = 0;     /* Time of last scan */
     FILE           *in;
-    int             i;
+    int             i, j;
     char            line[128];
-    int             za, zb, zc, zd, ze, zf, zg, zh, zi, zj;
+    int             za, zb, zc, zd;
     char            ifname[21];
+    char            mac[3*MAX_MAC_ADDR_LEN+1];
+    char           *tok;
 
     arptab_current = 0;         /* Anytime this is called we need to reset 'current' */
 
@@ -642,11 +648,10 @@
                 at = newtab;
             }
         }
-        if (12 !=
+        if (7 !=
             sscanf(line,
-                   "%d.%d.%d.%d 0x%*x 0x%x %x:%x:%x:%x:%x:%x %*[^ ] %20s\n",
-                   &za, &zb, &zc, &zd, &tmp_flags, &ze, &zf, &zg, &zh, &zi,
-                   &zj, ifname)) {
+                   "%d.%d.%d.%d 0x%*x 0x%x %s %*[^ ] %20s\n",
+                   &za, &zb, &zc, &zd, &tmp_flags, mac, ifname)) {
             snmp_log(LOG_ERR, "Bad line in /proc/net/arp: %s", line);
             continue;
         }
@@ -659,16 +664,15 @@
         }
         ifname[sizeof(ifname)-1] = 0; /* make sure name is null terminated */
         at[i].at_flags = tmp_flags;
-        at[i].at_enaddr[0] = ze;
-        at[i].at_enaddr[1] = zf;
-        at[i].at_enaddr[2] = zg;
-        at[i].at_enaddr[3] = zh;
-        at[i].at_enaddr[4] = zi;
-        at[i].at_enaddr[5] = zj;
         tmp_a = ((u_long) za << 24) |
             ((u_long) zb << 16) | ((u_long) zc << 8) | ((u_long) zd);
         at[i].at_iaddr.s_addr = htonl(tmp_a);
         at[i].if_index = netsnmp_access_interface_index_find(ifname);
+        
+        for (j=0,tok=strtok(mac, ":"); tok != NULL; tok=strtok(NULL, ":"),j++) {
+        	at[i].at_enaddr[j] = strtol(tok, NULL, 16);
+        }
+        at[i].at_enaddr_len = j;
         i++;
     }
     arptab_size = i;
@@ -712,11 +716,12 @@
 
 #ifdef ARP_SCAN_FOUR_ARGUMENTS
 static int
-ARP_Scan_Next(u_long * IPAddr, char *PhysAddr, u_long * ifType,
-              u_short * ifIndex)
+ARP_Scan_Next(in_addr_t * IPAddr, char *PhysAddr, int *PhysAddrLen,
+              u_long * ifType, u_short * ifIndex)
 #else
 static int
-ARP_Scan_Next(u_long * IPAddr, char *PhysAddr, u_long * ifType)
+ARP_Scan_Next(in_addr_t * IPAddr, char *PhysAddr, int *PhysAddrLen,
+              u_long * ifType)
 #endif
 {
 #ifndef NETSNMP_CAN_USE_SYSCTL
@@ -732,6 +737,7 @@
         *ifIndex = at[arptab_current].if_index;
         memcpy(PhysAddr, &at[arptab_current].at_enaddr,
                sizeof(at[arptab_current].at_enaddr));
+        *PhysAddrLen = at[arptab_current].at_enaddr_len;
 
         /*
          * increment to point next entry 
@@ -752,6 +758,7 @@
                at[arptab_current].PhysAddr.o_length);
         *ifType = at[arptab_current].Type;
         *ifIndex = at[arptab_current].IfIndex;
+        *PhysAddrLen = at[arptab_current].PhysAddr.o_length;
         /*
          * increment to point next entry 
          */
@@ -804,10 +811,12 @@
 #if defined (sunV3) || defined(sparc) || defined(hpux)
         memcpy(PhysAddr, (char *) &atab->at_enaddr,
                sizeof(atab->at_enaddr));
+        *PhysAddrLen = sizeof(atab->at_enaddr);
 #endif
 #if defined(mips) || defined(ibm032)
         memcpy(PhysAddr, (char *) atab->at_enaddr,
                sizeof(atab->at_enaddr));
+        *PhysAddrLen = sizeof(atab->at_enaddr);
 #endif
         return (1);
     }
@@ -832,6 +841,7 @@
             *IPAddr = sin->sin_addr.s_addr;
 #endif
             memcpy(PhysAddr, (char *) LLADDR(sdl), sdl->sdl_alen);
+            *PhysAddrLen = sdl->sdl_alen;
             *ifIndex = sdl->sdl_index;
             *ifType = 1;        /* XXX */
             return (1);

=== modified file 'agent/mibgroup/mibII/at.h'
--- agent/mibgroup/mibII/at.h	2004-09-13 12:06:21 +0000
+++ agent/mibgroup/mibII/at.h	2010-06-10 18:02:54 +0000
@@ -31,13 +31,17 @@
 # define ATF_COM	0x02
 #endif                          /*  ATF_COM */
 
+/* InfiniBand uses HW addr > 6 */
+#define MAX_MAC_ADDR_LEN 32 
+
 #if defined(linux) || defined(irix6)
 /*
  * arp struct to pass flags, hw-addr and ip-addr in bsd manner:
  */
      struct arptab {
          int             at_flags;
-         char            at_enaddr[6];
+         char            at_enaddr[MAX_MAC_ADDR_LEN];
+         int             at_enaddr_len;
          struct in_addr  at_iaddr;
          int             if_index;
      };

=== modified file 'agent/mibgroup/mibII/interfaces.c'
--- agent/mibgroup/mibII/interfaces.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/interfaces.c	2010-06-10 18:02:54 +0000
@@ -216,7 +216,7 @@
     {IFNUMBER, ASN_INTEGER, RONLY, var_interfaces, 1, {1}},
     {IFINDEX, ASN_INTEGER, RONLY, var_ifEntry, 3, {2, 1, 1}},
     {IFDESCR, ASN_OCTET_STR, RONLY, var_ifEntry, 3, {2, 1, 2}},
-    {IFTYPE, ASN_INTEGER, RONLY, var_ifEntry, 3, {2, 1, 3}},
+    {NETSNMP_IFTYPE, ASN_INTEGER, RONLY, var_ifEntry, 3, {2, 1, 3}},
     {IFMTU, ASN_INTEGER, RONLY, var_ifEntry, 3, {2, 1, 4}},
     {IFSPEED, ASN_GAUGE, RONLY, var_ifEntry, 3, {2, 1, 5}},
     {IFPHYSADDRESS, ASN_OCTET_STR, RONLY, var_ifEntry, 3, {2, 1, 6}},
@@ -581,7 +581,7 @@
         cp = if_name;
         *var_len = strlen(if_name);
         return (u_char *) cp;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else
@@ -756,7 +756,7 @@
         cp = Name;
         *var_len = strlen(cp);
         return (u_char *) cp;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else {
@@ -1081,7 +1081,7 @@
 #endif
         *var_len = strlen(cp);
         return (u_char *) cp;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else {
@@ -1322,7 +1322,7 @@
         *var_len = ifstat.ifDescr.o_length;
         (void) memcpy(return_buf, ifstat.ifDescr.o_bytes, *var_len);
         return (u_char *) return_buf;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else
@@ -1422,16 +1422,17 @@
 * Determines network interface speed. It is system specific. Only linux
 * realization is made. 
 */
-unsigned int getIfSpeed(int fd, struct ifreq ifr)
+unsigned int getIfSpeed(int fd, struct ifreq ifr, unsigned int defaultspeed)
 {
 #ifdef linux
     /** temporary expose internal until this module can be re-written */
     extern unsigned int
-        netsnmp_linux_interface_get_if_speed(int fd, const char *name);
+        netsnmp_linux_interface_get_if_speed(int fd, const char *name,
+                unsigned long long defaultspeed);
 
-    return netsnmp_linux_interface_get_if_speed(fd, ifr.ifr_name);
+    return netsnmp_linux_interface_get_if_speed(fd, ifr.ifr_name, defaultspeed);
 #else /*!linux*/			   
-    return 10000000;
+    return defaultspeed;
 #endif 
 }
 
@@ -1752,11 +1753,30 @@
              * do only guess if_type from name, if we could not read
              * * it before from SIOCGIFHWADDR 
              */
+            unsigned int defaultspeed = NOMINAL_LINK_SPEED;
+                if (!(nnew->if_flags & IFF_RUNNING)) {
+                    /* 
+                     * use speed 0 if the if speed cannot be determined *and* the
+                     * interface is down
+                     */
+                    defaultspeed = 0;
+                }
+
             if (!nnew->if_type)
                 nnew->if_type = if_type_from_name(nnew->if_name);
-            nnew->if_speed = nnew->if_type == 6 ? getIfSpeed(fd, ifrq) :
-                nnew->if_type == 24 ? 10000000 :
-                nnew->if_type == 9 ? 4000000 : 0;
+            switch(nnew->if_type) {
+            case 6:
+                nnew->if_speed = getIfSpeed(fd, ifrq, defaultspeed);
+                break;
+            case 24:
+                nnew->if_speed = 10000000;
+                break;
+            case 9:
+                nnew->if_speed = 4000000;
+                break;
+            default:
+                nnew->if_speed = 0;
+            }
             /*Zero speed means link problem*/
             if(nnew->if_speed == 0 && nnew->if_flags & IFF_UP){
                 nnew->if_flags &= ~IFF_RUNNING;
@@ -2464,7 +2484,7 @@
         cp = ifmd.ifmd_name;
         *var_len = strlen(cp);
         return (u_char *) cp;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else
@@ -2695,7 +2715,7 @@
     case IFDESCR:
         *var_len = ifRow.dwDescrLen;
         return (u_char *) ifRow.bDescr;
-    case IFTYPE:
+    case NETSNMP_IFTYPE:
         if (if_ptr)
             long_return = if_ptr->type;
         else

=== modified file 'agent/mibgroup/mibII/interfaces.h'
--- agent/mibgroup/mibII/interfaces.h	2007-05-10 22:20:23 +0000
+++ agent/mibgroup/mibII/interfaces.h	2010-06-10 18:02:54 +0000
@@ -61,7 +61,7 @@
 #define IFNUMBER        0
 #define IFINDEX         1
 #define IFDESCR         2
-#define IFTYPE          3
+#define NETSNMP_IFTYPE          3
 #define IFMTU           4
 #define IFSPEED         5
 #define IFPHYSADDRESS   6

=== modified file 'agent/mibgroup/mibII/ip.c'
--- agent/mibgroup/mibII/ip.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/ip.c	2010-06-10 18:02:54 +0000
@@ -283,7 +283,7 @@
         type = ASN_INTEGER;
         break;
     case IPINRECEIVES:
-        ret_value = ipstat.ipInReceives;
+        ret_value = ipstat.ipInReceives & 0xffffffff;
         break;
     case IPINHDRERRORS:
         ret_value = ipstat.ipInHdrErrors;
@@ -301,10 +301,10 @@
         ret_value = ipstat.ipInDiscards;
         break;
     case IPINDELIVERS:
-        ret_value = ipstat.ipInDelivers;
+        ret_value = ipstat.ipInDelivers & 0xffffffff;
         break;
     case IPOUTREQUESTS:
-        ret_value = ipstat.ipOutRequests;
+        ret_value = ipstat.ipOutRequests & 0xffffffff;
         break;
     case IPOUTDISCARDS:
         ret_value = ipstat.ipOutDiscards;
@@ -359,7 +359,7 @@
         type = ASN_INTEGER;
         break;
     case IPINRECEIVES:
-        ret_value = ipstat.ips_total;
+        ret_value = ipstat.ips_total & 0xffffffff;
         break;
     case IPINHDRERRORS:
         ret_value = ipstat.ips_badsum
@@ -390,7 +390,7 @@
 #endif
     case IPINDELIVERS:
 #if STRUCT_IPSTAT_HAS_IPS_DELIVERED
-        ret_value = ipstat.ips_delivered;
+        ret_value = ipstat.ips_delivered & 0xffffffff;
         break;
 #else
         netsnmp_set_request_error(reqinfo, request, SNMP_NOSUCHOBJECT);
@@ -398,7 +398,7 @@
 #endif
     case IPOUTREQUESTS:
 #if STRUCT_IPSTAT_HAS_IPS_LOCALOUT
-        ret_value = ipstat.ips_localout;
+        ret_value = ipstat.ips_localout & 0xffffffff;
         break;
 #else
         netsnmp_set_request_error(reqinfo, request, SNMP_NOSUCHOBJECT);

=== modified file 'agent/mibgroup/mibII/ipCidrRouteTable_access.c'
--- agent/mibgroup/mibII/ipCidrRouteTable_access.c	2004-09-13 12:06:21 +0000
+++ agent/mibgroup/mibII/ipCidrRouteTable_access.c	2010-06-10 18:02:54 +0000
@@ -22,7 +22,7 @@
 /** a global static we'll make use of a lot to map to the right
    datatype to return (which for SNMP integer's is always a long). */
 static u_long long_ret;
-  
+static in_addr_t addr_ret;
 
 /*
  * User-defined data access functions for data in table ipCidrRouteTable 
@@ -32,18 +32,18 @@
 get_ipCidrRouteDest(void *data_context, size_t * ret_len)
 {
     RTENTRY *ourroute = (RTENTRY *) data_context;
-    long_ret = ((struct sockaddr_in *) (&ourroute->rt_dst))->sin_addr.s_addr;
-    *ret_len = sizeof(long_ret);
-    return &long_ret;
+    addr_ret = ((struct sockaddr_in *) (&ourroute->rt_dst))->sin_addr.s_addr;
+    *ret_len = sizeof(addr_ret);
+    return &addr_ret;
 }
 
 u_long         *
 get_ipCidrRouteMask(void *data_context, size_t * ret_len)
 {
     RTENTRY *ourroute = (RTENTRY *) data_context;
-    long_ret = ((struct sockaddr_in *) (&ourroute->rt_genmask))->sin_addr.s_addr;
-    *ret_len = sizeof(long_ret);
-    return &long_ret;
+    addr_ret = ((struct sockaddr_in *) (&ourroute->rt_genmask))->sin_addr.s_addr;
+    *ret_len = sizeof(addr_ret);
+    return &addr_ret;
 }
 
 long           *
@@ -59,9 +59,9 @@
 get_ipCidrRouteNextHop(void *data_context, size_t * ret_len)
 {
     RTENTRY *ourroute = (RTENTRY *) data_context;
-    long_ret = ((struct sockaddr_in *) (&ourroute->rt_gateway))->sin_addr.s_addr;
-    *ret_len = sizeof(long_ret);
-    return &long_ret;
+    addr_ret = ((struct sockaddr_in *) (&ourroute->rt_gateway))->sin_addr.s_addr;
+    *ret_len = sizeof(addr_ret);
+    return &addr_ret;
 }
 
 long           *

=== modified file 'agent/mibgroup/mibII/ipv6.c'
--- agent/mibgroup/mibII/ipv6.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/mibII/ipv6.c	2010-06-10 18:02:54 +0000
@@ -778,7 +778,7 @@
             memset(&ifr, 0, sizeof(ifr));
             ifr.ifr_addr.sa_family = AF_INET6;
             strncpy(ifr.ifr_name, if_getname(interface),
-                    sizeof(ifr.ifr_name));
+                    sizeof(ifr.ifr_name) - 1);
             if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFMTU, (caddr_t) & ifr) < 0) {
@@ -945,7 +945,7 @@
 
             memset(&ifr, 0, sizeof(ifr));
             strncpy(ifr.ifr_name, if_getname(interface),
-                    sizeof(ifr.ifr_name));
+                    sizeof(ifr.ifr_name) - 1);
             if ((s = socket(AF_INET6, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFSTAT_IN6, (caddr_t) & ifr) < 0) {
@@ -1098,7 +1098,7 @@
 
             memset(&ifr, 0, sizeof(ifr));
             strncpy(ifr.ifr_name, if_getname(interface),
-                    sizeof(ifr.ifr_name));
+                    sizeof(ifr.ifr_name) - 1);
             if ((s = socket(AF_INET6, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFSTAT_ICMP6, (caddr_t) & ifr) < 0) {
@@ -1951,7 +1951,7 @@
                 break;
             memset(&ifr, 0, sizeof(ifr));
             ifr.ifr_addr.sa_family = AF_INET6;
-            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name));
+            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name) - 1);
             if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFMTU, (caddr_t) & ifr) < 0) {
@@ -1971,7 +1971,7 @@
                 break;
             memset(&ifr, 0, sizeof(ifr));
             ifr.ifr_addr.sa_family = AF_INET6;
-            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name));
+            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name) - 1);
             if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFHWADDR, &ifr) < 0) {
@@ -2000,7 +2000,7 @@
                 break;
             memset(&ifr, 0, sizeof(ifr));
             ifr.ifr_addr.sa_family = AF_INET6;
-            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name));
+            strncpy(ifr.ifr_name, p, sizeof(ifr.ifr_name) - 1);
             if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
                 break;
             if (ioctl(s, SIOCGIFFLAGS, &ifr) < 0) {

=== modified file 'agent/mibgroup/mibII/system_mib.c'
--- agent/mibgroup/mibII/system_mib.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/mibII/system_mib.c	2010-06-10 18:02:54 +0000
@@ -31,7 +31,7 @@
 #include <winsock.h>
 #endif
 
-#ifdef HAVE_SYS_TIME_H
+#if !defined(mingw32) && defined(HAVE_SYS_TIME_H)
 #include <sys/time.h>
 #endif
 

=== modified file 'agent/mibgroup/mibII/tcp.c'
--- agent/mibgroup/mibII/tcp.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/tcp.c	2010-06-10 18:02:54 +0000
@@ -272,10 +272,10 @@
         type = ASN_GAUGE;
         break;
     case TCPINSEGS:
-        ret_value = tcpstat.tcpInSegs;
+        ret_value = tcpstat.tcpInSegs & 0xffffffff;
         break;
     case TCPOUTSEGS:
-        ret_value = tcpstat.tcpOutSegs;
+        ret_value = tcpstat.tcpOutSegs & 0xffffffff;
         break;
     case TCPRETRANSSEGS:
         ret_value = tcpstat.tcpRetransSegs;
@@ -366,14 +366,14 @@
         type = ASN_GAUGE;
         break;
     case TCPINSEGS:
-        ret_value = tcpstat.tcps_rcvtotal;
+        ret_value = tcpstat.tcps_rcvtotal & 0xffffffff;
         break;
     case TCPOUTSEGS:
         /*
          * RFC 1213 defines this as the number of segments sent
          * "excluding those containing only retransmitted octets"
          */
-        ret_value = tcpstat.tcps_sndtotal - tcpstat.tcps_sndrexmitpack;
+        ret_value = (tcpstat.tcps_sndtotal - tcpstat.tcps_sndrexmitpack) & 0xffffffff;
         break;
     case TCPRETRANSSEGS:
         ret_value = tcpstat.tcps_sndrexmitpack;

=== modified file 'agent/mibgroup/mibII/udpTable.c'
--- agent/mibgroup/mibII/udpTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/udpTable.c	2010-06-10 18:02:54 +0000
@@ -362,7 +362,7 @@
 {
     UDPTABLE_ENTRY_TYPE	 *entry = (UDPTABLE_ENTRY_TYPE *)*loop_context;
     long port;
-    in_addr_t addr;
+    long addr;
 
     if (!entry)
         return NULL;
@@ -377,7 +377,7 @@
 #else
     addr = UDP_ADDRESS_TO_NETWORK_ORDER((in_addr_t)entry->UDPTABLE_LOCALADDRESS);
     snmp_set_var_value(index, (u_char *)&addr,
-                                 sizeof(entry->UDPTABLE_LOCALADDRESS));
+                                 sizeof(addr));
 #endif
     port = UDP_PORT_TO_HOST_ORDER(entry->UDPTABLE_LOCALPORT);
     snmp_set_var_value(index->next_variable,

=== modified file 'agent/mibgroup/mibII/vacm_conf.c'
--- agent/mibgroup/mibII/vacm_conf.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/mibII/vacm_conf.c	2010-06-10 18:02:54 +0000
@@ -1129,10 +1129,12 @@
          */
         if ((MASTER_AGENT == agent_mode) && (strcmp(name, "snmptrapd") != 0)) {
             snmp_log(LOG_WARNING,
-                 "Warning: no access control information configured.\n  It's "
-                 "unlikely this agent can serve any useful purpose in this "
-                 "state.\n  Run \"snmpconf -g basic_setup\" to help you "
-                 "configure the %s.conf file for this agent.\n", name );
+                 "Warning: no access control information configured.\n"
+                 "  (Config search path: %s)\n"
+                 "  It's unlikely this agent can serve any useful purpose in this state.\n"
+                 "  Run \"snmpconf -g basic_setup\" to help you "
+                 "configure the %s.conf file for this agent.\n",
+                 get_configuration_directory(), name);
         }
 
         /*
@@ -1152,7 +1154,9 @@
                                     NETSNMP_DS_APP_NO_AUTHORIZATION)) {
             snmp_log(LOG_WARNING,
                  "Warning: no access control information configured.\n"
-                 "This receiver will *NOT* accept any incoming notifications.\n");
+                 "  (Config search path: %s)\n"
+                 "This receiver will *NOT* accept any incoming notifications.\n",
+                 get_configuration_directory());
         }
     }
     return SNMP_ERR_NOERROR;

=== modified file 'agent/mibgroup/mibII/vacm_context.c'
--- agent/mibgroup/mibII/vacm_context.c	2006-11-28 12:29:34 +0000
+++ agent/mibgroup/mibII/vacm_context.c	2010-06-10 18:02:54 +0000
@@ -95,6 +95,7 @@
     if (!table_info || !iinfo) {
         SNMP_FREE(table_info);
         SNMP_FREE(iinfo);
+        SNMP_FREE(my_handler);
         return;
     }
 

=== modified file 'agent/mibgroup/mibII/vacm_vars.c'
--- agent/mibgroup/mibII/vacm_vars.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/mibII/vacm_vars.c	2010-06-10 18:02:54 +0000
@@ -1544,11 +1544,6 @@
     viewName[0][viewNameL] = 0;
 
     for (i = 0; i < subtreeL; i++) {
-	if (oidIndex[i + viewNameL + 1] > 255) {
-	    free(*viewName);
-	    free(*subtree);
-	    return SNMP_ERR_INCONSISTENTNAME;
-	}
         subtree[0][i] = (oid) oidIndex[i + viewNameL + 1];
     }
 

=== modified file 'agent/mibgroup/notification-log-mib/notification_log.c'
--- agent/mibgroup/notification-log-mib/notification_log.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/notification-log-mib/notification_log.c	2010-06-10 18:02:54 +0000
@@ -586,8 +586,9 @@
     u_long          tmpul;
     int             col;
 
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID,
-                               NETSNMP_DS_APP_DONT_LOG)) {
+    if (!nlmLogVarTable
+        || netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID,
+                                  NETSNMP_DS_APP_DONT_LOG)) {
         return;
     }
 

=== modified file 'agent/mibgroup/sctp-mib/sctpAssocLocalAddrTable.c'
--- agent/mibgroup/sctp-mib/sctpAssocLocalAddrTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpAssocLocalAddrTable.c	2010-06-10 18:02:54 +0000
@@ -121,9 +121,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
-
     if (container)
         CONTAINER_FREE(container);
 

=== modified file 'agent/mibgroup/sctp-mib/sctpAssocRemAddrTable.c'
--- agent/mibgroup/sctp-mib/sctpAssocRemAddrTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpAssocRemAddrTable.c	2010-06-10 18:02:54 +0000
@@ -120,8 +120,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
 
     if (container)
         CONTAINER_FREE(container);

=== modified file 'agent/mibgroup/sctp-mib/sctpAssocTable.c'
--- agent/mibgroup/sctp-mib/sctpAssocTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpAssocTable.c	2010-06-10 18:02:54 +0000
@@ -152,12 +152,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (cache)
-        netsnmp_cache_free(cache);
-
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
-
     if (container)
         CONTAINER_FREE(container);
 

=== modified file 'agent/mibgroup/sctp-mib/sctpLookupLocalPortTable.c'
--- agent/mibgroup/sctp-mib/sctpLookupLocalPortTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpLookupLocalPortTable.c	2010-06-10 18:02:54 +0000
@@ -117,8 +117,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
 
     if (container)
         CONTAINER_FREE(container);

=== modified file 'agent/mibgroup/sctp-mib/sctpLookupRemHostNameTable.c'
--- agent/mibgroup/sctp-mib/sctpLookupRemHostNameTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpLookupRemHostNameTable.c	2010-06-10 18:02:54 +0000
@@ -119,9 +119,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
-
     if (container)
         CONTAINER_FREE(container);
 

=== modified file 'agent/mibgroup/sctp-mib/sctpLookupRemIPAddrTable.c'
--- agent/mibgroup/sctp-mib/sctpLookupRemIPAddrTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpLookupRemIPAddrTable.c	2010-06-10 18:02:54 +0000
@@ -113,8 +113,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
 
     if (container)
         CONTAINER_FREE(container);

=== modified file 'agent/mibgroup/sctp-mib/sctpLookupRemPortTable.c'
--- agent/mibgroup/sctp-mib/sctpLookupRemPortTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpLookupRemPortTable.c	2010-06-10 18:02:54 +0000
@@ -112,8 +112,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
 
     if (container)
         CONTAINER_FREE(container);

=== modified file 'agent/mibgroup/sctp-mib/sctpLookupRemPrimIPAddrTable.c'
--- agent/mibgroup/sctp-mib/sctpLookupRemPrimIPAddrTable.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpLookupRemPrimIPAddrTable.c	2010-06-10 18:02:54 +0000
@@ -114,8 +114,6 @@
     if (handler)
         netsnmp_handler_free(handler);
 
-    if (table_info)
-        netsnmp_table_registration_info_free(table_info);
 
     if (container)
         CONTAINER_FREE(container);

=== modified file 'agent/mibgroup/sctp-mib/sctpScalars_linux.c'
--- agent/mibgroup/sctp-mib/sctpScalars_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpScalars_linux.c	2010-06-10 18:02:54 +0000
@@ -52,7 +52,7 @@
 {
     FILE           *f;
     char            line[100];
-    u_long          value;
+    unsigned long long value;
     char           *delimiter;
     int             ret = 0;
 
@@ -74,7 +74,7 @@
             return -1;
         }
         errno = 0;
-        value = strtoul(delimiter + 1, NULL, 10);
+        value = strtoull(delimiter + 1, NULL, 10);
         if (errno != 0) {
             DEBUGMSGTL(("sctp:scalars:stats:arch_load",
                         "Malformed value!'\n"));

=== modified file 'agent/mibgroup/sctp-mib/sctpTables_common.c'
--- agent/mibgroup/sctp-mib/sctpTables_common.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpTables_common.c	2010-06-10 18:02:54 +0000
@@ -1,3 +1,7 @@
+#include <net-snmp/net-snmp-config.h>
+#include <net-snmp/net-snmp-includes.h>
+#include <net-snmp/agent/net-snmp-agent-includes.h>
+
 #include "sctpTables_common.h"
 #include "sctpAssocTable.h"
 #include "sctpAssocRemAddrTable.h"
@@ -39,6 +43,7 @@
         sctpAssocTable_entry_free(entry);
         CONTAINER_REMOVE(to_delete, NULL);
     }
+    CONTAINER_FREE(to_delete);
 }
 
 static void
@@ -72,6 +77,7 @@
         sctpAssocRemAddrTable_entry_free(entry);
         CONTAINER_REMOVE(to_delete, NULL);
     }
+    CONTAINER_FREE(to_delete);
 }
 
 static void
@@ -105,6 +111,7 @@
         sctpAssocLocalAddrTable_entry_free(entry);
         CONTAINER_REMOVE(to_delete, NULL);
     }
+    CONTAINER_FREE(to_delete);
 }
 
 

=== modified file 'agent/mibgroup/sctp-mib/sctpTables_common.h'
--- agent/mibgroup/sctp-mib/sctpTables_common.h	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpTables_common.h	2010-06-10 18:02:54 +0000
@@ -1,10 +1,6 @@
 #ifndef SCTP_TABLES_COMMON_H
 #define SCTP_TABLES_COMMON_H
 
-#include <net-snmp/net-snmp-config.h>
-#include <net-snmp/net-snmp-includes.h>
-#include <net-snmp/agent/net-snmp-agent-includes.h>
-
 #define SCTP_IPADDRESS_SIZE 16
 #define SCTP_HOSTNAME_SIZE 255
 

=== modified file 'agent/mibgroup/sctp-mib/sctpTables_linux.c'
--- agent/mibgroup/sctp-mib/sctpTables_linux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/sctp-mib/sctpTables_linux.c	2010-06-10 18:02:54 +0000
@@ -1,3 +1,7 @@
+#include <net-snmp/net-snmp-config.h>
+#include <net-snmp/net-snmp-includes.h>
+#include <net-snmp/agent/net-snmp-agent-includes.h>
+
 #include "sctpAssocTable.h"
 #include "sctpAssocLocalAddrTable.h"
 #include "sctpAssocRemAddrTable.h"
@@ -126,7 +130,7 @@
 static int
 parse_assoc_line(char *line, sctpTables_containers * containers)
 {
-    long            inode;
+    unsigned long long inode;
     char           *token;
     int             ret;
     sctpAssocTable_entry *entry;
@@ -169,7 +173,7 @@
         ret = SNMP_ERR_GENERR;
         goto error;
     }
-    inode = strtol(token, NULL, 10);
+    inode = strtoull(token, NULL, 10);
     entry->sctpAssocPrimProcess = get_pid_from_inode(inode);
 
     token = strtok(NULL, " ");  /* LPORT */

=== modified file 'agent/mibgroup/smux/smux.c'
--- agent/mibgroup/smux/smux.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/smux/smux.c	2010-06-10 18:02:54 +0000
@@ -139,7 +139,7 @@
 {
     smux_peer_auth *aptr;
     char           *password_cptr;
-    int             cptr_len;
+    int             rv;
 
     if ((aptr =
          (smux_peer_auth *) calloc(1, sizeof(smux_peer_auth))) == NULL) {
@@ -151,30 +151,31 @@
 	return;
     }
 
+    password_cptr = strchr(cptr, ' ');
+    if (password_cptr)
+        *(password_cptr++) = '\0';
+
     /*
      * oid 
      */
     aptr->sa_active_fd = -1;
     aptr->sa_oid_len = MAX_OID_LEN;
-    read_objid( cptr, aptr->sa_oid, &aptr->sa_oid_len );
+    rv = read_objid( cptr, aptr->sa_oid, &aptr->sa_oid_len );
     DEBUGMSGTL(("smux_conf", "parsing registration for: %s\n", cptr));
-
-    password_cptr = strchr(cptr, ' ');
-    cptr_len = strlen(cptr);
+    if (!rv)
+        config_perror("Error parsing smux oid");
 
     if (password_cptr != NULL) {    /* Do we have a password or not? */
-        *password_cptr = 0x0;
-	if ((&password_cptr - &cptr + 1) < cptr_len) {
-	    cptr = ++password_cptr;
 	    DEBUGMSGTL(("smux_conf", "password is: %s\n",
-	                SNMP_STRORNULL(cptr)));
-	}
+	                SNMP_STRORNULL(password_cptr)));
 
         /*
          * password 
          */
-        if (cptr)
-            strcpy(aptr->sa_passwd, cptr);
+        if (*password_cptr) {
+            strncpy(aptr->sa_passwd, password_cptr, SMUXMAXSTRLEN-1);
+            aptr->sa_passwd[SMUXMAXSTRLEN-1] = '\0';
+        }
     } else {
         /*
          * null passwords OK 

=== modified file 'agent/mibgroup/snmpv3/usmUser.c'
--- agent/mibgroup/snmpv3/usmUser.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/snmpv3/usmUser.c	2010-06-10 18:02:54 +0000
@@ -988,17 +988,15 @@
                      usmNoPrivProtocol,
                      sizeof(usmNoPrivProtocol) / sizeof(oid)) != 0
 #ifndef NETSNMP_DISABLE_DES
-                    && snmp_oid_compare((oid *) var_val,
-                                        var_val_len / sizeof(oid),
-                                        usmDESPrivProtocol,
-                                        sizeof(usmDESPrivProtocol) /
-                                        sizeof(oid) != 0)
+                 && snmp_oid_compare
+                    ((oid *) var_val, var_val_len / sizeof(oid),
+                     usmDESPrivProtocol,
+                     sizeof(usmDESPrivProtocol) / sizeof(oid)) != 0
 #endif
-                    && snmp_oid_compare((oid *) var_val,
-                                        var_val_len / sizeof(oid),
-                                        usmAESPrivProtocol,
-                                        sizeof(usmAESPrivProtocol) /
-                                        sizeof(oid) != 0)) {
+                 && snmp_oid_compare
+                    ((oid *) var_val, var_val_len / sizeof(oid),
+                     usmAESPrivProtocol,
+                     sizeof(usmAESPrivProtocol) / sizeof(oid)) != 0) {
                     return SNMP_ERR_WRONGVALUE;
                 }
             }

=== modified file 'agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.c'
--- agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.48 $ of : mfd-top.m2c,v $ 
  *
- * $Id: tcpConnectionTable.c 14169 2006-01-25 16:28:12Z dts12 $
+ * $Id: tcpConnectionTable.c 17861 2009-12-02 15:39:04Z jsafranek $
  */
 /** \page MFD helper for tcpConnectionTable
  *
@@ -155,6 +155,8 @@
     /*
      * TODO:211:o: |-> Perform extra tcpConnectionTable rowreq cleanup.
      */
+    netsnmp_access_tcpconn_entry_free(rowreq_ctx->data);
+    rowreq_ctx->data = NULL;
 }                               /* tcpConnectionTable_rowreq_ctx_cleanup */
 
 /**

=== modified file 'agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.c'
--- agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/tcp-mib/tcpConnectionTable/tcpConnectionTable_data_access.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.17 $ of : mfd-data-access.m2c,v $ 
  *
- * $Id: tcpConnectionTable_data_access.c 14169 2006-01-25 16:28:12Z dts12 $
+ * $Id: tcpConnectionTable_data_access.c 17861 2009-12-02 15:39:04Z jsafranek $
  */
 /*
  * standard Net-SNMP includes 

=== modified file 'agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.c'
--- agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.48 $ of : mfd-top.m2c,v $ 
  *
- * $Id: tcpListenerTable.c 14169 2006-01-25 16:28:12Z dts12 $
+ * $Id: tcpListenerTable.c 17861 2009-12-02 15:39:04Z jsafranek $
  */
 /** \page MFD helper for tcpListenerTable
  *
@@ -154,6 +154,8 @@
     /*
      * TODO:211:o: |-> Perform extra tcpListenerTable rowreq cleanup.
      */
+    netsnmp_access_tcpconn_entry_free(rowreq_ctx->data);
+    rowreq_ctx->data = NULL;
 }                               /* tcpListenerTable_rowreq_ctx_cleanup */
 
 /**

=== modified file 'agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.c'
--- agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/tcp-mib/tcpListenerTable/tcpListenerTable_data_access.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.17 $ of : mfd-data-access.m2c,v $ 
  *
- * $Id: tcpListenerTable_data_access.c 14169 2006-01-25 16:28:12Z dts12 $
+ * $Id: tcpListenerTable_data_access.c 17861 2009-12-02 15:39:04Z jsafranek $
  */
 /*
  * standard Net-SNMP includes 

=== modified file 'agent/mibgroup/ucd-snmp/disk.c'
--- agent/mibgroup/ucd-snmp/disk.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/ucd-snmp/disk.c	2010-06-10 18:02:54 +0000
@@ -163,6 +163,11 @@
     int             minpercent;
 };
 
+#ifndef  INT32_MAX
+#define  INT32_MAX  0x7fffffff
+#endif
+
+
 int             numdisks;
 int             allDisksIncluded = 0;
 int             maxdisks = 0;
@@ -751,7 +756,7 @@
 #endif
     avail = (long)(vfs.f_bavail * multiplier);
     iserror = (disks[disknum].minimumspace >= 0 ?
-               avail < disks[disknum].minimumspace :
+               vfs.f_bavail < (disks[disknum].minimumspace/multiplier) :
                100 - percent <= disks[disknum].minpercent) ? 1 : 0;
 #if defined(STRUCT_STATVFS_HAS_F_FILES) || defined STRUCT_STATFS_HAS_F_FAVAIL
     percent_inode = vfs.f_favail <= 0 ? 100 :
@@ -767,12 +772,22 @@
 #endif /* defined(STRUCT_STATVFS_HAS_F_FILES) */ 
     switch (vp->magic) {
     case DISKTOTAL:
-        long_ret = (long)(vfs.f_blocks * multiplier);
+        if ( vfs.f_blocks > ( INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)(vfs.f_blocks * multiplier);
         return ((u_char *) (&long_ret));
     case DISKAVAIL:
-        return ((u_char *) (&avail));
+        if ( vfs.f_bavail > ( INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)(vfs.f_bavail * multiplier);
+        return ((u_char *) (&long_ret));
     case DISKUSED:
-        long_ret = (long)((vfs.f_blocks - vfs.f_bfree) * multiplier);
+        if ( (vfs.f_blocks - vfs.f_bfree) > ( INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)((vfs.f_blocks - vfs.f_bfree) * multiplier);
         return ((u_char *) (&long_ret));
     case DISKPERCENT:
         long_ret = percent;
@@ -844,13 +859,22 @@
             : 100 - percent <= disks[disknum].minpercent) ? 1 : 0;
     switch (vp->magic) {
     case DISKTOTAL:
-        long_ret = (long)(totalblks * multiplier);
+        if ( totalblks > ( INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)(totalblks * multiplier);
         return ((u_char *) (&long_ret));
     case DISKAVAIL:
-        long_ret = (long)(avail * multiplier);
+        if ( avail > ( INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)(avail * multiplier);
         return ((u_char *) (&long_ret));
     case DISKUSED:
-        long_ret = (long)(used * multiplier);
+        if ( used > (  INT32_MAX / multiplier ))
+            long_ret = INT32_MAX;
+        else
+            long_ret = (long)(used * multiplier);
         return ((u_char *) (&long_ret));
     case DISKPERCENT:
         long_ret = percent;

=== modified file 'agent/mibgroup/ucd-snmp/diskio.c'
--- agent/mibgroup/ucd-snmp/diskio.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/ucd-snmp/diskio.c	2010-06-10 18:02:54 +0000
@@ -148,9 +148,11 @@
         {DISKIO_NWRITTEN, ASN_COUNTER, RONLY, var_diskio, 1, {4}},
         {DISKIO_READS, ASN_COUNTER, RONLY, var_diskio, 1, {5}},
         {DISKIO_WRITES, ASN_COUNTER, RONLY, var_diskio, 1, {6}},
+#if defined(freebsd4) || defined(freebsd5)
         {DISKIO_LA1, ASN_INTEGER, RONLY, var_diskio, 1, {9}},
         {DISKIO_LA5, ASN_INTEGER, RONLY, var_diskio, 1, {10}},
         {DISKIO_LA15, ASN_INTEGER, RONLY, var_diskio, 1, {11}},
+#endif
         {DISKIO_NREADX, ASN_COUNTER64, RONLY, var_diskio, 1, {12}},
         {DISKIO_NWRITTENX, ASN_COUNTER64, RONLY, var_diskio, 1, {13}},
     };
@@ -833,7 +835,7 @@
       c64_ret.high = head.indices[indx].wsect >> (32 - 9);
       return (u_char *) & c64_ret;
     default:
-	snmp_log(LOG_ERR, "diskio.c: don't know how to handle %d request\n", vp->magic);
+	snmp_log(LOG_ERR, "don't know how to handle %d request\n", vp->magic);
   }
   return NULL;
 }

=== modified file 'agent/mibgroup/ucd-snmp/pass.c'
--- agent/mibgroup/ucd-snmp/pass.c	2007-05-10 22:20:23 +0000
+++ agent/mibgroup/ucd-snmp/pass.c	2010-06-10 18:02:54 +0000
@@ -287,6 +287,7 @@
     oid             newname[MAX_OID_LEN];
     int             i, rtest, fd, newlen;
     static long     long_ret;
+    static in_addr_t addr_ret;
     char            buf[SNMP_MAXBUF];
     static char     buf2[SNMP_MAXBUF];
     static oid      objid[MAX_OID_LEN];
@@ -412,13 +413,13 @@
                         *var_len = 0;
                         return (NULL);
                     }
-                    long_ret =
+                    addr_ret =
                         (objid[0] << (8 * 3)) + (objid[1] << (8 * 2)) +
                         (objid[2] << 8) + objid[3];
-                    long_ret = htonl(long_ret);
-                    *var_len = sizeof(long_ret);
+                    addr_ret = htonl(addr_ret);
+                    *var_len = sizeof(addr_ret);
                     vp->type = ASN_IPADDRESS;
-                    return ((unsigned char *) &long_ret);
+                    return ((unsigned char *) &addr_ret);
                 }
             }
             *var_len = 0;
@@ -502,12 +503,12 @@
                 buf[ sizeof(buf)-1 ] = 0;
                 break;
             case ASN_OBJECT_ID:
-                sprint_mib_oid(buf2, (oid *) var_val, var_val_len);
+                sprint_mib_oid(buf2, (oid *) var_val, var_val_len/sizeof(oid));
                 snprintf(buf, sizeof(buf), "objectid \"%s\"\n", buf2);
                 buf[ sizeof(buf)-1 ] = 0;
                 break;
             }
-            strncat(passthru->command, buf, sizeof(passthru->command));
+            strncat(passthru->command, buf, sizeof(passthru->command)-strlen(passthru->command)-1);
             passthru->command[ sizeof(passthru->command)-1 ] = 0;
             DEBUGMSGTL(("ucd-snmp/pass", "pass-running:  %s",
                         passthru->command));

=== modified file 'agent/mibgroup/ucd-snmp/pass.h'
--- agent/mibgroup/ucd-snmp/pass.h	2005-11-25 14:17:40 +0000
+++ agent/mibgroup/ucd-snmp/pass.h	2010-06-10 18:02:54 +0000
@@ -7,6 +7,7 @@
 void            init_pass(void);
 
 config_require(util_funcs)
+config_add_mib(NET-SNMP-PASS-MIB)
 
 extern FindVarMethod var_extensible_pass;
 WriteMethod     setPass;

=== modified file 'agent/mibgroup/ucd-snmp/pass_persist.c'
--- agent/mibgroup/ucd-snmp/pass_persist.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ucd-snmp/pass_persist.c	2010-06-10 18:02:54 +0000
@@ -218,6 +218,7 @@
     oid             newname[MAX_OID_LEN];
     int             i, rtest, newlen;
     static long     long_ret;
+    static in_addr_t addr_ret;
     char            buf[SNMP_MAXBUF];
     static char     buf2[SNMP_MAXBUF];
     static oid      objid[MAX_OID_LEN];
@@ -366,13 +367,13 @@
                         *var_len = 0;
                         return (NULL);
                     }
-                    long_ret =
+                    addr_ret =
                         (objid[0] << (8 * 3)) + (objid[1] << (8 * 2)) +
                         (objid[2] << 8) + objid[3];
-                    long_ret = htonl(long_ret);
-                    *var_len = sizeof(long_ret);
+                    addr_ret = htonl(addr_ret);
+                    *var_len = sizeof(addr_ret);
                     vp->type = ASN_IPADDRESS;
-                    return ((unsigned char *) &long_ret);
+                    return ((unsigned char *) &addr_ret);
                 }
             }
             *var_len = 0;
@@ -464,7 +465,7 @@
                 buf[ sizeof(buf)-1 ] = 0;
                 break;
             case ASN_OBJECT_ID:
-                sprint_mib_oid(buf2, (oid *) var_val, var_val_len);
+                sprint_mib_oid(buf2, (oid *) var_val, var_val_len/sizeof(oid));
                 snprintf(buf, sizeof(buf), "objectid \"%s\"\n", buf2);
                 buf[ sizeof(buf)-1 ] = 0;
                 break;
@@ -784,6 +785,13 @@
         close(persist_pipes[iindex].fdIn);
         persist_pipes[iindex].fdIn = -1;
     }
+
+#if defined(WIN32) && !defined (mingw32) && !defined (HAVE_SIGNAL)
+    if (!CloseHandle((HANDLE)persist_pipes[iindex].pid)) {
+          DEBUGMSGTL(("ucd-snmp/pass_persist","close_persist_pipe pid: close error\n"));
+        } 
+#endif
+    
 #ifdef __uClinux__
 	/*remove the pipes*/
 	unlink(fifo_in_path);

=== modified file 'agent/mibgroup/ucd-snmp/proc.c'
--- agent/mibgroup/ucd-snmp/proc.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/ucd-snmp/proc.c	2010-06-10 18:02:54 +0000
@@ -458,6 +458,7 @@
       if(len <= 0) continue;
       cmdline[len] = 0;
       while(--len && !cmdline[len]);
+      if(len <= 0) continue;
       while(--len) if(!cmdline[len]) cmdline[len] = ' ';
       if(!strncmp(cmdline,procname,plen)) total++;
 #else

=== modified file 'agent/mibgroup/ucd-snmp/proxy.c'
--- agent/mibgroup/ucd-snmp/proxy.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ucd-snmp/proxy.c	2010-06-10 18:02:54 +0000
@@ -4,7 +4,7 @@
  */
 /*
  * Portions of this file are copyrighted by:
- * Copyright @ 2003 Sun Microsystems, Inc. All rights reserved.
+ * Copyright @ 2009 Sun Microsystems, Inc. All rights reserved.
  * Use is subject to license terms specified in the COPYING file
  * distributed with the Net-SNMP package.
  */
@@ -408,6 +408,8 @@
                 /*
                  * too large 
                  */
+                if (pdu)
+                    snmp_free_pdu(pdu);
                 snmp_log(LOG_ERR,
                          "proxy oid request length is too long\n");
                 return SNMP_ERR_NOERROR;
@@ -437,6 +439,8 @@
      */
     if (!proxy_fill_in_session(handler, reqinfo, (void **)&configured)) {
         netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_GENERR);
+        if (pdu)
+            snmp_free_pdu(pdu);
         return SNMP_ERR_NOERROR;
     }
 

=== modified file 'agent/mibgroup/ucd-snmp/versioninfo.c'
--- agent/mibgroup/ucd-snmp/versioninfo.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ucd-snmp/versioninfo.c	2010-06-10 18:02:54 +0000
@@ -113,7 +113,7 @@
         *var_len = strlen(errmsg);
         return ((u_char *) errmsg);
     case VERDATE:
-        sprintf(errmsg, "$Date: 2006-09-14 17:48:50 -0700 (Thu, 14 Sep 2006) $");
+        sprintf(errmsg, "$Date: 2006-09-15 01:48:50 +0100 (Fri, 15 Sep 2006) $");
         *var_len = strlen(errmsg);
         return ((u_char *) errmsg);
     case VERCDATE:

=== modified file 'agent/mibgroup/ucd-snmp/vmstat.c'
--- agent/mibgroup/ucd-snmp/vmstat.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ucd-snmp/vmstat.c	2010-06-10 18:02:54 +0000
@@ -73,11 +73,11 @@
          */
         case CPURAWUSER:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->user_ticks );
+                                        info->user_ticks & 0xffffffff);
              break;
         case CPURAWNICE:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->nice_ticks );
+                                        info->nice_ticks & 0xffffffff);
              break;
         case CPURAWSYSTEM:
              /*
@@ -88,29 +88,29 @@
               *   if it has a non-zero value.
               */
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->sys2_ticks ?
+                                       (info->sys2_ticks ?
                                         info->sys2_ticks :
-                                        info->sys_ticks );
+                                        info->sys_ticks ) & 0xffffffff);
              break;
         case CPURAWIDLE:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->idle_ticks );
+                                        info->idle_ticks & 0xffffffff);
              break;
         case CPURAWWAIT:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->wait_ticks );
+                                        info->wait_ticks & 0xffffffff);
              break;
         case CPURAWKERNEL:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->kern_ticks );
+                                        info->kern_ticks & 0xffffffff);
              break;
         case CPURAWINTR:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->intrpt_ticks );
+                                        info->intrpt_ticks & 0xffffffff);
              break;
         case CPURAWSOFTIRQ:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->sirq_ticks );
+                                        info->sirq_ticks & 0xffffffff);
              break;
 
         /*
@@ -158,11 +158,11 @@
          */
         case SYSRAWINTERRUPTS:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->nInterrupts );
+                                        info->nInterrupts & 0xffffffff);
              break;
         case SYSRAWCONTEXT:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->nCtxSwitches );
+                                        info->nCtxSwitches & 0xffffffff);
              break;
         case SYSINTERRUPTS:
              if ( info->history && info->history[0].total_hist ) {
@@ -184,11 +184,11 @@
          */
         case RAWSWAPIN:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->swapIn );
+                                        info->swapIn & 0xffffffff);
              break;
         case RAWSWAPOUT:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->swapOut );
+                                        info->swapOut & 0xffffffff);
              break;
         case SWAPIN:
              if ( info->history && info->history[0].total_hist ) {
@@ -212,11 +212,11 @@
          */
         case IORAWSENT:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->pageOut );
+                                        info->pageOut & 0xffffffff);
              break;
         case IORAWRECEIVE:
              snmp_set_var_typed_integer(requests->requestvb, ASN_COUNTER,
-                                        info->pageIn );
+                                        info->pageIn & 0xffffffff);
              break;
         case IOSENT:
              if ( info->history && info->history[0].total_hist ) {

=== modified file 'agent/mibgroup/ucd-snmp/vmstat_solaris2.c'
--- agent/mibgroup/ucd-snmp/vmstat_solaris2.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/ucd-snmp/vmstat_solaris2.c	2010-06-10 18:02:54 +0000
@@ -521,6 +521,7 @@
         time_diff =
             (snapshot[0].css_time -
              snapshot[number_of_snapshots].css_time) / 1000000;
+        if ( time_diff == 0 ) { time_diff = 1; }  /* Protect against division-by-zero */
 
         DEBUGMSGTL(("ucd-snmp/vmstat_solaris2.c:update_stats",
                     "time_diff: %lld\n", time_diff));

=== modified file 'agent/mibgroup/udp-mib/data_access/udp_endpoint_linux.c'
--- agent/mibgroup/udp-mib/data_access/udp_endpoint_linux.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/udp-mib/data_access/udp_endpoint_linux.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  *  udpEndpointTable MIB architecture support
  *
- * $Id: udp_endpoint_linux.c 15986 2007-03-23 09:06:19Z dts12 $
+ * $Id: udp_endpoint_linux.c 17723 2009-08-05 20:07:38Z dts12 $
  */
 #include <net-snmp/net-snmp-config.h>
 #include <net-snmp/net-snmp-includes.h>
@@ -259,6 +259,7 @@
 
     container = netsnmp_file_text_parse(fp, container, PM_USER_FUNCTION,
                                         0, &lpi);
+    netsnmp_file_release(fp);
     return (NULL == container);
 }
 
@@ -291,7 +292,7 @@
 
     container = netsnmp_file_text_parse(fp, container, PM_USER_FUNCTION,
                                         0, &lpi);
-
+    netsnmp_file_release(fp);
     return (NULL == container);
 }
 #endif /* NETSNMP_ENABLE_IPV6 */

=== modified file 'agent/mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.c'
--- agent/mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/udp-mib/udpEndpointTable/udpEndpointTable_data_access.c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
  * Note: this file originally auto-generated by mib2c using
  *       version : 1.17 $ of : mfd-data-access.m2c,v $ 
  *
- * $Id: udpEndpointTable_data_access.c 15250 2006-09-19 03:27:05Z hardaker $
+ * $Id: udpEndpointTable_data_access.c 17719 2009-08-05 15:12:06Z jsafranek $
  */
 /*
  * standard Net-SNMP includes 
@@ -289,8 +289,7 @@
 
     ITERATOR_RELEASE(ep_it);
 
-    netsnmp_access_udp_endpoint_container_free(ep_c,
-                                               NETSNMP_ACCESS_UDP_ENDPOINT_FREE_DONT_CLEAR);
+    netsnmp_access_udp_endpoint_container_free(ep_c, 0);
 
 
     DEBUGMSGT(("verbose:udpEndpointTable:udpEndpointTable_container_load",

=== modified file 'agent/mibgroup/util_funcs.c'
--- agent/mibgroup/util_funcs.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/util_funcs.c	2010-06-10 18:02:54 +0000
@@ -86,6 +86,20 @@
 #ifdef HAVE_SYS_STAT_H
 #include <sys/stat.h>
 #endif
+#if HAVE_DIRENT_H
+#include <dirent.h>
+#else
+# define dirent direct
+# if HAVE_SYS_NDIR_H
+#  include <sys/ndir.h>
+# endif
+# if HAVE_SYS_DIR_H
+#  include <sys/dir.h>
+# endif
+# if HAVE_NDIR_H
+#  include <ndir.h>
+# endif
+#endif
 
 #include <net-snmp/net-snmp-includes.h>
 #include <net-snmp/agent/net-snmp-agent-includes.h>
@@ -130,12 +144,12 @@
 #else
     if (mktemp(name)) {
 # ifndef WIN32        
-        fd = open(name, O_CREAT | O_EXCL | O_WRONLY);
+        fd = open(name, O_CREAT | O_EXCL | O_WRONLY, S_IRUSR | S_IWUSR);
 # else
         /*
           Win32 needs _S_IREAD | _S_IWRITE to set permissions on file after closing
-         */
-        fd = _open(name, _O_CREAT, _S_IREAD | _S_IWRITE | _O_EXCL | _O_WRONLY);
+        */
+        fd = _open(name, _O_CREAT | _O_EXCL | _O_WRONLY, _S_IREAD | _S_IWRITE);
 # endif
     }
 #endif
@@ -629,10 +643,17 @@
       return 0;
     }
     
+    DEBUGMSGTL(("util_funcs","child hProcess (stored in pid): %d\n",(int)pi.hProcess));
+    DEBUGMSGTL(("util_funcs","child dwProcessId (task manager): %d\n",(int)pi.dwProcessId));
+
     /* Set global child process handle */
     *pid = (int)pi.hProcess;
 
-    /* Close pipe handles to make sure that no handles to the write end of the
+    /* Cleanup */
+    if (!CloseHandle(pi.hThread))
+      DEBUGMSGTL(("util_funcs","get_exec_pipes CloseHandle pi.hThread: %d\n",cmd));
+
+   /* Close pipe handles to make sure that no handles to the write end of the
      * output pipe are maintained in this process or else the pipe will
      * not close when the child process exits and any calls to ReadFile 
      * will hang.
@@ -1188,3 +1209,89 @@
     *max_idx = table->next_index - 1;
     return table->data;
 }
+
+#ifdef linux
+# define PROC_PATH          "/proc"
+# define FILE_DISP          "fd/"
+# define SOCKET_TYPE_1      "socket:["
+# define SOCKET_TYPE_2      "[0000]:"
+
+unsigned long long
+extract_inode(char *format)
+{
+    unsigned long long ret = 0;
+
+    if (!strncmp(format, SOCKET_TYPE_1, 8)) {
+        ret = strtoull(format + 8, NULL, 0);
+    } else if (!strncmp(format, SOCKET_TYPE_2, 7)) {
+        ret = strtoull(format + 7, NULL, 0);
+    }
+
+    return ret;
+}
+
+unsigned int
+get_pid_from_inode(unsigned long long inode)
+{
+    DIR            *procdirs = NULL, *piddirs = NULL;
+    char           *name = NULL;
+    char            path_name[PATH_MAX + 1];
+    char            socket_lnk[NAME_MAX + 1];
+    int             filelen = 0, readlen = 0, iflag = 0;
+    struct dirent  *procinfo, *pidinfo;
+    unsigned int    pid;
+    unsigned long long temp_inode;
+
+    if (!(procdirs = opendir(PROC_PATH))) {
+        snmp_log(LOG_ERR, "snmpd: cannot open /proc\n");       
+        return 0;
+    }
+
+    while ((procinfo = readdir(procdirs)) != NULL) {
+        name = procinfo->d_name;
+        for (; *name; name++) {
+            if (!isdigit(*name))
+                break;
+        }
+        if(*name)
+            continue;
+
+        memset(path_name, '\0', PATH_MAX + 1);
+        filelen = snprintf(path_name, PATH_MAX,
+                           PROC_PATH "/%s/" FILE_DISP, procinfo->d_name);
+        if (filelen <= 0 || PATH_MAX < filelen)
+            continue;
+
+        pid = strtoul(procinfo->d_name, NULL, 0);
+
+        if (!(piddirs = opendir(path_name)))
+            continue;
+
+        while ((pidinfo = readdir(piddirs)) != NULL) {
+            if (filelen + strlen(pidinfo->d_name) > PATH_MAX)
+                continue;
+
+            strcpy(path_name + filelen, pidinfo->d_name);
+
+            memset(socket_lnk, '\0', NAME_MAX + 1);
+            readlen = readlink(path_name, socket_lnk, NAME_MAX);
+            if (readlen < 0)
+                continue;
+            socket_lnk[readlen] = '\0';
+
+            temp_inode = extract_inode(socket_lnk);
+            if (inode == temp_inode) {
+                iflag = 1;
+                break;
+            }
+        }
+        closedir(piddirs);
+        if (iflag == 1)
+            break;
+    }
+    if (procdirs)
+        closedir(procdirs);
+    return pid;
+}
+
+#endif  /* #ifdef linux */

=== modified file 'agent/mibgroup/util_funcs.h'
--- agent/mibgroup/util_funcs.h	2005-11-25 14:17:40 +0000
+++ agent/mibgroup/util_funcs.h	2010-06-10 18:02:54 +0000
@@ -34,6 +34,10 @@
 void            wait_on_exec(struct extensible *);
 const char     *make_tempfile(void);
 
+#ifdef linux
+unsigned int    get_pid_from_inode(unsigned long long);
+#endif
+
 #define     satosin(x)      ((struct sockaddr_in *) &(x))
 #define     SOCKADDR(x)     (satosin(x)->sin_addr.s_addr)
 #ifndef MIB_STATS_CACHE_TIMEOUT

=== modified file 'agent/mibgroup/utilities/iquery.c'
--- agent/mibgroup/utilities/iquery.c	2009-11-12 16:17:40 +0000
+++ agent/mibgroup/utilities/iquery.c	2010-06-10 18:02:54 +0000
@@ -61,6 +61,9 @@
     if (secName)
         netsnmp_query_set_default_session(
              netsnmp_iquery_user_session(secName));
+    else
+        snmp_log(LOG_WARNING,
+                 "iquerySecName has not been configured - internal queries will fail\n");
     return SNMPERR_SUCCESS;
 }
 
@@ -186,7 +189,7 @@
         ss->securityEngineIDLen = engIDLen;
         if ( version == SNMP_VERSION_3 ) {
             ss->securityNameLen = strlen(secName);
-            memdup(&(ss->securityName), (u_char*)secName, ss->securityNameLen);
+            memdup((u_char**)&(ss->securityName), (u_char*)secName, ss->securityNameLen);
         } else {
             memdup( &(ss->community), secName, strlen(secName));
             ss->community_len = strlen(secName);

=== modified file 'agent/mibgroup/winExtDLL.c'
--- agent/mibgroup/winExtDLL.c	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/winExtDLL.c	2010-06-10 18:02:54 +0000
@@ -1,1605 +1,1694 @@
-/*
- *  winExtDLL Net-SNMP extension
- *  (c) 2006 Alex Burger
- *
- *  Created 9/9/06
- *
- * Purpose:  To load Windows SNMP Service extension DLLs provided with Windows
- *           (such as hostmib.dll).  This allows Net-SNMP to be a replacement 
- *           for the Windows SNMP service.
- *
- * Notes:    This extension requires the PSDK including the Snmp.h header file.
- *           Including Snmp.h will conflict with existing Net-SNMP defines for
- *           ASN_OCTETSTRING etc.  To resolve this, create a copy of Snmp.h in
- *           the PSDK include/ folder called Snmp-winExtDLL.h and change all
- *           occurances of ASN_ to MS_ASN_
- *
- *           This extension requires that the Windows SNMP Service is installed
- *           but set to disabled.  This is required so that the extension DLLs 
- *           are available for loading, and also because this extension and the 
- *           existing Windows extensions use the Windows SNMP API from snmpapi.dll.
- *
- *           This extension is NOT for dynamically loading Net-SNMP extensions.
- */
-
-#include <windows.h>
-#include <cstdio>
-#include <Snmp-winExtDLL.h>                  // Modified Windows SDK snmp.h.  See Notes above
-#include <mgmtapi.h>
-#include <string.h>
-
-/*
- * include important headers 
- */
+/**
+ * @brief winExtDLL Net-SNMP agent extension module.
+ *
+ * Copyright (c) 2006-2009 Alex Burger.
+ * Copyright (c) 2009-2010 Bart Van Assche <bart.vanassche@gmail.com>.
+ *
+ * This Net-SNMP agent extension module loads Windows SNMP Extension Agent
+ * DLLs in the Net-SNMP agent. Not only extension DLLs provided with Windows
+ * (e.g. hostmib.dll) but also third-party extension DLLs are supported. This
+ * allows Net-SNMP to be a replacement for the Windows SNMP service, and makes
+ * it possible to use the SNMPv3 protocol.
+ *
+ * @see See also <a href="http://msdn.microsoft.com/en-us/library/aa378988(VS.85).aspx">SNMP Functions</a>
+ *   for more information about Microsoft's SNMP Extension Agent API.
+ *
+ * @note In order to use this agent extension module, the Windows SNMP service
+ *   must be installed first and must be disabled. Installing the Windows SNMP
+ *   service is the only way to install the Windows Extension DLLs and to make
+ *   sure that information about these DLLs is present in the registry.
+ *
+ * @note All Windows extension DLLs are loaded during startup of the Net-SNMP
+ *   service. The Net-SNMP service must be restarted to load new modules. This
+ *   extension is NOT for dynamically loading Net-SNMP extensions.
+ *
+ *
+ * History:
+ * - 2010/03/19:
+ *    * Multi-varbind set request PDUs are now handled correctly.
+ *    * If loading an extension DLL fails, the reason why this failed is now
+ *      logged.
+ *    * Fixed a memory leak that occurred when SnmpExtensionQuery() or
+ *      SnmpExtensionQueryEx() failed while processing an SNMP PDU. Note:
+ *      occurrence of an SNMP error does not make these functions fail, and
+ *      it is not yet known whether or not it was possible to trigger this
+ *      memory leak.
+ * - 2010/03/17: Fixed bug 2971257. Multi-varbind getNext requests with OIDs
+ *     in reverse lexicographical order are again processed correctly.
+ * - 2010/01/22: Compiles now with MinGW too.
+ * - 2009/12/11:
+ *   * The value of sysUpTime.0 reported by inetmib1.dll is now correct.
+ *   * A linkUp or linkDown trap is now sent after the status of a network
+ *     interface has changed.
+ * - 2009/03/26: 
+ *   * Removed several artificial limits. Result: more than 100 SNMP extension
+ *     DLLs can now be loaded simultaneously and more than 100 OID ranges can
+ *     now be registered. Loading e.g. the Dell OpenManage SNMP extension DLL
+ *     does no longer crash Net-SNMP. 
+ *   * Number of OID ranges registered during startup is now logged.
+ *   * It is no longer attempted to free the Broadcom SNMP extension DLLs
+ *     bcmif.dll and baspmgnt.dll since doing so triggers a deadlock.
+ *   * Added support for reregistration of an OID prefix. As an example, both
+ *     both Microsoft's inetmib1.dll and the Eicon Diva divasnmpx.dll register
+ *     the OID prefix iso.org.dod.internet.mgmt.mib-2.interfaces
+ *     (.1.3.6.1.2.1.2). WinExtDLL will process OIDs with this prefix by using
+ *     the handler that was registered last for the OID prefix. A message will
+ *     be logged indicating that a handler has been replaced.
+ * - 2009/03/10:
+ *   * Fixed several bugs in var_winExtDLL(): looking up extension DLL info
+ *     based on the OID in a varbind is wrong. It does happen during GetNext
+ *     processing that Net-SNMP passes intentionally varbinds to a handler
+ *     with OIDs that are outside the range registered by the handler. Fixed
+ *     this by filling in a pointer to the extension DLL info in
+ *     netsnmp_mib_handler::myvoid and by using that information in the
+ *     var_winExtDLL() handler function.
+ *   * SetRequest PDUs are now passed once to an extension DLL instead of
+ *     four times.
+ *   * The error status and error index of a multi-varbind set request is now
+ *     filled in correctly.
+ *   * Added support for the SNMP extension DLL three-phase SNMP set.
+ *   * Made traps SNMPv2 compliant by adding the sysUpTime.0 varbind.
+ *   * The varbind list generated by extension DLLs for e.g. linkUp and
+ *     linkDown traps is now passed to Net-SNMP. Previously this varbind list
+ *     was discarded for generic traps.
+ *   * Fixed memory leaks triggered by Get and GetNext PDU processing.
+ *   * Added missing RegCloseKey() calls.
+ *   * Added shutdown function shutdown_winExtDLL().
+ *   * Replaced #include <cstdio> by #include <stdio.h> such that this source
+ *     file compiles with Visual Studio 2005.
+ *   * Removed many unused local variables.
+ *   * Fixed several other compiler warnings.
+ * - 2006/09/09: creation of this file.
+ */
+
 #include <net-snmp/net-snmp-config.h>
-#if HAVE_STDLIB_H
+#include <net-snmp/agent/mib_module_config.h>
+
+#ifdef USING_WINEXTDLL_MODULE
+
+#include <net-snmp/types.h>
+
+#include <assert.h>
+#include <stdio.h>
 #include <stdlib.h>
-#endif
-#if HAVE_STRING_H
 #include <string.h>
-#else
-#include <strings.h>
-#endif
-
-/*
- * needed by util_funcs.h 
- */
-#if TIME_WITH_SYS_TIME
-# ifdef WIN32
-#  include <sys/timeb.h>
-# else
-#  include <sys/time.h>
-# endif
-# include <time.h>
-#else
-# if HAVE_SYS_TIME_H
-#  include <sys/time.h>
-# else
-#  include <time.h>
-# endif
-#endif
-
-#if HAVE_WINSOCK_H
-#include <winsock.h>
-#endif
-#if HAVE_NETINET_IN_H
-#include <netinet/in.h>
-#endif
+#include <time.h>
+#include <windows.h>
+#include "../../win32/Snmp-winExtDLL.h"
+#include "../../win32/MgmtApi-winExtDLL.h"
 
 #include <net-snmp/net-snmp-includes.h>
 #include <net-snmp/agent/net-snmp-agent-includes.h>
-
 #include "util_funcs.h"
-
 #include "winExtDLL.h"
 
-#define SZBUF_MAX               1024
-#define SZBUF_DLLNAME_MAX       254
-#define MAX_WINEXT_DLLS         100
-#define MAX_KEY_LENGTH          255
+
 #define MAX_VALUE_NAME          16383
-#define MAX_WINEXT_TRAP_EVENTS  100
-
-#define DEBUGMSGWINOID(x)     do {if (_DBG_IF_) {__DBGMSGWINOID(x);} }while(0)
-#define __DBGMSGWINOID(x)     debugmsg_win_oid x
-void debugmsg_win_oid(const char *token, const AsnObjectIdentifier * theoid);
-
-/* Structure to hold name, pointers to functions and MIB tree supported by
- * each Windows SNMP Extension DLL */
-typedef struct {
-  char          dll_name[SZBUF_DLLNAME_MAX];
-  DWORD (WINAPI *xSnmpExtensionInit)(DWORD, HANDLE*, AsnObjectIdentifier*);
-  DWORD (WINAPI *xSnmpExtensionInitEx)(AsnObjectIdentifier*);
-  DWORD (WINAPI *xSnmpExtensionQuery)(BYTE, SnmpVarBindList* ,AsnInteger32* ,AsnInteger32*);
-  DWORD (WINAPI *xSnmpExtensionQueryEx)(DWORD, DWORD, SnmpVarBindList*, AsnOctetString*, AsnInteger32*, AsnInteger32*);
-  BOOL  (WINAPI *xSnmpExtensionTrap)( AsnObjectIdentifier *, AsnInteger *, AsnInteger *, AsnTimeticks *, SnmpVarBindList * );
-  HANDLE        *subagentTrapEvent;
-  netsnmp_handler_registration *my_handler;
-  oid           name[MAX_OID_LEN];              //   pSupportedView in Net-SNMP format
-  size_t        name_length;
-  AsnObjectIdentifier pSupportedView;
-} winExtensionAgents;
-
-winExtensionAgents winExtensionAgent[MAX_WINEXT_DLLS];
-winExtensionAgents winExtensionAgent_temp;      /* For sorting */
-int winExtensionAgent_index = 0;
-
-char *extDLLs[MAX_WINEXT_DLLS];
-int extDLLs_index = 0;
-
-HANDLE *subagentTrapEvents[MAX_WINEXT_TRAP_EVENTS];
-int subagentTrapEvents_index = 0;
-
-void winExtDLL_free_config_winExtDLL(void);
-
-void read_ExtensionAgents_list();
-void read_ExtensionAgents_list2(const TCHAR *);
-
-void subagentTrapCheck();
-
-void send_trap(
-    AsnObjectIdentifier *, 
-    AsnInteger *, 
-    AsnInteger *, 
-    AsnTimeticks *,    
-    SnmpVarBindList *);
-
-void init_winExtDLL(void)
-{
-  // Windows SNMP
-  DWORD dwUptimeReference = 0;
-  HANDLE subagentTrapEvent;
-  AsnObjectIdentifier pSupportedView;
-  BOOL result;
-  HANDLE hThread;
-  DWORD IDThread;
-
-  char dll_name[SZBUF_DLLNAME_MAX];
-  DWORD (WINAPI *xSnmpExtensionInit)(DWORD, HANDLE*, AsnObjectIdentifier*);
-  DWORD (WINAPI *xSnmpExtensionInitEx)(AsnObjectIdentifier*);
-  DWORD (WINAPI *xSnmpExtensionQuery)(BYTE, SnmpVarBindList* ,AsnInteger32* ,AsnInteger32*);
-  DWORD (WINAPI *xSnmpExtensionQueryEx)(DWORD, DWORD, SnmpVarBindList*, AsnOctetString*, AsnInteger32*, AsnInteger32*);
-  BOOL  (WINAPI *xSnmpExtensionTrap)( AsnObjectIdentifier *, AsnInteger *, AsnInteger *, AsnTimeticks *, SnmpVarBindList * );
-
-  // Net-SNMP
-  oid name[MAX_OID_LEN];
-  size_t length = 0;
-  int i;
-  int DLLnum = 0;
-  int winExtensionAgent_num = 0;
-  
-  int iter, indx;
-  
-  netsnmp_handler_registration *my_handler;
-
-  HANDLE hInst = NULL;
-
-  DEBUGMSGTL(("winExtDLL", "init_winExtDLL called\n"));
-
-  read_ExtensionAgents_list();  
-  
-  DEBUGMSGTL(("winExtDLL", "winExtDLL enabled.\n"));   
-  
-  DEBUGMSGTL(("winExtDLL", "Size of winExtensionAgent: %d\n",sizeof(winExtensionAgent) / sizeof(winExtensionAgents)));
-
-  for(i=0; i <= sizeof(winExtensionAgent) / sizeof(winExtensionAgents); i++) {
-    winExtensionAgent[0].xSnmpExtensionInit = NULL;
-    winExtensionAgent[0].xSnmpExtensionInitEx = NULL;
-  }
-
-  /* Load all the DLLs */
-  for (DLLnum = 0; DLLnum <= extDLLs_index; DLLnum++) {
-
-    if (! (extDLLs[DLLnum]))
-      continue;
-
-    DEBUGMSGTL(("winExtDLL", "-----------------------------------------\n"));
-    DEBUGMSGTL(("winExtDLL", "DLL to load: %s, DLL number: %d, winExtensionAgent_num: %d\n", extDLLs[DLLnum], DLLnum,
-          winExtensionAgent_num));
-    DEBUGMSGTL(("winExtDLL", "Size of DLL to load: %d\n", strlen(extDLLs[DLLnum])));
-    
-    hInst = LoadLibrary(extDLLs[DLLnum]);
-    
-    if (hInst == NULL)
-    {
-      DEBUGMSGTL(("winExtDLL","Could not load Windows extension DLL %s.\n", extDLLs[DLLnum]));
-      snmp_log(LOG_ERR,
-          "Could not load Windows extension DLL: %s.\n", extDLLs[DLLnum]);
-      continue;
-    }
-    else {
-      DEBUGMSGTL(("winExtDLL","DLL loaded.\n"));
-    }
-
-    // Create local copy of DLL name and functions
-    strncpy(dll_name, extDLLs[DLLnum], SZBUF_DLLNAME_MAX-1);
-    xSnmpExtensionInit = (DWORD (WINAPI *)(DWORD, HANDLE*, AsnObjectIdentifier*)) 
-      GetProcAddress ((HMODULE) hInst, "SnmpExtensionInit");
-    xSnmpExtensionInitEx = (DWORD (WINAPI *)(AsnObjectIdentifier*)) 
-      GetProcAddress ((HMODULE) hInst, "SnmpExtensionInitEx");
-    xSnmpExtensionQuery = (DWORD (WINAPI *)(BYTE, SnmpVarBindList* ,AsnInteger32* ,AsnInteger32*)) 
-      GetProcAddress ((HMODULE) hInst, "SnmpExtensionQuery");
-    xSnmpExtensionQueryEx = (DWORD (WINAPI *)(DWORD, DWORD, SnmpVarBindList*, AsnOctetString*, AsnInteger32*, AsnInteger32*))
-      GetProcAddress ((HMODULE) hInst, "SnmpExtensionQueryEx");
-    xSnmpExtensionTrap = (BOOL  (WINAPI *)(AsnObjectIdentifier *, AsnInteger *, AsnInteger *, AsnTimeticks *, SnmpVarBindList * ))
-      GetProcAddress ((HMODULE) hInst, "SnmpExtensionTrap");
-
-    if (xSnmpExtensionQuery)
-      DEBUGMSGTL(("winExtDLL", "xSnmpExtensionQuery found\n"));
-    if (xSnmpExtensionQueryEx)
-      DEBUGMSGTL(("winExtDLL", "xSnmpExtensionQueryEx found\n"));
-    if (xSnmpExtensionQuery)
-      DEBUGMSGTL(("winExtDLL", "xSnmpExtensionTrap found\n"));
-
-    // Store DLL name and functions in winExtensionAgent array
-    strncpy(winExtensionAgent[winExtensionAgent_num].dll_name, dll_name, SZBUF_DLLNAME_MAX-1);
-    winExtensionAgent[winExtensionAgent_num].xSnmpExtensionInit = xSnmpExtensionInit;
-    winExtensionAgent[winExtensionAgent_num].xSnmpExtensionInitEx = xSnmpExtensionInitEx;
-    winExtensionAgent[winExtensionAgent_num].xSnmpExtensionQuery = xSnmpExtensionQuery;
-    winExtensionAgent[winExtensionAgent_num].xSnmpExtensionQueryEx = xSnmpExtensionQueryEx;
-    winExtensionAgent[winExtensionAgent_num].xSnmpExtensionTrap = xSnmpExtensionTrap;
-
-    // Init and get first supported view from Windows SNMP extension DLL  
-    result = xSnmpExtensionInit(dwUptimeReference, &subagentTrapEvent, &pSupportedView);
-
-    DEBUGMSGTL(("winExtDLL", "Supported view: "));
-    DEBUGMSGWINOID(("winExtDLL", &pSupportedView));
-    DEBUGMSG(("winExtDLL", "\n"));
-
-    // Store the subagent's trap handler, even if it's NULL
-    winExtensionAgent[winExtensionAgent_num].subagentTrapEvent = subagentTrapEvent;
-
-    // Store the subagent's trap handler in a global array for use by waitformultipleobjects()
-    if (subagentTrapEvent) {
-      DEBUGMSGTL(("winExtDLL", "Trap handler defined.  Storing...\n"));
-      subagentTrapEvents[subagentTrapEvents_index] = subagentTrapEvent;
-      subagentTrapEvents_index++;
-    }
-
-    // Convert OID from Windows 'supported view' to Net-SNMP
-    for (i = 0; i < (pSupportedView.idLength > MAX_OID_LEN?MAX_OID_LEN:pSupportedView.idLength); i++) {
-      name[i] = (oid)pSupportedView.ids[i];
-    }
-    length = i;
-
-    // Store supported view in Net-SNMP format
-    memcpy(winExtensionAgent[winExtensionAgent_num].name, name, sizeof(name));
-    winExtensionAgent[winExtensionAgent_num].name_length = length;
- 
-    DEBUGMSGTL(("winExtDLL", "Windows OID converted to Net-SNMP: "));
-    DEBUGMSGOID(("winExtDLL", name, length));
-    DEBUGMSG(("winExtDLL", "\n"));
-
-    // Store supported view in Windows format
-    SnmpUtilOidCpy(&winExtensionAgent[winExtensionAgent_num].pSupportedView,&pSupportedView);
-
-    // Create handler registration
-    winExtensionAgent[winExtensionAgent_num].my_handler = netsnmp_create_handler_registration("winExtDLL",
-        var_winExtDLL,
-        name,
-        length,
-        HANDLER_CAN_RWRITE);
-    
-    if (!winExtensionAgent[winExtensionAgent_num].my_handler) {
-      snmp_log(LOG_ERR,
-          "malloc failed registering handler for winExtDLL");
-      DEBUGMSGTL(("winExtDLL", "malloc failed registering handler for winExtDLL"));
-      return (-1);
-    }
-    else {
-      DEBUGMSGTL(("winExtDLL", "handler registered\n"));
-    }
-    
-    // Register handler with Net-SNMP
-    netsnmp_register_handler(winExtensionAgent[winExtensionAgent_num].my_handler);
-
-    // Check for additional supported views and register them with the same handler
-    if (winExtensionAgent[winExtensionAgent_num].xSnmpExtensionInitEx) {
-      DEBUGMSGTL(("winExtDLL", "xSnmpExtensionInitEx found\n"));
-
-      winExtensionAgent_num++;
-
-      while (1) { // Loop looking for more supported views
-        // Store DLL name and functions in winExtensionAgent array  
-        strncpy(winExtensionAgent[winExtensionAgent_num].dll_name, dll_name, SZBUF_DLLNAME_MAX-1);
-        winExtensionAgent[winExtensionAgent_num].xSnmpExtensionInit = xSnmpExtensionInit;
-        winExtensionAgent[winExtensionAgent_num].xSnmpExtensionInitEx = xSnmpExtensionInitEx;
-        winExtensionAgent[winExtensionAgent_num].xSnmpExtensionQuery = xSnmpExtensionQuery;
-        winExtensionAgent[winExtensionAgent_num].xSnmpExtensionQueryEx = xSnmpExtensionQueryEx;
-        winExtensionAgent[winExtensionAgent_num].xSnmpExtensionTrap = xSnmpExtensionTrap;     
-        winExtensionAgent[winExtensionAgent_num].subagentTrapEvent = NULL;
-        // Get extra supported view
-        result = xSnmpExtensionInitEx(&pSupportedView);
-
-        if (! (result)) {
-          winExtensionAgent_num--;
-          break;
-        }
-
-        DEBUGMSGTL(("winExtDLL", "result of xSnmpExtensionInitEx: %d\n",result));
-      
-        DEBUGMSGTL(("winExtDLL", "Supported view: "));
-        DEBUGMSGWINOID(("winExtDLL", &pSupportedView));
-        DEBUGMSG(("winExtDLL", "\n"));
-        
-        // Convert OID from Windows 'supported view' to Net-SNMP
-        for (i = 0; i < (pSupportedView.idLength > MAX_OID_LEN?MAX_OID_LEN:pSupportedView.idLength); i++) {
-          name[i] = (oid)pSupportedView.ids[i];
-        }
-        length = i;
-  
-        // Store supported view in Net-SNMP format
-        memcpy(winExtensionAgent[winExtensionAgent_num].name, name, sizeof(name));
-        winExtensionAgent[winExtensionAgent_num].name_length = length;
-
-        DEBUGMSGTL(("winExtDLL", "Windows OID converted to Net-SNMP: "));
-        DEBUGMSGOID(("winExtDLL", name, length));
-        DEBUGMSG(("winExtDLL", "\n"));
-  
-        // Store supported view in Windows format
-        SnmpUtilOidCpy(&winExtensionAgent[winExtensionAgent_num].pSupportedView,&pSupportedView);
-  
+#define MS_ASN_UINTEGER32 MS_ASN_UNSIGNED32
+
+
+typedef         BOOL(WINAPI *
+                     PFNSNMPEXTENSIONINIT) (DWORD dwUpTimeReference,
+                                            HANDLE * phSubagentTrapEvent,
+                                            AsnObjectIdentifier *
+                                            pFirstSupportedRegion);
+
+typedef         BOOL(WINAPI *
+                     PFNSNMPEXTENSIONINITEX) (AsnObjectIdentifier *
+                                              pNextSupportedRegion);
+
+typedef         BOOL(WINAPI *
+                     PFNSNMPEXTENSIONMONITOR) (LPVOID pAgentMgmtData);
+
+typedef         BOOL(WINAPI * PFNSNMPEXTENSIONQUERY) (BYTE bPduType,
+                                                      SnmpVarBindList *
+                                                      pVarBindList,
+                                                      AsnInteger32 *
+                                                      pErrorStatus,
+                                                      AsnInteger32 *
+                                                      pErrorIndex);
+
+typedef         BOOL(WINAPI * PFNSNMPEXTENSIONQUERYEX) (UINT nRequestType,
+                                                        UINT
+                                                        nTransactionId,
+                                                        SnmpVarBindList *
+                                                        pVarBindList,
+                                                        AsnOctetString *
+                                                        pContextInfo,
+                                                        AsnInteger32 *
+                                                        pErrorStatus,
+                                                        AsnInteger32 *
+                                                        pErrorIndex);
+
+typedef         BOOL(WINAPI * PFNSNMPEXTENSIONTRAP) (AsnObjectIdentifier *
+                                                     pEnterpriseOid,
+                                                     AsnInteger32 *
+                                                     pGenericTrapId,
+                                                     AsnInteger32 *
+                                                     pSpecificTrapId,
+                                                     AsnTimeticks *
+                                                     pTimeStamp,
+                                                     SnmpVarBindList *
+                                                     pVarBindList);
+
+typedef         VOID(WINAPI * PFNSNMPEXTENSIONCLOSE) (void);
+
+/**
+ * Extensible array, a data structure similar to the C++ STL class
+ * std::vector<>.
+ */
+typedef struct {
+    /** Pointer to the memory allocated for the array. */
+    void           *p;
+    /** Number of bytes occupied by a single element.  */
+    size_t          elem_size;
+    /** Number of elements that have been allocated.   */
+    int             reserved;
+    /** Number of elements currently in use.           */
+    int             size;
+} xarray;
+
+/**
+ * Information managed by winExtDLL about Windows SNMP extension DLL's.
+ */
+typedef struct {
+    char           *dll_name;                        /**< Dynamically allocated DLL name. */
+    HANDLE          dll_handle;                      /**< DLL handle. */
+    PFNSNMPEXTENSIONINIT pfSnmpExtensionInit;
+    PFNSNMPEXTENSIONINITEX pfSnmpExtensionInitEx;
+    PFNSNMPEXTENSIONQUERY pfSnmpExtensionQuery;
+    PFNSNMPEXTENSIONQUERYEX pfSnmpExtensionQueryEx;
+    PFNSNMPEXTENSIONTRAP pfSnmpExtensionTrap;
+    HANDLE          subagentTrapEvent;
+} winextdll;
+
+/**
+ * Information managed by winExtDLL about a single view of a Windows SNMP
+ * extension DLL.
+ */
+typedef struct {
+    winextdll      *winextdll_info;
+    netsnmp_handler_registration *my_handler;
+    oid             name[MAX_OID_LEN];                   /**< OID of this view. */
+    size_t          name_length;
+} winextdll_view;
+
+/**
+ * Per varbind SNMP extension DLL context information for SNMP set operations.
+ */
+typedef struct context_info_s {
+    struct context_info_s *next;
+    int             index;
+    AsnOctetString  context_info;
+} context_info;
+
+
+/*
+ * External function declarations. 
+ */
+void __declspec(dllimport) WINAPI SnmpSvcInitUptime(void);
+
+
+/*
+ * Local functions declarations. 
+ */
+static int      basename_equals(const char *path, const char *basename);
+static int      register_netsnmp_handler(winextdll_view *
+                                         const ext_dll_view_info);
+static void     read_extension_dlls_from_registry(void);
+static void     read_extension_dlls_from_registry_at(const char *const subkey);
+static char    *read_extension_dll_path_from_registry(const TCHAR *);
+static void     subagentTrapCheck(unsigned int clientreg, void *clientarg);
+static int      var_winExtDLL(netsnmp_mib_handler *handler,
+                              netsnmp_handler_registration *reginfo,
+                              netsnmp_agent_request_info *reqinfo,
+                              netsnmp_request_info *requests);
+static int      append_windows_varbind_list(netsnmp_variable_list **
+                                            const net_snmp_varbinds,
+                                            const SnmpVarBindList *
+                                            const win_varbinds);
+static int      append_windows_varbind(netsnmp_variable_list **
+                                       const net_snmp_varbinds,
+                                       const SnmpVarBind *
+                                       const win_varbind);
+static int      convert_to_windows_varbind_list(SnmpVarBindList *
+                                                pVarBindList,
+                                                netsnmp_variable_list *
+                                                netsnmp_varbinds);
+static int      convert_win_snmp_err(const int win_snmp_err);
+static winextdll_view *lookup_view_by_oid(oid * const name,
+                                          const size_t name_len);
+static void     copy_oid(oid * const to_name, size_t * const to_name_len,
+                         const oid * const from_name,
+                         const size_t from_name_len);
+static UINT    *copy_oid_to_new_windows_oid(AsnObjectIdentifier *
+                                            const windows_oid,
+                                            const oid * const name,
+                                            const size_t name_len);
+static void     send_trap(const AsnObjectIdentifier * const,
+                          const AsnInteger, const AsnInteger,
+                          const AsnTimeticks,
+                          const SnmpVarBindList * const);
+static u_char  *winsnmp_memdup(const void *src, const size_t len);
+#if 0
+static void     xarray_init(xarray * a, size_t elem_size);
+#endif
+static void     xarray_destroy(xarray * a);
+static void    *xarray_push_back(xarray * a, const void *elem);
+#if 0
+static void     xarray_erase(xarray * a, void *const elem);
+#endif
+static void    *xarray_reserve(xarray * a, int reserved);
+
+
+/*
+ * Local variable definitions. 
+ */
+#define WINEXTDLL(i)            ((winextdll*)s_winextdll.p)[i]
+#define WINEXTDLL_VIEW(i)       ((winextdll_view*)s_winextdll_view.p)[i]
+#define TRAPEVENT(i)            ((HANDLE*)s_trapevent.p)[i]
+#define TRAPEVENT_TO_DLLINFO(i) ((winextdll**)s_trapevent_to_dllinfo.p)[i]
+static xarray   s_winextdll = { 0, sizeof(winextdll) };
+static xarray   s_winextdll_view = { 0, sizeof(winextdll_view) };
+static xarray   s_trapevent = { 0, sizeof(HANDLE) };
+static xarray   s_trapevent_to_dllinfo = { 0, sizeof(winextdll *) };
+static context_info *context_info_head;
+
+
+/*
+ * Function definitions. 
+ */
+
+/** Initialize the winExtDLL extension agent. */
+void
+init_winExtDLL(void)
+{
+    BOOL            result;
+    int             i;
+
+    DEBUGMSG(("winExtDLL", "init_winExtDLL started.\n"));
+
+    SnmpSvcInitUptime();
+
+    read_extension_dlls_from_registry();
+
+    DEBUGMSG(("winExtDLL",
+              "init_winExtDLL: found %d extension DLLs in the registry.\n",
+              s_winextdll.size));
+
+    xarray_reserve(&s_winextdll, 128);
+
+    /*
+     * Load all the DLLs 
+     */
+    for (i = 0; i < s_winextdll.size; i++) {
+        winextdll      *const ext_dll_info = &WINEXTDLL(i);
+        AsnObjectIdentifier view;
+        winextdll_view  ext_dll_view_info;
+
+        assert(ext_dll_info);
+        if (!ext_dll_info->dll_name)
+            continue;
+
+        DEBUGMSG(("winExtDLL", "loading DLL %s.\n",
+                  ext_dll_info->dll_name));
+        ext_dll_info->dll_handle = LoadLibrary(ext_dll_info->dll_name);
+
+        if (ext_dll_info->dll_handle == NULL) {
+            const DWORD     dwErrorcode = GetLastError();
+            LPTSTR          lpMsgBuf;
+
+            FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
+                          FORMAT_MESSAGE_FROM_SYSTEM, NULL, dwErrorcode,
+                          MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
+                          (LPTSTR) & lpMsgBuf, 0, NULL);
+            if (lpMsgBuf) {
+                LPTSTR          p;
+
+                /*
+                 * Remove trailing "\r\n".
+                 */
+                p = strchr(lpMsgBuf, '\r');
+                if (p)
+                    *p = '\0';
+            }
+            snmp_log(LOG_ERR,
+                     "init_winExtDLL: could not load SNMP extension"
+                     " DLL %s: %s\n",
+                     ext_dll_info->dll_name, lpMsgBuf ? lpMsgBuf : "(?)");
+            if (lpMsgBuf)
+                LocalFree(lpMsgBuf);
+            continue;
+        }
+
+        /*
+         * Store DLL name and functions in s_extension_dll_info array. 
+         */
+        ext_dll_info->pfSnmpExtensionInit = (PFNSNMPEXTENSIONINIT)
+            GetProcAddress(ext_dll_info->dll_handle, "SnmpExtensionInit");
+        ext_dll_info->pfSnmpExtensionInitEx = (PFNSNMPEXTENSIONINITEX)
+            GetProcAddress(ext_dll_info->dll_handle,
+                           "SnmpExtensionInitEx");
+        ext_dll_info->pfSnmpExtensionQuery = (PFNSNMPEXTENSIONQUERY)
+            GetProcAddress(ext_dll_info->dll_handle, "SnmpExtensionQuery");
+        ext_dll_info->pfSnmpExtensionQueryEx = (PFNSNMPEXTENSIONQUERYEX)
+            GetProcAddress(ext_dll_info->dll_handle,
+                           "SnmpExtensionQueryEx");
+        ext_dll_info->pfSnmpExtensionTrap = (PFNSNMPEXTENSIONTRAP)
+            GetProcAddress(ext_dll_info->dll_handle, "SnmpExtensionTrap");
+
+
+        if (ext_dll_info->pfSnmpExtensionQuery == NULL
+            && ext_dll_info->pfSnmpExtensionQueryEx == NULL) {
+            snmp_log(LOG_ERR,
+                     "error in extension DLL %s: SNMP query function missing.\n",
+                     ext_dll_info->dll_name);
+        }
+
+        /*
+         * Init and get first supported view from Windows SNMP extension DLL.
+         * Note: although according to the documentation of SnmpExtensionInit()
+         * the first argument of this function should be ignored by extension
+         * DLLs, passing the value GetTickCount() / 10 is necessary to make
+         * inetmib1.dll work correctly. Passing zero as the first argument
+         * causes inetmib1.dll to report an incorrect value for sysUpTime.0
+         * and also causes the same DLL not to send linkUp or linkDown traps.
+         */
+        ext_dll_info->subagentTrapEvent = NULL;
+        view.idLength = 0;
+        view.ids = 0;
+        result =
+            ext_dll_info->pfSnmpExtensionInit(GetTickCount() / 10,
+                                              &ext_dll_info->
+                                              subagentTrapEvent, &view);
+
+        if (!result) {
+            snmp_log(LOG_ERR,
+                     "init_winExtDLL: initialization of DLL %s failed.\n",
+                     ext_dll_info->dll_name);
+            FreeLibrary(ext_dll_info->dll_handle);
+            ext_dll_info->dll_handle = 0;
+            continue;
+        }
+
+        if (ext_dll_info->subagentTrapEvent != NULL) {
+            xarray_push_back(&s_trapevent,
+                             &ext_dll_info->subagentTrapEvent);
+            xarray_push_back(&s_trapevent_to_dllinfo, &ext_dll_info);
+        }
+
+        memset(&ext_dll_view_info, 0, sizeof(ext_dll_view_info));
+        ext_dll_view_info.winextdll_info = ext_dll_info;
+        copy_oid(ext_dll_view_info.name, &ext_dll_view_info.name_length,
+                 view.ids, view.idLength);
+        xarray_push_back(&s_winextdll_view, &ext_dll_view_info);
+
+        /*
+         * Loop looking for more supported views. 
+         */
+        while (ext_dll_info->pfSnmpExtensionInitEx
+               && ext_dll_info->pfSnmpExtensionInitEx(&view)) {
+            memset(&ext_dll_view_info, 0, sizeof(ext_dll_view_info));
+            ext_dll_view_info.winextdll_info = ext_dll_info;
+            copy_oid(ext_dll_view_info.name,
+                     &ext_dll_view_info.name_length, view.ids,
+                     view.idLength);
+            xarray_push_back(&s_winextdll_view, &ext_dll_view_info);
+        }
+    }
+
+    /*
+     * Note: since register_netsnmp_handler() writes a pointer to the
+     * winextdll_view in one of the Net-SNMP data structures, it is not
+     * allowed to move winextdll_view data structures in memory after
+     * registration with Net-SNMP. Or: register_snmp_handler() must be called
+     * only once it is sure that the size of array s_winextdll_view won't change
+     * anymore.
+     */
+    for (i = 0; i < s_winextdll_view.size; i++)
+        register_netsnmp_handler(&WINEXTDLL_VIEW(i));
+
+    DEBUGMSG(("winExtDLL",
+              "init_winExtDLL: registered %d OID ranges.\n",
+              s_winextdll_view.size));
+
+    /*
+     * Let Net-SNMP call subagentTrapCheck() once per second. 
+     */
+    if (s_trapevent.size)
+        snmp_alarm_register(1, SA_REPEAT, subagentTrapCheck, NULL);
+
+    DEBUGMSG(("winExtDLL", "init_winExtDLL finished.\n"));
+}
+
+void
+shutdown_winExtDLL(void)
+{
+    int             i;
+
+    DEBUGMSG(("winExtDLL", "shutdown_winExtDLL() started.\n"));
+
+    for (i = s_winextdll_view.size - 1; i >= 0; i--) {
+        winextdll_view *const v = &WINEXTDLL_VIEW(i);
+        if (v && v->my_handler) {
+            DEBUGIF("winExtDLL") {
+                DEBUGMSG(("winExtDLL",
+                          "unregistering handler for DLL %s and OID prefix ",
+                          v->winextdll_info->dll_name));
+                DEBUGMSGOID(("winExtDLL", v->name, v->name_length));
+                DEBUGMSG(("winExtDLL", " ("));
+                DEBUGMSGSUBOID(("winExtDLL", v->name, v->name_length));
+                DEBUGMSG(("winExtDLL", ").\n"));
+            }
+            netsnmp_unregister_handler(v->my_handler);
+        }
+    }
+    xarray_destroy(&s_winextdll_view);
+
+    for (i = s_winextdll.size - 1; i >= 0; i--) {
+        winextdll      *const ext_dll_info = &WINEXTDLL(i);
+        /*
+         * Freeing the Broadcom SNMP extension libraries triggers a deadlock,
+         * so skip bcmif.dll and baspmgnt.dll. 
+         */
+        if (ext_dll_info->dll_handle != 0
+            && !basename_equals(ext_dll_info->dll_name, "bcmif.dll")
+            && !basename_equals(ext_dll_info->dll_name, "baspmgnt.dll")) {
+            DEBUGMSG(("winExtDLL", "unloading %s.\n",
+                      ext_dll_info->dll_name));
+            FreeLibrary(ext_dll_info->dll_handle);
+        }
+        free(ext_dll_info->dll_name);
+    }
+    xarray_destroy(&s_winextdll);
+
+    xarray_destroy(&s_trapevent_to_dllinfo);
+
+    xarray_destroy(&s_trapevent);
+
+    DEBUGMSG(("winExtDLL", "shutdown_winExtDLL() finished.\n"));
+}
+
+/**
+ * Compare the basename of a path with a given string.
+ *
+ * @return 1 if the basename matches, 0 if not.
+ */
+static int
+basename_equals(const char *path, const char *basename)
+{
+    const size_t    path_len = strlen(path);
+    const size_t    basename_len = strlen(basename);
+
+    assert(strchr(path, '/') == 0);
+    assert(strchr(basename, '/') == 0);
+    assert(strchr(basename, '\\') == 0);
+
+    return path_len >= basename_len + 1
+        && path[path_len - basename_len - 1] == '\\'
+        && stricmp(path + path_len - basename_len, basename) == 0;
+}
+
+/**
+ * Register a single OID subtree with Net-SNMP.
+ *
+ * @return 1 if successful, 0 if not.
+ */
+int
+register_netsnmp_handler(winextdll_view * const ext_dll_view_info)
+{
+    winextdll      *ext_dll_info;
+    winextdll_view *previously_registered_view;
+
+    ext_dll_info = ext_dll_view_info->winextdll_info;
+
+    previously_registered_view
+        = lookup_view_by_oid(ext_dll_view_info->name,
+                             ext_dll_view_info->name_length);
+
+    if (previously_registered_view) {
+        size_t          oid_namelen, outlen;
+        char           *oid_name;
+        int             buffer_large_enough;
+
+        oid_namelen = 0;
+        outlen = 0;
+        oid_name = NULL;
+        buffer_large_enough =
+            sprint_realloc_objid((u_char **) & oid_name, &oid_namelen,
+                                 &outlen, 1, ext_dll_view_info->name,
+                                 ext_dll_view_info->name_length);
+        snmp_log(LOG_INFO, "OID range %s%s: replacing handler %s by %s.\n",
+                 oid_name ? oid_name : "",
+                 buffer_large_enough ? "" : " [TRUNCATED]",
+                 previously_registered_view->winextdll_info->dll_name,
+                 ext_dll_view_info->winextdll_info->dll_name);
+        if (oid_name)
+            free(oid_name);
+
+        previously_registered_view->winextdll_info = ext_dll_info;
+        memset(ext_dll_view_info, 0, sizeof(*ext_dll_view_info));
+        return 1;
+    } else {
         // Create handler registration
-        winExtensionAgent[winExtensionAgent_num].my_handler = netsnmp_create_handler_registration("winExtDLL",
-            var_winExtDLL,
-            name,
-            length,
-            HANDLER_CAN_RWRITE);
-        
-        if (!winExtensionAgent[winExtensionAgent_num].my_handler) {
-          snmp_log(LOG_ERR,
-              "malloc failed registering handler for winExtDLL");
-          DEBUGMSGTL(("winExtDLL", "malloc failed registering handler for winExtDLL"));
-          return (-1);
-        }
-        else {
-          DEBUGMSGTL(("winExtDLL", "handler registered\n"));
-        }
-        
-        // Register handler with Net-SNMP
-        netsnmp_register_handler(winExtensionAgent[winExtensionAgent_num].my_handler);
-
-        winExtensionAgent_num++;
-      } 
-    }
-    winExtensionAgent_num++;
-  }
-
-
-  winExtensionAgent_index = winExtensionAgent_num-1;             // Array index
-  DEBUGMSGTL(("winExtDLL", "winExtensionAgent_index: %d\n",winExtensionAgent_index));
-
-  /* Reverse sort array of winExtensionAgents */
-  i = sizeof(winExtensionAgent) / sizeof(winExtensionAgents);
-  //DEBUGMSGTL(("winExtDLL", "Sorting...\n"));
-  for (iter=0; iter < i-1; iter++) {
-    for (indx=0; indx < i-1; indx++) {
-      if (snmp_oidtree_compare(winExtensionAgent[indx].name, winExtensionAgent[indx].name_length,
-            winExtensionAgent[indx+1].name, winExtensionAgent[indx+1].name_length) < 0) {
-        winExtensionAgent_temp = winExtensionAgent[indx];
-        winExtensionAgent[indx] = winExtensionAgent[indx+1];
-        winExtensionAgent[indx+1] = winExtensionAgent_temp;
-      }
-    }
-  }
-  DEBUGMSGTL(("winExtDLL", "Dumping sorted Windows extension OIDs\n"));
-  for (i=0; winExtensionAgent[i].xSnmpExtensionInit; i++) {
-    DEBUGMSGTL(("winExtDLL", "DLL name: %s, view: ",winExtensionAgent[i].dll_name));
-    DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-    DEBUGMSG(("winExtDLL", "\n"));
-  }
-
-  DEBUGMSGTL(("winExtDLL", "Number of subagentTrapEvents: %d\n",subagentTrapEvents_index));
-
-  if (subagentTrapEvents_index) {
-    
-    DEBUGMSGTL(("winExtDLL", "Setting alarm check for subagent trap events every 5 seconds\n"));
-    snmp_alarm_register(5,      /* seconds */
-        SA_REPEAT,              /* repeat (every x seconds). */
-        subagentTrapCheck,      /* our callback */
-        NULL                    /* no callback data needed */
-        );    
-  }
-}
-
-int
+        ext_dll_view_info->my_handler
+            = netsnmp_create_handler_registration(ext_dll_info->dll_name,
+                                                  var_winExtDLL,
+                                                  ext_dll_view_info->name,
+                                                  ext_dll_view_info->
+                                                  name_length,
+                                                  HANDLER_CAN_RWRITE);
+
+        if (ext_dll_view_info->my_handler) {
+            ext_dll_view_info->my_handler->handler->myvoid =
+                ext_dll_view_info;
+            if (netsnmp_register_handler(ext_dll_view_info->my_handler)
+                == MIB_REGISTERED_OK) {
+                DEBUGIF("winExtDLL") {
+                    DEBUGMSG(("winExtDLL",
+                              "registering handler for DLL %s and OID prefix ",
+                              ext_dll_info->dll_name));
+                    DEBUGMSGOID(("winExtDLL", ext_dll_view_info->name,
+                                 ext_dll_view_info->name_length));
+                    DEBUGMSG(("winExtDLL", " ("));
+                    DEBUGMSGSUBOID(("winExtDLL", ext_dll_view_info->name,
+                                    ext_dll_view_info->name_length));
+                    DEBUGMSG(("winExtDLL", ").\n"));
+                }
+                return 1;
+            } else {
+                snmp_log(LOG_ERR, "handler registration failed.\n");
+                ext_dll_view_info->my_handler = 0;
+            }
+        } else {
+            snmp_log(LOG_ERR, "handler creation failed.\n");
+        }
+    }
+
+    return 0;
+}
+
+/**
+ * Allocate SNMP extension DLL context information. Such context information
+ * is necessary to allow an extension DLL to process a set request.
+ *
+ * @param[in] index Varbind index in original PDU.
+ *
+ * @return NULL if context information for the specified index was already
+ *   allocated, and otherwise a pointer to the newly allocated context
+ *   information.
+ */
+static context_info *
+alloc_context_info(const int index)
+{
+    context_info   *p;
+
+    DEBUGMSG(("winExtDLL:context_info", "alloc_context_info(%d)\n",
+              index));
+
+    for (p = context_info_head; p; p = p->next) {
+        if (p->index == index) {
+            assert(FALSE);
+            return NULL;
+        }
+    }
+
+    p = calloc(1, sizeof(context_info));
+    p->next = context_info_head;
+    context_info_head = p;
+    p->index = index;
+
+    return p;
+}
+
+/**
+ * Deallocate SNMP extension DLL context information.
+ *
+ * @param[in] index Varbind index in original PDU.
+ */
+static void
+free_context_info(const int index)
+{
+    context_info  **pprev = &context_info_head;
+    context_info   *p;
+
+    DEBUGMSG(("winExtDLL:context_info", "free_context_info(%d)\n", index));
+
+    for (p = context_info_head; p; p = p->next) {
+        if (p->index == index) {
+            *pprev = p->next;
+            free(p);
+            break;
+        }
+        pprev = &p->next;
+    }
+}
+
+/**
+ * Look up SNMP extension DLL context information.
+ *
+ * @param[in] index Varbind index in original PDU.
+ */
+static AsnOctetString *
+get_context_info(const int index)
+{
+    context_info   *p;
+
+    DEBUGMSG(("winExtDLL:context_info", "get_context_info(%d)\n", index));
+
+    for (p = context_info_head; p; p = p->next)
+        if (p->index == index)
+            return &p->context_info;
+
+    assert(FALSE);
+    return NULL;
+}
+
+static int
 var_winExtDLL(netsnmp_mib_handler *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info *reqinfo,
               netsnmp_request_info *requests)
 {
-
-    netsnmp_request_info *request = requests;
-    netsnmp_variable_list *var;
-    oid             oid_requested[MAX_OID_LEN];
-    size_t          oid_requested_length;
-    
-    static char     ret_szbuf_temp[SZBUF_MAX];          // Holder for return strings
-    static oid      ret_oid[MAX_OID_LEN];               // Holder for return OIDs
-    static size_t   ret_oid_length = 0;                 // Holder for return OIDs
-    static long     ret_long;                           // Holder for all other returns
-
-    static char     set_szbuf_temp[SZBUF_MAX];          // Holder for set strings    
-    static oid      set_oid[MAX_OID_LEN];               // Holder for set OIDs
-    static size_t   set_oid_length = 0;                 // Holder for set OIDs
-    oid             *temp_oid;
-    size_t          temp_oid_length;
-    
-    static int      temp;
-    static u_long   accesses = 7;
-    u_char          netsnmp_ASN_type;
-    u_char          windows_ASN_type;
-
-    char          *stringtemp;
-
-    // WinSNMP variables:
-    BOOL result;   
-    SnmpVarBind *mySnmpVarBind;
-    AsnInteger32 pErrorStatus;
-    AsnInteger32 pErrorIndex;
-    SnmpVarBindList pVarBindList;  
-    int i=0;
-    int j=0;
-
-    DWORD (WINAPI *xSnmpExtensionQuery)(BYTE, SnmpVarBindList* ,AsnInteger32* ,AsnInteger32*);
-    DWORD (WINAPI *xSnmpExtensionQueryEx)(DWORD, DWORD, SnmpVarBindList*, AsnOctetString*, AsnInteger32*, AsnInteger32*);
-    DWORD (WINAPI *next_xSnmpExtensionQuery)(BYTE, SnmpVarBindList* ,AsnInteger32* ,AsnInteger32*);
-    DWORD (WINAPI *next_xSnmpExtensionQueryEx)(DWORD, DWORD, SnmpVarBindList*, AsnOctetString*, AsnInteger32*, AsnInteger32*);
-    AsnObjectIdentifier winExtensionAgent_pSupportedView;               // Support view of this extension agent
-    oid winExtensionAgent_name[MAX_OID_LEN];                            // Support view of this extension agent
-    size_t winExtensionAgent_name_length;                               // Support view of this extension agent
-
-    int match_winExtensionAgent_index = -1;
-
-    DEBUGMSGTL(("winExtDLL", "-----------------------------------------\n"));
-    DEBUGMSGTL(("winExtDLL", "var_winExtDLL handler starting, mode = %d\n",
-                reqinfo->mode));
-    
+    winextdll_view *const ext_dll_view_info = handler->myvoid;
+    winextdll      *ext_dll_info;
+    netsnmp_request_info *request;
+    UINT            nRequestType;
+    const char     *mode_name;
+    int             rc;
+
+    assert(ext_dll_view_info);
+    ext_dll_info = ext_dll_view_info->winextdll_info;
+#if ! defined(NDEBUG)
+    assert(ext_dll_view_info ==
+           lookup_view_by_oid(reginfo->rootoid, reginfo->rootoid_len));
+#endif
+
+    if (ext_dll_info == 0) {
+        DEBUGMSG(("winExtDLL",
+                  "internal error: no matching extension DLL found.\n"));
+        assert(0);
+        return SNMP_ERR_GENERR;
+    }
+
     switch (reqinfo->mode) {
     case MODE_GET:
+        mode_name = "GET";
+        nRequestType = SNMP_EXTENSION_GET;
+        assert(!context_info_head);
+        break;
     case MODE_GETNEXT:
-
-      if (reqinfo->mode == MODE_GET)
-        DEBUGMSGTL(("winExtDLL", "GET requested\n"));
-      else if (reqinfo->mode == MODE_GETNEXT)
-        DEBUGMSGTL(("winExtDLL", "GETNEXT requested\n"));
-      
-      for (request = requests; request; request=request->next) {
-        
-        var = request->requestvb;
-
-        // Make copy of requested OID
-        for (i = 0; i < (var->name_length > MAX_OID_LEN? MAX_OID_LEN: var->name_length); i++) {
-          oid_requested[i] = var->name[i];
-        }
-        oid_requested_length = i;
-        
-        DEBUGMSGTL(("winExtDLL", "Requested: "));
-        DEBUGMSGOID(("winExtDLL", oid_requested, oid_requested_length));
-        DEBUGMSG(("winExtDLL", "\n"));       
-
-        DEBUGMSGTL(("winExtDLL", "Var type requested: %d\n",var->type));
-
-        /* Loop through all the winExtensionAgent's looking for a matching handler */
-        xSnmpExtensionQuery = NULL;
-        xSnmpExtensionQueryEx = NULL;
-        next_xSnmpExtensionQuery = NULL;
-        next_xSnmpExtensionQueryEx = NULL;
-
-        DEBUGMSGTL(("winExtDLL", "Looping through all the winExtensionAgent's looking for a matching handler (exact).\n"));
-        // Search starting with lowest so a walk of .1.3 starts with the lowest extension
-        for (i = winExtensionAgent_index; winExtensionAgent[i].xSnmpExtensionInit && i >= 0; i--) {          
-
-          /*DEBUGMSGTL(("winExtDLL", "Comparing: "));
-          DEBUGMSGOID(("winExtDLL", var->name, var->name_length));
-          DEBUGMSG(("winExtDLL", "\n"));       
-
-          DEBUGMSGTL(("winExtDLL", "to:        "));
-          DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-          DEBUGMSG(("winExtDLL", "\n"));*/
-
-          if (snmp_oidtree_compare(var->name, var->name_length, winExtensionAgent[i].name, 
-                winExtensionAgent[i].name_length) == 0) {
-
-            DEBUGMSGTL(("winExtDLL", "Found exact match: "));
-            DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-            DEBUGMSG(("winExtDLL", "\n"));
-            match_winExtensionAgent_index = i;
-            //DEBUGMSGTL(("winExtDLL", "Index: %d\n",match_winExtensionAgent_index));
-            break;
-          }
-        }
-
-        if (match_winExtensionAgent_index == -1) {
-          DEBUGMSGTL(("winExtDLL", "Looping through all the winExtensionAgent's looking for a matching handler (next best).\n"));
-          for (i=0; winExtensionAgent[i].xSnmpExtensionInit && i < MAX_WINEXT_DLLS; i++) {
-            
-            /*DEBUGMSGTL(("winExtDLL", "Comparing: "));
-            DEBUGMSGOID(("winExtDLL", var->name, var->name_length));
-            DEBUGMSG(("winExtDLL", "\n"));       
-            
-            DEBUGMSGTL(("winExtDLL", "to:        "));
-            DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-            DEBUGMSG(("winExtDLL", "\n"));       
-            DEBUGMSGTL(("winExtDLL", "and:       "));
-            DEBUGMSGOID(("winExtDLL", winExtensionAgent[i+1].name, winExtensionAgent[i+1].name_length));
-            DEBUGMSG(("winExtDLL", "\n"));       */
-
-            if (snmp_oidtree_compare(var->name, var->name_length, winExtensionAgent[i].name, 
-                  winExtensionAgent[i].name_length) <= 0 &&
-                snmp_oidtree_compare(var->name, var->name_length, winExtensionAgent[i+1].name, 
-                  winExtensionAgent[i+1].name_length) >= 0                      // FIXME:  Checking past the last extension?
-               ) {
-              DEBUGMSGTL(("winExtDLL", "Found best match: "));
-              DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-              DEBUGMSG(("winExtDLL", "\n"));
-              match_winExtensionAgent_index = i;
-              //DEBUGMSGTL(("winExtDLL", "Index: %d\n",match_winExtensionAgent_index));
-              break;
-            }
-          }
-        }
-
-        //DEBUGMSG(("winExtDLL", "Index: %d\n",match_winExtensionAgent_index));
-
-        if (match_winExtensionAgent_index == -1) {
-          DEBUGMSGTL(("winExtDLL","Could not find a handler for the requested OID.  This should never happen!!\n"));
-          return SNMP_ERR_GENERR;
-        }
-
-        // Make copy of current extension's OID
-        for (j = 0; j < (winExtensionAgent[i].name_length > MAX_OID_LEN? MAX_OID_LEN: winExtensionAgent[i].name_length); j++) {
-          winExtensionAgent_name[j] = winExtensionAgent[i].name[j];
-        }
-        winExtensionAgent_name_length = j;
-
-        xSnmpExtensionQuery = winExtensionAgent[i].xSnmpExtensionQuery;
-        xSnmpExtensionQueryEx = winExtensionAgent[i].xSnmpExtensionQueryEx;
-        SnmpUtilOidCpy(&winExtensionAgent_pSupportedView, &winExtensionAgent[i].pSupportedView);
-
-        if (! (xSnmpExtensionQuery || xSnmpExtensionQueryEx)) {
-          if (reqinfo->mode == MODE_GET) {
-            DEBUGMSGTL(("winExtDLL","Could not find a handler for the requested OID.  This should never happen!!\n"));
-            return SNMP_ERR_GENERR;
-          }
-          else {
-            DEBUGMSGTL(("winExtDLL","Could not find a handler for the requested OID.  Returning SNMP_ERR_NOSUCHNAME.\n"));
-            return SNMP_ERR_NOSUCHNAME;
-          }
-        }
-        
-        // Query
-        pVarBindList.list = (SnmpVarBind *) SnmpUtilMemAlloc(sizeof (SnmpVarBind));
-        if (pVarBindList.list) {
-
-          // Convert OID from Net-SNMP to Windows         
-         
-          pVarBindList.list->name.ids = (UINT *) SnmpUtilMemAlloc(sizeof (UINT) *var->name_length);
-          
-          if (pVarBindList.list->name.ids) {
-            // Actual copy
-            
-            for (i = 0; i < var->name_length; i++) {
-              pVarBindList.list->name.ids[i] = (UINT)var->name[i];
-            }
-            pVarBindList.list->name.idLength = i;
-            
-            DEBUGMSGTL(("winExtDLL", "Windows OID: "));
-            DEBUGMSGWINOID(("winExtDLL", pVarBindList.list));
-            DEBUGMSG(("winExtDLL", "\n"));
-            
-          }
-          else {
-            DEBUGMSGTL(("winExtDLL", "\nyCould not allocate memory for Windows SNMP varbind.\n"));
-            return (0);
-          }
-
-          //pVarBindList.list = pVarBindList.list;
-
-          pVarBindList.len = 1;          
-	}
-        else {
-          DEBUGMSGTL(("winExtDLL", "Could not allocate memory for Windows SNMP varbind list.\n"));
-          return (0);
-        }        
-		
-        if (reqinfo->mode == MODE_GET) {
-          DEBUGMSGTL(("winExtDLL", "win: MODE_GET\n"));
-          if (xSnmpExtensionQueryEx) {
-            DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQueryEx\n"));
-            result = xSnmpExtensionQueryEx(SNMP_PDU_GET, 1, &pVarBindList, NULL, &pErrorStatus, &pErrorIndex);
-          }
-          else { 
-            DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQuery\n"));
-            result = xSnmpExtensionQuery(SNMP_PDU_GET, &pVarBindList, &pErrorStatus, &pErrorIndex);
-          } 
-        }
-        else if (reqinfo->mode == MODE_GETNEXT) {
-          DEBUGMSGTL(("winExtDLL", "win: MODE_GETNEXT -\n"));
-          if (xSnmpExtensionQueryEx) {
-            DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQueryEx\n"));
-            result = xSnmpExtensionQueryEx(SNMP_PDU_GETNEXT, 1, &pVarBindList, NULL, &pErrorStatus, &pErrorIndex);
-          }
-          else { 
-            DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQuery\n"));
-            result = xSnmpExtensionQuery(SNMP_PDU_GETNEXT, &pVarBindList, &pErrorStatus, &pErrorIndex);
-          } 
-
-          DEBUGMSGTL(("winExtDLL", "Windows OID returned from xSnmpExtensionQuery(Ex): "));
-          DEBUGMSGWINOID(("winExtDLL", pVarBindList.list));
-          DEBUGMSG(("winExtDLL", "\n"));
-
-          // Convert OID from Windows to Net-SNMP so Net-SNMP has the new 'next' OID
-          // FIXME:  Do we need to realloc var->name or is is MAX_OID_LEN?
-          for (i = 0; i < (pVarBindList.list->name.idLength > MAX_OID_LEN?MAX_OID_LEN:pVarBindList.list->name.idLength); i++) {
-            var->name[i] = (oid)pVarBindList.list->name.ids[i];
-          }
-          var->name_length = i;
-
-          DEBUGMSGTL(("winExtDLL", "Comparing: "));
-          DEBUGMSGOID(("winExtDLL", var->name, var->name_length));
-          DEBUGMSG(("winExtDLL", "\n"));       
-
-          DEBUGMSGTL(("winExtDLL", "to:        "));
-          DEBUGMSGOID(("winExtDLL", winExtensionAgent_name, winExtensionAgent_name_length));
-          DEBUGMSG(("winExtDLL", "\n"));       
-          
-
-          // If the OID we got back is less than or equal to what we requested, increment the current supported view
-          // and send it back instead.
-          if (snmp_oid_compare(var->name, var->name_length, oid_requested, oid_requested_length) <= 0) {
-            DEBUGMSGTL(("winExtDLL", "xSnmpExtensionQuery(Ex) returned an OID less than or equal to what we requested\n"));
-            DEBUGMSGTL(("winExtDLL", " Setting return OID to be equal to current supported view, plus one\n"));
-
-            // Set var->name to be equal to current supported view, plus one
-            for (i = 0; i < (winExtensionAgent_name_length > MAX_OID_LEN? MAX_OID_LEN: winExtensionAgent_name_length); i++) {
-              var->name[i] = winExtensionAgent_name[i];
-            }
-            var->name_length = i;
-            var->name[i-1]++;
-
-            //return SNMP_ERR_NOSUCHNAME;
-            
-          }
-
-          // If the OID we got back is outside our view, increment the current supported view and send it back instead.
-          // This is for Windows extension agents that support multiple views.  We want Net-SNMP to decide if we should be
-          // called for this OID, not the extension agent, just in case there is a Net-SNMP agent in between.
-          else if (snmp_oidtree_compare(var->name, var->name_length, winExtensionAgent_name, winExtensionAgent_name_length) > 0) {
-            DEBUGMSGTL(("winExtDLL", "xSnmpExtensionQuery(Ex) returned an OID outside our view\n"));
-            DEBUGMSGTL(("winExtDLL", " Setting return OID to be equal to current supported view, plus one\n"));
-
-            // Set var->name to be equal to current supported view, plus one
-            for (i = 0; i < (winExtensionAgent_name_length > MAX_OID_LEN? MAX_OID_LEN: winExtensionAgent_name_length); i++) {
-              var->name[i] = winExtensionAgent_name[i];
-            }
-            var->name_length = i;
-            var->name[i-1]++;
-
-            //return SNMP_ERR_NOSUCHNAME;
-            
-          }
-       }       
-        DEBUGMSGTL(("winExtDLL", "OID being sent back to Net-SNMP: "));
-        DEBUGMSGOID(("winExtDLL", var->name, var->name_length));
-        DEBUGMSG(("winExtDLL", "\n"));
-
-        DEBUGMSGTL(("winExtDLL", "win: Result of xSnmpExtensionQuery(Ex): %d\n",result));
-        
-        DEBUGMSGTL(("winExtDLL", "win: Error status of xSnmpExtensionQuery(Ex): %d\n",pErrorStatus));
-
-        DEBUGMSGTL(("winExtDLL", "win: asnType: %d\n",pVarBindList.list->value.asnType));
-      
-        // Set Net-SNMP ASN type based on closest match to Windows ASN type
-        switch (pVarBindList.list->value.asnType) {
-          case MS_ASN_OCTETSTRING:
-            netsnmp_ASN_type = ASN_OCTET_STR;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OCTETSTRING = ASN_OCTET_STR\n"));
-            break;
-          case MS_ASN_INTEGER:          // And MS_ASN_INTEGER32
-            netsnmp_ASN_type = ASN_INTEGER;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_INTEGER = ASN_INTEGER\n"));
-            break;
-          case MS_ASN_UNSIGNED32:       // SNMP v2
-            netsnmp_ASN_type = ASN_UNSIGNED;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_UNSIGNED32 = ASN_UNSIGNED\n"));
-            break;
-          case MS_ASN_COUNTER64:       // SNMP v2
-            netsnmp_ASN_type = ASN_COUNTER64;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER64 = ASN_COUNTER64\n"));
-            break;
-          case MS_ASN_BITS:
-            netsnmp_ASN_type = ASN_BIT_STR;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_BITS = ASN_BIT_STR\n"));
-            break;
-          case MS_ASN_OBJECTIDENTIFIER:
-            netsnmp_ASN_type = ASN_OBJECT_ID;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OBJECTIDENTIFIER = ASN_OBJECT_ID\n"));
-            break;
-          case MS_ASN_SEQUENCE:
-            netsnmp_ASN_type = ASN_SEQUENCE;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_SEQUENCE = ASN_SEQUENCE\n"));
-            break;
-          case MS_ASN_IPADDRESS:
-            netsnmp_ASN_type = ASN_IPADDRESS;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_IPADDRESS = ASN_IPADDRESS\n"));
-            break;
-          case MS_ASN_COUNTER32:
-            netsnmp_ASN_type = ASN_COUNTER;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER32 = ASN_COUNTER\n"));
-            break;
-          case MS_ASN_GAUGE32:
-            netsnmp_ASN_type = ASN_GAUGE;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_GAUGE32 = ASN_GAUGE\n"));
-            break;
-          case MS_ASN_TIMETICKS:
-            netsnmp_ASN_type = ASN_TIMETICKS;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_TIMETICKS = ASN_TIMETICKS\n"));
-            break;
-          case MS_ASN_OPAQUE:
-            netsnmp_ASN_type = ASN_OPAQUE;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OPAQUE = ASN_OPAQUE\n"));
-            break;
-          default:
-            netsnmp_ASN_type = ASN_INTEGER;
-            DEBUGMSGTL(("winExtDLL", "unknown MS ASN type.  Defaulting to ASN_INTEGER\n"));
-            break;
-        }
-
-        DEBUGMSGTL(("winExtDLL", "Net-SNMP object type for returned value: %d\n",netsnmp_ASN_type));
-
-        switch (pVarBindList.list->value.asnType) {
-          case MS_ASN_IPADDRESS:
-          case MS_ASN_OCTETSTRING:           
-            
-            strncpy(ret_szbuf_temp, pVarBindList.list->value.asnValue.string.stream, (pVarBindList.list->value.asnValue.string.length > 
-                  SZBUF_MAX?SZBUF_MAX:pVarBindList.list->value.asnValue.string.length));
-           
-            if (pVarBindList.list->value.asnValue.string.length < SZBUF_MAX) 
-              ret_szbuf_temp[pVarBindList.list->value.asnValue.string.length] = '\0';
-            else
-              ret_szbuf_temp[SZBUF_MAX-1] = '\0';
-
-            // Printing strings that have a comma in them via DEBUGMSGTL doesn't work..
-            DEBUGMSGTL(("winExtDLL", "Note:  Sometimes junk is outputted here even though the string is fine.  Problem with DEBUGMSGTL?\n",ret_szbuf_temp));
-            DEBUGMSGTL(("winExtDLL", "win: String: %s\n",ret_szbuf_temp));
-            DEBUGMSGTL(("winExtDLL", "win: length of string response: %d\n",strlen(ret_szbuf_temp)));
-            
-            snmp_set_var_typed_value(var, netsnmp_ASN_type,
-                ret_szbuf_temp,
-                strlen(ret_szbuf_temp));
-            //return SNMP_ERR_NOERROR;           
-            break;
-
-          case MS_ASN_INTEGER:          // And MS_ASN_INTEGER32
-          case MS_ASN_UNSIGNED32:
-          case MS_ASN_COUNTER64:
-          case MS_ASN_BITS:
-          case MS_ASN_SEQUENCE:
-          case MS_ASN_COUNTER32:
-          case MS_ASN_GAUGE32:
-          case MS_ASN_TIMETICKS:
-          case MS_ASN_OPAQUE:
-
-            DEBUGMSGTL(("winExtDLL", "win: Long: %ld\n",pVarBindList.list->value.asnValue.number));
-
-            ret_long = pVarBindList.list->value.asnValue.number;
-
-            // Return results
-            snmp_set_var_typed_value(var, netsnmp_ASN_type,
-                &ret_long,
-                sizeof(ret_long));
-            //return SNMP_ERR_NOERROR;           
-            break;
-
-          case MS_ASN_OBJECTIDENTIFIER:
-            // Convert OID to Net-SNMP
-
-            DEBUGMSGTL(("winExtDLL", "Returned OID: "));
-            DEBUGMSGWINOID(("winExtDLL", &pVarBindList.list->value.asnValue.object));
-            DEBUGMSG(("winExtDLL", "\n"));
-           
-            // Convert OID from Windows to Net-SNMP
-            for (i = 0; i < (pVarBindList.list->value.asnValue.object.idLength > MAX_OID_LEN?MAX_OID_LEN:
-                  pVarBindList.list->value.asnValue.object.idLength); i++) {
-              ret_oid[i] = (oid)pVarBindList.list->value.asnValue.object.ids[i];
-            }
-            ret_oid_length = i;
-           
-            DEBUGMSGTL(("winExtDLL", "Windows OID converted to Net-SNMP: "));
-            DEBUGMSGOID(("winExtDLL", ret_oid, ret_oid_length));
-            DEBUGMSG(("winExtDLL", "\n"));
-                      
-            snmp_set_var_typed_value(var, netsnmp_ASN_type,
-                ret_oid,
-                ret_oid_length  * sizeof(oid));
-            //return SNMP_ERR_NOERROR;           
-            
-            break;
-            
-          default:
-            // The Windows agent didn't return data so set values to NULL
-            // FIXME:  We never get here.  We set it to INTEGER above..
-            snmp_set_var_typed_value(var, NULL,
-                NULL,
-                NULL);
-            break;
-        }
-        if (&pVarBindList)
-          SnmpUtilVarBindListFree(&pVarBindList);
-      }  
-      break;
-
-    case MODE_SET_RESERVE1:     
+        mode_name = "GETNEXT";
+        nRequestType = SNMP_EXTENSION_GET_NEXT;
+        assert(!context_info_head);
+        break;
+    case MODE_SET_RESERVE1:
+        mode_name = "SET_RESERVE1";
+        nRequestType = SNMP_EXTENSION_SET_TEST;
+        break;
     case MODE_SET_RESERVE2:
+        mode_name = "SET_RESERVE2";
+        return SNMP_ERR_NOERROR;
     case MODE_SET_ACTION:
-
-      DEBUGMSGTL(("winExtDLL", "SET requested\n"));
-      
-      for (request = requests; request; request=request->next) {
-
-        var = request->requestvb;
-        
-        DEBUGMSGTL(("winExtDLL", "requested: "));
-        DEBUGMSGOID(("winExtDLL", var->name, var->name_length));
-        DEBUGMSG(("winExtDLL", "\n"));       
-
-        DEBUGMSGTL(("winExtDLL", "Var type requested: %d\n",var->type));
-
-        /* Loop through all the winExtensionAgent's looking for a matching handler */
-        xSnmpExtensionQuery = NULL;
-        xSnmpExtensionQueryEx = NULL;
-        for (i=0; winExtensionAgent[i].xSnmpExtensionInit && i < MAX_WINEXT_DLLS; i++) {
-          DEBUGMSGTL(("winExtDLL", "Looping through all the winExtensionAgent's looking for a matching handler.\n"));
-          
-          if (snmp_oidtree_compare(var->name, var->name_length, winExtensionAgent[i].name, 
-                winExtensionAgent[i].name_length) >= 0) {
-            DEBUGMSGTL(("winExtDLL", "Found match: "));
-            DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-            DEBUGMSG(("winExtDLL", "\n"));
-            xSnmpExtensionQuery = winExtensionAgent[i].xSnmpExtensionQuery;
-            xSnmpExtensionQueryEx = winExtensionAgent[i].xSnmpExtensionQueryEx;
-            break;
-          }
-        }
-
-        if (! (xSnmpExtensionQuery || xSnmpExtensionQueryEx)) {
-          DEBUGMSGTL(("winExtDLL","Could not find a handler for the requested OID.  This should never happen!!\n"));
-          return SNMP_ERR_GENERR;
-        }
-
-        // Set Windows ASN type based on closest match to Net-SNMP ASN type
-        switch (var->type) {
-          case ASN_OCTET_STR:
-            windows_ASN_type = MS_ASN_OCTETSTRING;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OCTETSTRING = ASN_OCTET_STR\n"));
-            break;
-          case ASN_INTEGER:          // And MS_ASN_INTEGER32
-            windows_ASN_type = MS_ASN_INTEGER;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_INTEGER = ASN_INTEGER\n"));
-            break;
-          case ASN_UNSIGNED:
-            windows_ASN_type = MS_ASN_UNSIGNED32;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_UNSIGNED32 = ASN_UNSIGNED\n"));
-            break;
-          case ASN_COUNTER64:
-            windows_ASN_type = MS_ASN_COUNTER64;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER64 = ASN_COUNTER64\n"));
-            break;
-          case ASN_BIT_STR:
-            windows_ASN_type = MS_ASN_BITS;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_BITS = ASN_BIT_STR\n"));
-            break;
-          case ASN_OBJECT_ID:
-            windows_ASN_type = MS_ASN_OBJECTIDENTIFIER;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OBJECTIDENTIFIER = ASN_OBJECT_ID\n"));
-            break;
-          case ASN_SEQUENCE:
-            windows_ASN_type = MS_ASN_SEQUENCE;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_SEQUENCE = ASN_SEQUENCE\n"));
-            break;
-          case ASN_IPADDRESS:
-            windows_ASN_type = MS_ASN_IPADDRESS;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_IPADDRESS = ASN_IPADDRESS\n"));
-            break;
-          case ASN_COUNTER:
-            windows_ASN_type = MS_ASN_COUNTER32;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER32 = ASN_COUNTER\n"));
-            break;
-//          case ASN_GAUGE:                     // Same as UNSIGNED
-//            windows_ASN_type = MS_ASN_GAUGE32;
-//            DEBUGMSGTL(("winExtDLL", "MS_ASN_GAUGE32 = ASN_GAUGE\n"));
-//          break;
-          case ASN_TIMETICKS:
-            windows_ASN_type = MS_ASN_TIMETICKS;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_TIMETICKS = ASN_TIMETICKS\n"));
-            break;
-          case ASN_OPAQUE:
-            windows_ASN_type = MS_ASN_OPAQUE;
-            DEBUGMSGTL(("winExtDLL", "MS_ASN_OPAQUE = ASN_OPAQUE\n"));
-            break;
-          default:
-            windows_ASN_type = MS_ASN_INTEGER;
-            DEBUGMSGTL(("winExtDLL", "unknown MS ASN type.  Defaulting to ASN_INTEGER\n"));
-            break;
-        }
-
-        DEBUGMSGTL(("winExtDLL", "Net-SNMP object type for returned value: %d\n",windows_ASN_type));
-
-        // Query
-        pVarBindList.list = (SnmpVarBind *) SnmpUtilMemAlloc(sizeof (SnmpVarBind));
-        if (pVarBindList.list) {
-          // Convert OID from Net-SNMP to Windows         
-          pVarBindList.list->name.ids = (UINT *) SnmpUtilMemAlloc(sizeof (UINT) *var->name_length);
-
-          if (pVarBindList.list->name.ids) {
-            // Actual copy
-            for (i = 0; i < var->name_length; i++) {
-              pVarBindList.list->name.ids[i] = (UINT)var->name[i];
-            }
-            pVarBindList.list->name.idLength = i;
-
-            // Print OID
-            DEBUGMSGTL(("winExtDLL","Windows OID length: %d\n",pVarBindList.list->name.idLength));
-            DEBUGMSGTL(("winExtDLL","Windows OID: "));
-            DEBUGMSGWINOID(("winExtDLL", pVarBindList.list));
-            DEBUGMSG(("winExtDLL", "\n"));
-          }
-          else {
-            DEBUGMSGTL(("winExtDLL", "\nyCould not allocate memory for Windows SNMP varbind.\n"));
-            return (0);
-          }
-          //pVarBindList.list = pVarBindList.list;
-          pVarBindList.len = 1;          
-	}
-        else {
-          DEBUGMSGTL(("winExtDLL", "\nyCould not allocate memory for Windows SNMP varbind list.\n"));
-          return (0);
-        }
-		        
-        // Set Windows ASN type
-        pVarBindList.list->value.asnType = windows_ASN_type;
-          
-        switch (var->type) {
-          case ASN_IPADDRESS:
-          case ASN_OCTET_STR:            
-
-            strncpy(set_szbuf_temp, var->val.string, (var->val_len > SZBUF_MAX?SZBUF_MAX:var->val_len));
-
-            // Make sure string is terminated
-            set_szbuf_temp[var->val_len > SZBUF_MAX?SZBUF_MAX:var->val_len] = '\0';
-
-            DEBUGMSGTL(("winExtDLL", "String to write: %s\n",set_szbuf_temp));
-            DEBUGMSGTL(("winExtDLL", "Length of string to write: %d\n",strlen(set_szbuf_temp)));
-
-            pVarBindList.list->value.asnValue.string.stream = set_szbuf_temp;
-            pVarBindList.list->value.asnValue.string.length = strlen(set_szbuf_temp);
-            pVarBindList.list->value.asnValue.string.dynamic = 0;
-            
-            break;
-
-          case ASN_INTEGER:          // And MS_ASN_INTEGER32
-          case ASN_UNSIGNED:
-          case ASN_COUNTER64:
-          case ASN_BIT_STR:
-          case ASN_SEQUENCE:
-          case ASN_COUNTER:
-          case ASN_TIMETICKS:
-          case ASN_OPAQUE:        
-            
-            pVarBindList.list->value.asnValue.number = *(var->val.integer);
-            break;
-              
-          case ASN_OBJECT_ID:
-            
-            // Convert OID from Net-SNMP to Windows
-            temp_oid = var->val.objid;
-            temp_oid_length = var->val_len / sizeof(oid);           
-            
-            DEBUGMSGTL(("winExtDLL","Sizeof var->val.objid: %d\n", temp_oid_length));
-
-            DEBUGMSGTL(("winExtDLL","OID: from user "));
-            DEBUGMSGOID(("winExtDLL", temp_oid, temp_oid_length));
-            DEBUGMSG(("winExtDLL","\n"));
-            
-            mySnmpVarBind->name.ids = (UINT *) SnmpUtilMemAlloc(sizeof (UINT) * temp_oid_length);
-
-            if (mySnmpVarBind->name.ids) {
-              // Actual copy
-              for (i = 0; i < temp_oid_length; i++) {
-                mySnmpVarBind->name.ids[i] = (UINT)temp_oid[i];
-              }
-              mySnmpVarBind->name.idLength = i;
-              
-              // Print OID
-              DEBUGMSGTL(("winExtDLL","Windows OID length: %d\n",mySnmpVarBind->name.idLength));
-              DEBUGMSGTL(("winExtDLL","Windows OID: "));
-              DEBUGMSGWINOID(("winExtDLL", mySnmpVarBind));
-              DEBUGMSG(("winExtDLL", "\n"));
-            }
-            else {
-              DEBUGMSGTL(("winExtDLL", "\nyCould not allocate memory for Windows SNMP varbind.\n"));
-              return SNMP_ERR_GENERR;
-            }
-            SnmpUtilOidCpy(&pVarBindList.list->value.asnValue.object, &mySnmpVarBind->name);
-            //pVarBindList.list->value.asnValue.object = mySnmpVarBind->name;
-            if (mySnmpVarBind)
-              SnmpUtilVarBindFree(mySnmpVarBind);
-            
-          default:
-            break;      
-        }  
-
-        if (xSnmpExtensionQueryEx) {
-          DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQueryEx\n"));
-          result = xSnmpExtensionQueryEx(SNMP_PDU_SET, 1, &pVarBindList, NULL, &pErrorStatus, &pErrorIndex);
-        }
-        else { 
-          DEBUGMSGTL(("winExtDLL", "Calling xSnmpExtensionQuery\n"));
-          result = xSnmpExtensionQuery(SNMP_PDU_SET, &pVarBindList, &pErrorStatus, &pErrorIndex);
-        }
-
-        DEBUGMSGTL(("winExtDLL", "win: Result of xSnmpExtensionQuery: %d\n",result));        
-        DEBUGMSGTL(("winExtDLL", "win: Error status of xSnmpExtensionQuery: %d\n",pErrorStatus));
-        DEBUGMSGTL(("winExtDLL", "win: asnType: %d\n",pVarBindList.list->value.asnType));
-
-        if (result == 0) {
-          DEBUGMSGTL(("winExtDLL", "\nyxWindows SnmpExtensionQuery failure.\n"));
-          return SNMP_ERR_GENERR;
-        }
-        
-        if (&pVarBindList)
-          SnmpUtilVarBindListFree(&pVarBindList);
-
-        if (pErrorStatus) {
-          switch (pErrorStatus) {
-            case SNMP_ERRORSTATUS_INCONSISTENTNAME:
-              return SNMP_ERR_GENERR;
-            default:
-              return pErrorStatus;
-              break;
-          }
-        }
-      }
-      break;     
-
+        mode_name = "SET_ACTION";
+        return SNMP_ERR_NOERROR;
     case MODE_SET_UNDO:
+        mode_name = "SET_UNDO";
+        nRequestType = SNMP_EXTENSION_SET_UNDO;
+        break;
     case MODE_SET_COMMIT:
+        mode_name = "SET_COMMIT";
+        nRequestType = SNMP_EXTENSION_SET_COMMIT;
+        break;
     case MODE_SET_FREE:
-
-      break;
-      
+        mode_name = "SET_FREE";
+        nRequestType = SNMP_EXTENSION_SET_CLEANUP;
+        break;
     default:
-        snmp_log(LOG_WARNING, "unsupported mode for winExtDLL called (%d)\n",
-                               reqinfo->mode);
+        DEBUGMSG(("winExtDLL",
+                  "internal error: invalid mode %d.\n", reqinfo->mode));
+        assert(0);
         return SNMP_ERR_NOERROR;
     }
 
-    return SNMP_ERR_NOERROR;
-}
-
-void winExtDLL_free_config_winExtDLL(void) {
-}
-
-void read_ExtensionAgents_list() {
-  HKEY          hKey; 
-  unsigned char * key_value = NULL;
-  DWORD         key_value_size = 0;
-  DWORD         key_value_type = 0;
-  DWORD         valueSize = MAX_VALUE_NAME; 
-  int           i;
-  TCHAR         valueName[MAX_VALUE_NAME];
-  TCHAR         valueName2[MAX_VALUE_NAME];
-  DWORD         retCode;
-  
-  DEBUGMSGTL(("winExtDLL", "read_ExtensionAgents_list called\n"));
-
-  /* The Windows SNMP service stores the list of extension agents to be loaded in the
-   * registry under HKLM\SYSTEM\CurrentControlSet\Services\SNMP\Parameters\ExtensionAgents.
-   * This list contains a list of other keys that contain the actual file path to the DLL.
-   */
-
-  /* Open SYSTEM\\CurrentControlSet\\Services\\SNMP\\Parameters\\ExtensionAgent */
-  retCode = RegOpenKeyExA(
-      HKEY_LOCAL_MACHINE, 
-      "SYSTEM\\CurrentControlSet\\Services\\SNMP\\Parameters\\ExtensionAgents", 
-      0, 
-      KEY_QUERY_VALUE, 
-      &hKey);
-  
-  if (retCode == ERROR_SUCCESS) {
-    /* Enumerate list of extension agents.  This is a list of other keys that contain the
-     * actual filename of the extension agent.  */
-    for (i=0; retCode==ERROR_SUCCESS; i++) 
-    { 
-      valueSize = MAX_VALUE_NAME; 
-      valueName[0] = '\0'; 
-      retCode = RegEnumValue(
-          hKey,
-          i,
-          valueName, 
-          &valueSize, 
-          NULL, 
-          NULL,
-          NULL,
-          NULL);
-      
-      if (retCode == ERROR_SUCCESS ) 
-      { 
-        /* Get key name that contains the actual filename of the extension agent */
-        DEBUGMSGTL(("winExtDLL", "-----------------------------------------\n"));
-        DEBUGMSGTL(("winExtDLL", "Registry: (%d) %s\n", i+1, valueName));
-        
-        key_value_size = MAX_VALUE_NAME;
-        if (RegQueryValueExA(
-              hKey, 
-              valueName, 
-              NULL, 
-              &key_value_type, 
-              valueName2, 
-              &key_value_size) == ERROR_SUCCESS) {
-        }
-        DEBUGMSGTL(("winExtDLL", "key_value: %s\n",valueName2));
-        read_ExtensionAgents_list2(valueName2);
-        extDLLs_index++;
-      }
+    rc = SNMP_ERR_NOERROR;
+
+    for (request = requests; request; request = request->next) {
+        netsnmp_variable_list *varbind;
+        SnmpVarBindList win_varbinds;
+        AsnInteger32    ErrorStatus;
+        AsnInteger32    ErrorIndex;
+        BOOL            result;
+        BOOL            copy_value;
+
+        memset(&win_varbinds, 0, sizeof(win_varbinds));
+
+        if (request->processed || rc != SNMP_ERR_NOERROR)
+            goto free_win_varbinds;
+
+        if (reqinfo->mode == MODE_SET_RESERVE1)
+            alloc_context_info(request->index);
+
+        varbind = request->requestvb;
+        assert(varbind);
+
+        /*
+         * Convert the Net-SNMP varbind to a Windows SNMP varbind list.
+         */
+        rc = convert_to_windows_varbind_list(&win_varbinds, varbind);
+        if (rc != SNMP_ERR_NOERROR) {
+            DEBUGMSG(("winExtDLL",
+                      "converting varbind list to Windows format failed with"
+                      " error code %d.\n", request->status));
+            netsnmp_request_set_error(requests, rc);
+            goto free_win_varbinds;
+        }
+
+        assert(win_varbinds.len == 1);
+
+        /*
+         * For a GetNext PDU, if the varbind OID comes lexicographically
+         * before the root OID of this handler, replace it by the root OID.
+         */
+        if (reqinfo->mode == MODE_GETNEXT
+            && snmp_oid_compare(win_varbinds.list[0].name.ids,
+                                win_varbinds.list[0].name.idLength,
+                                reginfo->rootoid,
+                                reginfo->rootoid_len) < 0) {
+            AsnObjectIdentifier Root =
+                { reginfo->rootoid_len, reginfo->rootoid };
+            SnmpUtilOidCpy(&win_varbinds.list[0].name, &Root);
+        }
+
+        if (ext_dll_info->pfSnmpExtensionQueryEx) {
+            result = ext_dll_info->pfSnmpExtensionQueryEx(nRequestType,
+                                                          1,
+                                                          &win_varbinds,
+                                                          get_context_info(request->index),
+                                                          &ErrorStatus,
+                                                          &ErrorIndex);
+        } else if (ext_dll_info->pfSnmpExtensionQuery) {
+            result =
+                ext_dll_info->pfSnmpExtensionQuery((BYTE) nRequestType,
+                                                   &win_varbinds,
+                                                   &ErrorStatus,
+                                                   &ErrorIndex);
+        } else {
+            snmp_log(LOG_ERR,
+                     "error in extension DLL %s: SNMP query function missing.\n",
+                     ext_dll_info->dll_name);
+            result = FALSE;
+        }
+
+        if (!result) {
+            snmp_log(LOG_ERR,
+                     "extension DLL %s: SNMP query function failed.\n",
+                     ext_dll_info->dll_name);
+            rc = SNMP_ERR_GENERR;
+            goto free_win_varbinds;
+        }
+
+        rc = convert_win_snmp_err(ErrorStatus);
+        if (rc != SNMP_ERR_NOERROR) {
+            DEBUGMSG(("winExtDLL",
+                      "extension DLL %s: SNMP query function returned error code %lu (Windows) / %d (Net-SNMP).\n",
+                      ext_dll_info->dll_name, ErrorStatus, rc));
+            assert(ErrorIndex == 1);
+            netsnmp_request_set_error(requests, rc);
+            if (rc == SNMP_NOSUCHOBJECT || rc == SNMP_NOSUCHINSTANCE
+                || rc == SNMP_ERR_NOSUCHNAME)
+                rc = SNMP_ERR_NOERROR;
+            goto free_win_varbinds;
+        }
+
+        copy_value = FALSE;
+        if (reqinfo->mode == MODE_GET)
+            copy_value = TRUE;
+        else if (reqinfo->mode == MODE_GETNEXT) {
+            const SnmpVarBind *win_varbind;
+
+            win_varbind = &win_varbinds.list[0];
+
+            /*
+             * Verify whether the OID returned by the extension DLL fits
+             * inside the OID range this handler has been registered
+             * with. Also compare the OID passed to the extension DLL with
+             * the OID returned by the same DLL. If the DLL returned a
+             * lexicographically earlier OID, this means that there is no
+             * next OID in the MIB implemented by the DLL.
+             *
+             * Note: for some GetNext requests BoundsChecker will report
+             * that the code below accesses a dangling pointer. This is
+             * a limitation of BoundsChecker: apparently BoundsChecker is
+             * not able to cope with reallocation of memory for
+             * win_varbind by an SNMP extension DLL that has not been
+             * instrumented by BoundsChecker.
+             */
+            if (netsnmp_oid_is_subtree(ext_dll_view_info->name,
+                                       ext_dll_view_info->name_length,
+                                       win_varbind->name.ids,
+                                       win_varbind->name.idLength) == 0
+                && snmp_oid_compare(varbind->name, varbind->name_length,
+                                    win_varbind->name.ids,
+                                    win_varbind->name.idLength) < 0) {
+                /*
+                 * Copy the OID returned by the extension DLL to the
+                 * Net-SNMP varbind.
+                 */
+                snmp_set_var_objid(varbind,
+                                   win_varbind->name.ids,
+                                   win_varbind->name.idLength);
+                copy_value = TRUE;
+            }
+        }
+        if (copy_value) {
+            netsnmp_variable_list *result_vb;
+
+            /*
+             * Copy the value returned by the extension DLL to the Net-SNMP
+             * varbind.
+             */
+            result_vb = NULL;
+            rc = append_windows_varbind(&result_vb, &win_varbinds.list[0]);
+            assert(result_vb || rc != SNMP_ERR_NOERROR);
+            if (result_vb) {
+                snmp_set_var_typed_value(varbind,
+                                         result_vb->type,
+                                         result_vb->val.string,
+                                         result_vb->val_len);
+                snmp_free_varbind(result_vb);
+            } else {
+                netsnmp_request_set_error(requests, rc);
+                goto free_win_varbinds;
+            }
+        }
+
+free_win_varbinds:
+        if (reqinfo->mode == MODE_SET_COMMIT
+            || reqinfo->mode == MODE_SET_UNDO
+            || reqinfo->mode == MODE_SET_FREE)
+            free_context_info(request->index);
+        if (win_varbinds.list)
+            SnmpUtilVarBindListFree(&win_varbinds);
     }
-    if (extDLLs_index)
-      extDLLs_index--;
-  }
-}
-
-void read_ExtensionAgents_list2(const TCHAR *keyName) {
-  HKEY          hKey; 
-  unsigned char * key_value = NULL;
-  DWORD         key_value_size = 0;
-  DWORD         key_value_type = 0;
-  DWORD         valueSize = MAX_VALUE_NAME; 
-  TCHAR         valueName[MAX_VALUE_NAME];
-  TCHAR         valueNameExpanded[MAX_VALUE_NAME];
-  int           i;
-  DWORD         retCode;
-  
-  DEBUGMSGTL(("winExtDLL", "read_ExtensionAgents_list2 called\n"));
-  DEBUGMSGTL(("winExtDLL", "Registry: Opening key %s\n", keyName));
-
-  /* Open extension agent's key */
-  retCode = RegOpenKeyExA(
-      HKEY_LOCAL_MACHINE, 
-      keyName, 
-      0, 
-      KEY_QUERY_VALUE, 
-      &hKey);
-  
-  if (retCode == ERROR_SUCCESS) {
-    /* Read Pathname value */
-
-    DEBUGMSGTL(("winExtDLL", "Registry: Reading value for %s\n", keyName));
-       
-    key_value_size = MAX_VALUE_NAME;
-    retCode = RegQueryValueExA(
-        hKey, 
-        "Pathname", 
-        NULL, 
-        &key_value_type, 
-        valueName, 
-        &key_value_size);
-    
+
+    return rc;
+}
+
+/**
+ * Iterate over the SNMP extension DLL information in the registry and store
+ * the retrieved information in s_winextdll[].
+ *
+ * At the time an SNMP extension DLL is installed, some information about the
+ * DLL is written to the registry at one of the two following locations:
+ * HKLM\SYSTEM\CurrentControlSet\Control\SNMP\Parameters\ExtensionAgents for
+ * Windows Vista, Windows 7 and Windows 2008 or
+ * HKLM\SYSTEM\CurrentControlSet\Services\SNMP\Parameters\ExtensionAgents for
+ * earlier Windows versions. Under this key zero or more REG_SZ values are
+ * stored with the names of registry keys containing the DLL path.
+ */
+void
+read_extension_dlls_from_registry()
+{
+    DEBUGMSGTL(("winExtDLL",
+                "read_extension_dlls_from_registry called\n"));
+
+    read_extension_dlls_from_registry_at
+        ("SYSTEM\\CurrentControlSet\\Services\\SNMP\\Parameters\\ExtensionAgents");
+    read_extension_dlls_from_registry_at
+        ("SYSTEM\\CurrentControlSet\\Control\\SNMP\\Parameters\\ExtensionAgents");
+}
+
+void
+read_extension_dlls_from_registry_at(const char *const subkey)
+{
+    DWORD           retCode;
+    HKEY            hKey;
+    int             i;
+    DWORD           valueSize;
+    TCHAR           valueName[MAX_VALUE_NAME];
+    DWORD           dataType;
+    TCHAR           data[MAX_VALUE_NAME];
+    DWORD           dataSize;
+
+    retCode = RegOpenKeyExA(HKEY_LOCAL_MACHINE, subkey,
+                            0, KEY_QUERY_VALUE, &hKey);
+
     if (retCode == ERROR_SUCCESS) {
-      valueName[key_value_size-1] = NULL;               /* Make sure last element is a NULL */        
-      DEBUGMSGTL(("winExtDLL", "Extension agent Pathname size: %d\n",key_value_size));
-      DEBUGMSGTL(("winExtDLL", "Extension agent Pathname: %s\n",valueName));
-
-      if (ExpandEnvironmentStrings(valueName, valueNameExpanded, MAX_VALUE_NAME)) {
-        DEBUGMSGTL(("winExtDLL", "Extension agent Pathname expanded: %s\n",valueNameExpanded));
-        if (extDLLs_index < MAX_WINEXT_DLLS) {
-
-          extDLLs[extDLLs_index] = strdup(valueNameExpanded);
-          
-          if (extDLLs[extDLLs_index]) {
-            strcpy(extDLLs[extDLLs_index], valueNameExpanded );
-            DEBUGMSGTL(("winExtDLL", "Extension agent Pathname expanded extDLLs: %s\n",extDLLs[extDLLs_index]));
-            DEBUGMSGTL(("winExtDLL", "Extension agent Pathname size: %d\n",strlen(extDLLs[extDLLs_index])));
-          }
-          else {
-            DEBUGMSGTL(("winExtDLL", "Could not allocate memory for extDLLs[%d]\n",extDLLs_index));
-          }
-        }
-      }
-      else {
-        DEBUGMSGTL(("winExtDLL", "ExpandEnvironmentStrings failed\n"));
-      }      
-    }
-  }
-}
-
-// Called by alarm to check for traps waiting to be processed.
-void subagentTrapCheck() {
-  DWORD dwWaitResult;
-  BOOL bResult;
-  int i;
-  netsnmp_variable_list *notification_vars = NULL;
-
-  // Windows SNMP
-  AsnObjectIdentifier   pEnterprise;
-  AsnInteger            pGenericTrap;
-  AsnInteger            pSpecificTrap;
-  AsnTimeticks          pTimeStamp;
-  SnmpVarBindList       pVariableBindings;
- 
-  DEBUGMSGTL(("winExtDLL", "subagentTrapMonitor called\n"));
-
-  dwWaitResult = WaitForMultipleObjects(
-      subagentTrapEvents_index,
-      subagentTrapEvents,
-      FALSE,
-      0);
-
-  if (! (dwWaitResult) || (dwWaitResult == WAIT_TIMEOUT))
-    return;
-  
-  DEBUGMSGTL(("winExtDLL", "---------------------------------------------\n"));
-  DEBUGMSGTL(("winExtDLL", "subagentTrapCheck found a trap event (index: %d)\n",dwWaitResult));
-  
-  /* Loop through all the winExtensionAgent's looking for a matching handler */
-  for (i=0;  winExtensionAgent[i].xSnmpExtensionInit && i < MAX_WINEXT_DLLS; i++) {
-    DEBUGMSGTL(("winExtDLL", "Looping through all the winExtensionAgent's looking for a matching trap handler.\n"));
-
-    if (winExtensionAgent[i].subagentTrapEvent == subagentTrapEvents[dwWaitResult]) {
-      DEBUGMSGTL(("winExtDLL", "Found match: "));
-      DEBUGMSGOID(("winExtDLL", winExtensionAgent[i].name, winExtensionAgent[i].name_length));
-      DEBUGMSG(("winExtDLL", "\n"));
-
-      if (winExtensionAgent[i].xSnmpExtensionTrap)
-        DEBUGMSGTL(("winExtDLL", "xSnmpExtensionTrap exists for this subagent\n"));
-      else {
-        DEBUGMSGTL(("winExtDLL", "xSnmpExtensionTrap does NOT exist for this subagent\n"));
-        continue;
-      }
-
-      pEnterprise.ids = NULL;
-      pEnterprise.idLength = 0;
-      pGenericTrap = pSpecificTrap = NULL;
-      pTimeStamp = 0;
-      pVariableBindings.list = NULL;
-      pVariableBindings.len = 0;
-
-      DEBUGMSGTL(("winExtDLL", "Calling SnmpExtensionTrap\n"));
-      bResult = winExtensionAgent[i].xSnmpExtensionTrap(
-          &pEnterprise,
-          &pGenericTrap,
-          &pSpecificTrap,
-          &pTimeStamp,
-          &pVariableBindings);
-      
-      DEBUGMSGTL(("winExtDLL", "result of SnmpExtensionTrap call:  %d\n",bResult));
-
-      
-      DEBUGMSGTL(("winExtDLL", "GenericTrap: %d\n",pGenericTrap));
-      DEBUGMSGTL(("winExtDLL", "SpecificTrap: %d\n",pSpecificTrap));
-
-      if (pEnterprise.idLength)
-        DEBUGMSGTL(("winExtDLL", "pEnterprise is not 0\n"));
-      else
-        DEBUGMSGTL(("winExtDLL", "pEnterprise is 0\n"));
-
-      // Assume that if enterprise length is >0, it's a real trap and not a cleanup call
-      // FIXME:  Not sure if this is correct.  Need to test with agent that sends a non-enterprise trap
-      if (pEnterprise.idLength) {
-        
-        // Send the trap
-        send_trap(
-            &pEnterprise, 
-            &pGenericTrap, 
-            &pSpecificTrap, 
-            &pTimeStamp,
-            &pVariableBindings);
-      }
-
-      // Look for more traps from this agent (if result is TRUE there are more traps)
-      while(bResult) {
-        DEBUGMSGTL(("winExtDLL", "More traps to process.  Calling SnmpExtensionTrap again\n"));
-
-        pEnterprise.ids = NULL;
-        pEnterprise.idLength = 0;
-        pGenericTrap = pSpecificTrap = NULL;
-        pTimeStamp = 0;
-        pVariableBindings.list = NULL;
-        pVariableBindings.len = 0;
-
-        bResult = winExtensionAgent[i].xSnmpExtensionTrap(
-            &pEnterprise,
-            &pGenericTrap,
-            &pSpecificTrap,
-            &pTimeStamp,
-            &pVariableBindings);
-        
-        DEBUGMSGTL(("winExtDLL", "result of SnmpExtensionTrap call:  %d\n",bResult));
-
-        // Assume that if enterprise length is >0, it's a real trap and not a cleanup call
-        // FIXME:  Not sure if this is correct.  Need to test with agent that sends a non-enterprise trap
-        if (pEnterprise.idLength) {
-          
-          DEBUGMSGTL(("winExtDLL", "GenericTrap: %d\n",pGenericTrap));
-          DEBUGMSGTL(("winExtDLL", "SpecificTrap: %d\n",pSpecificTrap));
-
-          if (pEnterprise.idLength)
-            DEBUGMSGTL(("winExtDLL", "pEnterprise is not 0\n"));
-          else
-            DEBUGMSGTL(("winExtDLL", "pEnterprise is 0\n"));
-          
-          // Send the trap
-          send_trap(
-              &pEnterprise, 
-              &pGenericTrap, 
-              &pSpecificTrap,
-              &pTimeStamp,
-              &pVariableBindings);
-        }
-        SnmpUtilVarBindListFree(&pVariableBindings);
-      }
-      break;
-    }
-  }
-
-  // Events should be auto-reset, but just in case..
-  ResetEvent(dwWaitResult);
-
-  return 1;
-}
-
-
-void send_trap(
-    AsnObjectIdentifier *pEnterprise, 
-    AsnInteger *pGenericTrap, 
-    AsnInteger *pSpecificTrap, 
-    AsnTimeticks *pTimeStamp,
-    SnmpVarBindList *pVariableBindings) {
-
-  int           i, j;
-  SnmpVarBind   mySnmpVarBind;
-  oid           my_oid[MAX_OID_LEN];               // Holder for pVariableBindings OIDs
-  size_t        my_oid_length = 0;                 // Holder for pVariableBindings OIDs
-
-  oid           enterprise_oid[MAX_OID_LEN];       // Holder for enterprise OID
-  size_t        enterprise_oid_length = 0;          // Holder for enterprise OID
-
-  oid           ret_oid[MAX_OID_LEN];               // Holder for return OIDs
-  size_t        ret_oid_length = 0;                 // Holder for return OIDs
-
-  char          *stringtemp;
-
-  /*
-   * here is where we store the variables to be sent in the trap 
-   */
-  netsnmp_variable_list *notification_vars = NULL;
-  
-  /*
-   * In the notification, we have to assign our notification OID to
-   * the snmpTrapOID.0 object. Here is it's definition. 
-   */
-  oid             objid_snmptrap[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };
-  size_t          objid_snmptrap_len = OID_LENGTH(objid_snmptrap);
-
-  DEBUGMSGTL(("winExtDLL", "send_trap() called\n"));
-  DEBUGMSGTL(("winExtDLL", "pVariableBindings length: %d\n",pVariableBindings->len));
-
-  if (*pGenericTrap != 6) {
-    DEBUGMSGTL(("winExtDLL", "Working on generic trap\n"));
-    DEBUGMSGTL(("winExtDLL", "sending v1 trap\n"));
-    send_easy_trap(*pGenericTrap, *pSpecificTrap);
-    return;
-  }
-
-  // Convert enterprise OID from Windows to Net-SNMP so Net-SNMP
-  for (j = 0; j < (pEnterprise->idLength > MAX_OID_LEN?MAX_OID_LEN:pEnterprise->idLength); j++) {
-    enterprise_oid[j] = (oid)pEnterprise->ids[j];
-  }
-  enterprise_oid_length = j;
-
-  DEBUGMSGTL(("winExtDLL", "Enterprise OID: "));
-  DEBUGMSGOID(("winExtDLL", enterprise_oid, enterprise_oid_length));
-  DEBUGMSG(("winExtDLL", "\n"));
-
-  // We need to copy .0.specific trap to copy of enterprise and use that for objid_snmptrap!!
-
-  for (i = 0; i < enterprise_oid_length; i++) {
-    my_oid[i] = enterprise_oid[i];
-  }
-  my_oid_length = i;
-
-  my_oid[my_oid_length] = 0;
-  my_oid_length++;
-
-  my_oid[my_oid_length] = *pSpecificTrap;
-  my_oid_length++;
-
-  DEBUGMSGTL(("winExtDLL", "Trap OID (snmpTrapOID.0): "));
-  DEBUGMSGOID(("winExtDLL", my_oid, my_oid_length));
-  DEBUGMSG(("winExtDLL", "\n"));
-
-  /*
-   * add in the trap definition object 
-   */
-  snmp_varlist_add_variable(&notification_vars,
-      /*
-       * the snmpTrapOID.0 variable 
-       */
-      objid_snmptrap, objid_snmptrap_len,
-      /*
-       * value type is an OID 
-       */
-      ASN_OBJECT_ID,
-      /*
-       * value contents is our notification OID 
-       */
-      (u_char *) my_oid,
-      /*
-       * size in bytes
-       */
-      my_oid_length  * sizeof(oid));
-
-  for (i = 0; i< pVariableBindings->len; i++) {
-
-    mySnmpVarBind = pVariableBindings->list[i];
-
-    // Convert OID from Windows to Net-SNMP so Net-SNMP
-    for (j = 0; j < (mySnmpVarBind.name.idLength > MAX_OID_LEN?MAX_OID_LEN:mySnmpVarBind.name.idLength); j++) {
-      my_oid[j] = (oid)mySnmpVarBind.name.ids[j];
-    }
-    my_oid_length = j;
-
-    DEBUGMSGTL(("winExtDLL", "OID in trap variable binding: "));
-    DEBUGMSGOID(("winExtDLL", my_oid, my_oid_length));
-    DEBUGMSG(("winExtDLL", "\n"));
-
-    // Set Net-SNMP ASN type based on closest match to Windows ASN type
-    switch (mySnmpVarBind.value.asnType) {
-      case MS_ASN_OCTETSTRING:        // AsnOctetString
-        stringtemp = netsnmp_strdup_and_null(mySnmpVarBind.value.asnValue.string.stream, mySnmpVarBind.value.asnValue.string.length);
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_OCTETSTRING = ASN_OCTET_STR\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_OCTETSTRING = %s\n",stringtemp));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_OCTET_STR,
-            stringtemp,
-            strlen(stringtemp));
-        break;
-      case MS_ASN_INTEGER:          // And MS_ASN_INTEGER32
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_INTEGER = ASN_INTEGER\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_INTEGER = %d\n",mySnmpVarBind.value.asnValue.number));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_INTEGER,
-            (u_char *)&mySnmpVarBind.value.asnValue.number,
-            sizeof(mySnmpVarBind.value.asnValue.number));
-        break;
-      case MS_ASN_UNSIGNED32:       // SNMP v2
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_UNSIGNED32 = ASN_UNSIGNED\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_UNSIGNED32 = %d\n",mySnmpVarBind.value.asnValue.unsigned32));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_UNSIGNED,
-            (u_char *)&mySnmpVarBind.value.asnValue.unsigned32,
-            sizeof(mySnmpVarBind.value.asnValue.unsigned32));
-        break;
-      case MS_ASN_COUNTER64:       // SNMP v2
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER64 = ASN_COUNTER64\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER64 = %d\n",mySnmpVarBind.value.asnValue.counter64));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_COUNTER64,
-            (u_char *)&mySnmpVarBind.value.asnValue.counter64,
-            sizeof(mySnmpVarBind.value.asnValue.counter64));
-        break;
-      case MS_ASN_BITS:               // AsnOctetString
-        stringtemp = netsnmp_strdup_and_null(mySnmpVarBind.value.asnValue.bits.stream, mySnmpVarBind.value.asnValue.bits.length);
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_BITS = ASN_BIT_STR\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_BITS = %s\n",stringtemp));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_BIT_STR,
-            stringtemp,
-            strlen(stringtemp));
-        break;
-      case MS_ASN_OBJECTIDENTIFIER:   // AsnObjectIdentifier
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_OBJECTIDENTIFIER = ASN_OBJECT_ID\n"));
-        // Convert OID to Net-SNMP
-
-        DEBUGMSGTL(("winExtDLL", "Returned OID: "));
-        DEBUGMSGWINOID(("winExtDLL", &mySnmpVarBind.value.asnValue.object));
-        DEBUGMSG(("winExtDLL", "\n"));
-        
-        // Convert OID from Windows to Net-SNMP
-        for (i = 0; i < (mySnmpVarBind.value.asnValue.object.idLength > MAX_OID_LEN?MAX_OID_LEN:
-              mySnmpVarBind.value.asnValue.object.idLength); i++) {
-          ret_oid[i] = (oid)mySnmpVarBind.value.asnValue.object.ids[i];
-        }
-        ret_oid_length = i;
-        
-        DEBUGMSGTL(("winExtDLL", "Windows OID converted to Net-SNMP: "));
-        DEBUGMSGOID(("winExtDLL", ret_oid, ret_oid_length));
-        DEBUGMSG(("winExtDLL", "\n"));
-
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_OBJECT_ID,
-            (u_char *)&ret_oid,
-            ret_oid_length * sizeof(oid));
-        break;
-      case MS_ASN_SEQUENCE:           // AsnOctetString
-        stringtemp = netsnmp_strdup_and_null(mySnmpVarBind.value.asnValue.sequence.stream, mySnmpVarBind.value.asnValue.sequence.length);
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_SEQUENCE = ASN_SEQUENCE\n"));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_SEQUENCE,
-            stringtemp,
-            strlen(stringtemp));
-        break;
-      case MS_ASN_IPADDRESS:          // AsnOctetString
-        stringtemp = netsnmp_strdup_and_null(mySnmpVarBind.value.asnValue.address.stream, mySnmpVarBind.value.asnValue.address.length);
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_IPADDRESS = ASN_IPADDRESS\n"));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_IPADDRESS,
-            stringtemp,
-            strlen(stringtemp));
-        break;
-      case MS_ASN_COUNTER32:          
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER32 = ASN_COUNTER\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_COUNTER32 = %d\n",mySnmpVarBind.value.asnValue.counter));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_COUNTER,
-            (u_char *)&mySnmpVarBind.value.asnValue.counter,
-            sizeof(mySnmpVarBind.value.asnValue.counter));
-        break;
-      case MS_ASN_GAUGE32:
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_GAUGE32 = ASN_GAUGE\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_GAUGE32 = %d\n",mySnmpVarBind.value.asnValue.gauge));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_GAUGE,
-            (u_char *)&mySnmpVarBind.value.asnValue.gauge,
-            sizeof(mySnmpVarBind.value.asnValue.gauge));
-        break;
-      case MS_ASN_TIMETICKS:
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_TIMETICKS = ASN_TIMETICKS\n"));
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_TIMETICKS = %d\n",mySnmpVarBind.value.asnValue.ticks));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_TIMETICKS,
-            (u_char *)&mySnmpVarBind.value.asnValue.ticks,
-            sizeof(mySnmpVarBind.value.asnValue.ticks));
-        break;
-      case MS_ASN_OPAQUE:             // AsnOctetString
-        stringtemp = netsnmp_strdup_and_null(mySnmpVarBind.value.asnValue.arbitrary.stream, mySnmpVarBind.value.asnValue.arbitrary.length);
-        DEBUGMSGTL(("winExtDLL", "MS_ASN_OPAQUE = ASN_OPAQUE\n"));
-        snmp_varlist_add_variable(&notification_vars,
-            my_oid, my_oid_length,
-            ASN_OPAQUE,
-            stringtemp,
-            strlen(stringtemp));          break;
-      default:
-        DEBUGMSGTL(("winExtDLL", "Defaulting to ASN_INTEGER\n"));
-        break;
-    }
-  }
-  /*
-   * send the trap out.  This will send it to all registered
-   * receivers (see the "SETTING UP TRAP AND/OR INFORM DESTINATIONS"
-   * section of the snmpd.conf manual page. 
-   */
-
-  DEBUGMSGTL(("winExtDLL", "sending v2 trap\n"));
-  send_v2trap(notification_vars);
-
-  /*
-   * free the created notification variable list 
-   */
-  DEBUGMSGTL(("winExtDLL", "cleaning up\n"));
-  snmp_free_varbind(notification_vars);
-}
-
-/* DEBUGMSGWINOID */
-void
-debugmsg_win_oid(const char *token, const AsnObjectIdentifier * theoid)
-{
-    u_char          buf[1024];
-    u_char          temp[10];
-    size_t          buf_len = 0, out_len = 0;
+        for (i = 0; ; i++) {
+            valueSize = sizeof(valueName);
+            dataSize = sizeof(data);
+            retCode = RegEnumValue(hKey, i, valueName, &valueSize, NULL,
+                                   &dataType, (BYTE *) data, &dataSize);
+
+            if (retCode != ERROR_SUCCESS)
+                break;
+            if (dataType == REG_SZ) {
+                winextdll       ext_dll_info;
+
+                memset(&ext_dll_info, 0, sizeof(ext_dll_info));
+                ext_dll_info.dll_name =
+                    read_extension_dll_path_from_registry(data);
+                if (ext_dll_info.dll_name) {
+                    xarray_push_back(&s_winextdll, &ext_dll_info);
+                    DEBUGMSG(("winExtDLL", "registry key %s: DLL %s.\n",
+                              data, ext_dll_info.dll_name));
+                }
+            }
+        }
+        RegCloseKey(hKey);
+    }
+}
+
+/** Store the DLL path in dynamically allocated memory. */
+char           *
+read_extension_dll_path_from_registry(const TCHAR * keyName)
+{
+    HKEY            hKey;
+    DWORD           key_value_type = 0;
+    TCHAR           valueName[MAX_VALUE_NAME];
+    DWORD           key_value_size = MAX_VALUE_NAME;
+    TCHAR           valueNameExpanded[MAX_VALUE_NAME];
+    DWORD           retCode;
+    char           *result = 0;
+
+    retCode = RegOpenKeyExA(HKEY_LOCAL_MACHINE,
+                            keyName, 0, KEY_QUERY_VALUE, &hKey);
+
+    if (retCode != ERROR_SUCCESS)
+        return 0;
+
+    retCode = RegQueryValueExA(hKey,
+                               "Pathname",
+                               NULL,
+                               &key_value_type,
+                               (BYTE *) valueName, &key_value_size);
+
+    if (retCode != ERROR_SUCCESS) {
+        RegCloseKey(hKey);
+        return 0;
+    }
+
+    if (key_value_type == REG_EXPAND_SZ) {
+        if (ExpandEnvironmentStrings
+            (valueName, valueNameExpanded, MAX_VALUE_NAME))
+            result = strdup(valueNameExpanded);
+    } else if (key_value_type == REG_SZ)
+        result = strdup(valueName);
+
+    RegCloseKey(hKey);
+    return result;
+}
+
+/**
+ * Callback function called by the Net-SNMP agent to check for traps waiting
+ * to be processed.
+ */
+void
+subagentTrapCheck(unsigned int clientreg, void *clientarg)
+{
+    while (1) {
+        DWORD           dwWaitResult;
+        BOOL            bResult;
+        int             i;
+        int             j;
+        const winextdll *ext_dll_info;
+
+        dwWaitResult = WaitForMultipleObjects(s_trapevent.size,
+                                              &TRAPEVENT(0), FALSE, 0);
+
+        i = dwWaitResult - WAIT_OBJECT_0;
+        if (i < 0 || i >= s_trapevent.size) {
+            assert(dwWaitResult == WAIT_TIMEOUT);
+            return;
+        }
+
+        assert(s_trapevent.size == s_trapevent_to_dllinfo.size);
+        ext_dll_info = TRAPEVENT_TO_DLLINFO(i);
+        assert(ext_dll_info->subagentTrapEvent == TRAPEVENT(i));
+
+        /*
+         * Reset the signalled event just in case the extension DLL erroneously
+         * allocated a manual-reset event instead of an auto-reset event. It is
+         * important to reset the event BEFORE traps are processed, otherwise a
+         * race condition is triggered between the extension DLL setting the
+         * event and this code resetting the event.
+         */
+        ResetEvent(TRAPEVENT(i));
+
+        if (!ext_dll_info->pfSnmpExtensionTrap) {
+            snmp_log(LOG_ERR,
+                     "internal error in SNMP extension DLL %s: a trap is ready"
+                     " but the function SnmpExtensionTrap() is missing.\n",
+                     ext_dll_info->dll_name);
+            return;
+        }
+
+        /*
+         * Process at most hundred traps per extension DLL. If the extension DLL
+         * has more traps waiting, that's probably a bug in the extension DLL.
+         */
+        for (j = 0; j < 100; j++) {
+            AsnObjectIdentifier Enterprise = { 0, NULL };
+            AsnInteger      GenericTrap = 0;
+            AsnInteger      SpecificTrap = 0;
+            AsnTimeticks    TimeStamp = 0;
+            SnmpVarBindList TrapVarbinds = { NULL, 0 };
+
+            bResult = ext_dll_info->pfSnmpExtensionTrap(&Enterprise,
+                                                        &GenericTrap,
+                                                        &SpecificTrap,
+                                                        &TimeStamp,
+                                                        &TrapVarbinds);
+
+            if (!bResult)
+                break;
+
+            send_trap(&Enterprise, GenericTrap, SpecificTrap, TimeStamp,
+                      &TrapVarbinds);
+
+            SnmpUtilVarBindListFree(&TrapVarbinds);
+        }
+    }
+}
+
+void
+send_trap(const AsnObjectIdentifier * const pEnterprise,
+          const AsnInteger GenericTrap,
+          const AsnInteger SpecificTrap,
+          const AsnTimeticks TimeStamp,
+          const SnmpVarBindList * const pTrapVarbinds)
+{
+    /*
+     * A quote from the paragraph in RFC 1908 about SNMPv1 to SNMPv2c
+     * trap translation (http://www.ietf.org/rfc/rfc1908.txt):
+     * <quote>
+     * If a Trap-PDU is received, then it is mapped into a SNMPv2-Trap-
+     * PDU.  This is done by prepending onto the variable-bindings field
+     * two new bindings:  sysUpTime.0 [6], which takes its value from the
+     * timestamp field of the Trap-PDU; and, snmpTrapOID.0 [6], which is
+     * calculated thusly:  if the value of generic-trap field is
+     * `enterpriseSpecific', then the value used is the concatenation of
+     * the enterprise field from the Trap-PDU with two additional sub-
+     * identifiers, `0', and the value of the specific-trap field;
+     * otherwise, the value of the corresponding trap defined in [6] is
+     * used.
+     * </quote>
+     *
+     * Reference [6] refers to RFC 1907 (http://www.ietf.org/rfc/rfc1907.txt),
+     * where the generic trap OIDs have been defined as follows:
+     * coldStart             ::= { snmpTraps 1 }
+     * warmStart             ::= { snmpTraps 2 }
+     * linkDown              ::= { snmpTraps 3 }
+     * linkUp                ::= { snmpTraps 4 }
+     * authenticationFailure ::= { snmpTraps 5 }
+     * egpNeighborLoss       ::= { snmpTraps 6 }
+     */
+    static const oid sysuptime_oid[] = { 1, 3, 6, 1, 2, 1, 1, 3, 0 };
+    static const size_t sysuptime_oid_len = OID_LENGTH(sysuptime_oid);
+
+    static const oid snmptrap_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };
+    static const size_t snmptrap_oid_len = OID_LENGTH(snmptrap_oid);
+
+    static const oid snmptraps_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 5 };
+    static const size_t snmptraps_oid_len = OID_LENGTH(snmptraps_oid);
+
+    oid             vb2_oid[MAX_OID_LEN];
+    size_t          vb2_oid_len;
+
+    netsnmp_variable_list *notification_vars = NULL;
+
+
+    /*
+     * Append the varbind (sysUpTime.0, TimeStamp). 
+     */
+    snmp_varlist_add_variable(&notification_vars,
+                              sysuptime_oid, sysuptime_oid_len,
+                              ASN_TIMETICKS,
+                              (const u_char *) &TimeStamp,
+                              sizeof(TimeStamp));
+
+    if (GenericTrap == SNMP_GENERICTRAP_ENTERSPECIFIC) {
+        /*
+         * Enterprise specific trap: compute the OID
+         * *pEnterprise + ".0." + SpecificTrap.
+         */
+        copy_oid(vb2_oid, &vb2_oid_len,
+                 pEnterprise->ids, pEnterprise->idLength);
+        vb2_oid[vb2_oid_len++] = 0;
+        vb2_oid[vb2_oid_len++] = SpecificTrap;
+    } else {
+        /*
+         * Generic trap: compute the OID snmpTraps + "." + GenericTrap.
+         * Since the GenericTrap values are those defined in SNMPv1, since
+         * these values start at zero, and since the corresponding values in
+         * SNMPv2 start at one, translate the GenericTrap value accordingly.
+         * See also http://www.ietf.org/rfc/rfc1214.txt and
+         * http://www.ietf.org/rfc/rfc3418.txt.
+         */
+        copy_oid(vb2_oid, &vb2_oid_len, snmptraps_oid, snmptraps_oid_len);
+        vb2_oid[vb2_oid_len++] = GenericTrap + 1;
+    }
+
+    /*
+     * Append the varbind (snmpTrap, vb2_oid). 
+     */
+    snmp_varlist_add_variable(&notification_vars,
+                              snmptrap_oid, snmptrap_oid_len,
+                              ASN_OBJECT_ID,
+                              (u_char *) vb2_oid,
+                              vb2_oid_len * sizeof(vb2_oid[0]));
+
+    /*
+     * Append all the varbinds in pTrapVarbinds. 
+     */
+    append_windows_varbind_list(&notification_vars, pTrapVarbinds);
+
+    /*
+     * Send trap. 
+     */
+    send_v2trap(notification_vars);
+
+    /*
+     * Free the memory allocated for notification_vars. 
+     */
+    snmp_free_varbind(notification_vars);
+}
+
+/**
+ * Convert a Windows varbind to a Net-SNMP varbind and add it to the list of
+ * varbinds 'net_snmp_varbinds'.
+ *
+ * @note The memory allocated inside this function must be freed by the caller
+ *   as follows: snmp_free_varbind(*net_snmp_varbinds).
+ */
+static int
+append_windows_varbind_list(netsnmp_variable_list **
+                            const net_snmp_varbinds,
+                            const SnmpVarBindList * const win_varbinds)
+{
+    int             i, status = SNMP_ERR_NOERROR;
+
+    for (i = 0; i < win_varbinds->len; i++) {
+        status =
+            append_windows_varbind(net_snmp_varbinds,
+                                   &win_varbinds->list[i]);
+        if (status != SNMP_ERR_NOERROR)
+            break;
+    }
+    return status;
+}
+
+static int
+append_windows_varbind(netsnmp_variable_list ** const net_snmp_varbinds,
+                       const SnmpVarBind * const win_varbind)
+{
+    switch (win_varbind->value.asnType) {
+    case MS_ASN_INTEGER:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_INTEGER,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.number,
+                                  sizeof(win_varbind->value.asnValue.
+                                         number));
+        break;
+    case MS_ASN_BITS:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_BIT_STR,
+                                  win_varbind->value.asnValue.bits.stream,
+                                  win_varbind->value.asnValue.bits.length);
+        break;
+    case MS_ASN_OCTETSTRING:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_OCTET_STR,
+                                  win_varbind->value.asnValue.string.
+                                  stream,
+                                  win_varbind->value.asnValue.string.
+                                  length);
+        break;
+    case MS_ASN_NULL:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_NULL, 0, 0);
+        break;
+    case MS_ASN_OBJECTIDENTIFIER:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_OBJECT_ID,
+                                  (u_char *) win_varbind->value.asnValue.
+                                  object.ids,
+                                  win_varbind->value.asnValue.object.
+                                  idLength * sizeof(oid));
+        break;
+
+        /*
+         * MS_ASN_INTEGER32: synonym for MS_ASN_INTEGER. 
+         */
+
+    case MS_ASN_SEQUENCE:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_SEQUENCE,
+                                  win_varbind->value.asnValue.sequence.
+                                  stream,
+                                  win_varbind->value.asnValue.sequence.
+                                  length);
+        break;
+    case MS_ASN_IPADDRESS:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_IPADDRESS,
+                                  win_varbind->value.asnValue.address.
+                                  stream,
+                                  win_varbind->value.asnValue.address.
+                                  length);
+        break;
+    case MS_ASN_COUNTER32:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_COUNTER,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.counter,
+                                  sizeof(win_varbind->value.asnValue.
+                                         counter));
+        break;
+    case MS_ASN_GAUGE32:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_GAUGE,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.gauge,
+                                  sizeof(win_varbind->value.asnValue.
+                                         gauge));
+        break;
+    case MS_ASN_TIMETICKS:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_TIMETICKS,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.ticks,
+                                  sizeof(win_varbind->value.asnValue.
+                                         ticks));
+        break;
+    case MS_ASN_OPAQUE:        // AsnOctetString
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_OPAQUE,
+                                  win_varbind->value.asnValue.arbitrary.
+                                  stream,
+                                  win_varbind->value.asnValue.arbitrary.
+                                  length);
+        break;
+    case MS_ASN_COUNTER64:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_COUNTER64,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.counter64,
+                                  sizeof(win_varbind->value.asnValue.
+                                         counter64));
+        break;
+    case MS_ASN_UINTEGER32:
+        snmp_varlist_add_variable(net_snmp_varbinds, win_varbind->name.ids,
+                                  win_varbind->name.idLength,
+                                  ASN_UNSIGNED,
+                                  (const u_char *) &win_varbind->value.
+                                  asnValue.unsigned32,
+                                  sizeof(win_varbind->value.asnValue.
+                                         unsigned32));
+        break;
+    default:
+        return SNMP_ERR_GENERR;
+    }
+
+    return SNMP_ERR_NOERROR;
+}
+
+/**
+ * Convert a Net-SNMP varbind to a WinSNMP varbind list.
+ *
+ * @param[out] pVarBindList WinSNMP varbind list, initialized by this
+ *               function.
+ * @param[in]  varbind Net-SNMP varbind.
+ */
+int
+convert_to_windows_varbind_list(SnmpVarBindList * pVarBindList,
+                                netsnmp_variable_list * varbind)
+{
+    SnmpVarBind    *win_varbind;
+
+    assert(pVarBindList);
+    assert(varbind);
+
+    pVarBindList->len = 1;
+    pVarBindList->list
+        = (SnmpVarBind *) SnmpUtilMemAlloc(pVarBindList->len
+                                           *
+                                           sizeof(pVarBindList->list[0]));
+    if (pVarBindList->list == 0)
+        goto generr;
+
+    memset(&pVarBindList->list[0], 0, sizeof(pVarBindList->list[0]));
+
+    win_varbind = &pVarBindList->list[0];
+
+    if (varbind->name
+        && !copy_oid_to_new_windows_oid(&win_varbind->name,
+                                        varbind->name,
+                                        varbind->name_length))
+        goto generr;
+
+    switch (varbind->type) {
+    case ASN_BOOLEAN:
+        // There is no equivalent type in Microsoft's <snmp.h>.
+        assert(0);
+        win_varbind->value.asnType = MS_ASN_INTEGER;
+        win_varbind->value.asnValue.number = *(varbind->val.integer);
+        break;
+    case ASN_INTEGER:
+        win_varbind->value.asnType = MS_ASN_INTEGER;
+        win_varbind->value.asnValue.number = *(varbind->val.integer);
+        break;
+    case ASN_BIT_STR:
+        win_varbind->value.asnType = MS_ASN_BITS;
+        win_varbind->value.asnValue.string.stream
+            = winsnmp_memdup(varbind->val.string, varbind->val_len);
+        win_varbind->value.asnValue.string.length =
+            (UINT) (varbind->val_len);
+        win_varbind->value.asnValue.string.dynamic = TRUE;
+        break;
+    case ASN_OCTET_STR:
+        win_varbind->value.asnType = MS_ASN_OCTETSTRING;
+        win_varbind->value.asnValue.string.stream
+            = winsnmp_memdup(varbind->val.string, varbind->val_len);
+        win_varbind->value.asnValue.string.length =
+            (UINT) (varbind->val_len);
+        win_varbind->value.asnValue.string.dynamic = TRUE;
+        break;
+    case ASN_NULL:
+        win_varbind->value.asnType = MS_ASN_NULL;
+        memset(&win_varbind->value, 0, sizeof(win_varbind->value));
+        break;
+    case ASN_OBJECT_ID:
+        win_varbind->value.asnType = MS_ASN_OBJECTIDENTIFIER;
+        if (!copy_oid_to_new_windows_oid
+            (&win_varbind->value.asnValue.object, varbind->val.objid,
+             varbind->val_len / sizeof(varbind->val.objid[0])))
+            return SNMP_ERR_GENERR;
+        break;
+    case ASN_SEQUENCE:
+        win_varbind->value.asnType = MS_ASN_SEQUENCE;
+        win_varbind->value.asnValue.string.stream
+            = winsnmp_memdup(varbind->val.string, varbind->val_len);
+        win_varbind->value.asnValue.string.length =
+            (UINT) (varbind->val_len);
+        win_varbind->value.asnValue.string.dynamic = TRUE;
+        break;
+    case ASN_SET:
+        // There is no equivalent type in Microsoft's <snmp.h>.
+        assert(0);
+        win_varbind->value.asnType = MS_ASN_INTEGER;
+        win_varbind->value.asnValue.number = *(varbind->val.integer);
+        break;
+    case ASN_IPADDRESS:
+        win_varbind->value.asnType = MS_ASN_IPADDRESS;
+        win_varbind->value.asnValue.string.stream
+            = winsnmp_memdup(varbind->val.string, varbind->val_len);
+        win_varbind->value.asnValue.string.length =
+            (UINT) (varbind->val_len);
+        win_varbind->value.asnValue.string.dynamic = TRUE;
+        break;
+    case ASN_COUNTER:
+        win_varbind->value.asnType = MS_ASN_COUNTER32;
+        win_varbind->value.asnValue.counter = *(varbind->val.integer);
+        break;
+        /*
+         * ASN_GAUGE == ASN_UNSIGNED 
+         */
+    case ASN_UNSIGNED:
+        win_varbind->value.asnType = MS_ASN_UNSIGNED32;
+        win_varbind->value.asnValue.unsigned32 = *(varbind->val.integer);
+        break;
+    case ASN_TIMETICKS:
+        win_varbind->value.asnType = MS_ASN_TIMETICKS;
+        win_varbind->value.asnValue.ticks = *(varbind->val.integer);
+        break;
+    case ASN_OPAQUE:
+        win_varbind->value.asnType = MS_ASN_OPAQUE;
+        win_varbind->value.asnValue.string.stream
+            = winsnmp_memdup(varbind->val.string, varbind->val_len);
+        win_varbind->value.asnValue.string.length =
+            (UINT) (varbind->val_len);
+        win_varbind->value.asnValue.string.dynamic = TRUE;
+        break;
+    case ASN_COUNTER64:
+        win_varbind->value.asnType = MS_ASN_COUNTER64;
+        win_varbind->value.asnValue.counter64.HighPart
+            = varbind->val.counter64->high;
+        win_varbind->value.asnValue.counter64.LowPart
+            = varbind->val.counter64->low;
+        break;
+    default:
+        assert(0);
+        goto generr;
+    }
+
+    return SNMP_ERR_NOERROR;
+
+  generr:
+    SnmpUtilVarBindListFree(pVarBindList);
+    memset(pVarBindList, 0, sizeof(*pVarBindList));
+    return SNMP_ERR_GENERR;
+}
+
+/** Convert a Windows SNMP error code to the equivalent Net-SNMP error code. */
+int
+convert_win_snmp_err(const int win_snmp_err)
+{
+    switch (win_snmp_err) {
+    case SNMP_ERRORSTATUS_NOERROR:
+        return SNMP_ERR_NOERROR;
+    case SNMP_ERRORSTATUS_TOOBIG:
+        return SNMP_ERR_TOOBIG;
+    case SNMP_ERRORSTATUS_NOSUCHNAME:
+        /*
+         * Note: SNMP extension DLLs return SNMP_ERRORSTATUS_NOSUCHNAME
+         * when either noSuchObject or noSuchInstance should be returned to
+         * the SNMP manager (assuming SNMPv2c or SNMPv3). Unfortunately it
+         * is not possible without consulting the MIB to find out whether
+         * either SNMP_NOSUCHINSTANCE or SNMP_NOSUCHOBJECT should be returned.
+         * See also RFC 1448.
+         */
+        return SNMP_NOSUCHINSTANCE;
+    case SNMP_ERRORSTATUS_BADVALUE:
+        return SNMP_ERR_BADVALUE;
+    case SNMP_ERRORSTATUS_READONLY:
+        return SNMP_ERR_READONLY;
+    case SNMP_ERRORSTATUS_GENERR:
+        return SNMP_ERR_GENERR;
+    case SNMP_ERRORSTATUS_NOACCESS:
+        return SNMP_ERR_NOACCESS;
+    case SNMP_ERRORSTATUS_WRONGTYPE:
+        return SNMP_ERR_WRONGTYPE;
+    case SNMP_ERRORSTATUS_WRONGLENGTH:
+        return SNMP_ERR_WRONGLENGTH;
+    case SNMP_ERRORSTATUS_WRONGENCODING:
+        return SNMP_ERR_WRONGENCODING;
+    case SNMP_ERRORSTATUS_WRONGVALUE:
+        return SNMP_ERR_WRONGVALUE;
+    case SNMP_ERRORSTATUS_NOCREATION:
+        return SNMP_ERR_NOCREATION;
+    case SNMP_ERRORSTATUS_INCONSISTENTVALUE:
+        return SNMP_ERR_INCONSISTENTVALUE;
+    case SNMP_ERRORSTATUS_RESOURCEUNAVAILABLE:
+        return SNMP_ERR_RESOURCEUNAVAILABLE;
+    case SNMP_ERRORSTATUS_COMMITFAILED:
+        return SNMP_ERR_COMMITFAILED;
+    case SNMP_ERRORSTATUS_UNDOFAILED:
+        return SNMP_ERR_UNDOFAILED;
+    case SNMP_ERRORSTATUS_AUTHORIZATIONERROR:
+        return SNMP_ERR_AUTHORIZATIONERROR;
+    case SNMP_ERRORSTATUS_NOTWRITABLE:
+        return SNMP_ERR_NOTWRITABLE;
+    case SNMP_ERRORSTATUS_INCONSISTENTNAME:
+        return SNMP_ERR_INCONSISTENTNAME;
+    }
+    assert(0);
+    return SNMP_ERR_GENERR;
+}
+
+/**
+ * Look up the extension DLL view that was registered with the given OID.
+ */
+static winextdll_view *
+lookup_view_by_oid(oid * const name, const size_t name_len)
+{
     int             i;
 
-    buf[0] = '\0';
-
-    for (i = 0; i < theoid->idLength; i++) {
-      sprintf(temp, ".%d", theoid->ids[i]);
-      strcat(buf, temp);
-    }
-
-    if (buf != NULL) {
-      debugmsg(token, "%s", buf);
-      //DEBUGMSGTL((token, "%s\n", buf));
-    }
-}
-
+    for (i = 0; i < s_winextdll_view.size; i++) {
+        if (netsnmp_oid_equals(WINEXTDLL_VIEW(i).name,
+                               WINEXTDLL_VIEW(i).name_length,
+                               name, name_len) == 0
+            && WINEXTDLL_VIEW(i).my_handler) {
+            return &WINEXTDLL_VIEW(i);
+        }
+    }
+
+    return NULL;
+}
+
+/**
+ * Copy an OID.
+ *
+ * @param[out] to_name       Number of elements written to destination OID.
+ * @param[out] to_name_len   Length of destination OID. Must have at least
+ *                           min(from_name_len, MAX_OID_LEN) elements.
+ * @param[in]  from_name     Original OID.
+ * @param[in]  from_name_len Length of original OID.
+ */
+static void
+copy_oid(oid * const to_name, size_t * const to_name_len,
+         const oid * const from_name, const size_t from_name_len)
+{
+    int             j;
+
+    assert(to_name);
+    assert(to_name_len);
+    assert(from_name);
+
+    for (j = 0; j < from_name_len && j < MAX_OID_LEN; j++)
+        to_name[j] = from_name[j];
+
+    *to_name_len = j;
+}
+
+/**
+ * Convert a Net-SNMP OID into a Windows OID and allocate memory for the
+ * Windows OID.
+ *
+ * @param[out] windows_oid   Pointer to a AsnObjectIdentifier.
+ * @param[in]  name   Pointer to an array with elements of type oid
+ *           and length name_len.
+ * @param[in]  name_len Number of elements of input and output OID.
+ */
+static UINT    *
+copy_oid_to_new_windows_oid(AsnObjectIdentifier * const windows_oid,
+                            const oid * const name, const size_t name_len)
+{
+    assert(windows_oid);
+    assert(windows_oid->ids == 0);
+    assert(windows_oid->idLength == 0);
+    assert(name);
+
+    windows_oid->ids
+        =
+        (UINT *) winsnmp_memdup(name,
+                                sizeof(windows_oid->ids[0]) * name_len);
+    windows_oid->idLength = (UINT) name_len;
+    return windows_oid->ids;
+}
+
+static u_char  *
+winsnmp_memdup(const void *src, const size_t len)
+{
+    u_char         *p;
+
+    assert(len == (UINT) len);
+
+    p = SnmpUtilMemAlloc((UINT) len);
+    if (p)
+        memcpy(p, src, len);
+    return p;
+}
+
+#if 0
+/** Initialize array 'a'. */
+static void
+xarray_init(xarray * a, size_t elem_size)
+{
+    assert(a);
+
+    memset(a, 0, sizeof(*a));
+    a->elem_size = elem_size;
+}
+#endif
+
+/** Deallocate any memory that was dynamically allocated for 'a'. */
+static void
+xarray_destroy(xarray * a)
+{
+    assert(a);
+
+    xarray_reserve(a, 0);
+}
+
+/**
+ * Append the contents of the address range [ elem, elem + a->elem_size [ to a.
+ *
+ * Resize a if necessary.
+ *
+ * @return A pointer to the address where the data has been copied upon success,
+ *         or NULL upon failure.
+ */
+static void    *
+xarray_push_back(xarray * a, const void *elem)
+{
+    assert(a);
+    assert(elem);
+    assert(a->size <= a->reserved);
+
+    if (a->size == a->reserved)
+        xarray_reserve(a, a->reserved == 0 ? 16 : 2 * a->reserved);
+    if (a->size < a->reserved) {
+        assert(a->size < a->reserved);
+        return memcpy((char *) (a->p) + a->elem_size * a->size++, elem,
+                      a->elem_size);
+    }
+    return NULL;
+}
+
+#if 0
+/** Erase [ elem, elem + a->elem_size [ from a. */
+static void
+xarray_erase(xarray * a, void *const elem)
+{
+    assert(a);
+    assert(a->size >= 1);
+    assert(a->p <= elem);
+    assert((const char *) elem + a->elem_size <=
+           (char *) a->p + a->size * a->elem_size);
+    assert(((const char *) elem - (char *) a->p) % a->elem_size == 0);
+
+    a->size--;
+    memmove((char *) elem, (char *) elem + a->elem_size,
+            a->size - ((const char *) elem -
+                       (char *) a->p) / a->elem_size);
+}
+#endif
+
+/**
+ * Change the number of allocated elements to 'reserved'.
+ *
+ * Can be used either for enlarging or for shrinking the memory allocated for
+ * 'a'. Does not modify 'a' if memory allocation fails. Newly allocted memory
+ * is not initialized.
+ *
+ * @return != NULL upon success, NULL upon failure.
+ */
+static void    *
+xarray_reserve(xarray * a, int reserved)
+{
+    assert(a);
+    assert(a->size <= a->reserved);
+
+    if ((a->p = realloc(a->p, a->elem_size * reserved)))
+        a->reserved = reserved;
+    else
+        a->reserved = 0;
+    return a->p;
+}
+
+#endif                          /* USING_WINEXTDLL_MODULE */

=== modified file 'agent/mibgroup/winExtDLL.h'
--- agent/mibgroup/winExtDLL.h	2007-12-08 14:59:50 +0000
+++ agent/mibgroup/winExtDLL.h	2010-06-10 18:02:54 +0000
@@ -9,13 +9,6 @@
 #endif
 
     /*
-     * We use 'header_generic' from the util_funcs module,
-     *  so make sure this module is included in the agent.
-     */
-config_require(util_funcs)
-
-
-    /*
      * Declare our publically-visible functions.
      * Typically, these will include the initialization and shutdown functions,
      *  the main request callback routine and any writeable object methods.
@@ -24,9 +17,8 @@
      *  and writeable object methods ('WriteMethod').
      */
      void     init_winExtDLL(void);
-
-     Netsnmp_Node_Handler var_winExtDLL;
-     
+     void     shutdown_winExtDLL(void);
+   
 #ifdef __cplusplus
 }
 #endif

=== modified file 'agent/snmp_agent.c'
--- agent/snmp_agent.c	2009-11-12 16:17:40 +0000
+++ agent/snmp_agent.c	2010-06-10 18:02:54 +0000
@@ -644,6 +644,18 @@
     }
 }
 
+void netsnmp_addrcache_destroy(void)
+{
+    int             i = 0;
+
+    for (i = 0; i < SNMP_ADDRCACHE_SIZE; i++) {
+        if (addrCache[i].status == SNMP_ADDRCACHE_USED) {
+            free(addrCache[i].addr);
+            addrCache[i].status = SNMP_ADDRCACHE_UNUSED;
+        }
+    }
+}
+
 /*
  * Adds a new entry to the cache of addresses that
  * have recently made connections to the agent.
@@ -1153,7 +1165,7 @@
 {
     netsnmp_transport *transport;
     char           *cptr;
-    char            buf[SPRINT_MAX_LEN];
+    char           *buf = NULL;
     char           *st;
 
     /* default to a default cache size */
@@ -1168,15 +1180,6 @@
         
         return 0;               /*  No error if ! MASTER_AGENT  */
     }
-#ifdef USING_AGENTX_MASTER_MODULE
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID, 
-			       NETSNMP_DS_AGENT_AGENTX_MASTER) == 1)
-        real_init_master();
-#endif
-#ifdef USING_SMUX_MODULE
-    if(should_init("smux"))
-    real_init_smux();
-#endif
 
     /*
      * Have specific agent ports been specified?  
@@ -1185,13 +1188,17 @@
 				 NETSNMP_DS_AGENT_PORTS);
 
     if (cptr) {
-        snprintf(buf, sizeof(buf), "%s", cptr);
-        buf[ sizeof(buf)-1 ] = 0;
+        buf = strdup(cptr);
+        if (!buf) {
+            snmp_log(LOG_ERR,
+                     "Error processing transport \"%s\"\n", cptr);
+            return 1;
+        }
     } else {
         /*
          * No, so just specify the default port.  
          */
-        buf[0] = 0;
+        buf = "";
     }
 
     DEBUGMSGTL(("snmp_agent", "final port spec: \"%s\"\n", buf));
@@ -1221,7 +1228,7 @@
             DEBUGMSGTL(("snmp_agent",
                         "init_master_agent; pseudo-transport \"none\" "
 			"requested\n"));
-            return 0;
+            break;
         }
         transport = netsnmp_transport_open_server("snmp", cptr);
 
@@ -1243,6 +1250,16 @@
         }
     } while(st && *st != '\0');
 
+#ifdef USING_AGENTX_MASTER_MODULE
+    if (netsnmp_ds_get_boolean(NETSNMP_DS_APPLICATION_ID, 
+			       NETSNMP_DS_AGENT_AGENTX_MASTER) == 1)
+        real_init_master();
+#endif
+#ifdef USING_SMUX_MODULE
+    if(should_init("smux"))
+    real_init_smux();
+#endif
+
     return 0;
 }
 
@@ -2203,7 +2220,7 @@
 
             asp->bulkcache =
                 (netsnmp_variable_list **) malloc(
-                    asp->pdu->errindex * r * sizeof(struct varbind_list *));
+                    (n + asp->pdu->errindex * r) * sizeof(struct varbind_list *));
 
             if (!asp->bulkcache) {
                 DEBUGMSGTL(("snmp_agent", "Bulkcache malloc failed\n"));

=== modified file 'agent/snmp_perl.c'
--- agent/snmp_perl.c	2007-12-08 14:59:50 +0000
+++ agent/snmp_perl.c	2010-06-10 18:02:54 +0000
@@ -58,7 +58,7 @@
     return;
 
   bail_out:
-    snmp_log(LOG_ERR, "embedded perl support failed to initalize\n");
+    snmp_log(LOG_ERR, "embedded perl support failed to initialize\n");
     netsnmp_ds_set_boolean(NETSNMP_DS_APPLICATION_ID, 
 			   NETSNMP_DS_AGENT_DISABLE_PERL, 1);
     return;

=== modified file 'agent/snmp_vars.c'
--- agent/snmp_vars.c	2007-12-08 14:59:50 +0000
+++ agent/snmp_vars.c	2010-06-10 18:02:54 +0000
@@ -366,6 +366,7 @@
     clear_snmp_enum();
     clear_callback();
     clear_user_list();
+    netsnmp_addrcache_destroy();
 
     done_init_agent = 0;
 }

=== modified file 'apps/Makefile.depend'
--- apps/Makefile.depend	2009-11-12 16:17:40 +0000
+++ apps/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -71,8 +71,7 @@
 ./snmpbulkget.lo: ../include/net-snmp/system/sysv.h
 ./snmpbulkget.lo: ../include/net-snmp/system/generic.h
 ./snmpbulkget.lo: ../include/net-snmp/machine/generic.h 
-./snmpbulkget.lo:  ../include/net-snmp/utilities.h
-./snmpbulkget.lo: ../include/net-snmp/types.h 
+./snmpbulkget.lo: ../include/net-snmp/utilities.h ../include/net-snmp/types.h
 ./snmpbulkget.lo: ../include/net-snmp/definitions.h
 ./snmpbulkget.lo: ../include/net-snmp/library/snmp_api.h
 ./snmpbulkget.lo: ../include/net-snmp/library/asn1.h
@@ -266,7 +265,7 @@
 ./snmpdf.lo: ../include/net-snmp/system/sysv.h
 ./snmpdf.lo: ../include/net-snmp/system/generic.h
 ./snmpdf.lo: ../include/net-snmp/machine/generic.h 
-./snmpdf.lo:  ../include/net-snmp/net-snmp-includes.h
+./snmpdf.lo: ../include/net-snmp/net-snmp-includes.h
 ./snmpdf.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
 ./snmpdf.lo:  ../include/net-snmp/library/snmp_api.h
 ./snmpdf.lo: ../include/net-snmp/library/asn1.h
@@ -329,9 +328,8 @@
 ./snmpget.lo: ../include/net-snmp/system/sysv.h
 ./snmpget.lo: ../include/net-snmp/system/generic.h
 ./snmpget.lo: ../include/net-snmp/machine/generic.h 
-./snmpget.lo:  ../include/net-snmp/utilities.h
-./snmpget.lo: ../include/net-snmp/types.h 
-./snmpget.lo: ../include/net-snmp/definitions.h
+./snmpget.lo: ../include/net-snmp/utilities.h ../include/net-snmp/types.h
+./snmpget.lo:  ../include/net-snmp/definitions.h
 ./snmpget.lo: ../include/net-snmp/library/snmp_api.h
 ./snmpget.lo: ../include/net-snmp/library/asn1.h
 ./snmpget.lo: ../include/net-snmp/library/snmp_impl.h
@@ -818,6 +816,75 @@
 ./snmptrap.lo: ../include/net-snmp/library/snmp_secmod.h
 ./snmptrap.lo: ../include/net-snmp/library/snmpv3-security-includes.h
 ./snmptrap.lo: ../include/net-snmp/library/snmpusm.h
+./snmptrapd_auth.lo: ../include/net-snmp/net-snmp-config.h
+./snmptrapd_auth.lo: ../include/net-snmp/system/linux.h
+./snmptrapd_auth.lo: ../include/net-snmp/system/sysv.h
+./snmptrapd_auth.lo: ../include/net-snmp/system/generic.h
+./snmptrapd_auth.lo: ../include/net-snmp/machine/generic.h
+./snmptrapd_auth.lo: ../include/net-snmp/net-snmp-includes.h
+./snmptrapd_auth.lo: ../include/net-snmp/definitions.h
+./snmptrapd_auth.lo: ../include/net-snmp/types.h 
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/asn1.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_impl.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp-tc.h
+./snmptrapd_auth.lo: ../include/net-snmp/utilities.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_client.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/system.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/tools.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/int64.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/mt_support.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_alarm.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/callback.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/data_list.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/oid_stash.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/check_varbind.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/container.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/factory.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_logging.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/container_binary_array.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/container_list_ssll.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/container_iterator.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/container.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_assert.h
+./snmptrapd_auth.lo: ../include/net-snmp/version.h
+./snmptrapd_auth.lo: ../include/net-snmp/session_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_transport.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_service.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpCallbackDomain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/ucd_compat.h
+./snmptrapd_auth.lo: ../include/net-snmp/pdu_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/mib_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/mib.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/parse.h
+./snmptrapd_auth.lo: ../include/net-snmp/varbind_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/config_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/read_config.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/default_store.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_enum.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/vacm.h
+./snmptrapd_auth.lo: ../include/net-snmp/output_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_debug.h
+./snmptrapd_auth.lo: ../include/net-snmp/snmpv3_api.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpv3.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/transform_oids.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/keytools.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/scapi.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/lcd_time.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_secmod.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpv3-security-includes.h
+./snmptrapd_auth.lo: ../include/net-snmp/library/snmpusm.h
+./snmptrapd_auth.lo: snmptrapd_handlers.h snmptrapd_auth.h snmptrapd_ds.h
+./snmptrapd_auth.lo: ../agent/mibgroup/mibII/vacm_conf.h
+./snmptrapd_auth.lo: ../include/net-snmp/agent/agent_trap.h
 ./snmptrapd.lo: ../include/net-snmp/net-snmp-config.h
 ./snmptrapd.lo: ../include/net-snmp/system/linux.h
 ./snmptrapd.lo: ../include/net-snmp/system/sysv.h
@@ -921,75 +988,6 @@
 ./snmptrapd.lo: snmptrapd_log.h snmptrapd_ds.h snmptrapd_auth.h
 ./snmptrapd.lo: ../agent/mibgroup/notification-log-mib/notification_log.h
 ./snmptrapd.lo: ../agent/mibgroup/mibII/vacm_conf.h
-./snmptrapd_auth.lo: ../include/net-snmp/net-snmp-config.h
-./snmptrapd_auth.lo: ../include/net-snmp/system/linux.h
-./snmptrapd_auth.lo: ../include/net-snmp/system/sysv.h
-./snmptrapd_auth.lo: ../include/net-snmp/system/generic.h
-./snmptrapd_auth.lo: ../include/net-snmp/machine/generic.h
-./snmptrapd_auth.lo: ../include/net-snmp/net-snmp-includes.h
-./snmptrapd_auth.lo: ../include/net-snmp/definitions.h
-./snmptrapd_auth.lo: ../include/net-snmp/types.h 
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/asn1.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_impl.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp-tc.h
-./snmptrapd_auth.lo: ../include/net-snmp/utilities.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_client.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/system.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/tools.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/int64.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/mt_support.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/callback.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/data_list.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/oid_stash.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/check_varbind.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/container.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/factory.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_logging.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/container_binary_array.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/container_iterator.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/container.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_assert.h
-./snmptrapd_auth.lo: ../include/net-snmp/version.h
-./snmptrapd_auth.lo: ../include/net-snmp/session_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_transport.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_service.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/ucd_compat.h
-./snmptrapd_auth.lo: ../include/net-snmp/pdu_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/mib_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/mib.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/parse.h
-./snmptrapd_auth.lo: ../include/net-snmp/varbind_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/config_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/read_config.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/default_store.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_enum.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/vacm.h
-./snmptrapd_auth.lo: ../include/net-snmp/output_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_debug.h
-./snmptrapd_auth.lo: ../include/net-snmp/snmpv3_api.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpv3.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/transform_oids.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/keytools.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/scapi.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/lcd_time.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmp_secmod.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./snmptrapd_auth.lo: ../include/net-snmp/library/snmpusm.h
-./snmptrapd_auth.lo: snmptrapd_handlers.h snmptrapd_auth.h snmptrapd_ds.h
-./snmptrapd_auth.lo: ../agent/mibgroup/mibII/vacm_conf.h
-./snmptrapd_auth.lo: ../include/net-snmp/agent/agent_trap.h
 ./snmptrapd_handlers.lo: ../include/net-snmp/net-snmp-config.h
 ./snmptrapd_handlers.lo: ../include/net-snmp/system/linux.h
 ./snmptrapd_handlers.lo: ../include/net-snmp/system/sysv.h
@@ -1422,6 +1420,73 @@
 ./snmpnetstat/if.lo: ../include/net-snmp/library/snmpusm.h
 ./snmpnetstat/if.lo:  ./snmpnetstat/main.h
 ./snmpnetstat/if.lo: ./snmpnetstat/netstat.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/net-snmp-config.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/system/linux.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/system/sysv.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/system/generic.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/machine/generic.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/net-snmp-includes.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/definitions.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/types.h 
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/asn1.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/utilities.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_client.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/system.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/tools.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/int64.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/mt_support.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_alarm.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/callback.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/data_list.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/oid_stash.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/check_varbind.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/container.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/factory.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_binary_array.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_list_ssll.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_iterator.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/container.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_assert.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/version.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/session_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_service.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpCallbackDomain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/ucd_compat.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/pdu_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/mib_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/mib.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/parse.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/varbind_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/config_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/read_config.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/default_store.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/vacm.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/output_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/snmpv3_api.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpv3.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/transform_oids.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/keytools.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/scapi.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/lcd_time.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_secmod.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpv3-security-includes.h
+./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpusm.h
+./snmpnetstat/inet6.lo: ./snmpnetstat/main.h ./snmpnetstat/netstat.h
 ./snmpnetstat/inet.lo: ../include/net-snmp/net-snmp-config.h
 ./snmpnetstat/inet.lo: ../include/net-snmp/system/linux.h
 ./snmpnetstat/inet.lo: ../include/net-snmp/system/sysv.h
@@ -1489,73 +1554,6 @@
 ./snmpnetstat/inet.lo: ../include/net-snmp/library/snmpv3-security-includes.h
 ./snmpnetstat/inet.lo: ../include/net-snmp/library/snmpusm.h
 ./snmpnetstat/inet.lo: ./snmpnetstat/main.h ./snmpnetstat/netstat.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/net-snmp-config.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/system/linux.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/system/sysv.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/system/generic.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/machine/generic.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/net-snmp-includes.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/definitions.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/types.h 
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/asn1.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/utilities.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_client.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/system.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/tools.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/int64.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/mt_support.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/callback.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/data_list.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/oid_stash.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/check_varbind.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/container.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/factory.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_binary_array.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/container_iterator.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/container.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_assert.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/version.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/session_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_service.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/ucd_compat.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/pdu_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/mib_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/mib.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/parse.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/varbind_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/config_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/read_config.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/default_store.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/vacm.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/output_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/snmpv3_api.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpv3.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/transform_oids.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/keytools.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/scapi.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/lcd_time.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmp_secmod.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./snmpnetstat/inet6.lo: ../include/net-snmp/library/snmpusm.h
-./snmpnetstat/inet6.lo: ./snmpnetstat/main.h ./snmpnetstat/netstat.h
 ./snmpnetstat/main.lo: ../include/net-snmp/net-snmp-config.h
 ./snmpnetstat/main.lo: ../include/net-snmp/system/linux.h
 ./snmpnetstat/main.lo: ../include/net-snmp/system/sysv.h

=== modified file 'apps/encode_keychange.c'
--- apps/encode_keychange.c	2007-12-08 14:59:50 +0000
+++ apps/encode_keychange.c	2010-06-10 18:02:54 +0000
@@ -478,7 +478,7 @@
     char            path[SNMP_MAXBUF], buf[SNMP_MAXBUF], *s = NULL;
 
     struct stat     statbuf;
-    FILE           *fp;
+    FILE           *fp = NULL;
 
 
 
@@ -624,6 +624,9 @@
         SNMP_FREE(nbuf);
     }
 
+    if (fp)
+        fclose (fp);
+        
     return rval;
 
 }                               /* end get_user_passphrases() */

=== modified file 'apps/snmpnetstat/Makefile.depend'
--- apps/snmpnetstat/Makefile.depend	2009-11-12 16:17:40 +0000
+++ apps/snmpnetstat/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -6,8 +6,9 @@
 ./if.lo: ../../include/net-snmp/system/generic.h
 ./if.lo: ../../include/net-snmp/machine/generic.h
 ./if.lo: ../../include/net-snmp/net-snmp-includes.h 
-./if.lo: ../../include/net-snmp/definitions.h ../../include/net-snmp/types.h
-./if.lo:  ../../include/net-snmp/library/snmp_api.h
+./if.lo:  ../../include/net-snmp/definitions.h
+./if.lo: ../../include/net-snmp/types.h 
+./if.lo: ../../include/net-snmp/library/snmp_api.h
 ./if.lo: ../../include/net-snmp/library/asn1.h
 ./if.lo: ../../include/net-snmp/library/snmp_impl.h
 ./if.lo: ../../include/net-snmp/library/snmp.h
@@ -64,14 +65,80 @@
 ./if.lo: ../../include/net-snmp/library/snmp_secmod.h
 ./if.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
 ./if.lo: ../../include/net-snmp/library/snmpusm.h 
-./if.lo:  main.h netstat.h
+./if.lo:   main.h
+./if.lo: netstat.h
+./inet6.lo: ../../include/net-snmp/net-snmp-config.h
+./inet6.lo: ../../include/net-snmp/system/linux.h
+./inet6.lo: ../../include/net-snmp/system/sysv.h
+./inet6.lo: ../../include/net-snmp/system/generic.h
+./inet6.lo: ../../include/net-snmp/machine/generic.h 
+./inet6.lo: ../../include/net-snmp/net-snmp-includes.h 
+./inet6.lo: ../../include/net-snmp/definitions.h
+./inet6.lo: ../../include/net-snmp/types.h 
+./inet6.lo: ../../include/net-snmp/library/snmp_api.h
+./inet6.lo: ../../include/net-snmp/library/asn1.h
+./inet6.lo: ../../include/net-snmp/library/snmp_impl.h
+./inet6.lo: ../../include/net-snmp/library/snmp.h
+./inet6.lo: ../../include/net-snmp/library/snmp-tc.h
+./inet6.lo: ../../include/net-snmp/utilities.h
+./inet6.lo: ../../include/net-snmp/library/snmp_client.h
+./inet6.lo: ../../include/net-snmp/library/system.h
+./inet6.lo: ../../include/net-snmp/library/tools.h
+./inet6.lo: ../../include/net-snmp/library/int64.h
+./inet6.lo: ../../include/net-snmp/library/mt_support.h
+./inet6.lo: ../../include/net-snmp/library/snmp_alarm.h
+./inet6.lo: ../../include/net-snmp/library/callback.h
+./inet6.lo: ../../include/net-snmp/library/data_list.h
+./inet6.lo: ../../include/net-snmp/library/oid_stash.h
+./inet6.lo: ../../include/net-snmp/library/check_varbind.h
+./inet6.lo: ../../include/net-snmp/library/container.h
+./inet6.lo: ../../include/net-snmp/library/factory.h
+./inet6.lo: ../../include/net-snmp/library/snmp_logging.h
+./inet6.lo: ../../include/net-snmp/library/container_binary_array.h
+./inet6.lo: ../../include/net-snmp/library/container_list_ssll.h
+./inet6.lo: ../../include/net-snmp/library/container_iterator.h
+./inet6.lo: ../../include/net-snmp/library/container.h
+./inet6.lo: ../../include/net-snmp/library/snmp_assert.h
+./inet6.lo: ../../include/net-snmp/version.h
+./inet6.lo: ../../include/net-snmp/session_api.h
+./inet6.lo: ../../include/net-snmp/library/snmp_transport.h
+./inet6.lo: ../../include/net-snmp/library/snmp_service.h
+./inet6.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
+./inet6.lo: ../../include/net-snmp/library/snmpUnixDomain.h
+./inet6.lo: ../../include/net-snmp/library/snmpUDPDomain.h
+./inet6.lo: ../../include/net-snmp/library/snmpTCPDomain.h
+./inet6.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
+./inet6.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
+./inet6.lo: ../../include/net-snmp/library/snmpIPXDomain.h
+./inet6.lo: ../../include/net-snmp/library/ucd_compat.h
+./inet6.lo: ../../include/net-snmp/pdu_api.h ../../include/net-snmp/mib_api.h
+./inet6.lo: ../../include/net-snmp/library/mib.h
+./inet6.lo: ../../include/net-snmp/library/parse.h
+./inet6.lo: ../../include/net-snmp/varbind_api.h
+./inet6.lo: ../../include/net-snmp/config_api.h
+./inet6.lo: ../../include/net-snmp/library/read_config.h
+./inet6.lo: ../../include/net-snmp/library/default_store.h
+./inet6.lo: ../../include/net-snmp/library/snmp_parse_args.h
+./inet6.lo: ../../include/net-snmp/library/snmp_enum.h
+./inet6.lo: ../../include/net-snmp/library/vacm.h
+./inet6.lo: ../../include/net-snmp/output_api.h
+./inet6.lo: ../../include/net-snmp/library/snmp_debug.h
+./inet6.lo: ../../include/net-snmp/snmpv3_api.h
+./inet6.lo: ../../include/net-snmp/library/snmpv3.h
+./inet6.lo: ../../include/net-snmp/library/transform_oids.h
+./inet6.lo: ../../include/net-snmp/library/keytools.h
+./inet6.lo: ../../include/net-snmp/library/scapi.h
+./inet6.lo: ../../include/net-snmp/library/lcd_time.h
+./inet6.lo: ../../include/net-snmp/library/snmp_secmod.h
+./inet6.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
+./inet6.lo: ../../include/net-snmp/library/snmpusm.h main.h netstat.h
 ./inet.lo: ../../include/net-snmp/net-snmp-config.h
 ./inet.lo: ../../include/net-snmp/system/linux.h
 ./inet.lo: ../../include/net-snmp/system/sysv.h
 ./inet.lo: ../../include/net-snmp/system/generic.h
 ./inet.lo: ../../include/net-snmp/machine/generic.h 
 ./inet.lo: ../../include/net-snmp/net-snmp-includes.h 
-./inet.lo:  ../../include/net-snmp/definitions.h
+./inet.lo: ../../include/net-snmp/definitions.h
 ./inet.lo: ../../include/net-snmp/types.h 
 ./inet.lo: ../../include/net-snmp/library/snmp_api.h
 ./inet.lo: ../../include/net-snmp/library/asn1.h
@@ -130,78 +197,13 @@
 ./inet.lo: ../../include/net-snmp/library/snmp_secmod.h
 ./inet.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
 ./inet.lo: ../../include/net-snmp/library/snmpusm.h main.h netstat.h
-./inet6.lo: ../../include/net-snmp/net-snmp-config.h
-./inet6.lo: ../../include/net-snmp/system/linux.h
-./inet6.lo: ../../include/net-snmp/system/sysv.h
-./inet6.lo: ../../include/net-snmp/system/generic.h
-./inet6.lo: ../../include/net-snmp/machine/generic.h 
-./inet6.lo: ../../include/net-snmp/net-snmp-includes.h 
-./inet6.lo:  ../../include/net-snmp/definitions.h
-./inet6.lo: ../../include/net-snmp/types.h 
-./inet6.lo: ../../include/net-snmp/library/snmp_api.h
-./inet6.lo: ../../include/net-snmp/library/asn1.h
-./inet6.lo: ../../include/net-snmp/library/snmp_impl.h
-./inet6.lo: ../../include/net-snmp/library/snmp.h
-./inet6.lo: ../../include/net-snmp/library/snmp-tc.h
-./inet6.lo: ../../include/net-snmp/utilities.h
-./inet6.lo: ../../include/net-snmp/library/snmp_client.h
-./inet6.lo: ../../include/net-snmp/library/system.h
-./inet6.lo: ../../include/net-snmp/library/tools.h
-./inet6.lo: ../../include/net-snmp/library/int64.h
-./inet6.lo: ../../include/net-snmp/library/mt_support.h
-./inet6.lo: ../../include/net-snmp/library/snmp_alarm.h
-./inet6.lo: ../../include/net-snmp/library/callback.h
-./inet6.lo: ../../include/net-snmp/library/data_list.h
-./inet6.lo: ../../include/net-snmp/library/oid_stash.h
-./inet6.lo: ../../include/net-snmp/library/check_varbind.h
-./inet6.lo: ../../include/net-snmp/library/container.h
-./inet6.lo: ../../include/net-snmp/library/factory.h
-./inet6.lo: ../../include/net-snmp/library/snmp_logging.h
-./inet6.lo: ../../include/net-snmp/library/container_binary_array.h
-./inet6.lo: ../../include/net-snmp/library/container_list_ssll.h
-./inet6.lo: ../../include/net-snmp/library/container_iterator.h
-./inet6.lo: ../../include/net-snmp/library/container.h
-./inet6.lo: ../../include/net-snmp/library/snmp_assert.h
-./inet6.lo: ../../include/net-snmp/version.h
-./inet6.lo: ../../include/net-snmp/session_api.h
-./inet6.lo: ../../include/net-snmp/library/snmp_transport.h
-./inet6.lo: ../../include/net-snmp/library/snmp_service.h
-./inet6.lo: ../../include/net-snmp/library/snmpCallbackDomain.h
-./inet6.lo: ../../include/net-snmp/library/snmpUnixDomain.h
-./inet6.lo: ../../include/net-snmp/library/snmpUDPDomain.h
-./inet6.lo: ../../include/net-snmp/library/snmpTCPDomain.h
-./inet6.lo: ../../include/net-snmp/library/snmpUDPIPv6Domain.h
-./inet6.lo: ../../include/net-snmp/library/snmpTCPIPv6Domain.h
-./inet6.lo: ../../include/net-snmp/library/snmpIPXDomain.h
-./inet6.lo: ../../include/net-snmp/library/ucd_compat.h
-./inet6.lo: ../../include/net-snmp/pdu_api.h ../../include/net-snmp/mib_api.h
-./inet6.lo: ../../include/net-snmp/library/mib.h
-./inet6.lo: ../../include/net-snmp/library/parse.h
-./inet6.lo: ../../include/net-snmp/varbind_api.h
-./inet6.lo: ../../include/net-snmp/config_api.h
-./inet6.lo: ../../include/net-snmp/library/read_config.h
-./inet6.lo: ../../include/net-snmp/library/default_store.h
-./inet6.lo: ../../include/net-snmp/library/snmp_parse_args.h
-./inet6.lo: ../../include/net-snmp/library/snmp_enum.h
-./inet6.lo: ../../include/net-snmp/library/vacm.h
-./inet6.lo: ../../include/net-snmp/output_api.h
-./inet6.lo: ../../include/net-snmp/library/snmp_debug.h
-./inet6.lo: ../../include/net-snmp/snmpv3_api.h
-./inet6.lo: ../../include/net-snmp/library/snmpv3.h
-./inet6.lo: ../../include/net-snmp/library/transform_oids.h
-./inet6.lo: ../../include/net-snmp/library/keytools.h
-./inet6.lo: ../../include/net-snmp/library/scapi.h
-./inet6.lo: ../../include/net-snmp/library/lcd_time.h
-./inet6.lo: ../../include/net-snmp/library/snmp_secmod.h
-./inet6.lo: ../../include/net-snmp/library/snmpv3-security-includes.h
-./inet6.lo: ../../include/net-snmp/library/snmpusm.h main.h netstat.h
 ./main.lo: ../../include/net-snmp/net-snmp-config.h
 ./main.lo: ../../include/net-snmp/system/linux.h
 ./main.lo: ../../include/net-snmp/system/sysv.h
 ./main.lo: ../../include/net-snmp/system/generic.h
 ./main.lo: ../../include/net-snmp/machine/generic.h
 ./main.lo: ../../include/net-snmp/net-snmp-includes.h 
-./main.lo: ../../include/net-snmp/definitions.h
+./main.lo:  ../../include/net-snmp/definitions.h
 ./main.lo: ../../include/net-snmp/types.h 
 ./main.lo: ../../include/net-snmp/library/snmp_api.h
 ./main.lo: ../../include/net-snmp/library/asn1.h
@@ -335,7 +337,7 @@
 ./winstub.lo: ../../include/net-snmp/system/generic.h
 ./winstub.lo: ../../include/net-snmp/machine/generic.h
 ./winstub.lo: ../../include/net-snmp/net-snmp-includes.h 
-./winstub.lo: ../../include/net-snmp/definitions.h
+./winstub.lo:  ../../include/net-snmp/definitions.h
 ./winstub.lo: ../../include/net-snmp/types.h 
 ./winstub.lo: ../../include/net-snmp/library/snmp_api.h
 ./winstub.lo: ../../include/net-snmp/library/asn1.h

=== modified file 'apps/snmpnetstat/inet.c'
--- apps/snmpnetstat/inet.c	2006-11-28 12:29:34 +0000
+++ apps/snmpnetstat/inet.c	2010-06-10 18:02:54 +0000
@@ -158,14 +158,14 @@
         cp[2] = vp->name[ 12 ] & 0xff;
         cp[3] = vp->name[ 13 ] & 0xff;
         localAddr.s_addr = tmpAddr.addr.s_addr;
-        localPort        = ntohs(vp->name[ 14 ]);
+        localPort        = ntohs((u_short)(vp->name[ 14 ]));
         cp = tmpAddr.data;
         cp[0] = vp->name[ 15 ] & 0xff;
         cp[1] = vp->name[ 16 ] & 0xff;
         cp[2] = vp->name[ 17 ] & 0xff;
         cp[3] = vp->name[ 18 ] & 0xff;
         remoteAddr.s_addr = tmpAddr.addr.s_addr;
-        remotePort        = ntohs(vp->name[ 19 ]);
+        remotePort        = ntohs((u_short)(vp->name[ 19 ]));
 
         printf("%-5.5s", name);
         inetprint(&localAddr,  localPort,  name, 1);
@@ -223,7 +223,7 @@
         cp[2] = vp->name[ 12 ] & 0xff;
         cp[3] = vp->name[ 13 ] & 0xff;
         localAddr.s_addr = tmpAddr.addr.s_addr;
-        localPort        = ntohs( vp->name[ 14 ]);
+        localPort        = ntohs( (u_short)(vp->name[ 14 ]));
         inetprint(&localAddr, localPort, name, 1);
         putchar('\n');
     }

=== modified file 'apps/snmpnetstat/route.c'
--- apps/snmpnetstat/route.c	2007-12-08 14:59:50 +0000
+++ apps/snmpnetstat/route.c	2010-06-10 18:02:54 +0000
@@ -68,6 +68,9 @@
 
 #include "main.h"
 #include "netstat.h"
+#if HAVE_WINSOCK_H
+#include "winstub.h"
+#endif
 
 #define SET_MASK 0x01
 #define SET_GWAY 0x02

=== modified file 'apps/snmptable.c'
--- apps/snmptable.c	2007-12-08 14:59:50 +0000
+++ apps/snmptable.c	2010-06-10 18:02:54 +0000
@@ -397,7 +397,7 @@
             printf("\nSNMP table %s, part %d\n\n", table_name, part);
         first_field = last_field;
         dp = data;
-        if (show_index && !no_headers && !column_width) {
+        if (show_index && !no_headers && !column_width && first_pass) {
             width = index_width;
             printf(index_fmt, "index");
         } else
@@ -873,7 +873,7 @@
                                                   NETSNMP_DS_LIB_OID_OUTPUT_FORMAT)) {
                         case NETSNMP_OID_OUTPUT_MODULE:
 			case 0:
-                            name_p = strrchr(buf, ':');
+                            name_p = strchr(buf, ':')+1;
                             break;
                         case NETSNMP_OID_OUTPUT_SUFFIX:
                             name_p = buf;
@@ -890,7 +890,14 @@
 					              NETSNMP_DS_LIB_OID_OUTPUT_FORMAT));
 			    exit(1);
                         }
-                        name_p = strchr(name_p, '.') + 1;
+                        name_p = strchr(name_p, '.');
+                        if ( name_p == NULL ) {
+                            /* The 'strchr' call above failed, i.e. the results
+                             * don't seem to include instance subidentifiers! */
+                            running = 0;
+                            break;
+                        }
+                        name_p++;  /* Move on to the instance identifier */
                     }
                     for (row = 0; row < entries; row++)
                         if (strcmp(name_p, indices[row]) == 0)

=== modified file 'apps/snmptest.c'
--- apps/snmptest.c	2009-11-12 16:17:40 +0000
+++ apps/snmptest.c	2010-06-10 18:02:54 +0000
@@ -456,6 +456,7 @@
                     goto getValue;
                 }
                 memcpy(vp->val.string, buf, strlen(buf) - 1);
+                vp->val.string[sizeof(vp->val.string)-1] = 0;
                 vp->val_len = strlen(buf) - 1;
             } else if (ch == 'x') {
                 size_t          buf_len = 256;

=== modified file 'apps/snmptrapd.c'
--- apps/snmptrapd.c	2009-11-12 16:17:40 +0000
+++ apps/snmptrapd.c	2010-06-10 18:02:54 +0000
@@ -52,7 +52,7 @@
 #include <netinet/in.h>
 #endif
 #include <stdio.h>
-#if HAVE_SYS_TIME_H
+#if !defined(mingw32) && defined(HAVE_SYS_TIME_H)
 # include <sys/time.h>
 # if TIME_WITH_SYS_TIME
 #  include <time.h>
@@ -1076,6 +1076,8 @@
         }
     }
 
+    SOCK_STARTUP;
+
     /*
      * I'm being lazy here, and not checking the
      * return value from these registration calls.
@@ -1293,8 +1295,6 @@
         snmp_log(LOG_WARNING, "-s and -S options are deprecated; use -Ls <facility> instead\n");
     }
     
-    SOCK_STARTUP;
-
     if (listen_ports)
         cp = listen_ports;
     else
@@ -1323,7 +1323,7 @@
                  */
                 snmptrapd_close_sessions(sess_list);
                 netsnmp_transport_free(transport);
-                snmp_log(LOG_ERR, "couldn't open snmp - %m");
+                snmp_log(LOG_ERR, "couldn't open snmp - %s", strerror(errno));
                 SOCK_CLEANUP;
                 exit(1);
             } else {

=== modified file 'apps/snmptrapd_handlers.c'
--- apps/snmptrapd_handlers.c	2007-12-08 14:59:50 +0000
+++ apps/snmptrapd_handlers.c	2010-06-10 18:02:54 +0000
@@ -310,7 +310,7 @@
  * to be applied to *all* incoming traps
  */
 netsnmp_trapd_handler *
-netsnmp_add_global_traphandler(int list, Netsnmp_Trap_Handler handler) {
+netsnmp_add_global_traphandler(int list, Netsnmp_Trap_Handler* handler) {
     netsnmp_trapd_handler *traph;
 
     if ( !handler )
@@ -352,7 +352,7 @@
  * traps with no specific trap handlers of their own.
  */
 netsnmp_trapd_handler *
-netsnmp_add_default_traphandler( Netsnmp_Trap_Handler handler) {
+netsnmp_add_default_traphandler( Netsnmp_Trap_Handler* handler) {
     netsnmp_trapd_handler *traph;
 
     if ( !handler )
@@ -378,7 +378,7 @@
  * Register a new trap-specific traphandler
  */
 netsnmp_trapd_handler *
-netsnmp_add_traphandler(Netsnmp_Trap_Handler handler,
+netsnmp_add_traphandler(Netsnmp_Trap_Handler* handler,
                         oid *trapOid, int trapOidLen ) {
     netsnmp_trapd_handler *traph, *traph2;
 

=== modified file 'apps/snmptrapd_handlers.h'
--- apps/snmptrapd_handlers.h	2007-12-08 14:59:50 +0000
+++ apps/snmptrapd_handlers.h	2010-06-10 18:02:54 +0000
@@ -51,9 +51,9 @@
 #define NETSNMPTRAPD_HANDLER_FINISH  4	/* No further processing */
 
 void snmptrapd_register_configs( void );
-netsnmp_trapd_handler *netsnmp_add_global_traphandler(int list, Netsnmp_Trap_Handler handler);
-netsnmp_trapd_handler *netsnmp_add_default_traphandler(Netsnmp_Trap_Handler handler);
-netsnmp_trapd_handler *netsnmp_add_traphandler(Netsnmp_Trap_Handler handler,
+netsnmp_trapd_handler *netsnmp_add_global_traphandler(int list, Netsnmp_Trap_Handler* handler);
+netsnmp_trapd_handler *netsnmp_add_default_traphandler(Netsnmp_Trap_Handler* handler);
+netsnmp_trapd_handler *netsnmp_add_traphandler(Netsnmp_Trap_Handler* handler,
                         oid *trapOid, int trapOidLen);
 netsnmp_trapd_handler *netsnmp_get_traphandler(oid *trapOid, int trapOidLen);
 

=== modified file 'apps/snmptrapd_log.c'
--- apps/snmptrapd_log.c	2009-11-12 16:17:40 +0000
+++ apps/snmptrapd_log.c	2010-06-10 18:02:54 +0000
@@ -53,7 +53,7 @@
 #endif
 #include <stdio.h>
 #include <ctype.h>
-#if HAVE_SYS_TIME_H
+#if !defined(mingw32) && defined(HAVE_SYS_TIME_H)
 # include <sys/time.h>
 # if TIME_WITH_SYS_TIME
 #  include <time.h>

=== modified file 'configure'
--- configure	2009-11-12 16:17:40 +0000
+++ configure	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 #! /bin/sh
-# From configure.in Revision: 17274 .
+# From configure.in Revision: 18739 .
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.59 for Net-SNMP 5.4.2.1.
+# Generated by GNU Autoconf 2.59 for Net-SNMP 5.4.3.
 #
 # Report bugs to <net-snmp-coders@lists.sourceforge.net>.
 #
@@ -287,7 +287,7 @@
 if test "X${echo_test_string+set}" != Xset; then
 # find a string as large as possible, as long as the shell can cope with it
   for cmd in 'sed 50q "$0"' 'sed 20q "$0"' 'sed 10q "$0"' 'sed 2q "$0"' 'echo test'; do
-    # expected sizes: less than 2Kb, 1Kb, 512 bytes, 16 bytes, ...
+    # expected sizes: less than 2kB, 1kB, 512 bytes, 16 bytes, ...
     if (echo_test_string=`eval $cmd`) 2>/dev/null &&
        echo_test_string=`eval $cmd` &&
        (test "X$echo_test_string" = "X$echo_test_string") 2>/dev/null
@@ -424,8 +424,8 @@
 # Identity of this package.
 PACKAGE_NAME='Net-SNMP'
 PACKAGE_TARNAME='net-snmp'
-PACKAGE_VERSION='5.4.2.1'
-PACKAGE_STRING='Net-SNMP 5.4.2.1'
+PACKAGE_VERSION='5.4.3'
+PACKAGE_STRING='Net-SNMP 5.4.3'
 PACKAGE_BUGREPORT='net-snmp-coders@lists.sourceforge.net'
 
 ac_unique_file="agent/mibgroup/ucd-snmp/extensible.c"
@@ -955,7 +955,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures Net-SNMP 5.4.2.1 to adapt to many kinds of systems.
+\`configure' configures Net-SNMP 5.4.3 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1017,7 +1017,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of Net-SNMP 5.4.2.1:";;
+     short | recursive ) echo "Configuration of Net-SNMP 5.4.3:";;
    esac
   cat <<\_ACEOF
 
@@ -1434,7 +1434,7 @@
 test -n "$ac_init_help" && exit 0
 if $ac_init_version; then
   cat <<\_ACEOF
-Net-SNMP configure 5.4.2.1
+Net-SNMP configure 5.4.3
 generated by GNU Autoconf 2.59
 
 Copyright (C) 2003 Free Software Foundation, Inc.
@@ -1448,7 +1448,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by Net-SNMP $as_me 5.4.2.1, which was
+It was created by Net-SNMP $as_me 5.4.3, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
   $ $0 $@
@@ -25433,7 +25433,7 @@
 transport_lobj_list=`echo " $transport_src_list " | sed 's/\.c/\.lo/g'`
 
 ## win32 platforms require inet_ntop etc.
-if test "x$PARTIALTARGETOS" = "xmingw32" -o "x$PARTIALTARGETOS" = "xmingw32msvc" -o "x$PARTIALTARGETOS" = "xcygwin"; then
+if test "x$PARTIALTARGETOS" = "xmingw32" -o "x$PARTIALTARGETOS" = "xmingw32msvc"; then
   if echo "$transport_def_list" | grep "IPV6" >/dev/null; then
     transport_obj_list="$transport_obj_list inet_ntop.o inet_pton.o"
     transport_lobj_list="$transport_lobj_list inet_ntop.lo inet_pton.lo"
@@ -26054,7 +26054,7 @@
 test_modules="$new_module_list"
 new_module_list=""
 
-# remove modules that were explicity excluded
+# remove modules that were explicitly excluded
 for i in $test_modules
  do
   if echo " $new_with_out_mib_modules " | grep " $i " > /dev/null; then
@@ -26283,7 +26283,7 @@
     done
 
     #---------------------
-    # make sure module wasn't explicity excluded, or already added
+    # make sure module wasn't explicitly excluded, or already added
     #
     if test "x$dblfix" != "x" ; then
 
@@ -26971,9 +26971,9 @@
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
   ac_cv_ETC_MNTTAB="unknown"
-for i in /etc/mnttab /etc/mtab /etc/filesystems
+for i in /etc/mnttab /etc/mtab /etc/filesystems /dev/mnttab
   do
-  if test -f $i; then
+  if test -f $i -o -c $i; then
     ac_cv_ETC_MNTTAB="$i"
     break;
   fi
@@ -30202,6 +30202,76 @@
 
 fi
 
+
+  # rpm 4.6 has incompatible API, turn on the legacy one
+  echo "$as_me:$LINENO: checking whether headerGetEntry is declared" >&5
+echo $ECHO_N "checking whether headerGetEntry is declared... $ECHO_C" >&6
+if test "${ac_cv_have_decl_headerGetEntry+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <rpm/rpmlib.h>
+
+
+int
+main ()
+{
+#ifndef headerGetEntry
+  char *p = (char *) headerGetEntry;
+#endif
+
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
+  (eval $ac_compile) 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } &&
+	 { ac_try='test -z "$ac_c_werror_flag"
+			 || test ! -s conftest.err'
+  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }; } &&
+	 { ac_try='test -s conftest.$ac_objext'
+  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }; }; then
+  ac_cv_have_decl_headerGetEntry=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+ac_cv_have_decl_headerGetEntry=no
+fi
+rm -f conftest.err conftest.$ac_objext conftest.$ac_ext
+fi
+echo "$as_me:$LINENO: result: $ac_cv_have_decl_headerGetEntry" >&5
+echo "${ECHO_T}$ac_cv_have_decl_headerGetEntry" >&6
+if test $ac_cv_have_decl_headerGetEntry = yes; then
+  :
+else
+
+cat >>confdefs.h <<\_ACEOF
+#define _RPM_4_4_COMPAT
+_ACEOF
+
+fi
+
 fi
 
 # libkvm
@@ -38382,7 +38452,7 @@
 
 # Checks for byte order
 if test $cross_compiling = yes; then
-  if test $with_endianness = "big"; then
+  if test x$with_endianness = xbig; then
     cat >>confdefs.h <<\_ACEOF
 #define WORDS_BIGENDIAN 1
 _ACEOF
@@ -49110,12 +49180,12 @@
 
 #
 # In FreeBSD 4.x, the TCP timer constants aren't.  They are defined
-# in terms of `hz', the kernel clock tick.  In this case,
-# we need to have a local variable `hz' in scope and set to a useful
+# in terms of 'hz', the kernel clock tick.  In this case,
+# we need to have a local variable 'hz' in scope and set to a useful
 # value whenever we use one of these constants.
 #
-echo "$as_me:$LINENO: checking whether TCP timers depend on \`hz'" >&5
-echo $ECHO_N "checking whether TCP timers depend on \`hz'... $ECHO_C" >&6
+echo "$as_me:$LINENO: checking whether TCP timers depend on 'hz'" >&5
+echo $ECHO_N "checking whether TCP timers depend on 'hz'... $ECHO_C" >&6
 if test "${ac_cv_TCPTV_NEEDS_HZ+set}" = set; then
   echo $ECHO_N "(cached) $ECHO_C" >&6
 else
@@ -50031,7 +50101,7 @@
 } >&5
 cat >&5 <<_CSEOF
 
-This file was extended by Net-SNMP $as_me 5.4.2.1, which was
+This file was extended by Net-SNMP $as_me 5.4.3, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -50094,7 +50164,7 @@
 
 cat >>$CONFIG_STATUS <<_ACEOF
 ac_cs_version="\\
-Net-SNMP config.status 5.4.2.1
+Net-SNMP config.status 5.4.3
 configured by $0, generated by GNU Autoconf 2.59,
   with options \\"`echo "$ac_configure_args" | sed 's/[\\""\`\$]/\\\\&/g'`\\"
 

=== modified file 'configure.in'
--- configure.in	2009-11-12 16:17:40 +0000
+++ configure.in	2010-06-10 18:02:54 +0000
@@ -10,10 +10,10 @@
 #
 # Process this file with autoconf to produce a configure script.
 #
-AC_INIT([Net-SNMP], [5.4.2.1], [net-snmp-coders@lists.sourceforge.net])
+AC_INIT([Net-SNMP], [5.4.3], [net-snmp-coders@lists.sourceforge.net])
 AC_PREREQ([2.59])
 AC_CONFIG_SRCDIR([agent/mibgroup/ucd-snmp/extensible.c])
-AC_REVISION([$Revision: 17274 $])
+AC_REVISION([$Revision: 18816 $])
 
 AC_CONFIG_HEADER(include/net-snmp/net-snmp-config.h)
 
@@ -1643,7 +1643,7 @@
 transport_lobj_list=`echo " $transport_src_list " | sed 's/\.c/\.lo/g'`
 
 ## win32 platforms require inet_ntop etc.
-if test "x$PARTIALTARGETOS" = "xmingw32" -o "x$PARTIALTARGETOS" = "xmingw32msvc" -o "x$PARTIALTARGETOS" = "xcygwin"; then
+if test "x$PARTIALTARGETOS" = "xmingw32" -o "x$PARTIALTARGETOS" = "xmingw32msvc"; then
   if echo "$transport_def_list" | grep "IPV6" >/dev/null; then
     transport_obj_list="$transport_obj_list inet_ntop.o inet_pton.o"
     transport_lobj_list="$transport_lobj_list inet_ntop.lo inet_pton.lo"
@@ -1886,7 +1886,7 @@
 test_modules="$new_module_list"
 new_module_list=""
 
-# remove modules that were explicity excluded
+# remove modules that were explicitly excluded
 for i in $test_modules
  do
   if echo " $new_with_out_mib_modules " | grep " $i " > /dev/null; then
@@ -2070,7 +2070,7 @@
     done
 
     #---------------------
-    # make sure module wasn't explicity excluded, or already added
+    # make sure module wasn't explicitly excluded, or already added
     #
     if test "x$dblfix" != "x" ; then
       AC_MSG_MODULE_DBG("$i was duplicated -- putting into main")
@@ -2609,9 +2609,9 @@
 
 AC_CACHE_CHECK(for mount table location,ac_cv_ETC_MNTTAB,
 [ac_cv_ETC_MNTTAB="unknown"
-for i in /etc/mnttab /etc/mtab /etc/filesystems
+for i in /etc/mnttab /etc/mtab /etc/filesystems /dev/mnttab
   do
-  if test -f $i; then
+  if test -f $i -o -c $i; then
     ac_cv_ETC_MNTTAB="$i"
     break;
   fi
@@ -2860,8 +2860,15 @@
       CFLAGS="$CFLAGS -I/usr/include/rpm"
     ],,-lrpm $_rpmlibs)
   ])
+
+  # rpm 4.6 has incompatible API, turn on the legacy one
+  AC_CHECK_DECL([headerGetEntry],
+    : ,
+    AC_DEFINE([_RPM_4_4_COMPAT], [], [Define if you have RPM 4.6 or newer to turn on legacy API]),
+    [[#include <rpm/rpmlib.h>]]
+  )
 fi
-  
+
 # libkvm
 AC_CHECK_LIB(kvm, kvm_read, [_libkvm="-lkvm"])
 AC_CHECK_FUNC(kvm_openfiles, AC_DEFINE(HAVE_KVM_OPENFILES, 1, [Define to 1 if you have the `kvm_openfiles' function.]),
@@ -3633,7 +3640,7 @@
 
 # Checks for byte order
 if test $cross_compiling = yes; then
-  if test $with_endianness = "big"; then
+  if test x$with_endianness = xbig; then
     AC_DEFINE(WORDS_BIGENDIAN)
   elif test -z $with_endianness; then
     AC_MSG_ERROR([You are cross-compiling, but you have not specified the target's endianness])
@@ -4551,11 +4558,11 @@
 
 #
 # In FreeBSD 4.x, the TCP timer constants aren't.  They are defined
-# in terms of `hz', the kernel clock tick.  In this case,
-# we need to have a local variable `hz' in scope and set to a useful
+# in terms of 'hz', the kernel clock tick.  In this case,
+# we need to have a local variable 'hz' in scope and set to a useful
 # value whenever we use one of these constants.
 #
-AC_CACHE_CHECK(whether TCP timers depend on \`hz',ac_cv_TCPTV_NEEDS_HZ,
+AC_CACHE_CHECK(whether TCP timers depend on 'hz',ac_cv_TCPTV_NEEDS_HZ,
 [AC_EGREP_CPP(hz,
 [#include <netinet/tcp_timer.h>
 TCPTV_SRTTDFLT

=== modified file 'dist/extractnews' (properties changed: -x to +x)
=== modified file 'dist/find-requires' (properties changed: -x to +x)
--- dist/find-requires	2009-11-12 16:17:40 +0000
+++ dist/find-requires	2010-06-10 18:02:54 +0000
@@ -2,4 +2,4 @@
 # This is rpmbuild helper script used to filter out perl(Tk) and 
 # perl(Term::ReadKey) dependencies.
 
-/usr/lib/rpm/find-requires | grep -v "perl(Tk)\|perl(Term::ReadKey)
+/usr/lib/rpm/find-requires | grep -v "perl(Tk)\|perl(Term::ReadKey)"

=== modified file 'dist/net-snmp.spec'
--- dist/net-snmp.spec	2009-11-12 16:17:40 +0000
+++ dist/net-snmp.spec	2010-06-10 18:02:54 +0000
@@ -3,6 +3,7 @@
 #
 %define netsnmp_embedded_perl 1
 %define netsnmp_perl_modules 1
+%define netsnmp_cflags ""
 
 # ugly RHEL detector
 # SuSE build service defines rhel_version, RHEL itself defines nothing
@@ -36,7 +37,7 @@
 %endif
 Summary: Tools and servers for the SNMP protocol
 Name: net-snmp
-Version: 5.4.2.1
+Version: 5.4.3
 # update release for vendor release. (eg 1.fc6, 1.rh72, 1.ydl3, 1.ydl23)
 Release: 1
 URL: http://www.net-snmp.org/
@@ -64,6 +65,8 @@
 %if 0%{?fedora} >= 9
 Provides: net-snmp-gui
 Obsoletes: net-snmp-gui
+# newer fedoras need following macro to compile with new rpm
+%define netsnmp_cflags "-D_RPM_4_4_COMPAT"
 %else
 BuildRequires: beecrypt-devel
 %endif
@@ -126,7 +129,7 @@
 	%{!?netsnmp_perl_modules: --without-perl-modules} \
 	%{?netsnmp_embedded_perl: --enable-as-needed --enable-embedded-perl} \
 	%{!?netsnmp_embedded_perl: --disable-embedded-perl} \
-	--with-cflags="$RPM_OPT_FLAGS"
+	--with-cflags="$RPM_OPT_FLAGS %{netsnmp_cflags}"
 
 make
 

=== modified file 'doxygen.conf'
--- doxygen.conf	2009-11-12 16:17:40 +0000
+++ doxygen.conf	2010-06-10 18:02:54 +0000
@@ -23,7 +23,7 @@
 # This could be handy for archiving the generated documentation or 
 # if some version control system is used.
 
-PROJECT_NUMBER         = 5.4.2
+PROJECT_NUMBER         = 5.4.3.pre1
 
 # The OUTPUT_DIRECTORY tag is used to specify the (relative or absolute) 
 # base path where the generated documentation will be put. 

=== modified file 'include/net-snmp/agent/agent_handler.h'
--- include/net-snmp/agent/agent_handler.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/agent/agent_handler.h	2010-06-10 18:02:54 +0000
@@ -61,6 +61,7 @@
                                           struct
                                           netsnmp_agent_request_info_s *,
                                           struct netsnmp_request_info_s *);
+        void (*data_free)(void *myvoid); /**< data free hook for myvoid */
 
         struct netsnmp_mib_handler_s *next;
         struct netsnmp_mib_handler_s *prev;
@@ -213,14 +214,13 @@
                                         handler_access_method, oid *reg_oid,
                                         size_t reg_oid_len, int modes);
 
-    NETSNMP_INLINE netsnmp_delegated_cache
+    netsnmp_delegated_cache
         *netsnmp_create_delegated_cache(netsnmp_mib_handler *,
                                         netsnmp_handler_registration *,
                                         netsnmp_agent_request_info *,
                                         netsnmp_request_info *, void *);
-    NETSNMP_INLINE void netsnmp_free_delegated_cache(netsnmp_delegated_cache
-                                                 *dcache);
-    NETSNMP_INLINE netsnmp_delegated_cache
+    void netsnmp_free_delegated_cache(netsnmp_delegated_cache *dcache);
+    netsnmp_delegated_cache
         *netsnmp_handler_check_cache(netsnmp_delegated_cache *dcache);
     void            netsnmp_register_handler_by_name(const char *,
                                                      netsnmp_mib_handler
@@ -228,22 +228,22 @@
 
     void            netsnmp_clear_handler_list(void);
 
-    NETSNMP_INLINE void
+    void
         netsnmp_request_add_list_data(netsnmp_request_info *request,
                                       netsnmp_data_list *node);
 
-    NETSNMP_INLINE int
+    int
         netsnmp_request_remove_list_data(netsnmp_request_info *request,
                                          const char *name);
 
-    NETSNMP_INLINE void    *netsnmp_request_get_list_data(netsnmp_request_info
+    void    *netsnmp_request_get_list_data(netsnmp_request_info
                                                   *request,
                                                   const char *name);
 
-    NETSNMP_INLINE void
+    void
               netsnmp_free_request_data_set(netsnmp_request_info *request);
 
-    NETSNMP_INLINE void
+    void
              netsnmp_free_request_data_sets(netsnmp_request_info *request);
 
     void            netsnmp_handler_free(netsnmp_mib_handler *);

=== modified file 'include/net-snmp/agent/snmp_agent.h'
--- include/net-snmp/agent/snmp_agent.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/agent/snmp_agent.h	2010-06-10 18:02:54 +0000
@@ -204,6 +204,7 @@
      */
 
     void            netsnmp_addrcache_initialise(void);
+    void            netsnmp_addrcache_destroy(void);
     void            netsnmp_addrcache_age(void);
 
 
@@ -282,24 +283,24 @@
                                                 *t);
     void            netsnmp_deregister_agent_nsap(int handle);
 
-    NETSNMP_INLINE void
+    void
         netsnmp_agent_add_list_data(netsnmp_agent_request_info *agent,
                                     netsnmp_data_list *node);
 
-    NETSNMP_INLINE int
+    int
         netsnmp_agent_remove_list_data(netsnmp_agent_request_info *ari,
                                        const char * name);
 
-    NETSNMP_INLINE void *
+    void *
             netsnmp_agent_get_list_data(netsnmp_agent_request_info
                                         *agent, const char *name);
 
-    NETSNMP_INLINE void
+    void
             netsnmp_free_agent_data_set(netsnmp_agent_request_info *agent);
 
-    NETSNMP_INLINE void
+    void
            netsnmp_free_agent_data_sets(netsnmp_agent_request_info *agent);
-    NETSNMP_INLINE void    
+    void
         netsnmp_free_agent_request_info(netsnmp_agent_request_info *ari);
 
 #ifdef __cplusplus

=== modified file 'include/net-snmp/agent/table_data.h'
--- include/net-snmp/agent/table_data.h	2007-05-10 22:20:23 +0000
+++ include/net-snmp/agent/table_data.h	2010-06-10 18:02:54 +0000
@@ -50,7 +50,7 @@
     void               *netsnmp_table_data_delete_row(netsnmp_table_row  *row);
     int                 netsnmp_table_data_add_row(   netsnmp_table_data *table,
                                                       netsnmp_table_row  *row);
-    NETSNMP_INLINE void
+    void
        netsnmp_table_data_replace_row(netsnmp_table_data *table,
                                       netsnmp_table_row *origrow,
                                       netsnmp_table_row *newrow);

=== modified file 'include/net-snmp/agent/table_dataset.h'
--- include/net-snmp/agent/table_dataset.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/agent/table_dataset.h	2010-06-10 18:02:54 +0000
@@ -77,21 +77,21 @@
 
     netsnmp_table_data_set *netsnmp_create_table_data_set(const char *);
     netsnmp_table_row *netsnmp_table_data_set_clone_row( netsnmp_table_row *row);
-    NETSNMP_INLINE void netsnmp_table_dataset_delete_all_data(
+    void netsnmp_table_dataset_delete_all_data(
                             netsnmp_table_data_set_storage *data);
-    NETSNMP_INLINE void netsnmp_table_dataset_delete_row(netsnmp_table_row *row);
+    void netsnmp_table_dataset_delete_row(netsnmp_table_row *row);
 
-    NETSNMP_INLINE void netsnmp_table_dataset_add_row(netsnmp_table_data_set
+    void netsnmp_table_dataset_add_row(netsnmp_table_data_set
                                                   *table,
                                                   netsnmp_table_row *row);
-    NETSNMP_INLINE void    
+    void
         netsnmp_table_dataset_replace_row(netsnmp_table_data_set *table,
                                           netsnmp_table_row *origrow,
                                           netsnmp_table_row *newrow);
-    NETSNMP_INLINE void netsnmp_table_dataset_remove_row(netsnmp_table_data_set
+    void netsnmp_table_dataset_remove_row(netsnmp_table_data_set
                                                      *table,
                                                      netsnmp_table_row *row);
-    NETSNMP_INLINE void    
+    void
         netsnmp_table_dataset_remove_and_delete_row(netsnmp_table_data_set
                                                     *table,
                                                     netsnmp_table_row *row);
@@ -130,7 +130,7 @@
     int netsnmp_register_table_data_set(netsnmp_handler_registration *,
                                         netsnmp_table_data_set *,
                                         netsnmp_table_registration_info *);
-    NETSNMP_INLINE netsnmp_table_data_set
+    netsnmp_table_data_set
         *netsnmp_extract_table_data_set(netsnmp_request_info *request);
     netsnmp_table_data_set_storage
         *netsnmp_extract_table_data_set_column(netsnmp_request_info *,
@@ -174,7 +174,7 @@
  * DataSet API: Index operations
  * ============================ */
 
-    NETSNMP_INLINE void netsnmp_table_dataset_add_index(netsnmp_table_data_set
+    void netsnmp_table_dataset_add_index(netsnmp_table_data_set
                                                     *table, u_char type);
 #if HAVE_STDARG_H
     void netsnmp_table_set_add_indexes(netsnmp_table_data_set *tset, ...);

=== modified file 'include/net-snmp/data_access/arp.h'
--- include/net-snmp/data_access/arp.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/data_access/arp.h	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  * arp data access header
  *
- * $Id: arp.h 15220 2006-09-15 00:48:50Z tanders $
+ * $Id: arp.h 17892 2009-12-09 14:37:16Z jsafranek $
  */
 #ifndef NETSNMP_ACCESS_ARP_H
 #define NETSNMP_ACCESS_ARP_H
@@ -17,8 +17,8 @@
 #   define NETSNMP_ACCESS_ARP_IPADDR_BUF_SIZE 4
 #endif
 
-/** MAC address is 6 - do we want to support anything larger? */
-#define NETSNMP_ACCESS_ARP_PHYSADDR_BUF_SIZE 6
+/** MAC address is 6, InfiniBand uses more, 32 must be enough for near future.*/
+#define NETSNMP_ACCESS_ARP_PHYSADDR_BUF_SIZE 32
 
 /*************************************************************
  * constants for enums for the MIB node
@@ -78,7 +78,7 @@
    u_char    arp_physaddress[NETSNMP_ACCESS_ARP_PHYSADDR_BUF_SIZE];
    u_char    arp_ipaddress[NETSNMP_ACCESS_ARP_IPADDR_BUF_SIZE];
 
-   u_char    arp_physaddress_len;/* phys address len, 6 */
+   u_char    arp_physaddress_len;/* phys address len, max 32 */
    u_char    arp_ipaddress_len;  /* ip address len, 4 | 16 */
    u_char    arp_type;           /* inetNetToMediaType 1-5 */
    u_char    arp_state;          /* inetNetToMediaState 1-7 */

=== modified file 'include/net-snmp/data_access/interface.h'
--- include/net-snmp/data_access/interface.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/data_access/interface.h	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  * interface data access header
  *
- * $Id: interface.h 15205 2006-09-14 17:15:32Z rstory $
+ * $Id: interface.h 18100 2010-02-05 09:48:46Z jsafranek $
  */
 #ifndef NETSNMP_ACCESS_INTERFACE_H
 #define NETSNMP_ACCESS_INTERFACE_H
@@ -71,6 +71,9 @@
 
 #endif                          /* ifOperStatus_ENUMS */
 
+/* nominal speed of network interface - used when the real speed is unknown */
+#define NOMINAL_LINK_SPEED 10000000
+
 /**---------------------------------------------------------------------*/
 /*
  * structure definitions
@@ -176,7 +179,7 @@
 typedef struct _conf_if_list {
     const char     *name;
     int             type;
-    u_long          speed;
+    uint64_t        speed;
     struct _conf_if_list *next;
 } netsnmp_conf_if_list;
 

=== modified file 'include/net-snmp/library/container.h'
--- include/net-snmp/library/container.h	2009-11-12 16:17:40 +0000
+++ include/net-snmp/library/container.h	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
 #define NETSNMP_CONTAINER_H
 
 /*
- * $Id: container.h 16804 2008-02-13 23:37:48Z magfr $
+ * $Id: container.h 17254 2008-10-14 09:37:21Z jsafranek $
  *
  * WARNING: This is a recently created file, and all of it's contents are
  *          subject to change at any time.
@@ -358,7 +358,7 @@
         if(x) {
             int rc = x->insert(x,k);
             if(rc)
-                snmp_log(LOG_ERR,"error on subcontainer '%s' insert (%d)\n",
+                snmp_log(LOG_DEBUG,"error on subcontainer '%s' insert (%d)\n",
                          x->container_name ? x->container_name : "", rc);
             else {
                 rc = CONTAINER_INSERT_HELPER(x->next, k);

=== modified file 'include/net-snmp/library/data_list.h'
--- include/net-snmp/library/data_list.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/library/data_list.h	2010-06-10 18:02:54 +0000
@@ -14,7 +14,7 @@
  * @addtogroup agent
  * @addtogroup library *
  *
- * $Id: data_list.h 9583 2004-02-16 20:46:24Z hardaker $
+ * $Id: data_list.h 18102 2010-02-08 19:47:17Z bvassche $
  *
  * External definitions for functions and variables in netsnmp_data_list.c.
  *
@@ -56,7 +56,7 @@
        Netsnmp_Free_List_Data *data_list_free_ptr;
     } netsnmp_data_list_saveinfo;
 
-    NETSNMP_INLINE netsnmp_data_list * 
+    netsnmp_data_list *
       netsnmp_create_data_list(const char *, void *, Netsnmp_Free_List_Data* );
     void            netsnmp_data_list_add_node(netsnmp_data_list **head,
                                                netsnmp_data_list *node);
@@ -70,7 +70,7 @@
     void            netsnmp_free_all_list_data(netsnmp_data_list *head);        /* multiple */
     int             netsnmp_remove_list_node(netsnmp_data_list **realhead,
                                              const char *name);
-    NETSNMP_INLINE netsnmp_data_list *
+    netsnmp_data_list *
     netsnmp_get_list_node(netsnmp_data_list *head,
                           const char *name);
 

=== modified file 'include/net-snmp/library/file_utils.h'
--- include/net-snmp/library/file_utils.h	2007-05-10 22:20:23 +0000
+++ include/net-snmp/library/file_utils.h	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 #ifndef NETSNMP_FILE_UTILS_H
 #define NETSNMP_FILE_UTILS_H
 
-#ifdef _cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 
@@ -82,7 +82,7 @@
 
     
         
-#ifdef _cplusplus
+#ifdef __cplusplus
 }
 #endif
 

=== modified file 'include/net-snmp/library/snmp_api.h'
--- include/net-snmp/library/snmp_api.h	2009-11-12 16:17:40 +0000
+++ include/net-snmp/library/snmp_api.h	2010-06-10 18:02:54 +0000
@@ -532,7 +532,7 @@
     netsnmp_vardata val;
    /** the length of the value to be copied into buf */
    size_t          val_len;
-   /** 90 percentile < 24. */
+   /** buffer to hold the OID */
    oid             name_loc[MAX_OID_LEN];  
    /** 90 percentile < 40. */
    u_char          buf[40];
@@ -737,6 +737,7 @@
                                        size_t);
     int             netsnmp_oid_tree_equals(const oid *, size_t, const oid *,
                                             size_t);
+    NETSNMP_IMPORT
     int             netsnmp_oid_is_subtree(const oid *, size_t, const oid *,
                                            size_t);
     int             netsnmp_oid_find_prefix(const oid * in_name1, size_t len1,

=== modified file 'include/net-snmp/library/snmp_assert.h'
--- include/net-snmp/library/snmp_assert.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/library/snmp_assert.h	2010-06-10 18:02:54 +0000
@@ -16,7 +16,7 @@
  * define __STRING for systems (*cough* sun *cough*) that don't have it
  */
 #ifndef __STRING
-#  ifdef __STDC__
+#  if defined(__STDC__) || defined(_MSC_VER)
 #    define __STRING(x) #x
 #  else
 #    define __STRING(x) "x"

=== modified file 'include/net-snmp/library/snmp_logging.h'
--- include/net-snmp/library/snmp_logging.h	2007-12-08 14:59:50 +0000
+++ include/net-snmp/library/snmp_logging.h	2010-06-10 18:02:54 +0000
@@ -5,6 +5,7 @@
 extern          "C" {
 #endif
 
+#include <stdio.h>
 #if HAVE_SYSLOG_H
 #include <syslog.h>
 #endif

=== removed file 'include/net-snmp/library/snmplocalsm.h'
--- include/net-snmp/library/snmplocalsm.h	2007-05-10 22:20:23 +0000
+++ include/net-snmp/library/snmplocalsm.h	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-/*
- * Header file for Local Security Model support
- */
-
-#ifndef SNMPLOCALSM_H
-#define SNMPLOCALSM_H
-
-#ifdef __cplusplus
-extern          "C" {
-#endif
-
-    int             localsm_rgenerate_out_msg(struct
-                                          snmp_secmod_outgoing_params *);
-    int             localsm_process_in_msg(struct snmp_secmod_incoming_params
-                                       *);
-    void            init_usm(void);
-
-#ifdef __cplusplus
-}
-#endif
-#endif                          /* SNMPLOCALSM_H */

=== modified file 'include/net-snmp/library/text_utils.h'
--- include/net-snmp/library/text_utils.h	2007-05-10 22:20:23 +0000
+++ include/net-snmp/library/text_utils.h	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 #ifndef NETSNMP_TEXT_UTILS_H
 #define NETSNMP_TEXT_UTILS_H
 
-#ifdef _cplusplus
+#ifdef __cplusplus
 extern "C" {
 #endif
 
@@ -106,7 +106,7 @@
 #define PMLP_TYPE_BOOLEAN                                   4
 
         
-#ifdef _cplusplus
+#ifdef __cplusplus
 }
 #endif
 

=== modified file 'include/net-snmp/library/winservice.h'
--- include/net-snmp/library/winservice.h	2005-11-25 14:17:40 +0000
+++ include/net-snmp/library/winservice.h	2010-06-10 18:02:54 +0000
@@ -77,7 +77,7 @@
   /*
    * To unregister service 
    */
-  int UnregisterService (LPCSTR lpszServiceName, int quiet);
+  int UnregisterService (LPCTSTR lpszServiceName, int quiet);
 
   /*
    * To parse command line for startup option 
@@ -155,7 +155,7 @@
   /*
    * TheadFunction - To spawan as thread - Invokes registered service function 
    */
-  DWORD WINAPI ThreadFunction (LPVOID lpParam);
+  unsigned WINAPI ThreadFunction (LPVOID lpParam);
 
   /*
    * Service STOP function registration with this framewrok

=== modified file 'include/net-snmp/net-snmp-config.h.in'
--- include/net-snmp/net-snmp-config.h.in	2009-11-12 16:17:40 +0000
+++ include/net-snmp/net-snmp-config.h.in	2010-06-10 18:02:54 +0000
@@ -1198,6 +1198,9 @@
 # undef _ALL_SOURCE
 #endif
 
+/* Define if you have RPM 4.6 or newer to turn on legacy API */
+#undef _RPM_4_4_COMPAT
+
 /* Define to empty if `const' does not conform to ANSI C. */
 #undef const
 

=== modified file 'include/net-snmp/system/cygwin.h'
--- include/net-snmp/system/cygwin.h	2006-11-28 12:29:34 +0000
+++ include/net-snmp/system/cygwin.h	2010-06-10 18:02:54 +0000
@@ -11,6 +11,3 @@
 #undef bsdlike
 #undef MBSTAT_SYMBOL
 #undef TOTAL_MEMORY_SYMBOL
-
-#define UDP_ADDRESSES_IN_HOST_ORDER 1
-#define UDP_PORTS_IN_HOST_ORDER 1

=== modified file 'local/mib2c'
--- local/mib2c	2009-11-12 16:17:40 +0000
+++ local/mib2c	2010-06-10 18:02:54 +0000
@@ -2,7 +2,7 @@
 #!/usr/bin/perl -w
 
 #
-# $Id: mib2c 16865 2008-03-24 17:54:20Z dts12 $
+# $Id: mib2c 17684 2009-07-10 07:46:43Z jsafranek $
 #
 # Description: 
 #
@@ -146,7 +146,7 @@
 	       "OBJECTID", "oid",
 	       "COUNTER64", "U64",
 	       "COUNTER", "u_long",
-	       "IPADDR", "u_long",
+	       "IPADDR", "in_addr_t",
 	       "BITS", "char",
 	       "TICKS", "u_long",
 	       "GAUGE", "u_long",

=== modified file 'local/mib2c-conf.d/generic-table-oids.m2c'
--- local/mib2c-conf.d/generic-table-oids.m2c	2007-12-08 14:59:50 +0000
+++ local/mib2c-conf.d/generic-table-oids.m2c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 #############################################################  -*- c -*-
 ## generic include for XXX. Do not use directly.
 ##
-## $Id: generic-table-oids.m2c 12855 2005-09-27 15:56:08Z rstory $
+## $Id: generic-table-oids.m2c 17548 2009-04-23 16:35:18Z hardaker $
 ########################################################################
 @if $m2c_create_fewer_files != 1@
 @eval $hack = "Id"@
@@ -10,7 +10,7 @@
 @open ${name}.h@
 /*
  * Note: this file originally auto-generated by mib2c using
- *  $Id: generic-table-oids.m2c 12855 2005-09-27 15:56:08Z rstory $
+ *  $Id: generic-table-oids.m2c 17548 2009-04-23 16:35:18Z hardaker $
  *
  * $$hack:$
  */
@@ -19,7 +19,7 @@
 @end@ // m2c_create_fewer_files
 ########################################################################
 @if $m2c_mark_boundary == 1@
-/** START header generated by $RCSfile$ $Revision: 12855 $ */
+/** START header generated by $RCSfile$ $Revision: 17548 $ */
 @end@
 ##
 
@@ -30,17 +30,23 @@
     @eval $maxv = 0@
     @eval $gto_flag_req = ""@
     @eval $gto_flag_set = ""@
+	@eval $m2c_tmp_gto = 0@
+
     @foreach $node column@
 #define COLUMN_$node.uc         $node.subid
         @if $node.accessible == 1@
            @if ($node.settable == 1) || ($m2c_table_sparse == 1)@
-@             eval $m2c_tmp_gto = ($node.subid - 1)@
 @             if "x$gto_flag_set" eq "x"@
 @               eval $gto_flag_set = "COLUMN_$node.uc_FLAG"@
 @             else@
 @               eval $gto_flag_set = "$gto_flag_set | COLUMN_$node.uc_FLAG"@
 @             end@
+			  @if $m2c_tmp_gto > 31@
+#define COLUMN_$node.uc_FLAG    (((uint64_t)0x1) << $m2c_tmp_gto)
+			  @else@
 #define COLUMN_$node.uc_FLAG    (0x1 << $m2c_tmp_gto)
+			  @end@
+			  @eval $m2c_tmp_gto = $m2c_tmp_gto + 1@
            @end@
            @if ($m2c_table_row_creation == 1) && ($node.settable == 1) && ("x$node.defval" eq "x")@
               @if "x$gto_flag_req" eq "x"@
@@ -103,5 +109,5 @@
 @end@
 ########################################################################
 @if $m2c_mark_boundary == 1@
-/** END header generated by $RCSfile$ $Revision: 12855 $ */
+/** END header generated by $RCSfile$ $Revision: 17548 $ */
 @end@

=== modified file 'local/mib2c-conf.d/mfd-access-unsorted-external-defines.m2i'
--- local/mib2c-conf.d/mfd-access-unsorted-external-defines.m2i	2007-12-08 14:59:50 +0000
+++ local/mib2c-conf.d/mfd-access-unsorted-external-defines.m2i	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 #############################################################  -*- c -*-
 ## generic include for XXX. Do not use directly.
 ##
-## $Id: mfd-access-unsorted-external-defines.m2i 11972 2005-03-02 19:35:44Z rstory $
+## $Id: mfd-access-unsorted-external-defines.m2i 17717 2009-08-04 21:59:16Z dts12 $
 ########################################################################
 ##
 @eval $mfd_aue_wrap_param = "wrap_ctx"@
@@ -14,7 +14,7 @@
 @eval $mfd_aue_param_cmt = "$mfd_aue_param Pointer to a $mfd_aue_param_type"
 ##
 @if $m2c_mark_boundary == 1@
-/** START code generated by $RCSfile$ $Revision: 11972 $ */
+/** START code generated by $RCSfile$ $Revision: 17717 $ */
 @end@
 ##//####################################################################
 ##//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@ -39,7 +39,7 @@
 /**
  * loop context
  *
- * TODO:
+ * ToDo:
  * define loop context structure
  *
  *  Since the actual loop is in the MFD handler, a loop contex parameter
@@ -358,7 +358,7 @@
     }
 
     /*
-     * TODO:
+     * ToDo:
      * set up loop context
      */
 @if $m2c_include_examples == 1@
@@ -393,7 +393,7 @@
     rowreq_ctx_ref->rowreq_ctx = loop_ctx_ref->loop_ctx->rowreq_ctx;
 
     /*
-     * TODO:
+     * ToDo:
      * set local vars for index from loop_ctx_ref->loop_ctx
      *  this can be done in one of two ways:
      */
@@ -404,7 +404,7 @@
 @   foreach $node index@
 @      include m2c_setup_node.m2i@
         /*
-         * TODO:
+         * ToDo:
          * set rowreq_ctx_ref->rowreq_ctx->tbl_idx->$node
 @      if $m2c_node_needlength == 1@
          *     and rowreq_ctx_ref->tbl_idx->${node}_len
@@ -503,7 +503,7 @@
         return MFD_END_OF_DATA;
 
     /*
-     * TODO:
+     * ToDo:
      * set local vars for index from loop_ctx_ref->loop_ctx
      *  this can be done in one of two ways:
      */
@@ -514,7 +514,7 @@
 @   foreach $node index@
 @      include m2c_setup_node.m2i@
         /*
-         * TODO:
+         * ToDo:
          * set rowreq_ctx_ref->rowreq_ctx->tbl_idx->$node
 @      if $m2c_node_needlength == 1@
          *     and rowreq_ctx_ref->tbl_idx->${node}_len
@@ -604,7 +604,7 @@
     netsnmp_assert(loop_ctx_ref && save_loop_ctx_ref);
 
     /*
-     * TODO:
+     * ToDo:
      * 1) allocate new loop context, unless you can reuse a previous pointer.
      * 2) save information for the position of loop_ctx_ref in save_loop_ctx_ref.
      */
@@ -667,7 +667,7 @@
 @    foreach $node nonindex@
 @      include m2c_setup_node.m2i@
     /*
-     * TODO:
+     * ToDo:
      * set rowreq_ctx_ref->${m2c_data_item}$node
      *     from the loop context
      */
@@ -771,7 +771,7 @@
         ${context}_release_rowreq_ctx(loop_ctx_ref->loop_ctx->rowreq_ctx);
 
     /*
-     * TODO:
+     * ToDo:
      * release resources
      */
 @if $m2c_include_examples == 1@
@@ -881,7 +881,7 @@
 ########################################################################
   Defining context for the loop
   -----------------------------
-    TODO : typedef ${context}_loop_context
+    ToDo : typedef ${context}_loop_context
     WHERE: ${table}_data_access.h
 
     @if $mfd_readme_verbose != 0@
@@ -931,7 +931,7 @@
 ########################################################################
   Initialization
   --------------
-    TODO : Initialization
+    ToDo : Initialization
     FUNC : ${context}_loop_init_data
     WHERE: ${table}_data_access.c
 
@@ -944,7 +944,7 @@
 ########################################################################
   Preparing for the loop
   ----------------------
-    TODO : initialize loop context
+    ToDo : initialize loop context
     FUNC : ${context}_loop_init_context
     WHERE: ${table}_data_access.c
 
@@ -991,7 +991,7 @@
 ########################################################################
   The Loop
   --------
-    TODO : return raw data
+    ToDo : return raw data
     FUNC : ${context}_loop_get_first
     WHERE: ${table}_data_access.c
 
@@ -1041,7 +1041,7 @@
 
     @end@
 
-    TODO : return raw data
+    ToDo : return raw data
     FUNC : ${context}_loop_get_next
     WHERE: ${table}_data_access.c
 
@@ -1085,7 +1085,7 @@
 ########################################################################
   Updating the Index
   ------------------
-    TODO : update index for the raw data
+    ToDo : update index for the raw data
     FUNC : ${context}_indexes_set
     WHERE: ${table}_data_access.c
 
@@ -1101,7 +1101,7 @@
 ########################################################################
   Saving a position in the loop
   -----------------------------
-    TODO : Saving a position in the loop
+    ToDo : Saving a position in the loop
     FUNC : ${context}_loop_save_position
     WHERE: ${table}_data_access.c
 
@@ -1135,7 +1135,7 @@
 ########################################################################
   Returning Data For an Index
   ---------------------------
-    TODO : copy transient raw data to generated structure
+    ToDo : copy transient raw data to generated structure
     FUNC : ${context}_loop_get_data
     WHERE: ${table}_data_access.c
 
@@ -1157,7 +1157,7 @@
 ########################################################################
   Cleaning up after the loop
   --------------------------
-    TODO : release any allocated memory
+    ToDo : release any allocated memory
     FUNC : ${context}_loop_cleanup_context
     WHERE: ${table}_data_access.c
 
@@ -1194,5 +1194,5 @@
 @end@ // m2c_processing_type eq 'r
 ########################################################################
 @if $m2c_mark_boundary == 1@
-/** END code generated by $RCSfile$ $Revision: 11972 $ */
+/** END code generated by $RCSfile$ $Revision: 17717 $ */
 @end@

=== modified file 'local/mib2c.iterate.conf'
--- local/mib2c.iterate.conf	2007-12-08 14:59:50 +0000
+++ local/mib2c.iterate.conf	2010-06-10 18:02:54 +0000
@@ -5,7 +5,7 @@
 @open ${name}.h@
 /*
  * Note: this file originally auto-generated by mib2c using
- *  $Id: mib2c.iterate.conf 15999 2007-03-25 22:32:02Z dts12 $
+ *  $Id: mib2c.iterate.conf 17821 2009-11-11 09:00:00Z dts12 $
  */
 #ifndef $name.uc_H
 #define $name.uc_H
@@ -37,7 +37,7 @@
 @open ${name}.c@
 /*
  * Note: this file originally auto-generated by mib2c using
- *  $Id: mib2c.iterate.conf 15999 2007-03-25 22:32:02Z dts12 $
+ *  $Id: mib2c.iterate.conf 17821 2009-11-11 09:00:00Z dts12 $
  */
 
 #include <net-snmp/net-snmp-config.h>
@@ -220,6 +220,9 @@
     char buf[STRMAX];
 
     fp = fopen( "/data/for/${i}", "r" );
+    if ( !fp ) {
+        return -1;
+    }
     while ( fgets( buf, STRMAX, fp )) {
         this = SNMP_MALLOC_TYPEDEF( struct ${i}_entry );
         /* Unpick 'buf' and populate 'this' */
@@ -228,9 +231,10 @@
         ${i}_head = this;    /* Iterate helper is fine with unordered lists! */
     }
     fclose(fp);
+    return 0;  /* OK */
 }
 
-int
+void
 ${i}_free( netsnmp_cache *cache, void *vmagic ) {
     struct ${i}_entry *this, *that;
 

=== modified file 'local/mib2c.iterate_access.conf'
--- local/mib2c.iterate_access.conf	2007-12-08 14:59:50 +0000
+++ local/mib2c.iterate_access.conf	2010-06-10 18:02:54 +0000
@@ -5,7 +5,7 @@
 @open ${name}.h@
 /*
  * Note: this file originally auto-generated by mib2c using
- *        $Id: mib2c.iterate_access.conf 15179 2006-09-08 15:44:37Z dts12 $
+ *        $Id: mib2c.iterate_access.conf 17483 2009-04-09 08:54:46Z dts12 $
  */
 #ifndef $name.uc_H
 #define $name.uc_H
@@ -39,7 +39,7 @@
 @open ${name}.c@
 /*
  * Note: this file originally auto-generated by mib2c using
- *        $Id: mib2c.iterate_access.conf 15179 2006-09-08 15:44:37Z dts12 $
+ *        $Id: mib2c.iterate_access.conf 17483 2009-04-09 08:54:46Z dts12 $
  */
 
 #include <net-snmp/net-snmp-config.h>
@@ -264,7 +264,7 @@
                     /** create the commit storage info */
                     ci = SNMP_MALLOC_STRUCT(commitInfo);
                     if (!data_context) {
-                        ci->data_context = ${i}_create_data_context(table_info->indexes, COLUMN_$c.uc):
+                        ci->data_context = ${i}_create_data_context(table_info->indexes, table_info->colnum);
                         ci->new_row = 1;
                     } else {
                         ci->data_context = data_context;

=== modified file 'local/mib2c.old-api.conf'
--- local/mib2c.old-api.conf	2007-12-08 14:59:50 +0000
+++ local/mib2c.old-api.conf	2010-06-10 18:02:54 +0000
@@ -5,7 +5,7 @@
 @open ${name}.h@
 /*
  * Note: this file originally auto-generated by mib2c using
- *        $Id: mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
+ *        $Id: mib2c.old-api.conf 17851 2009-11-30 16:46:06Z dts12 $
  */
 #ifndef $name.uc_H
 #define $name.uc_H
@@ -36,7 +36,7 @@
 @open ${name}.c@
 /*
  * Note: this file originally auto-generated by mib2c using
- *        $Id: mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
+ *        $Id: mib2c.old-api.conf 17851 2009-11-30 16:46:06Z dts12 $
  */
 
 #include <net-snmp/net-snmp-config.h>
@@ -59,7 +59,7 @@
  *   for the $name mib section 
  */
 
-struct variable7 ${name}_variables[] = {
+struct variable4 ${name}_variables[] = {
 /*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
 @eval $magic = 0@
 @eval $namelen = length("$name.commaoid")@
@@ -77,16 +77,24 @@
 @end@
 
 @foreach $i table@
- @eval $suffix = substr("$i.commaoid", $namelen + 1)@
+ @eval $magic = 0@
+ @eval $nlen2 = length("$i.commaoid")@
+ @if $nlen2 > $namelen@
+  @eval $suffix = substr("$i.commaoid", $namelen + 1)@
+  @eval $ctmp = ","@
+ @else@
+  @eval $suffix = ""@
+  @eval $ctmp = ""@
+ @end@
  @eval $suffixlen = $i.oidlength - $name.oidlength + 2@
  @foreach $c column@
     @eval $magic = $magic + 1@
 #define $c.uc		$magic
     @if $c.settable@
-{$c.uc,  $c.type,  RWRITE,  var_${i}, $suffixlen,  { $suffix, 1, $c.subid }},
+{$c.uc,  $c.type,  RWRITE,  var_${i}, $suffixlen,  { $suffix $ctmp 1, $c.subid }},
     @end@
     @if !$c.settable@
-{$c.uc,  $c.type,  RONLY,   var_${i}, $suffixlen,  { $suffix, 1, $c.subid }},
+{$c.uc,  $c.type,  RONLY,   var_${i}, $suffixlen,  { $suffix $ctmp 1, $c.subid }},
     @end@
  @end@
 @end@

=== modified file 'local/mib2c.table_data.conf'
--- local/mib2c.table_data.conf	2007-12-08 14:59:50 +0000
+++ local/mib2c.table_data.conf	2010-06-10 18:02:54 +0000
@@ -5,7 +5,7 @@
 @open ${name}.h@
 /*
  * Note: this file originally auto-generated by mib2c using
- *  $Id: mib2c.table_data.conf 15999 2007-03-25 22:32:02Z dts12 $
+ *  $Id: mib2c.table_data.conf 18469 2010-04-07 14:05:38Z dts12 $
  */
 #ifndef $name.uc_H
 #define $name.uc_H
@@ -35,7 +35,7 @@
 @open ${name}.c@
 /*
  * Note: this file originally auto-generated by mib2c using
- *  $Id: mib2c.table_data.conf 15999 2007-03-25 22:32:02Z dts12 $
+ *  $Id: mib2c.table_data.conf 18469 2010-04-07 14:05:38Z dts12 $
  */
 
 #include <net-snmp/net-snmp-config.h>
@@ -54,7 +54,7 @@
 }
 
 @foreach $i table@
-  # Determine the first/last column names
+  ## Determine the first/last column names
   @eval $first_column = "-"@
   @eval $last_column = "-"@
   @foreach $c column@
@@ -104,9 +104,9 @@
 @if "$cache" ne "" @
     cache = netsnmp_cache_create($i.uc_TIMEOUT,
                                   ${i}_load, ${i}_free,
-                                  ${i}_oid, ${i}_oid_len),
+                                  ${i}_oid, ${i}_oid_len);
     cache->magic = (void *)table_data;
-    netsnmp_inject_handler_before( reg, netsnmp_cache_handler_GET(cache), TABLE_DATA_NAME))
+    netsnmp_inject_handler_before( reg, netsnmp_cache_handler_GET(cache), TABLE_TDATA_NAME);
 @end@
 
     /* Initialise the contents of the table here */
@@ -221,6 +221,9 @@
     @end@
 
     fp = fopen( "/data/for/${i}", "r" );
+    if ( !fp ) {
+        return -1;
+    }
     while ( fgets( buf, STRMAX, fp )) {
         /* Unpick 'buf' to extract the index values... */
         this = ${i}_createEntry(table
@@ -236,9 +239,10 @@
         /* ... and then populate 'this' with the column values */
     }
     fclose(fp);
+    return 0;  /* OK */
 }
 
-int
+void
 ${i}_free( netsnmp_cache *cache, void *vmagic ) {
     netsnmp_tdata     *table = (netsnmp_tdata *)vmagic;
     netsnmp_tdata_row *this;

=== modified file 'local/passtest.pl'
--- local/passtest.pl	2007-05-10 22:20:23 +0000
+++ local/passtest.pl	2010-06-10 18:02:54 +0000
@@ -1,36 +1,74 @@
 #!/usr/bin/perl
-$place = ".1.3.6.1.4.1.2021.255";
-$req = $ARGV[1];
+$place = ".1.3.6.1.4.1.8072.2.255";   # NET-SNMP-PASS-MIB::netSnmpPassExamples
+$req = $ARGV[1];                      # Requested OID
 
+#
+#  Process SET requests by simply logging the assigned value
+#      Note that such "assignments" are not persistent,
+#      nor is the syntax or requested value validated
+#  
 if ($ARGV[0] eq "-s") {
-  open LOG,">>/tmp/passtest.log";
+  open  LOG,">>/tmp/passtest.log";
   print LOG "@ARGV\n";
   close LOG;
   exit 0;
 }
 
+#
+#  GETNEXT requests - determine next valid instance
+#
 if ($ARGV[0] eq "-n") {
-  if ($req eq "$place") { $ret = "$place.1";}
-  elsif ($req eq "$place.1") { $ret = "$place.2.1";}
-  elsif ($req eq "$place.2.1") { $ret = "$place.2.2";}
-  elsif ($req eq "$place.2.2") { $ret = "$place.3";}
-  elsif ($req eq "$place.3") { $ret = "$place.4";}
-  elsif ($req eq "$place.4") { $ret = "$place.5";}
-  elsif ($req eq "$place.5") { $ret = "$place.6";}
-  else {exit 0;}
+     if (($req eq  "$place")         ||
+         ($req eq  "$place.0")       ||
+         ($req =~ m/$place\.0\..*/)  ||
+         ($req eq  "$place.1"))       { $ret = "$place.1.0";}       # netSnmpPassString.0
+  elsif (($req =~ m/$place\.1\..*/)  ||
+         ($req eq  "$place.2")       ||
+         ($req eq  "$place.2.0")     ||
+         ($req =~ m/$place\.2\.0\..*/)    ||
+         ($req eq  "$place.2.1")          ||
+         ($req eq  "$place.2.1.0")        ||
+         ($req =~ m/$place\.2\.1\.0\..*/) ||
+         ($req eq  "$place.2.1.1")        ||
+         ($req =~ m/$place\.2\.1\.1\..*/) ||
+         ($req eq  "$place.2.1.2")        ||
+         ($req eq  "$place.2.1.2.0")) { $ret = "$place.2.1.2.1";}   # netSnmpPassInteger.1
+  elsif (($req =~ m/$place\.2\.1\.2\..*/) ||
+         ($req eq  "$place.2.1.3")   ||
+         ($req eq  "$place.2.1.3.0")) { $ret = "$place.2.1.3.1";}   # netSnmpPassOID.1
+  elsif (($req =~ m/$place\.2\..*/)  ||
+         ($req eq  "$place.3"))       { $ret = "$place.3.0";}       # netSnmpPassTimeTicks.0
+  elsif (($req =~ m/$place\.3\..*/)  ||
+         ($req eq  "$place.4"))       { $ret = "$place.4.0";}       # netSnmpPassIpAddress.0
+  elsif (($req =~ m/$place\.4\..*/)  ||
+         ($req eq  "$place.5"))       { $ret = "$place.5.0";}       # netSnmpPassCounter.0
+  elsif (($req =~ m/$place\.5\..*/)  ||
+         ($req eq  "$place.6"))       { $ret = "$place.6.0";}       # netSnmpPassGauge.0
+  else   {exit 0;}
 }
 else {
-  if ($req eq "$place") { exit 0;}
-  else {$ret = $req;}
+#
+#  GET requests - check for valid instance
+#
+  if ( ($req eq "$place.1.0")     ||
+       ($req eq "$place.2.1.2.1") ||
+       ($req eq "$place.2.1.3.1") ||
+       ($req eq "$place.3.0")     ||
+       ($req eq "$place.3.0")     ||
+       ($req eq "$place.3.0")     ||
+       ($req eq "$place.3.0"))     { $ret = $req; }
+  else { exit 0;}
 }
 
+#
+#  "Process" GET* requests - return hard-coded value
+#
 print "$ret\n";
-
-if ($ret eq "$place.1") { print "string\nlife the universe and everything\n"; exit 0;}
-elsif ($ret eq "$place.2.1") { print "integer\n42\n"; exit 0;}
-elsif ($ret eq "$place.2.2") { print "objectid\n.1.3.6.1.4.42.42.42\n"; exit 0;}
-elsif ($ret eq "$place.3") { print "timeticks\n363136200\n"; exit 0;}
-elsif ($ret eq "$place.4") { print "ipaddress\n127.0.0.1\n"; exit 0;}
-elsif ($ret eq "$place.5") { print "counter\n42\n"; exit 0;}
-elsif ($ret eq "$place.6") { print "gauge\n42\n"; exit 0;}
-else { print "string\nack... $ret $req\n"; exit 0; }
+   if ($ret eq "$place.1.0")     { print "string\nLife, the Universe, and Everything\n"; exit 0;}
+elsif ($ret eq "$place.2.1.2.1") { print "integer\n42\n";                                exit 0;}
+elsif ($ret eq "$place.2.1.3.1") { print "objectid\n.1.3.6.1.4.42.42.42\n";              exit 0;}
+elsif ($ret eq "$place.3.0")     { print "timeticks\n363136200\n";                       exit 0;}
+elsif ($ret eq "$place.4.0")     { print "ipaddress\n127.0.0.1\n";                       exit 0;}
+elsif ($ret eq "$place.5.0")     { print "counter\n42\n";                                exit 0;}
+elsif ($ret eq "$place.6.0")     { print "gauge\n42\n";                                  exit 0;}
+else                             { print "string\nack... $ret $req\n";                   exit 0;}  # Should not happen

=== modified file 'local/snmpconf.dir/snmpd-data/monitor'
--- local/snmpconf.dir/snmpd-data/monitor	2004-09-13 12:06:21 +0000
+++ local/snmpconf.dir/snmpd-data/monitor	2010-06-10 18:02:54 +0000
@@ -26,7 +26,7 @@
 info #
 info # PATH:  mount path to the disk in question.
 info # MIN:   Disks with space below this value will have the Mib's errorFlag set.
-info #        Can be a raw byte value or a percentage followed by the %
+info #        Can be a raw integer value (units of kB) or a percentage followed by the %
 info #        symbol.  Default value = 100000.
 info #
 info The results are reported in the dskTable section of the UCD-SNMP-MIB tree
@@ -57,13 +57,13 @@
 info Display a files size statistics.
 info If it grows to be too large, report an error about it.
 info
-info # file /path/to/file [maxsize_in_bytes]
+info # file /path/to/file [maxsize_in_kilobytes]
 info #
 info #   if maxsize is not specified, assume only size reporting is needed.
 info #
 info The results are reported in the fileTable section of the UCD-SNMP-MIB tree
 question 1 Enter the path to the file you wish to monitor
-question 2 Enter the maximum size (in bytes) allowable for $1
+question 2 Enter the maximum size (in kilobytes) allowable for $1
 
 group monitoring_services
 multiple proc Do you want to configure the agents ability to monitor processes?

=== modified file 'local/traptoemail'
--- local/traptoemail	2004-09-13 12:06:21 +0000
+++ local/traptoemail	2010-06-10 18:02:54 +0000
@@ -11,6 +11,7 @@
 
 use Net::SMTP;
 use Getopt::Std;
+use POSIX qw(strftime);
 
 $opts{'s'} = "localhost";
 $opts{'f'} = 'root@' . `hostname`;
@@ -62,6 +63,7 @@
 $message->data();
 $message->datasend("To: " . join(", ",@ARGV) . "\n");
 $message->datasend("From: $opts{f}\n");
+$message->datasend("Date: ".strftime("%a, %e %b %Y %X %z", localtime())."\n");
 $message->datasend("Subject: trap received from $hostname: $values[1]\n");
 $message->datasend("\n");
 $message->datasend("Host: $hostname ($ipaddress)\n");

=== modified file 'man/Makefile.in'
--- man/Makefile.in	2007-12-08 14:59:50 +0000
+++ man/Makefile.in	2010-06-10 18:02:54 +0000
@@ -41,7 +41,7 @@
 	netsnmp_table_data.3 netsnmp_table_dataset.3		       \
 	netsnmp_table_iterator.3 netsnmp_scalar.3       \
 	netsnmp_watcher.3 netsnmp_mode_end_call.3 netsnmp_library.3    \
-	netsnmp_mib_utilities.3 netsnmp_Container_iterator.3	       \
+	netsnmp_mib_utilities.3					       \
 	netsnmp_baby_steps.3 netsnmp_cache_handler.3		       \
 	netsnmp_container.3 netsnmp_iterator_info_s.3 netsnmp_leaf.3   \
 	netsnmp_row_merge.3		       \

=== modified file 'man/mib_api.3.def'
--- man/mib_api.3.def	2009-11-12 16:17:40 +0000
+++ man/mib_api.3.def	2010-06-10 18:02:54 +0000
@@ -283,20 +283,18 @@
 take an object identifier (without an accompanying variable instance)
 and print out the textual representation.
 .PP
-.B print_description
+.BI print_description ,
+.BI fprint_description ,
+.BI snprint_description ,
 and
-.B fprint_description
+.B sprint_realloc_description
 take an object identifier (as for
 .B print_objid
-above) and print out the associated DESCRIPTION clause. The 
+above) and print out a version of the MIB definition for that object,
+together with the full OID. The
 .I width
-argument gives the number of subidentifiers of an OID, e.g., .1.3.6
-is composed of 3 subidentifiers.
+argument controls how the OID is layed out.
 .PP
-Note that there are no corresponding routines
-.B snprint_description
-or
-.BR sprint_realloc_description .
 By default the parser does not save descriptions since they may be
 huge.  In order to be able to print them, you must call
 .BR snmp_set_save_descriptions(1) .

=== removed file 'man/netsnmp_Container_iterator.3'
--- man/netsnmp_Container_iterator.3	2007-12-08 14:59:50 +0000
+++ man/netsnmp_Container_iterator.3	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-.TH "Container_iterator" 3 "24 Nov 2004" "net-snmp" \" -*- nroff -*-
-.ad l
-.nh
-.SH NAME
-Container_iterator \- 
-.SS "Typedefs"
-
-.in +1c
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Loop_Key\fP )(void *iterator_ctx, netsnmp_ref_void *loop_ctx, netsnmp_ref_void *key)"
-.br
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Loop_Data\fP )(void *iterator_ctx, netsnmp_ref_void *loop_ctx, netsnmp_ref_void *data)"
-.br
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Ctx\fP )(void *iterator_ctx, netsnmp_ref_void *loop_ctx)"
-.br
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Ctx_Dup\fP )(void *iterator_ctx, netsnmp_ref_void *loop_ctx, netsnmp_ref_void *dup_ctx, int reuse)"
-.br
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Op\fP )(void *iterator_ctx)"
-.br
-.ti -1c
-.RI "typedef int( \fBNetsnmp_Iterator_Data\fP )(void *iterator_ctx, const void *data)"
-.br
-.in -1c
-.SS "Functions"
-
-.in +1c
-.ti -1c
-.RI "void \fBnetsnmp_container_iterator_init\fP (void)"
-.br
-.ti -1c
-.RI "netsnmp_container * \fBnetsnmp_container_iterator_get\fP (void *iterator_user_ctx, netsnmp_container_compare *compare, Netsnmp_Iterator_Loop_Key *get_first, Netsnmp_Iterator_Loop_Key *get_next, Netsnmp_Iterator_Loop_Data *get_data, Netsnmp_Iterator_Ctx_Dup *save_pos, Netsnmp_Iterator_Ctx *init_loop_ctx, Netsnmp_Iterator_Ctx *cleanup_loop_ctx, Netsnmp_Iterator_Data *free_user_ctx, int sorted)"
-.br
-.ti -1c
-.RI "void \fBnetsnmp_container_iterator_set_data_cb\fP (netsnmp_container *c, Netsnmp_Iterator_Data *insert_data, Netsnmp_Iterator_Data *remove_data, Netsnmp_Iterator_Op *get_size)"
-.br
-.in -1c

=== modified file 'man/netsnmp_agent.3'
--- man/netsnmp_agent.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_agent.3	2010-06-10 18:02:54 +0000
@@ -1,20 +1,20 @@
-.TH "The Net-SNMP agent" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "The Net-SNMP agent" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-The Net-SNMP agent \- The snmp agent responds to SNMP queries from management stations.  
+The Net-SNMP agent \- 
+.PP
+The snmp agent responds to SNMP queries from management stations.  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBNet-SNMP Agent handler and extensibility API\fP"
 .br
-.RI "\fIThe basic theory goes something like this: In the past, with the original mib module api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request). \fP"
 .PP
-.in +1c
 
+.RI "\fIThe basic theory goes something like this: In the past, with the original mib \fBmodule\fP api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request). \fP"
 .ti -1c
 .RI "\fBMaintain a registry of MIB subtrees, together with related information regarding mibmodule, sessions, etc\fP"
 .br
@@ -28,5 +28,6 @@
 .SH "Detailed Description"
 .PP 
 The snmp agent responds to SNMP queries from management stations. 
-.PP
-
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_agent_registry.3'
--- man/netsnmp_agent_registry.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_agent_registry.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "Maintain a registry of MIB subtrees, together with related information regarding mibmodule, sessions, etc" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "Maintain a registry of MIB subtrees, together with related information regarding mibmodule, sessions, etc" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -30,10 +30,10 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fBlookup_cache_s\fP \fBlookup_cache\fP"
+.RI "typedef struct \fBlookup_cache_s\fP \fBlookup_cache\fP"
 .br
 .ti -1c
-.RI "typedef \fBlookup_cache_context_s\fP \fBlookup_cache_context\fP"
+.RI "typedef struct \fBlookup_cache_context_s\fP \fBlookup_cache_context\fP"
 .br
 .in -1c
 .SS "Functions"
@@ -210,16 +210,14 @@
 .RI "int \fBexternal_signal_scheduled\fP [NUM_EXTERNAL_SIGS]"
 .br
 .ti -1c
-.RI "void(*[NUM_EXTERNAL_SIGS]) \fBexternal_signal_handler\fP (int)"
+.RI "void(* \fBexternal_signal_handler\fP [NUM_EXTERNAL_SIGS])(int)"
 .br
 .in -1c
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_acm_check_subtree (\fBnetsnmp_pdu\fP * pdu, oid * name, size_t namelen)"
 .PP
-checks to see if everything within a given subtree is either: in view, not in view, or possibly both. 
-.PP
-If the entire subtree is not-in-view we can use this information to skip calling the sub-handlers entirely. 
+checks to see if everything within a given subtree is either: in view, not in view, or possibly both. If the entire subtree is not-in-view we can use this information to skip calling the sub-handlers entirely. 
 .PP
 \fBReturns:\fP
 .RS 4
@@ -229,15 +227,9 @@
 
 .PP
 Definition at line 1323 of file agent_registry.c.
-.PP
-References view_parameters::check_subtree, view_parameters::errorcode, snmp_pdu::flags, view_parameters::name, view_parameters::namelen, view_parameters::pdu, snmp_call_callbacks(), and snmp_pdu::version.
-.PP
-Referenced by netsnmp_add_varbind_to_cache().
 .SS "int netsnmp_get_lookup_cache_size (void)"
 .PP
-retrieves the current value of the lookup cache size 
-.PP
-\fBReturns:\fP
+retrieves the current value of the lookup cache size \fBReturns:\fP
 .RS 4
 the current lookup cache size 
 .RE
@@ -245,15 +237,9 @@
 
 .PP
 Definition at line 1396 of file agent_registry.c.
-.PP
-References lookup_cache_size.
-.PP
-Referenced by netsnmp_register_mib(), and unregister_mib_context().
 .SS "void netsnmp_set_lookup_cache_size (int newsize)"
 .PP
-set the lookup cache size for optimized agent registration performance. 
-.PP
-\fBParameters:\fP
+set the lookup cache size for optimized agent registration performance. \fBParameters:\fP
 .RS 4
 \fInewsize\fP set to the maximum size of a cache for a given context. Set to 0 to completely disable caching, or to -1 to set to the default cache size (8), or to a number of your chosing. The rough guide is that it should be equal to the maximum number of simultanious managers you expect to talk to the agent (M) times 80% (or so, he says randomly) the average number (N) of varbinds you expect to receive in a given request for a manager. ie, M times N. Bigger does NOT necessarily mean better. Certainly 16 should be an upper limit. 32 is the hard coded limit. 
 .RE
@@ -261,15 +247,9 @@
 
 .PP
 Definition at line 1383 of file agent_registry.c.
-.PP
-References lookup_cache_size, SUBTREE_DEFAULT_CACHE_SIZE, and SUBTREE_MAX_CACHE_SIZE.
-.PP
-Referenced by init_master_agent(), netsnmp_register_mib(), and unregister_mib_context().
 .SS "int unregister_mib_context (oid * name, size_t len, int priority, int range_subid, oid range_ubound, const char * context)"
 .PP
-Unregisters an OID that has an associated context name value. 
-.PP
-Typically used when a module has multiple contexts defined. The parameters priority, range_subid, and range_ubound should be used in conjunction with agentx, see RFC 2741, otherwise these values should always be 0.
+Unregisters an OID that has an associated context name value. Typically used when a \fBmodule\fP has multiple contexts defined. The parameters priority, range_subid, and range_ubound should be used in conjunction with agentx, see RFC 2741, otherwise these values should always be 0.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -293,7 +273,6 @@
 
 .PP
 Definition at line 969 of file agent_registry.c.
-.PP
-References netsnmp_subtree_s::children, netsnmp_get_lookup_cache_size(), netsnmp_oid_equals(), netsnmp_set_lookup_cache_size(), netsnmp_subtree_find(), netsnmp_subtree_find_first(), netsnmp_subtree_free(), netsnmp_subtree_unload(), netsnmp_subtree_s::next, and NULL.
-.PP
-Referenced by netsnmp_register_mib(), netsnmp_unregister_handler(), remove_tree_entry(), and unregister_mib_range().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_agent_trap.3'
--- man/netsnmp_agent_trap.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_agent_trap.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "Trap generation routines for mib modules to use" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "Trap generation routines for mib modules to use" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -80,7 +80,7 @@
 .ti -1c
 .RI "void \fBsend_v2trap\fP (\fBnetsnmp_variable_list\fP *vars)"
 .br
-.RI "\fIUses the supplied list of variable bindings to form an SNMPv2 trap, which is sent to SNMPv2-capable sinks on the configured list. \fP"
+.RI "\fIUses the supplied list of \fBvariable\fP bindings to form an SNMPv2 trap, which is sent to SNMPv2-capable sinks on the configured list. \fP"
 .ti -1c
 .RI "void \fBsend_trap_pdu\fP (\fBnetsnmp_pdu\fP *pdu)"
 .br
@@ -110,10 +110,10 @@
 
 .in +1c
 .ti -1c
-.RI "\fBtrap_sink\fP * \fBsinks\fP = NULL"
+.RI "struct \fBtrap_sink\fP * \fBsinks\fP = NULL"
 .br
 .ti -1c
-.RI "timeval \fBstarttime\fP"
+.RI "struct timeval \fBstarttime\fP"
 .br
 .ti -1c
 .RI "oid \fBobjid_enterprisetrap\fP [] = { NETSNMP_NOTIFICATION_MIB }"
@@ -195,15 +195,9 @@
 Captures responses or the lack there of from INFORMs that were sent 1) a response is received from an INFORM 2) one isn't received and the retries/timeouts have failed. 
 .PP
 Definition at line 850 of file agent_trap.c.
-.PP
-References snmp_increment_statistic().
-.PP
-Referenced by send_trap_to_sess().
 .SS "int netsnmp_send_traps (int trap, int specific, oid * enterprise, int enterprise_length, \fBnetsnmp_variable_list\fP * vars, char * context, int flags)"
 .PP
-This function allows you to make a distinction between generic traps from different classes of equipment. 
-.PP
-For example, you may want to handle a SNMP_TRAP_LINKDOWN trap for a particular device in a different manner to a generic system SNMP_TRAP_LINKDOWN trap.
+This function allows you to make a distinction between generic traps from different classes of equipment. For example, you may want to handle a SNMP_TRAP_LINKDOWN trap for a particular device in a different manner to a generic system SNMP_TRAP_LINKDOWN trap.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -230,7 +224,7 @@
 .br
 \fIenterprise_length\fP is the length of the enterprise oid, use macro, OID_LENGTH, to compute length.
 .br
-\fIvars\fP is used to supply list of variable bindings to form an SNMPv2 trap.
+\fIvars\fP is used to supply list of \fBvariable\fP bindings to form an SNMPv2 trap.
 .br
 \fIcontext\fP currently unused
 .br
@@ -252,15 +246,9 @@
 
 .PP
 Definition at line 629 of file agent_trap.c.
-.PP
-References snmp_pdu::agent_addr, convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), snmp_pdu::enterprise, snmp_pdu::enterprise_length, find_varbind_in_list(), snmp_pdu::flags, variable_list::name, variable_list::name_length, netsnmp_get_agent_uptime(), trap_sink::next, variable_list::next_variable, NULL, netsnmp_vardata::objid, trap_sink::pdutype, send_trap_to_sess(), trap_sink::sesp, sinks, SNMP_AUTHENTICATED_TRAPS_DISABLED, snmp_clone_mem(), snmp_clone_varbind(), snmp_enableauthentraps, snmp_free_pdu(), snmp_free_varbind(), snmp_log(), snmp_oid_compare(), snmp_pdu_create(), snmp_varlist_add_variable(), snmptrap_oid, snmptrap_oid_len, snmptrapenterprise_oid, snmptrapenterprise_oid_len, snmp_pdu::specific_type, sysuptime_oid, sysuptime_oid_len, snmp_pdu::time, trap_prefix, snmp_pdu::trap_type, variable_list::val, snmp_pdu::variables, and trap_sink::version.
-.PP
-Referenced by send_enterprise_trap_vars().
 .SS "void send_easy_trap (int trap, int specific)"
 .PP
-Sends an SNMPv1 trap (or the SNMPv2 equivalent) to the list of configured trap destinations (or 'sinks'), using the provided values for the generic trap type and specific trap value. 
-.PP
-This function eventually calls send_enterprise_trap_vars. If the trap type is not set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length paramater is set to the pre defined NETSNMP_SYSTEM_MIB oid and length respectively. If the trap type is set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length parameters are set to the pre-defined NETSNMP_NOTIFICATION_MIB oid and length respectively.
+Sends an SNMPv1 trap (or the SNMPv2 equivalent) to the list of configured trap destinations (or 'sinks'), using the provided values for the generic trap type and specific trap value. This function eventually calls send_enterprise_trap_vars. If the trap type is not set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length paramater is set to the pre defined NETSNMP_SYSTEM_MIB oid and length respectively. If the trap type is set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length parameters are set to the pre-defined NETSNMP_NOTIFICATION_MIB oid and length respectively.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -276,7 +264,7 @@
 .PP
 \fBSee also:\fP
 .RS 4
-\fBsend_enterprise_trap_vars\fP 
+send_enterprise_trap_vars 
 .PP
 \fBsend_v2trap\fP 
 .RE
@@ -284,21 +272,15 @@
 
 .PP
 Definition at line 978 of file agent_trap.c.
-.PP
-References NULL, and send_trap_vars().
-.PP
-Referenced by handle_snmp_packet().
 .SS "void send_v2trap (\fBnetsnmp_variable_list\fP * vars)"
 .PP
-Uses the supplied list of variable bindings to form an SNMPv2 trap, which is sent to SNMPv2-capable sinks on the configured list. 
-.PP
-An equivalent INFORM is sent to the configured list of inform sinks. Sinks that can only handle SNMPv1 traps are skipped.
+Uses the supplied list of \fBvariable\fP bindings to form an SNMPv2 trap, which is sent to SNMPv2-capable sinks on the configured list. An equivalent INFORM is sent to the configured list of inform sinks. Sinks that can only handle SNMPv1 traps are skipped.
 .PP
 This function eventually calls send_enterprise_trap_vars. If the trap type is not set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length paramater is set to the pre defined NETSNMP_SYSTEM_MIB oid and length respectively. If the trap type is set to SNMP_TRAP_ENTERPRISESPECIFIC the enterprise and enterprise_length parameters are set to the pre-defined NETSNMP_NOTIFICATION_MIB oid and length respectively.
 .PP
 \fBParameters:\fP
 .RS 4
-\fIvars\fP is used to supply list of variable bindings to form an SNMPv2 trap.
+\fIvars\fP is used to supply list of \fBvariable\fP bindings to form an SNMPv2 trap.
 .RE
 .PP
 \fBReturns:\fP
@@ -310,7 +292,7 @@
 .RS 4
 \fBsend_easy_trap\fP 
 .PP
-\fBsend_enterprise_trap_vars\fP 
+send_enterprise_trap_vars 
 .RE
 .PP
 
@@ -320,13 +302,9 @@
 \fBnotification.c\fP.
 .PP
 Definition at line 1007 of file agent_trap.c.
-.PP
-References send_trap_vars().
 .SH "Variable Documentation"
 .PP 
-.SS "oid \fBsnmptrapenterprise_oid\fP[]"
-.PP
-\fBInitial value:\fP
+.SS "oid snmptrapenterprise_oid[]"\fBInitial value:\fP
 .PP
 .nf
 
@@ -334,5 +312,6 @@
 .fi
 .PP
 Definition at line 99 of file agent_trap.c.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), init_traps(), and netsnmp_send_traps().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_asn1_packet_parse.3'
--- man/netsnmp_asn1_packet_parse.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_asn1_packet_parse.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "asn1 parsing and datatype manipulation routines." 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "asn1 parsing and datatype manipulation routines." 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-asn1 parsing and datatype manipulation routines. \- Note on.  
+asn1 parsing and datatype manipulation routines. \- 
+.PP
+Note on.  
 
-.PP
 .SS "Defines"
 
 .in +1c
@@ -93,11 +94,41 @@
 .ti -1c
 .RI "int \fBasn_realloc\fP (u_char **pkt, size_t *pkt_len)"
 .br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_length\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, size_t length)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_header\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, size_t length)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_int\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const long *intp, size_t intsize)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_string\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const u_char *str, size_t strlength)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_unsigned_int\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const u_long *intp, size_t intsize)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_sequence\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, size_t length)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_objid\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const oid *objid, size_t objidlength)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_null\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_bitstring\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const u_char *str, size_t strlength)"
+.br
+.ti -1c
+.RI "int \fBasn_realloc_rbuild_unsigned_int64\fP (u_char **pkt, size_t *pkt_len, size_t *offset, int r, u_char type, const struct \fBcounter64\fP *cp, size_t countersize)"
+.br
 .in -1c
 .SH "Detailed Description"
 .PP 
 Note on. 
-.PP
+
 Re-allocating reverse ASN.1 encoder functions. Synopsis:
 .PP
 .PP
@@ -200,9 +231,7 @@
  
 .SH "Define Documentation"
 .PP 
-.SS "#define CHECK_OVERFLOW_S(x, y)"
-.PP
-\fBValue:\fP
+.SS "#define CHECK_OVERFLOW_S(x, y)"\fBValue:\fP
 .PP
 .nf
 do { int trunc = 0;                     \
@@ -219,11 +248,7 @@
 .fi
 .PP
 Definition at line 214 of file asn1.c.
-.PP
-Referenced by asn_build_int(), and asn_parse_int().
-.SS "#define CHECK_OVERFLOW_U(x, y)"
-.PP
-\fBValue:\fP
+.SS "#define CHECK_OVERFLOW_U(x, y)"\fBValue:\fP
 .PP
 .nf
 do {                                    \
@@ -235,5 +260,6 @@
 .fi
 .PP
 Definition at line 226 of file asn1.c.
-.PP
-Referenced by asn_build_objid(), asn_build_unsigned_int(), asn_build_unsigned_int64(), asn_parse_unsigned_int(), and asn_parse_unsigned_int64().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_baby_steps.3'
--- man/netsnmp_baby_steps.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_baby_steps.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "baby_steps" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "baby_steps" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-baby_steps \- Calls your handler in baby_steps for set processing.  
+baby_steps \- 
+.PP
+Calls your handler in baby_steps for set processing.  
 
-.PP
 .SS "Modules"
 
 .in +1c
@@ -27,7 +28,6 @@
 .SH "Detailed Description"
 .PP 
 Calls your handler in baby_steps for set processing. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_baby_steps_handler_get (u_long modes)"
@@ -35,14 +35,11 @@
 returns a baby_steps handler that can be injected into a given handler chain. 
 .PP
 Definition at line 58 of file baby_steps.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_handler_free(), NULL, netsnmp_baby_steps_modes_s::registered, snmp_log(), and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_baby_steps_handler_init().
 .SS "void netsnmp_baby_steps_handler_init (void)"
 .PP
 initializes the baby_steps helper which then registers a baby_steps handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 319 of file baby_steps.c.
-.PP
-References netsnmp_baby_steps_handler_get(), and netsnmp_register_handler_by_name().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_bulk_to_next.3'
--- man/netsnmp_bulk_to_next.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_bulk_to_next.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "bulk_to_next" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "bulk_to_next" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-bulk_to_next \- Convert GETBULK requests into GETNEXT requests for the handler.  
+bulk_to_next \- 
+.PP
+Convert GETBULK requests into GETNEXT requests for the handler.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -27,7 +28,7 @@
 .SH "Detailed Description"
 .PP 
 Convert GETBULK requests into GETNEXT requests for the handler. 
-.PP
+
 The only purpose of this handler is to convert a GETBULK request to a GETNEXT request. It is inserted into handler chains where the handler has not set the HANDLER_CAN_GETBULK flag. 
 .SH "Function Documentation"
 .PP 
@@ -36,23 +37,16 @@
 takes answered requests and decrements the repeat count and updates the requests to the next to-do varbind in the list 
 .PP
 Definition at line 42 of file bulk_to_next.c.
-.PP
-References netsnmp_request_info_s::inclusive, variable_list::name, variable_list::name_length, netsnmp_request_info_s::next, variable_list::next_variable, netsnmp_request_info_s::range_end, netsnmp_request_info_s::range_end_len, netsnmp_request_info_s::repeat, netsnmp_request_info_s::requestvb, snmp_oid_compare(), snmp_set_var_objid(), and variable_list::type.
-.PP
-Referenced by netsnmp_bulk_to_next_helper().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_bulk_to_next_handler (void)"
 .PP
 returns a bulk_to_next handler that can be injected into a given handler chain. 
 .PP
 Definition at line 27 of file bulk_to_next.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_bulk_to_next_helper(), netsnmp_create_handler(), and NULL.
-.PP
-Referenced by netsnmp_init_bulk_to_next_helper(), and netsnmp_register_handler().
 .SS "void netsnmp_init_bulk_to_next_helper (void)"
 .PP
 initializes the bulk_to_next helper which then registers a bulk_to_next handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 139 of file bulk_to_next.c.
-.PP
-References netsnmp_get_bulk_to_next_handler(), and netsnmp_register_handler_by_name().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_cache_handler.3'
--- man/netsnmp_cache_handler.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_cache_handler.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "cache_handler" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "cache_handler" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-cache_handler \- Maintains a cache of data for use by lower level handlers.  
+cache_handler \- 
+.PP
+Maintains a cache of data for use by lower level handlers.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -74,7 +75,7 @@
 .ti -1c
 .RI "int \fBnetsnmp_is_cache_valid\fP (\fBnetsnmp_agent_request_info\fP *reqinfo)"
 .br
-.RI "\fIfor backwards compat \fP"
+.RI "\fIIs the cache valid for a given request? for backwards compatability. \fP"
 .ti -1c
 .RI "int \fBnetsnmp_cache_helper_handler\fP (\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
 .br
@@ -87,7 +88,7 @@
 .SH "Detailed Description"
 .PP 
 Maintains a cache of data for use by lower level handlers. 
-.PP
+
 This helper checks to see whether the data has been loaded 'recently' (according to the timeout for that particular cache) and calls the registered 'load_cache' routine if necessary. The lower handlers can then work with this local cached data.
 .PP
 A timeout value of -1 will cause \fBnetsnmp_cache_check_expired()\fP to always return true, and thus the cache will be reloaded for every request.
@@ -126,37 +127,21 @@
 Reload the cache if required. 
 .PP
 Definition at line 385 of file cache_handler.c.
-.PP
-References netsnmp_cache_check_expired(), and netsnmp_cache_s::valid.
-.PP
-Referenced by netsnmp_cache_helper_handler().
 .SS "int netsnmp_cache_check_expired (\fBnetsnmp_cache\fP * cache)"
 .PP
-Check if the cache timeout has passed. 
-.PP
-Sets and return the expired flag. 
+Check if the cache timeout has passed. Sets and return the expired flag. 
 .PP
 Definition at line 370 of file cache_handler.c.
-.PP
-References atime_ready(), netsnmp_cache_s::expired, NULL, netsnmp_cache_s::timeout, netsnmp_cache_s::timestamp, and netsnmp_cache_s::valid.
-.PP
-Referenced by netsnmp_cache_check_and_reload(), and release_cached_resources().
 .SS "\fBnetsnmp_cache\fP* netsnmp_cache_create (int timeout, NetsnmpCacheLoad * load_hook, NetsnmpCacheFree * free_hook, oid * rootoid, int rootoid_len)"
 .PP
 returns a cache 
 .PP
 Definition at line 136 of file cache_handler.c.
-.PP
-References netsnmp_cache_s::enabled, netsnmp_cache_s::free_cache, netsnmp_cache_s::load_cache, netsnmp_ds_get_int(), netsnmp_cache_s::next, NULL, netsnmp_cache_s::prev, netsnmp_cache_s::rootoid, netsnmp_cache_s::rootoid_len, snmp_duplicate_objid(), snmp_log(), SNMP_MALLOC_TYPEDEF, and netsnmp_cache_s::timeout.
-.PP
-Referenced by netsnmp_get_cache_handler(), and netsnmp_get_timed_bare_stash_cache_handler().
 .SS "\fBnetsnmp_cache\fP* netsnmp_cache_find_by_oid (oid * rootoid, int rootoid_len)"
 .PP
 find existing cache 
 .PP
 Definition at line 120 of file cache_handler.c.
-.PP
-References netsnmp_oid_equals(), netsnmp_cache_s::next, NULL, netsnmp_cache_s::rootoid, and netsnmp_cache_s::rootoid_len.
 .SS "\fBnetsnmp_cache\fP* netsnmp_cache_get_head (void)"
 .PP
 get cache head 
@@ -167,17 +152,11 @@
 returns a cache handler that can be injected into a given handler chain. 
 .PP
 Definition at line 247 of file cache_handler.c.
-.PP
-References netsnmp_mib_handler_s::flags, netsnmp_cache_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_mib_handler_s::myvoid, netsnmp_cache_helper_handler(), netsnmp_cache_timer_start(), netsnmp_create_handler(), NULL, and netsnmp_cache_s::valid.
-.PP
-Referenced by netsnmp_cache_handler_register(), netsnmp_get_cache_handler(), and netsnmp_get_timed_bare_stash_cache_handler().
 .SS "int netsnmp_cache_handler_register (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_cache\fP * cache)"
 .PP
 functionally the same as calling \fBnetsnmp_register_handler()\fP but also injects a cache handler at the same time for you. 
 .PP
 Definition at line 295 of file cache_handler.c.
-.PP
-References netsnmp_cache_handler_get(), netsnmp_inject_handler(), netsnmp_register_handler(), and NULL.
 .SS "int netsnmp_cache_helper_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 Implements the cache handler. 
@@ -189,91 +168,58 @@
 next handler called automatically - 'AUTO_NEXT' 
 .PP
 Definition at line 420 of file cache_handler.c.
-.PP
-References netsnmp_cache_s::cache_hint, netsnmp_cache_s::enabled, netsnmp_cache_s::flags, netsnmp_mib_handler_s::flags, netsnmp_cache_s::free_cache, netsnmp_handler_args_s::handler, netsnmp_handler_registration_s::handlerName, netsnmp_cache_s::load_cache, netsnmp_cache_s::magic, MIB_HANDLER_AUTO_NEXT, netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, netsnmp_cache_check_and_reload(), netsnmp_cache_is_valid(), netsnmp_cache_reqinfo_insert(), netsnmp_ds_get_boolean(), netsnmp_request_set_error_all(), NULL, netsnmp_handler_args_s::reginfo, netsnmp_handler_args_s::reqinfo, netsnmp_handler_args_s::requests, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_log(), and netsnmp_cache_s::valid.
-.PP
-Referenced by netsnmp_cache_handler_get().
 .SS "int netsnmp_cache_is_valid (\fBnetsnmp_agent_request_info\fP * reqinfo, const char * name)"
 .PP
 Is the cache valid for a given request? 
 .PP
 Definition at line 402 of file cache_handler.c.
-.PP
-References netsnmp_cache_reqinfo_extract(), and netsnmp_cache_s::valid.
-.PP
-Referenced by netsnmp_cache_helper_handler(), and netsnmp_is_cache_valid().
 .SS "\fBnetsnmp_cache\fP* netsnmp_cache_reqinfo_extract (\fBnetsnmp_agent_request_info\fP * reqinfo, const char * name)"
 .PP
 Extract the cache information for a given request (PDU). 
 .PP
 Definition at line 350 of file cache_handler.c.
-.PP
-References _build_cache_name(), netsnmp_agent_get_list_data(), and SNMP_FREE.
-.PP
-Referenced by netsnmp_cache_is_valid(), netsnmp_extract_cache_info(), and netsnmp_stash_cache_helper().
 .SS "void netsnmp_cache_reqinfo_insert (\fBnetsnmp_cache\fP * cache, \fBnetsnmp_agent_request_info\fP * reqinfo, const char * name)"
 .PP
 Insert the cache information for a given request (PDU). 
 .PP
 Definition at line 333 of file cache_handler.c.
-.PP
-References _build_cache_name(), netsnmp_agent_add_list_data(), netsnmp_agent_get_list_data(), netsnmp_create_data_list(), NULL, and SNMP_FREE.
-.PP
-Referenced by netsnmp_cache_helper_handler().
 .SS "unsigned int netsnmp_cache_timer_start (\fBnetsnmp_cache\fP * cache)"
 .PP
 starts the recurring cache_load callback 
 .PP
 Definition at line 191 of file cache_handler.c.
-.PP
-References netsnmp_cache_s::flags, NULL, netsnmp_cache_s::rootoid, netsnmp_cache_s::rootoid_len, snmp_alarm_register(), snmp_log(), netsnmp_cache_s::timeout, and netsnmp_cache_s::timer_id.
-.PP
-Referenced by netsnmp_cache_handler_get().
 .SS "void netsnmp_cache_timer_stop (\fBnetsnmp_cache\fP * cache)"
 .PP
 stops the recurring cache_load callback 
 .PP
 Definition at line 226 of file cache_handler.c.
-.PP
-References netsnmp_cache_s::flags, NULL, snmp_alarm_unregister(), snmp_log(), and netsnmp_cache_s::timer_id.
 .SS "\fBnetsnmp_cache\fP* netsnmp_extract_cache_info (\fBnetsnmp_agent_request_info\fP * reqinfo)"
 .PP
 Extract the cache information for a given request (PDU). 
 .PP
 Definition at line 362 of file cache_handler.c.
-.PP
-References netsnmp_cache_reqinfo_extract().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_cache_handler (int timeout, NetsnmpCacheLoad * load_hook, NetsnmpCacheFree * free_hook, oid * rootoid, int rootoid_len)"
 .PP
 returns a cache handler that can be injected into a given handler chain. 
 .PP
 Definition at line 276 of file cache_handler.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_cache_create(), netsnmp_cache_handler_get(), and NULL.
-.PP
-Referenced by netsnmp_register_cache_handler().
 .SS "int netsnmp_is_cache_valid (\fBnetsnmp_agent_request_info\fP * reqinfo)"
 .PP
-for backwards compat 
+Is the cache valid for a given request? for backwards compatability. for backwards compat
 .PP
 \fBnetsnmp_cache_is_valid()\fP is preferred. 
 .PP
 Definition at line 413 of file cache_handler.c.
-.PP
-References netsnmp_cache_is_valid().
 .SS "int netsnmp_register_cache_handler (\fBnetsnmp_handler_registration\fP * reginfo, int timeout, NetsnmpCacheLoad * load_hook, NetsnmpCacheFree * free_hook)"
 .PP
 functionally the same as calling \fBnetsnmp_register_handler()\fP but also injects a cache handler at the same time for you. 
 .PP
 Definition at line 308 of file cache_handler.c.
-.PP
-References netsnmp_get_cache_handler(), netsnmp_inject_handler(), netsnmp_register_handler(), NULL, netsnmp_handler_registration_s::rootoid, and netsnmp_handler_registration_s::rootoid_len.
 .SS "void release_cached_resources (unsigned int regNo, void * clientargs)"
 .PP
-run regularly to automatically release cached resources. 
-.PP
-xxx - method to prevent cache from expiring while a request is being processed (e.g. delegated request). proposal: set a flag, which would be cleared when request finished (which could be acomplished by a dummy data list item in agent req info & custom free function). 
+run regularly to automatically release cached resources. xxx - method to prevent cache from expiring while a request is being processed (e.g. delegated request). proposal: set a flag, which would be cleared when request finished (which could be acomplished by a dummy data list item in agent req info & custom free function). 
 .PP
 Definition at line 575 of file cache_handler.c.
-.PP
-References netsnmp_cache_s::flags, netsnmp_cache_check_expired(), netsnmp_cache_s::next, NULL, and netsnmp_cache_s::valid.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_callback.3'
--- man/netsnmp_callback.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_callback.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "A generic callback mechanism" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "A generic callback mechanism" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -63,16 +63,14 @@
 .RI "void \fBclear_callback\fP (void)"
 .br
 .ti -1c
-.RI "\fBsnmp_gen_callback\fP * \fBsnmp_callback_list\fP (int major, int minor)"
+.RI "struct \fBsnmp_gen_callback\fP * \fBsnmp_callback_list\fP (int major, int minor)"
 .br
 .in -1c
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_callback_clear_client_arg (void * ptr, int i, int j)"
 .PP
-find and clear client args that match ptr 
-.PP
-\fBParameters:\fP
+find and clear client args that match ptr \fBParameters:\fP
 .RS 4
 \fIptr\fP pointer to search for 
 .br
@@ -84,15 +82,9 @@
 
 .PP
 Definition at line 474 of file callback.c.
-.PP
-References snmp_gen_callback::next, NULL, snmp_gen_callback::sc_callback, and snmp_gen_callback::sc_client_arg.
-.PP
-Referenced by clear_callback().
 .SS "int snmp_call_callbacks (int major, int minor, void * caller_arg)"
 .PP
-This function calls the callback function for each registered callback of type major and minor. 
-.PP
-\fBParameters:\fP
+This function calls the callback function for each registered callback of type major and minor. \fBParameters:\fP
 .RS 4
 \fImajor\fP is the SNMP callback major type used
 .br
@@ -116,15 +108,9 @@
 
 .PP
 Definition at line 298 of file callback.c.
-.PP
-References _callback_lock(), _callback_unlock(), init_callbacks(), snmp_gen_callback::next, NULL, snmp_gen_callback::sc_callback, and snmp_gen_callback::sc_client_arg.
-.PP
-Referenced by add_trap_session(), check_access(), in_a_view(), log_handler_callback(), netsnmp_acm_check_subtree(), netsnmp_register_mib(), netsnmp_register_mib_table_row(), read_configs(), read_premib_configs(), snmp_shutdown(), snmp_store(), and unregister_mibs_by_session().
 .SS "int snmp_register_callback (int major, int minor, SNMPCallback * new_callback, void * arg)"
 .PP
-This function registers a generic callback function. 
-.PP
-The major and minor values are used to set the new_callback function into a global static multi-dimensional array of type struct \fBsnmp_gen_callback\fP. The function makes sure to append this callback function at the end of the link list, snmp_gen_callback->next.
+This function registers a generic callback function. The major and minor values are used to set the new_callback function into a global static multi-dimensional array of type struct \fBsnmp_gen_callback\fP. The function makes sure to append this callback function at the end of the link list, snmp_gen_callback->next.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -180,15 +166,9 @@
 
 .PP
 Definition at line 230 of file callback.c.
-.PP
-References netsnmp_register_callback().
-.PP
-Referenced by init_snmp_alarm(), netsnmp_init_handler_conf(), and netsnmp_register_save_list().
 .SS "int snmp_unregister_callback (int major, int minor, SNMPCallback * target, void * arg, int matchargs)"
 .PP
-This function unregisters a specified callback function given a major and minor type. 
-.PP
-Note: no bound checking on major and minor.
+This function unregisters a specified callback function given a major and minor type. Note: no bound checking on major and minor.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -198,9 +178,9 @@
 .br
 \fItarget\fP is the callback function that will be unregistered.
 .br
-\fIarg\fP is a void pointer used for comparison against the registered callback's sc_client_arg variable.
+\fIarg\fP is a void pointer used for comparison against the registered callback's sc_client_arg \fBvariable\fP.
 .br
-\fImatchargs\fP is an integer used to bypass the comparison of arg and the callback's sc_client_arg variable only when matchargs is set to 0.
+\fImatchargs\fP is an integer used to bypass the comparison of arg and the callback's sc_client_arg \fBvariable\fP only when matchargs is set to 0.
 .RE
 .PP
 \fBReturns:\fP
@@ -220,5 +200,6 @@
 set cleanup flag? 
 .PP
 Definition at line 418 of file callback.c.
-.PP
-References _callback_lock(), _callback_unlock(), CALLBACK_LOCK_COUNT, init_callbacks(), snmp_gen_callback::next, NULL, snmp_gen_callback::sc_callback, snmp_gen_callback::sc_client_arg, and SNMP_FREE.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_container.3'
--- man/netsnmp_container.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_container.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "container" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "container" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -9,7 +9,10 @@
 .ti -1c
 .RI "\fBnull_container\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement specialized containers. \fP"
-.PP
-
 .in -1c
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_data_list.3'
--- man/netsnmp_data_list.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_data_list.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "generic linked-list data handling with a string as a key." 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "generic linked-list data handling with a string as a key." 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -9,7 +9,7 @@
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_free_list_data\fP (\fBnetsnmp_data_list\fP *\fBnode\fP)"
 .br
-.RI "\fIfrees the data and a name at a given data_list node. \fP"
+.RI "\fIfrees the data and a name at a given data_list \fBnode\fP. \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_free_all_list_data\fP (\fBnetsnmp_data_list\fP *head)"
 .br
@@ -17,11 +17,11 @@
 .ti -1c
 .RI "NETSNMP_INLINE \fBnetsnmp_data_list\fP * \fBnetsnmp_create_data_list\fP (const char *name, void *data, Netsnmp_Free_List_Data *beer)"
 .br
-.RI "\fIadds creates a data_list node given a name, data and a free function ptr. \fP"
+.RI "\fIadds creates a data_list \fBnode\fP given a name, data and a free function ptr. \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_add_list_data\fP (\fBnetsnmp_data_list\fP **head, \fBnetsnmp_data_list\fP *\fBnode\fP)"
 .br
-.RI "\fIdepreciated: use \fBnetsnmp_data_list_add_node()\fP \fP"
+.RI "\fIadds data to a datalist \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_data_list_add_node\fP (\fBnetsnmp_data_list\fP **head, \fBnetsnmp_data_list\fP *\fBnode\fP)"
 .br
@@ -37,11 +37,11 @@
 .ti -1c
 .RI "NETSNMP_INLINE \fBnetsnmp_data_list\fP * \fBnetsnmp_get_list_node\fP (\fBnetsnmp_data_list\fP *head, const char *name)"
 .br
-.RI "\fIreturns a data_list node for a given name within a data_list \fP"
+.RI "\fIreturns a data_list \fBnode\fP for a given name within a data_list \fP"
 .ti -1c
 .RI "int \fBnetsnmp_remove_list_node\fP (\fBnetsnmp_data_list\fP **realhead, const char *name)"
 .br
-.RI "\fIRemoves a named node from a data_list (and frees it). \fP"
+.RI "\fIRemoves a named \fBnode\fP from a data_list (and frees it). \fP"
 .ti -1c
 .RI "void \fBnetsnmp_register_save_list\fP (\fBnetsnmp_data_list\fP **datalist, const char *type, const char *token, Netsnmp_Save_List_Data *data_list_save_ptr, Netsnmp_Read_List_Data *data_list_read_ptr, Netsnmp_Free_List_Data *data_list_free_ptr)"
 .br
@@ -63,20 +63,28 @@
 .PP 
 .SS "NETSNMP_INLINE void netsnmp_add_list_data (\fBnetsnmp_data_list\fP ** head, \fBnetsnmp_data_list\fP * node)"
 .PP
-depreciated: use \fBnetsnmp_data_list_add_node()\fP 
+adds data to a datalist depreciated: use \fBnetsnmp_data_list_add_node()\fP
+.PP
+\fBNote:\fP
+.RS 4
+netsnmp_data_list_add_node is preferred 
+.RE
+.PP
+\fBParameters:\fP
+.RS 4
+\fIhead\fP a pointer to the head \fBnode\fP of a data_list 
+.br
+\fI\fBnode\fP\fP a \fBnode\fP to stash in the data_list 
+.RE
+.PP
+
 .PP
 Definition at line 83 of file data_list.c.
-.PP
-References netsnmp_data_list_add_node().
-.PP
-Referenced by netsnmp_agent_add_list_data(), netsnmp_data_list_add_data(), netsnmp_read_data_callback(), netsnmp_register_auto_data_table(), netsnmp_register_handler_by_name(), netsnmp_register_save_list(), and netsnmp_request_add_list_data().
 .SS "NETSNMP_INLINE \fBnetsnmp_data_list\fP* netsnmp_create_data_list (const char * name, void * data, Netsnmp_Free_List_Data * beer)"
 .PP
-adds creates a data_list node given a name, data and a free function ptr. 
-.PP
-\fBParameters:\fP
+adds creates a data_list \fBnode\fP given a name, data and a free function ptr. \fBParameters:\fP
 .RS 4
-\fIname\fP the name of the node to cache the data. 
+\fIname\fP the name of the \fBnode\fP to cache the data. 
 .br
 \fIdata\fP the data to be stored under that name 
 .br
@@ -85,7 +93,7 @@
 .PP
 \fBReturns:\fP
 .RS 4
-a newly created data_list node which can be given to the netsnmp_add_list_data function. 
+a newly created data_list \fBnode\fP which can be given to the netsnmp_add_list_data function. 
 .RE
 .PP
 
@@ -95,19 +103,13 @@
 \fBdelayed_instance.c\fP.
 .PP
 Definition at line 60 of file data_list.c.
-.PP
-References netsnmp_data_list_s::data, netsnmp_data_list_s::free_func, netsnmp_data_list_s::name, NULL, and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by _netsnmp_stash_cache_load(), _netsnmp_tdata_helper_handler(), netsnmp_cache_reqinfo_insert(), netsnmp_container_table_row_insert(), netsnmp_data_list_add_data(), netsnmp_insert_iterator_context(), netsnmp_insert_table_row(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_read_data_callback(), netsnmp_register_auto_data_table(), netsnmp_register_handler_by_name(), netsnmp_register_save_list(), netsnmp_row_merge_status_get(), netsnmp_table_data_helper_handler(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_watcher_helper_handler(), and table_helper_handler().
 .SS "NETSNMP_INLINE \fBnetsnmp_data_list\fP* netsnmp_data_list_add_data (\fBnetsnmp_data_list\fP ** head, const char * name, void * data, Netsnmp_Free_List_Data * beer)"
 .PP
-adds data to a datalist 
-.PP
-\fBParameters:\fP
+adds data to a datalist \fBParameters:\fP
 .RS 4
-\fIhead\fP a pointer to the head node of a data_list 
+\fIhead\fP a pointer to the head \fBnode\fP of a data_list 
 .br
-\fIname\fP the name of the node to cache the data. 
+\fIname\fP the name of the \fBnode\fP to cache the data. 
 .br
 \fIdata\fP the data to be stored under that name 
 .br
@@ -116,115 +118,83 @@
 .PP
 \fBReturns:\fP
 .RS 4
-a newly created data_list node which was inserted in the list 
+a newly created data_list \fBnode\fP which was inserted in the list 
 .RE
 .PP
 
 .PP
 Definition at line 137 of file data_list.c.
-.PP
-References netsnmp_add_list_data(), netsnmp_create_data_list(), NULL, and snmp_log().
 .SS "NETSNMP_INLINE void netsnmp_data_list_add_node (\fBnetsnmp_data_list\fP ** head, \fBnetsnmp_data_list\fP * node)"
 .PP
-adds data to a datalist 
-.PP
-\fBParameters:\fP
+adds data to a datalist \fBParameters:\fP
 .RS 4
-\fIhead\fP a pointer to the head node of a data_list 
+\fIhead\fP a pointer to the head \fBnode\fP of a data_list 
 .br
-\fInode\fP a node to stash in the data_list 
+\fI\fBnode\fP\fP a \fBnode\fP to stash in the data_list 
 .RE
 .PP
 
 .PP
 Definition at line 93 of file data_list.c.
-.PP
-References netsnmp_data_list_s::name, netsnmp_data_list_s::next, NULL, and snmp_log().
-.PP
-Referenced by netsnmp_add_list_data().
 .SS "NETSNMP_INLINE void netsnmp_free_all_list_data (\fBnetsnmp_data_list\fP * head)"
 .PP
-frees all data and nodes in a list. 
-.PP
-\fBParameters:\fP
+frees all data and nodes in a list. \fBParameters:\fP
 .RS 4
-\fIhead\fP the top node of the list to be freed. 
+\fIhead\fP the top \fBnode\fP of the list to be freed. 
 .RE
 .PP
 
 .PP
 Definition at line 42 of file data_list.c.
-.PP
-References netsnmp_free_list_data(), netsnmp_data_list_s::next, and SNMP_FREE.
-.PP
-Referenced by netsnmp_clear_handler_list(), netsnmp_free_agent_data_sets(), netsnmp_free_agent_request_info(), netsnmp_free_request_data_sets(), and netsnmp_stash_to_next_helper().
 .SS "NETSNMP_INLINE void netsnmp_free_list_data (\fBnetsnmp_data_list\fP * node)"
 .PP
-frees the data and a name at a given data_list node. 
-.PP
-Note that this doesn't free the node itself. 
+frees the data and a name at a given data_list \fBnode\fP. Note that this doesn't free the \fBnode\fP itself. 
 .PP
 \fBParameters:\fP
 .RS 4
-\fInode\fP the node for which the data should be freed 
+\fI\fBnode\fP\fP the \fBnode\fP for which the data should be freed 
 .RE
 .PP
 
 .PP
 Definition at line 26 of file data_list.c.
-.PP
-References netsnmp_data_list_s::data, netsnmp_data_list_s::free_func, netsnmp_data_list_s::name, and SNMP_FREE.
-.PP
-Referenced by netsnmp_free_agent_data_set(), netsnmp_free_all_list_data(), netsnmp_free_request_data_set(), and netsnmp_remove_list_node().
 .SS "NETSNMP_INLINE void* netsnmp_get_list_data (\fBnetsnmp_data_list\fP * head, const char * name)"
 .PP
-returns a data_list node's data for a given name within a data_list 
-.PP
-\fBParameters:\fP
+returns a data_list node's data for a given name within a data_list \fBParameters:\fP
 .RS 4
-\fIhead\fP the head node of a data_list 
+\fIhead\fP the head \fBnode\fP of a data_list 
 .br
 \fIname\fP the name to find 
 .RE
 .PP
 \fBReturns:\fP
 .RS 4
-a pointer to the data cached at that node 
+a pointer to the data cached at that \fBnode\fP 
 .RE
 .PP
 
 .PP
 Definition at line 162 of file data_list.c.
-.PP
-References netsnmp_data_list_s::name, netsnmp_data_list_s::next, and NULL.
-.PP
-Referenced by netsnmp_agent_get_list_data(), netsnmp_config_parse_add_row(), netsnmp_config_parse_table_set(), netsnmp_read_data_callback(), netsnmp_request_get_list_data(), and parse_injectHandler_conf().
 .SS "NETSNMP_INLINE \fBnetsnmp_data_list\fP* netsnmp_get_list_node (\fBnetsnmp_data_list\fP * head, const char * name)"
 .PP
-returns a data_list node for a given name within a data_list 
-.PP
-\fBParameters:\fP
+returns a data_list \fBnode\fP for a given name within a data_list \fBParameters:\fP
 .RS 4
-\fIhead\fP the head node of a data_list 
+\fIhead\fP the head \fBnode\fP of a data_list 
 .br
 \fIname\fP the name to find 
 .RE
 .PP
 \fBReturns:\fP
 .RS 4
-a pointer to the data_list node 
+a pointer to the data_list \fBnode\fP 
 .RE
 .PP
 
 .PP
 Definition at line 180 of file data_list.c.
-.PP
-References netsnmp_data_list_s::name, netsnmp_data_list_s::next, and NULL.
 .SS "void netsnmp_read_data_callback (const char * token, char * line)"
 .PP
-intended to be registerd as a .conf parser It should be registered using: 
-.PP
-register_app_config_handler('token', netsnmp_read_data_callback, XXX)
+intended to be registerd as a .conf parser It should be registered using: register_app_config_handler('token', netsnmp_read_data_callback, XXX)
 .PP
 where INFO_POINTER is a pointer to a netsnmp_data_list_saveinfo object containing apporpriate registration information 
 .PP
@@ -236,15 +206,9 @@
 
 .PP
 Definition at line 333 of file data_list.c.
-.PP
-References netsnmp_data_list_saveinfo_s::data_list_free_ptr, netsnmp_data_list_saveinfo_s::data_list_read_ptr, netsnmp_data_list_saveinfo_s::datalist, netsnmp_add_list_data(), netsnmp_create_data_list(), netsnmp_get_list_data(), NULL, read_config_read_data(), and snmp_log().
-.PP
-Referenced by netsnmp_register_save_list().
 .SS "void netsnmp_register_save_list (\fBnetsnmp_data_list\fP ** datalist, const char * type, const char * token, Netsnmp_Save_List_Data * data_list_save_ptr, Netsnmp_Read_List_Data * data_list_read_ptr, Netsnmp_Free_List_Data * data_list_free_ptr)"
 .PP
-registers to store a data_list set of data at persistent storage time 
-.PP
-\fBParameters:\fP
+registers to store a data_list set of data at persistent storage time \fBParameters:\fP
 .RS 4
 \fIdatalist\fP the data to be saved 
 .br
@@ -256,7 +220,7 @@
 .br
 \fIdata_list_read_ptr\fP a function pointer which can read the remainder of a saved line and return the application specific void * pointer. 
 .br
-\fIdata_list_free_ptr\fP a function pointer which will be passed to the data node for freeing it in the future when/if the list/node is cleaned up or destroyed. 
+\fIdata_list_free_ptr\fP a function pointer which will be passed to the data \fBnode\fP for freeing it in the future when/if the list/node is cleaned up or destroyed. 
 .RE
 .PP
 
@@ -269,15 +233,11 @@
 
 .PP
 Definition at line 231 of file data_list.c.
-.PP
-References netsnmp_data_list_saveinfo_s::data_list_free_ptr, netsnmp_data_list_saveinfo_s::data_list_read_ptr, netsnmp_data_list_saveinfo_s::data_list_save_ptr, netsnmp_data_list_saveinfo_s::datalist, netsnmp_add_list_data(), netsnmp_create_data_list(), netsnmp_ds_get_string(), netsnmp_read_data_callback(), netsnmp_save_all_data_callback(), NULL, register_config_handler(), snmp_log(), SNMP_MALLOC_TYPEDEF, snmp_register_callback(), netsnmp_data_list_saveinfo_s::token, and netsnmp_data_list_saveinfo_s::type.
 .SS "int netsnmp_remove_list_node (\fBnetsnmp_data_list\fP ** realhead, const char * name)"
 .PP
-Removes a named node from a data_list (and frees it). 
-.PP
-\fBParameters:\fP
+Removes a named \fBnode\fP from a data_list (and frees it). \fBParameters:\fP
 .RS 4
-\fIrealhead\fP a pointer to the head node of a data_list 
+\fIrealhead\fP a pointer to the head \fBnode\fP of a data_list 
 .br
 \fIname\fP the name to find and remove 
 .RE
@@ -290,33 +250,20 @@
 
 .PP
 Definition at line 198 of file data_list.c.
-.PP
-References netsnmp_free_list_data(), netsnmp_data_list_s::next, and NULL.
-.PP
-Referenced by netsnmp_agent_remove_list_data(), and netsnmp_request_remove_list_data().
 .SS "int netsnmp_save_all_data (\fBnetsnmp_data_list\fP * head, const char * type, const char * token, Netsnmp_Save_List_Data * data_list_save_ptr)"
 .PP
-intended to be called as a callback during persistent save operations. 
-.PP
-See the netsnmp_save_all_data_callback for where this is typically used. 
+intended to be called as a callback during persistent save operations. See the netsnmp_save_all_data_callback for where this is typically used. 
 .PP
 Definition at line 297 of file data_list.c.
-.PP
-References netsnmp_data_list_s::data, netsnmp_data_list_s::name, netsnmp_data_list_s::next, read_config_save_octet_string(), read_config_store(), and SNMP_MAXBUF.
-.PP
-Referenced by netsnmp_save_all_data_callback().
 .SS "int netsnmp_save_all_data_callback (int major, int minor, void * serverarg, void * clientarg)"
 .PP
-intended to be registerd as a callback operation. 
-.PP
-It should be registered using:
+intended to be registerd as a callback operation. It should be registered using:
 .PP
 snmp_register_callback(SNMP_CALLBACK_LIBRARY, SNMP_CALLBACK_STORE_DATA, netsnmp_save_all_data_callback, INFO_POINTER);
 .PP
 where INFO_POINTER is a pointer to a netsnmp_data_list_saveinfo object containing apporpriate registration information 
 .PP
 Definition at line 280 of file data_list.c.
-.PP
-References netsnmp_data_list_saveinfo_s::data_list_save_ptr, netsnmp_data_list_saveinfo_s::datalist, netsnmp_save_all_data(), snmp_log(), netsnmp_data_list_saveinfo_s::token, and netsnmp_data_list_saveinfo_s::type.
-.PP
-Referenced by netsnmp_register_save_list().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_debug.3'
--- man/netsnmp_debug.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_debug.3	2010-06-10 18:02:54 +0000
@@ -1,12 +1,31 @@
-.TH "debug" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "debug" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-debug \- Print out debugging information about the handler chain being called.  
-
+debug \- 
 .PP
+Print out debugging information about the handler chain being called.  
+
+.SS "Functions"
+
+.in +1c
+.ti -1c
+.RI "\fBnetsnmp_mib_handler\fP * \fBnetsnmp_get_debug_handler\fP (void)"
+.br
+.RI "\fIreturns a debug handler that can be injected into a given handler chain. \fP"
+.ti -1c
+.RI "void \fBdebug_print_requests\fP (\fBnetsnmp_request_info\fP *requests)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_debug_helper\fP (\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
+.br
+.ti -1c
+.RI "void \fBnetsnmp_init_debug_helper\fP (void)"
+.br
+.RI "\fIinitializes the debug helper which then registers a debug handler as a run-time injectable handler for configuration file use. \fP"
+.in -1c
 .SS "handler"
-
+ 
 .in +1c
 .ti -1c
 .RI "void \fBnetsnmp_init_serialize\fP (void)"
@@ -32,29 +51,11 @@
 .br
 .RI "\fIcall the initialization sequence for all handlers with init_ routines. \fP"
 .in -1c
-.SS "Functions"
-
-.in +1c
-.ti -1c
-.RI "\fBnetsnmp_mib_handler\fP * \fBnetsnmp_get_debug_handler\fP (void)"
-.br
-.RI "\fIreturns a debug handler that can be injected into a given handler chain. \fP"
-.ti -1c
-.RI "void \fBdebug_print_requests\fP (\fBnetsnmp_request_info\fP *requests)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_debug_helper\fP (\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
-.br
-.ti -1c
-.RI "void \fBnetsnmp_init_debug_helper\fP (void)"
-.br
-.RI "\fIinitializes the debug helper which then registers a debug handler as a run-time injectable handler for configuration file use. \fP"
-.in -1c
 .SH "Detailed Description"
 .PP 
 Print out debugging information about the handler chain being called. 
-.PP
-This is a useful module for run-time debugging of requests as the pass this handler in a calling chain. All debugging output is done via the standard debugging routines with a token name of 'helper:debug', so use the -Dhelper:debug command line flag to see the output when running the snmpd demon. It's not recommended you compile this into a handler chain during compile time, but instead use the 'injectHandler' token in the snmpd.conf file (or similar) to add it to the chain later:
+
+This is a useful \fBmodule\fP for run-time debugging of requests as the pass this handler in a calling chain. All debugging output is done via the standard debugging routines with a token name of 'helper:debug', so use the -Dhelper:debug command line flag to see the output when running the snmpd demon. It's not recommended you compile this into a handler chain during compile time, but instead use the 'injectHandler' token in the snmpd.conf file (or similar) to add it to the chain later:
 .PP
 injectHandler debug my_module_name
 .PP
@@ -70,53 +71,36 @@
 returns a debug handler that can be injected into a given handler chain. 
 .PP
 Definition at line 51 of file debug_handler.c.
-.PP
-References netsnmp_create_handler(), and netsnmp_debug_helper().
-.PP
-Referenced by netsnmp_init_debug_helper().
 .SS "void netsnmp_init_bulk_to_next_helper (void)"
 .PP
 initializes the bulk_to_next helper which then registers a bulk_to_next handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 139 of file bulk_to_next.c.
-.PP
-Referenced by netsnmp_init_helpers().
 .SS "void netsnmp_init_debug_helper (void)"
 .PP
 initializes the debug helper which then registers a debug handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 155 of file debug_handler.c.
-.PP
-References netsnmp_get_debug_handler(), and netsnmp_register_handler_by_name().
 .SS "void netsnmp_init_helpers (void)"
 .PP
 call the initialization sequence for all handlers with init_ routines. 
 .PP
 Definition at line 36 of file all_helpers.c.
-.PP
-References netsnmp_init_bulk_to_next_helper(), netsnmp_init_debug_helper(), netsnmp_init_read_only_helper(), netsnmp_init_serialize(), netsnmp_init_stash_cache_helper(), and netsnmp_init_table_dataset().
-.PP
-Referenced by init_agent().
 .SS "void netsnmp_init_read_only_helper (void)"
 .PP
 initializes the read_only helper which then registers a read_only handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 81 of file read_only.c.
-.PP
-Referenced by netsnmp_init_helpers().
 .SS "void netsnmp_init_serialize (void)"
 .PP
 initializes the serialize helper which then registers a serialize handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 93 of file serialize.c.
-.PP
-Referenced by netsnmp_init_helpers().
 .SS "void netsnmp_init_stash_cache_helper (void)"
 .PP
 initializes the stash_cache helper which then registers a stash_cache handler as a run-time injectable handler for configuration file use. 
 .PP
-Definition at line 237 of file stash_cache.c.
-.PP
-References netsnmp_get_stash_cache_handler(), and netsnmp_register_handler_by_name().
-.PP
-Referenced by netsnmp_init_helpers().
+Definition at line 238 of file stash_cache.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_default_store.3'
--- man/netsnmp_default_store.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_default_store.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "storage space for defaults" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "storage space for defaults" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-storage space for defaults \- The purpose of the default storage is three-fold:.  
+storage space for defaults \- 
+.PP
+The purpose of the default storage is three-fold:.  
 
-.PP
 .SS "Data Structures"
 
 .in +1c
@@ -16,7 +17,7 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fBnetsnmp_ds_read_config_s\fP \fBnetsnmp_ds_read_config\fP"
+.RI "typedef struct \fBnetsnmp_ds_read_config_s\fP \fBnetsnmp_ds_read_config\fP"
 .br
 .in -1c
 .SS "Functions"
@@ -69,7 +70,7 @@
 .SH "Detailed Description"
 .PP 
 The purpose of the default storage is three-fold:. 
-.PP
+
 1) To create a global storage space without creating a whole bunch of globally accessible variables or a whole bunch of access functions to work with more privately restricted variables.
 .PP
 2) To provide a single location where the thread lock- ing needs to be implemented. At the time of this writing, however, thread locking is not yet in place.
@@ -108,7 +109,7 @@
 .IP "\(bu" 2
 #define NETSNMP_DS_LIB_DONT_READ_CONFIGS 6
 .IP "\(bu" 2
-#define NETSNMP_DS_LIB_MIB_REPLACE 7 replace objects from latest module
+#define NETSNMP_DS_LIB_MIB_REPLACE 7 replace objects from latest \fBmodule\fP
 .IP "\(bu" 2
 #define NETSNMP_DS_LIB_PRINT_NUMERIC_ENUM 8 print only numeric enum values
 .IP "\(bu" 2
@@ -227,9 +228,7 @@
 .PP 
 .SS "int netsnmp_ds_set_boolean (int storeid, int which, int value)"
 .PP
-Stores 'true' or 'false' given an int value for value into netsnmp_ds_booleans[store][which] slot. 
-.PP
-\fBParameters:\fP
+Stores 'true' or 'false' given an int value for value into netsnmp_ds_booleans[store][which] slot. \fBParameters:\fP
 .RS 4
 \fIstoreid\fP an index to the boolean storage container's first index(store)
 .br
@@ -246,5 +245,6 @@
 
 .PP
 Definition at line 197 of file default_store.c.
-.PP
-Referenced by init_agent(), netsnmp_ds_handle_config(), read_configs(), read_premib_configs(), setup_tree(), and snmp_out_toggle_options().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_handler.3'
--- man/netsnmp_handler.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_handler.3	2010-06-10 18:02:54 +0000
@@ -1,80 +1,68 @@
-.TH "Net-SNMP Agent handler and extensibility API" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "Net-SNMP Agent handler and extensibility API" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-Net-SNMP Agent handler and extensibility API \- The basic theory goes something like this: In the past, with the original mib module api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request).  
-
+Net-SNMP Agent handler and extensibility API \- 
 .PP
+The basic theory goes something like this: In the past, with the original mib \fBmodule\fP api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request).  
+
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBnetsnmp_mib_handler_s\fP"
+.br
+.RI "\fIthe mib handler structure to be registered \fP"
+.ti -1c
+.RI "struct \fBnetsnmp_handler_registration_s\fP"
+.br
+.RI "\fIRoot registration info. \fP"
+.ti -1c
+.RI "struct \fBnetsnmp_handler_args_s\fP"
+.br
+.ti -1c
+.RI "struct \fBnetsnmp_delegated_cache_s\fP"
+.br
+.in -1c
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fButility_handlers\fP"
 .br
+.PP
+
 .RI "\fISimplify request processing A group of handlers intended to simplify certain aspects of processing a request for a MIB object. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBleaf_handlers\fP"
 .br
+.PP
+
 .RI "\fIProcess individual leaf objects A group of handlers to implement individual leaf objects and instances (both scalar objects, and individual objects and instances within a table). \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBbaby_steps\fP"
 .br
+.PP
+
 .RI "\fICalls your handler in baby_steps for set processing. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBold_api\fP"
 .br
-.RI "\fICalls mib module code written in the old style of code. \fP"
 .PP
-.in +1c
 
+.RI "\fICalls mib \fBmodule\fP code written in the old style of code. \fP"
 .ti -1c
 .RI "\fBstash_cache\fP"
 .br
+.PP
+
 .RI "\fIAutomatically caches data for certain handlers. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table. \fP"
-.PP
-
-.in -1c
-.SS "Data Structures"
-
-.in +1c
-.ti -1c
-.RI "struct \fBnetsnmp_mib_handler_s\fP"
-.br
-.RI "\fIthe mib handler structure to be registered \fP"
-.ti -1c
-.RI "struct \fBnetsnmp_handler_registration_s\fP"
-.br
-.RI "\fIRoot registration info. \fP"
-.ti -1c
-.RI "struct \fBnetsnmp_handler_args_s\fP"
-.br
-.ti -1c
-.RI "struct \fBnetsnmp_delegated_cache_s\fP"
-.br
-.ti -1c
-.RI "struct \fBnetsnmp_mib_handler_s\fP"
-.br
-.RI "\fIthe mib handler structure to be registered \fP"
-.ti -1c
-.RI "struct \fBnetsnmp_handler_registration_s\fP"
-.br
-.RI "\fIRoot registration info. \fP"
 .in -1c
 .SS "Defines"
 
@@ -141,28 +129,28 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fBnetsnmp_mib_handler_s\fP \fBnetsnmp_mib_handler\fP"
+.RI "typedef struct \fBnetsnmp_mib_handler_s\fP \fBnetsnmp_mib_handler\fP"
 .br
 .RI "\fITypedefs the \fBnetsnmp_mib_handler_s\fP struct into netsnmp_mib_handler. \fP"
 .ti -1c
-.RI "typedef \fBnetsnmp_handler_registration_s\fP \fBnetsnmp_handler_registration\fP"
+.RI "typedef struct \fBnetsnmp_handler_registration_s\fP \fBnetsnmp_handler_registration\fP"
 .br
 .RI "\fITypedefs the \fBnetsnmp_handler_registration_s\fP struct into netsnmp_handler_registration. \fP"
 .ti -1c
 .RI "typedef int( \fBNetsnmp_Node_Handler\fP )(\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
 .br
 .ti -1c
-.RI "typedef \fBnetsnmp_handler_args_s\fP \fBnetsnmp_handler_args\fP"
+.RI "typedef struct \fBnetsnmp_handler_args_s\fP \fBnetsnmp_handler_args\fP"
 .br
 .ti -1c
-.RI "typedef \fBnetsnmp_delegated_cache_s\fP \fBnetsnmp_delegated_cache\fP"
+.RI "typedef struct \fBnetsnmp_delegated_cache_s\fP \fBnetsnmp_delegated_cache\fP"
 .br
 .in -1c
 .SS "Functions"
 
 .in +1c
 .ti -1c
-.RI "\fBnetsnmp_mib_handler\fP * \fBnetsnmp_create_handler\fP (const char *name, \fBNetsnmp_Node_Handler\fP *handler_access_method)"
+.RI "\fBnetsnmp_mib_handler\fP * \fBnetsnmp_create_handler\fP (const char *name, Netsnmp_Node_Handler *handler_access_method)"
 .br
 .RI "\fIcreates a netsnmp_mib_handler structure given a name and a access method. \fP"
 .ti -1c
@@ -170,7 +158,7 @@
 .br
 .RI "\fIcreates a handler registration structure given a name, a access_method function, a registration location oid and the modes the handler supports. \fP"
 .ti -1c
-.RI "\fBnetsnmp_handler_registration\fP * \fBnetsnmp_create_handler_registration\fP (const char *name, \fBNetsnmp_Node_Handler\fP *handler_access_method, oid *reg_oid, size_t reg_oid_len, int modes)"
+.RI "\fBnetsnmp_handler_registration\fP * \fBnetsnmp_create_handler_registration\fP (const char *name, Netsnmp_Node_Handler *handler_access_method, oid *reg_oid, size_t reg_oid_len, int modes)"
 .br
 .ti -1c
 .RI "int \fBnetsnmp_register_handler\fP (\fBnetsnmp_handler_registration\fP *reginfo)"
@@ -248,9 +236,9 @@
 .br
 .RI "\fIremove data from a request \fP"
 .ti -1c
-.RI "NETSNMP_INLINE void * \fBnetsnmp_request_get_list_data\fP (\fBnetsnmp_request_info\fP *request, const char *name)"
+.RI "void * \fBnetsnmp_request_get_list_data\fP (\fBnetsnmp_request_info\fP *request, const char *name)"
 .br
-.RI "\fIextract data from a request that was added previously by a parent module \fP"
+.RI "\fIextract data from a request that was added previously by a parent \fBmodule\fP \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_free_request_data_set\fP (\fBnetsnmp_request_info\fP *request)"
 .br
@@ -293,15 +281,15 @@
 .in -1c
 .SH "Detailed Description"
 .PP 
-The basic theory goes something like this: In the past, with the original mib module api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request). 
-.PP
+The basic theory goes something like this: In the past, with the original mib \fBmodule\fP api (which derived from the original CMU SNMP code) the underlying mib modules were passed very little information (only the truly most basic information about a request). 
+
 This worked well at the time but in todays world of subagents, device instrumentation, low resource consumption, etc, it just isn't flexible enough. 'handlers' are here to fix all that.
 .PP
 With the rewrite of the agent internals for the net-snmp 5.0 release, we introduce a modular calling scheme that allows agent modules to be written in a very flexible manner, and more importantly allows reuse of code in a decent way (and without the memory and speed overheads of OO languages like C++).
 .PP
-Functionally, the notion of what a handler does is the same as the older api: A handler is \fBcreated\fP and then \fBregistered\fP with the main agent at a given OID in the OID tree and gets called any time a request is made that it should respond to. You probably should use one of the convenience helpers instead of doing anything else yourself though:
+Functionally, the notion of what a handler does is the same as the older api: A handler is \fBcreated\fP and then \fBregistered\fP with the main agent at a given OID in the OID \fBtree\fP and gets called any time a request is made that it should respond to. You probably should use one of the convenience helpers instead of doing anything else yourself though:
 .PP
-Most importantly, though, is that the handlers are built on the notion of modularity and reuse. Specifically, rather than do all the really hard work (like parsing table indexes out of an incoming oid request) in each module, the API is designed to make it easy to write 'helper' handlers that merely process some aspect of the request before passing it along to the final handler that returns the real answer. Most people will want to make use of the \fBinstance\fP, \fBtable\fP, \fBtable_iterator\fP, \fBtable_data\fP, or \fBtable_dataset\fP helpers to make their life easier. These 'helpers' interpert important aspects of the request and pass them on to you.
+Most importantly, though, is that the handlers are built on the notion of modularity and reuse. Specifically, rather than do all the really hard work (like parsing table indexes out of an incoming oid request) in each \fBmodule\fP, the API is designed to make it easy to write 'helper' handlers that merely process some aspect of the request before passing it along to the final handler that returns the real answer. Most people will want to make use of the \fBinstance\fP, \fBtable\fP, \fBtable_iterator\fP, \fBtable_data\fP, or \fBtable_dataset\fP helpers to make their life easier. These 'helpers' interpert important aspects of the request and pass them on to you.
 .PP
 For instance, the \fBtable\fP helper is designed to hand you a list of extracted index values from an incoming request. THe \fBtable_iterator\fP helper is built on top of the table helper, and is designed to help you iterate through data stored elsewhere (like in a kernel) that is not in OID lexographical order (ie, don't write your own index/oid sorting routine, use this helper instead). The beauty of the \fBtable_iterator helper\fP, as well as the \fBinstance\fP helper is that they take care of the complex GETNEXT processing entirely for you and hand you everything you need to merely return the data as if it was a GET request. Much less code and hair pulling. I've pulled all my hair out to help you so that only one of us has to be bald. 
 .SH "Typedef Documentation"
@@ -309,65 +297,33 @@
 .SS "struct \fBnetsnmp_handler_registration_s\fP \fBnetsnmp_handler_registration\fP"
 .PP
 Typedefs the \fBnetsnmp_handler_registration_s\fP struct into netsnmp_handler_registration. 
-.PP
 .SS "struct \fBnetsnmp_mib_handler_s\fP \fBnetsnmp_mib_handler\fP"
 .PP
 Typedefs the \fBnetsnmp_mib_handler_s\fP struct into netsnmp_mib_handler. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_call_handler (\fBnetsnmp_mib_handler\fP * next_handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 calls a handler with with appropriate NULL checking of arguments, etc. 
-.PP
-Definition at line 394 of file agent_handler.c.
-.PP
-References netsnmp_mib_handler_s::access_method, netsnmp_mib_handler_s::handler_name, MIB_HANDLER_AUTO_NEXT, MIB_HANDLER_AUTO_NEXT_OVERRIDE_ONCE, netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::next, NULL, and snmp_log().
-.PP
-Referenced by netsnmp_call_handlers(), netsnmp_call_next_handler(), netsnmp_call_next_handler_one_request(), netsnmp_mode_end_call_helper(), and netsnmp_multiplexer_helper_handler().
 .SS "int netsnmp_call_next_handler (\fBnetsnmp_mib_handler\fP * current, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 calls the next handler in the chain after the current one with with appropriate NULL checking, etc. 
-.PP
-Definition at line 524 of file agent_handler.c.
-.PP
-References netsnmp_call_handler(), netsnmp_mib_handler_s::next, NULL, and snmp_log().
-.PP
-Referenced by _netsnmp_stash_cache_load(), netsnmp_bulk_to_next_helper(), netsnmp_debug_helper(), netsnmp_instance_counter32_handler(), netsnmp_instance_helper_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_mode_end_call_helper(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_serialize_helper_handler(), netsnmp_stash_to_next_helper(), and table_helper_handler().
 .SS "int netsnmp_call_next_handler_one_request (\fBnetsnmp_mib_handler\fP * current, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 calls the next handler in the chain after the current one with with appropriate NULL checking, etc. 
-.PP
-Definition at line 546 of file agent_handler.c.
-.PP
-References netsnmp_call_handler(), netsnmp_mib_handler_s::next, netsnmp_request_info_s::next, NULL, and snmp_log().
 .SS "void netsnmp_clear_handler_list (void)"
 .PP
 clears the entire handler-registration list 
-.PP
-Definition at line 905 of file agent_handler.c.
-.PP
-References netsnmp_free_all_list_data(), and NULL.
-.PP
-Referenced by shutdown_agent().
-.SS "NETSNMP_INLINE \fBnetsnmp_delegated_cache\fP * netsnmp_create_delegated_cache (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests, void * localinfo)"
-.PP
-creates a cache of information which can be saved for future reference. 
-.PP
-Use \fBnetsnmp_handler_check_cache()\fP later to make sure it's still valid before referencing it in the future. 
+.SS "\fBnetsnmp_delegated_cache\fP * netsnmp_create_delegated_cache (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests, void * localinfo)"
+.PP
+creates a cache of information which can be saved for future reference. Use \fBnetsnmp_handler_check_cache()\fP later to make sure it's still valid before referencing it in the future. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
-.PP
-Definition at line 696 of file agent_handler.c.
-.PP
-References netsnmp_agent_request_info_s::asp, netsnmp_delegated_cache_s::handler, netsnmp_delegated_cache_s::localinfo, netsnmp_agent_session_s::pdu, netsnmp_delegated_cache_s::reginfo, netsnmp_delegated_cache_s::reqinfo, netsnmp_delegated_cache_s::requests, SNMP_MALLOC_TYPEDEF, netsnmp_delegated_cache_s::transaction_id, and snmp_pdu::transid.
-.SS "\fBnetsnmp_mib_handler\fP * netsnmp_create_handler (const char * name, \fBNetsnmp_Node_Handler\fP * handler_access_method)"
-.PP
-creates a netsnmp_mib_handler structure given a name and a access method. 
-.PP
-The returned handler should then be \fBregistered.\fP
+.SS "\fBnetsnmp_mib_handler\fP * netsnmp_create_handler (const char * name, Netsnmp_Node_Handler * handler_access_method)"
+.PP
+creates a netsnmp_mib_handler structure given a name and a access method. The returned handler should then be \fBregistered.\fP
 .PP
 \fBParameters:\fP
 .RS 4
@@ -383,112 +339,54 @@
 .PP
 \fBSee also:\fP
 .RS 4
-\fBnetsnmp_create_handler_registration()\fP 
+netsnmp_create_handler_registration() 
 .PP
 \fBnetsnmp_register_handler()\fP 
 .RE
 .PP
 
-.PP
-Definition at line 105 of file agent_handler.c.
-.PP
-References netsnmp_mib_handler_s::access_method, netsnmp_mib_handler_s::handler_name, NULL, SNMP_FREE, and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by get_old_api_handler(), netsnmp_baby_steps_access_multiplexer_get(), netsnmp_baby_steps_handler_get(), netsnmp_cache_handler_get(), netsnmp_container_table_handler_get(), netsnmp_create_handler_registration(), netsnmp_get_bulk_to_next_handler(), netsnmp_get_debug_handler(), netsnmp_get_instance_handler(), netsnmp_get_mode_end_call_handler(), netsnmp_get_multiplexer_handler(), netsnmp_get_read_only_handler(), netsnmp_get_row_merge_handler(), netsnmp_get_scalar_group_handler(), netsnmp_get_scalar_handler(), netsnmp_get_serialize_handler(), netsnmp_get_stash_to_next_handler(), netsnmp_get_table_data_handler(), netsnmp_get_table_data_set_handler(), netsnmp_get_table_handler(), netsnmp_get_table_iterator_handler(), netsnmp_get_tdata_handler(), netsnmp_get_timed_bare_stash_cache_handler(), netsnmp_get_watched_spinlock_handler(), netsnmp_get_watched_timestamp_handler(), netsnmp_get_watcher_handler(), netsnmp_sparse_table_handler_get(), netsnmp_sparse_table_register(), netsnmp_table_array_register(), and netsnmp_table_row_handler_get().
 .SS "\fBnetsnmp_mib_handler\fP * netsnmp_find_handler_by_name (\fBnetsnmp_handler_registration\fP * reginfo, const char * name)"
 .PP
 Returns a handler from a chain based on the name. 
-.PP
-Definition at line 838 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::handler, netsnmp_mib_handler_s::handler_name, netsnmp_mib_handler_s::next, and NULL.
-.PP
-Referenced by netsnmp_find_handler_data_by_name().
 .SS "void * netsnmp_find_handler_data_by_name (\fBnetsnmp_handler_registration\fP * reginfo, const char * name)"
 .PP
-Returns a handler's void * pointer from a chain based on the name. 
-.PP
-This probably shouldn't be used by the general public as the void * data may change as a handler evolves. Handlers should really advertise some function for you to use instead. 
-.PP
-Definition at line 855 of file agent_handler.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_find_handler_by_name(), and NULL.
-.PP
-Referenced by netsnmp_find_table_registration_info().
-.SS "NETSNMP_INLINE void netsnmp_free_delegated_cache (\fBnetsnmp_delegated_cache\fP * dcache)"
+Returns a handler's void * pointer from a chain based on the name. This probably shouldn't be used by the general public as the void * data may change as a handler evolves. Handlers should really advertise some function for you to use instead. 
+.SS "void netsnmp_free_delegated_cache (\fBnetsnmp_delegated_cache\fP * dcache)"
 .PP
 frees a cache once you're finished using it 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
-.PP
-Definition at line 734 of file agent_handler.c.
-.PP
-References SNMP_FREE.
-.SS "NETSNMP_INLINE void netsnmp_free_request_data_set (\fBnetsnmp_request_info\fP * request)"
+.SS "void netsnmp_free_request_data_set (\fBnetsnmp_request_info\fP * request)"
 .PP
 Free the extra data stored in a request. 
-.PP
-Definition at line 820 of file agent_handler.c.
-.PP
-References netsnmp_free_list_data(), and netsnmp_request_info_s::parent_data.
-.SS "NETSNMP_INLINE void netsnmp_free_request_data_sets (\fBnetsnmp_request_info\fP * request)"
+.SS "void netsnmp_free_request_data_sets (\fBnetsnmp_request_info\fP * request)"
 .PP
 Free the extra data stored in a bunch of requests (all data in the chain). 
-.PP
-Definition at line 828 of file agent_handler.c.
-.PP
-References netsnmp_free_all_list_data(), NULL, and netsnmp_request_info_s::parent_data.
-.PP
-Referenced by free_agent_snmp_session(), get_set_cache(), netsnmp_add_varbind_to_cache(), and netsnmp_delete_request_infos().
-.SS "NETSNMP_INLINE \fBnetsnmp_delegated_cache\fP * netsnmp_handler_check_cache (\fBnetsnmp_delegated_cache\fP * dcache)"
-.PP
-check's a given cache and returns it if it is still valid (ie, the agent still considers it to be an outstanding request. 
-.PP
-Returns NULL if it's no longer valid. 
+.SS "\fBnetsnmp_delegated_cache\fP * netsnmp_handler_check_cache (\fBnetsnmp_delegated_cache\fP * dcache)"
+.PP
+check's a given cache and returns it if it is still valid (ie, the agent still considers it to be an outstanding request. Returns NULL if it's no longer valid. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
-.PP
-Definition at line 720 of file agent_handler.c.
-.PP
-References netsnmp_check_transaction_id(), NULL, and netsnmp_delegated_cache_s::transaction_id.
 .SS "\fBnetsnmp_mib_handler\fP * netsnmp_handler_dup (\fBnetsnmp_mib_handler\fP * handler)"
 .PP
 dulpicates a handler and all subsequent handlers see also _clone_handler 
-.PP
-Definition at line 591 of file agent_handler.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_handler_free(), netsnmp_mib_handler_s::next, NULL, and netsnmp_mib_handler_s::prev.
-.PP
-Referenced by netsnmp_handler_registration_dup().
 .SS "void netsnmp_handler_free (\fBnetsnmp_mib_handler\fP * handler)"
 .PP
 free's the resourceses associated with a given handler 
 .PP
 make sure we aren't pointing to ourselves.
 .PP
-XXX : segv here at shutdown if SHUTDOWN_AGENT_CLEANLY defined. About 30 functions down the stack, starting in \fBclear_context()\fP -> \fBclear_subtree()\fP 
-.PP
-Definition at line 569 of file agent_handler.c.
-.PP
-References netsnmp_mib_handler_s::handler_name, netsnmp_mib_handler_s::next, NULL, and SNMP_FREE.
-.PP
-Referenced by handler_free_callback(), netsnmp_baby_steps_handler_get(), netsnmp_get_scalar_group_handler(), netsnmp_get_timed_bare_stash_cache_handler(), netsnmp_handler_dup(), and netsnmp_handler_registration_free().
+XXX : segv here at shutdown if SHUTDOWN_AGENT_CLEANLY defined. About 30 functions down the stack, starting in clear_context() -> clear_subtree()
 .SS "void netsnmp_handler_mark_requests_as_delegated (\fBnetsnmp_request_info\fP * requests, int isdelegated)"
 .PP
 marks a list of requests as delegated (or not if isdelegaded = 0) 
-.PP
-Definition at line 748 of file agent_handler.c.
-.PP
-References netsnmp_request_info_s::delegated, and netsnmp_request_info_s::next.
 .SS "\fBnetsnmp_handler_registration\fP * netsnmp_handler_registration_create (const char * name, \fBnetsnmp_mib_handler\fP * handler, oid * reg_oid, size_t reg_oid_len, int modes)"
 .PP
-creates a handler registration structure given a name, a access_method function, a registration location oid and the modes the handler supports. 
-.PP
-If modes == 0, then modes will automatically be set to the default value of only HANDLER_CAN_DEFAULT, which is by default read-only GET and GETNEXT requests. A hander which supports sets but not row creation should set us a mode of HANDLER_CAN_SET_ONLY. 
+creates a handler registration structure given a name, a access_method function, a registration location oid and the modes the handler supports. If modes == 0, then modes will automatically be set to the default value of only HANDLER_CAN_DEFAULT, which is by default read-only GET and GETNEXT requests. A hander which supports sets but not row creation should set us a mode of HANDLER_CAN_SET_ONLY. 
 .PP
 \fBNote:\fP
 .RS 4
@@ -537,88 +435,34 @@
 .RE
 .PP
 
-.PP
-Definition at line 163 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::handler, HANDLER_CAN_DEFAULT, netsnmp_handler_registration_s::handlerName, memdup(), netsnmp_handler_registration_s::modes, NULL, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_create_handler_registration().
 .SS "\fBnetsnmp_handler_registration\fP * netsnmp_handler_registration_dup (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 duplicates the handler registration object 
-.PP
-Definition at line 634 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::contextName, netsnmp_handler_registration_s::handler, netsnmp_handler_registration_s::handlerName, memdup(), netsnmp_handler_registration_s::modes, netsnmp_handler_dup(), netsnmp_handler_registration_free(), NULL, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::range_subid, netsnmp_handler_registration_s::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, and netsnmp_handler_registration_s::timeout.
-.PP
-Referenced by netsnmp_subtree_deepcopy().
 .SS "void netsnmp_handler_registration_free (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 free the resources associated with a handler registration object 
-.PP
-Definition at line 620 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::contextName, netsnmp_handler_registration_s::handler, netsnmp_handler_registration_s::handlerName, netsnmp_handler_free(), NULL, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, and SNMP_FREE.
-.PP
-Referenced by netsnmp_handler_registration_dup(), netsnmp_register_mib(), netsnmp_register_mib_table_row(), netsnmp_subtree_free(), and unregister_mibs_by_session().
 .SS "int netsnmp_inject_handler (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_mib_handler\fP * handler)"
 .PP
-inject a new handler into the calling chain of the handlers definedy by the netsnmp_handler_registration pointer. 
-.PP
-The new handler is injected at the top of the list and hence will be the new handler to be called first. 
-.PP
-Definition at line 386 of file agent_handler.c.
-.PP
-References netsnmp_inject_handler_before(), and NULL.
-.PP
-Referenced by netsnmp_cache_handler_register(), netsnmp_container_table_register(), netsnmp_register_cache_handler(), netsnmp_register_handler(), netsnmp_register_instance(), netsnmp_register_read_only_instance(), netsnmp_register_read_only_scalar(), netsnmp_register_read_only_table_data(), netsnmp_register_row_merge(), netsnmp_register_scalar(), netsnmp_register_scalar_group(), netsnmp_register_serialize(), netsnmp_register_table(), netsnmp_register_table_data(), netsnmp_register_table_data_set(), netsnmp_register_table_iterator(), netsnmp_register_watched_instance(), netsnmp_register_watched_scalar(), netsnmp_register_watched_spinlock(), netsnmp_sparse_table_register(), netsnmp_table_array_register(), netsnmp_table_row_register(), netsnmp_tdata_register(), and netsnmp_watched_timestamp_register().
+inject a new handler into the calling chain of the handlers definedy by the netsnmp_handler_registration pointer. The new handler is injected at the top of the list and hence will be the new handler to be called first. 
 .SS "int netsnmp_inject_handler_before (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_mib_handler\fP * handler, const char * before_what)"
 .PP
-inject a new handler into the calling chain of the handlers definedy by the netsnmp_handler_registration pointer. 
-.PP
-The new handler is injected after the before_what handler, or if NULL at the top of the list and hence will be the new handler to be called first. 
-.PP
-Definition at line 329 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::handler, netsnmp_mib_handler_s::handler_name, netsnmp_mib_handler_s::next, NULL, netsnmp_mib_handler_s::prev, and snmp_log().
-.PP
-Referenced by netsnmp_inject_handler(), and netsnmp_inject_handler_into_subtree().
+inject a new handler into the calling chain of the handlers definedy by the netsnmp_handler_registration pointer. The new handler is injected after the before_what handler, or if NULL at the top of the list and hence will be the new handler to be called first. 
 .SS "int netsnmp_register_handler (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 register a handler, as defined by the netsnmp_handler_registration pointer. 
-.PP
-Definition at line 202 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::contextName, netsnmp_mib_handler_s::flags, netsnmp_handler_registration_s::handler, HANDLER_CAN_DEFAULT, HANDLER_CAN_GETBULK, netsnmp_mib_handler_s::handler_name, netsnmp_handler_registration_s::handlerName, MIB_HANDLER_INSTANCE, netsnmp_handler_registration_s::modes, netsnmp_get_bulk_to_next_handler(), netsnmp_inject_handler(), netsnmp_register_mib(), netsnmp_mib_handler_s::next, NULL, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::range_subid, netsnmp_handler_registration_s::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_log(), and netsnmp_handler_registration_s::timeout.
-.PP
-Referenced by netsnmp_cache_handler_register(), netsnmp_register_cache_handler(), netsnmp_register_old_api(), netsnmp_register_row_merge(), netsnmp_register_serialize(), netsnmp_register_table(), netsnmp_sparse_table_register(), and netsnmp_table_row_register().
 .SS "void netsnmp_register_handler_by_name (const char * name, \fBnetsnmp_mib_handler\fP * handler)"
 .PP
 registers a given handler by name so that it can be found easily later. 
-.PP
-Definition at line 893 of file agent_handler.c.
-.PP
-References handler_free_callback(), netsnmp_add_list_data(), and netsnmp_create_data_list().
-.PP
-Referenced by netsnmp_baby_steps_handler_init(), netsnmp_init_bulk_to_next_helper(), netsnmp_init_debug_helper(), netsnmp_init_read_only_helper(), netsnmp_init_row_merge(), netsnmp_init_serialize(), and netsnmp_init_stash_cache_helper().
 .SS "int netsnmp_register_handler_nocallback (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 register a handler, as defined by the netsnmp_handler_registration pointer. 
-.PP
-Definition at line 277 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::contextName, netsnmp_handler_registration_s::handler, HANDLER_CAN_DEFAULT, netsnmp_mib_handler_s::handler_name, netsnmp_handler_registration_s::modes, netsnmp_register_mib(), netsnmp_mib_handler_s::next, NULL, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::range_subid, netsnmp_handler_registration_s::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_log(), and netsnmp_handler_registration_s::timeout.
-.PP
-Referenced by netsnmp_register_mib_table_row().
-.SS "NETSNMP_INLINE void netsnmp_request_add_list_data (\fBnetsnmp_request_info\fP * request, \fBnetsnmp_data_list\fP * node)"
-.PP
-add data to a request that can be extracted later by submodules 
-.PP
-\fBParameters:\fP
+.SS "void netsnmp_request_add_list_data (\fBnetsnmp_request_info\fP * request, \fBnetsnmp_data_list\fP * node)"
+.PP
+add data to a request that can be extracted later by submodules \fBParameters:\fP
 .RS 4
 \fIrequest\fP the netsnmp request info structure
 .br
-\fInode\fP this is the data to be added to the linked list request->parent_data
+\fI\fBnode\fP\fP this is the data to be added to the linked list request->parent_data
 .RE
 .PP
 \fBReturns:\fP
@@ -631,17 +475,9 @@
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
-.PP
-Definition at line 768 of file agent_handler.c.
-.PP
-References netsnmp_add_list_data(), and netsnmp_request_info_s::parent_data.
-.PP
-Referenced by _netsnmp_tdata_helper_handler(), netsnmp_container_table_row_insert(), netsnmp_insert_iterator_context(), netsnmp_insert_table_row(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_table_data_helper_handler(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_watcher_helper_handler(), and table_helper_handler().
-.SS "NETSNMP_INLINE void * netsnmp_request_get_list_data (\fBnetsnmp_request_info\fP * request, const char * name)"
-.PP
-extract data from a request that was added previously by a parent module 
-.PP
-\fBParameters:\fP
+.SS "void * netsnmp_request_get_list_data (\fBnetsnmp_request_info\fP * request, const char * name)"
+.PP
+extract data from a request that was added previously by a parent \fBmodule\fP \fBParameters:\fP
 .RS 4
 \fIrequest\fP the netsnmp request info function
 .br
@@ -658,17 +494,9 @@
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
-.PP
-Definition at line 810 of file agent_handler.c.
-.PP
-References netsnmp_get_list_data(), NULL, and netsnmp_request_info_s::parent_data.
-.PP
-Referenced by netsnmp_container_table_container_extract(), netsnmp_container_table_extract_context(), netsnmp_container_table_row_extract(), netsnmp_extract_array_context(), netsnmp_extract_iterator_context(), netsnmp_extract_table(), netsnmp_extract_table_data_set(), netsnmp_extract_table_info(), netsnmp_extract_table_row(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_extract(), netsnmp_tdata_extract_container(), netsnmp_tdata_extract_table(), and netsnmp_watcher_helper_handler().
-.SS "NETSNMP_INLINE int netsnmp_request_remove_list_data (\fBnetsnmp_request_info\fP * request, const char * name)"
-.PP
-remove data from a request 
-.PP
-\fBParameters:\fP
+.SS "int netsnmp_request_remove_list_data (\fBnetsnmp_request_info\fP * request, const char * name)"
+.PP
+remove data from a request \fBParameters:\fP
 .RS 4
 \fIrequest\fP the netsnmp request info structure
 .br
@@ -681,16 +509,9 @@
 .RE
 .PP
 
-.PP
-Definition at line 789 of file agent_handler.c.
-.PP
-References netsnmp_remove_list_node(), NULL, and netsnmp_request_info_s::parent_data.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
 .SS "int netsnmp_unregister_handler (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 unregister a handler, as defined by the netsnmp_handler_registration pointer. 
-.PP
-Definition at line 267 of file agent_handler.c.
-.PP
-References netsnmp_handler_registration_s::contextName, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::range_subid, netsnmp_handler_registration_s::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, and unregister_mib_context().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_instance.3'
--- man/netsnmp_instance.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_instance.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "instance" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "instance" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-instance \- Process individual MIB instances easily.  
+instance \- 
+.PP
+Process individual MIB instances easily.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -21,61 +22,61 @@
 .br
 .RI "\fIThis function injects a 'read only' handler into the handler chain prior to serializing/registering the handler. \fP"
 .ti -1c
-.RI "int \fBnetsnmp_register_read_only_ulong_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_ulong_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_counter32_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_long_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_long_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_uint_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, unsigned int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_uint_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, unsigned int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBregister_read_only_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_ulong_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_ulong_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_counter32_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_long_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_long_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBregister_read_only_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_num_file_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, char *file_name, int asn_type, int mode, \fBNetsnmp_Node_Handler\fP *subhandler, const char *contextName)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
+.RI "int \fBnetsnmp_register_read_only_ulong_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_ulong_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_counter32_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_long_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_long_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_uint_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, unsigned int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_uint_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, unsigned int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBregister_read_only_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_ulong_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_ulong_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_counter32_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_long_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_long_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBregister_read_only_int_instance_context\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_num_file_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, char *file_name, int asn_type, int mode, Netsnmp_Node_Handler *subhandler, const char *contextName)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_int_instance\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler)"
 .br
 .RI "\fIThis function registers an int helper handler to a specified OID. \fP"
 .ti -1c
@@ -103,14 +104,11 @@
 .SH "Detailed Description"
 .PP 
 Process individual MIB instances easily. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_instance_handler (void)"
 .PP
-Creates an instance helper handler, calls netsnmp_create_handler, which then could be registered, using \fBnetsnmp_register_handler()\fP. 
-.PP
-\fBReturns:\fP
+Creates an instance helper handler, calls netsnmp_create_handler, which then could be registered, using \fBnetsnmp_register_handler()\fP. \fBReturns:\fP
 .RS 4
 Returns a pointer to a netsnmp_mib_handler struct which contains the handler's name and the access method 
 .RE
@@ -118,22 +116,14 @@
 
 .PP
 Definition at line 48 of file instance.c.
-.PP
-References netsnmp_create_handler(), and netsnmp_instance_helper_handler().
-.PP
-Referenced by netsnmp_register_instance(), netsnmp_register_read_only_instance(), netsnmp_register_read_only_scalar(), netsnmp_register_scalar(), and netsnmp_register_scalar_group().
 .SS "int netsnmp_instance_num_file_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
+fall through 
+.PP
 Definition at line 741 of file instance.c.
-.PP
-References netsnmp_mib_handler_s::access_method, netsnmp_num_file_instance_s::file_name, netsnmp_num_file_instance_s::filep, netsnmp_vardata::integer, memdup(), netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, netsnmp_call_next_handler(), netsnmp_create_data_list(), netsnmp_request_add_list_data(), netsnmp_request_get_list_data(), netsnmp_set_request_error(), netsnmp_mib_handler_s::next, NULL, netsnmp_request_info_s::requestvb, snmp_set_var_typed_value(), variable_list::type, netsnmp_num_file_instance_s::type, and variable_list::val.
-.PP
-Referenced by netsnmp_register_num_file_instance().
 .SS "int netsnmp_register_instance (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
-This function registers an instance helper handler, which is a way of registering an exact OID such that GENEXT requests are handled entirely by the helper. 
-.PP
-First need to inject it into the calling chain of the handler defined by the netsnmp_handler_registration struct, reginfo. The new handler is injected at the top of the list and will be the new handler to be called first. This function also injects a serialize handler before actually calling netsnmp_register_handle, registering reginfo.
+This function registers an instance helper handler, which is a way of registering an exact OID such that GENEXT requests are handled entirely by the helper. First need to inject it into the calling chain of the handler defined by the netsnmp_handler_registration struct, reginfo. The new handler is injected at the top of the list and will be the new handler to be called first. This function also injects a serialize handler before actually calling netsnmp_register_handle, registering reginfo.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -152,15 +142,9 @@
 \fBdelayed_instance.c\fP.
 .PP
 Definition at line 73 of file instance.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_INSTANCE, netsnmp_get_instance_handler(), netsnmp_inject_handler(), and netsnmp_register_serialize().
-.PP
-Referenced by netsnmp_register_int_instance(), netsnmp_register_int_instance_context(), netsnmp_register_long_instance(), netsnmp_register_long_instance_context(), netsnmp_register_num_file_instance(), netsnmp_register_uint_instance(), netsnmp_register_ulong_instance(), netsnmp_register_ulong_instance_context(), and netsnmp_register_watched_instance().
-.SS "int netsnmp_register_int_instance (const char * name, oid * reg_oid, size_t reg_oid_len, int * it, \fBNetsnmp_Node_Handler\fP * subhandler)"
-.PP
-This function registers an int helper handler to a specified OID. 
-.PP
-\fBParameters:\fP
+.SS "int netsnmp_register_int_instance (const char * name, oid * reg_oid, size_t reg_oid_len, int * it, Netsnmp_Node_Handler * subhandler)"
+.PP
+This function registers an int helper handler to a specified OID. \fBParameters:\fP
 .RS 4
 \fIname\fP the name used for registration pruposes.
 .br
@@ -185,13 +169,9 @@
 \fBscalar_int.c\fP.
 .PP
 Definition at line 460 of file instance.c.
-.PP
-References HANDLER_CAN_RWRITE, netsnmp_instance_int_handler(), netsnmp_register_instance(), and NULL.
 .SS "int netsnmp_register_read_only_instance (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
-This function injects a 'read only' handler into the handler chain prior to serializing/registering the handler. 
-.PP
-The only purpose of this 'read only' handler is to return an appropriate error for any requests passed to it in a SET mode. Inserting it into your handler chain will ensure you're never asked to perform a SET request so you can ignore those error conditions.
+This function injects a 'read only' handler into the handler chain prior to serializing/registering the handler. The only purpose of this 'read only' handler is to return an appropriate error for any requests passed to it in a SET mode. Inserting it into your handler chain will ensure you're never asked to perform a SET request so you can ignore those error conditions.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -206,7 +186,6 @@
 
 .PP
 Definition at line 100 of file instance.c.
-.PP
-References netsnmp_get_instance_handler(), netsnmp_get_read_only_handler(), netsnmp_inject_handler(), and netsnmp_register_serialize().
-.PP
-Referenced by netsnmp_register_num_file_instance(), netsnmp_register_read_only_counter32_instance(), netsnmp_register_read_only_counter32_instance_context(), netsnmp_register_read_only_int_instance(), netsnmp_register_read_only_int_instance_context(), netsnmp_register_read_only_long_instance(), netsnmp_register_read_only_long_instance_context(), netsnmp_register_read_only_uint_instance(), netsnmp_register_read_only_ulong_instance(), and netsnmp_register_read_only_ulong_instance_context().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_iterator_info_s.3'
--- man/netsnmp_iterator_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_iterator_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "iterator_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "iterator_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-iterator_info_s \- Holds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner.  
+iterator_info_s \- 
+.PP
+Holds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
@@ -15,37 +16,37 @@
 .RI "\fBnetsnmp_container\fP \fBc\fP"
 .br
 .ti -1c
-.RI "\fBNetsnmp_Iterator_Loop_Key\fP * \fBget_first\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Loop_Key\fP * \fBget_next\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Loop_Data\fP * \fBget_data\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Data\fP * \fBfree_user_ctx\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Ctx\fP * \fBinit_loop_ctx\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Ctx\fP * \fBcleanup_loop_ctx\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Ctx_Dup\fP * \fBsave_pos\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Data\fP * \fBrelease_data\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Data\fP * \fBinsert_data\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Data\fP * \fBremove_data\fP"
-.br
-.ti -1c
-.RI "\fBNetsnmp_Iterator_Op\fP * \fBget_size\fP"
+.RI "Netsnmp_Iterator_Loop_Key * \fBget_first\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Loop_Key * \fBget_next\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Loop_Data * \fBget_data\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Data * \fBfree_user_ctx\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Ctx * \fBinit_loop_ctx\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Ctx * \fBcleanup_loop_ctx\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Ctx_Dup * \fBsave_pos\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Data * \fBrelease_data\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Data * \fBinsert_data\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Data * \fBremove_data\fP"
+.br
+.ti -1c
+.RI "Netsnmp_Iterator_Op * \fBget_size\fP"
 .br
 .ti -1c
 .RI "int \fBsorted\fP"
@@ -69,8 +70,6 @@
 This can be used by client handlers to store any information they need. 
 .PP
 Definition at line 69 of file container_iterator.c.
-.PP
-Referenced by netsnmp_container_iterator_get().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_leaf.3'
--- man/netsnmp_leaf.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_leaf.3	2010-06-10 18:02:54 +0000
@@ -1,43 +1,44 @@
-.TH "leaf_handlers" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "leaf_handlers" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-leaf_handlers \- Process individual leaf objects A group of handlers to implement individual leaf objects and instances (both scalar objects, and individual objects and instances within a table).  
+leaf_handlers \- 
+.PP
+Process individual leaf objects A group of handlers to implement individual leaf objects and instances (both scalar objects, and individual objects and instances within a table).  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBinstance\fP"
 .br
+.PP
+
 .RI "\fIProcess individual MIB instances easily. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBscalar\fP"
 .br
+.PP
+
 .RI "\fIProcess scalars easily. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBscalar_group\fP"
 .br
+.PP
+
 .RI "\fIProcess groups of scalars. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBwatcher\fP"
 .br
-.RI "\fIWatch a specified variable and process it as an instance or scalar object. \fP"
 .PP
 
+.RI "\fIWatch a specified \fBvariable\fP and process it as an instance or scalar object. \fP"
 .in -1c
 .SH "Detailed Description"
 .PP 
 Process individual leaf objects A group of handlers to implement individual leaf objects and instances (both scalar objects, and individual objects and instances within a table). 
-.PP
+
 These handlers will typically allow control to be passed down to a lower level, user-provided handler, but this is (usually) optional. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_library.3'
--- man/netsnmp_library.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_library.3	2010-06-10 18:02:54 +0000
@@ -1,18 +1,27 @@
-.TH "The Net-SNMP library" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "The Net-SNMP library" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
 The Net-SNMP library \- 
+.SS "Data Structures"
+
+.in +1c
+.ti -1c
+.RI "struct \fBsnmp_internal_session\fP"
+.br
+.ti -1c
+.RI "struct \fBsession_list\fP"
+.br
+.in -1c
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBasn1 parsing and datatype manipulation routines.\fP"
 .br
+.PP
+
 .RI "\fINote on. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBA generic callback mechanism\fP"
 .br
@@ -22,27 +31,24 @@
 .ti -1c
 .RI "\fBstorage space for defaults\fP"
 .br
+.PP
+
 .RI "\fIThe purpose of the default storage is three-fold:. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBmib parsing and datatype manipulation routines.\fP"
 .br
 .ti -1c
 .RI "\fBStore and retrieve data referenced by an OID.\fP"
 .br
+.PP
+
 .RI "\fIThis is essentially a way of storing data associated with a given OID. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBparsing various configuration files at run time\fP"
 .br
+.PP
+
 .RI "\fIThe read_config related functions are a fairly extensible system of parsing various configuration files at the run time. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBgeneric library based alarm timers for various parts of an application\fP"
 .br
@@ -56,16 +62,6 @@
 .RI "\fBMemory Utility Routines\fP"
 .br
 .in -1c
-.SS "Data Structures"
-
-.in +1c
-.ti -1c
-.RI "struct \fBsnmp_internal_session\fP"
-.br
-.ti -1c
-.RI "struct \fBsession_list\fP"
-.br
-.in -1c
 .SS "Defines"
 
 .in +1c
@@ -97,21 +93,6 @@
 .RI "#define \fBBSD4_2\fP"
 .br
 .ti -1c
-.RI "#define \fBNFDBITS\fP   (sizeof(\fBfd_mask\fP) * NBBY)"
-.br
-.ti -1c
-.RI "#define \fBFD_SET\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_CLR\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_ISSET\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_ZERO\fP(p)   memset((p), 0, sizeof(*(p)))"
-.br
-.ti -1c
 .RI "#define \fBDEFAULT_COMMUNITY\fP   'public'"
 .br
 .ti -1c
@@ -139,13 +120,6 @@
 .RI "#define \fBERROR_STAT_LENGTH\fP   11"
 .br
 .in -1c
-.SS "Typedefs"
-
-.in +1c
-.ti -1c
-.RI "typedef long \fBfd_mask\fP"
-.br
-.in -1c
 .SS "Functions"
 
 .in +1c
@@ -219,7 +193,7 @@
 .ti -1c
 .RI "void \fBinit_snmp\fP (const char *type)"
 .br
-.RI "\fICalls the functions to do config file loading and mib module parsing in the correct order. \fP"
+.RI "\fICalls the functions to do config file loading and mib \fBmodule\fP parsing in the correct order. \fP"
 .ti -1c
 .RI "void \fBsnmp_store\fP (const char *type)"
 .br
@@ -265,12 +239,24 @@
 .RI "int \fBsnmp_close_sessions\fP (void)"
 .br
 .ti -1c
+.RI "int \fBsnmpv3_header_realloc_rbuild\fP (u_char **pkt, size_t *pkt_len, size_t *offset, \fBnetsnmp_session\fP *session, \fBnetsnmp_pdu\fP *pdu)"
+.br
+.ti -1c
+.RI "int \fBsnmpv3_scopedPDU_header_realloc_rbuild\fP (u_char **pkt, size_t *pkt_len, size_t *offset, \fBnetsnmp_pdu\fP *pdu, size_t body_len)"
+.br
+.ti -1c
+.RI "int \fBsnmpv3_packet_realloc_rbuild\fP (u_char **pkt, size_t *pkt_len, size_t *offset, \fBnetsnmp_session\fP *session, \fBnetsnmp_pdu\fP *pdu, u_char *pdu_data, size_t pdu_data_len)"
+.br
+.ti -1c
 .RI "int \fBsnmpv3_packet_build\fP (\fBnetsnmp_session\fP *session, \fBnetsnmp_pdu\fP *pdu, u_char *packet, size_t *out_length, u_char *pdu_data, size_t pdu_data_len)"
 .br
 .ti -1c
 .RI "u_char * \fBsnmp_pdu_build\fP (\fBnetsnmp_pdu\fP *pdu, u_char *cp, size_t *out_length)"
 .br
 .ti -1c
+.RI "int \fBsnmp_pdu_realloc_rbuild\fP (u_char **pkt, size_t *pkt_len, size_t *offset, \fBnetsnmp_pdu\fP *pdu)"
+.br
+.ti -1c
 .RI "int \fBsnmpv3_parse\fP (\fBnetsnmp_pdu\fP *pdu, u_char *data, size_t *length, u_char **after_header, \fBnetsnmp_session\fP *sess)"
 .br
 .ti -1c
@@ -401,10 +387,10 @@
 
 .in +1c
 .ti -1c
-.RI "\fBmodule_init_list\fP * \fBinitlist\fP = NULL"
+.RI "struct \fBmodule_init_list\fP * \fBinitlist\fP = NULL"
 .br
 .ti -1c
-.RI "\fBmodule_init_list\fP * \fBnoinitlist\fP = NULL"
+.RI "struct \fBmodule_init_list\fP * \fBnoinitlist\fP = NULL"
 .br
 .ti -1c
 .RI "\fBnetsnmp_subtree\fP * \fBsubtrees\fP"
@@ -416,7 +402,7 @@
 .RI "u_char \fBreturn_buf\fP [258]"
 .br
 .ti -1c
-.RI "timeval \fBstarttime\fP"
+.RI "struct timeval \fBstarttime\fP"
 .br
 .ti -1c
 .RI "int \fBcallback_master_num\fP = -1"
@@ -425,10 +411,10 @@
 .RI "oid \fBnullOid\fP [] = { 0, 0 }"
 .br
 .ti -1c
-.RI "int \fBnullOidLen\fP = sizeof(\fBnullOid\fP)"
+.RI "int \fBnullOidLen\fP = sizeof(nullOid)"
 .br
 .ti -1c
-.RI "\fBsession_list\fP * \fBSessions\fP = NULL"
+.RI "struct \fBsession_list\fP * \fBSessions\fP = NULL"
 .br
 .ti -1c
 .RI "int \fBsnmp_errno\fP = 0"
@@ -436,9 +422,7 @@
 .in -1c
 .SH "Define Documentation"
 .PP 
-.SS "#define timercmp(tvp, uvp, cmp)"
-.PP
-\fBValue:\fP
+.SS "#define timercmp(tvp, uvp, cmp)"\fBValue:\fP
 .PP
 .nf
 /* CSTYLED */ \
@@ -449,22 +433,18 @@
 .fi
 .PP
 Definition at line 148 of file snmp_api.c.
-.PP
-Referenced by netsnmp_addrcache_add(), and snmp_sess_timeout().
 .SH "Function Documentation"
 .PP 
 .SS "int _sess_read (void * sessp, fd_set * fdset)"
 .PP
-Definition at line 5390 of file snmp_api.c.
-.PP
-References asn_check_packet(), snmp_session::callback, snmp_session::callback_magic, snmp_internal_session::check_packet, netsnmp_transport_s::f_accept, netsnmp_transport_s::f_close, netsnmp_transport_s::f_recv, FD_ISSET, netsnmp_transport_s::flags, snmp_internal_session::hook_build, snmp_internal_session::hook_create_pdu, snmp_internal_session::hook_parse, snmp_internal_session::hook_post, snmp_internal_session::hook_pre, snmp_internal_session::hook_realloc_build, session_list::internal, MAX_PACKET_LENGTH, MAXIMUM_PACKET_SIZE, session_list::next, NULL, snmp_internal_session::packet, snmp_internal_session::packet_len, snmp_internal_session::packet_size, snmp_session::s_errno, snmp_session::s_snmp_errno, session_list::session, Sessions, SNMP_FREE, snmp_log(), snmp_sess_add_ex(), snmp_set_detail(), netsnmp_transport_s::sock, strerror(), and session_list::transport.
-.PP
-Referenced by snmp_sess_read().
+XXX-rks: why no SNMP_FREE(isp->packet); ??
+.PP
+XXX-rks: why no SNMP_FREE(isp->packet); ?? 
+.PP
+Definition at line 5412 of file snmp_api.c.
 .SS "int init_agent (const char * app)"
 .PP
-Initialize the agent. 
-.PP
-Calls into init_agent_read_config to set tha app's configuration file in the appropriate default storage space, NETSNMP_DS_LIB_APPTYPE. Need to call init_agent before calling init_snmp.
+Initialize the agent. Calls into init_agent_read_config to set tha app's configuration file in the appropriate default storage space, NETSNMP_DS_LIB_APPTYPE. Need to call init_agent before calling init_snmp.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -484,13 +464,9 @@
 
 .PP
 Definition at line 270 of file snmp_vars.c.
-.PP
-References _init_agent_callback_transport, init_traps(), netsnmp_ds_get_boolean(), netsnmp_ds_set_boolean(), netsnmp_init_helpers(), NULL, setup_tree(), snmp_log(), and starttime.
 .SS "void init_snmp (const char * type)"
 .PP
-Calls the functions to do config file loading and mib module parsing in the correct order. 
-.PP
-\fBParameters:\fP
+Calls the functions to do config file loading and mib \fBmodule\fP parsing in the correct order. \fBParameters:\fP
 .RS 4
 \fItype\fP label for the config file 'type'
 .RE
@@ -507,14 +483,10 @@
 .PP
 
 .PP
-Definition at line 766 of file snmp_api.c.
-.PP
-References init_callbacks(), init_snmp_alarm(), init_snmp_logging(), netsnmp_ds_get_string(), netsnmp_ds_set_string(), netsnmp_init_mib(), read_configs(), read_premib_configs(), register_mib_handlers(), and snmp_init_statistics().
+Definition at line 787 of file snmp_api.c.
 .SS "int netsnmp_oid_compare_ll (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2, size_t * offpt)"
 .PP
-lexicographical compare two object identifiers and return the point where they differ 
-.PP
-Caution: this method is called often by command responder applications (ie, agent).
+lexicographical compare two object identifiers and return the point where they differ Caution: this method is called often by command responder applications (ie, agent).
 .PP
 \fBReturns:\fP
 .RS 4
@@ -523,14 +495,10 @@
 .PP
 
 .PP
-Definition at line 6328 of file snmp_api.c.
-.PP
-Referenced by netsnmp_subtree_change_next(), netsnmp_subtree_change_prev(), and netsnmp_subtree_find_prev().
+Definition at line 6350 of file snmp_api.c.
 .SS "int netsnmp_oid_equals (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2)"
 .PP
-Compares 2 OIDs to determine if they are exactly equal. 
-.PP
-This should be faster than doing a snmp_oid_compare for different length OIDs, since the length is checked first and if != returns immediately. Might be very slighly faster if lengths are ==. 
+Compares 2 OIDs to determine if they are exactly equal. This should be faster than doing a snmp_oid_compare for different length OIDs, since the length is checked first and if != returns immediately. Might be very slighly faster if lengths are ==. 
 .PP
 \fBParameters:\fP
 .RS 4
@@ -550,14 +518,10 @@
 .PP
 
 .PP
-Definition at line 6409 of file snmp_api.c.
-.PP
-Referenced by netsnmp_cache_find_by_oid(), netsnmp_subtree_free(), netsnmp_subtree_load(), netsnmp_unregister_mib_table_row(), and unregister_mib_context().
+Definition at line 6431 of file snmp_api.c.
 .SS "int netsnmp_oid_find_prefix (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2)"
 .PP
-Given two OIDs, determine the common prefix to them both. 
-.PP
-\fBParameters:\fP
+Given two OIDs, determine the common prefix to them both. \fBParameters:\fP
 .RS 4
 \fIin_name1\fP A pointer to the first oid. 
 .br
@@ -575,16 +539,10 @@
 .PP
 
 .PP
-Definition at line 6465 of file snmp_api.c.
-.PP
-References SNMP_MIN.
-.PP
-Referenced by netsnmp_add_varbind_to_cache().
+Definition at line 6487 of file snmp_api.c.
 .SS "int netsnmp_oid_is_subtree (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2)"
 .PP
-Identical to netsnmp_oid_equals, except only the length up to len1 is compared. 
-.PP
-Functionally, this determines if in_name2 is equal or a subtree of in_name1 
+Identical to netsnmp_oid_equals, except only the length up to len1 is compared. Functionally, this determines if in_name2 is equal or a subtree of in_name1 
 .PP
 \fBParameters:\fP
 .RS 4
@@ -604,12 +562,10 @@
 .PP
 
 .PP
-Definition at line 6445 of file snmp_api.c.
+Definition at line 6467 of file snmp_api.c.
 .SS "int snmp_oid_compare (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2)"
 .PP
-lexicographical compare two object identifiers. 
-.PP
-Caution: this method is called often by command responder applications (ie, agent).
+lexicographical compare two object identifiers. Caution: this method is called often by command responder applications (ie, agent).
 .PP
 \fBReturns:\fP
 .RS 4
@@ -618,14 +574,10 @@
 .PP
 
 .PP
-Definition at line 6279 of file snmp_api.c.
-.PP
-Referenced by check_getnext_results(), convert_v2pdu_to_v1(), find_varbind_in_list(), lookup_cache_find(), netsnmp_bulk_to_next_fix_requests(), netsnmp_check_getnext_reply(), netsnmp_container_table_row_insert(), netsnmp_insert_iterator_context(), netsnmp_insert_table_row(), netsnmp_instance_helper_handler(), netsnmp_iterator_row_get_byoid(), netsnmp_iterator_row_next_byoid(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_send_traps(), netsnmp_stash_to_next_helper(), netsnmp_subtree_compare(), netsnmp_subtree_find(), netsnmp_subtree_find_next(), netsnmp_subtree_find_prev(), netsnmp_subtree_load(), netsnmp_subtree_split(), netsnmp_table_data_add_row(), netsnmp_table_data_get_from_oid(), netsnmp_table_data_helper_handler(), netsnmp_table_data_row_next_byoid(), netsnmp_tdata_compare_oid(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), snmp_oidsubtree_compare(), snmp_oidtree_compare(), and table_helper_handler().
+Definition at line 6301 of file snmp_api.c.
 .SS "int snmp_oidtree_compare (const oid * in_name1, size_t len1, const oid * in_name2, size_t len2)"
 .PP
-Compares 2 OIDs to determine if they are equal up until the shortest length. 
-.PP
-\fBParameters:\fP
+Compares 2 OIDs to determine if they are equal up until the shortest length. \fBParameters:\fP
 .RS 4
 \fIin_name1\fP A pointer to the first oid. 
 .br
@@ -643,16 +595,10 @@
 .PP
 
 .PP
-Definition at line 6381 of file snmp_api.c.
-.PP
-References snmp_oid_compare().
-.PP
-Referenced by netsnmp_query_walk(), and netsnmp_tdata_compare_subtree_oid().
+Definition at line 6403 of file snmp_api.c.
 .SS "void snmp_shutdown (const char * type)"
 .PP
-Shuts down the application, saving any needed persistent storage, and appropriate clean up. 
-.PP
-\fBParameters:\fP
+Shuts down the application, saving any needed persistent storage, and appropriate clean up. \fBParameters:\fP
 .RS 4
 \fItype\fP Label for the config file 'type' used
 .RE
@@ -664,14 +610,10 @@
 .PP
 
 .PP
-Definition at line 834 of file snmp_api.c.
-.PP
-References clear_callback(), netsnmp_ds_shutdown(), NULL, shutdown_mib(), shutdown_snmp_logging(), snmp_alarm_unregister_all(), snmp_call_callbacks(), snmp_close_sessions(), snmp_store(), and unregister_all_config_handlers().
+Definition at line 853 of file snmp_api.c.
 .SS "int snmpv3_engineID_probe (struct \fBsession_list\fP * slp, \fBnetsnmp_session\fP * in_session)"
 .PP
-probe for peer engineID 
-.PP
-\fBParameters:\fP
+probe for peer engineID \fBParameters:\fP
 .RS 4
 \fIslp\fP session list pointer. 
 .br
@@ -681,7 +623,7 @@
 \fBNote:\fP
 .RS 4
 .IP "\(bu" 2
-called by _sess_open(), \fBsnmp_sess_add_ex()\fP
+called by _sess_open(), snmp_sess_add_ex()
 .IP "\(bu" 2
 in_session is the user supplied session provided to those functions.
 .IP "\(bu" 2
@@ -698,8 +640,7 @@
 .PP
 
 .PP
-Definition at line 1254 of file snmp_api.c.
-.PP
-References create_user_from_session(), snmp_session::engineBoots, snmp_session::engineTime, snmp_session::flags, NULL, snmp_session::s_snmp_errno, snmp_session::securityEngineID, snmp_session::securityEngineIDLen, session_list::session, snmp_api_errstring(), snmp_errstring(), snmp_sess_synch_response(), TRUE, and snmp_session::version.
-.PP
-Referenced by snmp_sess_add_ex().
+Definition at line 1276 of file snmp_api.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_mib_maintenance.3'
--- man/netsnmp_mib_maintenance.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_mib_maintenance.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "mib_maintenance" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "mib_maintenance" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-mib_maintenance \- Routines for maintaining a MIB table.  
+mib_maintenance \- 
+.PP
+Routines for maintaining a MIB table.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -40,7 +41,6 @@
 .SH "Detailed Description"
 .PP 
 Routines for maintaining a MIB table. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "void netsnmp_generic_extract_row (\fBnetsnmp_request_info\fP * request)"
@@ -55,25 +55,19 @@
 Definition at line 189 of file table_generic.c.
 .SS "netsnmp_generic_free_handler (\fBnetsnmp_mib_handler\fP * handler)"
 .PP
-Free a MIB handler structure, releasing any related resources. 
-.PP
-Possibly called automatically by 'netsnmp_unregister_handler' ? 
+Free a MIB handler structure, releasing any related resources. Possibly called automatically by 'netsnmp_unregister_handler' ? 
 .PP
 Definition at line 165 of file table_generic.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_generic_get_handler (void)"
 .PP
-Create a MIB handler structure. 
-.PP
-This will typically be invoked within the corresponding 'netsnmp_generic_register' routine (or the registration code of a sub-helper based on this helper).
+Create a MIB handler structure. This will typically be invoked within the corresponding 'netsnmp_generic_register' routine (or the registration code of a sub-helper based on this helper).
 .PP
 Alternatively, it might be called from the initialisation code of a particular MIB table implementation. 
 .PP
 Definition at line 158 of file table_generic.c.
 .SS "void netsnmp_generic_insert_row (\fBnetsnmp_request_info\fP * request, void * row)"
 .PP
-Associate a (new) row with the requested varbind. 
-.PP
-The row should also be associated with any other varbinds that refer to the same index values. 
+Associate a (new) row with the requested varbind. The row should also be associated with any other varbinds that refer to the same index values. 
 .PP
 Definition at line 203 of file table_generic.c.
 .SS "int netsnmp_generic_register (\fBnetsnmp_handler_registration\fP * reginfo, void * table, \fBnetsnmp_table_registration_info\fP * table_info)"
@@ -83,8 +77,9 @@
 Definition at line 172 of file table_generic.c.
 .SS "int netsnmp_generic_unregister (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
-Unregister a MIB table from the SNMP agent. 
-.PP
-This should also release the internal representation of the table. ?? Is a table-specific version of this needed, or would 'netsnmp_unregister_handler' + 'netsnmp_generic_free_handler' do? 
+Unregister a MIB table from the SNMP agent. This should also release the internal representation of the table. ?? Is a table-specific version of this needed, or would 'netsnmp_unregister_handler' + 'netsnmp_generic_free_handler' do? 
 .PP
 Definition at line 183 of file table_generic.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_mib_utilities.3'
--- man/netsnmp_mib_utilities.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_mib_utilities.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "mib parsing and datatype manipulation routines." 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "mib parsing and datatype manipulation routines." 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -17,10 +17,10 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fB_PrefixList\fP * \fBPrefixListPtr\fP"
+.RI "typedef struct \fB_PrefixList\fP * \fBPrefixListPtr\fP"
 .br
 .ti -1c
-.RI "typedef \fB_PrefixList\fP \fBPrefixList\fP"
+.RI "typedef struct \fB_PrefixList\fP \fBPrefixList\fP"
 .br
 .in -1c
 .SS "Enumerations"
@@ -63,7 +63,7 @@
 .ti -1c
 .RI "int \fBsprint_realloc_timeticks\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP *var, const struct \fBenum_list\fP *enums, const char *hint, const char *units)"
 .br
-.RI "\fIPrints a timetick variable into a buffer. \fP"
+.RI "\fIPrints a timetick \fBvariable\fP into a buffer. \fP"
 .ti -1c
 .RI "int \fBsprint_realloc_hinted_integer\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, long val, const char decimaltype, const char *hint, const char *units)"
 .br
@@ -110,11 +110,11 @@
 .ti -1c
 .RI "int \fBsprint_realloc_by_type\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP *var, const struct \fBenum_list\fP *enums, const char *hint, const char *units)"
 .br
-.RI "\fIUniversal print routine, prints a variable into a buffer according to the variable type. \fP"
+.RI "\fIUniversal print routine, prints a \fBvariable\fP into a buffer according to the \fBvariable\fP type. \fP"
 .ti -1c
-.RI "\fBtree\fP * \fBget_tree_head\fP (void)"
+.RI "struct \fBtree\fP * \fBget_tree_head\fP (void)"
 .br
-.RI "\fIRetrieves the tree head. \fP"
+.RI "\fIRetrieves the \fBtree\fP head. \fP"
 .ti -1c
 .RI "char * \fBsnmp_out_toggle_options\fP (char *options)"
 .br
@@ -173,7 +173,7 @@
 .RI "void \fBnetsnmp_sprint_realloc_objid\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, int *buf_overflow, const oid *objid, size_t objidlen)"
 .br
 .ti -1c
-.RI "\fBtree\fP * \fBnetsnmp_sprint_realloc_objid_tree\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, int *buf_overflow, const oid *objid, size_t objidlen)"
+.RI "struct \fBtree\fP * \fBnetsnmp_sprint_realloc_objid_tree\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, int *buf_overflow, const oid *objid, size_t objidlen)"
 .br
 .ti -1c
 .RI "int \fBsprint_realloc_objid\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const oid *objid, size_t objidlen)"
@@ -198,11 +198,11 @@
 .ti -1c
 .RI "void \fBprint_variable\fP (const oid *objid, size_t objidlen, const \fBnetsnmp_variable_list\fP *\fBvariable\fP)"
 .br
-.RI "\fIPrints a variable to stdout. \fP"
+.RI "\fIPrints a \fBvariable\fP to stdout. \fP"
 .ti -1c
 .RI "void \fBfprint_variable\fP (FILE *f, const oid *objid, size_t objidlen, const \fBnetsnmp_variable_list\fP *\fBvariable\fP)"
 .br
-.RI "\fIPrints a variable to a file descriptor. \fP"
+.RI "\fIPrints a \fBvariable\fP to a file descriptor. \fP"
 .ti -1c
 .RI "int \fBsprint_realloc_value\fP (u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, const oid *objid, size_t objidlen, const \fBnetsnmp_variable_list\fP *\fBvariable\fP)"
 .br
@@ -238,7 +238,7 @@
 .RI "int \fBdump_realloc_oid_to_string\fP (const oid *objid, size_t objidlen, u_char **buf, size_t *buf_len, size_t *out_len, int allow_realloc, char quotechar)"
 .br
 .ti -1c
-.RI "\fBtree\fP * \fBget_tree\fP (const oid *objid, size_t objidlen, struct \fBtree\fP *subtree)"
+.RI "struct \fBtree\fP * \fBget_tree\fP (const oid *objid, size_t objidlen, struct \fBtree\fP *subtree)"
 .br
 .ti -1c
 .RI "void \fBprint_description\fP (oid *objid, size_t objidlen, int width)"
@@ -260,12 +260,6 @@
 .ti -1c
 .RI "int \fBget_wild_node\fP (const char *name, oid *objid, size_t *objidlen)"
 .br
-.RI "\fI\fBSee also:\fP
-.RS 4
-comments on find_best_tree_node for usage after first time. 
-.RE
-.PP
-\fP"
 .ti -1c
 .RI "int \fBget_node\fP (const char *name, oid *objid, size_t *objidlen)"
 .br
@@ -381,10 +375,10 @@
 
 .in +1c
 .ti -1c
-.RI "\fBtree\fP * \fBtree_head\fP"
+.RI "struct \fBtree\fP * \fBtree_head\fP"
 .br
 .ti -1c
-.RI "\fBtree\fP * \fBMib\fP"
+.RI "struct \fBtree\fP * \fBMib\fP"
 .br
 .ti -1c
 .RI "oid \fBRFC1213_MIB\fP [] = { 1, 3, 6, 1, 2, 1 }"
@@ -397,9 +391,7 @@
 .PP 
 .SS "int _sprint_hexstring_line (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const u_char * cp, size_t line_len)"
 .PP
-Prints a hexadecimal string into a buffer. 
-.PP
-The characters pointed by *cp are encoded as hexadecimal string.
+Prints a hexadecimal string into a buffer. The characters pointed by *cp are encoded as hexadecimal string.
 .PP
 If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
@@ -426,24 +418,16 @@
 
 .PP
 Definition at line 271 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), and snmp_realloc().
-.PP
-Referenced by sprint_realloc_hexstring().
 .SS "int build_oid (oid ** out, size_t * out_len, oid * prefix, size_t prefix_len, \fBnetsnmp_variable_list\fP * indexes)"
 .PP
-Definition at line 3578 of file mib.c.
-.PP
-References build_oid_noalloc(), tree::indexes, and snmp_clone_mem().
-.PP
-Referenced by _netsnmp_tdata_generate_index_oid(), netsnmp_table_build_oid(), and netsnmp_table_data_generate_index_oid().
+xxx-rks: should free previous value? 
+.PP
+Definition at line 3581 of file mib.c.
 .SS "int build_oid_segment (\fBnetsnmp_variable_list\fP * var)"
 .PP
-Takes the value in VAR and turns it into an OID segment in var->name. 
-.PP
-\fBParameters:\fP
+Takes the value in VAR and turns it into an OID segment in var->name. \fBParameters:\fP
 .RS 4
-\fIvar\fP The variable.
+\fIvar\fP The \fBvariable\fP.
 .RE
 .PP
 \fBReturns:\fP
@@ -453,16 +437,10 @@
 .PP
 
 .PP
-Definition at line 3442 of file mib.c.
-.PP
-References netsnmp_vardata::integer, variable_list::name, variable_list::name_length, variable_list::name_loc, NULL, netsnmp_vardata::objid, SNMP_FREE, netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by build_oid_noalloc().
+Definition at line 3445 of file mib.c.
 .SS "void fprint_description (FILE * f, oid * objid, size_t objidlen, int width)"
 .PP
-Prints on oid description into a file descriptor. 
-.PP
-\fBParameters:\fP
+Prints on oid description into a file descriptor. \fBParameters:\fP
 .RS 4
 \fIf\fP The file descriptor to print to. 
 .br
@@ -475,16 +453,10 @@
 .PP
 
 .PP
-Definition at line 4437 of file mib.c.
-.PP
-References NULL, SNMP_FREE, and sprint_realloc_description().
-.PP
-Referenced by print_description().
+Definition at line 4451 of file mib.c.
 .SS "void fprint_objid (FILE * f, const oid * objid, size_t objidlen)"
 .PP
-Prints an oid to a file descriptor. 
-.PP
-\fBParameters:\fP
+Prints an oid to a file descriptor. \fBParameters:\fP
 .RS 4
 \fIf\fP The file descriptor to print to. 
 .br
@@ -495,16 +467,10 @@
 .PP
 
 .PP
-Definition at line 3163 of file mib.c.
-.PP
-References netsnmp_sprint_realloc_objid_tree(), NULL, and SNMP_FREE.
-.PP
-Referenced by print_objid().
+Definition at line 3164 of file mib.c.
 .SS "void fprint_variable (FILE * f, const oid * objid, size_t objidlen, const \fBnetsnmp_variable_list\fP * variable)"
 .PP
-Prints a variable to a file descriptor. 
-.PP
-\fBParameters:\fP
+Prints a \fBvariable\fP to a file descriptor. \fBParameters:\fP
 .RS 4
 \fIf\fP The file descriptor to print to. 
 .br
@@ -512,76 +478,50 @@
 .br
 \fIobjidlen\fP The length of teh object id. 
 .br
-\fIvariable\fP The variable to print. 
+\fI\fBvariable\fP\fP The \fBvariable\fP to print. 
 .RE
 .PP
 
 .PP
-Definition at line 3317 of file mib.c.
-.PP
-References NULL, SNMP_FREE, and sprint_realloc_variable().
-.PP
-Referenced by print_variable().
-.SS "struct \fBtree\fP* get_tree_head (void)"
-.PP
-Retrieves the tree head. 
-.PP
-\fBReturns:\fP
+Definition at line 3318 of file mib.c.
+.SS "struct \fBtree\fP* get_tree_head (void)\fC [read]\fP"
+.PP
+Retrieves the \fBtree\fP head. \fBReturns:\fP
 .RS 4
-the tree head. 
+the \fBtree\fP head. 
 .RE
 .PP
 
 .PP
 Definition at line 2017 of file mib.c.
-.PP
-References tree_head.
-.PP
-Referenced by netsnmp_config_parse_table_set(), and snmp_add_var().
-.SS "int get_wild_node (const char * name, oid * objid, size_t * objidlen)"
-.PP
-\fBSee also:\fP
+.SS "int get_wild_node (const char * name, oid * objid, size_t * objidlen)"\fBSee also:\fP
 .RS 4
 comments on find_best_tree_node for usage after first time. 
 .RE
 .PP
 
 .PP
-Definition at line 5457 of file mib.c.
-.PP
-References get_node(), tree::label, NULL, and tree_head.
-.PP
-Referenced by snmp_parse_oid().
+Definition at line 5490 of file mib.c.
 .SS "void netsnmp_fixup_mib_directory (void)"
 .PP
-Definition at line 2479 of file mib.c.
-.PP
-References netsnmp_get_mib_directory(), netsnmp_getenv(), netsnmp_set_mib_directory(), NULL, and SNMP_FREE.
-.PP
-Referenced by netsnmp_init_mib().
+swap in the new value and repeat 
+.PP
+Definition at line 2480 of file mib.c.
 .SS "char* netsnmp_get_mib_directory (void)"
 .PP
-Definition at line 2432 of file mib.c.
-.PP
-References netsnmp_ds_get_string(), netsnmp_getenv(), netsnmp_set_mib_directory(), and NULL.
-.PP
-Referenced by netsnmp_fixup_mib_directory(), and netsnmp_init_mib().
+Check if the environment \fBvariable\fP is set
+.PP
+Not set use hard coded path 
+.PP
+Definition at line 2433 of file mib.c.
 .SS "void netsnmp_init_mib (void)"
 .PP
-Initialises the mib reader. 
-.PP
-Reads in all settings from the environment. 
-.PP
-Definition at line 2526 of file mib.c.
-.PP
-References tree::child_list, tree::label, _PrefixList::len, Mib, mib_prefixes, netsnmp_fixup_mib_directory(), netsnmp_get_mib_directory(), netsnmp_getenv(), NULL, SNMP_FREE, _PrefixList::str, and tree_head.
-.PP
-Referenced by init_mib(), and init_snmp().
+Initialises the mib reader. Reads in all settings from the environment. 
+.PP
+Definition at line 2527 of file mib.c.
 .SS "int netsnmp_oid2chars (char * C, int L, const oid * O)"
 .PP
-Converts an OID to its character form. 
-.PP
-in example 5 . 1 . 2 . 3 . 4 . 5 = 12345
+Converts an OID to its character form. in example 5 . 1 . 2 . 3 . 4 . 5 = 12345
 .PP
 \fBParameters:\fP
 .RS 4
@@ -601,14 +541,10 @@
 .PP
 length 
 .PP
-Definition at line 6244 of file mib.c.
-.PP
-Referenced by netsnmp_oid2str().
+Definition at line 6277 of file mib.c.
 .SS "int netsnmp_oid2str (char * S, int L, oid * O)"
 .PP
-Converts an OID to its string form. 
-.PP
-in example 5 . 'h' . 'e' . 'l' . 'l' . 'o' = 'hello\\0' (null terminated)
+Converts an OID to its string form. in example 5 . 'h' . 'e' . 'l' . 'l' . 'o' = 'hello\\0' (null terminated)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -626,21 +562,19 @@
 .PP
 
 .PP
-Definition at line 6272 of file mib.c.
-.PP
-References netsnmp_oid2chars().
+Definition at line 6305 of file mib.c.
 .SS "void netsnmp_set_mib_directory (const char * dir)"
 .PP
-Definition at line 2377 of file mib.c.
-.PP
-References netsnmp_ds_get_string(), netsnmp_ds_set_string(), NULL, and SNMP_FREE.
-.PP
-Referenced by netsnmp_fixup_mib_directory(), and netsnmp_get_mib_directory().
+New dir starts with '+', thus we add it.
+.PP
+If dir starts with '+' skip '+' it.
+.PP
+set_string calls strdup, so if we allocated memory, free it 
+.PP
+Definition at line 2378 of file mib.c.
 .SS "int netsnmp_str2oid (const char * S, oid * O, int L)"
 .PP
-Converts a string to its OID form. 
-.PP
-in example 'hello' = 5 . 'h' . 'e' . 'l' . 'l' . 'o'
+Converts a string to its OID form. in example 'hello' = 5 . 'h' . 'e' . 'l' . 'l' . 'o'
 .PP
 \fBParameters:\fP
 .RS 4
@@ -658,40 +592,30 @@
 .PP
 
 .PP
-Definition at line 6209 of file mib.c.
+Definition at line 6242 of file mib.c.
 .SS "void print_description (oid * objid, size_t objidlen, int width)"
 .PP
-Prints on oid description on stdout. 
-.PP
-\fBSee also:\fP
+Prints on oid description on stdout. \fBSee also:\fP
 .RS 4
 \fBfprint_description\fP 
 .RE
 .PP
 
 .PP
-Definition at line 4421 of file mib.c.
-.PP
-References fprint_description().
+Definition at line 4435 of file mib.c.
 .SS "void print_mib (FILE * fp)"
 .PP
-Prints the MIBs to the file fp. 
-.PP
-\fBParameters:\fP
+Prints the MIBs to the file fp. \fBParameters:\fP
 .RS 4
 \fIfp\fP The file descriptor to print to. 
 .RE
 .PP
 
 .PP
-Definition at line 2741 of file mib.c.
-.PP
-References tree_head.
+Definition at line 2742 of file mib.c.
 .SS "void print_objid (const oid * objid, size_t objidlen)"
 .PP
-Prints an oid to stdout. 
-.PP
-\fBParameters:\fP
+Prints an oid to stdout. \fBParameters:\fP
 .RS 4
 \fIobjid\fP The oid to print 
 .br
@@ -700,32 +624,24 @@
 .PP
 
 .PP
-Definition at line 3149 of file mib.c.
-.PP
-References fprint_objid().
+Definition at line 3150 of file mib.c.
 .SS "void print_variable (const oid * objid, size_t objidlen, const \fBnetsnmp_variable_list\fP * variable)"
 .PP
-Prints a variable to stdout. 
-.PP
-\fBParameters:\fP
+Prints a \fBvariable\fP to stdout. \fBParameters:\fP
 .RS 4
 \fIobjid\fP The object id. 
 .br
 \fIobjidlen\fP The length of teh object id. 
 .br
-\fIvariable\fP The variable to print. 
+\fI\fBvariable\fP\fP The \fBvariable\fP to print. 
 .RE
 .PP
 
 .PP
-Definition at line 3301 of file mib.c.
-.PP
-References fprint_variable().
+Definition at line 3302 of file mib.c.
 .SS "int read_objid (const char * input, oid * output, size_t * out_len)"
 .PP
-Reads an object identifier from an input string into internal OID form. 
-.PP
-When called, out_len must hold the maximum length of the output array.
+Reads an object identifier from an input string into internal OID form. When called, out_len must hold the maximum length of the output array.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -743,39 +659,25 @@
 .PP
 If an error occurs, this function returns 0 and MAY set snmp_errno. snmp_errno is NOT set if SET_SNMP_ERROR evaluates to nothing. This can make multi-threaded use a tiny bit more robust. 
 .PP
-Definition at line 2839 of file mib.c.
-.PP
-References get_node(), netsnmp_ds_get_boolean(), NULL, SNMP_FREE, and tree_head.
-.PP
-Referenced by read_config_read_objid(), and snmp_parse_oid().
+Definition at line 2840 of file mib.c.
 .SS "void set_function (struct \fBtree\fP * subtree)"
 .PP
-Set's the printing function printomat in a subtree according it's type. 
-.PP
-\fBParameters:\fP
+Set's the printing function printomat in a subtree according it's type. \fBParameters:\fP
 .RS 4
 \fIsubtree\fP The subtree to set. 
 .RE
 .PP
 
 .PP
-Definition at line 2762 of file mib.c.
-.PP
-References NULL, tree::printer, tree::printomat, sprint_realloc_bitstring(), sprint_realloc_by_type(), sprint_realloc_counter(), sprint_realloc_counter64(), sprint_realloc_gauge(), sprint_realloc_integer(), sprint_realloc_ipaddress(), sprint_realloc_networkaddress(), sprint_realloc_nsapaddress(), sprint_realloc_null(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), sprint_realloc_opaque(), sprint_realloc_timeticks(), sprint_realloc_uinteger(), and tree::type.
+Definition at line 2763 of file mib.c.
 .SS "void shutdown_mib (void)"
 .PP
 Unloads all mibs. 
 .PP
-Definition at line 2716 of file mib.c.
-.PP
-References tree::label, Mib, NULL, SNMP_FREE, and tree_head.
-.PP
-Referenced by snmp_shutdown().
+Definition at line 2717 of file mib.c.
 .SS "void snmp_in_toggle_options_usage (const char * lead, FILE * outf)"
 .PP
-Prints out a help usage for the in* toggle options. 
-.PP
-\fBParameters:\fP
+Prints out a help usage for the in* toggle options. \fBParameters:\fP
 .RS 4
 \fIlead\fP The lead to print for every line. 
 .br
@@ -784,12 +686,10 @@
 .PP
 
 .PP
-Definition at line 2289 of file mib.c.
+Definition at line 2290 of file mib.c.
 .SS "oid* snmp_parse_oid (const char * argv, oid * root, size_t * rootlen)"
 .PP
-Given a string, parses an oid out of it (if possible). 
-.PP
-It will try to parse it based on predetermined configuration if present or by every method possible otherwise. If a suffix has been registered using NETSNMP_DS_LIB_OIDSUFFIX, it will be appended to the input string before processing.
+Given a string, parses an oid out of it (if possible). It will try to parse it based on predetermined configuration if present or by every method possible otherwise. If a suffix has been registered using NETSNMP_DS_LIB_OIDSUFFIX, it will be appended to the input string before processing.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -807,16 +707,10 @@
 .PP
 
 .PP
-Definition at line 5815 of file mib.c.
-.PP
-References clear_tree_flags(), get_node(), get_wild_node(), netsnmp_ds_get_boolean(), netsnmp_ds_get_string(), NULL, read_objid(), and tree_head.
-.PP
-Referenced by netsnmp_config_parse_table_set(), and snmp_add_var().
+Definition at line 5848 of file mib.c.
 .SS "int sprint_realloc_asciistring (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const u_char * cp, size_t len)"
 .PP
-Prints an ascii string into a buffer. 
-.PP
-The characters pointed by *cp are encoded as an ascii string.
+Prints an ascii string into a buffer. The characters pointed by *cp are encoded as an ascii string.
 .PP
 If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
@@ -843,15 +737,9 @@
 
 .PP
 Definition at line 367 of file mib.c.
-.PP
-References snmp_realloc().
-.PP
-Referenced by asn_build_string(), asn_parse_string(), snprint_asciistring(), and sprint_realloc_octet_string().
 .SS "int sprint_realloc_badtype (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Fallback routine for a bad type, prints 'Variable has bad type' into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Fallback routine for a bad type, prints 'Variable has bad type' into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -863,9 +751,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -880,15 +768,9 @@
 
 .PP
 Definition at line 1902 of file mib.c.
-.PP
-References snmp_strcat().
-.PP
-Referenced by snprint_badtype(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_bitstring (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a bit string into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a bit string into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -900,9 +782,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -917,15 +799,9 @@
 
 .PP
 Definition at line 1763 of file mib.c.
-.PP
-References netsnmp_vardata::bitstring, enum_list::label, netsnmp_ds_get_boolean(), enum_list::next, NULL, snmp_strcat(), sprint_realloc_by_type(), sprint_realloc_hexstring(), variable_list::type, variable_list::val, variable_list::val_len, and enum_list::value.
-.PP
-Referenced by set_function(), snprint_bitstring(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_by_type (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Universal print routine, prints a variable into a buffer according to the variable type. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Universal print routine, prints a \fBvariable\fP into a buffer according to the \fBvariable\fP type. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -937,9 +813,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -954,15 +830,9 @@
 
 .PP
 Definition at line 1937 of file mib.c.
-.PP
-References sprint_realloc_badtype(), sprint_realloc_bitstring(), sprint_realloc_counter(), sprint_realloc_counter64(), sprint_realloc_gauge(), sprint_realloc_integer(), sprint_realloc_ipaddress(), sprint_realloc_null(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), sprint_realloc_opaque(), sprint_realloc_timeticks(), sprint_realloc_uinteger(), and variable_list::type.
-.PP
-Referenced by set_function(), snprint_by_type(), sprint_realloc_bitstring(), sprint_realloc_counter(), sprint_realloc_counter64(), sprint_realloc_gauge(), sprint_realloc_integer(), sprint_realloc_ipaddress(), sprint_realloc_networkaddress(), sprint_realloc_nsapaddress(), sprint_realloc_null(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), sprint_realloc_opaque(), sprint_realloc_timeticks(), sprint_realloc_uinteger(), sprint_realloc_value(), sprint_realloc_variable(), and table_helper_handler().
 .SS "int sprint_realloc_counter (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a counter value into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a counter value into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -974,9 +844,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -991,15 +861,9 @@
 
 .PP
 Definition at line 1530 of file mib.c.
-.PP
-References netsnmp_vardata::integer, netsnmp_ds_get_boolean(), NULL, snmp_strcat(), sprint_realloc_by_type(), variable_list::type, and variable_list::val.
-.PP
-Referenced by set_function(), snprint_counter(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_counter64 (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a counter into a buffer. 
-.PP
-The variable var is encoded as a counter value.
+Prints a counter into a buffer. The \fBvariable\fP var is encoded as a counter value.
 .PP
 If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
@@ -1013,9 +877,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1030,15 +894,9 @@
 
 .PP
 Definition at line 846 of file mib.c.
-.PP
-References netsnmp_vardata::counter64, netsnmp_ds_get_boolean(), NULL, snmp_cstrcat, sprint_realloc_by_type(), variable_list::type, and variable_list::val.
-.PP
-Referenced by set_function(), snprint_counter64(), sprint_realloc_by_type(), and sprint_realloc_opaque().
 .SS "int sprint_realloc_gauge (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a gauge value into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a gauge value into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1050,9 +908,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1067,15 +925,9 @@
 
 .PP
 Definition at line 1457 of file mib.c.
-.PP
-References netsnmp_vardata::integer, netsnmp_ds_get_boolean(), NULL, snmp_strcat(), sprint_realloc_by_type(), sprint_realloc_hinted_integer(), variable_list::type, and variable_list::val.
-.PP
-Referenced by set_function(), snprint_gauge(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_hinted_integer (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, long val, const char decimaltype, const char * hint, const char * units)"
 .PP
-Prints an integer according to the hint into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an integer according to the hint into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1087,9 +939,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIval\fP The variable to encode. 
+\fIval\fP The \fBvariable\fP to encode. 
 .br
-\fIdecimaltype\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIdecimaltype\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may _NOT_ be NULL. 
 .br
@@ -1104,15 +956,9 @@
 
 .PP
 Definition at line 1183 of file mib.c.
-.PP
-References snmp_strcat().
-.PP
-Referenced by snprint_hinted_integer(), and sprint_realloc_gauge().
 .SS "int sprint_realloc_integer (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an integer into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an integer into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1124,9 +970,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1141,15 +987,9 @@
 
 .PP
 Definition at line 1257 of file mib.c.
-.PP
-References netsnmp_vardata::integer, enum_list::label, netsnmp_ds_get_boolean(), enum_list::next, NULL, snmp_strcat(), sprint_realloc_by_type(), variable_list::type, variable_list::val, and enum_list::value.
-.PP
-Referenced by set_function(), snprint_integer(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_ipaddress (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an ip-address into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an ip-address into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1161,9 +1001,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1178,15 +1018,9 @@
 
 .PP
 Definition at line 1659 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), NULL, snmp_realloc(), snmp_strcat(), sprint_realloc_by_type(), netsnmp_vardata::string, variable_list::type, and variable_list::val.
-.PP
-Referenced by set_function(), snprint_ipaddress(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_networkaddress (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a network address into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a network address into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1198,9 +1032,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1215,15 +1049,9 @@
 
 .PP
 Definition at line 1593 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), NULL, snmp_realloc(), snmp_strcat(), sprint_realloc_by_type(), netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by set_function(), and snprint_networkaddress().
 .SS "int sprint_realloc_null (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a null value into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a null value into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1235,9 +1063,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1252,15 +1080,9 @@
 
 .PP
 Definition at line 1719 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), NULL, snmp_strcat(), sprint_realloc_by_type(), and variable_list::type.
-.PP
-Referenced by set_function(), snprint_null(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_object_identifier (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an object identifier into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an object identifier into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1272,9 +1094,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1289,15 +1111,9 @@
 
 .PP
 Definition at line 1039 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), netsnmp_sprint_realloc_objid_tree(), NULL, netsnmp_vardata::objid, snmp_strcat(), sprint_realloc_by_type(), variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by set_function(), snprint_object_identifier(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_octet_string (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an octet string into a buffer. 
-.PP
-The variable var is encoded as octet string.
+Prints an octet string into a buffer. The \fBvariable\fP var is encoded as octet string.
 .PP
 If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
@@ -1311,9 +1127,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1328,15 +1144,9 @@
 
 .PP
 Definition at line 427 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), netsnmp_ds_get_int(), NULL, snmp_cstrcat, SNMP_MIN, snmp_realloc(), sprint_realloc_asciistring(), sprint_realloc_by_type(), sprint_realloc_hexstring(), sprint_realloc_octet_string(), netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by set_function(), snprint_octet_string(), sprint_realloc_by_type(), and sprint_realloc_octet_string().
 .SS "int sprint_realloc_opaque (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an object identifier into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an object identifier into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1348,9 +1158,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1365,15 +1175,9 @@
 
 .PP
 Definition at line 949 of file mib.c.
-.PP
-References netsnmp_ds_get_boolean(), NULL, snmp_cstrcat, snmp_strcat(), sprint_realloc_by_type(), sprint_realloc_counter64(), sprint_realloc_hexstring(), netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by set_function(), snprint_opaque(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_timeticks (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints a timetick variable into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints a timetick \fBvariable\fP into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1385,9 +1189,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1402,15 +1206,9 @@
 
 .PP
 Definition at line 1109 of file mib.c.
-.PP
-References netsnmp_vardata::integer, netsnmp_ds_get_boolean(), NULL, snmp_strcat(), sprint_realloc_by_type(), variable_list::type, and variable_list::val.
-.PP
-Referenced by set_function(), snprint_timeticks(), and sprint_realloc_by_type().
 .SS "int sprint_realloc_uinteger (u_char ** buf, size_t * buf_len, size_t * out_len, int allow_realloc, const \fBnetsnmp_variable_list\fP * var, const struct \fBenum_list\fP * enums, const char * hint, const char * units)"
 .PP
-Prints an unsigned integer into a buffer. 
-.PP
-If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
+Prints an unsigned integer into a buffer. If allow_realloc is true the buffer will be (re)allocated to fit in the needed size. (Note: *buf may change due to this.)
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1422,9 +1220,9 @@
 .br
 \fIallow_realloc\fP if not zero reallocate the buffer to fit the needed size. 
 .br
-\fIvar\fP The variable to encode. 
+\fIvar\fP The \fBvariable\fP to encode. 
 .br
-\fIenums\fP The enumeration ff this variable is enumerated. may be NULL. 
+\fIenums\fP The enumeration ff this \fBvariable\fP is enumerated. may be NULL. 
 .br
 \fIhint\fP Contents of the DISPLAY-HINT clause of the MIB. See RFC 1903 Section 3.1 for details. may be NULL. 
 .br
@@ -1439,15 +1237,9 @@
 
 .PP
 Definition at line 1360 of file mib.c.
-.PP
-References netsnmp_vardata::integer, enum_list::label, netsnmp_ds_get_boolean(), enum_list::next, NULL, snmp_strcat(), sprint_realloc_by_type(), variable_list::type, variable_list::val, and enum_list::value.
-.PP
-Referenced by set_function(), snprint_uinteger(), and sprint_realloc_by_type().
 .SS "char* uptime_string (u_long timeticks, char * buf)"
 .PP
-Converts timeticks to hours, minutes, seconds string. 
-.PP
-CMU compatible does not show centiseconds.
+Converts timeticks to hours, minutes, seconds string. CMU compatible does not show centiseconds.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -1468,14 +1260,10 @@
 .PP
 
 .PP
-Definition at line 5780 of file mib.c.
-.PP
-References uptime_string_n().
+Definition at line 5813 of file mib.c.
 .SH "Variable Documentation"
 .PP 
-.SS "\fBPrefixList\fP \fBmib_prefixes\fP[]"
-.PP
-\fBInitial value:\fP
+.SS "\fBPrefixList\fP mib_prefixes[]"\fBInitial value:\fP
 .PP
 .nf
  {
@@ -1490,5 +1278,6 @@
 .fi
 .PP
 Definition at line 160 of file mib.c.
-.PP
-Referenced by netsnmp_init_mib(), and netsnmp_sprint_realloc_objid_tree().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_mode_end_call.3'
--- man/netsnmp_mode_end_call.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_mode_end_call.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "mode_end_call" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "mode_end_call" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-mode_end_call \- At the end of a series of requests, call another handler hook.  
+mode_end_call \- 
+.PP
+At the end of a series of requests, call another handler hook.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -23,7 +24,7 @@
 .SH "Detailed Description"
 .PP 
 At the end of a series of requests, call another handler hook. 
-.PP
+
 Handlers that want to loop through a series of requests and then receive a callback at the end of a particular MODE can use this helper to make this possible. For most modules, this is not needed as the handler itself could perform a for() loop around the request list and then perform its actions afterwards. However, if something like the serialize helper is in use this isn't possible because not all the requests for a given handler are being passed downward in a single group. Thus, this helper *must* be added above other helpers like the serialize helper to be useful.
 .PP
 Multiple mode specific handlers can be registered and will be called in the order they were regestered in. Callbacks regesterd with a mode of NETSNMP_MODE_END_ALL_MODES will be called for all modes. 
@@ -31,9 +32,7 @@
 .PP 
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_mode_end_call_handler (\fBnetsnmp_mode_handler_list\fP * endlist)"
 .PP
-returns a mode_end_call handler that can be injected into a given handler chain. 
-.PP
-\fBParameters:\fP
+returns a mode_end_call handler that can be injected into a given handler chain. \fBParameters:\fP
 .RS 4
 \fIendlist\fP The callback list for the handler to make use of. 
 .RE
@@ -46,13 +45,9 @@
 
 .PP
 Definition at line 45 of file mode_end_call.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_mode_end_call_helper(), and NULL.
 .SS "\fBnetsnmp_mode_handler_list\fP* netsnmp_mode_end_call_add_mode_callback (\fBnetsnmp_mode_handler_list\fP * endlist, int mode, \fBnetsnmp_mib_handler\fP * callbackh)"
 .PP
-adds a mode specific callback to the callback list. 
-.PP
-\fBParameters:\fP
+adds a mode specific callback to the callback list. \fBParameters:\fP
 .RS 4
 \fIendlist\fP the information structure for the mode_end_call helper. Can be NULL to create a new list. 
 .br
@@ -69,5 +64,6 @@
 
 .PP
 Definition at line 65 of file mode_end_call.c.
-.PP
-References netsnmp_mode_handler_list_s::callback_handler, netsnmp_mode_handler_list_s::mode, netsnmp_mode_handler_list_s::next, NULL, and SNMP_MALLOC_TYPEDEF.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_multiplexer.3'
--- man/netsnmp_multiplexer.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_multiplexer.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "multiplexer" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "multiplexer" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-multiplexer \- Splits mode requests into calls to different handlers.  
+multiplexer \- 
+.PP
+Splits mode requests into calls to different handlers.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -20,7 +21,7 @@
 .SH "Detailed Description"
 .PP 
 Splits mode requests into calls to different handlers. 
-.PP
+
 The multiplexer helper lets you split the calling chain depending on the calling mode (get vs getnext vs set). Useful if you want different routines to handle different aspects of SNMP requests, which is very common for GET vs SET type actions.
 .PP
 Functionally:
@@ -42,14 +43,11 @@
 returns a multiplixer handler given a \fBnetsnmp_mib_handler_methods\fP structure of subhandlers. 
 .PP
 Definition at line 33 of file multiplexer.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_multiplexer_helper_handler(), NULL, and snmp_log().
 .SS "int netsnmp_multiplexer_helper_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 implements the multiplexer helper 
 .PP
 Definition at line 54 of file multiplexer.c.
-.PP
-References netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, netsnmp_call_handler(), netsnmp_request_set_error_all(), and snmp_log().
-.PP
-Referenced by netsnmp_get_multiplexer_handler().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_netsnmp_agent_request_info_s.3'
--- man/netsnmp_netsnmp_agent_request_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_agent_request_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_agent_request_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_agent_request_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_agent_request_info_s \- The agent transaction request structure.  
+netsnmp_agent_request_info_s \- 
+.PP
+The agent transaction request structure.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <snmp_agent.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -17,7 +18,7 @@
 .RI "int \fBmode\fP"
 .br
 .ti -1c
-.RI "\fBnetsnmp_agent_session_s\fP * \fBasp\fP"
+.RI "struct \fBnetsnmp_agent_session_s\fP * \fBasp\fP"
 .br
 .RI "\fIpdu contains authinfo, eg \fP"
 .ti -1c
@@ -36,13 +37,11 @@
 Definition at line 158 of file snmp_agent.h.
 .SH "Field Documentation"
 .PP 
-.SS "struct \fBnetsnmp_agent_session_s\fP* \fBnetsnmp_agent_request_info_s::asp\fP"
+.SS "struct \fBnetsnmp_agent_session_s\fP* \fBnetsnmp_agent_request_info_s::asp\fP\fC [read]\fP"
 .PP
 pdu contains authinfo, eg 
 .PP
 Definition at line 162 of file snmp_agent.h.
-.PP
-Referenced by get_set_cache(), handle_var_requests(), and netsnmp_create_delegated_cache().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_column_info_t.3'
--- man/netsnmp_netsnmp_column_info_t.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_column_info_t.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_column_info_t" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_column_info_t" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_column_info_t \- column info struct.  
+netsnmp_column_info_t \- 
+.PP
+column info struct.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <table.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -33,7 +34,7 @@
 .RI "} \fBdetails\fP"
 .br
 .ti -1c
-.RI "\fBnetsnmp_column_info_t\fP * \fBnext\fP"
+.RI "struct \fBnetsnmp_column_info_t\fP * \fBnext\fP"
 .br
 .in -1c
 .SH "Detailed Description"

=== modified file 'man/netsnmp_netsnmp_data_list_s.3'
--- man/netsnmp_netsnmp_data_list_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_data_list_s.3	2010-06-10 18:02:54 +0000
@@ -1,20 +1,21 @@
-.TH "netsnmp_data_list_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_data_list_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_data_list_s \- used to iterate through lists of data  
+netsnmp_data_list_s \- 
+.PP
+used to iterate through lists of data  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <data_list.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
 .ti -1c
-.RI "\fBnetsnmp_data_list_s\fP * \fBnext\fP"
+.RI "struct \fBnetsnmp_data_list_s\fP * \fBnext\fP"
 .br
 .ti -1c
 .RI "char * \fBname\fP"
@@ -40,15 +41,11 @@
 The pointer to the data passed on. 
 .PP
 Definition at line 45 of file data_list.h.
-.PP
-Referenced by netsnmp_create_data_list(), netsnmp_free_list_data(), and netsnmp_save_all_data().
 .SS "Netsnmp_Free_List_Data* \fBnetsnmp_data_list_s::free_func\fP"
 .PP
 must know how to free netsnmp_data_list->data 
 .PP
 Definition at line 47 of file data_list.h.
-.PP
-Referenced by netsnmp_create_data_list(), and netsnmp_free_list_data().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_handler_registration_s.3'
--- man/netsnmp_netsnmp_handler_registration_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_handler_registration_s.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_handler_registration_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_handler_registration_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_handler_registration_s \- Root registration info.  
+netsnmp_handler_registration_s \- 
+.PP
+Root registration info.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <agent_handler.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -67,49 +68,39 @@
 .PP
 \fBdelayed_instance.c\fP, and \fBwatched.c\fP.
 .PP
-Definition at line 94 of file agent_handler.h.
+Definition at line 95 of file agent_handler.h.
 .SH "Field Documentation"
 .PP 
-.SS "char* \fBnetsnmp_handler_registration_s::handlerName\fP"
-.PP
-for mrTable listings, and other uses 
-.PP
-Definition at line 97 of file agent_handler.h.
-.PP
-Referenced by netsnmp_cache_helper_handler(), netsnmp_container_table_register(), netsnmp_debug_helper(), netsnmp_handler_registration_create(), netsnmp_handler_registration_dup(), netsnmp_handler_registration_free(), netsnmp_inject_handler_into_subtree(), netsnmp_register_handler(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), netsnmp_stash_cache_helper(), netsnmp_table_array_register(), and netsnmp_table_row_register().
 .SS "char* \fBnetsnmp_handler_registration_s::contextName\fP"
 .PP
 NULL = default context. 
 .PP
-Definition at line 99 of file agent_handler.h.
-.PP
-Referenced by netsnmp_debug_helper(), netsnmp_handler_registration_dup(), netsnmp_handler_registration_free(), netsnmp_register_handler(), netsnmp_register_handler_nocallback(), netsnmp_register_mib(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), netsnmp_unregister_handler(), and unregister_mibs_by_session().
-.SS "oid* \fBnetsnmp_handler_registration_s::rootoid\fP"
-.PP
-where are we registered at? 
-.PP
-Definition at line 104 of file agent_handler.h.
-.PP
-Referenced by netsnmp_cache_helper_handler(), netsnmp_debug_helper(), netsnmp_handler_registration_create(), netsnmp_handler_registration_dup(), netsnmp_handler_registration_free(), netsnmp_instance_helper_handler(), netsnmp_old_api_helper(), netsnmp_register_cache_handler(), netsnmp_register_handler(), netsnmp_register_handler_nocallback(), netsnmp_register_mib(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), netsnmp_register_read_only_scalar(), netsnmp_register_scalar(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_stash_to_next_helper(), netsnmp_table_build_oid(), netsnmp_table_build_oid_from_index(), netsnmp_table_data_build_result(), netsnmp_table_data_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_register(), netsnmp_unregister_handler(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), and table_helper_handler().
+Definition at line 100 of file agent_handler.h.
 .SS "\fBnetsnmp_mib_handler\fP* \fBnetsnmp_handler_registration_s::handler\fP"
 .PP
 handler details 
 .PP
-Definition at line 110 of file agent_handler.h.
-.PP
-Referenced by netsnmp_call_handlers(), netsnmp_container_table_register(), netsnmp_debug_helper(), netsnmp_find_handler_by_name(), netsnmp_find_table_array_handler(), netsnmp_handler_registration_create(), netsnmp_handler_registration_dup(), netsnmp_handler_registration_free(), netsnmp_inject_handler_before(), netsnmp_register_handler(), netsnmp_register_handler_nocallback(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), netsnmp_table_container_register(), netsnmp_table_row_register(), and unregister_mibs_by_session().
+Definition at line 111 of file agent_handler.h.
+.SS "char* \fBnetsnmp_handler_registration_s::handlerName\fP"
+.PP
+for mrTable listings, and other uses 
+.PP
+Definition at line 98 of file agent_handler.h.
+.SS "void* \fBnetsnmp_handler_registration_s::my_reg_void\fP"
+.PP
+void ptr for registeree 
+.PP
+Definition at line 126 of file agent_handler.h.
 .SS "int \fBnetsnmp_handler_registration_s::priority\fP"
 .PP
 more optional stuff 
 .PP
-Definition at line 116 of file agent_handler.h.
-.PP
-Referenced by netsnmp_debug_helper(), netsnmp_handler_registration_create(), netsnmp_handler_registration_dup(), netsnmp_register_handler(), netsnmp_register_handler_nocallback(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), and netsnmp_unregister_handler().
-.SS "void* \fBnetsnmp_handler_registration_s::my_reg_void\fP"
-.PP
-void ptr for registeree 
-.PP
-Definition at line 125 of file agent_handler.h.
+Definition at line 117 of file agent_handler.h.
+.SS "oid* \fBnetsnmp_handler_registration_s::rootoid\fP"
+.PP
+where are we registered at? 
+.PP
+Definition at line 105 of file agent_handler.h.
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_iterator_info_s.3'
--- man/netsnmp_netsnmp_iterator_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_iterator_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,40 +1,41 @@
-.TH "netsnmp_iterator_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_iterator_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_iterator_info_s \- Holds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner.  
+netsnmp_iterator_info_s \- 
+.PP
+Holds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <table_iterator.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
 .ti -1c
-.RI "\fBNetsnmp_First_Data_Point\fP * \fBget_first_data_point\fP"
+.RI "Netsnmp_First_Data_Point * \fBget_first_data_point\fP"
 .br
 .RI "\fIResponsible for: returning the first set of 'index' data, a loop-context pointer, and optionally a data context pointer. \fP"
 .ti -1c
-.RI "\fBNetsnmp_Next_Data_Point\fP * \fBget_next_data_point\fP"
+.RI "Netsnmp_Next_Data_Point * \fBget_next_data_point\fP"
 .br
 .RI "\fIGiven the previous loop context, this should return the next loop context, associated index set and optionally a data context. \fP"
 .ti -1c
-.RI "\fBNetsnmp_Make_Data_Context\fP * \fBmake_data_context\fP"
+.RI "Netsnmp_Make_Data_Context * \fBmake_data_context\fP"
 .br
 .RI "\fIIf a data context wasn't supplied by the get_first_data_point or get_next_data_point functions and the make_data_context pointer is defined, it will be called to convert a loop context into a data context. \fP"
 .ti -1c
-.RI "\fBNetsnmp_Free_Loop_Context\fP * \fBfree_loop_context\fP"
+.RI "Netsnmp_Free_Loop_Context * \fBfree_loop_context\fP"
 .br
 .RI "\fIA function which should free the loop context. \fP"
 .ti -1c
-.RI "\fBNetsnmp_Free_Data_Context\fP * \fBfree_data_context\fP"
+.RI "Netsnmp_Free_Data_Context * \fBfree_data_context\fP"
 .br
 .RI "\fIFrees a data context. \fP"
 .ti -1c
-.RI "\fBNetsnmp_Free_Loop_Context\fP * \fBfree_loop_context_at_end\fP"
+.RI "Netsnmp_Free_Loop_Context * \fBfree_loop_context_at_end\fP"
 .br
 .RI "\fIFrees a loop context at the end of the entire iteration sequence. \fP"
 .ti -1c
@@ -49,7 +50,7 @@
 .br
 .RI "\fIA pointer to the netsnmp_table_registration_info object this iterator is registered along with. \fP"
 .ti -1c
-.RI "\fBNetsnmp_First_Data_Point\fP * \fBget_row_indexes\fP"
+.RI "Netsnmp_First_Data_Point * \fBget_row_indexes\fP"
 .br
 .ti -1c
 .RI "\fBnetsnmp_variable_list\fP * \fBindexes\fP"
@@ -64,46 +65,36 @@
 Definition at line 53 of file table_iterator.h.
 .SH "Field Documentation"
 .PP 
-.SS "\fBNetsnmp_First_Data_Point\fP* \fBnetsnmp_iterator_info_s::get_first_data_point\fP"
+.SS "Netsnmp_Free_Data_Context* \fBnetsnmp_iterator_info_s::free_data_context\fP"
+.PP
+Frees a data context. This will be called at any time a data context needs to be freed. This may be at the same time as a correspondng loop context is freed, or much much later. Multiple data contexts may be kept in existence at any time. 
+.PP
+Definition at line 82 of file table_iterator.h.
+.SS "Netsnmp_Free_Loop_Context* \fBnetsnmp_iterator_info_s::free_loop_context\fP"
+.PP
+A function which should free the loop context. This function is called at *each* iteration step, which is not-optimal for speed purposes. The use of free_loop_context_at_end instead is strongly encouraged. This can be set to NULL to avoid its usage. 
+.PP
+Definition at line 75 of file table_iterator.h.
+.SS "Netsnmp_Free_Loop_Context* \fBnetsnmp_iterator_info_s::free_loop_context_at_end\fP"
+.PP
+Frees a loop context at the end of the entire iteration sequence. Generally, this would free the loop context allocated by the get_first_data_point function (which would then be updated by each call to the get_next_data_point function). It is not called until the get_next_data_point function returns a NULL 
+.PP
+Definition at line 90 of file table_iterator.h.
+.SS "Netsnmp_First_Data_Point* \fBnetsnmp_iterator_info_s::get_first_data_point\fP"
 .PP
 Responsible for: returning the first set of 'index' data, a loop-context pointer, and optionally a data context pointer. 
 .PP
 Definition at line 57 of file table_iterator.h.
-.PP
-Referenced by netsnmp_iterator_create_table(), netsnmp_iterator_row_count(), netsnmp_iterator_row_first(), netsnmp_iterator_row_get_byoid(), netsnmp_iterator_row_next_byoid(), and netsnmp_table_iterator_helper_handler().
-.SS "\fBNetsnmp_Next_Data_Point\fP* \fBnetsnmp_iterator_info_s::get_next_data_point\fP"
+.SS "Netsnmp_Next_Data_Point* \fBnetsnmp_iterator_info_s::get_next_data_point\fP"
 .PP
 Given the previous loop context, this should return the next loop context, associated index set and optionally a data context. 
 .PP
 Definition at line 62 of file table_iterator.h.
-.PP
-Referenced by netsnmp_iterator_create_table(), netsnmp_iterator_row_count(), netsnmp_iterator_row_get_byoid(), netsnmp_iterator_row_next_byoid(), and netsnmp_table_iterator_helper_handler().
-.SS "\fBNetsnmp_Make_Data_Context\fP* \fBnetsnmp_iterator_info_s::make_data_context\fP"
+.SS "Netsnmp_Make_Data_Context* \fBnetsnmp_iterator_info_s::make_data_context\fP"
 .PP
 If a data context wasn't supplied by the get_first_data_point or get_next_data_point functions and the make_data_context pointer is defined, it will be called to convert a loop context into a data context. 
 .PP
 Definition at line 68 of file table_iterator.h.
-.SS "\fBNetsnmp_Free_Loop_Context\fP* \fBnetsnmp_iterator_info_s::free_loop_context\fP"
-.PP
-A function which should free the loop context. 
-.PP
-This function is called at *each* iteration step, which is not-optimal for speed purposes. The use of free_loop_context_at_end instead is strongly encouraged. This can be set to NULL to avoid its usage. 
-.PP
-Definition at line 75 of file table_iterator.h.
-.SS "\fBNetsnmp_Free_Data_Context\fP* \fBnetsnmp_iterator_info_s::free_data_context\fP"
-.PP
-Frees a data context. 
-.PP
-This will be called at any time a data context needs to be freed. This may be at the same time as a correspondng loop context is freed, or much much later. Multiple data contexts may be kept in existence at any time. 
-.PP
-Definition at line 82 of file table_iterator.h.
-.SS "\fBNetsnmp_Free_Loop_Context\fP* \fBnetsnmp_iterator_info_s::free_loop_context_at_end\fP"
-.PP
-Frees a loop context at the end of the entire iteration sequence. 
-.PP
-Generally, this would free the loop context allocated by the get_first_data_point function (which would then be updated by each call to the get_next_data_point function). It is not called until the get_next_data_point function returns a NULL 
-.PP
-Definition at line 90 of file table_iterator.h.
 .SS "void* \fBnetsnmp_iterator_info_s::myvoid\fP"
 .PP
 This can be used by client handlers to store any information they need. 
@@ -114,8 +105,6 @@
 A pointer to the netsnmp_table_registration_info object this iterator is registered along with. 
 .PP
 Definition at line 100 of file table_iterator.h.
-.PP
-Referenced by netsnmp_register_table_iterator(), and netsnmp_table_iterator_helper_handler().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_mib_handler_access_methods.3'
--- man/netsnmp_netsnmp_mib_handler_access_methods.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_mib_handler_access_methods.3	2010-06-10 18:02:54 +0000
@@ -1,20 +1,19 @@
-.TH "netsnmp_mib_handler_access_methods" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_mib_handler_access_methods" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_mib_handler_access_methods \- Defines the access methods to be called by the access_multiplexer helper.  
+netsnmp_mib_handler_access_methods \- 
+.PP
+Defines the access methods to be called by the access_multiplexer helper.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <baby_steps.h>\fP
-.PP
 .SH "Detailed Description"
 .PP 
 Defines the access methods to be called by the access_multiplexer helper. 
-.PP
-
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_mib_handler_methods.3'
--- man/netsnmp_netsnmp_mib_handler_methods.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_mib_handler_methods.3	2010-06-10 18:02:54 +0000
@@ -1,20 +1,19 @@
-.TH "netsnmp_mib_handler_methods" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_mib_handler_methods" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_mib_handler_methods \- Defines the subhandlers to be called by the multiplexer helper.  
+netsnmp_mib_handler_methods \- 
+.PP
+Defines the subhandlers to be called by the multiplexer helper.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <multiplexer.h>\fP
-.PP
 .SH "Detailed Description"
 .PP 
 Defines the subhandlers to be called by the multiplexer helper. 
-.PP
-
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_mib_handler_s.3'
--- man/netsnmp_netsnmp_mib_handler_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_mib_handler_s.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_mib_handler_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_mib_handler_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_mib_handler_s \- the mib handler structure to be registered  
+netsnmp_mib_handler_s \- 
+.PP
+the mib handler structure to be registered  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <agent_handler.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -27,12 +28,16 @@
 .ti -1c
 .RI "int(* \fBaccess_method\fP )(struct \fBnetsnmp_mib_handler_s\fP *, struct \fBnetsnmp_handler_registration_s\fP *, struct \fBnetsnmp_agent_request_info_s\fP *, struct \fBnetsnmp_request_info_s\fP *)"
 .br
-.RI "\fI_clone_handler in \fBagent_handler.c\fP. \fP"
-.ti -1c
-.RI "\fBnetsnmp_mib_handler_s\fP * \fBnext\fP"
-.br
-.ti -1c
-.RI "\fBnetsnmp_mib_handler_s\fP * \fBprev\fP"
+.RI "\fIif you add more members, you probably also want to update \fP"
+.ti -1c
+.RI "void(* \fBdata_free\fP )(void *\fBmyvoid\fP)"
+.br
+.RI "\fIdata free hook for myvoid \fP"
+.ti -1c
+.RI "struct \fBnetsnmp_mib_handler_s\fP * \fBnext\fP"
+.br
+.ti -1c
+.RI "struct \fBnetsnmp_mib_handler_s\fP * \fBprev\fP"
 .br
 .in -1c
 .SH "Detailed Description"
@@ -47,25 +52,22 @@
 Definition at line 48 of file agent_handler.h.
 .SH "Field Documentation"
 .PP 
+.SS "int(* \fBnetsnmp_mib_handler_s::access_method\fP)(struct \fBnetsnmp_mib_handler_s\fP *, struct \fBnetsnmp_handler_registration_s\fP *, struct \fBnetsnmp_agent_request_info_s\fP *, struct \fBnetsnmp_request_info_s\fP *)"
+.PP
+if you add more members, you probably also want to update _clone_handler in \fBagent_handler.c\fP. 
+.SS "void(* \fBnetsnmp_mib_handler_s::data_free\fP)(void *\fBmyvoid\fP)"
+.PP
+data free hook for myvoid 
+.SS "int \fBnetsnmp_mib_handler_s::flags\fP"
+.PP
+for agent_handler's internal use 
+.PP
+Definition at line 53 of file agent_handler.h.
 .SS "void* \fBnetsnmp_mib_handler_s::myvoid\fP"
 .PP
 for handler's internal use 
 .PP
 Definition at line 51 of file agent_handler.h.
-.PP
-Referenced by _netsnmp_tdata_helper_handler(), netsnmp_baby_steps_access_multiplexer_get(), netsnmp_baby_steps_handler_get(), netsnmp_cache_handler_get(), netsnmp_cache_helper_handler(), netsnmp_container_table_handler_get(), netsnmp_debug_helper(), netsnmp_find_handler_data_by_name(), netsnmp_get_cache_handler(), netsnmp_get_mode_end_call_handler(), netsnmp_get_multiplexer_handler(), netsnmp_get_row_merge_handler(), netsnmp_get_scalar_group_handler(), netsnmp_get_table_data_handler(), netsnmp_get_table_data_set_handler(), netsnmp_get_table_handler(), netsnmp_get_table_iterator_handler(), netsnmp_get_tdata_handler(), netsnmp_get_timed_bare_stash_cache_handler(), netsnmp_handler_dup(), netsnmp_instance_counter32_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_mode_end_call_helper(), netsnmp_multiplexer_helper_handler(), netsnmp_old_api_helper(), netsnmp_register_mib_table_row(), netsnmp_register_old_api(), netsnmp_register_watched_instance(), netsnmp_register_watched_scalar(), netsnmp_register_watched_spinlock(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_table_container_register(), netsnmp_table_data_helper_handler(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_handler_get(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watched_timestamp_register(), netsnmp_watcher_helper_handler(), table_helper_handler(), and unregister_mibs_by_session().
-.SS "int \fBnetsnmp_mib_handler_s::flags\fP"
-.PP
-for agent_handler's internal use 
-.PP
-Definition at line 53 of file agent_handler.h.
-.PP
-Referenced by netsnmp_baby_steps_access_multiplexer_get(), netsnmp_bulk_to_next_helper(), netsnmp_cache_handler_get(), netsnmp_cache_helper_handler(), netsnmp_container_table_handler_get(), netsnmp_get_bulk_to_next_handler(), netsnmp_get_read_only_handler(), netsnmp_get_stash_to_next_handler(), netsnmp_get_table_data_handler(), netsnmp_get_table_data_set_handler(), netsnmp_get_tdata_handler(), netsnmp_get_watched_spinlock_handler(), netsnmp_get_watched_timestamp_handler(), netsnmp_get_watcher_handler(), netsnmp_register_handler(), netsnmp_register_instance(), netsnmp_stash_to_next_helper(), netsnmp_table_row_handler_get(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), and netsnmp_watcher_helper_handler().
-.SS "int(* \fBnetsnmp_mib_handler_s::access_method\fP)(struct \fBnetsnmp_mib_handler_s\fP *, struct \fBnetsnmp_handler_registration_s\fP *, struct \fBnetsnmp_agent_request_info_s\fP *, struct \fBnetsnmp_request_info_s\fP *)"
-.PP
-_clone_handler in \fBagent_handler.c\fP. 
-.PP
-Referenced by netsnmp_call_handler(), netsnmp_create_handler(), netsnmp_find_table_array_handler(), netsnmp_instance_counter32_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), and netsnmp_instance_ulong_handler().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_request_info_s.3'
--- man/netsnmp_netsnmp_request_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_request_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,33 +1,34 @@
-.TH "netsnmp_request_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_request_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_request_info_s \- The netsnmp request info structure.  
+netsnmp_request_info_s \- 
+.PP
+The netsnmp request info structure.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <snmp_agent.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
 .ti -1c
 .RI "\fBnetsnmp_variable_list\fP * \fBrequestvb\fP"
 .br
-.RI "\fIvariable bindings \fP"
+.RI "\fI\fBvariable\fP bindings \fP"
 .ti -1c
 .RI "\fBnetsnmp_data_list\fP * \fBparent_data\fP"
 .br
 .RI "\fIcan be used to pass information on a per-request basis from a helper to the later handlers \fP"
 .ti -1c
-.RI "\fBnetsnmp_agent_request_info_s\fP * \fBagent_req_info\fP"
+.RI "struct \fBnetsnmp_agent_request_info_s\fP * \fBagent_req_info\fP"
 .br
 .ti -1c
 .RI "oid * \fBrange_end\fP"
 .br
-.RI "\fIdon't free, reference to (struct tree)->end \fP"
+.RI "\fIdon't free, reference to (struct \fBtree\fP)->end \fP"
 .ti -1c
 .RI "size_t \fBrange_end_len\fP"
 .br
@@ -58,13 +59,13 @@
 .RI "\fBnetsnmp_variable_list\fP * \fBrequestvb_start\fP"
 .br
 .ti -1c
-.RI "\fBnetsnmp_request_info_s\fP * \fBnext\fP"
-.br
-.ti -1c
-.RI "\fBnetsnmp_request_info_s\fP * \fBprev\fP"
-.br
-.ti -1c
-.RI "\fBnetsnmp_subtree_s\fP * \fBsubtree\fP"
+.RI "struct \fBnetsnmp_request_info_s\fP * \fBnext\fP"
+.br
+.ti -1c
+.RI "struct \fBnetsnmp_request_info_s\fP * \fBprev\fP"
+.br
+.ti -1c
+.RI "struct \fBnetsnmp_subtree_s\fP * \fBsubtree\fP"
 .br
 .in -1c
 .SH "Detailed Description"
@@ -79,45 +80,35 @@
 Definition at line 54 of file snmp_agent.h.
 .SH "Field Documentation"
 .PP 
-.SS "\fBnetsnmp_variable_list\fP* \fBnetsnmp_request_info_s::requestvb\fP"
-.PP
-variable bindings 
-.PP
-\fBExamples: \fP
-.in +1c
-\fBdelayed_instance.c\fP.
-.PP
-Definition at line 58 of file snmp_agent.h.
-.PP
-Referenced by _request_set_error(), check_acm(), check_getnext_results(), debug_print_requests(), netsnmp_add_varbind_to_cache(), netsnmp_bulk_to_next_fix_requests(), netsnmp_bulk_to_next_helper(), netsnmp_check_getnext_reply(), netsnmp_instance_counter32_handler(), netsnmp_instance_helper_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_old_api_helper(), netsnmp_reassign_requests(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_stash_cache_helper(), netsnmp_stash_to_next_helper(), netsnmp_table_build_oid(), netsnmp_table_build_oid_from_index(), netsnmp_table_build_result(), netsnmp_table_data_build_result(), netsnmp_table_data_set_helper_handler(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), and table_helper_handler().
+.SS "int \fBnetsnmp_request_info_s::index\fP"
+.PP
+index in original pdu 
+.PP
+Definition at line 84 of file snmp_agent.h.
 .SS "\fBnetsnmp_data_list\fP* \fBnetsnmp_request_info_s::parent_data\fP"
 .PP
 can be used to pass information on a per-request basis from a helper to the later handlers 
 .PP
 Definition at line 64 of file snmp_agent.h.
-.PP
-Referenced by debug_print_requests(), netsnmp_add_varbind_to_cache(), netsnmp_free_request_data_set(), netsnmp_free_request_data_sets(), netsnmp_request_add_list_data(), netsnmp_request_get_list_data(), netsnmp_request_remove_list_data(), and netsnmp_stash_to_next_helper().
 .SS "oid* \fBnetsnmp_request_info_s::range_end\fP"
 .PP
-don't free, reference to (struct tree)->end 
+don't free, reference to (struct \fBtree\fP)->end 
 .PP
 Definition at line 72 of file snmp_agent.h.
-.PP
-Referenced by check_getnext_results(), netsnmp_add_varbind_to_cache(), and netsnmp_bulk_to_next_fix_requests().
-.SS "int \fBnetsnmp_request_info_s::index\fP"
-.PP
-index in original pdu 
-.PP
-Definition at line 84 of file snmp_agent.h.
-.PP
-Referenced by check_getnext_results(), debug_print_requests(), netsnmp_add_varbind_to_cache(), netsnmp_check_requests_status(), and netsnmp_reassign_requests().
 .SS "int \fBnetsnmp_request_info_s::repeat\fP"
 .PP
 get-bulk 
 .PP
 Definition at line 87 of file snmp_agent.h.
-.PP
-Referenced by check_acm(), netsnmp_bulk_to_next_fix_requests(), and netsnmp_create_subtree_cache().
+.SS "\fBnetsnmp_variable_list\fP* \fBnetsnmp_request_info_s::requestvb\fP"
+.PP
+\fBvariable\fP bindings 
+.PP
+\fBExamples: \fP
+.in +1c
+\fBdelayed_instance.c\fP.
+.PP
+Definition at line 58 of file snmp_agent.h.
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_table_registration_info_s.3'
--- man/netsnmp_netsnmp_table_registration_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_table_registration_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_table_registration_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_table_registration_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_table_registration_info_s \- Table registration structure.  
+netsnmp_table_registration_info_s \- 
+.PP
+Table registration structure.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <table.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -46,38 +47,26 @@
 list of varbinds with only 'type' set 
 .PP
 Definition at line 76 of file table.h.
-.PP
-Referenced by netsnmp_get_table_handler(), netsnmp_register_table_data_set(), netsnmp_register_table_iterator(), and table_helper_handler().
+.SS "unsigned int \fBnetsnmp_table_registration_info_s::max_column\fP"
+.PP
+the maximum columns number 
+.PP
+Definition at line 87 of file table.h.
+.SS "unsigned int \fBnetsnmp_table_registration_info_s::min_column\fP"
+.PP
+the minimum columns number. If there are columns in-between which are not valid, use valid_columns to get automatic column range checking. 
+.PP
+Definition at line 85 of file table.h.
 .SS "unsigned int \fBnetsnmp_table_registration_info_s::number_indexes\fP"
 .PP
 calculated automatically 
 .PP
 Definition at line 78 of file table.h.
-.PP
-Referenced by netsnmp_get_table_handler(), and table_helper_handler().
-.SS "unsigned int \fBnetsnmp_table_registration_info_s::min_column\fP"
-.PP
-the minimum columns number. 
-.PP
-If there are columns in-between which are not valid, use valid_columns to get automatic column range checking. 
-.PP
-Definition at line 85 of file table.h.
-.PP
-Referenced by netsnmp_register_table_data_set(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_register(), and table_helper_handler().
-.SS "unsigned int \fBnetsnmp_table_registration_info_s::max_column\fP"
-.PP
-the maximum columns number 
-.PP
-Definition at line 87 of file table.h.
-.PP
-Referenced by netsnmp_register_table_data_set(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_register(), and table_helper_handler().
 .SS "\fBnetsnmp_column_info\fP* \fBnetsnmp_table_registration_info_s::valid_columns\fP"
 .PP
 more details on columns 
 .PP
 Definition at line 90 of file table.h.
-.PP
-Referenced by table_helper_handler().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_netsnmp_table_request_info_s.3'
--- man/netsnmp_netsnmp_table_request_info_s.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_netsnmp_table_request_info_s.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "netsnmp_table_request_info_s" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "netsnmp_table_request_info_s" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-netsnmp_table_request_info_s \- The table request info structure.  
+netsnmp_table_request_info_s \- 
+.PP
+The table request info structure.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <table.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -47,22 +48,16 @@
 0 if OID not long enough 
 .PP
 Definition at line 104 of file table.h.
-.PP
-Referenced by netsnmp_table_build_oid(), netsnmp_table_build_oid_from_index(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), and table_helper_handler().
+.SS "\fBnetsnmp_variable_list\fP* \fBnetsnmp_table_request_info_s::indexes\fP"
+.PP
+contents freed by helper upon exit 
+.PP
+Definition at line 108 of file table.h.
 .SS "unsigned int \fBnetsnmp_table_request_info_s::number_indexes\fP"
 .PP
 0 if failure to parse any 
 .PP
 Definition at line 106 of file table.h.
-.PP
-Referenced by table_helper_handler().
-.SS "\fBnetsnmp_variable_list\fP* \fBnetsnmp_table_request_info_s::indexes\fP"
-.PP
-contents freed by helper upon exit 
-.PP
-Definition at line 108 of file table.h.
-.PP
-Referenced by netsnmp_container_table_row_insert(), netsnmp_insert_iterator_context(), netsnmp_insert_table_row(), netsnmp_table_build_oid(), netsnmp_table_data_set_create_newrowstash(), netsnmp_update_indexes_from_variable_list(), netsnmp_update_variable_list_from_index(), and table_helper_handler().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_oid_stash.3'
--- man/netsnmp_oid_stash.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_oid_stash.3	2010-06-10 18:02:54 +0000
@@ -1,17 +1,18 @@
-.TH "Store and retrieve data referenced by an OID." 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "Store and retrieve data referenced by an OID." 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-Store and retrieve data referenced by an OID. \- This is essentially a way of storing data associated with a given OID.  
+Store and retrieve data referenced by an OID. \- 
+.PP
+This is essentially a way of storing data associated with a given OID.  
 
-.PP
 .SS "Functions"
 
 .in +1c
 .ti -1c
 .RI "\fBnetsnmp_oid_stash_node\fP * \fBnetsnmp_oid_stash_create_sized_node\fP (size_t mysize)"
 .br
-.RI "\fICreate an netsnmp_oid_stash node. \fP"
+.RI "\fICreate an netsnmp_oid_stash \fBnode\fP. \fP"
 .ti -1c
 .RI "NETSNMP_INLINE \fBnetsnmp_oid_stash_node\fP * \fBnetsnmp_oid_stash_create_node\fP (void)"
 .br
@@ -23,11 +24,11 @@
 .ti -1c
 .RI "\fBnetsnmp_oid_stash_node\fP * \fBnetsnmp_oid_stash_get_node\fP (\fBnetsnmp_oid_stash_node\fP *root, oid *lookup, size_t lookup_len)"
 .br
-.RI "\fIreturns a node associated with a given OID. \fP"
+.RI "\fIreturns a \fBnode\fP associated with a given OID. \fP"
 .ti -1c
 .RI "\fBnetsnmp_oid_stash_node\fP * \fBnetsnmp_oid_stash_getnext_node\fP (\fBnetsnmp_oid_stash_node\fP *root, oid *lookup, size_t lookup_len)"
 .br
-.RI "\fIreturns the next node associated with a given OID. \fP"
+.RI "\fIreturns the next \fBnode\fP associated with a given OID. \fP"
 .ti -1c
 .RI "void * \fBnetsnmp_oid_stash_get_data\fP (\fBnetsnmp_oid_stash_node\fP *root, oid *lookup, size_t lookup_len)"
 .br
@@ -39,15 +40,15 @@
 .ti -1c
 .RI "void \fBnetsnmp_oid_stash_store\fP (\fBnetsnmp_oid_stash_node\fP *root, const char *tokenname, NetSNMPStashDump *dumpfn, oid *curoid, size_t curoid_len)"
 .br
-.RI "\fIstores data in a starsh tree to peristent storage. \fP"
+.RI "\fIstores data in a starsh \fBtree\fP to peristent storage. \fP"
 .ti -1c
 .RI "void \fBoid_stash_dump\fP (\fBnetsnmp_oid_stash_node\fP *root, char *prefix)"
 .br
-.RI "\fIFor debugging: dump the netsnmp_oid_stash tree to stdout. \fP"
+.RI "\fIFor debugging: dump the netsnmp_oid_stash \fBtree\fP to stdout. \fP"
 .ti -1c
 .RI "void \fBnetsnmp_oid_stash_free\fP (\fBnetsnmp_oid_stash_node\fP **root, NetSNMPStashFreeNode *freefn)"
 .br
-.RI "\fIFrees the contents of a netsnmp_oid_stash tree. \fP"
+.RI "\fIFrees the contents of a netsnmp_oid_stash \fBtree\fP. \fP"
 .ti -1c
 .RI "void \fBnetsnmp_oid_stash_no_free\fP (void *bogus)"
 .br
@@ -55,17 +56,15 @@
 .SH "Detailed Description"
 .PP 
 This is essentially a way of storing data associated with a given OID. 
-.PP
-It stores a bunch of data pointers within a memory tree that allows fairly efficient lookups with a heavily populated tree. 
+
+It stores a bunch of data pointers within a memory \fBtree\fP that allows fairly efficient lookups with a heavily populated \fBtree\fP. 
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_oid_stash_add_data (\fBnetsnmp_oid_stash_node\fP ** root, oid * lookup, size_t lookup_len, void * mydata)"
 .PP
-adds data to the stash at a given oid. 
-.PP
-\fBParameters:\fP
+adds data to the stash at a given oid. \fBParameters:\fP
 .RS 4
-\fIroot\fP the top of the stash tree 
+\fIroot\fP the top of the stash \fBtree\fP 
 .br
 \fIlookup\fP the oid index to store the data at. 
 .br
@@ -82,56 +81,38 @@
 
 .PP
 Definition at line 83 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, netsnmp_oid_stash_create_node(), netsnmp_oid_stash_node_s::next_sibling, NULL, netsnmp_oid_stash_node_s::parent, netsnmp_oid_stash_node_s::prev_sibling, netsnmp_oid_stash_node_s::thedata, and netsnmp_oid_stash_node_s::value.
-.PP
-Referenced by netsnmp_stash_to_next_helper(), and netsnmp_table_data_set_helper_handler().
 .SS "NETSNMP_INLINE \fBnetsnmp_oid_stash_node\fP* netsnmp_oid_stash_create_node (void)"
 .PP
-Creates a netsnmp_oid_stash_node. 
-.PP
-Assumes you want the default OID_STASH_CHILDREN_SIZE hash size for the node. 
+Creates a netsnmp_oid_stash_node. Assumes you want the default OID_STASH_CHILDREN_SIZE hash size for the \fBnode\fP. 
 .PP
 \fBReturns:\fP
 .RS 4
-NULL on error, otherwise the newly allocated node 
+NULL on error, otherwise the newly allocated \fBnode\fP 
 .RE
 .PP
 
 .PP
 Definition at line 66 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_create_sized_node().
-.PP
-Referenced by netsnmp_oid_stash_add_data().
 .SS "\fBnetsnmp_oid_stash_node\fP* netsnmp_oid_stash_create_sized_node (size_t mysize)"
 .PP
-Create an netsnmp_oid_stash node. 
-.PP
-\fBParameters:\fP
+Create an netsnmp_oid_stash \fBnode\fP. \fBParameters:\fP
 .RS 4
 \fImysize\fP the size of the child pointer array
 .RE
 .PP
 \fBReturns:\fP
 .RS 4
-NULL on error, otherwise the newly allocated node 
+NULL on error, otherwise the newly allocated \fBnode\fP 
 .RE
 .PP
 
 .PP
 Definition at line 46 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, NULL, and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_oid_stash_create_node().
 .SS "void netsnmp_oid_stash_free (\fBnetsnmp_oid_stash_node\fP ** root, NetSNMPStashFreeNode * freefn)"
 .PP
-Frees the contents of a netsnmp_oid_stash tree. 
-.PP
-\fBParameters:\fP
+Frees the contents of a netsnmp_oid_stash \fBtree\fP. \fBParameters:\fP
 .RS 4
-\fIroot\fP the top of the tree (or branch to be freed) 
+\fIroot\fP the top of the \fBtree\fP (or branch to be freed) 
 .br
 \fIfreefn\fP The function to be called on each data (void *) pointer. If left NULL the system free() function will be called 
 .RE
@@ -139,15 +120,9 @@
 
 .PP
 Definition at line 401 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_free(), netsnmp_oid_stash_node_s::next_sibling, and netsnmp_oid_stash_node_s::thedata.
-.PP
-Referenced by _netsnmp_stash_cache_free(), and netsnmp_oid_stash_free().
 .SS "void* netsnmp_oid_stash_get_data (\fBnetsnmp_oid_stash_node\fP * root, oid * lookup, size_t lookup_len)"
 .PP
-returns a data pointer associated with a given OID. 
-.PP
-This is equivelent to netsnmp_oid_stash_get_node, but returns only the data not the entire node.
+returns a data pointer associated with a given OID. This is equivelent to netsnmp_oid_stash_get_node, but returns only the data not the entire \fBnode\fP.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -161,19 +136,13 @@
 
 .PP
 Definition at line 282 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_get_node(), NULL, and netsnmp_oid_stash_node_s::thedata.
-.PP
-Referenced by netsnmp_stash_cache_helper(), and netsnmp_table_data_set_helper_handler().
 .SS "\fBnetsnmp_oid_stash_node\fP* netsnmp_oid_stash_get_node (\fBnetsnmp_oid_stash_node\fP * root, oid * lookup, size_t lookup_len)"
 .PP
-returns a node associated with a given OID. 
-.PP
-\fBParameters:\fP
+returns a \fBnode\fP associated with a given OID. \fBParameters:\fP
 .RS 4
-\fIroot\fP the top of the stash tree 
+\fIroot\fP the top of the stash \fBtree\fP 
 .br
-\fIlookup\fP the oid to look up a node for. 
+\fIlookup\fP the oid to look up a \fBnode\fP for. 
 .br
 \fIlookup_len\fP the length of the lookup oid 
 .RE
@@ -181,26 +150,14 @@
 
 .PP
 Definition at line 154 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, netsnmp_oid_stash_node_s::next_sibling, NULL, and netsnmp_oid_stash_node_s::value.
-.PP
-Referenced by netsnmp_oid_stash_get_data().
 .SS "\fBnetsnmp_oid_stash_node\fP* netsnmp_oid_stash_getnext_node (\fBnetsnmp_oid_stash_node\fP * root, oid * lookup, size_t lookup_len)"
 .PP
-returns the next node associated with a given OID. 
-.PP
-INCOMPLETE. This is equivelent to a GETNEXT operation. 
+returns the next \fBnode\fP associated with a given OID. INCOMPLETE. This is equivelent to a GETNEXT operation. 
 .PP
 Definition at line 191 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, netsnmp_oid_stash_node_s::next_sibling, NULL, and netsnmp_oid_stash_node_s::value.
-.PP
-Referenced by netsnmp_stash_cache_helper().
 .SS "void netsnmp_oid_stash_store (\fBnetsnmp_oid_stash_node\fP * root, const char * tokenname, NetSNMPStashDump * dumpfn, oid * curoid, size_t curoid_len)"
 .PP
-stores data in a starsh tree to peristent storage. 
-.PP
-This function can be called to save all data in a stash tree to Net-SNMP's percent storage. Make sure you register a parsing function with the read_config system to re-incorperate your saved data into future trees.
+stores data in a starsh \fBtree\fP to peristent storage. This function can be called to save all data in a stash \fBtree\fP to Net-SNMP's percent storage. Make sure you register a parsing function with the read_config system to re-incorperate your saved data into future trees.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -208,7 +165,7 @@
 .br
 \fItokenname\fP the file token name to save in (passing 'snmpd' will save things into snmpd.conf). 
 .br
-\fIdumpfn\fP A function which can dump the data stored at a particular node into a char buffer. 
+\fIdumpfn\fP A function which can dump the data stored at a particular \fBnode\fP into a char buffer. 
 .br
 \fIcuroid\fP must be a pointer to a OID array of length MAX_OID_LEN. 
 .br
@@ -218,15 +175,9 @@
 
 .PP
 Definition at line 334 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, netsnmp_ds_get_string(), netsnmp_oid_stash_store(), netsnmp_oid_stash_node_s::next_sibling, read_config_save_objid(), read_config_store(), SNMP_MAXBUF, netsnmp_oid_stash_node_s::thedata, and netsnmp_oid_stash_node_s::value.
-.PP
-Referenced by netsnmp_oid_stash_store(), and netsnmp_oid_stash_store_all().
 .SS "int netsnmp_oid_stash_store_all (int majorID, int minorID, void * serverarg, void * clientarg)"
 .PP
-a wrapper around netsnmp_oid_stash_store for use with a \fBsnmp_alarm\fP. 
-.PP
-when calling \fBsnmp_alarm\fP, you can list this as a callback. The clientarg should be a pointer to a netsnmp_oid_stash_save_info pointer. It can also be called directly, of course. The last argument (clientarg) is the only one that is used. The rest are ignored by the function. 
+a wrapper around netsnmp_oid_stash_store for use with a \fBsnmp_alarm\fP. when calling \fBsnmp_alarm\fP, you can list this as a callback. The clientarg should be a pointer to a netsnmp_oid_stash_save_info pointer. It can also be called directly, of course. The last argument (clientarg) is the only one that is used. The rest are ignored by the function. 
 .PP
 \fBParameters:\fP
 .RS 4
@@ -242,15 +193,11 @@
 
 .PP
 Definition at line 304 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_save_info_s::dumpfn, netsnmp_oid_stash_store(), netsnmp_oid_stash_save_info_s::root, and netsnmp_oid_stash_save_info_s::token.
 .SS "void oid_stash_dump (\fBnetsnmp_oid_stash_node\fP * root, char * prefix)"
 .PP
-For debugging: dump the netsnmp_oid_stash tree to stdout. 
-.PP
-\fBParameters:\fP
+For debugging: dump the netsnmp_oid_stash \fBtree\fP to stdout. \fBParameters:\fP
 .RS 4
-\fIroot\fP The top of the tree 
+\fIroot\fP The top of the \fBtree\fP 
 .br
 \fIprefix\fP a character string prefix printed to the beginning of each line. 
 .RE
@@ -258,5 +205,6 @@
 
 .PP
 Definition at line 374 of file oid_stash.c.
-.PP
-References netsnmp_oid_stash_node_s::children, netsnmp_oid_stash_node_s::children_size, netsnmp_oid_stash_node_s::next_sibling, netsnmp_oid_stash_node_s::thedata, and netsnmp_oid_stash_node_s::value.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_old_api.3'
--- man/netsnmp_old_api.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_old_api.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "old_api" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "old_api" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-old_api \- Calls mib module code written in the old style of code.  
+old_api \- 
+.PP
+Calls mib \fBmodule\fP code written in the old style of code.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -15,7 +16,7 @@
 .ti -1c
 .RI "int \fBnetsnmp_register_old_api\fP (const char *moduleName, struct \fBvariable\fP *var, size_t varsize, size_t numvars, oid *mibloc, size_t mibloclen, int priority, int range_subid, oid range_ubound, \fBnetsnmp_session\fP *ss, const char *context, int timeout, int flags)"
 .br
-.RI "\fIRegisters an old API set into the mib tree. \fP"
+.RI "\fIRegisters an old API set into the mib \fBtree\fP. \fP"
 .ti -1c
 .RI "int \fBnetsnmp_register_mib_table_row\fP (const char *moduleName, struct \fBvariable\fP *var, size_t varsize, size_t numvars, oid *mibloc, size_t mibloclen, int priority, int var_subid, \fBnetsnmp_session\fP *ss, const char *context, int timeout, int flags)"
 .br
@@ -27,48 +28,33 @@
 .in -1c
 .SH "Detailed Description"
 .PP 
-Calls mib module code written in the old style of code. 
-.PP
-This is a backwards compatilibity module that allows code written in the old API to be run under the new handler based architecture. Use it by calling \fBnetsnmp_register_old_api()\fP. 
+Calls mib \fBmodule\fP code written in the old style of code. 
+
+This is a backwards compatilibity \fBmodule\fP that allows code written in the old API to be run under the new handler based architecture. Use it by calling \fBnetsnmp_register_old_api()\fP. 
 .SH "Function Documentation"
 .PP 
 .SS "\fBnetsnmp_mib_handler\fP* get_old_api_handler (void)"
 .PP
-returns a old_api handler that should be the final calling handler. 
-.PP
-Don't use this function. Use the \fBnetsnmp_register_old_api()\fP function instead. 
+returns a old_api handler that should be the final calling handler. Don't use this function. Use the \fBnetsnmp_register_old_api()\fP function instead. 
 .PP
 Definition at line 37 of file old_api.c.
-.PP
-References netsnmp_create_handler(), and netsnmp_old_api_helper().
-.PP
-Referenced by netsnmp_register_mib_table_row(), and netsnmp_register_old_api().
 .SS "int netsnmp_old_api_helper (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 implements the old_api handler 
 .PP
 Definition at line 226 of file old_api.c.
-.PP
-References variable::acl, variable::findVar, variable::magic, MIB_CLIENTS_ARE_EVIL, netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, variable_list::name, variable::name, variable_list::name_length, variable::namelen, netsnmp_request_info_s::next, NULL, netsnmp_request_info_s::requestvb, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_set_var_objid(), and variable::type.
-.PP
-Referenced by get_old_api_handler().
 .SS "int netsnmp_register_mib_table_row (const char * moduleName, struct \fBvariable\fP * var, size_t varsize, size_t numvars, oid * mibloc, size_t mibloclen, int priority, int var_subid, \fBnetsnmp_session\fP * ss, const char * context, int timeout, int flags)"
 .PP
 registers a row within a mib table 
 .PP
 Definition at line 107 of file old_api.c.
-.PP
-References netsnmp_handler_registration_s::contextName, register_parameters::contextName, register_parameters::flags, get_old_api_handler(), netsnmp_handler_registration_s::handler, HANDLER_CAN_RWRITE, netsnmp_handler_registration_s::handlerName, netsnmp_handler_registration_s::modes, netsnmp_mib_handler_s::myvoid, register_parameters::name, register_parameters::namelen, netsnmp_handler_registration_free(), netsnmp_register_handler_nocallback(), NULL, netsnmp_handler_registration_s::priority, register_parameters::priority, netsnmp_handler_registration_s::range_subid, register_parameters::range_subid, netsnmp_handler_registration_s::range_ubound, register_parameters::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_call_callbacks(), SNMP_MALLOC_TYPEDEF, netsnmp_handler_registration_s::timeout, and register_parameters::timeout.
 .SS "int netsnmp_register_old_api (const char * moduleName, struct \fBvariable\fP * var, size_t varsize, size_t numvars, oid * mibloc, size_t mibloclen, int priority, int range_subid, oid range_ubound, \fBnetsnmp_session\fP * ss, const char * context, int timeout, int flags)"
 .PP
-Registers an old API set into the mib tree. 
-.PP
-Functionally this mimics the old \fBregister_mib_context()\fP function (and in fact the new \fBregister_mib_context()\fP function merely calls this new old_api one). 
+Registers an old API set into the mib \fBtree\fP. Functionally this mimics the old register_mib_context() function (and in fact the new register_mib_context() function merely calls this new old_api one). 
 .PP
 netsnmp_handler_registration_free(reginfo); already freed 
 .PP
 Definition at line 48 of file old_api.c.
-.PP
-References netsnmp_handler_registration_s::contextName, get_old_api_handler(), netsnmp_handler_registration_s::handler, HANDLER_CAN_RWRITE, netsnmp_handler_registration_s::handlerName, memdup(), netsnmp_handler_registration_s::modes, netsnmp_mib_handler_s::myvoid, netsnmp_register_handler(), NULL, netsnmp_handler_registration_s::priority, netsnmp_handler_registration_s::range_subid, netsnmp_handler_registration_s::range_ubound, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, SNMP_FREE, SNMP_MALLOC_TYPEDEF, and netsnmp_handler_registration_s::timeout.
-.PP
-Referenced by register_mib_context().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_read_config.3'
--- man/netsnmp_read_config.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_read_config.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "parsing various configuration files at run time" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "parsing various configuration files at run time" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-parsing various configuration files at run time \- The read_config related functions are a fairly extensible system of parsing various configuration files at the run time.  
+parsing various configuration files at run time \- 
+.PP
+The read_config related functions are a fairly extensible system of parsing various configuration files at the run time.  
 
-.PP
 .SS "Defines"
 
 .in +1c
@@ -16,17 +17,17 @@
 
 .in +1c
 .ti -1c
-.RI "\fBconfig_line\fP * \fBregister_prenetsnmp_mib_handler\fP (const char *type, const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
-.br
-.ti -1c
-.RI "\fBconfig_line\fP * \fBregister_app_prenetsnmp_mib_handler\fP (const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
-.br
-.ti -1c
-.RI "\fBconfig_line\fP * \fBregister_config_handler\fP (const char *type, const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
+.RI "struct \fBconfig_line\fP * \fBregister_prenetsnmp_mib_handler\fP (const char *type, const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
+.br
+.ti -1c
+.RI "struct \fBconfig_line\fP * \fBregister_app_prenetsnmp_mib_handler\fP (const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
+.br
+.ti -1c
+.RI "struct \fBconfig_line\fP * \fBregister_config_handler\fP (const char *type, const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
 .br
 .RI "\fIregister_config_handler registers handlers for certain tokens specified in certain types of files. \fP"
 .ti -1c
-.RI "\fBconfig_line\fP * \fBregister_app_config_handler\fP (const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
+.RI "struct \fBconfig_line\fP * \fBregister_app_config_handler\fP (const char *token, void(*parser)(const char *, char *), void(*releaser)(void), const char *help)"
 .br
 .ti -1c
 .RI "void \fBunregister_config_handler\fP (const char *type_param, const char *token)"
@@ -39,7 +40,7 @@
 .RI "void \fBunregister_all_config_handlers\fP ()"
 .br
 .ti -1c
-.RI "\fBconfig_line\fP * \fBread_config_get_handlers\fP (const char *type)"
+.RI "struct \fBconfig_line\fP * \fBread_config_get_handlers\fP (const char *type)"
 .br
 .ti -1c
 .RI "void \fBread_config_with_type_when\fP (const char *filename, const char *type, int when)"
@@ -48,7 +49,7 @@
 .RI "void \fBread_config_with_type\fP (const char *filename, const char *type)"
 .br
 .ti -1c
-.RI "\fBconfig_line\fP * \fBread_config_find_handler\fP (struct \fBconfig_line\fP *line_handlers, const char *token)"
+.RI "struct \fBconfig_line\fP * \fBread_config_find_handler\fP (struct \fBconfig_line\fP *line_handlers, const char *token)"
 .br
 .ti -1c
 .RI "int \fBrun_config_handler\fP (struct \fBconfig_line\fP *lptr, const char *token, char *cptr, int when)"
@@ -181,7 +182,7 @@
 
 .in +1c
 .ti -1c
-.RI "\fBconfig_files\fP * \fBconfig_files\fP = NULL"
+.RI "struct \fBconfig_files\fP * \fBconfig_files\fP = NULL"
 .br
 .ti -1c
 .RI "int \fBlinecount\fP"
@@ -193,7 +194,7 @@
 .SH "Detailed Description"
 .PP 
 The read_config related functions are a fairly extensible system of parsing various configuration files at the run time. 
-.PP
+
 The idea is that the calling application is able to register handlers for certain tokens specified in certain types of files. The read_configs function can then be called to look for all the files that it has registrations for, find the first word on each line, and pass the remainder to the appropriately registered handler.
 .PP
 For persistent configuration storage you will need to use the read_config_read_data, read_config_store, and read_config_store_data APIs in conjunction with first registering a callback so when the agent shutsdown for whatever reason data is written to your configuration files. The following explains in more detail the sequence to make this happen.
@@ -217,9 +218,7 @@
 .PP 
 .SS "char* read_config_read_data (int type, char * readfrom, void * dataptr, size_t * len)"
 .PP
-read_config_read_data reads data of a given type from a token(s) on a configuration line. 
-.PP
-The supported types are:
+read_config_read_data reads data of a given type from a token(s) on a configuration line. The supported types are:
 .PP
 .IP "\(bu" 2
 ASN_INTEGER
@@ -253,16 +252,10 @@
 .PP
 
 .PP
-Definition at line 1831 of file read_config.c.
-.PP
-References NULL, read_config_read_objid(), read_config_read_octet_string(), and skip_token().
-.PP
-Referenced by netsnmp_read_data_callback().
+Definition at line 1836 of file read_config.c.
 .SS "void read_config_store (const char * type, const char * line)"
 .PP
-read_config_store intended for use by applications to store permenant configuration information generated by sets or persistent counters. 
-.PP
-Appends line to a file named either ENV(SNMP_PERSISTENT_FILE) or '<NETSNMP_PERSISTENT_DIRECTORY>/<type>.conf'. Adds a trailing newline to the stored file if necessary.
+read_config_store intended for use by applications to store permenant configuration information generated by sets or persistent counters. Appends line to a file named either ENV(SNMP_PERSISTENT_FILE) or '<NETSNMP_PERSISTENT_DIRECTORY>/<type>.conf'. Adds a trailing newline to the stored file if necessary.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -278,16 +271,10 @@
 .PP
 
 .PP
-Definition at line 1267 of file read_config.c.
-.PP
-References get_persistent_directory(), netsnmp_ds_get_boolean(), netsnmp_getenv(), NULL, and snmp_log().
-.PP
-Referenced by netsnmp_oid_stash_store(), netsnmp_save_all_data(), read_app_config_store(), and snmp_save_persistent().
+Definition at line 1272 of file read_config.c.
 .SS "char* read_config_store_data (int type, char * storeto, void * dataptr, size_t * len)"
 .PP
-read_config_store_data stores data of a given type to a configuration line into the storeto buffer. 
-.PP
-Calls read_config_store_data_prefix with the prefix parameter set to a char space. The supported types are:
+read_config_store_data stores data of a given type to a configuration line into the storeto buffer. Calls read_config_store_data_prefix with the prefix parameter set to a char space. The supported types are:
 .PP
 .IP "\(bu" 2
 ASN_INTEGER
@@ -321,14 +308,10 @@
 .PP
 
 .PP
-Definition at line 1990 of file read_config.c.
-.PP
-References read_config_store_data_prefix().
-.SS "struct \fBconfig_line\fP* register_config_handler (const char * type, const char * token, void(*)(const char *, char *) parser, void(*)(void) releaser, const char * help)"
-.PP
-register_config_handler registers handlers for certain tokens specified in certain types of files. 
-.PP
-Allows a module writer use/register multiple configuration files based off of the type parameter. A module writer may want to set up multiple configuration files to separate out related tasks/variables or just for management of where to put tokens as the module or modules get more complex in regard to handling token registrations.
+Definition at line 1995 of file read_config.c.
+.SS "struct \fBconfig_line\fP* register_config_handler (const char * type, const char * token, void(*)(const char *, char *) parser, void(*)(void) releaser, const char * help)\fC [read]\fP"
+.PP
+register_config_handler registers handlers for certain tokens specified in certain types of files. Allows a \fBmodule\fP writer use/register multiple configuration files based off of the type parameter. A \fBmodule\fP writer may want to set up multiple configuration files to separate out related tasks/variables or just for management of where to put tokens as the \fBmodule\fP or modules get more complex in regard to handling token registrations.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -351,13 +334,9 @@
 
 .PP
 Definition at line 284 of file read_config.c.
-.PP
-Referenced by netsnmp_ds_register_config(), netsnmp_register_save_list(), register_app_config_handler(), and register_mib_handlers().
 .SS "void unregister_config_handler (const char * type_param, const char * token)"
 .PP
-uregister_config_handler un-registers handlers given a specific type_param and token. 
-.PP
-\fBParameters:\fP
+uregister_config_handler un-registers handlers given a specific type_param and token. \fBParameters:\fP
 .RS 4
 \fItype_param\fP the configuration file used where the token is located. Used to lookup the config file entry
 .br
@@ -372,7 +351,6 @@
 
 .PP
 Definition at line 315 of file read_config.c.
-.PP
-References config_files, netsnmp_ds_get_string(), config_line::next, NULL, SNMP_FREE, and unregister_config_handler().
-.PP
-Referenced by netsnmp_ds_shutdown(), unregister_all_config_handlers(), unregister_app_config_handler(), and unregister_config_handler().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_read_only.3'
--- man/netsnmp_read_only.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_read_only.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "read_only" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "read_only" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-read_only \- Make your handler read_only automatically The only purpose of this handler is to return an appropriate error for any requests passed to it in a SET mode.  
+read_only \- 
+.PP
+Make your handler read_only automatically The only purpose of this handler is to return an appropriate error for any requests passed to it in a SET mode.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -23,7 +24,7 @@
 .SH "Detailed Description"
 .PP 
 Make your handler read_only automatically The only purpose of this handler is to return an appropriate error for any requests passed to it in a SET mode. 
-.PP
+
 Inserting it into your handler chain will ensure you're never asked to perform a SET request so you can ignore those error conditions. 
 .SH "Function Documentation"
 .PP 
@@ -32,14 +33,11 @@
 returns a read_only handler that can be injected into a given handler chain. 
 .PP
 Definition at line 29 of file read_only.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_create_handler(), netsnmp_read_only_helper(), and NULL.
-.PP
-Referenced by netsnmp_init_read_only_helper(), netsnmp_register_read_only_instance(), netsnmp_register_read_only_scalar(), and netsnmp_register_read_only_table_data().
 .SS "void netsnmp_init_read_only_helper (void)"
 .PP
 initializes the read_only helper which then registers a read_only handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 81 of file read_only.c.
-.PP
-References netsnmp_get_read_only_handler(), and netsnmp_register_handler_by_name().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_row_merge.3'
--- man/netsnmp_row_merge.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_row_merge.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "row_merge" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "row_merge" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-row_merge \- Calls sub handlers with request for one row at a time.  
+row_merge \- 
+.PP
+Calls sub handlers with request for one row at a time.  
 
-.PP
 .SS "Defines"
 
 .in +1c
@@ -56,7 +57,7 @@
 .SH "Detailed Description"
 .PP 
 Calls sub handlers with request for one row at a time. 
-.PP
+
 This helper splits a whole bunch of requests into chunks based on the row index that they refer to, and passes all requests for a given row to the lower handlers. This is useful for handlers that don't want to process multiple rows at the same time, but are happy to iterate through the request list for a single row. 
 .SH "Function Documentation"
 .PP 
@@ -65,57 +66,36 @@
 returns a row_merge handler that can be injected into a given handler chain. 
 .PP
 Definition at line 28 of file row_merge.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_row_merge_helper_handler(), and NULL.
-.PP
-Referenced by netsnmp_init_row_merge(), and netsnmp_register_row_merge().
 .SS "void netsnmp_init_row_merge (void)"
 .PP
 initializes the row_merge helper which then registers a row_merge handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 360 of file row_merge.c.
-.PP
-References netsnmp_get_row_merge_handler(), and netsnmp_register_handler_by_name().
 .SS "int netsnmp_register_row_merge (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 functionally the same as calling \fBnetsnmp_register_handler()\fP but also injects a row_merge handler at the same time for you. 
 .PP
 Definition at line 42 of file row_merge.c.
-.PP
-References netsnmp_get_row_merge_handler(), netsnmp_inject_handler(), netsnmp_register_handler(), and netsnmp_handler_registration_s::rootoid_len.
 .SS "int netsnmp_row_merge_helper_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 Implements the row_merge handler. 
 .PP
 Definition at line 154 of file row_merge.c.
-.PP
-References netsnmp_row_merge_status_x::count, netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, variable_list::name, variable_list::name_length, netsnmp_call_next_handler(), netsnmp_row_merge_status_get(), netsnmp_request_info_s::next, NULL, netsnmp_request_info_s::prev, netsnmp_request_info_s::processed, netsnmp_request_info_s::requestvb, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, ROW_MERGE_DONE, ROW_MERGE_WAITING, netsnmp_row_merge_status_x::rows, netsnmp_row_merge_status_x::saved_requests, netsnmp_row_merge_status_x::saved_status, and SNMP_FREE.
-.PP
-Referenced by netsnmp_get_row_merge_handler().
 .SS "int netsnmp_row_merge_status_first (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo)"
 .PP
-Determine if this is the first row. 
-.PP
-returns 1 if this is the first row for this pass of the handler. 
+Determine if this is the first row. returns 1 if this is the first row for this pass of the handler. 
 .PP
 Definition at line 110 of file row_merge.c.
-.PP
-References netsnmp_row_merge_status_x::count, netsnmp_row_merge_status_x::current, netsnmp_row_merge_status_get(), and NULL.
 .SS "\fBnetsnmp_row_merge_status\fP* netsnmp_row_merge_status_get (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, int create_missing)"
 .PP
 retrieve row_merge_status 
 .PP
 Definition at line 67 of file row_merge.c.
-.PP
-References netsnmp_agent_add_list_data(), netsnmp_agent_get_list_data(), netsnmp_create_data_list(), NULL, snmp_log(), and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_row_merge_helper_handler(), netsnmp_row_merge_status_first(), and netsnmp_row_merge_status_last().
 .SS "int netsnmp_row_merge_status_last (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo)"
 .PP
-Determine if this is the last row. 
-.PP
-returns 1 if this is the last row for this pass of the handler. 
+Determine if this is the last row. returns 1 if this is the last row for this pass of the handler. 
 .PP
 Definition at line 130 of file row_merge.c.
-.PP
-References netsnmp_row_merge_status_x::count, netsnmp_row_merge_status_x::current, netsnmp_row_merge_status_get(), NULL, and netsnmp_row_merge_status_x::rows.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_scalar.3'
--- man/netsnmp_scalar.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_scalar.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "scalar" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "scalar" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-scalar \- Process scalars easily.  
+scalar \- 
+.PP
+Process scalars easily.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -27,14 +28,11 @@
 .SH "Detailed Description"
 .PP 
 Process scalars easily. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_scalar_handler (void)"
 .PP
-Creates a scalar handler calling netsnmp_create_handler with a handler name defaulted to 'scalar' and access method, netsnmp_scalar_helper_handler. 
-.PP
-\fBReturns:\fP
+Creates a scalar handler calling netsnmp_create_handler with a handler name defaulted to 'scalar' and access method, netsnmp_scalar_helper_handler. \fBReturns:\fP
 .RS 4
 Returns a pointer to a netsnmp_mib_handler struct which contains the handler's name and the access method
 .RE
@@ -49,15 +47,9 @@
 
 .PP
 Definition at line 46 of file scalar.c.
-.PP
-References netsnmp_create_handler(), and netsnmp_scalar_helper_handler().
-.PP
-Referenced by netsnmp_register_read_only_scalar(), netsnmp_register_scalar(), and netsnmp_register_scalar_group().
 .SS "int netsnmp_register_read_only_scalar (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
-This function registers a read only scalar helper handler. 
-.PP
-This function is very similar to netsnmp_register_scalar the only addition is that the 'read_only' handler is injected into the handler chain prior to injecting the serialize handler and registering reginfo.
+This function registers a read only scalar helper handler. This function is very similar to netsnmp_register_scalar the only addition is that the 'read_only' handler is injected into the handler chain prior to injecting the serialize handler and registering reginfo.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -79,13 +71,9 @@
 
 .PP
 Definition at line 109 of file scalar.c.
-.PP
-References netsnmp_get_instance_handler(), netsnmp_get_read_only_handler(), netsnmp_get_scalar_handler(), netsnmp_inject_handler(), netsnmp_register_serialize(), netsnmp_handler_registration_s::rootoid, and netsnmp_handler_registration_s::rootoid_len.
 .SS "int netsnmp_register_scalar (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
-This function registers a scalar helper handler. 
-.PP
-The registered OID, reginfo->rootoid, space is extended for the instance subid using realloc() but the reginfo->rootoid_len length is not extended just yet. .This function subsequently injects the instance, scalar, and serialize helper handlers before actually registering reginfo.
+This function registers a scalar helper handler. The registered OID, reginfo->rootoid, space is extended for the instance subid using realloc() but the reginfo->rootoid_len length is not extended just yet. .This function subsequently injects the instance, scalar, and serialize helper handlers before actually registering reginfo.
 .PP
 Each handler is injected/pushed to the top of the handler chain list and will be processed last in first out, LIFO.
 .PP
@@ -109,7 +97,6 @@
 
 .PP
 Definition at line 74 of file scalar.c.
-.PP
-References netsnmp_get_instance_handler(), netsnmp_get_scalar_handler(), netsnmp_inject_handler(), netsnmp_register_serialize(), netsnmp_handler_registration_s::rootoid, and netsnmp_handler_registration_s::rootoid_len.
-.PP
-Referenced by netsnmp_register_watched_scalar(), and netsnmp_watched_timestamp_register().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_scalar_group_group.3'
--- man/netsnmp_scalar_group_group.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_scalar_group_group.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "scalar_group" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "scalar_group" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-scalar_group \- Process groups of scalars.  
+scalar_group \- 
+.PP
+Process groups of scalars.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -21,5 +22,6 @@
 .SH "Detailed Description"
 .PP 
 Process groups of scalars. 
-.PP
-
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_serialize.3'
--- man/netsnmp_serialize.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_serialize.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "serialize" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "serialize" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-serialize \- Calls sub handlers one request at a time.  
+serialize \- 
+.PP
+Calls sub handlers one request at a time.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -28,7 +29,7 @@
 .SH "Detailed Description"
 .PP 
 Calls sub handlers one request at a time. 
-.PP
+
 This functionally passes in one request at a time into lower handlers rather than a whole bunch of requests at once. This is useful for handlers that don't want to iterate through the request lists themselves. Generally, this is probably less efficient so use with caution. The serialize handler might be useable to dynamically fix handlers with broken looping code, however. 
 .SH "Function Documentation"
 .PP 
@@ -37,32 +38,21 @@
 returns a serialize handler that can be injected into a given handler chain. 
 .PP
 Definition at line 31 of file serialize.c.
-.PP
-References netsnmp_create_handler(), and netsnmp_serialize_helper_handler().
-.PP
-Referenced by netsnmp_init_serialize(), and netsnmp_register_serialize().
 .SS "void netsnmp_init_serialize (void)"
 .PP
 initializes the serialize helper which then registers a serialize handler as a run-time injectable handler for configuration file use. 
 .PP
 Definition at line 93 of file serialize.c.
-.PP
-References netsnmp_get_serialize_handler(), and netsnmp_register_handler_by_name().
 .SS "int netsnmp_register_serialize (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 functionally the same as calling \fBnetsnmp_register_handler()\fP but also injects a serialize handler at the same time for you. 
 .PP
 Definition at line 40 of file serialize.c.
-.PP
-References netsnmp_get_serialize_handler(), netsnmp_inject_handler(), and netsnmp_register_handler().
-.PP
-Referenced by netsnmp_register_instance(), netsnmp_register_read_only_instance(), netsnmp_register_read_only_scalar(), netsnmp_register_scalar(), and netsnmp_register_scalar_group().
 .SS "int netsnmp_serialize_helper_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 Implements the serial handler. 
 .PP
 Definition at line 48 of file serialize.c.
-.PP
-References netsnmp_call_next_handler(), netsnmp_request_info_s::next, and NULL.
-.PP
-Referenced by netsnmp_get_serialize_handler().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_snmp_agent.3'
--- man/netsnmp_snmp_agent.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_agent.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "net-snmp agent related processing" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "net-snmp agent related processing" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -33,10 +33,10 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fB_agent_nsap\fP \fBagent_nsap\fP"
+.RI "typedef struct \fB_agent_nsap\fP \fBagent_nsap\fP"
 .br
 .ti -1c
-.RI "typedef \fBagent_set_cache_s\fP \fBagent_set_cache\fP"
+.RI "typedef struct \fBagent_set_cache_s\fP \fBagent_set_cache\fP"
 .br
 .in -1c
 .SS "Enumerations"
@@ -122,6 +122,9 @@
 .RI "void \fBnetsnmp_addrcache_initialise\fP (void)"
 .br
 .ti -1c
+.RI "void \fBnetsnmp_addrcache_destroy\fP (void)"
+.br
+.ti -1c
 .RI "int \fBnetsnmp_addrcache_add\fP (const char *addr)"
 .br
 .ti -1c
@@ -167,7 +170,7 @@
 .RI "void \fBnetsnmp_remove_and_free_agent_snmp_session\fP (\fBnetsnmp_agent_session\fP *asp)"
 .br
 .ti -1c
-.RI "void \fBnetsnmp_free_agent_snmp_session_by_session\fP (\fBnetsnmp_session\fP *sess, void(*free_request)(netsnmp_request_list *))"
+.RI "void \fBnetsnmp_free_agent_snmp_session_by_session\fP (\fBnetsnmp_session\fP *sess, void(*free_request)(\fBnetsnmp_request_list\fP *))"
 .br
 .ti -1c
 .RI "int \fBhandle_snmp_packet\fP (int op, \fBnetsnmp_session\fP *session, int reqid, \fBnetsnmp_pdu\fP *pdu, void *magic)"
@@ -237,7 +240,7 @@
 .br
 .RI "\fIset error for all requests \fP"
 .ti -1c
-.RI "u_long \fBnetsnmp_marker_uptime\fP (\fBmarker_t\fP pm)"
+.RI "u_long \fBnetsnmp_marker_uptime\fP (marker_t pm)"
 .br
 .ti -1c
 .RI "u_long \fBnetsnmp_timeval_uptime\fP (struct timeval *tv)"
@@ -266,11 +269,11 @@
 .ti -1c
 .RI "int \fBnetsnmp_set_request_error\fP (\fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *request, int error_value)"
 .br
-.RI "\fIdeprecated, use netsnmp_request_set_error instead \fP"
+.RI "\fIset error for a request \fP"
 .ti -1c
 .RI "int \fBnetsnmp_set_mode_request_error\fP (int mode, \fBnetsnmp_request_info\fP *request, int error_value)"
 .br
-.RI "\fIdeprecated, use netsnmp_request_set_error instead \fP"
+.RI "\fIset error for a request \fP"
 .ti -1c
 .RI "int \fBnetsnmp_set_all_requests_error\fP (\fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests, int error_value)"
 .br
@@ -283,7 +286,7 @@
 .RI "oid \fBversion_sysoid\fP [] = { NETSNMP_SYSTEM_MIB }"
 .br
 .ti -1c
-.RI "int \fBversion_sysoid_len\fP = OID_LENGTH(\fBversion_sysoid\fP)"
+.RI "int \fBversion_sysoid_len\fP = OID_LENGTH(version_sysoid)"
 .br
 .ti -1c
 .RI "int \fBlog_addresses\fP = 0"
@@ -304,7 +307,7 @@
 .RI "\fBnetsnmp_session\fP * \fBmain_session\fP = NULL"
 .br
 .ti -1c
-.RI "timeval \fBstarttime\fP"
+.RI "struct timeval \fBstarttime\fP"
 .br
 .in -1c
 .SH "Function Documentation"
@@ -313,16 +316,10 @@
 .PP
 set error for a request 
 .PP
-Definition at line 3395 of file snmp_agent.c.
-.PP
-References netsnmp_request_info_s::delegated, netsnmp_request_info_s::processed, REQUEST_IS_NOT_DELEGATED, netsnmp_request_info_s::requestvb, snmp_log(), netsnmp_request_info_s::status, and variable_list::type.
-.PP
-Referenced by netsnmp_request_set_error(), netsnmp_request_set_error_all(), netsnmp_request_set_error_idx(), netsnmp_set_mode_request_error(), and netsnmp_set_request_error().
+Definition at line 3414 of file snmp_agent.c.
 .SS "int agent_check_and_process (int block)"
 .PP
-This function checks for packets arriving on the SNMP port and processes them(snmp_read) if some are found, using the select(). 
-.PP
-If block is non zero, the function call blocks until a packet arrives
+This function checks for packets arriving on the SNMP port and processes them(snmp_read) if some are found, using the select(). If block is non zero, the function call blocks until a packet arrives
 .PP
 \fBParameters:\fP
 .RS 4
@@ -337,35 +334,19 @@
 
 .PP
 Definition at line 566 of file snmp_agent.c.
-.PP
-References FD_ZERO, netsnmp_check_outstanding_agent_requests(), NULL, run_alarms(), snmp_log(), snmp_log_perror(), snmp_read(), snmp_select_info(), and snmp_timeout().
 .SS "int check_getnext_results (\fBnetsnmp_agent_session\fP * asp)"
 .PP
-returns 1 if there are valid GETNEXT requests left. 
-.PP
-Returns 0 if not. 
-.PP
-Definition at line 2796 of file snmp_agent.c.
-.PP
-References netsnmp_request_info_s::inclusive, netsnmp_request_info_s::index, netsnmp_agent_session_s::mode, variable_list::name, variable_list::name_length, netsnmp_request_info_s::next, NULL, netsnmp_agent_session_s::oldmode, netsnmp_request_info_s::range_end, netsnmp_request_info_s::range_end_len, netsnmp_request_info_s::requestvb, snmp_oid_compare(), snmp_set_var_objid(), snmp_set_var_typed_value(), netsnmp_agent_session_s::treecache, netsnmp_agent_session_s::treecache_num, and variable_list::type.
-.PP
-Referenced by handle_getnext_loop().
+returns 1 if there are valid GETNEXT requests left. Returns 0 if not. 
+.PP
+Definition at line 2815 of file snmp_agent.c.
 .SS "int handle_getnext_loop (\fBnetsnmp_agent_session\fP * asp)"
 .PP
-repeatedly calls getnext handlers looking for an answer till all requests are satisified. 
-.PP
-It's expected that one pass has been made before entering this function 
-.PP
-Definition at line 2913 of file snmp_agent.c.
-.PP
-References check_acm(), check_getnext_results(), handle_var_requests(), netsnmp_check_for_delegated(), netsnmp_reassign_requests(), netsnmp_running, and variable_list::next_variable.
-.PP
-Referenced by check_delayed_request(), and handle_pdu().
+repeatedly calls getnext handlers looking for an answer till all requests are satisified. It's expected that one pass has been made before entering this function 
+.PP
+Definition at line 2932 of file snmp_agent.c.
 .SS "int handle_pdu (\fBnetsnmp_agent_session\fP * asp)"
 .PP
-This function calls into netsnmp_set_mode_request_error, sets error_value given a reqinfo->mode value. 
-.PP
-It's used to send specific errors back to the agent to process accordingly.
+This function calls into netsnmp_set_mode_request_error, sets error_value given a reqinfo->mode value. It's used to send specific errors back to the agent to process accordingly.
 .PP
 If error_value is set to SNMP_NOSUCHOBJECT, SNMP_NOSUCHINSTANCE, or SNMP_ENDOFMIBVIEW the following is applicable: Sets the error_value to request->requestvb->type if reqinfo->mode value is set to MODE_GET. If the reqinfo->mode value is set to MODE_GETNEXT or MODE_GETBULK the code calls snmp_log logging an error message.
 .PP
@@ -432,45 +413,32 @@
 .PP
 
 .PP
-Definition at line 3207 of file snmp_agent.c.
-.PP
-References check_acm(), snmp_pdu::command, count_varbinds(), snmp_pdu::flags, get_set_cache(), handle_getnext_loop(), handle_set_loop(), handle_var_requests(), netsnmp_agent_session_s::mode, netsnmp_create_subtree_cache(), variable_list::next_variable, NULL, netsnmp_agent_session_s::oldmode, netsnmp_agent_session_s::pdu, netsnmp_agent_session_s::requests, snmp_increment_statistic(), snmp_replace_var_types(), snmp_set_var_typed_value(), netsnmp_agent_session_s::status, variable_list::type, snmp_pdu::variables, and netsnmp_agent_session_s::vbcount.
-.PP
-Referenced by netsnmp_handle_request().
+Definition at line 3226 of file snmp_agent.c.
 .SS "int handle_snmp_packet (int op, \fBnetsnmp_session\fP * session, int reqid, \fBnetsnmp_pdu\fP * pdu, void * magic)"
 .PP
 handles an incoming SNMP packet into the agent 
 .PP
-Definition at line 1754 of file snmp_agent.c.
-.PP
-References check_access(), snmp_pdu::command, snmp_pdu::errstat, init_agent_snmp_session(), netsnmp_handle_request(), netsnmp_remove_and_free_agent_snmp_session(), NULL, netsnmp_agent_session_s::pdu, snmp_session::s_snmp_errno, send_easy_trap(), netsnmp_agent_session_s::session, snmp_free_pdu(), snmp_increment_statistic(), snmp_send(), netsnmp_agent_session_s::status, and snmp_pdu::version.
-.PP
-Referenced by netsnmp_register_agent_nsap().
+Definition at line 1771 of file snmp_agent.c.
 .SS "\fBnetsnmp_request_info\fP* netsnmp_add_varbind_to_cache (\fBnetsnmp_agent_session\fP * asp, int vbcount, \fBnetsnmp_variable_list\fP * varbind_ptr, \fBnetsnmp_subtree\fP * tp)"
 .PP
-Definition at line 1863 of file snmp_agent.c.
-.PP
-References netsnmp_request_info_s::agent_req_info, netsnmp_agent_session_s::cache_store, netsnmp_subtree_s::cacheid, snmp_pdu::command, netsnmp_request_info_s::delegated, netsnmp_subtree_s::end_a, netsnmp_subtree_s::end_len, netsnmp_subtree_s::global_cacheid, netsnmp_request_info_s::inclusive, netsnmp_request_info_s::index, variable_list::name, variable_list::name_length, netsnmp_acm_check_subtree(), netsnmp_free_request_data_sets(), netsnmp_get_local_cachid(), netsnmp_get_or_add_local_cachid(), netsnmp_oid_find_prefix(), netsnmp_request_info_s::next, netsnmp_subtree_s::next, NULL, netsnmp_request_info_s::parent_data, netsnmp_agent_session_s::pdu, netsnmp_request_info_s::prev, netsnmp_request_info_s::processed, netsnmp_request_info_s::range_end, netsnmp_request_info_s::range_end_len, netsnmp_agent_session_s::reqinfo, netsnmp_agent_session_s::requests, netsnmp_tree_cache_s::requests_begin, netsnmp_tree_cache_s::requests_end, netsnmp_request_info_s::requestvb, netsnmp_request_info_s::requestvb_start, netsnmp_subtree_s::start_a, netsnmp_subtree_s::start_len, netsnmp_request_info_s::status, netsnmp_tree_cache_s::subtree, netsnmp_request_info_s::subtree, netsnmp_agent_session_s::treecache, netsnmp_agent_session_s::treecache_len, netsnmp_agent_session_s::treecache_num, and variable_list::type.
-.PP
-Referenced by netsnmp_create_subtree_cache(), and netsnmp_reassign_requests().
+\fBTodo\fP
+.RS 4
+make this be more intelligent about ranges. Right now we merely take the highest level commonality of a registration range and use that. At times we might be able to be smarter about checking the range itself as opposed to the \fBnode\fP above where the range exists, but I doubt this will come up all that frequently. 
+.RE
+.PP
+
+.PP
+Definition at line 1880 of file snmp_agent.c.
 .SS "int netsnmp_check_transaction_id (int transaction_id)"
 .PP
-Decide if the requested transaction_id is still being processed within the agent. 
-.PP
-This is used to validate whether a delayed cache (containing possibly freed pointers) is still usable.
+Decide if the requested transaction_id is still being processed within the agent. This is used to validate whether a delayed cache (containing possibly freed pointers) is still usable.
 .PP
 returns SNMPERR_SUCCESS if it's still valid, or SNMPERR_GENERR if not. 
 .PP
-Definition at line 2699 of file snmp_agent.c.
-.PP
-References agent_delegated_list, netsnmp_agent_session_s::next, and NULL.
-.PP
-Referenced by check_delayed_request(), and netsnmp_handler_check_cache().
+Definition at line 2718 of file snmp_agent.c.
 .SS "int netsnmp_request_set_error (\fBnetsnmp_request_info\fP * request, int error_value)"
 .PP
-set error for a request 
-.PP
-\fBParameters:\fP
+set error for a request \fBParameters:\fP
 .RS 4
 \fIrequest\fP request which has error 
 .br
@@ -479,16 +447,10 @@
 .PP
 
 .PP
-Definition at line 3463 of file snmp_agent.c.
-.PP
-References _request_set_error(), netsnmp_request_info_s::agent_req_info, and netsnmp_agent_request_info_s::mode.
-.PP
-Referenced by netsnmp_remove_delegated_requests_for_session().
+Definition at line 3482 of file snmp_agent.c.
 .SS "NETSNMP_INLINE int netsnmp_request_set_error_all (\fBnetsnmp_request_info\fP * requests, int error)"
 .PP
-set error for all requests 
-.PP
-\fBParameters:\fP
+set error for all requests \fBParameters:\fP
 .RS 4
 \fIrequests\fP request list 
 .br
@@ -504,16 +466,10 @@
 .PP
 paranoid sanity checks 
 .PP
-Definition at line 3506 of file snmp_agent.c.
-.PP
-References _request_set_error(), netsnmp_request_info_s::agent_req_info, netsnmp_agent_request_info_s::mode, netsnmp_request_info_s::next, NULL, and snmp_log().
-.PP
-Referenced by netsnmp_cache_helper_handler(), netsnmp_multiplexer_helper_handler(), netsnmp_read_only_helper(), and netsnmp_set_all_requests_error().
+Definition at line 3525 of file snmp_agent.c.
 .SS "int netsnmp_request_set_error_idx (\fBnetsnmp_request_info\fP * request, int error_value, int idx)"
 .PP
-set error for a request within a request list 
-.PP
-\fBParameters:\fP
+set error for a request within a request list \fBParameters:\fP
 .RS 4
 \fIrequest\fP head of the request list 
 .br
@@ -524,14 +480,10 @@
 .PP
 
 .PP
-Definition at line 3478 of file snmp_agent.c.
-.PP
-References _request_set_error(), netsnmp_request_info_s::agent_req_info, netsnmp_agent_request_info_s::mode, and netsnmp_request_info_s::next.
+Definition at line 3497 of file snmp_agent.c.
 .SS "int netsnmp_set_all_requests_error (\fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests, int error_value)"
 .PP
-set error for all request 
-.PP
-\fBDeprecated\fP
+set error for all request \fBDeprecated\fP
 .RS 4
 use netsnmp_request_set_error_all 
 .RE
@@ -552,12 +504,10 @@
 .PP
 
 .PP
-Definition at line 3680 of file snmp_agent.c.
-.PP
-References netsnmp_request_set_error_all().
+Definition at line 3699 of file snmp_agent.c.
 .SS "int netsnmp_set_mode_request_error (int mode, \fBnetsnmp_request_info\fP * request, int error_value)"
 .PP
-deprecated, use netsnmp_request_set_error instead 
+set error for a request deprecated, use netsnmp_request_set_error instead
 .PP
 \fBDeprecated\fP
 .RS 4
@@ -580,12 +530,10 @@
 .PP
 
 .PP
-Definition at line 3664 of file snmp_agent.c.
-.PP
-References _request_set_error().
+Definition at line 3683 of file snmp_agent.c.
 .SS "int netsnmp_set_request_error (\fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * request, int error_value)"
 .PP
-deprecated, use netsnmp_request_set_error instead 
+set error for a request deprecated, use netsnmp_request_set_error instead
 .PP
 \fBDeprecated\fP
 .RS 4
@@ -612,15 +560,12 @@
 .in +1c
 \fBdelayed_instance.c\fP.
 .PP
-Definition at line 3645 of file snmp_agent.c.
-.PP
-References _request_set_error(), and netsnmp_agent_request_info_s::mode.
-.PP
-Referenced by netsnmp_call_handlers(), netsnmp_instance_counter32_handler(), netsnmp_instance_helper_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_table_data_set_helper_handler(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), and table_helper_handler().
+Definition at line 3664 of file snmp_agent.c.
 .SS "int netsnmp_wrap_up_request (\fBnetsnmp_agent_session\fP * asp, int status)"
 .PP
-Definition at line 1501 of file snmp_agent.c.
-.PP
-References _fix_endofmibview(), _reorder_getbulk(), snmp_pdu::command, count_varbinds(), snmp_pdu::errindex, snmp_pdu::errstat, netsnmp_agent_session_s::index, variable_list::name, variable_list::name_length, netsnmp_processing_set, netsnmp_remove_and_free_agent_snmp_session(), variable_list::next_variable, NULL, netsnmp_agent_session_s::orig_pdu, netsnmp_agent_session_s::pdu, save_set_cache(), netsnmp_agent_session_s::session, SNMP_FREE, snmp_free_pdu(), snmp_increment_statistic(), snmp_increment_statistic_by(), snmp_log(), snmp_perror(), snmp_send(), sprint_realloc_objid(), netsnmp_agent_session_s::status, variable_list::type, snmp_pdu::variables, and snmp_pdu::version.
-.PP
-Referenced by check_delayed_request(), and netsnmp_handle_request().
+if asp->pdu 
+.PP
+Definition at line 1518 of file snmp_agent.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_snmp_alarm.3'
--- man/netsnmp_snmp_alarm.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_alarm.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "snmp_alarm" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "snmp_alarm" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -10,7 +10,7 @@
 
 .in +1c
 .ti -1c
-.RI "timeval \fBt\fP"
+.RI "struct timeval \fBt\fP"
 .br
 .ti -1c
 .RI "unsigned int \fBflags\fP"
@@ -19,10 +19,10 @@
 .RI "unsigned int \fBclientreg\fP"
 .br
 .ti -1c
-.RI "timeval \fBt_last\fP"
+.RI "struct timeval \fBt_last\fP"
 .br
 .ti -1c
-.RI "timeval \fBt_next\fP"
+.RI "struct timeval \fBt_next\fP"
 .br
 .ti -1c
 .RI "void * \fBclientarg\fP"
@@ -31,7 +31,7 @@
 .RI "SNMPAlarmCallback * \fBthecallback\fP"
 .br
 .ti -1c
-.RI "\fBsnmp_alarm\fP * \fBnext\fP"
+.RI "struct \fBsnmp_alarm\fP * \fBnext\fP"
 .br
 .in -1c
 .SH "Detailed Description"

=== modified file 'man/netsnmp_snmp_client.3'
--- man/netsnmp_snmp_client.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_client.3	2010-06-10 18:02:54 +0000
@@ -1,37 +1,8 @@
-.TH "various PDU processing routines" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "various PDU processing routines" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
 various PDU processing routines \- 
-.SS "Defines"
-
-.in +1c
-.ti -1c
-.RI "#define \fBBSD4_2\fP"
-.br
-.ti -1c
-.RI "#define \fBNFDBITS\fP   (sizeof(\fBfd_mask\fP) * NBBY)"
-.br
-.ti -1c
-.RI "#define \fBFD_SET\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_CLR\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_ISSET\fP(n, p)   ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))"
-.br
-.ti -1c
-.RI "#define \fBFD_ZERO\fP(p)   memset((p), 0, sizeof(*(p)))"
-.br
-.in -1c
-.SS "Typedefs"
-
-.in +1c
-.ti -1c
-.RI "typedef long \fBfd_mask\fP"
-.br
-.in -1c
 .SS "Functions"
 
 .in +1c
@@ -131,9 +102,7 @@
 .PP 
 .SS "int snmp_set_var_typed_value (\fBnetsnmp_variable_list\fP * newvar, u_char type, const u_char * val_str, size_t val_len)"
 .PP
-snmp_set_var_typed_value is used to set data into the netsnmp_variable_list structure. 
-.PP
-Used to return data to the snmp request via the netsnmp_request_info structure's requestvb pointer.
+snmp_set_var_typed_value is used to set data into the netsnmp_variable_list structure. Used to return data to the snmp request via the netsnmp_request_info structure's requestvb pointer.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -157,15 +126,12 @@
 .in +1c
 \fBdelayed_instance.c\fP.
 .PP
-Definition at line 686 of file snmp_client.c.
-.PP
-References snmp_set_var_value(), and variable_list::type.
-.PP
-Referenced by _reorder_getbulk(), check_getnext_results(), handle_pdu(), netsnmp_check_getnext_reply(), netsnmp_create_subtree_cache(), netsnmp_instance_counter32_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_stash_cache_helper(), netsnmp_table_build_result(), netsnmp_table_data_build_result(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), snmp_replace_var_types(), and snmp_reset_var_types().
+Definition at line 687 of file snmp_client.c.
 .SS "int snmp_set_var_value (\fBnetsnmp_variable_list\fP * vars, const u_char * value, size_t len)"
 .PP
-Definition at line 753 of file snmp_client.c.
-.PP
-References variable_list::buf, netsnmp_vardata::counter64, netsnmp_vardata::integer, NULL, netsnmp_vardata::objid, snmp_log(), snmp_set_detail(), netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
-.PP
-Referenced by parse_one_oid_index(), snmp_set_var_typed_integer(), snmp_set_var_typed_value(), and snmp_varlist_add_variable().
+FALL THROUGH 
+.PP
+Definition at line 754 of file snmp_client.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_snmp_logging.3'
--- man/netsnmp_snmp_logging.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_logging.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "generic logging for net-snmp" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "generic logging for net-snmp" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -13,39 +13,6 @@
 .RI "#define \fBva_copy\fP(dest, src)   memcpy (&dest, &src, sizeof (va_list))"
 .br
 .ti -1c
-.RI "#define \fBLOG_CONS\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_PID\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL0\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL1\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL2\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL3\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL4\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL5\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL6\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_LOCAL7\fP   0"
-.br
-.ti -1c
-.RI "#define \fBLOG_DAEMON\fP   0"
-.br
-.ti -1c
 .RI "#define \fBLOG_USER\fP   0"
 .br
 .in -1c
@@ -65,7 +32,7 @@
 .RI "void \fBshutdown_snmp_logging\fP (void)"
 .br
 .ti -1c
-.RI "int \fBdecode_priority\fP (char *optarg, int *pri_max)"
+.RI "int \fBdecode_priority\fP (char **optarg, int *pri_max)"
 .br
 .ti -1c
 .RI "int \fBdecode_facility\fP (char *optarg)"
@@ -164,11 +131,11 @@
 .ti -1c
 .RI "int \fBsnmp_vlog\fP (int priority, const char *format, va_list ap)"
 .br
-.RI "\fIThis snmp logging function allows variable argument list given the specified priority, format and a populated va_list structure. \fP"
+.RI "\fIThis snmp logging function allows \fBvariable\fP argument list given the specified priority, format and a populated va_list structure. \fP"
 .ti -1c
 .RI "int \fBsnmp_log\fP (int priority, const char *format,...)"
 .br
-.RI "\fIThis snmp logging function allows variable argument list given the specified format and priority. \fP"
+.RI "\fIThis snmp logging function allows \fBvariable\fP argument list given the specified format and priority. \fP"
 .ti -1c
 .RI "void \fBsnmp_log_perror\fP (const char *s)"
 .br
@@ -190,30 +157,22 @@
 .PP 
 .SS "void netsnmp_logging_restart (void)"
 .PP
-Definition at line 616 of file snmp_logging.c.
+hmm, don't zero status isn't saved.. i think it's safer not to overwrite, in case a hup is just to re-read config files...
 .PP
-References netsnmp_log_handler_s::enabled, logh_head, netsnmp_enable_filelog(), netsnmp_log_handler_s::next, snmp_disable_filelog_entry(), snmp_disable_syslog_entry(), snmp_enable_syslog_ident(), and netsnmp_log_handler_s::type.
+Definition at line 636 of file snmp_logging.c.
 .SS "int snmp_get_do_logging (void)"
 .PP
-Is logging done? 
-.PP
-\fBReturns:\fP
+Is logging done? \fBReturns:\fP
 .RS 4
 Returns 0 if logging is off, 1 when it is done. 
 .RE
 .PP
 
 .PP
-Definition at line 473 of file snmp_logging.c.
-.PP
-References netsnmp_log_handler_s::enabled, logh_head, and netsnmp_log_handler_s::next.
-.PP
-Referenced by netsnmp_agent_check_parse().
+Definition at line 493 of file snmp_logging.c.
 .SS "int snmp_log (int priority, const char * format,  ...)"
 .PP
-This snmp logging function allows variable argument list given the specified format and priority. 
-.PP
-Calls the snmp_vlog function. The default logfile this function writes to is /var/log/snmpd.log.
+This snmp logging function allows \fBvariable\fP argument list given the specified format and priority. Calls the snmp_vlog function. The default logfile this function writes to is /var/log/snmpd.log.
 .PP
 \fBSee also:\fP
 .RS 4
@@ -226,16 +185,10 @@
 .in +1c
 \fBdelayed_instance.c\fP.
 .PP
-Definition at line 1255 of file snmp_logging.c.
-.PP
-References snmp_vlog().
-.PP
-Referenced by _callback_lock(), _request_set_error(), _sess_read(), agent_check_and_process(), config_perror(), config_pwarn(), convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), copy_word(), create_trap_session(), init_agent(), init_master_agent(), netsnmp_addrcache_add(), netsnmp_agent_check_packet(), netsnmp_agent_check_parse(), netsnmp_baby_steps_handler_get(), netsnmp_cache_create(), netsnmp_cache_helper_handler(), netsnmp_cache_timer_start(), netsnmp_cache_timer_stop(), netsnmp_call_handler(), netsnmp_call_handlers(), netsnmp_call_next_handler(), netsnmp_call_next_handler_one_request(), netsnmp_config_parse_add_row(), netsnmp_config_parse_table_set(), netsnmp_container_get_null(), netsnmp_container_iterator_get(), netsnmp_container_table_handler_get(), netsnmp_container_table_register(), netsnmp_data_list_add_data(), netsnmp_data_list_add_node(), netsnmp_ds_handle_config(), netsnmp_get_multiplexer_handler(), netsnmp_get_table_data_handler(), netsnmp_get_table_data_set_handler(), netsnmp_get_table_handler(), netsnmp_get_tdata_handler(), netsnmp_inject_handler_before(), netsnmp_instance_counter32_handler(), netsnmp_mark_row_column_writable(), netsnmp_multiplexer_helper_handler(), netsnmp_read_data_callback(), netsnmp_register_handler(), netsnmp_register_handler_nocallback(), netsnmp_register_mib(), netsnmp_register_num_file_instance(), netsnmp_register_save_list(), netsnmp_request_set_error_all(), netsnmp_row_merge_status_get(), netsnmp_save_all_data_callback(), netsnmp_send_traps(), netsnmp_sess_log_error(), netsnmp_set_row_column(), netsnmp_table_container_register(), netsnmp_table_data_add_row(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_table_row_handler_get(), netsnmp_table_row_register(), netsnmp_table_set_add_default_row(), netsnmp_tdata_add_row(), netsnmp_wrap_up_request(), read_config_files(), read_config_print_usage(), read_config_read_octet_string(), read_config_store(), register_signal(), snmp_build(), snmp_clean_persistent(), snmp_log_perror(), snmp_pdu_parse(), snmp_perror(), snmp_save_persistent(), snmp_set_var_value(), snmpd_parse_config_authtrap(), snmpv3_make_report(), snmpv3_packet_build(), snmpv3_parse(), and table_helper_handler().
+Definition at line 1275 of file snmp_logging.c.
 .SS "int snmp_vlog (int priority, const char * format, va_list ap)"
 .PP
-This snmp logging function allows variable argument list given the specified priority, format and a populated va_list structure. 
-.PP
-The default logfile this function writes to is /var/log/snmpd.log.
+This snmp logging function allows \fBvariable\fP argument list given the specified priority, format and a populated va_list structure. The default logfile this function writes to is /var/log/snmpd.log.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -270,7 +223,7 @@
 
 .PP
 .br
-\fIformat\fP is a pointer to a char representing the variable argument list format used.
+\fIformat\fP is a pointer to a char representing the \fBvariable\fP argument list format used.
 .br
 \fIap\fP is a va_list type used to traverse the list of arguments.
 .RE
@@ -287,8 +240,7 @@
 .PP
 
 .PP
-Definition at line 1194 of file snmp_logging.c.
-.PP
-References LOGLENGTH, NULL, snmp_log_string(), va_copy, and vsnprintf().
-.PP
-Referenced by snmp_log().
+Definition at line 1214 of file snmp_logging.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_snmp_pdu.3'
--- man/netsnmp_snmp_pdu.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_pdu.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "snmp_pdu" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "snmp_pdu" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-snmp_pdu \- The snmp protocol data unit.  
+snmp_pdu \- 
+.PP
+The snmp protocol data unit.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <snmp_api.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -155,192 +156,136 @@
 Definition at line 75 of file snmp_api.h.
 .SH "Field Documentation"
 .PP 
-.SS "long \fBsnmp_pdu::version\fP"
-.PP
-snmp version 
-.PP
-Definition at line 81 of file snmp_api.h.
-.PP
-Referenced by check_access(), handle_snmp_packet(), in_a_view(), netsnmp_acm_check_subtree(), netsnmp_wrap_up_request(), send_trap_to_sess(), snmp_pdu_create(), and snmpv3_parse().
+.SS "unsigned char \fBsnmp_pdu::agent_addr\fP[4]"
+.PP
+This is ONLY used for v1 TRAPs. 
+.PP
+Definition at line 142 of file snmp_api.h.
 .SS "int \fBsnmp_pdu::command\fP"
 .PP
 Type of this PDU. 
 .PP
 Definition at line 83 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), handle_pdu(), handle_snmp_packet(), netsnmp_add_varbind_to_cache(), netsnmp_agent_check_parse(), netsnmp_check_outstanding_agent_requests(), netsnmp_create_subtree_cache(), netsnmp_handle_request(), netsnmp_wrap_up_request(), save_set_cache(), send_trap_to_sess(), snmp_fix_pdu(), snmp_pdu_build(), snmp_pdu_create(), snmp_pdu_parse(), snmpv3_make_report(), and snmpv3_scopedPDU_parse().
-.SS "long \fBsnmp_pdu::reqid\fP"
-.PP
-Request id - note: not incremented on retries. 
-.PP
-Definition at line 85 of file snmp_api.h.
-.PP
-Referenced by snmp_fix_pdu(), snmp_pdu_build(), snmp_pdu_create(), and snmp_pdu_parse().
-.SS "long \fBsnmp_pdu::msgid\fP"
-.PP
-Message id for V3 messages note: incremented for each retry. 
-.PP
-Definition at line 87 of file snmp_api.h.
-.PP
-Referenced by snmp_fix_pdu(), snmp_pdu_create(), and snmpv3_parse().
-.SS "long \fBsnmp_pdu::transid\fP"
-.PP
-Unique ID for incoming transactions. 
-.PP
-Definition at line 89 of file snmp_api.h.
-.PP
-Referenced by check_delayed_request(), get_set_cache(), netsnmp_create_delegated_cache(), and save_set_cache().
-.SS "long \fBsnmp_pdu::sessid\fP"
-.PP
-Session id for AgentX messages. 
-.PP
-Definition at line 91 of file snmp_api.h.
-.PP
-Referenced by send_trap_to_sess().
-.SS "long \fBsnmp_pdu::errstat\fP"
-.PP
-Error status (non_repeaters in GetBulk). 
-.PP
-Definition at line 93 of file snmp_api.h.
-.PP
-Referenced by _reorder_getbulk(), handle_snmp_packet(), netsnmp_agent_check_parse(), netsnmp_create_subtree_cache(), netsnmp_wrap_up_request(), snmp_fix_pdu(), snmp_pdu_build(), snmp_pdu_create(), snmp_pdu_parse(), and snmpv3_make_report().
-.SS "long \fBsnmp_pdu::errindex\fP"
-.PP
-Error index (max_repetitions in GetBulk). 
-.PP
-Definition at line 95 of file snmp_api.h.
-.PP
-Referenced by _reorder_getbulk(), netsnmp_agent_check_parse(), netsnmp_create_subtree_cache(), netsnmp_wrap_up_request(), snmp_fix_pdu(), snmp_pdu_build(), snmp_pdu_create(), snmp_pdu_parse(), and snmpv3_make_report().
-.SS "u_long \fBsnmp_pdu::time\fP"
-.PP
-Uptime. 
-.PP
-Definition at line 97 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), netsnmp_send_traps(), snmp_pdu_build(), snmp_pdu_create(), and snmp_pdu_parse().
-.SS "int \fBsnmp_pdu::securityLevel\fP"
-.PP
-noAuthNoPriv, authNoPriv, authPriv 
-.PP
-Definition at line 102 of file snmp_api.h.
-.PP
-Referenced by snmpv3_make_report(), snmpv3_packet_build(), and snmpv3_parse().
-.SS "void* \fBsnmp_pdu::transport_data\fP"
-.PP
-Transport-specific opaque data. 
-.PP
-This replaces the IP-centric address field. 
-.PP
-Definition at line 110 of file snmp_api.h.
-.PP
-Referenced by snmp_create_sess_pdu(), snmp_free_pdu(), and snmp_pdu_create().
-.SS "const oid* \fBsnmp_pdu::tDomain\fP"
-.PP
-The actual transport domain. 
-.PP
-This SHOULD NOT BE FREE()D. 
-.PP
-Definition at line 117 of file snmp_api.h.
-.PP
-Referenced by snmp_create_sess_pdu().
 .SS "u_char* \fBsnmp_pdu::community\fP"
 .PP
 community for outgoing requests. 
 .PP
 Definition at line 127 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), and snmp_free_pdu().
 .SS "size_t \fBsnmp_pdu::community_len\fP"
 .PP
 length of community name. 
 .PP
 Definition at line 129 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2().
-.SS "oid* \fBsnmp_pdu::enterprise\fP"
-.PP
-System OID. 
-.PP
-Definition at line 135 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), netsnmp_send_traps(), snmp_free_pdu(), snmp_pdu_build(), and snmp_pdu_parse().
-.SS "long \fBsnmp_pdu::trap_type\fP"
-.PP
-trap type 
-.PP
-Definition at line 138 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), netsnmp_send_traps(), snmp_pdu_build(), and snmp_pdu_parse().
-.SS "long \fBsnmp_pdu::specific_type\fP"
-.PP
-specific type 
-.PP
-Definition at line 140 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), netsnmp_send_traps(), snmp_pdu_build(), and snmp_pdu_parse().
-.SS "unsigned char \fBsnmp_pdu::agent_addr\fP[4]"
-.PP
-This is ONLY used for v1 TRAPs. 
-.PP
-Definition at line 142 of file snmp_api.h.
-.PP
-Referenced by convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), netsnmp_send_traps(), snmp_pdu_build(), and snmp_pdu_parse().
 .SS "u_char* \fBsnmp_pdu::contextEngineID\fP"
 .PP
 context snmpEngineID 
 .PP
 Definition at line 148 of file snmp_api.h.
-.PP
-Referenced by snmp_free_pdu(), snmpv3_make_report(), snmpv3_parse(), and snmpv3_scopedPDU_parse().
 .SS "size_t \fBsnmp_pdu::contextEngineIDLen\fP"
 .PP
 Length of contextEngineID. 
 .PP
 Definition at line 150 of file snmp_api.h.
-.PP
-Referenced by snmpv3_make_report(), snmpv3_parse(), and snmpv3_scopedPDU_parse().
 .SS "char* \fBsnmp_pdu::contextName\fP"
 .PP
 authoritative contextName 
 .PP
 Definition at line 152 of file snmp_api.h.
-.PP
-Referenced by netsnmp_create_subtree_cache(), snmp_free_pdu(), snmpv3_make_report(), and snmpv3_scopedPDU_parse().
 .SS "size_t \fBsnmp_pdu::contextNameLen\fP"
 .PP
 Length of contextName. 
 .PP
 Definition at line 154 of file snmp_api.h.
-.PP
-Referenced by snmp_pdu_create(), snmpv3_make_report(), and snmpv3_scopedPDU_parse().
+.SS "oid* \fBsnmp_pdu::enterprise\fP"
+.PP
+System OID. 
+.PP
+Definition at line 135 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::errindex\fP"
+.PP
+Error index (max_repetitions in GetBulk). 
+.PP
+Definition at line 95 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::errstat\fP"
+.PP
+Error status (non_repeaters in GetBulk). 
+.PP
+Definition at line 93 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::msgid\fP"
+.PP
+Message id for V3 messages note: incremented for each retry. 
+.PP
+Definition at line 87 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::reqid\fP"
+.PP
+Request id - note: not incremented on retries. 
+.PP
+Definition at line 85 of file snmp_api.h.
 .SS "u_char* \fBsnmp_pdu::securityEngineID\fP"
 .PP
 authoritative snmpEngineID for security 
 .PP
 Definition at line 156 of file snmp_api.h.
-.PP
-Referenced by send_trap_to_sess(), snmp_free_pdu(), snmpv3_make_report(), snmpv3_packet_build(), snmpv3_parse(), and snmpv3_scopedPDU_parse().
 .SS "size_t \fBsnmp_pdu::securityEngineIDLen\fP"
 .PP
 Length of securityEngineID. 
 .PP
 Definition at line 158 of file snmp_api.h.
-.PP
-Referenced by send_trap_to_sess(), snmpv3_make_report(), snmpv3_packet_build(), snmpv3_parse(), and snmpv3_scopedPDU_parse().
+.SS "int \fBsnmp_pdu::securityLevel\fP"
+.PP
+noAuthNoPriv, authNoPriv, authPriv 
+.PP
+Definition at line 102 of file snmp_api.h.
 .SS "char* \fBsnmp_pdu::securityName\fP"
 .PP
 on behalf of this principal 
 .PP
 Definition at line 160 of file snmp_api.h.
-.PP
-Referenced by snmp_free_pdu(), snmpv3_packet_build(), and snmpv3_parse().
 .SS "size_t \fBsnmp_pdu::securityNameLen\fP"
 .PP
 Length of securityName. 
 .PP
 Definition at line 162 of file snmp_api.h.
-.PP
-Referenced by snmp_pdu_create(), snmpv3_packet_build(), and snmpv3_parse().
+.SS "long \fBsnmp_pdu::sessid\fP"
+.PP
+Session id for AgentX messages. 
+.PP
+Definition at line 91 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::specific_type\fP"
+.PP
+specific type 
+.PP
+Definition at line 140 of file snmp_api.h.
+.SS "const oid* \fBsnmp_pdu::tDomain\fP"
+.PP
+The actual transport domain. This SHOULD NOT BE FREE()D. 
+.PP
+Definition at line 117 of file snmp_api.h.
+.SS "u_long \fBsnmp_pdu::time\fP"
+.PP
+Uptime. 
+.PP
+Definition at line 97 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::transid\fP"
+.PP
+Unique ID for incoming transactions. 
+.PP
+Definition at line 89 of file snmp_api.h.
+.SS "void* \fBsnmp_pdu::transport_data\fP"
+.PP
+Transport-specific opaque data. This replaces the IP-centric address field. 
+.PP
+Definition at line 110 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::trap_type\fP"
+.PP
+trap type 
+.PP
+Definition at line 138 of file snmp_api.h.
+.SS "long \fBsnmp_pdu::version\fP"
+.PP
+snmp version 
+.PP
+Definition at line 81 of file snmp_api.h.
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_snmp_session.3'
--- man/netsnmp_snmp_session.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_snmp_session.3	2010-06-10 18:02:54 +0000
@@ -1,15 +1,16 @@
-.TH "snmp_session" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "snmp_session" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-snmp_session \- The snmp session structure.  
+snmp_session \- 
+.PP
+The snmp session structure.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <snmp_api.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
@@ -29,10 +30,10 @@
 .RI "u_long \fBflags\fP"
 .br
 .ti -1c
-.RI "\fBsnmp_session\fP * \fBsubsession\fP"
+.RI "struct \fBsnmp_session\fP * \fBsubsession\fP"
 .br
 .ti -1c
-.RI "\fBsnmp_session\fP * \fBnext\fP"
+.RI "struct \fBsnmp_session\fP * \fBnext\fP"
 .br
 .ti -1c
 .RI "char * \fBpeername\fP"
@@ -197,7 +198,7 @@
 .ti -1c
 .RI "void * \fBsecurityInfo\fP"
 .br
-.RI "\fIsecurity module specific \fP"
+.RI "\fIsecurity \fBmodule\fP specific \fP"
 .ti -1c
 .RI "void * \fBmyvoid\fP"
 .br
@@ -210,93 +211,19 @@
 Definition at line 187 of file snmp_api.h.
 .SH "Field Documentation"
 .PP 
-.SS "long \fBsnmp_session::version\fP"
-.PP
-snmp version 
-.PP
-Definition at line 192 of file snmp_api.h.
-.PP
-Referenced by add_trap_session(), create_user_from_session(), netsnmp_register_agent_nsap(), send_trap_to_sess(), snmp_sess_add_ex(), snmp_sess_init(), snmpd_parse_config_trapsess(), and snmpv3_engineID_probe().
-.SS "int \fBsnmp_session::retries\fP"
-.PP
-Number of retries before timeout. 
-.PP
-Definition at line 194 of file snmp_api.h.
-.PP
-Referenced by snmp_sess_init(), and snmp_sess_timeout().
-.SS "long \fBsnmp_session::timeout\fP"
-.PP
-Number of uS until first timeout, then exponential backoff. 
-.PP
-Definition at line 196 of file snmp_api.h.
-.PP
-Referenced by snmp_sess_init().
-.SS "char* \fBsnmp_session::peername\fP"
-.PP
-name or address of default peer (may include transport specifier and/or port number) 
-.PP
-Definition at line 202 of file snmp_api.h.
-.PP
-Referenced by snmpd_parse_config_trapsess().
-.SS "u_short \fBsnmp_session::remote_port\fP"
-.PP
-UDP port number of peer. 
-.PP
-(NO LONGER USED - USE peername INSTEAD) 
-.PP
-Definition at line 204 of file snmp_api.h.
-.PP
-Referenced by snmp_sess_init().
-.SS "char* \fBsnmp_session::localname\fP"
-.PP
-My Domain name or dotted IP address, 0 for default. 
-.PP
-Definition at line 206 of file snmp_api.h.
-.SS "u_short \fBsnmp_session::local_port\fP"
-.PP
-My UDP port number, 0 for default, picked randomly. 
-.PP
-Definition at line 208 of file snmp_api.h.
 .SS "u_char*(* \fBsnmp_session::authenticator\fP)(u_char *, size_t *, u_char *, size_t)"
 .PP
 Authentication function or NULL if null authentication is used. 
-.PP
-Referenced by netsnmp_register_agent_nsap().
 .SS "netsnmp_callback \fBsnmp_session::callback\fP"
 .PP
 Function to interpret incoming data. 
 .PP
 Definition at line 214 of file snmp_api.h.
-.PP
-Referenced by _sess_read(), netsnmp_register_agent_nsap(), snmp_sess_synch_response(), snmp_sess_timeout(), and snmp_synch_response_cb().
 .SS "void* \fBsnmp_session::callback_magic\fP"
 .PP
 Pointer to data that the callback function may consider important. 
 .PP
 Definition at line 218 of file snmp_api.h.
-.PP
-Referenced by _sess_read(), snmp_sess_synch_response(), snmp_sess_timeout(), and snmp_synch_response_cb().
-.SS "int \fBsnmp_session::s_errno\fP"
-.PP
-copy of system errno 
-.PP
-Definition at line 220 of file snmp_api.h.
-.PP
-Referenced by _sess_read(), and snmp_error().
-.SS "int \fBsnmp_session::s_snmp_errno\fP"
-.PP
-copy of library errno 
-.PP
-Definition at line 222 of file snmp_api.h.
-.PP
-Referenced by _sess_read(), handle_snmp_packet(), snmp_build(), snmp_error(), snmp_sess_add_ex(), snmp_sess_async_send(), snmp_sess_open(), snmp_sess_read(), and snmpv3_engineID_probe().
-.SS "long \fBsnmp_session::sessid\fP"
-.PP
-Session id - AgentX only. 
-.PP
-Definition at line 224 of file snmp_api.h.
-.PP
-Referenced by send_trap_to_sess().
 .SS "u_char* \fBsnmp_session::community\fP"
 .PP
 community for outgoing requests. 
@@ -307,27 +234,6 @@
 Length of community name. 
 .PP
 Definition at line 232 of file snmp_api.h.
-.SS "size_t \fBsnmp_session::rcvMsgMaxSize\fP"
-.PP
-Largest message to try to receive. 
-.PP
-Definition at line 234 of file snmp_api.h.
-.PP
-Referenced by snmp_sess_add_ex(), and snmp_sess_init().
-.SS "size_t \fBsnmp_session::sndMsgMaxSize\fP"
-.PP
-Largest message to try to send. 
-.PP
-Definition at line 236 of file snmp_api.h.
-.PP
-Referenced by snmpv3_parse().
-.SS "u_char \fBsnmp_session::isAuthoritative\fP"
-.PP
-are we the authoritative engine? 
-.PP
-Definition at line 242 of file snmp_api.h.
-.PP
-Referenced by netsnmp_register_agent_nsap().
 .SS "u_char* \fBsnmp_session::contextEngineID\fP"
 .PP
 authoritative snmpEngineID 
@@ -338,175 +244,196 @@
 Length of contextEngineID. 
 .PP
 Definition at line 246 of file snmp_api.h.
+.SS "char* \fBsnmp_session::contextName\fP"
+.PP
+authoritative contextName 
+.PP
+Definition at line 252 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::contextNameLen\fP"
+.PP
+Length of contextName. 
+.PP
+Definition at line 254 of file snmp_api.h.
 .SS "u_int \fBsnmp_session::engineBoots\fP"
 .PP
 initial engineBoots for remote engine 
 .PP
 Definition at line 248 of file snmp_api.h.
-.PP
-Referenced by snmpv3_engineID_probe().
 .SS "u_int \fBsnmp_session::engineTime\fP"
 .PP
 initial engineTime for remote engine 
 .PP
 Definition at line 250 of file snmp_api.h.
-.PP
-Referenced by snmpv3_engineID_probe().
-.SS "char* \fBsnmp_session::contextName\fP"
-.PP
-authoritative contextName 
-.PP
-Definition at line 252 of file snmp_api.h.
-.PP
-Referenced by unregister_mibs_by_session().
-.SS "size_t \fBsnmp_session::contextNameLen\fP"
-.PP
-Length of contextName. 
-.PP
-Definition at line 254 of file snmp_api.h.
-.SS "u_char* \fBsnmp_session::securityEngineID\fP"
-.PP
-authoritative snmpEngineID 
-.PP
-Definition at line 256 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session(), snmpd_parse_config_trapsess(), and snmpv3_engineID_probe().
-.SS "size_t \fBsnmp_session::securityEngineIDLen\fP"
-.PP
-Length of contextEngineID. 
-.PP
-Definition at line 258 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session(), snmpd_parse_config_trapsess(), and snmpv3_engineID_probe().
-.SS "char* \fBsnmp_session::securityName\fP"
-.PP
-on behalf of this principal 
-.PP
-Definition at line 260 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "size_t \fBsnmp_session::securityNameLen\fP"
-.PP
-Length of securityName. 
-.PP
-Definition at line 262 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "oid* \fBsnmp_session::securityAuthProto\fP"
-.PP
-auth protocol oid 
-.PP
-Definition at line 265 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "size_t \fBsnmp_session::securityAuthProtoLen\fP"
-.PP
-Length of auth protocol oid. 
-.PP
-Definition at line 267 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
+.SS "u_char \fBsnmp_session::isAuthoritative\fP"
+.PP
+are we the authoritative engine? 
+.PP
+Definition at line 242 of file snmp_api.h.
+.SS "u_short \fBsnmp_session::local_port\fP"
+.PP
+My UDP port number, 0 for default, picked randomly. 
+.PP
+Definition at line 208 of file snmp_api.h.
+.SS "char* \fBsnmp_session::localname\fP"
+.PP
+My Domain name or dotted IP address, 0 for default. 
+.PP
+Definition at line 206 of file snmp_api.h.
+.SS "void* \fBsnmp_session::myvoid\fP"
+.PP
+use as you want data used by 'SNMP_FLAGS_RESP_CALLBACK' handling in the agent XXX: or should we add a new field into this structure? 
+.PP
+Definition at line 308 of file snmp_api.h.
+.SS "char* \fBsnmp_session::paramName\fP"
+.PP
+target param name 
+.PP
+Definition at line 295 of file snmp_api.h.
+.SS "char* \fBsnmp_session::peername\fP"
+.PP
+name or address of default peer (may include transport specifier and/or port number) 
+.PP
+Definition at line 202 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::rcvMsgMaxSize\fP"
+.PP
+Largest message to try to receive. 
+.PP
+Definition at line 234 of file snmp_api.h.
+.SS "u_short \fBsnmp_session::remote_port\fP"
+.PP
+UDP port number of peer. (NO LONGER USED - USE peername INSTEAD) 
+.PP
+Definition at line 204 of file snmp_api.h.
+.SS "int \fBsnmp_session::retries\fP"
+.PP
+Number of retries before timeout. 
+.PP
+Definition at line 194 of file snmp_api.h.
+.SS "int \fBsnmp_session::s_errno\fP"
+.PP
+copy of system errno 
+.PP
+Definition at line 220 of file snmp_api.h.
+.SS "int \fBsnmp_session::s_snmp_errno\fP"
+.PP
+copy of library errno 
+.PP
+Definition at line 222 of file snmp_api.h.
 .SS "u_char \fBsnmp_session::securityAuthKey\fP[USM_AUTH_KU_LEN]"
 .PP
 Ku for auth protocol XXX. 
 .PP
 Definition at line 269 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "size_t \fBsnmp_session::securityAuthKeyLen\fP"
 .PP
 Length of Ku for auth protocol. 
 .PP
 Definition at line 271 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "u_char* \fBsnmp_session::securityAuthLocalKey\fP"
 .PP
 Kul for auth protocol. 
 .PP
 Definition at line 273 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "size_t \fBsnmp_session::securityAuthLocalKeyLen\fP"
 .PP
 Length of Kul for auth protocol XXX. 
 .PP
 Definition at line 275 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "oid* \fBsnmp_session::securityPrivProto\fP"
-.PP
-priv protocol oid 
-.PP
-Definition at line 278 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "size_t \fBsnmp_session::securityPrivProtoLen\fP"
-.PP
-Length of priv protocol oid. 
-.PP
-Definition at line 280 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
+.SS "oid* \fBsnmp_session::securityAuthProto\fP"
+.PP
+auth protocol oid 
+.PP
+Definition at line 265 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::securityAuthProtoLen\fP"
+.PP
+Length of auth protocol oid. 
+.PP
+Definition at line 267 of file snmp_api.h.
+.SS "u_char* \fBsnmp_session::securityEngineID\fP"
+.PP
+authoritative snmpEngineID 
+.PP
+Definition at line 256 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::securityEngineIDLen\fP"
+.PP
+Length of contextEngineID. 
+.PP
+Definition at line 258 of file snmp_api.h.
+.SS "void* \fBsnmp_session::securityInfo\fP"
+.PP
+security \fBmodule\fP specific 
+.PP
+Definition at line 300 of file snmp_api.h.
+.SS "int \fBsnmp_session::securityLevel\fP"
+.PP
+noAuthNoPriv, authNoPriv, authPriv 
+.PP
+Definition at line 293 of file snmp_api.h.
+.SS "int \fBsnmp_session::securityModel\fP"
+.PP
+snmp security model, v1, v2c, usm 
+.PP
+Definition at line 291 of file snmp_api.h.
+.SS "char* \fBsnmp_session::securityName\fP"
+.PP
+on behalf of this principal 
+.PP
+Definition at line 260 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::securityNameLen\fP"
+.PP
+Length of securityName. 
+.PP
+Definition at line 262 of file snmp_api.h.
 .SS "u_char \fBsnmp_session::securityPrivKey\fP[USM_PRIV_KU_LEN]"
 .PP
 Ku for privacy protocol XXX. 
 .PP
 Definition at line 282 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "size_t \fBsnmp_session::securityPrivKeyLen\fP"
 .PP
 Length of Ku for priv protocol. 
 .PP
 Definition at line 284 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "u_char* \fBsnmp_session::securityPrivLocalKey\fP"
 .PP
 Kul for priv protocol. 
 .PP
 Definition at line 286 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
 .SS "size_t \fBsnmp_session::securityPrivLocalKeyLen\fP"
 .PP
 Length of Kul for priv protocol XXX. 
 .PP
 Definition at line 288 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session().
-.SS "int \fBsnmp_session::securityModel\fP"
-.PP
-snmp security model, v1, v2c, usm 
-.PP
-Definition at line 291 of file snmp_api.h.
-.PP
-Referenced by create_user_from_session(), snmp_sess_close(), and snmp_sess_init().
-.SS "int \fBsnmp_session::securityLevel\fP"
-.PP
-noAuthNoPriv, authNoPriv, authPriv 
-.PP
-Definition at line 293 of file snmp_api.h.
-.SS "char* \fBsnmp_session::paramName\fP"
-.PP
-target param name 
-.PP
-Definition at line 295 of file snmp_api.h.
-.SS "void* \fBsnmp_session::securityInfo\fP"
-.PP
-security module specific 
-.PP
-Definition at line 300 of file snmp_api.h.
-.SS "void* \fBsnmp_session::myvoid\fP"
-.PP
-use as you want data 
-.PP
-used by 'SNMP_FLAGS_RESP_CALLBACK' handling in the agent XXX: or should we add a new field into this structure? 
-.PP
-Definition at line 308 of file snmp_api.h.
-.PP
-Referenced by snmp_synch_response_cb().
+.SS "oid* \fBsnmp_session::securityPrivProto\fP"
+.PP
+priv protocol oid 
+.PP
+Definition at line 278 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::securityPrivProtoLen\fP"
+.PP
+Length of priv protocol oid. 
+.PP
+Definition at line 280 of file snmp_api.h.
+.SS "long \fBsnmp_session::sessid\fP"
+.PP
+Session id - AgentX only. 
+.PP
+Definition at line 224 of file snmp_api.h.
+.SS "size_t \fBsnmp_session::sndMsgMaxSize\fP"
+.PP
+Largest message to try to send. 
+.PP
+Definition at line 236 of file snmp_api.h.
+.SS "long \fBsnmp_session::timeout\fP"
+.PP
+Number of uS until first timeout, then exponential backoff. 
+.PP
+Definition at line 196 of file snmp_api.h.
+.SS "long \fBsnmp_session::version\fP"
+.PP
+snmp version 
+.PP
+Definition at line 192 of file snmp_api.h.
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_stash_cache.3'
--- man/netsnmp_stash_cache.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_stash_cache.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "stash_cache" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "stash_cache" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-stash_cache \- Automatically caches data for certain handlers.  
+stash_cache \- 
+.PP
+Automatically caches data for certain handlers.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -49,7 +50,7 @@
 .SH "Detailed Description"
 .PP 
 Automatically caches data for certain handlers. 
-.PP
+
 This handler caches data in an optimized way which may aleviate the need for the lower level handlers to perform as much optimization. Specifically, somewhere in the lower level handlers must be a handler that supports the MODE_GET_STASH operation. Note that the table_iterator helper supports this. 
 .SH "Function Documentation"
 .PP 
@@ -57,60 +58,37 @@
 .PP
 updates a given cache depending on whether it needs to or not. 
 .PP
-Definition at line 194 of file stash_cache.c.
-.PP
-References netsnmp_stash_cache_info_s::cache, netsnmp_cache_s::cache_hint, netsnmp_handler_args_s::handler, netsnmp_cache_s::magic, netsnmp_agent_request_info_s::mode, netsnmp_agent_add_list_data(), netsnmp_call_next_handler(), netsnmp_create_data_list(), netsnmp_get_new_stash_cache(), netsnmp_mib_handler_s::next, NULL, netsnmp_handler_args_s::reginfo, netsnmp_handler_args_s::reqinfo, and netsnmp_handler_args_s::requests.
-.PP
-Referenced by netsnmp_get_timed_bare_stash_cache_handler().
+Definition at line 195 of file stash_cache.c.
 .SS "\fBnetsnmp_oid_stash_node\fP** netsnmp_extract_stash_cache (\fBnetsnmp_agent_request_info\fP * reqinfo)"
 .PP
 extracts a pointer to the stash_cache info from the reqinfo structure. 
 .PP
-Definition at line 112 of file stash_cache.c.
-.PP
-References netsnmp_agent_get_list_data().
-.PP
-Referenced by netsnmp_stash_to_next_helper(), and netsnmp_table_iterator_helper_handler().
+Definition at line 113 of file stash_cache.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_bare_stash_cache_handler (void)"
 .PP
 returns a single stash_cache handler that can be injected into a given handler chain (with a fixed timeout), but *only* if that handler chain explicitly supports stash cache processing. 
 .PP
-Definition at line 78 of file stash_cache.c.
-.PP
-References netsnmp_get_timed_bare_stash_cache_handler(), and NULL.
-.PP
-Referenced by netsnmp_get_stash_cache_handler().
+Definition at line 79 of file stash_cache.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_stash_cache_handler (void)"
 .PP
 returns a stash_cache handler sub-chain that can be injected into a given (arbitrary) handler chain, using a fixed cache timeout. 
 .PP
-Definition at line 87 of file stash_cache.c.
-.PP
-References netsnmp_get_bare_stash_cache_handler(), netsnmp_get_stash_to_next_handler(), and netsnmp_mib_handler_s::next.
-.PP
-Referenced by netsnmp_init_stash_cache_helper().
+Definition at line 88 of file stash_cache.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_timed_bare_stash_cache_handler (int timeout, oid * rootoid, size_t rootoid_len)"
 .PP
 returns a stash_cache handler that can be injected into a given handler chain (with the specified timeout and root OID values), but *only* if that handler chain explicitly supports stash cache processing. 
 .PP
 Definition at line 44 of file stash_cache.c.
-.PP
-References _netsnmp_stash_cache_free(), _netsnmp_stash_cache_load(), netsnmp_mib_handler_s::myvoid, netsnmp_cache_create(), netsnmp_cache_handler_get(), netsnmp_create_handler(), netsnmp_handler_free(), netsnmp_stash_cache_helper(), netsnmp_mib_handler_s::next, and NULL.
-.PP
-Referenced by netsnmp_get_bare_stash_cache_handler(), and netsnmp_get_timed_stash_cache_handler().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_timed_stash_cache_handler (int timeout, oid * rootoid, size_t rootoid_len)"
 .PP
 returns a stash_cache handler sub-chain that can be injected into a given (arbitrary) handler chain, using a configurable cache timeout. 
 .PP
-Definition at line 100 of file stash_cache.c.
-.PP
-References netsnmp_get_stash_to_next_handler(), netsnmp_get_timed_bare_stash_cache_handler(), and netsnmp_mib_handler_s::next.
+Definition at line 101 of file stash_cache.c.
 .SS "void netsnmp_init_stash_cache_helper (void)"
 .PP
 initializes the stash_cache helper which then registers a stash_cache handler as a run-time injectable handler for configuration file use. 
 .PP
-Definition at line 237 of file stash_cache.c.
-.PP
-References netsnmp_get_stash_cache_handler(), and netsnmp_register_handler_by_name().
-.PP
-Referenced by netsnmp_init_helpers().
+Definition at line 238 of file stash_cache.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_stash_to_next.3'
--- man/netsnmp_stash_to_next.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_stash_to_next.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "stash_to_next" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "stash_to_next" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-stash_to_next \- Convert GET_STASH requests into GETNEXT requests for the handler.  
+stash_to_next \- 
+.PP
+Convert GET_STASH requests into GETNEXT requests for the handler.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -19,7 +20,7 @@
 .SH "Detailed Description"
 .PP 
 Convert GET_STASH requests into GETNEXT requests for the handler. 
-.PP
+
 The purpose of this handler is to convert a GET_STASH auto-cache request to a series of GETNEXT requests. It can be inserted into a handler chain where the lower-level handlers don't process such requests themselves. 
 .SH "Function Documentation"
 .PP 
@@ -28,7 +29,6 @@
 returns a stash_to_next handler that can be injected into a given handler chain. 
 .PP
 Definition at line 28 of file stash_to_next.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_create_handler(), netsnmp_stash_to_next_helper(), and NULL.
-.PP
-Referenced by netsnmp_get_stash_cache_handler(), and netsnmp_get_timed_stash_cache_handler().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table.3'
--- man/netsnmp_table.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table.3	2010-06-10 18:02:54 +0000
@@ -1,61 +1,56 @@
-.TH "table" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table \- Helps you implement a table.  
+table \- 
+.PP
+Helps you implement a table.  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBtable_array\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table when data can be stored locally. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_container\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table when data can be found via a netsnmp_container. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_data\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table with datamatted storage. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBgeneric_table_API\fP"
 .br
+.PP
+
 .RI "\fIGeneral requirements for a table helper. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_iterator\fP"
 .br
+.PP
+
 .RI "\fIThe table iterator helper is designed to simplify the task of writing a table handler for the net-snmp agent when the data being accessed is not in an oid sorted form and must be accessed externally. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_row\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table shared across two or more subagents, or otherwise split into individual row slices. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtdata\fP"
 .br
+.PP
+
 .RI "\fIImplement a table with datamatted storage. \fP"
-.PP
-
 .in -1c
 .SS "Defines"
 
@@ -123,7 +118,7 @@
 .SH "Detailed Description"
 .PP 
 Helps you implement a table. 
-.PP
+
 This handler helps you implement a table by doing some of the processing for you.
 .PP
 This handler truly shows the power of the new handler mechanism. By creating a table handler and injecting it into your calling chain, or by using the \fBnetsnmp_register_table()\fP function to register your table, you get access to some pre-parsed information. Specifically, the table handler pulls out the column number and indexes from the request oid so that you don't have to do the complex work to do that parsing within your own code.
@@ -133,18 +128,12 @@
 .PP 
 .SS "int netsnmp_check_getnext_reply (\fBnetsnmp_request_info\fP * request, oid * prefix, size_t prefix_len, \fBnetsnmp_variable_list\fP * newvar, \fBnetsnmp_variable_list\fP ** outvar)"
 .PP
-checks the original request against the current data being passed in if its greater than the request oid but less than the current valid return, set the current valid return to the new value. 
-.PP
-returns 1 if outvar was replaced with the oid from newvar (success). returns 0 if not. 
-.PP
-Definition at line 884 of file table.c.
-.PP
-References build_oid_noalloc(), variable_list::name, variable_list::name_length, netsnmp_request_info_s::requestvb, snmp_clone_varbind(), snmp_free_varbind(), snmp_oid_compare(), snmp_set_var_objid(), snmp_set_var_typed_value(), netsnmp_vardata::string, variable_list::type, variable_list::val, and variable_list::val_len.
+checks the original request against the current data being passed in if its greater than the request oid but less than the current valid return, set the current valid return to the new value. returns 1 if outvar was replaced with the oid from newvar (success). returns 0 if not. 
+.PP
+Definition at line 881 of file table.c.
 .SS "NETSNMP_INLINE \fBnetsnmp_table_request_info\fP* netsnmp_extract_table_info (\fBnetsnmp_request_info\fP * request)"
 .PP
-Extracts the processed table information from a given request. 
-.PP
-Call this from subhandlers on a request to extract the processed netsnmp_request_info information. The resulting information includes the index values and the column number.
+Extracts the processed table information from a given request. Call this from subhandlers on a request to extract the processed netsnmp_request_info information. The resulting information includes the index values and the column number.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -159,24 +148,14 @@
 
 .PP
 Definition at line 125 of file table.c.
-.PP
-References netsnmp_request_get_list_data().
-.PP
-Referenced by _netsnmp_tdata_helper_handler(), netsnmp_container_table_row_insert(), netsnmp_insert_iterator_context(), netsnmp_insert_table_row(), netsnmp_table_data_helper_handler(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), and table_helper_handler().
 .SS "\fBnetsnmp_table_registration_info\fP* netsnmp_find_table_registration_info (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 extracts the registered netsnmp_table_registration_info object from a netsnmp_handler_registration object 
 .PP
 Definition at line 134 of file table.c.
-.PP
-References netsnmp_find_handler_data_by_name().
-.PP
-Referenced by netsnmp_table_data_helper_handler(), and netsnmp_table_iterator_helper_handler().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_table_handler (\fBnetsnmp_table_registration_info\fP * tabreq)"
 .PP
-Given a netsnmp_table_registration_info object, creates a table handler. 
-.PP
-You can use this table handler by injecting it into a calling chain. When the handler gets called, it'll do processing and store it's information into the request->parent_data structure.
+Given a netsnmp_table_registration_info object, creates a table handler. You can use this table handler by injecting it into a calling chain. When the handler gets called, it'll do processing and store it's information into the request->parent_data structure.
 .PP
 The table helper handler pulls out the column number and indexes from the request oid so that you don't have to do the complex work of parsing within your own code.
 .PP
@@ -193,80 +172,50 @@
 
 .PP
 Definition at line 85 of file table.c.
-.PP
-References count_varbinds(), netsnmp_table_registration_info_s::indexes, netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), NULL, netsnmp_table_registration_info_s::number_indexes, snmp_log(), and table_helper_handler().
-.PP
-Referenced by netsnmp_register_table(), and netsnmp_sparse_table_register().
 .SS "int netsnmp_register_table (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_registration_info\fP * tabreq)"
 .PP
 creates a table handler given the netsnmp_table_registration_info object, inserts it into the request chain and then calls \fBnetsnmp_register_handler()\fP to register the table into the agent. 
 .PP
 Definition at line 108 of file table.c.
-.PP
-References netsnmp_get_table_handler(), netsnmp_inject_handler(), and netsnmp_register_handler().
-.PP
-Referenced by netsnmp_container_table_register(), netsnmp_register_table_data(), netsnmp_register_table_iterator(), netsnmp_table_container_register(), and netsnmp_table_row_register().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_sparse_table_handler_get (void)"
 .PP
 create sparse table handler 
 .PP
 Definition at line 722 of file table.c.
-.PP
-References netsnmp_create_handler(), and SPARSE_TABLE_HANDLER_NAME.
 .SS "int netsnmp_sparse_table_register (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_registration_info\fP * tabreq)"
 .PP
 creates a table handler given the netsnmp_table_registration_info object, inserts it into the request chain and then calls \fBnetsnmp_register_handler()\fP to register the table into the agent. 
 .PP
 Definition at line 733 of file table.c.
-.PP
-References netsnmp_create_handler(), netsnmp_get_table_handler(), netsnmp_inject_handler(), netsnmp_register_handler(), and SPARSE_TABLE_HANDLER_NAME.
 .SS "int netsnmp_table_build_oid (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_request_info\fP * reqinfo, \fBnetsnmp_table_request_info\fP * table_info)"
 .PP
-given a registration info object, a request object and the table info object it builds the request->requestvb->name oid from the index values and column information found in the table_info object. 
-.PP
-Index values are extracted from the table_info varbinds. 
+given a registration info object, a request object and the table info object it builds the request->requestvb->name oid from the index values and column information found in the table_info object. Index values are extracted from the table_info varbinds. 
 .PP
 .Entry
 .PP
 .column 
 .PP
 Definition at line 784 of file table.c.
-.PP
-References build_oid(), netsnmp_table_request_info_s::colnum, netsnmp_table_request_info_s::indexes, variable_list::name, variable_list::name_length, netsnmp_request_info_s::requestvb, netsnmp_handler_registration_s::rootoid, and netsnmp_handler_registration_s::rootoid_len.
-.PP
-Referenced by netsnmp_table_build_result().
 .SS "int netsnmp_table_build_oid_from_index (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_request_info\fP * reqinfo, \fBnetsnmp_table_request_info\fP * table_info)"
 .PP
-given a registration info object, a request object and the table info object it builds the request->requestvb->name oid from the index values and column information found in the table_info object. 
-.PP
-Index values are extracted from the table_info index oid. 
+given a registration info object, a request object and the table info object it builds the request->requestvb->name oid from the index values and column information found in the table_info object. Index values are extracted from the table_info index oid. 
 .PP
 Definition at line 821 of file table.c.
-.PP
-References netsnmp_table_request_info_s::colnum, netsnmp_table_request_info_s::index_oid, netsnmp_table_request_info_s::index_oid_len, variable_list::name, variable_list::name_length, variable_list::name_loc, netsnmp_request_info_s::requestvb, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_clone_mem(), and SNMP_FREE.
 .SS "int netsnmp_table_build_result (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_request_info\fP * reqinfo, \fBnetsnmp_table_request_info\fP * table_info, u_char type, u_char * result, size_t result_len)"
 .PP
-Builds the result to be returned to the agent given the table information. 
-.PP
-Use this function to return results from lowel level handlers to the agent. It takes care of building the proper resulting oid (containing proper indexing) and inserts the result value into the returning varbind. 
+Builds the result to be returned to the agent given the table information. Use this function to return results from lowel level handlers to the agent. It takes care of building the proper resulting oid (containing proper indexing) and inserts the result value into the returning varbind. 
 .PP
 Definition at line 751 of file table.c.
-.PP
-References variable_list::name, variable_list::name_loc, netsnmp_table_build_oid(), NULL, netsnmp_request_info_s::requestvb, and snmp_set_var_typed_value().
 .SS "int netsnmp_update_indexes_from_variable_list (\fBnetsnmp_table_request_info\fP * tri)"
 .PP
 builds an oid given a set of indexes. 
 .PP
-Definition at line 866 of file table.c.
-.PP
-References build_oid_noalloc(), netsnmp_table_request_info_s::index_oid, netsnmp_table_request_info_s::index_oid_len, netsnmp_table_request_info_s::indexes, and NULL.
+Definition at line 863 of file table.c.
 .SS "int netsnmp_update_variable_list_from_index (\fBnetsnmp_table_request_info\fP * tri)"
 .PP
 parses an OID into table indexses 
 .PP
-Definition at line 850 of file table.c.
-.PP
-References netsnmp_table_request_info_s::index_oid, netsnmp_table_request_info_s::index_oid_len, netsnmp_table_request_info_s::indexes, parse_oid_indexes(), and snmp_reset_var_buffers().
+Definition at line 847 of file table.c.
 .SS "int table_helper_handler (\fBnetsnmp_mib_handler\fP * handler, \fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_agent_request_info\fP * reqinfo, \fBnetsnmp_request_info\fP * requests)"
 .PP
 implements the table helper handler 
@@ -280,7 +229,6 @@
 for loop 
 .PP
 Definition at line 142 of file table.c.
-.PP
-References netsnmp_table_request_info_s::colnum, netsnmp_mib_handler_s::handler_name, netsnmp_table_request_info_s::index_oid, netsnmp_table_request_info_s::index_oid_len, netsnmp_table_request_info_s::indexes, netsnmp_table_registration_info_s::indexes, netsnmp_table_registration_info_s::max_column, netsnmp_table_registration_info_s::min_column, netsnmp_agent_request_info_s::mode, netsnmp_mib_handler_s::myvoid, netsnmp_agent_get_list_data(), netsnmp_call_next_handler(), netsnmp_create_data_list(), netsnmp_extract_table_info(), netsnmp_free_agent_data_sets(), netsnmp_request_add_list_data(), netsnmp_set_request_error(), netsnmp_request_info_s::next, netsnmp_mib_handler_s::next, variable_list::next_variable, NULL, netsnmp_table_registration_info_s::number_indexes, netsnmp_table_request_info_s::number_indexes, parse_one_oid_index(), netsnmp_request_info_s::processed, netsnmp_table_request_info_s::reg_info, netsnmp_request_info_s::requestvb, netsnmp_handler_registration_s::rootoid, netsnmp_handler_registration_s::rootoid_len, snmp_clone_varbind(), SNMP_FREE, snmp_log(), SNMP_MALLOC_TYPEDEF, snmp_oid_compare(), snmp_set_var_objid(), sprint_realloc_by_type(), netsnmp_request_info_s::status, variable_list::type, and netsnmp_table_registration_info_s::valid_columns.
-.PP
-Referenced by netsnmp_get_table_handler().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_array.3'
--- man/netsnmp_table_array.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_array.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_array" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_array" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_array \- Helps you implement a table when data can be stored locally.  
+table_array \- 
+.PP
+Helps you implement a table when data can be stored locally.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -31,7 +32,7 @@
 .SH "Detailed Description"
 .PP 
 Helps you implement a table when data can be stored locally. 
-.PP
+
 The data is stored in a sorted array, using a binary search for lookups.
 .PP
 The table_array handler is used (automatically) in conjuntion with the \fBtable\fP handler. It is primarily intended to be used with the mib2c configuration file mib2c.array-user.conf.
@@ -54,7 +55,7 @@
 .PP
 If your table contains a RowStatus object, by default the code will not allow object in an active row to be modified. To allow active rows to be modified, remove the comment block around the #define <PREFIX>_CAN_MODIFY_ACTIVE_ROW in the header file.
 .PP
-Code will be generated to maintain a secondary index for all rows, stored in a binary tree. This is very useful for finding rows by a key other than the OID index. By default, the functions for maintaining this tree will be based on a character string. NOTE: this will likely be made into a more generic mechanism, using new callback methods, in the near future.
+Code will be generated to maintain a secondary index for all rows, stored in a binary \fBtree\fP. This is very useful for finding rows by a key other than the OID index. By default, the functions for maintaining this \fBtree\fP will be based on a character string. NOTE: this will likely be made into a more generic mechanism, using new callback methods, in the near future.
 .PP
 The generated code contains many TODO comments. Make sure you check each one to see if it applies to your code. Examples include checking indices for syntax (ranges, etc), initializing default values in newly created rows, checking for row activation and deactivation requirements, etc. 
 .SH "Function Documentation"
@@ -64,30 +65,21 @@
 find the context data used by the table_array helper 
 .PP
 Definition at line 229 of file table_array.c.
-.PP
-References netsnmp_request_get_list_data().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_find_table_array_handler (\fBnetsnmp_handler_registration\fP * reginfo)"
 .PP
 find the handler for the table_array helper. 
 .PP
 Definition at line 212 of file table_array.c.
-.PP
-References netsnmp_mib_handler_s::access_method, netsnmp_handler_registration_s::handler, netsnmp_mib_handler_s::next, and NULL.
 .SS "int netsnmp_table_array_check_row_status (\fBnetsnmp_table_array_callbacks\fP * cb, \fBnetsnmp_request_group\fP * ag, long * rs_new, long * rs_old)"
 .PP
 this function is called to validate RowStatus transitions. 
 .PP
 Definition at line 236 of file table_array.c.
-.PP
-References netsnmp_table_array_callbacks_s::can_activate, netsnmp_table_array_callbacks_s::can_deactivate, netsnmp_table_array_callbacks_s::can_delete, netsnmp_request_group_s::existing_row, NULL, netsnmp_request_group_s::row_deleted, and netsnmp_request_group_s::undo_info.
 .SS "int netsnmp_table_container_register (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_registration_info\fP * tabreg, \fBnetsnmp_table_array_callbacks\fP * cb, \fBnetsnmp_container\fP * container, int group_rows)"
 .PP
-register specified callbacks for the specified table/oid. 
-.PP
-If the group_rows parameter is set, the row related callbacks will be called once for each unique row index. Otherwise, each callback will be called only once, for all objects. 
+register specified callbacks for the specified table/oid. If the group_rows parameter is set, the row related callbacks will be called once for each unique row index. Otherwise, each callback will be called only once, for all objects. 
 .PP
 Definition at line 149 of file table_array.c.
-.PP
-References netsnmp_table_array_callbacks_s::can_set, table_container_data_s::cb, netsnmp_container_s::compare, netsnmp_table_array_callbacks_s::delete_row, netsnmp_table_array_callbacks_s::duplicate_row, netsnmp_handler_registration_s::handler, netsnmp_mib_handler_s::myvoid, netsnmp_container_s::ncompare, netsnmp_register_table(), NULL, netsnmp_table_array_callbacks_s::row_copy, snmp_log(), SNMP_MALLOC_TYPEDEF, table_container_data_s::table, and table_container_data_s::tblreg_info.
-.PP
-Referenced by netsnmp_table_array_register().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_container.3'
--- man/netsnmp_table_container.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_container.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_container" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_container" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_container \- Helps you implement a table when data can be found via a netsnmp_container.  
+table_container \- 
+.PP
+Helps you implement a table when data can be found via a netsnmp_container.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -35,14 +36,6 @@
 .br
 .RI "\fIretrieve the container used by the table_container helper \fP"
 .ti -1c
-.RI "void * \fBnetsnmp_container_table_row_extract\fP (\fBnetsnmp_request_info\fP *request)"
-.br
-.RI "\fIfind the context data used by the table_container helper \fP"
-.ti -1c
-.RI "void * \fBnetsnmp_container_table_extract_context\fP (\fBnetsnmp_request_info\fP *request)"
-.br
-.RI "\fIfind the context data used by the table_container helper \fP"
-.ti -1c
 .RI "void \fBnetsnmp_container_table_row_insert\fP (\fBnetsnmp_request_info\fP *request, \fBnetsnmp_index\fP *row)"
 .br
 .RI "\fIinserts a newly created table_container entry into a request list \fP"
@@ -54,7 +47,7 @@
 .SH "Detailed Description"
 .PP 
 Helps you implement a table when data can be found via a netsnmp_container. 
-.PP
+
 The table_container handler is used (automatically) in conjuntion with the \fBtable\fP handler.
 .PP
 This handler will use the index information provided by the \fBtable\fP handler to find the row needed to process the request.
@@ -65,7 +58,7 @@
 .PP
 TABLE_CONTAINER_KEY_NETSNMP_INDEX The container should do comparisons based on a key that may be cast to a netsnmp index (netsnmp_index *). This index contains only the index portion of the OID, not the entire OID.
 .PP
-TABLE_CONTAINER_KEY_VARBIND_INDEX The container should do comparisons based on a key that may be cast to a netsnmp variable list (netsnmp_variable_list *). This variable list will contain one varbind for each index component.
+TABLE_CONTAINER_KEY_VARBIND_INDEX The container should do comparisons based on a key that may be cast to a netsnmp \fBvariable\fP list (netsnmp_variable_list *). This \fBvariable\fP list will contain one varbind for each index component.
 .PP
 TABLE_CONTAINER_KEY_VARBIND_RAW (NOTE: unimplemented) While not yet implemented, future plans include passing the request varbind with the full OID to a container.
 .PP
@@ -95,47 +88,19 @@
 retrieve the container used by the table_container helper 
 .PP
 Definition at line 320 of file table_container.c.
-.PP
-References netsnmp_request_get_list_data().
-.SS "void* netsnmp_container_table_extract_context (\fBnetsnmp_request_info\fP * request)"
-.PP
-find the context data used by the table_container helper 
-.PP
-Definition at line 339 of file table_container.c.
-.PP
-References netsnmp_request_get_list_data().
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_container_table_handler_get (\fBnetsnmp_table_registration_info\fP * tabreg, \fBnetsnmp_container\fP * container, char key_type)"
 .PP
 returns a netsnmp_mib_handler object for the table_container helper 
 .PP
 Definition at line 254 of file table_container.c.
-.PP
-References netsnmp_container_s::compare, netsnmp_mib_handler_s::flags, container_table_data_s::key_type, MIB_HANDLER_AUTO_NEXT, netsnmp_mib_handler_s::myvoid, netsnmp_container_s::ncompare, netsnmp_create_handler(), NULL, snmp_log(), SNMP_MALLOC_TYPEDEF, container_table_data_s::table, and container_table_data_s::tblreg_info.
-.PP
-Referenced by netsnmp_container_table_register().
-.SS "void* netsnmp_container_table_row_extract (\fBnetsnmp_request_info\fP * request)"
-.PP
-find the context data used by the table_container helper 
-.PP
-Definition at line 329 of file table_container.c.
-.PP
-References netsnmp_request_get_list_data().
-.PP
-Referenced by _netsnmp_tdata_helper_handler(), and netsnmp_tdata_extract_row().
 .SS "void netsnmp_container_table_row_insert (\fBnetsnmp_request_info\fP * request, \fBnetsnmp_index\fP * row)"
 .PP
 inserts a newly created table_container entry into a request list 
 .PP
 Definition at line 351 of file table_container.c.
-.PP
-References build_oid_noalloc(), netsnmp_table_request_info_s::indexes, netsnmp_create_data_list(), netsnmp_extract_table_info(), netsnmp_request_add_list_data(), netsnmp_request_info_s::next, NULL, netsnmp_request_info_s::prev, netsnmp_request_info_s::processed, and snmp_oid_compare().
-.PP
-Referenced by netsnmp_insert_tdata_row().
 .SS "\fBnetsnmp_index\fP* netsnmp_table_index_find_next_row (\fBnetsnmp_container\fP * c, \fBnetsnmp_table_request_info\fP * tblreq)"
 .PP
-deprecated, backwards compatability only 
-.PP
-expected impact to remove: none
+deprecated, backwards compatability only expected impact to remove: none
 .IP "\(bu" 2
 used between helpers, shouldn't have been used by end users
 .PP
@@ -147,5 +112,6 @@
 
 .PP
 Definition at line 721 of file table_container.c.
-.PP
-References NULL.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_data.3'
--- man/netsnmp_table_data.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_data.3	2010-06-10 18:02:54 +0000
@@ -1,19 +1,20 @@
-.TH "table_data" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_data" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_data \- Helps you implement a table with datamatted storage.  
+table_data \- 
+.PP
+Helps you implement a table with datamatted storage.  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBtable_dataset\fP"
 .br
+.PP
+
 .RI "\fIHelps you implement a table with automatted storage. \fP"
-.PP
-
 .in -1c
 .SS "Functions"
 
@@ -170,8 +171,8 @@
 .SH "Detailed Description"
 .PP 
 Helps you implement a table with datamatted storage. 
-.PP
-This helper is obsolete. If you are writing a new module, please consider using the table_tdata helper instead.
+
+This helper is obsolete. If you are writing a new \fBmodule\fP, please consider using the table_tdata helper instead.
 .PP
 This helper helps you implement a table where all the indexes are expected to be stored within the agent itself and not in some external storage location. It can be used to store a list of rows, where a row consists of the indexes to the table and a generic data pointer. You can then implement a subhandler which is passed the exact row definition and data it must return data for or accept data for. Complex GETNEXT handling is greatly simplified in this case. 
 .SH "Function Documentation"
@@ -181,10 +182,6 @@
 creates and returns a pointer to table data set 
 .PP
 Definition at line 52 of file table_data.c.
-.PP
-References netsnmp_table_data_s::name, and SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_create_table_data_set(), and netsnmp_table_data_create_table().
 .SS "\fBnetsnmp_table_row\fP* netsnmp_create_table_data_row (void)"
 .PP
 creates and returns a pointer to table data set 
@@ -194,170 +191,93 @@
 \fBdata_set.c\fP.
 .PP
 Definition at line 62 of file table_data.c.
-.PP
-References SNMP_MALLOC_TYPEDEF.
-.PP
-Referenced by netsnmp_config_parse_add_row(), and netsnmp_table_data_set_create_row_from_defaults().
 .SS "\fBnetsnmp_table_data\fP* netsnmp_extract_table (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the table being accessed passed from the table_data helper 
 .PP
-Definition at line 649 of file table_data.c.
-.PP
-References netsnmp_request_get_list_data().
+Definition at line 653 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_extract_table_row (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the row being accessed passed from the table_data helper 
 .PP
-Definition at line 657 of file table_data.c.
-.PP
-References netsnmp_request_get_list_data().
-.PP
-Referenced by netsnmp_extract_table_row_data(), and netsnmp_table_data_set_helper_handler().
+Definition at line 661 of file table_data.c.
 .SS "void* netsnmp_extract_table_row_data (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the data from the row being accessed passed from the table_data helper 
 .PP
-Definition at line 666 of file table_data.c.
-.PP
-References netsnmp_table_row_s::data, netsnmp_extract_table_row(), and NULL.
-.PP
-Referenced by netsnmp_extract_table_data_set_column().
+Definition at line 670 of file table_data.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_table_data_handler (\fBnetsnmp_table_data\fP * table)"
 .PP
 Creates a table_data handler and returns it. 
 .PP
-Definition at line 371 of file table_data.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_table_data_helper_handler(), NULL, and snmp_log().
-.PP
-Referenced by netsnmp_register_table_data().
+Definition at line 375 of file table_data.c.
 .SS "NETSNMP_INLINE void netsnmp_insert_table_row (\fBnetsnmp_request_info\fP * request, \fBnetsnmp_table_row\fP * row)"
 .PP
 inserts a newly created table_data row into a request 
 .PP
-Definition at line 678 of file table_data.c.
-.PP
-References build_oid_noalloc(), netsnmp_table_request_info_s::indexes, netsnmp_create_data_list(), netsnmp_extract_table_info(), netsnmp_request_add_list_data(), netsnmp_request_info_s::next, NULL, netsnmp_request_info_s::prev, and snmp_oid_compare().
+Definition at line 682 of file table_data.c.
 .SS "int netsnmp_register_read_only_table_data (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_registration_info\fP * table_info)"
 .PP
 registers a handler as a read-only data table If table_info != NULL, it registers it as a normal table too. 
 .PP
-Definition at line 405 of file table_data.c.
-.PP
-References netsnmp_get_read_only_handler(), netsnmp_inject_handler(), and netsnmp_register_table_data().
+Definition at line 409 of file table_data.c.
 .SS "int netsnmp_register_table_data (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_registration_info\fP * table_info)"
 .PP
-registers a handler as a data table. 
-.PP
-If table_info != NULL, it registers it as a normal table too. 
-.PP
-Definition at line 394 of file table_data.c.
-.PP
-References netsnmp_get_table_data_handler(), netsnmp_inject_handler(), and netsnmp_register_table().
-.PP
-Referenced by netsnmp_register_read_only_table_data(), and netsnmp_register_table_data_set().
+registers a handler as a data table. If table_info != NULL, it registers it as a normal table too. 
+.PP
+Definition at line 398 of file table_data.c.
 .SS "int netsnmp_table_data_add_row (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
-Adds a row of data to a given table (stored in proper lexographical order). 
-.PP
-returns SNMPERR_SUCCESS on successful addition. or SNMPERR_GENERR on failure (E.G., indexes already existed) 
+Adds a row of data to a given table (stored in proper lexographical order). returns SNMPERR_SUCCESS on successful addition. or SNMPERR_GENERR on failure (E.G., indexes already existed) 
 .PP
 xxx-rks: remove invalid row? 
 .PP
-Definition at line 130 of file table_data.c.
-.PP
-References netsnmp_table_data_s::first_row, netsnmp_table_row_s::index_oid, netsnmp_table_row_s::index_oid_len, netsnmp_table_row_s::indexes, netsnmp_table_data_s::last_row, netsnmp_table_data_s::name, netsnmp_table_data_generate_index_oid(), netsnmp_table_row_s::next, NULL, netsnmp_table_row_s::prev, snmp_free_varbind(), snmp_log(), snmp_oid_compare(), and netsnmp_table_data_s::store_indexes.
-.PP
-Referenced by netsnmp_config_parse_add_row(), netsnmp_table_data_replace_row(), and netsnmp_table_dataset_add_row().
+Definition at line 134 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_clone_row (\fBnetsnmp_table_row\fP * row)"
 .PP
-clones a data row. 
-.PP
-DOES NOT CLONE THE CONTAINED DATA. 
+clones a data row. DOES NOT CLONE THE CONTAINED DATA. 
 .PP
 Definition at line 70 of file table_data.c.
-.PP
-References memdup(), NULL, and snmp_clone_varbind().
-.PP
-Referenced by netsnmp_table_data_set_clone_row().
 .SS "void* netsnmp_table_data_delete_row (\fBnetsnmp_table_row\fP * row)"
 .PP
-deletes a row's memory. 
-.PP
-returns the void data that it doesn't know how to delete. 
-.PP
-Definition at line 101 of file table_data.c.
-.PP
-References netsnmp_table_row_s::data, netsnmp_table_row_s::index_oid, netsnmp_table_row_s::indexes, NULL, SNMP_FREE, and snmp_free_varbind().
-.PP
-Referenced by netsnmp_table_data_delete_table(), netsnmp_table_data_remove_and_delete_row(), and netsnmp_table_dataset_delete_row().
+deletes a row's memory. returns the void data that it doesn't know how to delete. 
+.PP
+Definition at line 105 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_get (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_variable_list\fP * indexes)"
 .PP
 finds the data in 'datalist' stored at 'indexes' 
 .PP
-Definition at line 804 of file table_data.c.
-.PP
-References build_oid_noalloc(), netsnmp_table_data_get_from_oid(), and NULL.
-.PP
-Referenced by netsnmp_table_data_row_get_byidx().
+Definition at line 808 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_get_first_row (\fBnetsnmp_table_data\fP * table)"
 .PP
 returns the first row in the table 
 .PP
-Definition at line 785 of file table_data.c.
-.PP
-References netsnmp_table_data_s::first_row, and NULL.
-.PP
-Referenced by netsnmp_table_data_entry_first(), netsnmp_table_data_row_first(), and netsnmp_table_data_set_get_first_row().
+Definition at line 789 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_get_from_oid (\fBnetsnmp_table_data\fP * table, oid * searchfor, size_t searchfor_len)"
 .PP
 finds the data in 'datalist' stored at the searchfor oid 
 .PP
-Definition at line 818 of file table_data.c.
-.PP
-References netsnmp_table_data_s::first_row, netsnmp_table_row_s::index_oid, netsnmp_table_row_s::index_oid_len, netsnmp_table_row_s::next, NULL, and snmp_oid_compare().
-.PP
-Referenced by netsnmp_table_data_get(), netsnmp_table_data_row_get(), and netsnmp_table_data_row_get_byoid().
+Definition at line 822 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_get_next_row (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
 returns the next row in the table 
 .PP
-Definition at line 794 of file table_data.c.
-.PP
-References netsnmp_table_row_s::next, and NULL.
-.PP
-Referenced by netsnmp_table_data_row_next(), and netsnmp_table_data_set_get_next_row().
+Definition at line 798 of file table_data.c.
 .SS "void* netsnmp_table_data_remove_and_delete_row (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
-removes and frees a row of data to a given table and returns the void * 
-.PP
-returns the void * data on successful deletion. or NULL on failure (bad arguments) 
-.PP
-Definition at line 270 of file table_data.c.
-.PP
-References netsnmp_table_data_delete_row(), netsnmp_table_data_remove_row(), and NULL.
-.PP
-Referenced by netsnmp_table_data_remove_delete_row(), netsnmp_table_dataset_remove_and_delete_row(), and netsnmp_table_dataset_remove_row().
+removes and frees a row of data to a given table and returns the void * returns the void * data on successful deletion. or NULL on failure (bad arguments) 
+.PP
+Definition at line 274 of file table_data.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_remove_row (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
-removes a row of data to a given table and returns it (no free's called) 
-.PP
-returns the row pointer itself on successful removing. or NULL on failure (bad arguments) 
-.PP
-Definition at line 244 of file table_data.c.
-.PP
-References netsnmp_table_data_s::first_row, netsnmp_table_data_s::last_row, netsnmp_table_row_s::next, NULL, and netsnmp_table_row_s::prev.
-.PP
-Referenced by netsnmp_table_data_remove_and_delete_row(), and netsnmp_table_data_replace_row().
+removes a row of data to a given table and returns it (no free's called) returns the row pointer itself on successful removing. or NULL on failure (bad arguments) 
+.PP
+Definition at line 248 of file table_data.c.
 .SS "NETSNMP_INLINE void netsnmp_table_data_replace_row (\fBnetsnmp_table_data\fP * table, \fBnetsnmp_table_row\fP * origrow, \fBnetsnmp_table_row\fP * newrow)"
 .PP
-swaps out origrow with newrow. 
-.PP
-This does *not* delete/free anything! 
-.PP
-Definition at line 229 of file table_data.c.
-.PP
-References netsnmp_table_data_add_row(), and netsnmp_table_data_remove_row().
-.PP
-Referenced by netsnmp_table_dataset_replace_row().
+swaps out origrow with newrow. This does *not* delete/free anything! 
+.PP
+Definition at line 233 of file table_data.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_dataset.3'
--- man/netsnmp_table_dataset.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_dataset.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_dataset" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_dataset" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_dataset \- Helps you implement a table with automatted storage.  
+table_dataset \- 
+.PP
+Helps you implement a table with automatted storage.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -26,11 +27,11 @@
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_table_dataset_delete_all_data\fP (\fBnetsnmp_table_data_set_storage\fP *data)"
 .br
-.RI "\fIdeletes all the data from this node and beyond in the linked list \fP"
+.RI "\fIdeletes all the data from this \fBnode\fP and beyond in the linked list \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_table_dataset_delete_row\fP (\fBnetsnmp_table_row\fP *row)"
 .br
-.RI "\fIdeletes all the data from this node and beyond in the linked list \fP"
+.RI "\fIdeletes all the data from this \fBnode\fP and beyond in the linked list \fP"
 .ti -1c
 .RI "NETSNMP_INLINE void \fBnetsnmp_table_dataset_add_row\fP (\fBnetsnmp_table_data_set\fP *table, \fBnetsnmp_table_row\fP *row)"
 .br
@@ -115,7 +116,7 @@
 .br
 .RI "\fIsets a given column in a row with data given a type, value, and length. \fP"
 .ti -1c
-.RI "NETSNMP_INLINE void \fBnetsnmp_table_dataset_add_index\fP (\fBnetsnmp_table_data_set\fP *table, u_char type)"
+.RI "void \fBnetsnmp_table_dataset_add_index\fP (\fBnetsnmp_table_data_set\fP *table, u_char type)"
 .br
 .RI "\fIadds an index to the table. \fP"
 .ti -1c
@@ -126,9 +127,7 @@
 .SH "Detailed Description"
 .PP 
 Helps you implement a table with automatted storage. 
-.PP
-This helper is obsolete. If you are writing a new module, please consider using the table_dataset2 helper instead.
-.PP
+
 This handler helps you implement a table where all the data is expected to be stored within the agent itself and not in some external storage location. It handles all MIB requests including GETs, GETNEXTs and SETs. It's possible to simply create a table without actually ever defining a handler to be called when SNMP requests come in. To use the data, you can either attach a sub-handler that merely uses/manipulates the data further when requests come in, or you can loop through it externally when it's actually needed. This handler is most useful in cases where a table is holding configuration data for something which gets triggered via another event.
 .PP
 NOTE NOTE NOTE: This helper isn't complete and is likely to change somewhat over time. Specifically, the way it stores data internally may change drastically. 
@@ -142,34 +141,22 @@
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 80 of file table_dataset.c.
-.PP
-References netsnmp_create_table_data(), NULL, SNMP_MALLOC_TYPEDEF, and netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_config_parse_table_set().
+Definition at line 77 of file table_dataset.c.
 .SS "NETSNMP_INLINE \fBnetsnmp_table_data_set\fP* netsnmp_extract_table_data_set (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts a netsnmp_table_data_set pointer from a given request 
 .PP
-Definition at line 816 of file table_dataset.c.
-.PP
-References netsnmp_request_get_list_data().
+Definition at line 813 of file table_dataset.c.
 .SS "\fBnetsnmp_table_data_set_storage\fP* netsnmp_extract_table_data_set_column (\fBnetsnmp_request_info\fP * request, unsigned int column)"
 .PP
 extracts a netsnmp_table_data_set pointer from a given request 
 .PP
-Definition at line 826 of file table_dataset.c.
-.PP
-References netsnmp_extract_table_row_data(), and netsnmp_table_data_set_find_column().
+Definition at line 823 of file table_dataset.c.
 .SS "\fBnetsnmp_mib_handler\fP* netsnmp_get_table_data_set_handler (\fBnetsnmp_table_data_set\fP * data_set)"
 .PP
 Given a netsnmp_table_data_set definition, create a handler for it. 
 .PP
-Definition at line 356 of file table_dataset.c.
-.PP
-References netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_table_data_set_helper_handler(), NULL, and snmp_log().
-.PP
-Referenced by netsnmp_register_table_data_set().
+Definition at line 353 of file table_dataset.c.
 .SS "int netsnmp_mark_row_column_writable (\fBnetsnmp_table_row\fP * row, int column, int writable)"
 .PP
 marks a given column in a row as writable or not. 
@@ -178,16 +165,10 @@
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 1187 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, netsnmp_table_row_s::data, netsnmp_table_data_set_find_column(), netsnmp_table_data_set_storage_s::next, snmp_log(), SNMP_MALLOC_TYPEDEF, and netsnmp_table_data_set_storage_s::writable.
-.PP
-Referenced by netsnmp_config_parse_add_row(), and netsnmp_table_data_set_create_row_from_defaults().
+Definition at line 1189 of file table_dataset.c.
 .SS "void netsnmp_register_auto_data_table (\fBnetsnmp_table_data_set\fP * table_set, char * registration_name)"
 .PP
-registers a table_dataset so that the 'add_row' snmpd.conf token can be used to add data to this table. 
-.PP
-If registration_name is NULL then the name used when the table was created will be used instead.
+registers a table_dataset so that the 'add_row' snmpd.conf token can be used to add data to this table. If registration_name is NULL then the name used when the table was created will be used instead.
 .PP
 \fBTodo\fP
 .RS 4
@@ -200,97 +181,59 @@
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 853 of file table_dataset.c.
-.PP
-References netsnmp_table_data_s::name, netsnmp_add_list_data(), netsnmp_create_data_list(), NULL, SNMP_MALLOC_TYPEDEF, netsnmp_table_data_set_s::table, and data_set_tables_s::table_set.
-.PP
-Referenced by netsnmp_config_parse_table_set().
+Definition at line 850 of file table_dataset.c.
 .SS "int netsnmp_register_table_data_set (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_table_data_set\fP * data_set, \fBnetsnmp_table_registration_info\fP * table_info)"
 .PP
-register a given data_set at a given oid (specified in the netsnmp_handler_registration pointer). 
-.PP
-The reginfo->handler->access_method *may* be null if the call doesn't ever want to be called for SNMP operations. 
+register a given data_set at a given oid (specified in the netsnmp_handler_registration pointer). The reginfo->handler->access_method *may* be null if the call doesn't ever want to be called for SNMP operations. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 382 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, netsnmp_table_data_set_s::default_row, netsnmp_table_registration_info_s::indexes, netsnmp_table_data_s::indexes_template, netsnmp_table_registration_info_s::max_column, netsnmp_table_registration_info_s::min_column, netsnmp_get_table_data_set_handler(), netsnmp_inject_handler(), netsnmp_register_table_data(), netsnmp_table_data_set_storage_s::next, NULL, snmp_clone_varbind(), SNMP_MALLOC_TYPEDEF, SNMP_MAX, SNMP_MIN, and netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_config_parse_table_set().
+Definition at line 379 of file table_dataset.c.
 .SS "int netsnmp_set_row_column (\fBnetsnmp_table_row\fP * row, unsigned int column, int type, const char * value, size_t value_len)"
 .PP
-sets a given column in a row with data given a type, value, and length. 
-.PP
-Data is memdup'ed by the function. 
+sets a given column in a row with data given a type, value, and length. Data is memdup'ed by the function. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 1222 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, netsnmp_table_row_s::data, netsnmp_table_data_set_storage_s::data, netsnmp_table_data_set_storage_s::data_len, memdup(), netsnmp_table_data_set_find_column(), netsnmp_table_data_set_storage_s::next, SNMP_FREE, snmp_log(), SNMP_MALLOC_TYPEDEF, netsnmp_table_data_set_storage_s::string, netsnmp_table_data_set_storage_s::type, and netsnmp_table_data_set_storage_s::voidp.
-.PP
-Referenced by netsnmp_config_parse_add_row(), and netsnmp_table_data_set_create_row_from_defaults().
+Definition at line 1224 of file table_dataset.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_set_clone_row (\fBnetsnmp_table_row\fP * row)"
 .PP
 clones a dataset row, including all data. 
 .PP
-Definition at line 92 of file table_dataset.c.
-.PP
-References netsnmp_table_row_s::data, memdup(), netsnmp_table_data_clone_row(), netsnmp_table_dataset_delete_row(), netsnmp_table_data_set_storage_s::next, and NULL.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
+Definition at line 89 of file table_dataset.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_set_create_row_from_defaults (\fBnetsnmp_table_data_set_storage\fP * defrow)"
 .PP
 creates a new row from an existing defined default set 
 .PP
-Definition at line 226 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, netsnmp_table_data_set_storage_s::data, netsnmp_table_data_set_storage_s::data_len, netsnmp_create_table_data_row(), netsnmp_mark_row_column_writable(), netsnmp_set_row_column(), netsnmp_table_data_set_storage_s::next, NULL, netsnmp_table_data_set_storage_s::type, netsnmp_table_data_set_storage_s::voidp, and netsnmp_table_data_set_storage_s::writable.
-.PP
-Referenced by netsnmp_table_data_set_create_newrowstash().
+Definition at line 223 of file table_dataset.c.
 .SS "\fBnetsnmp_table_data_set_storage\fP* netsnmp_table_data_set_find_column (\fBnetsnmp_table_data_set_storage\fP * start, unsigned int column)"
 .PP
 Finds a column within a given storage set, given the pointer to the start of the storage set list. 
 .PP
-Definition at line 1175 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, and netsnmp_table_data_set_storage_s::next.
-.PP
-Referenced by netsnmp_extract_table_data_set_column(), netsnmp_mark_row_column_writable(), netsnmp_set_row_column(), netsnmp_table_data_set_helper_handler(), and netsnmp_table_set_add_default_row().
+Definition at line 1177 of file table_dataset.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_set_get_first_row (\fBnetsnmp_table_data_set\fP * table)"
 .PP
 returns the first row in the table 
 .PP
-Definition at line 1144 of file table_dataset.c.
-.PP
-References netsnmp_table_data_get_first_row(), and netsnmp_table_data_set_s::table.
+Definition at line 1146 of file table_dataset.c.
 .SS "\fBnetsnmp_table_row\fP* netsnmp_table_data_set_get_next_row (\fBnetsnmp_table_data_set\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
 returns the next row in the table 
 .PP
-Definition at line 1151 of file table_dataset.c.
-.PP
-References netsnmp_table_data_get_next_row(), and netsnmp_table_data_set_s::table.
-.SS "NETSNMP_INLINE void netsnmp_table_dataset_add_index (\fBnetsnmp_table_data_set\fP * table, u_char type)"
-.PP
-adds an index to the table. 
-.PP
-Call this repeatly for each index. 
+Definition at line 1153 of file table_dataset.c.
+.SS "void netsnmp_table_dataset_add_index (\fBnetsnmp_table_data_set\fP * table, u_char type)"
+.PP
+adds an index to the table. Call this repeatly for each index. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 1276 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_table_set_add_indexes().
+Definition at line 1278 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_add_row (\fBnetsnmp_table_data_set\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
 adds a new row to a dataset table 
@@ -299,97 +242,58 @@
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 171 of file table_dataset.c.
-.PP
-References netsnmp_table_data_add_row(), and netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
+Definition at line 168 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_delete_all_data (\fBnetsnmp_table_data_set_storage\fP * data)"
 .PP
-deletes all the data from this node and beyond in the linked list 
-.PP
-Definition at line 148 of file table_dataset.c.
-.PP
-References netsnmp_table_dataset_delete_data().
-.PP
-Referenced by netsnmp_table_dataset_delete_row(), and netsnmp_table_dataset_remove_and_delete_row().
+deletes all the data from this \fBnode\fP and beyond in the linked list 
+.PP
+Definition at line 145 of file table_dataset.c.
 .SS "NETSNMP_INLINE \fBnetsnmp_table_data_set_storage\fP* netsnmp_table_dataset_delete_data (\fBnetsnmp_table_data_set_storage\fP * data)"
 .PP
-deletes a single dataset table data. 
-.PP
-returns the (possibly still good) next pointer of the deleted data object. 
-.PP
-Definition at line 135 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::data, netsnmp_table_data_set_storage_s::next, NULL, SNMP_FREE, and netsnmp_table_data_set_storage_s::voidp.
-.PP
-Referenced by netsnmp_table_dataset_delete_all_data().
+deletes a single dataset table data. returns the (possibly still good) next pointer of the deleted data object. 
+.PP
+Definition at line 132 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_delete_row (\fBnetsnmp_table_row\fP * row)"
 .PP
-deletes all the data from this node and beyond in the linked list 
-.PP
-Definition at line 158 of file table_dataset.c.
-.PP
-References netsnmp_table_data_delete_row(), and netsnmp_table_dataset_delete_all_data().
-.PP
-Referenced by netsnmp_table_data_set_clone_row(), and netsnmp_table_data_set_helper_handler().
+deletes all the data from this \fBnode\fP and beyond in the linked list 
+.PP
+Definition at line 155 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_remove_and_delete_row (\fBnetsnmp_table_data_set\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
 removes a row from the table and then deletes it (and all its data) 
 .PP
-Definition at line 203 of file table_dataset.c.
-.PP
-References netsnmp_table_data_remove_and_delete_row(), netsnmp_table_dataset_delete_all_data(), and netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
+Definition at line 200 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_remove_row (\fBnetsnmp_table_data_set\fP * table, \fBnetsnmp_table_row\fP * row)"
 .PP
 removes a row from the table, but doesn't delete/free the column values 
 .PP
-Definition at line 192 of file table_dataset.c.
-.PP
-References netsnmp_table_data_remove_and_delete_row(), and netsnmp_table_data_set_s::table.
+Definition at line 189 of file table_dataset.c.
 .SS "NETSNMP_INLINE void netsnmp_table_dataset_replace_row (\fBnetsnmp_table_data_set\fP * table, \fBnetsnmp_table_row\fP * origrow, \fBnetsnmp_table_row\fP * newrow)"
 .PP
 adds a new row to a dataset table 
 .PP
-Definition at line 181 of file table_dataset.c.
-.PP
-References netsnmp_table_data_replace_row(), and netsnmp_table_data_set_s::table.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
+Definition at line 178 of file table_dataset.c.
 .SS "int netsnmp_table_set_add_default_row (\fBnetsnmp_table_data_set\fP * table_set, unsigned int column, int type, int writable, void * default_value, size_t default_value_len)"
 .PP
-adds a new default row to a table_set. 
-.PP
-Arguments should be the table_set, column number, variable type and finally a 1 if it is allowed to be writable, or a 0 if not. If the default_value field is not NULL, it will be used to populate new valuse in that column fro newly created rows. It is copied into the storage template (free your calling argument).
+adds a new default row to a table_set. Arguments should be the table_set, column number, \fBvariable\fP type and finally a 1 if it is allowed to be writable, or a 0 if not. If the default_value field is not NULL, it will be used to populate new valuse in that column fro newly created rows. It is copied into the storage template (free your calling argument).
 .PP
 returns SNMPERR_SUCCESS or SNMPERR_FAILURE 
 .PP
-Definition at line 252 of file table_dataset.c.
-.PP
-References netsnmp_table_data_set_storage_s::column, netsnmp_table_data_set_storage_s::data, netsnmp_table_data_set_storage_s::data_len, netsnmp_table_data_set_s::default_row, memdup(), netsnmp_table_data_set_find_column(), netsnmp_table_data_set_storage_s::next, NULL, snmp_log(), SNMP_MALLOC_TYPEDEF, netsnmp_table_data_set_storage_s::type, netsnmp_table_data_set_storage_s::voidp, and netsnmp_table_data_set_storage_s::writable.
-.PP
-Referenced by netsnmp_config_parse_table_set(), and netsnmp_table_set_multi_add_default_row().
+Definition at line 249 of file table_dataset.c.
 .SS "void netsnmp_table_set_add_indexes (\fBnetsnmp_table_data_set\fP * tset,  ...)"
 .PP
-adds multiple indexes to a table_dataset helper object. 
-.PP
-To end the list, use a 0 after the list of ASN index types. 
-.PP
-Definition at line 1287 of file table_dataset.c.
-.PP
-References netsnmp_table_dataset_add_index().
+adds multiple indexes to a table_dataset helper object. To end the list, use a 0 after the list of ASN index types. 
+.PP
+Definition at line 1289 of file table_dataset.c.
 .SS "void netsnmp_table_set_multi_add_default_row (\fBnetsnmp_table_data_set\fP * tset,  ...)"
 .PP
-adds multiple data column definitions to each row. 
-.PP
-Functionally, this is a wrapper around calling netsnmp_table_set_add_default_row repeatedly for you. 
+adds multiple data column definitions to each row. Functionally, this is a wrapper around calling netsnmp_table_set_add_default_row repeatedly for you. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdata_set.c\fP.
 .PP
-Definition at line 313 of file table_dataset.c.
-.PP
-References netsnmp_table_set_add_default_row().
+Definition at line 310 of file table_dataset.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_generic.3'
--- man/netsnmp_table_generic.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_generic.3	2010-06-10 18:02:54 +0000
@@ -1,43 +1,44 @@
-.TH "generic_table_API" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "generic_table_API" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-generic_table_API \- General requirements for a table helper.  
+generic_table_API \- 
+.PP
+General requirements for a table helper.  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBtable_maintenance\fP"
 .br
+.PP
+
 .RI "\fIRoutines for maintaining the contents of a table. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBmib_maintenance\fP"
 .br
+.PP
+
 .RI "\fIRoutines for maintaining a MIB table. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_rows\fP"
 .br
+.PP
+
 .RI "\fIRoutines for working with the rows of a table. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBtable_indexes\fP"
 .br
+.PP
+
 .RI "\fIRoutines for working with row indexes. \fP"
-.PP
-
 .in -1c
 .SH "Detailed Description"
 .PP 
 General requirements for a table helper. 
-.PP
+
 A given table helper need not implement the whole of this API, and may need to adjust the prototype of certain routines. But this description provides a suitable standard design framework. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_indexes.3'
--- man/netsnmp_table_indexes.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_indexes.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_indexes" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_indexes" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_indexes \- Routines for working with row indexes.  
+table_indexes \- 
+.PP
+Routines for working with row indexes.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -40,7 +41,6 @@
 .SH "Detailed Description"
 .PP 
 Routines for working with row indexes. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_generic_compare_idx (void * row, \fBnetsnmp_variable_list\fP * index)"
@@ -78,3 +78,6 @@
 Report the instance OIDs for a row. 
 .PP
 Definition at line 319 of file table_generic.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_iterator.3'
--- man/netsnmp_table_iterator.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_iterator.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_iterator" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_iterator" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_iterator \- The table iterator helper is designed to simplify the task of writing a table handler for the net-snmp agent when the data being accessed is not in an oid sorted form and must be accessed externally.  
+table_iterator \- 
+.PP
+The table iterator helper is designed to simplify the task of writing a table handler for the net-snmp agent when the data being accessed is not in an oid sorted form and must be accessed externally.  
 
-.PP
 .SS "Data Structures"
 
 .in +1c
@@ -15,10 +16,6 @@
 .RI "struct \fBnetsnmp_iterator_info_s\fP"
 .br
 .RI "\fIHolds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner. \fP"
-.ti -1c
-.RI "struct \fBnetsnmp_iterator_info_s\fP"
-.br
-.RI "\fIHolds iterator information containing functions which should be called by the iterator_handler to loop over your data set and sort it in a SNMP specific manner. \fP"
 .in -1c
 .SS "Defines"
 
@@ -37,7 +34,7 @@
 
 .in +1c
 .ti -1c
-.RI "typedef \fBti_cache_info_s\fP \fBti_cache_info\fP"
+.RI "typedef struct \fBti_cache_info_s\fP \fBti_cache_info\fP"
 .br
 .ti -1c
 .RI "typedef \fBnetsnmp_variable_list\fP *( \fBNetsnmp_First_Data_Point\fP )(void **loop_context, void **data_context, \fBnetsnmp_variable_list\fP *, struct \fBnetsnmp_iterator_info_s\fP *)"
@@ -55,7 +52,7 @@
 .RI "typedef void( \fBNetsnmp_Free_Data_Context\fP )(void *, struct \fBnetsnmp_iterator_info_s\fP *)"
 .br
 .ti -1c
-.RI "typedef \fBnetsnmp_iterator_info_s\fP \fBnetsnmp_iterator_info\fP"
+.RI "typedef struct \fBnetsnmp_iterator_info_s\fP \fBnetsnmp_iterator_info\fP"
 .br
 .RI "\fITypedefs the \fBnetsnmp_iterator_info_s\fP struct into netsnmp_iterator_info. \fP"
 .in -1c
@@ -63,7 +60,7 @@
 
 .in +1c
 .ti -1c
-.RI "\fBnetsnmp_iterator_info\fP * \fBnetsnmp_iterator_create_table\fP (\fBNetsnmp_First_Data_Point\fP *firstDP, \fBNetsnmp_Next_Data_Point\fP *nextDP, \fBNetsnmp_First_Data_Point\fP *getidx, \fBnetsnmp_variable_list\fP *indexes)"
+.RI "\fBnetsnmp_iterator_info\fP * \fBnetsnmp_iterator_create_table\fP (Netsnmp_First_Data_Point *firstDP, Netsnmp_Next_Data_Point *nextDP, Netsnmp_First_Data_Point *getidx, \fBnetsnmp_variable_list\fP *indexes)"
 .br
 .ti -1c
 .RI "void \fBnetsnmp_iterator_delete_table\fP (\fBnetsnmp_iterator_info\fP *iinfo)"
@@ -116,19 +113,19 @@
 
 .in +1c
 .ti -1c
-.RI "\fBNetsnmp_Node_Handler\fP \fBnetsnmp_table_iterator_helper_handler\fP"
+.RI "Netsnmp_Node_Handler \fBnetsnmp_table_iterator_helper_handler\fP"
 .br
 .in -1c
 .SH "Detailed Description"
 .PP 
 The table iterator helper is designed to simplify the task of writing a table handler for the net-snmp agent when the data being accessed is not in an oid sorted form and must be accessed externally. 
-.PP
-Functionally, it is a specialized version of the more generic table helper but easies the burden of GETNEXT processing by manually looping through all the data indexes retrieved through function calls which should be supplied by the module that wishes help. The module the table_iterator helps should, afterwards, never be called for the case of 'MODE_GETNEXT' and only for the GET and SET related modes instead.
+
+Functionally, it is a specialized version of the more generic table helper but easies the burden of GETNEXT processing by manually looping through all the data indexes retrieved through function calls which should be supplied by the \fBmodule\fP that wishes help. The \fBmodule\fP the table_iterator helps should, afterwards, never be called for the case of 'MODE_GETNEXT' and only for the GET and SET related modes instead.
 .PP
 The fundamental notion between the table iterator is that it allows your code to iterate over each 'row' within your data storage mechanism, without requiring that it be sorted in a SNMP-index-compliant manner. Through the get_first_data_point and get_next_data_point hooks, the table_iterator helper will repeatedly call your hooks to find the 'proper' row of data that needs processing. The following concepts are important:
 .PP
 .IP "\(bu" 2
-A loop context is a pointer which indicates where in the current processing of a set of rows you currently are. Allows the get_*_data_point routines to move from one row to the next, once the iterator handler has identified the appropriate row for this request, the job of the loop context is done. The most simple example would be a pointer to an integer which simply counts rows from 1 to X. More commonly, it might be a pointer to a linked list node, or someother internal or external reference to a data set (file seek value, array pointer, ...). If allocated during iteration, either the free_loop_context_at_end (preferably) or the free_loop_context pointers should be set.
+A loop context is a pointer which indicates where in the current processing of a set of rows you currently are. Allows the get_*_data_point routines to move from one row to the next, once the iterator handler has identified the appropriate row for this request, the job of the loop context is done. The most simple example would be a pointer to an integer which simply counts rows from 1 to X. More commonly, it might be a pointer to a linked list \fBnode\fP, or someother internal or external reference to a data set (file seek value, array pointer, ...). If allocated during iteration, either the free_loop_context_at_end (preferably) or the free_loop_context pointers should be set.
 .PP
 .PP
 .IP "\(bu" 2
@@ -138,7 +135,7 @@
 The table iterator operates in a series of steps that call your code hooks from your netsnmp_iterator_info registration pointer.
 .PP
 .IP "\(bu" 2
-the get_first_data_point hook is called at the beginning of processing. It should set the variable list to a list of indexes for the given table. It should also set the loop_context and maybe a data_context which you will get a pointer back to when it needs to call your code to retrieve actual data later. The list of indexes should be returned after being update.
+the get_first_data_point hook is called at the beginning of processing. It should set the \fBvariable\fP list to a list of indexes for the given table. It should also set the loop_context and maybe a data_context which you will get a pointer back to when it needs to call your code to retrieve actual data later. The list of indexes should be returned after being update.
 .PP
 .PP
 .IP "\(bu" 2
@@ -150,14 +147,11 @@
 .SS "struct \fBnetsnmp_iterator_info_s\fP \fBnetsnmp_iterator_info\fP"
 .PP
 Typedefs the \fBnetsnmp_iterator_info_s\fP struct into netsnmp_iterator_info. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "void * netsnmp_extract_iterator_context (\fBnetsnmp_request_info\fP * request)"
 .PP
-extracts the table_iterator specific data from a request. 
-.PP
-This function extracts the table iterator specific data from a netsnmp_request_info object. Calls netsnmp_request_get_list_data with request->parent_data set with data from a request that was added previously by a module and TABLE_ITERATOR_NAME handler name.
+extracts the table_iterator specific data from a request. This function extracts the table iterator specific data from a netsnmp_request_info object. Calls netsnmp_request_get_list_data with request->parent_data set with data from a request that was added previously by a \fBmodule\fP and TABLE_ITERATOR_NAME handler name.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -170,31 +164,15 @@
 .RE
 .PP
 
-.PP
-Definition at line 234 of file table_iterator.c.
-.PP
-References netsnmp_request_get_list_data(), and TABLE_ITERATOR_NAME.
 .SS "\fBnetsnmp_mib_handler\fP * netsnmp_get_table_iterator_handler (\fBnetsnmp_iterator_info\fP * iinfo)"
 .PP
 returns a netsnmp_mib_handler object for the table_iterator helper 
-.PP
-Definition at line 169 of file table_iterator.c.
-.PP
-References netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), netsnmp_table_iterator_helper_handler, NULL, and TABLE_ITERATOR_NAME.
-.PP
-Referenced by netsnmp_register_table_iterator().
 .SS "void netsnmp_insert_iterator_context (\fBnetsnmp_request_info\fP * request, void * data)"
 .PP
 inserts table_iterator specific data for a newly created row into a request 
-.PP
-Definition at line 242 of file table_iterator.c.
-.PP
-References build_oid_noalloc(), netsnmp_table_request_info_s::indexes, netsnmp_create_data_list(), netsnmp_extract_table_info(), netsnmp_request_add_list_data(), netsnmp_request_info_s::next, NULL, netsnmp_request_info_s::prev, snmp_oid_compare(), and TABLE_ITERATOR_NAME.
 .SS "int netsnmp_register_table_iterator (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_iterator_info\fP * iinfo)"
 .PP
-Creates and registers a table iterator helper handler calling netsnmp_create_handler with a handler name set to TABLE_ITERATOR_NAME and access method, netsnmp_table_iterator_helper_handler. 
-.PP
-If NOT_SERIALIZED is not defined the function injects the serialize handler into the calling chain prior to calling netsnmp_register_table.
+Creates and registers a table iterator helper handler calling netsnmp_create_handler with a handler name set to TABLE_ITERATOR_NAME and access method, netsnmp_table_iterator_helper_handler. If NOT_SERIALIZED is not defined the function injects the serialize handler into the calling chain prior to calling netsnmp_register_table.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -209,7 +187,6 @@
 .RE
 .PP
 
-.PP
-Definition at line 205 of file table_iterator.c.
-.PP
-References HANDLER_CAN_STASH, netsnmp_table_registration_info_s::indexes, netsnmp_iterator_info_s::indexes, netsnmp_handler_registration_s::modes, netsnmp_get_table_iterator_handler(), netsnmp_inject_handler(), netsnmp_register_table(), snmp_clone_varbind(), and netsnmp_iterator_info_s::table_reginfo.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_iterator.h.3'
--- man/netsnmp_table_iterator.h.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_iterator.h.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "table_iterator.h" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_iterator.h" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -43,7 +43,7 @@
 .RI "typedef void( \fBNetsnmp_Free_Data_Context\fP )(void *, struct \fBnetsnmp_iterator_info_s\fP *)"
 .br
 .ti -1c
-.RI "typedef \fBnetsnmp_iterator_info_s\fP \fBnetsnmp_iterator_info\fP"
+.RI "typedef struct \fBnetsnmp_iterator_info_s\fP \fBnetsnmp_iterator_info\fP"
 .br
 .RI "\fITypedefs the \fBnetsnmp_iterator_info_s\fP struct into netsnmp_iterator_info. \fP"
 .in -1c
@@ -98,7 +98,7 @@
 
 .in +1c
 .ti -1c
-.RI "\fBNetsnmp_Node_Handler\fP \fBnetsnmp_table_iterator_helper_handler\fP"
+.RI "Netsnmp_Node_Handler \fBnetsnmp_table_iterator_helper_handler\fP"
 .br
 .in -1c
 .SH "Detailed Description"

=== modified file 'man/netsnmp_table_maintenance.3'
--- man/netsnmp_table_maintenance.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_maintenance.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_maintenance" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_maintenance" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_maintenance \- Routines for maintaining the contents of a table.  
+table_maintenance \- 
+.PP
+Routines for maintaining the contents of a table.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -52,7 +53,7 @@
 .SH "Detailed Description"
 .PP 
 Routines for maintaining the contents of a table. 
-.PP
+
 This would typically be part of implementing an SNMP MIB, but could potentially also be used for a standalone table.
 .PP
 This section of the generic API is primarily relevant to table helpers where the representation of the table is constructed and maintained within the helper itself. 'External' tables will typically look after such aspects directly, although this section of the abstract API framework could also help direct the design of such table-specific implementations. 
@@ -70,39 +71,29 @@
 Definition at line 82 of file table_generic.c.
 .SS "int netsnmp_generic_copy_row (void * dst_row, void * src_row)"
 .PP
-Copy the contents of one row into another. 
-.PP
-The destination row structure should be created before this routine is called. 
+Copy the contents of one row into another. The destination row structure should be created before this routine is called. 
 .PP
 Definition at line 90 of file table_generic.c.
 .SS "void* netsnmp_generic_create_row (void)"
 .PP
-Create a new row structure suitable for this style of table. 
-.PP
-Note that this would typically be a 'standalone' row, and would not automatically be inserted into an actual table. 
+Create a new row structure suitable for this style of table. Note that this would typically be a 'standalone' row, and would not automatically be inserted into an actual table. 
 .PP
 Definition at line 76 of file table_generic.c.
 .SS "void* netsnmp_generic_create_table (const char * name, int flags)"
 .PP
-Create a structure to represent the table. 
-.PP
-This could be as simple as the head of a linked list, or a more complex container structure. The 'name' field would typically be used to distinguish between several tables implemented using the same table helper. The 'flags' field would be used to control various (helper-specific) aspects of table behaviour.
+Create a structure to represent the table. This could be as simple as the head of a linked list, or a more complex container structure. The 'name' field would typically be used to distinguish between several tables implemented using the same table helper. The 'flags' field would be used to control various (helper-specific) aspects of table behaviour.
 .PP
 The table structure returned should typically be regarded as an opaque, private structure. All operations on the content of the table should ideally use the appropriate routines from this API. 
 .PP
 Definition at line 60 of file table_generic.c.
 .SS "void netsnmp_generic_delete_row (void * row)"
 .PP
-Delete a row data structure. 
-.PP
-The row should be removed from any relevant table(s) before this routine is called. 
+Delete a row data structure. The row should be removed from any relevant table(s) before this routine is called. 
 .PP
 Definition at line 98 of file table_generic.c.
 .SS "void netsnmp_generic_delete_table (void * table)"
 .PP
-Release the structure representing a table. 
-.PP
-Any rows still contained within the table should also be removed and deleted. 
+Release the structure representing a table. Any rows still contained within the table should also be removed and deleted. 
 .PP
 Definition at line 68 of file table_generic.c.
 .SS "void netsnmp_generic_remove_delete_row (void * table, void * row)"
@@ -112,15 +103,14 @@
 Definition at line 127 of file table_generic.c.
 .SS "void* netsnmp_generic_remove_row (void * table, void * row)"
 .PP
-Remove a row from the table. 
-.PP
-The data structure for the row should not be released, and would be the return value of this routine. 
+Remove a row from the table. The data structure for the row should not be released, and would be the return value of this routine. 
 .PP
 Definition at line 121 of file table_generic.c.
 .SS "int netsnmp_generic_replace_row (void * table, void * old_row, void * new_row)"
 .PP
-Replace one row with another in the table. 
-.PP
-This will typically (but not necessarily) involve two rows sharing the same index information (e.g. to implement update/restore-style SET behaviour). 
+Replace one row with another in the table. This will typically (but not necessarily) involve two rows sharing the same index information (e.g. to implement update/restore-style SET behaviour). 
 .PP
 Definition at line 113 of file table_generic.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_table_rows.3'
--- man/netsnmp_table_rows.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_table_rows.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "table_rows" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "table_rows" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-table_rows \- Routines for working with the rows of a table.  
+table_rows \- 
+.PP
+Routines for working with the rows of a table.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -44,7 +45,6 @@
 .SH "Detailed Description"
 .PP 
 Routines for working with the rows of a table. 
-.PP
 .SH "Function Documentation"
 .PP 
 .SS "int netsnmp_generic_row_count (void * table)"
@@ -59,9 +59,7 @@
 Definition at line 228 of file table_generic.c.
 .SS "void* netsnmp_generic_row_get (void * table, void * row)"
 .PP
-Retrieve the given row from the table. 
-.PP
-This could either be the same data pointer, passed in, or a separate row structure sharing the same index values (or NULL).
+Retrieve the given row from the table. This could either be the same data pointer, passed in, or a separate row structure sharing the same index values (or NULL).
 .PP
 This routine also provides a means to tell whether a given row is present in the table. 
 .PP
@@ -78,9 +76,7 @@
 Definition at line 270 of file table_generic.c.
 .SS "void* netsnmp_generic_row_next (void * table, void * row)"
 .PP
-Retrieve the following row from the table. 
-.PP
-If the specified row is not present, this routine should return the entry next after the position this row would have occupied. 
+Retrieve the following row from the table. If the specified row is not present, this routine should return the entry next after the position this row would have occupied. 
 .PP
 Definition at line 249 of file table_generic.c.
 .SS "void* netsnmp_generic_row_next_byidx (void * table, \fBnetsnmp_variable_list\fP * indexes)"
@@ -93,3 +89,6 @@
 Retrieve the next row after the specified instance OIDs. 
 .PP
 Definition at line 276 of file table_generic.c.
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_tdata.3'
--- man/netsnmp_tdata.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_tdata.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "tdata" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "tdata" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-tdata \- Implement a table with datamatted storage.  
+tdata \- 
+.PP
+Implement a table with datamatted storage.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -136,13 +137,13 @@
 
 .in +1c
 .ti -1c
-.RI "\fBNetsnmp_Node_Handler\fP \fB_netsnmp_tdata_helper_handler\fP"
+.RI "Netsnmp_Node_Handler \fB_netsnmp_tdata_helper_handler\fP"
 .br
 .in -1c
 .SH "Detailed Description"
 .PP 
 Implement a table with datamatted storage. 
-.PP
+
 This helper helps you implement a table where all the rows are expected to be stored within the agent itself and not in some external storage location. It can be used to store a list of rows, where a row consists of the indexes to the table and a generic data pointer. You can then implement a subhandler which is passed the exact row definition and data it must return data for or accept data for. Complex GETNEXT handling is greatly simplified in this case. 
 .SH "Function Documentation"
 .PP 
@@ -151,215 +152,136 @@
 Creates a tdata handler and returns it. 
 .PP
 Definition at line 284 of file table_tdata.c.
-.PP
-References _netsnmp_tdata_helper_handler, netsnmp_mib_handler_s::flags, MIB_HANDLER_AUTO_NEXT, netsnmp_mib_handler_s::myvoid, netsnmp_create_handler(), NULL, and snmp_log().
-.PP
-Referenced by netsnmp_tdata_register().
 .SS "NETSNMP_INLINE void netsnmp_insert_tdata_row (\fBnetsnmp_request_info\fP * request, \fBnetsnmp_tdata_row\fP * row)"
 .PP
 inserts a newly created tdata row into a request 
 .PP
 Definition at line 399 of file table_tdata.c.
-.PP
-References netsnmp_container_table_row_insert().
 .SS "int netsnmp_tdata_add_row (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * row)"
 .PP
-Adds a row to the given table (stored in proper lexographical order). 
-.PP
-returns SNMPERR_SUCCESS on successful addition. or SNMPERR_GENERR on failure (E.G., indexes already existed) 
+Adds a row to the given table (stored in proper lexographical order). returns SNMPERR_SUCCESS on successful addition. or SNMPERR_GENERR on failure (E.G., indexes already existed) 
 .PP
 Definition at line 186 of file table_tdata.c.
-.PP
-References _netsnmp_tdata_generate_index_oid(), netsnmp_tdata_s::container, netsnmp_tdata_s::flags, netsnmp_tdata_row_s::indexes, netsnmp_tdata_s::name, NULL, netsnmp_tdata_row_s::oid_index, netsnmp_index_s::oids, snmp_free_varbind(), and snmp_log().
-.PP
-Referenced by netsnmp_tdata_replace_row().
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_clone_row (\fBnetsnmp_tdata_row\fP * row)"
 .PP
-clones a 'tdata' row. 
-.PP
-DOES NOT CLONE THE TABLE-SPECIFIC ENTRY DATA. 
+clones a 'tdata' row. DOES NOT CLONE THE TABLE-SPECIFIC ENTRY DATA. 
 .PP
 Definition at line 92 of file table_tdata.c.
-.PP
-References memdup(), NULL, snmp_clone_varbind(), SNMP_FREE, and snmp_free_varbind().
 .SS "int netsnmp_tdata_compare_idx (\fBnetsnmp_tdata_row\fP * row, \fBnetsnmp_variable_list\fP * indexes)"
 .PP
 compare a row with the given index values 
 .PP
 Definition at line 518 of file table_tdata.c.
-.PP
-References build_oid_noalloc(), netsnmp_tdata_compare_oid(), and NULL.
 .SS "int netsnmp_tdata_compare_oid (\fBnetsnmp_tdata_row\fP * row, oid * compareto, size_t compareto_len)"
 .PP
 compare a row with the given index OID 
 .PP
 Definition at line 531 of file table_tdata.c.
-.PP
-References netsnmp_index_s::len, netsnmp_index_s::oids, and snmp_oid_compare().
-.PP
-Referenced by netsnmp_tdata_compare_idx().
 .SS "int netsnmp_tdata_copy_row (\fBnetsnmp_tdata_row\fP * dst_row, \fBnetsnmp_tdata_row\fP * src_row)"
 .PP
-copy the contents of a 'tdata' row. 
-.PP
-DOES NOT COPY THE TABLE-SPECIFIC ENTRY DATA. 
+copy the contents of a 'tdata' row. DOES NOT COPY THE TABLE-SPECIFIC ENTRY DATA. 
 .PP
 Definition at line 129 of file table_tdata.c.
-.PP
-References memdup(), and snmp_clone_varbind().
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_create_row (void)"
 .PP
 creates and returns a pointer to new row data structure 
 .PP
 Definition at line 84 of file table_tdata.c.
-.PP
-References SNMP_MALLOC_TYPEDEF.
 .SS "\fBnetsnmp_tdata\fP* netsnmp_tdata_create_table (const char * name, long flags)"
 .PP
 creates and returns a 'tdata' table data structure 
 .PP
 Definition at line 54 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_tdata_s::name, NULL, and SNMP_MALLOC_TYPEDEF.
 .SS "void* netsnmp_tdata_delete_row (\fBnetsnmp_tdata_row\fP * row)"
 .PP
 deletes the memory used by the specified row returns the table-specific entry data (that it doesn't know how to delete) 
 .PP
 Definition at line 157 of file table_tdata.c.
-.PP
-References netsnmp_tdata_row_s::data, netsnmp_tdata_row_s::indexes, NULL, netsnmp_tdata_row_s::oid_index, netsnmp_index_s::oids, SNMP_FREE, and snmp_free_varbind().
-.PP
-Referenced by netsnmp_tdata_remove_and_delete_row().
 .SS "void netsnmp_tdata_delete_table (\fBnetsnmp_tdata\fP * table)"
 .PP
 creates and returns a 'tdata' table data structure 
 .PP
 Definition at line 68 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_tdata_s::name, and SNMP_FREE.
 .SS "\fBnetsnmp_container\fP* netsnmp_tdata_extract_container (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the tdata container from the request structure 
 .PP
 Definition at line 370 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_request_get_list_data(), and NULL.
 .SS "void* netsnmp_tdata_extract_entry (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the (table-specific) entry being accessed from the request structure 
 .PP
 Definition at line 387 of file table_tdata.c.
-.PP
-References netsnmp_tdata_row_s::data, netsnmp_tdata_extract_row(), and NULL.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_extract_row (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the tdata row being accessed from the request structure 
 .PP
 Definition at line 379 of file table_tdata.c.
-.PP
-References netsnmp_container_table_row_extract().
-.PP
-Referenced by netsnmp_tdata_extract_entry().
 .SS "\fBnetsnmp_tdata\fP* netsnmp_tdata_extract_table (\fBnetsnmp_request_info\fP * request)"
 .PP
 extracts the tdata table from the request structure 
 .PP
 Definition at line 362 of file table_tdata.c.
-.PP
-References netsnmp_request_get_list_data().
 .SS "int netsnmp_tdata_register (\fBnetsnmp_handler_registration\fP * reginfo, \fBnetsnmp_tdata\fP * table, \fBnetsnmp_table_registration_info\fP * table_info)"
 .PP
 registers a tdata-based MIB table 
 .PP
 Definition at line 351 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_container_table_register(), netsnmp_get_tdata_handler(), and netsnmp_inject_handler().
 .SS "void* netsnmp_tdata_remove_and_delete_row (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * row)"
 .PP
-removes and frees a row of the given table and returns the table-specific entry data 
-.PP
-returns the void * pointer on successful deletion. or NULL on failure (bad arguments) 
+removes and frees a row of the given table and returns the table-specific entry data returns the void * pointer on successful deletion. or NULL on failure (bad arguments) 
 .PP
 Definition at line 260 of file table_tdata.c.
-.PP
-References netsnmp_tdata_delete_row(), netsnmp_tdata_remove_row(), and NULL.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_remove_row (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * row)"
 .PP
-removes a row from the given table and returns it (no free's called) 
-.PP
-returns the row pointer itself on successful removing. or NULL on failure (bad arguments) 
+removes a row from the given table and returns it (no free's called) returns the row pointer itself on successful removing. or NULL on failure (bad arguments) 
 .PP
 Definition at line 242 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, and NULL.
-.PP
-Referenced by netsnmp_tdata_remove_and_delete_row(), and netsnmp_tdata_replace_row().
 .SS "void netsnmp_tdata_replace_row (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * origrow, \fBnetsnmp_tdata_row\fP * newrow)"
 .PP
-swaps out origrow with newrow. 
-.PP
-This does *not* delete/free anything! 
+swaps out origrow with newrow. This does *not* delete/free anything! 
 .PP
 Definition at line 227 of file table_tdata.c.
-.PP
-References netsnmp_tdata_add_row(), and netsnmp_tdata_remove_row().
 .SS "void* netsnmp_tdata_row_entry (\fBnetsnmp_tdata_row\fP * row)"
 .PP
 returns the (table-specific) entry data for a given row 
 .PP
 Definition at line 414 of file table_tdata.c.
-.PP
-References netsnmp_tdata_row_s::data, and NULL.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_first (\fBnetsnmp_tdata\fP * table)"
 .PP
 returns the first row in the table 
 .PP
 Definition at line 424 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_get (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * row)"
 .PP
 finds a row in the 'tdata' table given another row 
 .PP
 Definition at line 431 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_get_byidx (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_variable_list\fP * indexes)"
 .PP
 finds a row in the 'tdata' table given the index values 
 .PP
 Definition at line 447 of file table_tdata.c.
-.PP
-References build_oid_noalloc(), netsnmp_tdata_row_get_byoid(), and NULL.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_get_byoid (\fBnetsnmp_tdata\fP * table, oid * searchfor, size_t searchfor_len)"
 .PP
 finds a row in the 'tdata' table given the index OID 
 .PP
 Definition at line 460 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_index_s::len, NULL, and netsnmp_index_s::oids.
-.PP
-Referenced by netsnmp_tdata_row_get_byidx().
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_next (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_tdata_row\fP * row)"
 .PP
 returns the next row in the table 
 .PP
 Definition at line 439 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_next_byidx (\fBnetsnmp_tdata\fP * table, \fBnetsnmp_variable_list\fP * indexes)"
 .PP
 finds the lexically next row in the 'tdata' table given the index values 
 .PP
 Definition at line 475 of file table_tdata.c.
-.PP
-References build_oid_noalloc(), netsnmp_tdata_row_next_byoid(), and NULL.
 .SS "\fBnetsnmp_tdata_row\fP* netsnmp_tdata_row_next_byoid (\fBnetsnmp_tdata\fP * table, oid * searchfor, size_t searchfor_len)"
 .PP
 finds the lexically next row in the 'tdata' table given the index OID 
 .PP
 Definition at line 489 of file table_tdata.c.
-.PP
-References netsnmp_tdata_s::container, netsnmp_index_s::len, NULL, and netsnmp_index_s::oids.
-.PP
-Referenced by netsnmp_tdata_row_next_byidx().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_util.3'
--- man/netsnmp_util.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_util.3	2010-06-10 18:02:54 +0000
@@ -1,4 +1,4 @@
-.TH "Memory Utility Routines" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "Memory Utility Routines" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
@@ -7,7 +7,7 @@
 
 .in +1c
 .ti -1c
-.RI "#define \fBSNMP_MAXPATH\fP   1024"
+.RI "#define \fBSNMP_MAXPATH\fP   PATH_MAX"
 .br
 .ti -1c
 .RI "#define \fBSNMP_MAXBUF\fP   (1024 * 4)"
@@ -90,12 +90,6 @@
 .RI "#define \fBSNMP_MACRO_VAL_TO_STR_PRIV\fP(s)   #s"
 .br
 .ti -1c
-.RI "#define \fBFALSE\fP   0"
-.br
-.ti -1c
-.RI "#define \fBTRUE\fP   1"
-.br
-.ti -1c
 .RI "#define \fBQUITFUN\fP(e, l)"
 .br
 .ti -1c
@@ -179,35 +173,35 @@
 .RI "char * \fBdump_snmpEngineID\fP (const u_char *buf, size_t *buflen)"
 .br
 .ti -1c
-.RI "\fBmarker_t\fP \fBatime_newMarker\fP (void)"
+.RI "marker_t \fBatime_newMarker\fP (void)"
 .br
 .RI "\fIcreate a new time marker. \fP"
 .ti -1c
-.RI "void \fBatime_setMarker\fP (\fBmarker_t\fP pm)"
+.RI "void \fBatime_setMarker\fP (marker_t pm)"
 .br
 .RI "\fIset a time marker. \fP"
 .ti -1c
-.RI "long \fBatime_diff\fP (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.RI "long \fBatime_diff\fP (marker_t first, marker_t second)"
 .br
 .RI "\fIReturns the difference (in msec) between the two markers. \fP"
 .ti -1c
-.RI "u_long \fBuatime_diff\fP (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.RI "u_long \fBuatime_diff\fP (marker_t first, marker_t second)"
 .br
 .RI "\fIReturns the difference (in u_long msec) between the two markers. \fP"
 .ti -1c
-.RI "u_long \fBuatime_hdiff\fP (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.RI "u_long \fBuatime_hdiff\fP (marker_t first, marker_t second)"
 .br
 .RI "\fIReturns the difference (in u_long 1/100th secs) between the two markers (functionally this is what sysUpTime needs). \fP"
 .ti -1c
-.RI "int \fBatime_ready\fP (\fBmarker_t\fP pm, int deltaT)"
-.br
-.RI "\fITest: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). \fP"
-.ti -1c
-.RI "int \fBuatime_ready\fP (\fBmarker_t\fP pm, unsigned int deltaT)"
-.br
-.RI "\fITest: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). \fP"
-.ti -1c
-.RI "int \fBmarker_tticks\fP (\fBmarker_t\fP pm)"
+.RI "int \fBatime_ready\fP (marker_t pm, int deltaT)"
+.br
+.RI "\fITest: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). \fP"
+.ti -1c
+.RI "int \fBuatime_ready\fP (marker_t pm, unsigned int deltaT)"
+.br
+.RI "\fITest: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). \fP"
+.ti -1c
+.RI "int \fBmarker_tticks\fP (marker_t pm)"
 .br
 .RI "\fIReturn the number of timeTicks since the given marker. \fP"
 .ti -1c
@@ -216,19 +210,17 @@
 .ti -1c
 .RI "char * \fBnetsnmp_getenv\fP (const char *name)"
 .br
-.RI "\fINon Windows: Returns a pointer to the desired environment variable or NULL if the environment variable does not exist. \fP"
+.RI "\fINon Windows: Returns a pointer to the desired environment \fBvariable\fP or NULL if the environment \fBvariable\fP does not exist. \fP"
 .ti -1c
 .RI "int \fBnetsnmp_addrstr_hton\fP (char *ptr, size_t len)"
 .br
 .in -1c
 .SH "Define Documentation"
 .PP 
-.SS "#define DIFFTIMEVAL(now, then, diff)"
-.PP
-\fBValue:\fP
+.SS "#define DIFFTIMEVAL(now, then, diff)"\fBValue:\fP
 .PP
 .nf
-{                                                        \
+{                                                       \
         now.tv_sec--;                                   \
         now.tv_usec += 1000000L;                        \
         diff.tv_sec  = now.tv_sec  - then.tv_sec;       \
@@ -241,9 +233,7 @@
 .fi
 .PP
 Definition at line 131 of file tools.h.
-.SS "#define ISTRANSFORM(ttype, toid)"
-.PP
-\fBValue:\fP
+.SS "#define ISTRANSFORM(ttype, toid)"\fBValue:\fP
 .PP
 .nf
 !snmp_oid_compare(ttype, USM_LENGTH_OID_TRANSFORM,            \
@@ -251,9 +241,7 @@
 .fi
 .PP
 Definition at line 150 of file tools.h.
-.SS "#define QUITFUN(e, l)"
-.PP
-\fBValue:\fP
+.SS "#define QUITFUN(e, l)"\fBValue:\fP
 .PP
 .nf
 if ( (e) != SNMPERR_SUCCESS) {   \
@@ -268,13 +256,9 @@
 Frees a pointer only if it is !NULL and sets its value to NULL. 
 .PP
 Definition at line 53 of file tools.h.
-.PP
-Referenced by _sess_read(), build_oid_segment(), clear_callback(), clear_context(), clear_lookup_cache(), convert_v2pdu_to_v1(), create_user_from_session(), dump_chunk(), fprint_description(), fprint_objid(), fprint_value(), fprint_variable(), free_agent_snmp_session(), get_module_node(), get_node(), get_set_cache(), netsnmp_addrcache_add(), netsnmp_agent_check_packet(), netsnmp_agent_check_parse(), netsnmp_cache_reqinfo_extract(), netsnmp_cache_reqinfo_insert(), netsnmp_config_remember_free_list(), netsnmp_create_handler(), netsnmp_fixup_mib_directory(), netsnmp_free_agent_request_info(), netsnmp_free_all_list_data(), netsnmp_free_cachemap(), netsnmp_free_delegated_cache(), netsnmp_free_list_data(), netsnmp_getenv(), netsnmp_handler_free(), netsnmp_handler_registration_free(), netsnmp_init_mib(), netsnmp_iterator_delete_table(), netsnmp_reassign_requests(), netsnmp_register_agent_nsap(), netsnmp_register_old_api(), netsnmp_remove_loghandler(), netsnmp_row_merge_helper_handler(), netsnmp_sess_log_error(), netsnmp_set_mib_directory(), netsnmp_set_row_column(), netsnmp_sprint_realloc_objid(), netsnmp_sprint_realloc_objid_tree(), netsnmp_subtree_free(), netsnmp_subtree_join(), netsnmp_subtree_split(), netsnmp_table_build_oid_from_index(), netsnmp_table_data_delete_row(), netsnmp_table_data_delete_table(), netsnmp_table_data_set_helper_handler(), netsnmp_table_dataset_delete_data(), netsnmp_tcontainer_create_table(), netsnmp_tcontainer_delete_table(), netsnmp_tdata_clone_row(), netsnmp_tdata_delete_row(), netsnmp_tdata_delete_table(), netsnmp_wrap_up_request(), parse_octet_hint(), read_objid(), shutdown_mib(), snmp_add_var(), snmp_free_pdu(), snmp_free_var(), snmp_sess_close(), snmp_unregister_callback(), snmpv3_make_report(), snmpv3_parse(), table_helper_handler(), unregister_all_config_handlers(), unregister_config_handler(), and unregister_mibs_by_session().
 .SS "#define SNMP_MACRO_VAL_TO_STR(s)   SNMP_MACRO_VAL_TO_STR_PRIV(s)"
 .PP
-Expands to string with value of the s. 
-.PP
-If s is macro, the resulting string is value of the macro. Example: define TEST 1234 \fBSNMP_MACRO_VAL_TO_STR(TEST)\fP expands to '1234' SNMP_MACRO_VAL_TO_STR(TEST+1) expands to '1234+1' 
+Expands to string with value of the s. If s is macro, the resulting string is value of the macro. Example: define TEST 1234 \fBSNMP_MACRO_VAL_TO_STR(TEST)\fP expands to '1234' SNMP_MACRO_VAL_TO_STR(TEST+1) expands to '1234+1' 
 .PP
 Definition at line 99 of file tools.h.
 .SS "#define SNMP_MALLOC_STRUCT(s)   (struct s *) calloc(1, sizeof(struct s))"
@@ -282,29 +266,21 @@
 Mallocs memory of sizeof(struct s), zeros it and returns a pointer to it. 
 .PP
 Definition at line 64 of file tools.h.
-.PP
-Referenced by netsnmp_config_remember_in_list(), netsnmp_create_subtree_cache(), netsnmp_register_callback(), snmp_alarm_register(), and snmp_alarm_register_hr().
 .SS "#define SNMP_MALLOC_TYPEDEF(td)   (td *) calloc(1, sizeof(td))"
 .PP
 Mallocs memory of sizeof(t), zeros it and returns a pointer to it. 
 .PP
 Definition at line 68 of file tools.h.
-.PP
-Referenced by add_subtree(), get_context_lookup_cache(), init_agent_snmp_session(), netsnmp_baby_steps_handler_get(), netsnmp_cache_create(), netsnmp_container_get_null(), netsnmp_container_iterator_get(), netsnmp_container_table_handler_get(), netsnmp_create_data_list(), netsnmp_create_delegated_cache(), netsnmp_create_handler(), netsnmp_create_table_data(), netsnmp_create_table_data_row(), netsnmp_create_table_data_set(), netsnmp_create_watcher_info(), netsnmp_ds_register_config(), netsnmp_ds_register_premib(), netsnmp_get_new_stash_cache(), netsnmp_get_or_add_local_cachid(), netsnmp_get_scalar_group_handler(), netsnmp_handler_registration_create(), netsnmp_iterator_create_table(), netsnmp_mark_row_column_writable(), netsnmp_mode_end_call_add_mode_callback(), netsnmp_oid_stash_create_sized_node(), netsnmp_register_auto_data_table(), netsnmp_register_loghandler(), netsnmp_register_mib_table_row(), netsnmp_register_num_file_instance(), netsnmp_register_old_api(), netsnmp_register_save_list(), netsnmp_register_table_data_set(), netsnmp_row_merge_status_get(), netsnmp_set_row_column(), netsnmp_stash_to_next_helper(), netsnmp_table_container_register(), netsnmp_table_data_create_row(), netsnmp_table_data_set_create_newrowstash(), netsnmp_table_data_set_helper_handler(), netsnmp_table_iterator_helper_handler(), netsnmp_table_set_add_default_row(), netsnmp_tcontainer_create_table(), netsnmp_tdata_create_row(), netsnmp_tdata_create_table(), save_set_cache(), snmp_varlist_add_variable(), and table_helper_handler().
 .SS "#define SNMP_MAX(a, b)   ((a) > (b) ? (a) : (b))"
 .PP
 Computers the maximum of a and b. 
 .PP
 Definition at line 85 of file tools.h.
-.PP
-Referenced by netsnmp_config_parse_table_set(), netsnmp_create_subtree_cache(), and netsnmp_register_table_data_set().
 .SS "#define SNMP_MIN(a, b)   ((a) > (b) ? (b) : (a))"
 .PP
 Computers the minimum of a and b. 
 .PP
 Definition at line 89 of file tools.h.
-.PP
-Referenced by netsnmp_config_parse_table_set(), netsnmp_oid_find_prefix(), netsnmp_register_table_data_set(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_stash_to_next_helper(), netsnmp_table_data_helper_handler(), and sprint_realloc_octet_string().
 .SS "#define SNMP_SWIPE_MEM(n, s)   do { if (n) free((void *)n); n = s; s=NULL; } while(0)"
 .PP
 Frees pointer n only if it is !NULL, sets n to s and sets s to NULL. 
@@ -317,41 +293,29 @@
 Definition at line 72 of file tools.h.
 .SH "Function Documentation"
 .PP 
-.SS "long atime_diff (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.SS "long atime_diff (marker_t first, marker_t second)"
 .PP
 Returns the difference (in msec) between the two markers. 
 .PP
 Definition at line 795 of file tools.c.
-.PP
-Referenced by atime_ready(), and marker_tticks().
-.SS "\fBmarker_t\fP atime_newMarker (void)"
-.PP
-create a new time marker. 
-.PP
-NOTE: Caller must free time marker when no longer needed. 
+.SS "marker_t atime_newMarker (void)"
+.PP
+create a new time marker. NOTE: Caller must free time marker when no longer needed. 
 .PP
 Definition at line 771 of file tools.c.
-.PP
-Referenced by atime_ready(), marker_tticks(), and uatime_ready().
-.SS "int atime_ready (\fBmarker_t\fP pm, int deltaT)"
+.SS "int atime_ready (marker_t pm, int deltaT)"
 .PP
 Test: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). 
 .PP
 Definition at line 850 of file tools.c.
-.PP
-References atime_diff(), and atime_newMarker().
-.PP
-Referenced by netsnmp_cache_check_expired().
-.SS "void atime_setMarker (\fBmarker_t\fP pm)"
+.SS "void atime_setMarker (marker_t pm)"
 .PP
 set a time marker. 
 .PP
 Definition at line 782 of file tools.c.
 .SS "u_int binary_to_hex (const u_char * input, size_t len, char ** output)"
 .PP
-converts binary to hexidecimal 
-.PP
-\fBParameters:\fP
+converts binary to hexidecimal \fBParameters:\fP
 .RS 4
 \fI*input\fP Binary data. 
 .br
@@ -368,15 +332,9 @@
 FIX Is there already one of these in the UCD SNMP codebase? The old one should be used, or this one should be moved to \fBsnmplib/snmp_api.c\fP. 
 .PP
 Definition at line 287 of file tools.c.
-.PP
-References VAL2HEX.
-.PP
-Referenced by dump_chunk().
 .SS "void free_zero (void * buf, size_t size)"
 .PP
-zeros memory before freeing it. 
-.PP
-\fBParameters:\fP
+zeros memory before freeing it. \fBParameters:\fP
 .RS 4
 \fI*buf\fP Pointer at bytes to free. 
 .br
@@ -386,13 +344,9 @@
 
 .PP
 Definition at line 185 of file tools.c.
-.PP
-Referenced by hex_to_binary2(), and malloc_random().
 .SS "int hex_to_binary2 (const u_char * input, size_t len, char ** output)"
 .PP
-hex_to_binary2 
-.PP
-\fBParameters:\fP
+hex_to_binary2 \fBParameters:\fP
 .RS 4
 \fI*input\fP Printable data in base16. 
 .br
@@ -411,13 +365,9 @@
 FIX Another version of 'hex-to-binary' which takes odd length input strings. It also allocates the memory to hold the binary data. Should be integrated with the official hex_to_binary() function. 
 .PP
 Definition at line 324 of file tools.c.
-.PP
-References free_zero(), HEX2VAL, and NULL.
 .SS "u_char* malloc_random (size_t * size)"
 .PP
-Returns pointer to allocaed & set buffer on success, size contains number of random bytes filled. 
-.PP
-buf is NULL and *size set to KMT error value upon failure.
+Returns pointer to allocaed & set buffer on success, size contains number of random bytes filled. buf is NULL and *size set to KMT error value upon failure.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -432,22 +382,14 @@
 
 .PP
 Definition at line 205 of file tools.c.
-.PP
-References free_zero(), and NULL.
-.SS "int marker_tticks (\fBmarker_t\fP pm)"
+.SS "int marker_tticks (marker_t pm)"
 .PP
 Return the number of timeTicks since the given marker. 
 .PP
 Definition at line 898 of file tools.c.
-.PP
-References atime_diff(), and atime_newMarker().
-.PP
-Referenced by timeval_tticks().
 .SS "int memdup (u_char ** to, const u_char * from, size_t size)"
 .PP
-Duplicates a memory block. 
-.PP
-Copies a existing memory location from a pointer to another, newly malloced, pointer.
+Duplicates a memory block. Copies a existing memory location from a pointer to another, newly malloced, pointer.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -466,26 +408,14 @@
 
 .PP
 Definition at line 236 of file tools.c.
-.PP
-References NULL.
-.PP
-Referenced by convert_v2pdu_to_v1(), create_user_from_session(), netsnmp_handler_registration_create(), netsnmp_handler_registration_dup(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_register_old_api(), netsnmp_set_row_column(), netsnmp_table_data_clone_row(), netsnmp_table_data_copy_row(), netsnmp_table_data_set_clone_row(), netsnmp_table_row_register(), netsnmp_table_set_add_default_row(), netsnmp_tdata_clone_row(), netsnmp_tdata_copy_row(), netsnmp_watcher_helper_handler(), send_trap_to_sess(), and snmpd_parse_config_trapsess().
 .SS "char* netsnmp_getenv (const char * name)"
 .PP
-Non Windows: Returns a pointer to the desired environment variable or NULL if the environment variable does not exist. 
-.PP
-Windows: Returns a pointer to the desired environment variable if it exists. If it does not, the variable is looked up in the registry in HKCU\\Net-SNMP or HKLM\\Net-SNMP (whichever it finds first) and stores the result in the environment variable. It then returns a pointer to environment variable. 
+Non Windows: Returns a pointer to the desired environment \fBvariable\fP or NULL if the environment \fBvariable\fP does not exist. Windows: Returns a pointer to the desired environment \fBvariable\fP if it exists. If it does not, the \fBvariable\fP is looked up in the registry in HKCU\\Net-SNMP or HKLM\\Net-SNMP (whichever it finds first) and stores the result in the environment \fBvariable\fP. It then returns a pointer to environment \fBvariable\fP. 
 .PP
 Definition at line 926 of file tools.c.
-.PP
-References NULL, and SNMP_FREE.
-.PP
-Referenced by get_configuration_directory(), get_persistent_directory(), netsnmp_fixup_mib_directory(), netsnmp_get_mib_directory(), netsnmp_init_mib(), read_config_files(), and read_config_store().
 .SS "int netsnmp_hex_to_binary (u_char ** buf, size_t * buf_len, size_t * offset, int allow_realloc, const char * hex, const char * delim)"
 .PP
-convert an ASCII hex string (with specified delimiters) to binary 
-.PP
-\fBParameters:\fP
+convert an ASCII hex string (with specified delimiters) to binary \fBParameters:\fP
 .RS 4
 \fIbuf\fP address of a pointer (pointer to pointer) for the output buffer. If allow_realloc is set, the buffer may be grown via snmp_realloc to accomodate the data.
 .br
@@ -510,24 +440,14 @@
 
 .PP
 Definition at line 425 of file tools.c.
-.PP
-References NULL, and snmp_realloc().
-.PP
-Referenced by snmp_hex_to_binary().
 .SS "char* netsnmp_strdup_and_null (const u_char * from, size_t from_len)"
 .PP
 copies a (possible) unterminated string of a given length into a new buffer and null terminates it as well (new buffer MAY be one byte longer to account for this 
 .PP
 Definition at line 255 of file tools.c.
-.PP
-References NULL.
-.PP
-Referenced by netsnmp_table_data_set_helper_handler().
 .SS "int snmp_hex_to_binary (u_char ** buf, size_t * buf_len, size_t * offset, int allow_realloc, const char * hex)"
 .PP
-convert an ASCII hex string to binary 
-.PP
-\fBNote:\fP
+convert an ASCII hex string to binary \fBNote:\fP
 .RS 4
 This is a wrapper which calls netsnmp_hex_to_binary with a delimiter string of ' '.
 .RE
@@ -544,15 +464,9 @@
 
 .PP
 Definition at line 485 of file tools.c.
-.PP
-References netsnmp_hex_to_binary().
-.PP
-Referenced by create_user_from_session(), and snmp_add_var().
 .SS "int snmp_realloc (u_char ** buf, size_t * buf_len)"
 .PP
-This function increase the size of the buffer pointed at by *buf, which is initially of size *buf_len. 
-.PP
-Contents are preserved **AT THE BOTTOM END OF THE BUFFER**. If memory can be (re-)allocated then it returns 1, else it returns 0.
+This function increase the size of the buffer pointed at by *buf, which is initially of size *buf_len. Contents are preserved **AT THE BOTTOM END OF THE BUFFER**. If memory can be (re-)allocated then it returns 1, else it returns 0.
 .PP
 \fBParameters:\fP
 .RS 4
@@ -569,28 +483,21 @@
 
 .PP
 Definition at line 121 of file tools.c.
-.PP
-References NULL.
-.PP
-Referenced by _sprint_hexstring_line(), asn_realloc(), dump_realloc_oid_to_string(), netsnmp_hex_to_binary(), snmp_add_var(), snmp_decimal_to_binary(), snmp_strcat(), sprint_realloc_asciistring(), sprint_realloc_ipaddress(), sprint_realloc_networkaddress(), and sprint_realloc_octet_string().
-.SS "u_long uatime_diff (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.SS "u_long uatime_diff (marker_t first, marker_t second)"
 .PP
 Returns the difference (in u_long msec) between the two markers. 
 .PP
 Definition at line 812 of file tools.c.
-.PP
-Referenced by uatime_ready().
-.SS "u_long uatime_hdiff (\fBmarker_t\fP first, \fBmarker_t\fP second)"
+.SS "u_long uatime_hdiff (marker_t first, marker_t second)"
 .PP
 Returns the difference (in u_long 1/100th secs) between the two markers (functionally this is what sysUpTime needs). 
 .PP
 Definition at line 830 of file tools.c.
-.PP
-Referenced by netsnmp_marker_uptime().
-.SS "int uatime_ready (\fBmarker_t\fP pm, unsigned int deltaT)"
+.SS "int uatime_ready (marker_t pm, unsigned int deltaT)"
 .PP
 Test: Has (marked time plus delta) exceeded current time (in msec) ? Returns 0 if test fails or cannot be tested (no marker). 
 .PP
 Definition at line 872 of file tools.c.
-.PP
-References atime_newMarker(), and uatime_diff().
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_utilities.3'
--- man/netsnmp_utilities.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_utilities.3	2010-06-10 18:02:54 +0000
@@ -1,78 +1,74 @@
-.TH "utility_handlers" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "utility_handlers" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-utility_handlers \- Simplify request processing A group of handlers intended to simplify certain aspects of processing a request for a MIB object.  
+utility_handlers \- 
+.PP
+Simplify request processing A group of handlers intended to simplify certain aspects of processing a request for a MIB object.  
 
-.PP
 .SS "Modules"
 
 .in +1c
 .ti -1c
 .RI "\fBbulk_to_next\fP"
 .br
+.PP
+
 .RI "\fIConvert GETBULK requests into GETNEXT requests for the handler. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBcache_handler\fP"
 .br
+.PP
+
 .RI "\fIMaintains a cache of data for use by lower level handlers. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBdebug\fP"
 .br
+.PP
+
 .RI "\fIPrint out debugging information about the handler chain being called. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBmode_end_call\fP"
 .br
+.PP
+
 .RI "\fIAt the end of a series of requests, call another handler hook. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBmultiplexer\fP"
 .br
+.PP
+
 .RI "\fISplits mode requests into calls to different handlers. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBread_only\fP"
 .br
+.PP
+
 .RI "\fIMake your handler read_only automatically The only purpose of this handler is to return an appropriate error for any requests passed to it in a SET mode. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBrow_merge\fP"
 .br
+.PP
+
 .RI "\fICalls sub handlers with request for one row at a time. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBserialize\fP"
 .br
+.PP
+
 .RI "\fICalls sub handlers one request at a time. \fP"
-.PP
-.in +1c
-
 .ti -1c
 .RI "\fBstash_to_next\fP"
 .br
+.PP
+
 .RI "\fIConvert GET_STASH requests into GETNEXT requests for the handler. \fP"
-.PP
-
 .in -1c
 .SH "Detailed Description"
 .PP 
 Simplify request processing A group of handlers intended to simplify certain aspects of processing a request for a MIB object. 
-.PP
+
 These helpers do not implement any MIB objects themselves. Rather they handle specific generic situations, either returning an error, or passing a (possibly simpler) request down to lower level handlers. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/netsnmp_variable_list.3'
--- man/netsnmp_variable_list.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_variable_list.3	2010-06-10 18:02:54 +0000
@@ -1,26 +1,27 @@
-.TH "variable_list" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "variable_list" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-variable_list \- The netsnmp variable list binding structure, it's typedef'd to netsnmp_variable_list.  
+variable_list \- 
+.PP
+The netsnmp \fBvariable\fP list binding structure, it's typedef'd to netsnmp_variable_list.  
 
-.PP
 .SH SYNOPSIS
 .br
 .PP
+.PP
 \fC#include <snmp_api.h>\fP
-.PP
 .SS "Data Fields"
 
 .in +1c
 .ti -1c
-.RI "\fBvariable_list\fP * \fBnext_variable\fP"
+.RI "struct \fBvariable_list\fP * \fBnext_variable\fP"
 .br
-.RI "\fINULL for last variable. \fP"
+.RI "\fINULL for last \fBvariable\fP. \fP"
 .ti -1c
 .RI "oid * \fBname\fP"
 .br
-.RI "\fIObject identifier of variable. \fP"
+.RI "\fIObject identifier of \fBvariable\fP. \fP"
 .ti -1c
 .RI "size_t \fBname_length\fP"
 .br
@@ -28,11 +29,11 @@
 .ti -1c
 .RI "u_char \fBtype\fP"
 .br
-.RI "\fIASN type of variable. \fP"
+.RI "\fIASN type of \fBvariable\fP. \fP"
 .ti -1c
 .RI "\fBnetsnmp_vardata\fP \fBval\fP"
 .br
-.RI "\fIvalue of variable \fP"
+.RI "\fIvalue of \fBvariable\fP \fP"
 .ti -1c
 .RI "size_t \fBval_len\fP"
 .br
@@ -40,7 +41,7 @@
 .ti -1c
 .RI "oid \fBname_loc\fP [MAX_OID_LEN]"
 .br
-.RI "\fI90 percentile < 24. \fP"
+.RI "\fIbuffer to hold the OID \fP"
 .ti -1c
 .RI "u_char \fBbuf\fP [40]"
 .br
@@ -59,7 +60,7 @@
 .in -1c
 .SH "Detailed Description"
 .PP 
-The netsnmp variable list binding structure, it's typedef'd to netsnmp_variable_list. 
+The netsnmp \fBvariable\fP list binding structure, it's typedef'd to netsnmp_variable_list. 
 .PP
 \fBExamples: \fP
 .in +1c
@@ -69,82 +70,62 @@
 Definition at line 522 of file snmp_api.h.
 .SH "Field Documentation"
 .PP 
-.SS "struct \fBvariable_list\fP* \fBvariable_list::next_variable\fP"
-.PP
-NULL for last variable. 
-.PP
-Definition at line 524 of file snmp_api.h.
-.PP
-Referenced by _fix_endofmibview(), _reorder_getbulk(), build_oid_noalloc(), check_acm(), convert_v1pdu_to_v2(), convert_v2pdu_to_v1(), count_varbinds(), count_varbinds_of_type(), find_varbind_in_list(), find_varbind_of_type(), handle_getnext_loop(), handle_pdu(), netsnmp_agent_check_parse(), netsnmp_bulk_to_next_fix_requests(), netsnmp_config_parse_add_row(), netsnmp_create_subtree_cache(), netsnmp_handle_request(), netsnmp_query_walk(), netsnmp_send_traps(), netsnmp_wrap_up_request(), parse_oid_indexes(), snmp_clone_var(), snmp_free_varbind(), snmp_pdu_build(), snmp_pdu_parse(), snmp_replace_var_types(), snmp_reset_var_buffers(), snmp_varbind_len(), snmp_varlist_add_variable(), and table_helper_handler().
+.SS "u_char \fBvariable_list::buf\fP[40]"
+.PP
+90 percentile < 40. 
+.PP
+Definition at line 538 of file snmp_api.h.
+.SS "void* \fBvariable_list::data\fP"
+.PP
+(Opaque) hook for additional data 
+.PP
+Definition at line 540 of file snmp_api.h.
+.SS "void(* \fBvariable_list::dataFreeHook\fP)(void *)"
+.PP
+callback to free above 
 .SS "oid* \fBvariable_list::name\fP"
 .PP
-Object identifier of variable. 
+Object identifier of \fBvariable\fP. 
 .PP
 Definition at line 526 of file snmp_api.h.
-.PP
-Referenced by _fix_endofmibview(), _reorder_getbulk(), build_oid_segment(), check_acm(), check_getnext_results(), convert_v2pdu_to_v1(), dump_idx_registry(), find_varbind_in_list(), netsnmp_add_varbind_to_cache(), netsnmp_agent_check_parse(), netsnmp_bulk_to_next_fix_requests(), netsnmp_bulk_to_next_helper(), netsnmp_check_getnext_reply(), netsnmp_create_subtree_cache(), netsnmp_instance_helper_handler(), netsnmp_old_api_helper(), netsnmp_query_walk(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_send_traps(), netsnmp_stash_cache_helper(), netsnmp_stash_to_next_helper(), netsnmp_table_build_oid(), netsnmp_table_build_oid_from_index(), netsnmp_table_build_result(), netsnmp_table_data_set_helper_handler(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), netsnmp_wrap_up_request(), snmp_clone_var(), snmp_free_var(), snmp_pdu_build(), snmp_pdu_parse(), snmp_reset_var_buffers(), snmp_set_var_objid(), and snmpv3_get_report_type().
 .SS "size_t \fBvariable_list::name_length\fP"
 .PP
 number of subid's in name 
 .PP
 Definition at line 528 of file snmp_api.h.
-.PP
-Referenced by _fix_endofmibview(), _reorder_getbulk(), build_oid_segment(), check_acm(), check_getnext_results(), convert_v2pdu_to_v1(), dump_idx_registry(), find_varbind_in_list(), netsnmp_add_varbind_to_cache(), netsnmp_agent_check_parse(), netsnmp_bulk_to_next_fix_requests(), netsnmp_bulk_to_next_helper(), netsnmp_check_getnext_reply(), netsnmp_create_subtree_cache(), netsnmp_instance_helper_handler(), netsnmp_old_api_helper(), netsnmp_query_walk(), netsnmp_row_merge_helper_handler(), netsnmp_scalar_group_helper_handler(), netsnmp_scalar_helper_handler(), netsnmp_send_traps(), netsnmp_stash_cache_helper(), netsnmp_stash_to_next_helper(), netsnmp_table_build_oid(), netsnmp_table_build_oid_from_index(), netsnmp_table_data_set_helper_handler(), netsnmp_watched_spinlock_handler(), netsnmp_watched_timestamp_handler(), netsnmp_watcher_helper_handler(), netsnmp_wrap_up_request(), snmp_clone_var(), snmp_pdu_build(), snmp_pdu_parse(), snmp_reset_var_buffers(), snmp_set_var_objid(), and snmpv3_get_report_type().
+.SS "oid \fBvariable_list::name_loc\fP[MAX_OID_LEN]"
+.PP
+buffer to hold the OID 
+.PP
+Definition at line 536 of file snmp_api.h.
+.SS "struct \fBvariable_list\fP* \fBvariable_list::next_variable\fP\fC [read]\fP"
+.PP
+NULL for last \fBvariable\fP. 
+.PP
+Definition at line 524 of file snmp_api.h.
 .SS "u_char \fBvariable_list::type\fP"
 .PP
-ASN type of variable. 
+ASN type of \fBvariable\fP. 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
 .PP
 Definition at line 530 of file snmp_api.h.
-.PP
-Referenced by _fix_endofmibview(), _request_set_error(), build_oid_segment(), check_acm(), check_getnext_results(), convert_v2pdu_to_v1(), count_varbinds_of_type(), dump_idx_registry(), find_varbind_of_type(), handle_pdu(), netsnmp_add_varbind_to_cache(), netsnmp_bulk_to_next_fix_requests(), netsnmp_check_getnext_reply(), netsnmp_config_parse_add_row(), netsnmp_create_subtree_cache(), netsnmp_instance_helper_handler(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_reassign_requests(), netsnmp_scalar_group_helper_handler(), netsnmp_stash_cache_helper(), netsnmp_stash_to_next_helper(), netsnmp_table_data_set_helper_handler(), netsnmp_watcher_helper_handler(), netsnmp_wrap_up_request(), parse_one_oid_index(), snmp_pdu_build(), snmp_pdu_parse(), snmp_replace_var_types(), snmp_set_var_typed_integer(), snmp_set_var_typed_value(), snmp_set_var_value(), snmp_varlist_add_variable(), sprint_realloc_bitstring(), sprint_realloc_by_type(), sprint_realloc_counter(), sprint_realloc_counter64(), sprint_realloc_gauge(), sprint_realloc_integer(), sprint_realloc_ipaddress(), sprint_realloc_networkaddress(), sprint_realloc_nsapaddress(), sprint_realloc_null(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), sprint_realloc_opaque(), sprint_realloc_timeticks(), sprint_realloc_uinteger(), sprint_realloc_value(), sprint_realloc_variable(), and table_helper_handler().
 .SS "\fBnetsnmp_vardata\fP \fBvariable_list::val\fP"
 .PP
-value of variable 
+value of \fBvariable\fP 
 .PP
 \fBExamples: \fP
 .in +1c
 \fBdelayed_instance.c\fP.
 .PP
 Definition at line 532 of file snmp_api.h.
-.PP
-Referenced by build_oid_segment(), convert_v2pdu_to_v1(), dump_idx_registry(), netsnmp_check_getnext_reply(), netsnmp_instance_int_handler(), netsnmp_instance_long_handler(), netsnmp_instance_num_file_handler(), netsnmp_instance_uint_handler(), netsnmp_instance_ulong_handler(), netsnmp_send_traps(), netsnmp_stash_cache_helper(), netsnmp_table_data_set_helper_handler(), netsnmp_watcher_helper_handler(), parse_one_oid_index(), snmp_clone_var(), snmp_free_var(), snmp_pdu_build(), snmp_pdu_parse(), snmp_reset_var_buffers(), snmp_set_var_value(), sprint_realloc_bitstring(), sprint_realloc_counter(), sprint_realloc_counter64(), sprint_realloc_gauge(), sprint_realloc_integer(), sprint_realloc_ipaddress(), sprint_realloc_networkaddress(), sprint_realloc_nsapaddress(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), sprint_realloc_opaque(), sprint_realloc_timeticks(), and sprint_realloc_uinteger().
 .SS "size_t \fBvariable_list::val_len\fP"
 .PP
 the length of the value to be copied into buf 
 .PP
 Definition at line 534 of file snmp_api.h.
-.PP
-Referenced by build_oid_segment(), convert_v2pdu_to_v1(), dump_idx_registry(), netsnmp_check_getnext_reply(), netsnmp_stash_cache_helper(), netsnmp_table_data_set_helper_handler(), netsnmp_watcher_helper_handler(), parse_one_oid_index(), snmp_clone_var(), snmp_pdu_build(), snmp_pdu_parse(), snmp_reset_var_buffers(), snmp_set_var_value(), sprint_realloc_bitstring(), sprint_realloc_networkaddress(), sprint_realloc_nsapaddress(), sprint_realloc_object_identifier(), sprint_realloc_octet_string(), and sprint_realloc_opaque().
-.SS "oid \fBvariable_list::name_loc\fP[MAX_OID_LEN]"
-.PP
-90 percentile < 24. 
-.PP
-Definition at line 536 of file snmp_api.h.
-.PP
-Referenced by build_oid_segment(), netsnmp_table_build_oid_from_index(), netsnmp_table_build_result(), snmp_free_var(), snmp_reset_var_buffers(), and snmp_set_var_objid().
-.SS "u_char \fBvariable_list::buf\fP[40]"
-.PP
-90 percentile < 40. 
-.PP
-Definition at line 538 of file snmp_api.h.
-.PP
-Referenced by snmp_clone_var(), snmp_free_var(), snmp_pdu_parse(), snmp_reset_var_buffers(), and snmp_set_var_value().
-.SS "void* \fBvariable_list::data\fP"
-.PP
-(Opaque) hook for additional data 
-.PP
-Definition at line 540 of file snmp_api.h.
-.PP
-Referenced by snmp_clone_var(), snmp_free_var(), and snmp_pdu_parse().
-.SS "void(* \fBvariable_list::dataFreeHook\fP)(void *)"
-.PP
-callback to free above 
-.PP
-Referenced by snmp_clone_var(), snmp_free_var(), and snmp_pdu_parse().
 
 .SH "Author"
 .PP 

=== modified file 'man/netsnmp_watcher.3'
--- man/netsnmp_watcher.3	2009-11-12 16:17:40 +0000
+++ man/netsnmp_watcher.3	2010-06-10 18:02:54 +0000
@@ -1,10 +1,11 @@
-.TH "watcher" 3 "5 Sep 2008" "Version 5.4.2" "net-snmp" \" -*- nroff -*-
+.TH "watcher" 3 "23 May 2010" "Version 5.4.3.pre1" "net-snmp" \" -*- nroff -*-
 .ad l
 .nh
 .SH NAME
-watcher \- Watch a specified variable and process it as an instance or scalar object.  
+watcher \- 
+.PP
+Watch a specified \fBvariable\fP and process it as an instance or scalar object.  
 
-.PP
 .SS "Functions"
 
 .in +1c
@@ -27,10 +28,10 @@
 .RI "\fBnetsnmp_mib_handler\fP * \fBnetsnmp_get_watched_timestamp_handler\fP (void)"
 .br
 .ti -1c
-.RI "int \fBnetsnmp_watched_timestamp_register\fP (\fBnetsnmp_mib_handler\fP *whandler, \fBnetsnmp_handler_registration\fP *reginfo, \fBmarker_t\fP timestamp)"
+.RI "int \fBnetsnmp_watched_timestamp_register\fP (\fBnetsnmp_mib_handler\fP *whandler, \fBnetsnmp_handler_registration\fP *reginfo, marker_t timestamp)"
 .br
 .ti -1c
-.RI "int \fBnetsnmp_register_watched_timestamp\fP (\fBnetsnmp_handler_registration\fP *reginfo, \fBmarker_t\fP timestamp)"
+.RI "int \fBnetsnmp_register_watched_timestamp\fP (\fBnetsnmp_handler_registration\fP *reginfo, marker_t timestamp)"
 .br
 .ti -1c
 .RI "int \fBnetsnmp_watched_timestamp_handler\fP (\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
@@ -45,29 +46,30 @@
 .RI "int \fBnetsnmp_watched_spinlock_handler\fP (\fBnetsnmp_mib_handler\fP *handler, \fBnetsnmp_handler_registration\fP *reginfo, \fBnetsnmp_agent_request_info\fP *reqinfo, \fBnetsnmp_request_info\fP *requests)"
 .br
 .ti -1c
-.RI "int \fBnetsnmp_register_ulong_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_ulong_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_long_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_long_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_int_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_int_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
-.br
-.ti -1c
-.RI "int \fBnetsnmp_register_read_only_counter32_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, \fBNetsnmp_Node_Handler\fP *subhandler)"
+.RI "int \fBnetsnmp_register_ulong_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_ulong_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_long_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_long_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, long *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_int_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_int_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, int *it, Netsnmp_Node_Handler *subhandler)"
+.br
+.ti -1c
+.RI "int \fBnetsnmp_register_read_only_counter32_scalar\fP (const char *name, oid *reg_oid, size_t reg_oid_len, u_long *it, Netsnmp_Node_Handler *subhandler)"
 .br
 .in -1c
 .SH "Detailed Description"
 .PP 
-Watch a specified variable and process it as an instance or scalar object. 
-.PP
-
+Watch a specified \fBvariable\fP and process it as an instance or scalar object. 
+.SH "Author"
+.PP 
+Generated automatically by Doxygen for net-snmp from the source code.

=== modified file 'man/snmpcmd.1.def'
--- man/snmpcmd.1.def	2009-11-12 16:17:40 +0000
+++ man/snmpcmd.1.def	2010-06-10 18:02:54 +0000
@@ -96,11 +96,13 @@
 .TP
 .BI -e " engineID"
 Set the authoritative (security) engineID used for SNMPv3 REQUEST
-messages.  It is typically not necessary to specify this, as it will
+messages, given as a hexadecimal string (optionally prefixed by "0x").
+It is typically not necessary to specify this engine ID, as it will
 usually be discovered automatically.
 .TP
 .BI -E " engineID"
-Set the context engineID used for SNMPv3 REQUEST messages scopedPdu.
+Set the context engineID used for SNMPv3 REQUEST messages scopedPdu,
+given as a hexadecimal string.
 If not specified, this will default to the authoritative engineID.
 .TP
 .B -h, --help

=== modified file 'man/snmpd.conf.5.def'
--- man/snmpd.conf.5.def	2009-11-12 16:17:40 +0000
+++ man/snmpd.conf.5.def	2010-06-10 18:02:54 +0000
@@ -467,9 +467,9 @@
 .IP "disk PATH [ MINSPACE | MINPERCENT% ]"
 monitors the disk mounted at PATH for available disk space.
 .IP
-The minimum threshold can either be specified in Kb (MINSPACE) or
+The minimum threshold can either be specified in kB (MINSPACE) or
 as a percentage of the total disk (MINPERCENT% with a '%' character),
-defaulting to 100Kb if neither are specified.
+defaulting to 100kB if neither are specified.
 If the free disk space falls below this threshold, 
 then the corresponding \fCdskErrorFlag\fR instance will be
 set to 1, and a suitable description message reported via the
@@ -539,7 +539,7 @@
 even if the \fIload\fR directive is not present.
 .IP "swap MIN "
 monitors the amount of swap space available on the local system.
-If this falls below the specified threshold (MIN Kb),
+If this falls below the specified threshold (MIN kB),
 then the \fImemErrorSwap\fR object will be set to 1,
 and a suitable description message reported via \fImemSwapErrorMsg\fR.
 .RS
@@ -547,14 +547,14 @@
 This situation will \fBnot\fR automatically trigger a trap to report
 the problem - see the DisMan Event MIB section later.
 .RE
-If this directive is not specified, the default threshold is 16 Mb.
+If this directive is not specified, the default threshold is 16 MB.
 .SS Log File Monitoring
 This requires that the agent was built with support for either the
 \fIucd-snmp/file\fR or \fIucd-snmp/logmatch\fR modules respectively
 (both of which are included as part of the
 default build configuration).
 .IP "file FILE [MAXSIZE]"
-monitors the size of the specified file (in Kb).
+monitors the size of the specified file (in kB).
 If MAXSIZE is specified, and the size of the file exceeds
 this threshold, then the corresponding \fCfileErrorFlag\fR
 instance will be set to 1, and a suitable description message reported
@@ -565,20 +565,48 @@
 the problem - see the DisMan Event MIB section later.
 .RE
 .IP
-A maximum of 20 files can be monitored.
-.PP
-If no \fIfile\fR directives are defined, then walking the
+Note: A maximum of 20 files can be monitored.
+.IP
+Note: If no \fIfile\fR directives are defined, then walking the
 \fCfileTable\fR will fail (\fInoSuchObject\fR).
-.IP "logmatch NAME PATH CYCLETIME REGEX"
+.IP "logmatch NAME FILE CYCLETIME REGEX"
 monitors the specified file for occurances of the specified
-pattern REGEX.
-.\"
-.\"  XXX - Need more details here!
-.\"
-.IP
-A maximum of 50 files can be monitored.
-.PP
-If no \fIlogmatch\fR directives are defined, then walking the
+pattern REGEX. The file position is stored internally so the entire file
+is only read initially, every subsequent pass will only read the new lines
+added to the file since the last read.
+.RS
+.IP NAME
+name of the logmatch instance (will appear as logMatchName under
+logMatch/logMatchTable/logMatchEntry/logMatchName in the ucd-snmp MIB tree)
+.IP FILE
+absolute path to the logfile to be monitored. Note that this path
+can contain date/time directives (like in the UNIX 'date' command). See the
+manual page for 'strftime' for the various directives accepted.
+.IP CYCLETIME
+time interval for each logfile read and internal variable update in seconds.
+Note: an SNMPGET* operation will also trigger an immediate logfile read and
+variable update.
+.IP REGEX
+the regular expression to be used. Note: DO NOT enclose the regular expression
+in quotes even if there are spaces in the expression as the quotes will also
+become part of the pattern to be matched!
+.RE
+.IP
+Example:
+.RS
+.IP
+logmatch apache-GETs /usr/local/apache/logs/access.log-%Y-%m-%d 60 GET.*HTTP.*
+.IP
+This logmatch instance is named 'apache-GETs', uses 'GET.*HTTP.*' as its
+regular expression and it will monitor the file named
+(assuming today is May 6th 2009): '/usr/local/apache/logs/access.log-2009-05-06',
+tomorrow it will look for 'access.log-2009-05-07'. The logfile is read every 60
+seconds.
+.RE
+.IP
+Note: A maximum of 250 logmatch directives can be specified.
+.IP
+Note: If no \fIlogmatch\fR directives are defined, then walking the
 \fClogMatchTable\fR will fail (\fInoSuchObject\fI).
 .SH "ACTIVE MONITORING"
 The usual behaviour of an SNMP agent is to wait for incoming SNMP requests
@@ -782,14 +810,14 @@
 Once again, this user must be explicitly created and given
 suitable access rights.
 .RE
-.IP "notificationEvent ENAME NOTIFICATION [-n] [-i OID | -o OID ]*"
+.IP "notificationEvent ENAME NOTIFICATION [-m] [-i OID | -o OID ]*"
 defines a notification event named ENAME.
 This can be triggered from a given \fImonitor\fR entry by specifying
 the option \fI-e ENAME\fR (see above).
 NOTIFICATION should be the OID of the NOTIFICATION-TYPE definition
 for the notification to be generated.
 .IP
-If the \fI-n\fR option is given, the notification payload will
+If the \fI-m\fR option is given, the notification payload will
 include the standard varbinds as specified in the OBJECTS clause
 of the notification MIB definition.
 This option must come \fBafter\fR the NOTIFICATION OID

=== modified file 'man/snmpd.examples.5.def'
--- man/snmpd.examples.5.def	2007-12-08 14:59:50 +0000
+++ man/snmpd.examples.5.def	2010-06-10 18:02:54 +0000
@@ -305,7 +305,7 @@
 includeAllDisks 10%
 disk /var 20%
 disk /usr  3%
-\fI#  Keep 100 Mb free for crash dumps\fR
+\fI#  Keep 100 MB free for crash dumps\fR
 disk /mnt/crash  100000
 .fi
 .RE
@@ -393,7 +393,7 @@
 .RE
 .PP
 This defines an explicit boolean monitor entry, looking for any process
-using more than 10Mb of active memory.  Such processes will be reported
+using more than 10MB of active memory.  Such processes will be reported
 using the (standard) DisMan trap \fCmteTriggerFired\fR,
 but adding an extra (wildcarded) varbind \fChrSWRunName\fR.
 .PP

=== modified file 'man/snmpnetstat.1.def'
--- man/snmpnetstat.1.def	2007-12-08 14:59:50 +0000
+++ man/snmpnetstat.1.def	2010-06-10 18:02:54 +0000
@@ -73,7 +73,7 @@
 [common options] [-Ci] [-Cn] [-CI interface] AGENT [interval]
 .br
 .B snmpnetstat
-[common options] [-Ca] [-Cn] [-Cs] [-CP protocol] AGENT
+[common options] [-Ca] [-Cn] [-Cs] [-Cp protocol] AGENT
 .SH DESCRIPTION
 The
 .B snmpnetstat 
@@ -140,7 +140,7 @@
 symbolically).
 This option may be used with any of the display formats.
 .PP
-.BI \-CP " protocol"
+.BI \-Cp " protocol"
 Show statistics about 
 .IR protocol,
 which is either a well-known name for a protocol or an alias for it.  Some
@@ -236,7 +236,7 @@
 .I Single Protocol
 .PP
 When a protocol is specified with the
-.B \-CP
+.B \-Cp
 option, the
 information displayed is similar to that in the
 default display for active sockets, except the
@@ -279,7 +279,7 @@
 Example of using snmpnetstat to show statistics about a specific protocol:
 .PP
 .nf
-% snmpnetstat -v 2c -c public -CP tcp testhost
+% snmpnetstat -v 2c -c public -Cp tcp testhost
 
 Active Internet (tcp) Connections
 Proto Local Address                Foreign Address                 (state)

=== modified file 'man/snmptest.1.def'
--- man/snmptest.1.def	2004-09-13 12:06:21 +0000
+++ man/snmptest.1.def	2010-06-10 18:02:54 +0000
@@ -44,7 +44,7 @@
 types of SNMP requests to target agents.
 .PP
 AGENT identifies a target SNMP agent, which is instrumented
-to monitor the gievn objects.  At its simplest, the AGENT
+to monitor the given objects.  At its simplest, the AGENT
 specification will consist of a hostname or an IPv4
 address.  In this situation, the command will attempt
 communication with the agent, using UDP/IPv4 to port 161

=== modified file 'mibs/Makefile.in'
--- mibs/Makefile.in	2009-11-12 16:17:40 +0000
+++ mibs/Makefile.in	2010-06-10 18:02:54 +0000
@@ -43,7 +43,7 @@
 	SCTP-MIB.txt
 
 NETSNMPMIBS = NET-SNMP-TC.txt NET-SNMP-MIB.txt NET-SNMP-AGENT-MIB.txt \
-	NET-SNMP-EXAMPLES-MIB.txt NET-SNMP-EXTEND-MIB.txt
+	NET-SNMP-EXAMPLES-MIB.txt NET-SNMP-EXTEND-MIB.txt NET-SNMP-PASS-MIB.txt
 
 UCDMIBS = UCD-SNMP-MIB.txt UCD-DEMO-MIB.txt UCD-IPFWACC-MIB.txt \
 	UCD-DLMOD-MIB.txt UCD-DISKIO-MIB.txt

=== modified file 'mibs/NET-SNMP-AGENT-MIB.txt'
--- mibs/NET-SNMP-AGENT-MIB.txt	2006-07-06 11:44:44 +0000
+++ mibs/NET-SNMP-AGENT-MIB.txt	2010-06-10 18:02:54 +0000
@@ -22,7 +22,7 @@
 
 
 netSnmpAgentMIB MODULE-IDENTITY
-    LAST-UPDATED "200502070000Z"
+    LAST-UPDATED "201003170000Z"
     ORGANIZATION "www.net-snmp.org"
     CONTACT-INFO    
 	 "postal:   Wes Hardaker
@@ -32,6 +32,10 @@
           email:    net-snmp-coders@lists.sourceforge.net"
     DESCRIPTION
 	 "Defines control and monitoring structures for the Net-SNMP agent."
+    REVISION     "201003170000Z"
+    DESCRIPTION
+	 "Made sure that this MIB can be compiled by MIB compilers that do not
+	 recognize a double dash as end-of-comments."
     REVISION     "200502070000Z"
     DESCRIPTION
     	"Fixing syntax errors"
@@ -72,7 +76,7 @@
     DESCRIPTION
       "Default cache timeout value (unless overridden
        for a particular cache entry)."
-    DEFVAL { 5 --seconds-- }
+    DEFVAL { 5 } --seconds-- 
     ::= { nsCache 1 }
 
 nsCacheEnabled                OBJECT-TYPE

=== modified file 'mibs/NET-SNMP-EXTEND-MIB.txt'
--- mibs/NET-SNMP-EXTEND-MIB.txt	2006-07-06 11:44:44 +0000
+++ mibs/NET-SNMP-EXTEND-MIB.txt	2010-06-10 18:02:54 +0000
@@ -17,7 +17,7 @@
 
 
 netSnmpExtendMIB MODULE-IDENTITY
-    LAST-UPDATED "200405080000Z"
+    LAST-UPDATED "201003170000Z"
     ORGANIZATION "www.net-snmp.org"
     CONTACT-INFO    
 	 "postal:   Wes Hardaker
@@ -27,6 +27,9 @@
           email:    net-snmp-coders@lists.sourceforge.net"
     DESCRIPTION
 	 "Defines a framework for scripted extensions for the Net-SNMP agent."
+    REVISION     "201003170000Z"
+    DESCRIPTION
+         "Fixed inconsistencies in the definition of nsExtendConfigTable."
     REVISION     "200405080000Z"
     DESCRIPTION
 	"First revision."
@@ -211,8 +214,8 @@
 NsExtendOutput1Entry ::= SEQUENCE {
     nsExtendOutput1Line DisplayString,
     nsExtendOutputFull  DisplayString,
-    nsExtendOutNumLines INTEGER,
-    nsExtendResult      INTEGER
+    nsExtendOutNumLines Integer32,
+    nsExtendResult      Integer32
 }
 
 nsExtendOutput1Line OBJECT-TYPE

=== added file 'mibs/NET-SNMP-PASS-MIB.txt'
--- mibs/NET-SNMP-PASS-MIB.txt	1970-01-01 00:00:00 +0000
+++ mibs/NET-SNMP-PASS-MIB.txt	2010-06-10 18:02:54 +0000
@@ -0,0 +1,124 @@
+NET-SNMP-PASS-MIB DEFINITIONS ::= BEGIN
+
+--
+-- Example MIB objects for "pass" and "pass-persist" extension script
+--
+
+IMPORTS
+    MODULE-IDENTITY, OBJECT-TYPE, TimeTicks, IpAddress,
+          Counter32, Gauge32, Integer32     FROM SNMPv2-SMI
+    SnmpAdminString                         FROM SNMP-FRAMEWORK-MIB
+    netSnmpExamples                         FROM NET-SNMP-EXAMPLES-MIB
+;
+
+netSnmpPassExamples MODULE-IDENTITY
+    LAST-UPDATED "200905280000Z"
+    ORGANIZATION "www.net-snmp.org"
+    CONTACT-INFO    
+	 "postal:   Wes Hardaker
+                    P.O. Box 382
+                    Davis CA  95617
+
+          email:    net-snmp-coders@lists.sourceforge.net"
+    DESCRIPTION
+	"Example MIB objects for pass/pass-persist extension script"
+    ::= { netSnmpExamples 255 }
+
+--
+-- Example scalars
+--
+
+netSnmpPassString OBJECT-TYPE
+    SYNTAX      SnmpAdminString
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example string scalar object."
+    DEFVAL { "Life, the Universe, and Everything" }
+    ::= { netSnmpPassExamples 1 }
+
+netSnmpPassTimeTicks OBJECT-TYPE
+    SYNTAX      TimeTicks
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example timetick object."
+    DEFVAL { 363136200 }  -- 42 days, 0:42:42.00
+    ::= { netSnmpPassExamples 3 }
+
+netSnmpPassIpAddress OBJECT-TYPE
+    SYNTAX      IpAddress
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example IP Address object."
+    DEFVAL { '7f000001'H }  -- 127.0.0.1
+    ::= { netSnmpPassExamples 4 }
+
+netSnmpPassCounter OBJECT-TYPE
+    SYNTAX      Counter32
+    MAX-ACCESS  read-only
+    STATUS      current
+    DESCRIPTION "Example counter object.
+                 Note that this object will always return the value '42'."
+    ::= { netSnmpPassExamples 5 }
+
+netSnmpPassGauge OBJECT-TYPE
+    SYNTAX      Gauge32
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example Gauge object."
+    DEFVAL { 42 }
+    ::= { netSnmpPassExamples 6 }
+
+
+netSnmpPassOIDValue OBJECT IDENTIFIER
+    ::= { netSnmpPassExamples 99 }
+
+--
+--  Example Table
+--
+
+netSnmpPassTable OBJECT-TYPE
+    SYNTAX      SEQUENCE OF NetSnmpPassEntry
+    MAX-ACCESS  not-accessible
+    STATUS      current
+    DESCRIPTION "Example table"
+    ::= { netSnmpPassExamples 2 }
+
+netSnmpPassEntry OBJECT-TYPE
+    SYNTAX      NetSnmpPassEntry
+    MAX-ACCESS  not-accessible
+    STATUS      current
+    DESCRIPTION "Conceptual row in the example table."
+    INDEX   { netSnmpPassIndex }
+    ::= {netSnmpPassTable 1 }
+
+NetSnmpPassEntry ::= SEQUENCE {
+	netSnmpPassIndex   Integer32,
+	netSnmpPassInteger Integer32,
+	netSnmpPassOID 	   OBJECT IDENTIFIER
+}
+
+netSnmpPassIndex OBJECT-TYPE
+    SYNTAX      Integer32
+    MAX-ACCESS  not-accessible
+    STATUS      current
+    DESCRIPTION "Arbitrary index into the netSnmpPassTable.
+                 Note that there will always be one row, with index 1"
+    ::= { netSnmpPassEntry 1 }
+
+netSnmpPassInteger OBJECT-TYPE
+    SYNTAX      Integer32
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example Integer (table) object."
+    DEFVAL { 42 }
+    ::= { netSnmpPassEntry 2 }
+
+netSnmpPassOID OBJECT-TYPE
+    SYNTAX      OBJECT IDENTIFIER
+    MAX-ACCESS  read-write
+    STATUS      current
+    DESCRIPTION "Example OID (table) object."
+    DEFVAL { netSnmpPassOIDValue }
+    ::= { netSnmpPassEntry 3 }
+
+END

=== modified file 'mibs/UCD-DISKIO-MIB.txt'
--- mibs/UCD-DISKIO-MIB.txt	2007-05-10 22:20:23 +0000
+++ mibs/UCD-DISKIO-MIB.txt	2010-06-10 18:02:54 +0000
@@ -17,7 +17,7 @@
         FROM UCD-SNMP-MIB;
 
 ucdDiskIOMIB MODULE-IDENTITY
-    LAST-UPDATED "200001260000Z"
+    LAST-UPDATED "200504200000Z"
     ORGANIZATION "University of California, Davis"
     CONTACT-INFO    
 	"This mib is no longer being maintained by the University of
@@ -34,13 +34,19 @@
         "
     DESCRIPTION
         "This MIB module defines objects for disk IO statistics."
+
+    REVISION     "200504200000Z"
+    DESCRIPTION
+        "Add 64 bit counters. Patch from Dan Nelson."
+
+    REVISION     "200202130000Z"
+    DESCRIPTION
+        "Add 1, 5 and 15-minute load average objects"
+
     REVISION     "200001260000Z"
     DESCRIPTION
         "SMIv2 version derived from older definitions contained
          in the VEST-INTERNETT-MIB module."
-    REVISION     "200504200000Z"
-    DESCRIPTION
-        "Add 64 bit counters. Patch from Dan Nelson."
     ::= { ucdExperimental 15 }
 
 diskIOTable OBJECT-TYPE
@@ -67,6 +73,9 @@
     diskIONWritten      Counter32,
     diskIOReads         Counter32,
     diskIOWrites        Counter32,
+    diskIOLA1           Integer32,
+    diskIOLA5           Integer32,
+    diskIOLA15          Integer32,
     diskIONReadX        Counter64,
     diskIONWrittenX     Counter64
 }

=== modified file 'mibs/UCD-DLMOD-MIB.txt'
--- mibs/UCD-DLMOD-MIB.txt	2004-09-13 12:06:21 +0000
+++ mibs/UCD-DLMOD-MIB.txt	2010-06-10 18:02:54 +0000
@@ -11,7 +11,7 @@
     ucdExperimental				FROM UCD-SNMP-MIB;
 
 ucdDlmodMIB MODULE-IDENTITY
-    LAST-UPDATED "9912100000Z"
+    LAST-UPDATED "200001260000Z"
     ORGANIZATION "University of California, Davis"
     CONTACT-INFO    
 	"This mib is no longer being maintained by the University of
@@ -29,6 +29,11 @@
     DESCRIPTION
 	"This file defines the MIB objects for dynamic 
 	 loadable MIB modules."
+
+    REVISION	 "200001260000Z"
+    DESCRIPTION
+	"Renamed MIB root object"
+
     REVISION	 "9912100000Z"
     DESCRIPTION
 	"SMIv2 version converted from older MIB definitions."

=== modified file 'mibs/UCD-IPFILTER-MIB.txt'
--- mibs/UCD-IPFILTER-MIB.txt	2004-09-13 12:06:21 +0000
+++ mibs/UCD-IPFILTER-MIB.txt	2010-06-10 18:02:54 +0000
@@ -7,7 +7,7 @@
 	FROM UCD-SNMP-MIB;
 
 ucdIpFilter MODULE-IDENTITY
-    LAST-UPDATED "9912150000Z"
+    LAST-UPDATED "200001260000Z"
     ORGANIZATION "University of California, Davis"
     CONTACT-INFO    
 	"This mib is no longer being maintained by the University of
@@ -33,6 +33,11 @@
          IP Filter UCD-SNMP module URL
          ftp://ftp.polynet.lviv.ua/pub/UNIX/security/ipf/ucd-snmp-ipf-mod.tgz
          Yaroslav Terletsky <ts@polynet.lviv.ua>"
+
+    REVISION	 "200001260000Z"
+    DESCRIPTION
+	"Renamed MIB root object"
+
     REVISION	 "9912150000Z"
     DESCRIPTION
 	"SMIv2 version converted from an older MIB definition."

=== modified file 'mibs/UCD-SNMP-MIB.txt'
--- mibs/UCD-SNMP-MIB.txt	2007-12-08 14:59:50 +0000
+++ mibs/UCD-SNMP-MIB.txt	2010-06-10 18:02:54 +0000
@@ -53,21 +53,30 @@
          email:    net-snmp-coders@lists.sourceforge.net
         "
     DESCRIPTION
+	"This file defines the private UCD SNMP MIB extensions."
+
+    REVISION	 "200611220000Z"
+    DESCRIPTION
 	"Clarify behaviour of objects in the memory & systemStats groups
          (including updated versions of malnamed mem*Text objects).
          Define suitable TCs to describe error reporting/fix behaviour."
-    REVISION	 "200611220000Z"
+
+    REVISION	 "200404070000Z"
     DESCRIPTION
 	"Added ssCpuRawSoftIRQ for Linux (2.6) and forgotten raw swap counters."
-    REVISION	 "200404070000Z"
+
+    REVISION	 "200209050000Z"
     DESCRIPTION
 	"Deprecate the non-raw objects."
-    REVISION	 "200209050000Z"
+
+    REVISION	 "200109200000Z"
     DESCRIPTION
-	"This file defines the private UCD SNMP MIB extensions."
+	"Group to monitor log files"
+
     REVISION	 "200101170000Z"
     DESCRIPTION
 	"Added raw CPU and IO counters."
+
     REVISION	 "9912090000Z"
     DESCRIPTION
 	"SMIv2 version converted from older MIB definitions."
@@ -710,7 +719,9 @@
     MAX-ACCESS	read-only
     STATUS	current
     DESCRIPTION  
-	"Total size of the disk/partion (kBytes)"
+	"Total size of the disk/partion (kBytes).
+	 For large disks (>2Tb), this value will
+	 latch at INT32_MAX (2147483647)."
     ::= { dskEntry 6 } 
 
 dskAvail OBJECT-TYPE
@@ -718,7 +729,9 @@
     MAX-ACCESS	read-only
     STATUS	current
     DESCRIPTION  
-	"Available space on the disk"
+	"Available space on the disk.
+	 For large lightly-used disks (>2Tb), this
+	 value will latch at INT32_MAX (2147483647)."
     ::= { dskEntry 7 } 
 
 dskUsed OBJECT-TYPE
@@ -726,7 +739,9 @@
     MAX-ACCESS	read-only
     STATUS	current
     DESCRIPTION  
-	"Used space on the disk"
+	"Used space on the disk.
+	 For large heavily-used disks (>2Tb), this
+	 value will latch at INT32_MAX (2147483647)."
     ::= { dskEntry 8 } 
 
 dskPercent OBJECT-TYPE

=== modified file 'net-snmp-config.in'
--- net-snmp-config.in	2009-11-12 16:17:40 +0000
+++ net-snmp-config.in	2010-06-10 18:02:54 +0000
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-# $Id: net-snmp-config.in 17139 2008-07-30 17:28:08Z dts12 $
+# $Id: net-snmp-config.in 18651 2010-05-06 06:33:37Z bvassche $
 #
 # this shell script is designed to merely dump the configuration
 # information about how the net-snmp package was compiled.  The
@@ -94,6 +94,9 @@
     --default-mibdirs|--mibdirs|--MIBDIRS)
       echo @NETSNMP_DEFAULT_MIBDIRS@
       ;;
+    --env-separator)
+      echo "@ENV_SEPARATOR@"
+      ;;
     --snmpconfpath|--SNMPCONFPATH)
       echo "@SNMPCONFPATH@@ENV_SEPARATOR@@SNMPSHAREPATH@@ENV_SEPARATOR@@SNMPLIBPATH@@ENV_SEPARATOR@$HOME/.snmp@ENV_SEPARATOR@@PERSISTENT_DIRECTORY@"
       ;;

=== modified file 'perl/ASN/ASN.pm'
--- perl/ASN/ASN.pm	2009-11-12 16:17:40 +0000
+++ perl/ASN/ASN.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::ASN;
 
 use strict;
+use warnings;
 use Carp;
 
 require Exporter;
@@ -65,7 +66,7 @@
 	ASN_UNSIGNED
 	ASN_UNSIGNED64
 );
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 sub AUTOLOAD {
     # This AUTOLOAD is used to 'autoload' constants from the constant()

=== modified file 'perl/AnyData_SNMP/Format.pm'
--- perl/AnyData_SNMP/Format.pm	2004-09-13 12:06:21 +0000
+++ perl/AnyData_SNMP/Format.pm	2010-06-10 18:02:54 +0000
@@ -4,6 +4,7 @@
 #
 
 use strict;
+use warnings;
 use AnyData::Format::Base;
 use vars qw( @ISA );
 @AnyData::Format::SNMP::ISA = qw( AnyData::Format::Base );

=== modified file 'perl/AnyData_SNMP/Storage.pm'
--- perl/AnyData_SNMP/Storage.pm	2009-11-12 16:17:40 +0000
+++ perl/AnyData_SNMP/Storage.pm	2010-06-10 18:02:54 +0000
@@ -6,8 +6,9 @@
 ##   scalar sets?
 ##   multi-hosts
 
-$AnyData::Storage::VERSION = '5.04021';
+$AnyData::Storage::VERSION = '5.0403';
 use strict;
+use warnings;
 
 use vars qw(@basecols);
 

=== modified file 'perl/OID/OID.pm'
--- perl/OID/OID.pm	2009-11-12 16:17:40 +0000
+++ perl/OID/OID.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::OID;
 
 use strict;
+use warnings;
 use Carp;
 
 require Exporter;
@@ -91,7 +92,7 @@
 	snmp_oid_compare
         compare
 );
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 sub new {
     my $type = shift;
@@ -141,6 +142,8 @@
     return $self->{oidptr}->to_array();
 }
 
+sub DESTROY {}
+
 sub AUTOLOAD {
     # This AUTOLOAD is used to 'autoload' constants from the constant()
     # XS function.  If a constant is not found then control is passed

=== modified file 'perl/SNMP/SNMP.pm'
--- perl/SNMP/SNMP.pm	2009-11-12 16:17:40 +0000
+++ perl/SNMP/SNMP.pm	2010-06-10 18:02:54 +0000
@@ -7,7 +7,10 @@
 #     modify it under the same terms as Perl itself.
 
 package SNMP;
-$VERSION = '5.04021';   # current release version number
+$VERSION = '5.0403';   # current release version number
+
+use strict;
+use warnings;
 
 require Exporter;
 require DynaLoader;
@@ -46,11 +49,12 @@
 );
 
 sub AUTOLOAD {
+    no strict;
     # This AUTOLOAD is used to 'autoload' constants from the constant()
     # XS function.  If a constant is not found then control is passed
     # to the AUTOLOAD in AutoLoader.
     my($val,$pack,$file,$line);
-    local($constname);
+    my $constname;
     ($constname = $AUTOLOAD) =~ s/.*:://;
     # croak "&$module::constant not defined" if $constname eq 'constant';
     $val = constant($constname, @_ ? $_[0] : 0);
@@ -74,16 +78,23 @@
 # Preloaded methods go here.
 
 # Package variables
-tie $SNMP::debugging, SNMP::DEBUGGING;
-tie $SNMP::debug_internals, SNMP::DEBUG_INTERNALS;
-tie $SNMP::dump_packet, SNMP::DUMP_PACKET;
-tie %SNMP::MIB, SNMP::MIB;
-tie $SNMP::save_descriptions, SNMP::MIB::SAVE_DESCR;
-tie $SNMP::replace_newer, SNMP::MIB::REPLACE_NEWER;
-tie $SNMP::mib_options, SNMP::MIB::MIB_OPTIONS;
+tie $SNMP::debugging,         'SNMP::DEBUGGING';
+tie $SNMP::debug_internals,   'SNMP::DEBUG_INTERNALS';
+tie $SNMP::dump_packet,       'SNMP::DUMP_PACKET';
+tie %SNMP::MIB,               'SNMP::MIB';
+tie $SNMP::save_descriptions, 'SNMP::MIB::SAVE_DESCR';
+tie $SNMP::replace_newer,     'SNMP::MIB::REPLACE_NEWER';
+tie $SNMP::mib_options,       'SNMP::MIB::MIB_OPTIONS';
 
 %SNMP::V3_SEC_LEVEL_MAP = (noAuthNoPriv => 1, authNoPriv => 2, authPriv =>3);
 
+use vars qw(
+  $auto_init_mib $use_long_names $use_sprint_value $use_enums
+  $use_numeric %MIB $verbose $debugging $dump_packet $save_descriptions
+  $best_guess $non_increasing $replace_newer %session_params
+  $debug_internals $mib_options
+);
+
 $auto_init_mib = 1; # enable automatic MIB loading at session creation time
 $use_long_names = 0; # non-zero to prefer longer mib textual identifiers rather
                    # than just leaf indentifiers (see translateObj)
@@ -641,8 +652,6 @@
 }
 
 
-use strict;
-
 my $have_netsnmp_oid = eval { require NetSNMP::OID; };
 sub gettable {
 
@@ -912,7 +921,6 @@
 	}
     }
 }
-no strict;
 
 
 sub fget {
@@ -935,8 +943,8 @@
 
    SNMP::_get($this, $this->{RetryNoSuch}, $varbind_list_ref, $cb);
 
-   foreach $varbind (@$varbind_list_ref) {
-     $sub = $this->{VarFormats}{$varbind->[$SNMP::Varbind::tag_f]} ||
+   foreach my $varbind (@$varbind_list_ref) {
+     my $sub = $this->{VarFormats}{$varbind->[$SNMP::Varbind::tag_f]} ||
 	 $this->{TypeFormats}{$varbind->[$SNMP::Varbind::type_f]};
      &$sub($varbind) if defined $sub;
      push(@res, $varbind->[$SNMP::Varbind::val_f]);
@@ -988,8 +996,8 @@
 
    SNMP::_getnext($this, $varbind_list_ref, $cb);
 
-   foreach $varbind (@$varbind_list_ref) {
-     $sub = $this->{VarFormats}{$varbind->[$SNMP::Varbind::tag_f]} ||
+   foreach my $varbind (@$varbind_list_ref) {
+     my $sub = $this->{VarFormats}{$varbind->[$SNMP::Varbind::tag_f]} ||
 	 $this->{TypeFormats}{$varbind->[$SNMP::Varbind::type_f]};
      &$sub($varbind) if defined $sub;
      push(@res, $varbind->[$SNMP::Varbind::val_f]);
@@ -1068,7 +1076,7 @@
    return defined($cb) ? $res[0] : \@res;
 }
 
-%trap_type = (coldStart => 0, warmStart => 1, linkDown => 2, linkUp => 3,
+my %trap_type = (coldStart => 0, warmStart => 1, linkDown => 2, linkUp => 3,
 	      authFailure => 4, egpNeighborLoss => 5, specific => 6 );
 sub trap {
 # (v1) enterprise, agent, generic, specific, uptime, <vars>
@@ -1160,7 +1168,7 @@
 }
 
 package SNMP::TrapSession;
-@ISA = ('SNMP::Session');
+@SNMP::TrapSession::ISA = ('SNMP::Session');
 
 sub new {
    my $type = shift;
@@ -1175,11 +1183,11 @@
 
 package SNMP::Varbind;
 
-$tag_f = 0;
-$iid_f = 1;
-$val_f = 2;
-$type_f = 3;
-$time_f = 4;
+my $tag_f = 0;
+my $iid_f = 1;
+my $val_f = 2;
+my $type_f = 3;
+my $time_f = 4;
 
 sub new {
    my $type = shift;
@@ -1301,7 +1309,7 @@
     my $key = shift;
 
     if (!defined $this->{$key}) {
-	tie(%{$this->{$key}}, SNMP::MIB::NODE, $key) or return undef;
+	tie(%{$this->{$key}}, 'SNMP::MIB::NODE', $key) or return undef;
     }
     $this->{$key};
 }

=== modified file 'perl/SNMP/SNMP.xs'
--- perl/SNMP/SNMP.xs	2009-11-12 16:17:40 +0000
+++ perl/SNMP/SNMP.xs	2010-06-10 18:02:54 +0000
@@ -1396,6 +1396,8 @@
 
   case NETSNMP_CALLBACK_OP_TIMED_OUT:
     varlist_ref = &sv_undef;
+    sv_setpv(*err_str_svp, (char*)snmp_api_errstring(SNMPERR_TIMEOUT));
+    sv_setiv(*err_num_svp, SNMPERR_TIMEOUT);
     break;
   default:;
   } /* switch op */
@@ -2085,10 +2087,9 @@
       ** easy enough to do, and will avoid confusion for the caller from mis-
       ** behaving agents (badly misbehaving... ;^).
       */
-      if ((context->pkts_exch > 1) && (pix < context->repeaters)) {
+      if (context->pkts_exch > 1) {
 	 if (__oid_cmp(vars->name, vars->name_length,
-				   context->reqbase[pix].last_oid,
-				   context->reqbase[pix].last_len) <= 0)
+                       expect->last_oid, expect->last_len) <= 0)
 	 {
             if (check) 
             {
@@ -2115,12 +2116,10 @@
       ** variables in a completed request.  In order to maintain the correct
       ** ordering of which variables we expect to see in this packet, we must
       ** not set the ignore flags immediately.  It is done in bulkwalk_done().
-      ** XXX Can we use 'expect' instead of 'context->req_oids[pix]'?
       */
       if (context->oid_saved < context->non_reps) {
 	DBPRT(2, (DBOUT "   expected var %s (nonrepeater %d/%d)\n",
-		  __snprint_oid(context->req_oids[pix].req_oid,
-			 context->req_oids[pix].req_len),
+		  __snprint_oid(expect->req_oid, expect->req_len),
 		  pix, context->non_reps));
 	DBPRT(2, (DBOUT "   received var %s\n",
 		  __snprint_oid(vars->name, vars->name_length)));
@@ -2970,7 +2969,7 @@
         if (!strcmp(module,"ALL")) {
            read_all_mibs();
         } else {
-           read_module(module);
+           netsnmp_read_module(module);
         }
         if (get_tree_head()) {
            if (verbose) warn("Read %s\n", module);

=== modified file 'perl/SNMP/t/bulkwalk.t'
--- perl/SNMP/t/bulkwalk.t	2007-12-08 14:59:50 +0000
+++ perl/SNMP/t/bulkwalk.t	2010-06-10 18:02:54 +0000
@@ -1,6 +1,6 @@
 #!./perl
 #
-# $Id: bulkwalk.t 15551 2006-11-13 23:50:20Z tanders $
+# $Id: bulkwalk.t 17708 2009-07-27 12:06:25Z hardaker $
 #
 # Test bulkwalk functionality.
 
@@ -120,6 +120,9 @@
     # IRIX/HP-UX may have lo0 at the *end* of the interface list,
     # so just check for a non-empty string
     ok(($loopback ne ''));
+  } elsif ($^O eq 'freebsd') {
+    $loopback = $list[3][-1]->val;
+    ok(($loopback =~ /^lo/));
   } else {
     ok(($loopback =~ /^lo/));
   }
@@ -301,6 +304,9 @@
         # IRIX/HP-UX may have lo0 at the *end* of the interface list,
         # so just check for a non-empty string
         ok(($vbr->val ne ''));
+      } elsif ($^O eq 'freebsd') {
+        $vbr = $list->[3][-1];
+        ok(($vbr->val =~ /^lo/));
       } else {
         ok(($vbr->val =~ /^lo/));
       }

=== modified file 'perl/TrapReceiver/TrapReceiver.pm'
--- perl/TrapReceiver/TrapReceiver.pm	2009-11-12 16:17:40 +0000
+++ perl/TrapReceiver/TrapReceiver.pm	2010-06-10 18:02:54 +0000
@@ -47,7 +47,7 @@
 	NETSNMPTRAPD_PRE_HANDLER
 );
 
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 # sub new {
 #     my $type = shift;
@@ -135,6 +135,34 @@
 associated with it, and the value's numeric type (see NetSNMP::ASN for
 further details on SNMP typing information).
 
+Registered functions should return one of the following values:
+
+=over 2
+
+=item NETSNMPTRAPD_HANDLER_OK
+
+Handling the trap succeeded, but lets the snmptrapd demon check for
+further appropriate handlers.
+
+=item NETSNMPTRAPD_HANDLER_FAIL
+
+Handling the trap failed, but lets the snmptrapd demon check for
+further appropriate handlers.
+
+=item NETSNMPTRAPD_HANDLER_BREAK
+
+Stops evaluating the list of handlers for this specific trap, but lets
+the snmptrapd demon apply global handlers.
+
+=item NETSNMPTRAPD_HANDLER_FINISH
+
+Stops searching for further appropriate handlers.
+
+=back
+
+If a handler function does not return anything appropriate or even
+nothing at all, a return value of NETSNMPTRAPD_HANDLER_OK is assumed.
+
 Subroutines are registered using the NetSNMP::TrapReceiver::register
 function, which takes two arguments.  The first is a string describing
 the notification you want to register for (such as "linkUp" or
@@ -144,6 +172,7 @@
 no other handlers are called.  The "all" keyword indicates that the
 handler should ALWAYS be called for every notification.
 
+
 =head1 EXAMPLE
 
 As an example, put the following code into a file (say
@@ -157,7 +186,12 @@
       # print the PDU info (a hash reference)
       print "PDU INFO:\n";
       foreach my $k(keys(%{$_[0]})) {
-  	printf "  %-30s %s\n", $k, $_[0]{$k};
+        if ($k eq "securityEngineID" || $k eq "contextEngineID") {
+          printf "  %-30s 0x%s\n", $k, unpack('h*', $_[0]{$k});
+        }
+        else {
+          printf "  %-30s %s\n", $k, $_[0]{$k};
+        }
       }
 
       # print the variable bindings:

=== modified file 'perl/TrapReceiver/TrapReceiver.xs'
--- perl/TrapReceiver/TrapReceiver.xs	2009-11-12 16:17:40 +0000
+++ perl/TrapReceiver/TrapReceiver.xs	2010-06-10 18:02:54 +0000
@@ -39,6 +39,9 @@
     size_t ob_len = 0, oo_len = 0;
     AV *varbinds;
     HV *pduinfo;
+    int noValuesReturned;
+    int callingCFfailed = 0;
+    int result = NETSNMPTRAPD_HANDLER_OK;
 
     dSP;
     ENTER;
@@ -182,13 +185,42 @@
 
     /* actually call the callback function */
     if (SvTYPE(pcallback) == SVt_PVCV) {
-        perl_call_sv(pcallback, G_DISCARD);
+        noValuesReturned = perl_call_sv(pcallback, G_SCALAR);
         /* XXX: it discards the results, which isn't right */
     } else if (SvROK(pcallback) && SvTYPE(SvRV(pcallback)) == SVt_PVCV) {
         /* reference to code */
-        perl_call_sv(SvRV(pcallback), G_DISCARD);
+        noValuesReturned = perl_call_sv(SvRV(pcallback), G_SCALAR);
     } else {
         snmp_log(LOG_ERR, " tried to call a perl function but failed to understand its type: (ref = %x, svrok: %lu, SVTYPE: %lu)\n", (uintptr_t)pcallback, SvROK(pcallback), SvTYPE(pcallback));
+	callingCFfailed = 1;
+    }
+
+    if (!callingCFfailed) {
+      SPAGAIN;
+
+      if ( noValuesReturned == 0 ) {
+        snmp_log(LOG_WARNING, " perl callback function %x did not return a scalar, assuming %d (NETSNMPTRAPD_HANDLER_OK)\n", (uintptr_t)pcallback, NETSNMPTRAPD_HANDLER_OK);
+      }
+      else {
+	SV *rv = POPs;
+
+	if (SvTYPE(rv) != SVt_IV) {
+	  snmp_log(LOG_WARNING, " perl callback function %x returned a scalar of type %d instead of an integer, assuming %d (NETSNMPTRAPD_HANDLER_OK)\n", (uintptr_t)pcallback, SvTYPE(rv), NETSNMPTRAPD_HANDLER_OK);
+	}
+	else {
+	  int rvi = (IV)SvIVx(rv);
+
+	  if ((NETSNMPTRAPD_HANDLER_OK <= rvi) && (rvi <= NETSNMPTRAPD_HANDLER_FINISH)) {
+	    snmp_log(LOG_DEBUG, " perl callback function %x returns %d\n", (uintptr_t)pcallback, rvi);
+	    result = rvi;
+	  }
+	  else {
+	    snmp_log(LOG_WARNING, " perl callback function %x returned an invalid scalar integer value (%d), assuming %d (NETSNMPTRAPD_HANDLER_OK)\n", (uintptr_t)pcallback, rvi, NETSNMPTRAPD_HANDLER_OK);
+	  }
+	}
+      }
+
+      PUTBACK;
     }
 
 #ifdef DUMPIT
@@ -210,12 +242,9 @@
 #endif    
     free(tmparray);
 
-    /* Not needed because of the G_DISCARD flag (I think) */
-    /* SPAGAIN; */
-    /* PUTBACK; */
     FREETMPS;
     LEAVE;
-    return NETSNMPTRAPD_HANDLER_OK;
+    return result;
 }
 
 MODULE = NetSNMP::TrapReceiver		PACKAGE = NetSNMP::TrapReceiver		

=== modified file 'perl/TrapReceiver/const-c.inc'
--- perl/TrapReceiver/const-c.inc	2005-11-25 14:17:40 +0000
+++ perl/TrapReceiver/const-c.inc	2010-06-10 18:02:54 +0000
@@ -87,11 +87,11 @@
 	       NETSNMPTRAPD_HANDLER_OK NETSNMPTRAPD_POST_HANDLER
 	       NETSNMPTRAPD_PRE_HANDLER));
 
-print constant_types(); # macro defs
+print constant_types(), "\n"; # macro defs
 foreach (C_constant ("NetSNMP::TrapReceiver", 'constant', 'IV', $types, undef, 3, @names) ) {
     print $_, "\n"; # C constant subs
 }
-print "#### XS Section:\n";
+print "\n#### XS Section:\n";
 print XS_constant ("NetSNMP::TrapReceiver", $types);
 __END__
    */

=== modified file 'perl/TrapReceiver/const-xs.inc'
--- perl/TrapReceiver/const-xs.inc	2005-11-25 14:17:40 +0000
+++ perl/TrapReceiver/const-xs.inc	2010-06-10 18:02:54 +0000
@@ -22,12 +22,14 @@
            Second, if present, is found value */
         switch (type) {
         case PERL_constant_NOTFOUND:
-          sv = sv_2mortal(newSVpvf("%s is not a valid NetSNMP::TrapReceiver macro", s));
+          sv =
+	    sv_2mortal(newSVpvf("%s is not a valid NetSNMP::TrapReceiver macro", s));
           PUSHs(sv);
           break;
         case PERL_constant_NOTDEF:
           sv = sv_2mortal(newSVpvf(
-	    "Your vendor has not defined NetSNMP::TrapReceiver macro %s, used", s));
+	    "Your vendor has not defined NetSNMP::TrapReceiver macro %s, used",
+				   s));
           PUSHs(sv);
           break;
         case PERL_constant_ISIV:

=== modified file 'perl/agent/Support/Support.pm'
--- perl/agent/Support/Support.pm	2009-11-12 16:17:40 +0000
+++ perl/agent/Support/Support.pm	2010-06-10 18:02:54 +0000
@@ -26,9 +26,10 @@
 @ISA       = qw(Exporter getLeaf);
 @EXPORT    = qw(registerAgent getOidElement setOidElement);
 @EXPORT_OK = qw();
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 use strict;
+use warnings;
 
 BEGIN {
     print STDERR "Module SnmpAgent.pm loaded ok\n";

=== modified file 'perl/agent/agent.pm'
--- perl/agent/agent.pm	2009-11-12 16:17:40 +0000
+++ perl/agent/agent.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::agent;
 
 use strict;
+use warnings;
 use Carp;
 
 require Exporter;
@@ -86,7 +87,7 @@
 	SNMP_ERR_AUTHORIZATIONERROR
 	SNMP_ERR_NOTWRITABLE
 );
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 sub AUTOLOAD {
     # This AUTOLOAD is used to 'autoload' constants from the constant()

=== modified file 'perl/agent/agent.xs'
--- perl/agent/agent.xs	2009-11-12 16:17:40 +0000
+++ perl/agent/agent.xs	2010-06-10 18:02:54 +0000
@@ -13,6 +13,8 @@
 #define sv_undef PL_sv_undef
 #endif
 
+typedef netsnmp_handler_registration *NetSNMP__agent__netsnmp_handler_registration;
+
 typedef struct handler_cb_data_s {
    SV *perl_cb;
 } handler_cb_data;
@@ -397,7 +399,7 @@
         sv_setiv(arg, (IV) handler);
         XPUSHs(sv_2mortal(rarg));
         rarg = newSViv(0);
-        arg = newSVrv(rarg, "NetSNMP::agent::reginfo");
+        arg = newSVrv(rarg, "NetSNMP::agent::netsnmp_handler_registrationPtr");
         sv_setiv(arg, (IV) reginfo);
         XPUSHs(sv_2mortal(rarg));
         rarg = newSViv(0);
@@ -494,7 +496,7 @@
 
 MODULE = NetSNMP::agent  PACKAGE = NetSNMP::agent::netsnmp_handler_registration  PREFIX = nsahr_
 
-netsnmp_handler_registration *
+NetSNMP::agent::netsnmp_handler_registration
 nsahr_new(name, regoid, perlcallback)
         char *name;
 	char *regoid;
@@ -524,8 +526,6 @@
     OUTPUT:
         RETVAL
 
-MODULE = NetSNMP::agent  PACKAGE = netsnmp_handler_registrationPtr  PREFIX = nsahr_
-
 void
 nsahr_DESTROY(reginfo)
 	netsnmp_handler_registration *reginfo
@@ -549,6 +549,9 @@
     OUTPUT:
 	RETVAL
 
+
+MODULE = NetSNMP::agent PACKAGE = NetSNMP::agent::netsnmp_handler_registrationPtr PREFIX = nsahr_
+
 void
 nsahr_getRootOID(me)
     SV *me;
@@ -773,6 +776,8 @@
         netsnmp_request_info *request;
         u_long utmp;
         long ltmp;
+        uint64_t ulltmp;
+        struct counter64 c64;
 	oid myoid[MAX_OID_LEN];
 	size_t myoid_len;
         STRLEN stringlen;
@@ -828,7 +833,6 @@
 
           case ASN_UNSIGNED:
           case ASN_COUNTER:
-          case ASN_COUNTER64:
           case ASN_TIMETICKS:
 	      /* We want an integer here */
 	      if ((SvTYPE(value) == SVt_IV) || (SvTYPE(value) == SVt_PVMG) ||
@@ -862,6 +866,46 @@
 		break;
 	      }
 
+          case ASN_COUNTER64:
+	      /* We want an integer here */
+	      if ((SvTYPE(value) == SVt_IV) || (SvTYPE(value) == SVt_PVMG)) {
+		  /* Good - got a real one (or a blessed scalar which we have to hope will turn out OK) */
+		  ulltmp = SvIV(value);
+		  c64.high = (uint32_t)(ulltmp >> 32);
+		  c64.low  = (uint32_t)ulltmp;
+                  snmp_set_var_typed_value(request->requestvb, (u_char)type,
+                                       (u_char *) &c64, sizeof(struct counter64));
+		  RETVAL = 1;
+		  break;
+	      }
+	      else if (SvPOKp(value)) {
+	          /* Might be OK - got a string, so try to convert it, allowing base 10, octal, and hex forms */
+	          stringptr = SvPV(value, stringlen);
+#if defined(WIN32)
+		  ulltmp = strtoul(  stringptr, NULL, 0 );
+#else
+		  ulltmp = strtoull( stringptr, NULL, 0 );
+#endif
+		  if (errno == EINVAL) {
+		  	snmp_log(LOG_ERR, "Could not convert string to number in setValue: '%s'", stringptr);
+			RETVAL = 0;
+			break;
+		  }
+
+		  c64.high = (uint32_t)(ulltmp >> 32);
+		  c64.low  = (uint32_t)ulltmp;
+                  snmp_set_var_typed_value(request->requestvb, (u_char)type,
+                                       (u_char *) &c64, sizeof(struct counter64));
+		  RETVAL = 1;
+		  break;
+	      }
+	      else {
+		snmp_log(LOG_ERR, "Non-unsigned-integer value passed to setValue with ASN_COUNTER64: type was %d\n",
+			SvTYPE(value));
+		RETVAL = 0;
+		break;
+	      }
+
           case ASN_OCTET_STR:
           case ASN_BIT_STR:
 	      /* Check that we have been passed something with a string value (or a blessed scalar) */

=== modified file 'perl/agent/default_store/default_store.pm'
--- perl/agent/default_store/default_store.pm	2009-11-12 16:17:40 +0000
+++ perl/agent/default_store/default_store.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::agent::default_store;
 
 use strict;
+use warnings;
 use Carp;
 
 require Exporter;
@@ -95,7 +96,7 @@
 				   NETSNMP_DS_AGENT_MAX_GETBULKREPEATS
 				   NETSNMP_DS_AGENT_MAX_GETBULKRESPONSES
 );
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 sub AUTOLOAD {
     # This AUTOLOAD is used to 'autoload' constants from the constant()

=== modified file 'perl/agent/typemap'
--- perl/agent/typemap	2004-09-13 12:06:21 +0000
+++ perl/agent/typemap	2010-06-10 18:02:54 +0000
@@ -1,5 +1,6 @@
 TYPEMAP
 netsnmp_handler_registration *				T_PTROBJ
+NetSNMP::agent::netsnmp_handler_registration		T_PTROBJ
 netsnmp_request_info *					T_PTROBJ
 const char *						T_PV
 netsnmp_oid *						T_PTROBJ

=== modified file 'perl/default_store/default_store.pm'
--- perl/default_store/default_store.pm	2009-11-12 16:17:40 +0000
+++ perl/default_store/default_store.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::default_store;
 
 use strict;
+use warnings;
 use Carp;
 
 require Exporter;
@@ -199,7 +200,7 @@
 				   NETSNMP_DS_LIB_KSM_SERVICE_NAME
 				   NETSNMP_DS_LIB_SBSM_LOCAL_PWD
 );
-$VERSION = '5.04021';
+$VERSION = '5.0403';
 
 sub AUTOLOAD {
     # This AUTOLOAD is used to 'autoload' constants from the constant()

=== modified file 'perl/manager/manager.pm'
--- perl/manager/manager.pm	2006-07-06 11:44:44 +0000
+++ perl/manager/manager.pm	2010-06-10 18:02:54 +0000
@@ -1,6 +1,7 @@
 package NetSNMP::manager;
 
 use strict ();
+use warnings;
 use Apache::Constants qw(:common);
 use CGI qw(:standard delete_all);
 use SNMP ();

=== modified file 'python/netsnmp/client.py'
--- python/netsnmp/client.py	2009-11-12 16:17:40 +0000
+++ python/netsnmp/client.py	2010-06-10 18:02:54 +0000
@@ -28,6 +28,7 @@
         'Context':'',
         'Engineboots':0,
         'Enginetime':0,
+        'UseNumeric':0,
         }
     keys = kargs.keys()
     for key in keys:
@@ -51,7 +52,7 @@
         self.type = STR(type)
         # parse iid out of tag if needed
         if iid == None and tag != None:
-            regex = re.compile(r'^((?:\.\d+)+|(?:\.?\w+(?:\-*\w+)+)+)\.(\d*?)$')
+            regex = re.compile(r'^((?:\.\d+)+|(?:\w+(?:\-*\w+)+))\.?(.*)$')
             match = regex.match(tag)
             if match:
                 (self.tag, self.iid) = match.group(1,2)
@@ -234,8 +235,6 @@
                 var_list.append(arg)
             else:
                 var_list.append(Varbind(arg))
-    for var in var_list:
-        print "  ",var.tag, var.iid, "=", var.val, '(',var.type,')'
     res = sess.walk(var_list)
     return res
     

=== modified file 'python/netsnmp/client_intf.c'
--- python/netsnmp/client_intf.c	2009-11-12 16:17:40 +0000
+++ python/netsnmp/client_intf.c	2010-06-10 18:02:54 +0000
@@ -39,6 +39,32 @@
 
 #define STRLEN(x) (x ? strlen(x) : 0)
 
+/* from perl/SNMP/perlsnmp.h: */
+#ifndef timeradd
+#define	timeradd(a, b, result)						      \
+  do {									      \
+    (result)->tv_sec = (a)->tv_sec + (b)->tv_sec;			      \
+    (result)->tv_usec = (a)->tv_usec + (b)->tv_usec;			      \
+    if ((result)->tv_usec >= 1000000)					      \
+      {									      \
+	++(result)->tv_sec;						      \
+	(result)->tv_usec -= 1000000;					      \
+      }									      \
+  } while (0)
+#endif
+
+#ifndef timersub
+#define	timersub(a, b, result)						      \
+  do {									      \
+    (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;			      \
+    (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;			      \
+    if ((result)->tv_usec < 0) {					      \
+      --(result)->tv_sec;						      \
+      (result)->tv_usec += 1000000;					      \
+    }									      \
+  } while (0)
+#endif
+
 typedef netsnmp_session SnmpSession;
 typedef struct tree SnmpMibNode;
 static void __recalc_timeout (struct timeval*,struct timeval*,
@@ -1081,26 +1107,28 @@
   return PyObject_CallFunction(callable, "");
 }
 
-static char *
-py_netsnmp_attr_string(PyObject *obj, char * attr_name)
+static int
+py_netsnmp_attr_string(PyObject *obj, char * attr_name, char **val,
+    Py_ssize_t *len)
 {
-  char *val = NULL;
-
+  *val = NULL;
   if (obj && attr_name && PyObject_HasAttrString(obj, attr_name)) {
     PyObject *attr = PyObject_GetAttrString(obj, attr_name);
     if (attr) {
-      val = PyString_AsString(attr);
+      int retval;
+      retval = PyString_AsStringAndSize(attr, val, len);
       Py_DECREF(attr);
+      return retval;
     }
   }
 
-  return val;
+  return -1;
 }
 
-static long
+static long long
 py_netsnmp_attr_long(PyObject *obj, char * attr_name)
 {
-  long val = -1;
+  long long val = -1;
 
   if (obj && attr_name  && PyObject_HasAttrString(obj, attr_name)) {
     PyObject *attr = PyObject_GetAttrString(obj, attr_name);
@@ -1196,7 +1224,7 @@
       printf("error:snmp_new_session: Couldn't open SNMP session");
   }
  end:
-  return Py_BuildValue("i", (int)ss);
+  return Py_BuildValue("L", (long long)ss);
 }
 
 static PyObject *
@@ -1232,6 +1260,7 @@
     return NULL;
 
   __libraries_init("python");
+  snmp_sess_init(&session);
 
   if (version == 3) {
     session.version = SNMP_VERSION_3;
@@ -1330,7 +1359,7 @@
     }
   }
   
-  ss = snmp_open(&session);
+  ss = snmp_sess_open(&session);
 
  end:
   if (ss == NULL) {
@@ -1395,6 +1424,8 @@
   int err_ind;
   int err_num;
   char err_str[STR_BUF_SIZE];
+  char *tmpstr;
+  Py_ssize_t tmplen;
 	   
   oid_arr = calloc(MAX_OID_LEN, sizeof(oid));
 
@@ -1406,7 +1437,10 @@
 
     ss = (SnmpSession *)py_netsnmp_attr_long(session, "sess_ptr");
 
-    strcpy(err_str, py_netsnmp_attr_string(session, "ErrorStr"));
+    if (py_netsnmp_attr_string(session, "ErrorStr", &tmpstr, &tmplen) < 0) {
+      goto done;
+    }
+    memcpy(&err_str, tmpstr, tmplen);
     err_num = py_netsnmp_attr_long(session, "ErrorNum");
     err_ind = py_netsnmp_attr_long(session, "ErrorInd");
 
@@ -1427,12 +1461,13 @@
       PyObject *varlist_iter = PyObject_GetIter(varlist);
 
       while (varlist_iter && (varbind = PyIter_Next(varlist_iter))) {
-	tag = py_netsnmp_attr_string(varbind, "tag");
-	iid = py_netsnmp_attr_string(varbind, "iid");
-
-
-	tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, 
-		       NULL, best_guess);
+	if (py_netsnmp_attr_string(varbind, "tag", &tag, NULL) < 0 ||
+	    py_netsnmp_attr_string(varbind, "iid", &iid, NULL) < 0)
+	{
+	  oid_arr_len = 0;
+	} else {
+	  tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, NULL, best_guess);
+	}
 
 	if (oid_arr_len) {
 	  snmp_add_null_var(pdu, oid_arr, oid_arr_len);
@@ -1600,6 +1635,8 @@
   int err_ind;
   int err_num;
   char err_str[STR_BUF_SIZE];
+  char *tmpstr;
+  Py_ssize_t tmplen;
 	   
   oid_arr = calloc(MAX_OID_LEN, sizeof(oid));
 
@@ -1611,7 +1648,10 @@
 
     ss = (SnmpSession *)py_netsnmp_attr_long(session, "sess_ptr");
 
-    strcpy(err_str, py_netsnmp_attr_string(session, "ErrorStr"));
+    if (py_netsnmp_attr_string(session, "ErrorStr", &tmpstr, &tmplen) < 0) {
+      goto done;
+    }
+    memcpy(&err_str, tmpstr, tmplen);
     err_num = py_netsnmp_attr_long(session, "ErrorNum");
     err_ind = py_netsnmp_attr_long(session, "ErrorInd");
 
@@ -1632,11 +1672,13 @@
       PyObject *varlist_iter = PyObject_GetIter(varlist);
 
       while (varlist_iter && (varbind = PyIter_Next(varlist_iter))) {
-	tag = py_netsnmp_attr_string(varbind, "tag");
-	iid = py_netsnmp_attr_string(varbind, "iid");
-
-	tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, 
-		       NULL, best_guess);
+	if (py_netsnmp_attr_string(varbind, "tag", &tag, NULL) < 0 ||
+	    py_netsnmp_attr_string(varbind, "iid", &iid, NULL) < 0)
+	{
+	  oid_arr_len = 0;
+	} else {
+	  tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, NULL, best_guess);
+	}
 
 	if (_debug_level) 
 	  printf("netsnmp_getnext: filling request: %s:%s:%d:%d\n", 
@@ -1779,7 +1821,7 @@
   PyObject *varlist_iter;
   PyObject *varbind;
   PyObject *val_tuple = NULL;
-  PyObject *varbinds;
+  PyObject *varbinds  = NULL;
   int varlist_len = 0;
   int varlist_ind;
   netsnmp_session *ss;
@@ -1809,6 +1851,8 @@
   char err_str[STR_BUF_SIZE];
   int notdone = 1;
   int result_count = 0;
+  char *tmpstr;
+  Py_ssize_t tmplen;
 	   
   oid_arr = calloc(MAX_OID_LEN, sizeof(oid));
 
@@ -1827,7 +1871,10 @@
     }
     ss = (SnmpSession *)py_netsnmp_attr_long(session, "sess_ptr");
 
-    strcpy(err_str, py_netsnmp_attr_string(session, "ErrorStr"));
+    if (py_netsnmp_attr_string(session, "ErrorStr", &tmpstr, &tmplen) < 0) {
+      goto done;
+    }
+    memcpy(&err_str, tmpstr, tmplen);
     err_num = py_netsnmp_attr_long(session, "ErrorNum");
     err_ind = py_netsnmp_attr_long(session, "ErrorInd");
 
@@ -1848,11 +1895,13 @@
     
     /* get the initial starting oids*/
     while (varlist_iter && (varbind = PyIter_Next(varlist_iter))) {
-      tag = py_netsnmp_attr_string(varbind, "tag");
-      iid = py_netsnmp_attr_string(varbind, "iid");
-
-      tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, 
-      	       NULL, best_guess);
+      if (py_netsnmp_attr_string(varbind, "tag", &tag, NULL) < 0 ||
+         py_netsnmp_attr_string(varbind, "iid", &iid, NULL) < 0)
+      {
+        oid_arr_len = 0;
+      } else {
+        tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, NULL, best_guess);
+      }
 
       if (_debug_level) 
 	printf("netsnmp_walk: filling request: %s:%s:%d:%d\n", 
@@ -2004,7 +2053,6 @@
 			  (len ? Py_BuildValue("s#", str_buf, len) :
 			   Py_BuildValue("")));
             
-    	  Py_DECREF(varbind);
 
           } else {
 	    /* Return None for this variable. */
@@ -2012,6 +2060,7 @@
 	    PyTuple_SetItem(val_tuple, result_count++, Py_BuildValue(""));
 	    printf("netsnmp_walk: bad varbind (%d)\n", varlist_ind);
           }	
+          Py_XDECREF(varbind);
         }
         /* reuse the response as the next pdu to send */
         pdu = snmp_pdu_create(SNMP_MSG_GETNEXT);
@@ -2037,6 +2086,7 @@
   }
 
  done:
+  Py_XDECREF(varbinds);
   SAFE_FREE(oid_arr);
   return (val_tuple ? val_tuple : Py_BuildValue(""));
 }
@@ -2079,6 +2129,8 @@
   int err_ind;
   int err_num;
   char err_str[STR_BUF_SIZE];
+  char *tmpstr;
+  Py_ssize_t tmplen;
 	   
   oid_arr = calloc(MAX_OID_LEN, sizeof(oid));
 
@@ -2093,7 +2145,10 @@
       
       ss = (SnmpSession *)py_netsnmp_attr_long(session, "sess_ptr");
 
-      strcpy(err_str, py_netsnmp_attr_string(session, "ErrorStr"));
+      if (py_netsnmp_attr_string(session, "ErrorStr", &tmpstr, &tmplen) < 0) {
+        goto done;
+      }
+      memcpy(&err_str, tmpstr, tmplen);
       err_num = py_netsnmp_attr_long(session, "ErrorNum");
       err_ind = py_netsnmp_attr_long(session, "ErrorInd");
 
@@ -2116,11 +2171,13 @@
       varbinds_iter = PyObject_GetIter(varbinds);
 
       while (varbinds_iter && (varbind = PyIter_Next(varbinds_iter))) {
-	tag = py_netsnmp_attr_string(varbind, "tag");
-	iid = py_netsnmp_attr_string(varbind, "iid");
-
-	tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, 
-		       NULL, best_guess);
+        if (py_netsnmp_attr_string(varbind, "tag", &tag, NULL) < 0 ||
+          py_netsnmp_attr_string(varbind, "iid", &iid, NULL) < 0)
+        {
+          oid_arr_len = 0;
+        } else {
+          tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, NULL, best_guess);
+        }
 
 	if (oid_arr_len) {
 	  snmp_add_null_var(pdu, oid_arr, oid_arr_len);
@@ -2303,6 +2360,8 @@
   int err_ind;
   int err_num;
   char err_str[STR_BUF_SIZE];
+  char *tmpstr;
+  Py_ssize_t tmplen;
 	   
   oid_arr = calloc(MAX_OID_LEN, sizeof(oid));
 
@@ -2315,7 +2374,10 @@
     ss = (SnmpSession *)py_netsnmp_attr_long(session, "sess_ptr");
 
     /* PyObject_SetAttrString(); */
-    strcpy(err_str, py_netsnmp_attr_string(session, "ErrorStr"));
+    if (py_netsnmp_attr_string(session, "ErrorStr", &tmpstr, &tmplen) < 0) {
+      goto done;
+    }
+    memcpy(&err_str, tmpstr, tmplen);
     err_num = py_netsnmp_attr_long(session, "ErrorNum");
     err_ind = py_netsnmp_attr_long(session, "ErrorInd");
 
@@ -2329,11 +2391,13 @@
       PyObject *varlist_iter = PyObject_GetIter(varlist);
 
       while (varlist_iter && (varbind = PyIter_Next(varlist_iter))) {
-	tag = py_netsnmp_attr_string(varbind, "tag");
-	iid = py_netsnmp_attr_string(varbind, "iid");
-
-	tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, 
-		       &type, best_guess);
+        if (py_netsnmp_attr_string(varbind, "tag", &tag, NULL) < 0 ||
+          py_netsnmp_attr_string(varbind, "iid", &iid, NULL) < 0)
+        {
+          oid_arr_len = 0;
+        } else {
+          tp = __tag2oid(tag, iid, oid_arr, &oid_arr_len, &type, best_guess);
+        }
 
 	if (oid_arr_len==0) {
 	  if (verbose)
@@ -2344,7 +2408,10 @@
 	}
 
 	if (type == TYPE_UNKNOWN) {
-	  type_str = py_netsnmp_attr_string(varbind, "type");
+	  if (py_netsnmp_attr_string(varbind, "type", &type_str, NULL) < 0) {
+	    snmp_free_pdu(pdu);
+	    goto done;
+	  }
 	  type = __translate_appl_type(type_str);
 	  if (type == TYPE_UNKNOWN) {
 	    if (verbose)
@@ -2354,8 +2421,11 @@
 	  }
 	}
 
-	val = py_netsnmp_attr_string(varbind, "val");
-	strcpy(tmp_val_str, val);
+	if (py_netsnmp_attr_string(varbind, "val", &val, &tmplen) < 0) {
+	  snmp_free_pdu(pdu);
+	  goto done;
+	}
+	memcpy(tmp_val_str, val, tmplen);
 	if (type==TYPE_INTEGER && use_enums && tp && tp->enums) {
 	  for(ep = tp->enums; ep; ep = ep->next) {
 	    if (val && !strcmp(ep->label, val)) {
@@ -2364,7 +2434,7 @@
 	    }
 	  }
 	}
-	len = STRLEN(tmp_val_str);
+	len = (int)tmplen;
 	status = __add_var_val_str(pdu, oid_arr, oid_arr_len,
 				tmp_val_str, len, type);
 

=== modified file 'sedscript.in'
--- sedscript.in	2009-11-12 16:17:40 +0000
+++ sedscript.in	2010-06-10 18:02:54 +0000
@@ -100,4 +100,4 @@
 
 s#PREMOVEMESCMD#PSCMD#g
 s#AREMOVEMEGENTX_SOCKET#AGENTX_SOCKET#g
-s/VERSIONINFO/5.4.2/g
+s/VERSIONINFO/5.4.3.pre1/g

=== modified file 'snmplib/Makefile.depend'
--- snmplib/Makefile.depend	2009-11-12 16:17:40 +0000
+++ snmplib/Makefile.depend	2010-06-10 18:02:54 +0000
@@ -5,8 +5,9 @@
 ./asn1.lo: ../include/net-snmp/system/sysv.h
 ./asn1.lo: ../include/net-snmp/system/generic.h
 ./asn1.lo: ../include/net-snmp/machine/generic.h 
-./asn1.lo: ../include/net-snmp/output_api.h ../include/net-snmp/types.h
-./asn1.lo: ../include/net-snmp/definitions.h
+./asn1.lo:  ../include/net-snmp/output_api.h
+./asn1.lo: ../include/net-snmp/types.h 
+./asn1.lo:  ../include/net-snmp/definitions.h
 ./asn1.lo: ../include/net-snmp/library/snmp_api.h
 ./asn1.lo: ../include/net-snmp/library/asn1.h
 ./asn1.lo: ../include/net-snmp/library/snmp_impl.h
@@ -38,8 +39,8 @@
 ./callback.lo: ../include/net-snmp/system/sysv.h
 ./callback.lo: ../include/net-snmp/system/generic.h
 ./callback.lo: ../include/net-snmp/machine/generic.h 
-./callback.lo: ../include/net-snmp/types.h 
-./callback.lo: ../include/net-snmp/definitions.h
+./callback.lo:  ../include/net-snmp/types.h
+./callback.lo:  ../include/net-snmp/definitions.h
 ./callback.lo: ../include/net-snmp/library/snmp_api.h
 ./callback.lo: ../include/net-snmp/library/asn1.h
 ./callback.lo: ../include/net-snmp/library/snmp_impl.h
@@ -73,7 +74,7 @@
 ./check_varbind.lo: ../include/net-snmp/system/generic.h
 ./check_varbind.lo: ../include/net-snmp/machine/generic.h
 ./check_varbind.lo: ../include/net-snmp/net-snmp-includes.h
-./check_varbind.lo:  ../include/net-snmp/definitions.h
+./check_varbind.lo: ../include/net-snmp/definitions.h
 ./check_varbind.lo: ../include/net-snmp/types.h 
 ./check_varbind.lo: ../include/net-snmp/library/snmp_api.h
 ./check_varbind.lo: ../include/net-snmp/library/asn1.h
@@ -138,71 +139,6 @@
 ./cmu_compat.lo: ../include/net-snmp/system/sysv.h
 ./cmu_compat.lo: ../include/net-snmp/system/generic.h
 ./cmu_compat.lo: ../include/net-snmp/machine/generic.h
-./container.lo: ../include/net-snmp/net-snmp-config.h
-./container.lo: ../include/net-snmp/system/linux.h
-./container.lo: ../include/net-snmp/system/sysv.h
-./container.lo: ../include/net-snmp/system/generic.h
-./container.lo: ../include/net-snmp/machine/generic.h
-./container.lo: ../include/net-snmp/net-snmp-includes.h 
-./container.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
-./container.lo: ../include/net-snmp/library/snmp_api.h
-./container.lo: ../include/net-snmp/library/asn1.h
-./container.lo: ../include/net-snmp/library/snmp_impl.h
-./container.lo: ../include/net-snmp/library/snmp.h
-./container.lo: ../include/net-snmp/library/snmp-tc.h
-./container.lo: ../include/net-snmp/utilities.h
-./container.lo: ../include/net-snmp/library/snmp_client.h
-./container.lo: ../include/net-snmp/library/system.h
-./container.lo: ../include/net-snmp/library/tools.h
-./container.lo: ../include/net-snmp/library/int64.h
-./container.lo: ../include/net-snmp/library/mt_support.h
-./container.lo: ../include/net-snmp/library/snmp_alarm.h
-./container.lo: ../include/net-snmp/library/callback.h
-./container.lo: ../include/net-snmp/library/data_list.h
-./container.lo: ../include/net-snmp/library/oid_stash.h
-./container.lo: ../include/net-snmp/library/check_varbind.h
-./container.lo: ../include/net-snmp/library/container.h
-./container.lo: ../include/net-snmp/library/factory.h
-./container.lo: ../include/net-snmp/library/snmp_logging.h
-./container.lo: ../include/net-snmp/library/container_binary_array.h
-./container.lo: ../include/net-snmp/library/container_list_ssll.h
-./container.lo: ../include/net-snmp/library/container_iterator.h
-./container.lo: ../include/net-snmp/library/container.h
-./container.lo: ../include/net-snmp/library/snmp_assert.h
-./container.lo: ../include/net-snmp/version.h
-./container.lo: ../include/net-snmp/session_api.h
-./container.lo: ../include/net-snmp/library/snmp_transport.h
-./container.lo: ../include/net-snmp/library/snmp_service.h
-./container.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./container.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./container.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./container.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./container.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./container.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./container.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./container.lo: ../include/net-snmp/library/ucd_compat.h
-./container.lo: ../include/net-snmp/pdu_api.h ../include/net-snmp/mib_api.h
-./container.lo: ../include/net-snmp/library/mib.h
-./container.lo: ../include/net-snmp/library/parse.h
-./container.lo: ../include/net-snmp/varbind_api.h
-./container.lo: ../include/net-snmp/config_api.h
-./container.lo: ../include/net-snmp/library/read_config.h
-./container.lo: ../include/net-snmp/library/default_store.h
-./container.lo: ../include/net-snmp/library/snmp_parse_args.h
-./container.lo: ../include/net-snmp/library/snmp_enum.h
-./container.lo: ../include/net-snmp/library/vacm.h
-./container.lo: ../include/net-snmp/output_api.h
-./container.lo: ../include/net-snmp/library/snmp_debug.h
-./container.lo: ../include/net-snmp/snmpv3_api.h
-./container.lo: ../include/net-snmp/library/snmpv3.h
-./container.lo: ../include/net-snmp/library/transform_oids.h
-./container.lo: ../include/net-snmp/library/keytools.h
-./container.lo: ../include/net-snmp/library/scapi.h
-./container.lo: ../include/net-snmp/library/lcd_time.h
-./container.lo: ../include/net-snmp/library/snmp_secmod.h
-./container.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./container.lo: ../include/net-snmp/library/snmpusm.h
-./container.lo: ../include/net-snmp/library/container_null.h
 ./container_binary_array.lo: ../include/net-snmp/net-snmp-config.h
 ./container_binary_array.lo: ../include/net-snmp/system/linux.h
 ./container_binary_array.lo: ../include/net-snmp/system/sysv.h
@@ -269,6 +205,72 @@
 ./container_binary_array.lo: ../include/net-snmp/library/snmp_secmod.h
 ./container_binary_array.lo: ../include/net-snmp/library/snmpv3-security-includes.h
 ./container_binary_array.lo: ../include/net-snmp/library/snmpusm.h
+./container.lo: ../include/net-snmp/net-snmp-config.h
+./container.lo: ../include/net-snmp/system/linux.h
+./container.lo: ../include/net-snmp/system/sysv.h
+./container.lo: ../include/net-snmp/system/generic.h
+./container.lo: ../include/net-snmp/machine/generic.h
+./container.lo: ../include/net-snmp/net-snmp-includes.h 
+./container.lo:  ../include/net-snmp/definitions.h
+./container.lo: ../include/net-snmp/types.h 
+./container.lo: ../include/net-snmp/library/snmp_api.h
+./container.lo: ../include/net-snmp/library/asn1.h
+./container.lo: ../include/net-snmp/library/snmp_impl.h
+./container.lo: ../include/net-snmp/library/snmp.h
+./container.lo: ../include/net-snmp/library/snmp-tc.h
+./container.lo: ../include/net-snmp/utilities.h
+./container.lo: ../include/net-snmp/library/snmp_client.h
+./container.lo: ../include/net-snmp/library/system.h
+./container.lo: ../include/net-snmp/library/tools.h
+./container.lo: ../include/net-snmp/library/int64.h
+./container.lo: ../include/net-snmp/library/mt_support.h
+./container.lo: ../include/net-snmp/library/snmp_alarm.h
+./container.lo: ../include/net-snmp/library/callback.h
+./container.lo: ../include/net-snmp/library/data_list.h
+./container.lo: ../include/net-snmp/library/oid_stash.h
+./container.lo: ../include/net-snmp/library/check_varbind.h
+./container.lo: ../include/net-snmp/library/container.h
+./container.lo: ../include/net-snmp/library/factory.h
+./container.lo: ../include/net-snmp/library/snmp_logging.h
+./container.lo: ../include/net-snmp/library/container_binary_array.h
+./container.lo: ../include/net-snmp/library/container_list_ssll.h
+./container.lo: ../include/net-snmp/library/container_iterator.h
+./container.lo: ../include/net-snmp/library/container.h
+./container.lo: ../include/net-snmp/library/snmp_assert.h
+./container.lo: ../include/net-snmp/version.h
+./container.lo: ../include/net-snmp/session_api.h
+./container.lo: ../include/net-snmp/library/snmp_transport.h
+./container.lo: ../include/net-snmp/library/snmp_service.h
+./container.lo: ../include/net-snmp/library/snmpCallbackDomain.h
+./container.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./container.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./container.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./container.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./container.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
+./container.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./container.lo: ../include/net-snmp/library/ucd_compat.h
+./container.lo: ../include/net-snmp/pdu_api.h ../include/net-snmp/mib_api.h
+./container.lo: ../include/net-snmp/library/mib.h
+./container.lo: ../include/net-snmp/library/parse.h
+./container.lo: ../include/net-snmp/varbind_api.h
+./container.lo: ../include/net-snmp/config_api.h
+./container.lo: ../include/net-snmp/library/read_config.h
+./container.lo: ../include/net-snmp/library/default_store.h
+./container.lo: ../include/net-snmp/library/snmp_parse_args.h
+./container.lo: ../include/net-snmp/library/snmp_enum.h
+./container.lo: ../include/net-snmp/library/vacm.h
+./container.lo: ../include/net-snmp/output_api.h
+./container.lo: ../include/net-snmp/library/snmp_debug.h
+./container.lo: ../include/net-snmp/snmpv3_api.h
+./container.lo: ../include/net-snmp/library/snmpv3.h
+./container.lo: ../include/net-snmp/library/transform_oids.h
+./container.lo: ../include/net-snmp/library/keytools.h
+./container.lo: ../include/net-snmp/library/scapi.h
+./container.lo: ../include/net-snmp/library/lcd_time.h
+./container.lo: ../include/net-snmp/library/snmp_secmod.h
+./container.lo: ../include/net-snmp/library/snmpv3-security-includes.h
+./container.lo: ../include/net-snmp/library/snmpusm.h
+./container.lo: ../include/net-snmp/library/container_null.h
 ./container_iterator.lo: ../include/net-snmp/net-snmp-config.h
 ./container_iterator.lo: ../include/net-snmp/system/linux.h
 ./container_iterator.lo: ../include/net-snmp/system/sysv.h
@@ -474,7 +476,8 @@
 ./data_list.lo: ../include/net-snmp/system/generic.h
 ./data_list.lo: ../include/net-snmp/machine/generic.h
 ./data_list.lo: ../include/net-snmp/net-snmp-includes.h 
-./data_list.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
+./data_list.lo:  ../include/net-snmp/definitions.h
+./data_list.lo: ../include/net-snmp/types.h 
 ./data_list.lo: ../include/net-snmp/library/snmp_api.h
 ./data_list.lo: ../include/net-snmp/library/asn1.h
 ./data_list.lo: ../include/net-snmp/library/snmp_impl.h
@@ -709,19 +712,33 @@
 ./inet_ntop.lo: ../include/net-snmp/system/linux.h
 ./inet_ntop.lo: ../include/net-snmp/system/sysv.h
 ./inet_ntop.lo: ../include/net-snmp/system/generic.h
-./inet_ntop.lo: ../include/net-snmp/machine/generic.h
+./inet_ntop.lo: ../include/net-snmp/machine/generic.h 
+./inet_ntop.lo:  ../include/net-snmp/types.h
+./inet_ntop.lo: ../include/net-snmp/definitions.h
+./inet_ntop.lo: ../include/net-snmp/library/snmp_api.h
+./inet_ntop.lo: ../include/net-snmp/library/asn1.h
+./inet_ntop.lo: ../include/net-snmp/library/snmp_impl.h
+./inet_ntop.lo: ../include/net-snmp/library/snmp.h
+./inet_ntop.lo: ../include/net-snmp/library/snmp-tc.h
 ./inet_pton.lo: ../include/net-snmp/net-snmp-config.h
 ./inet_pton.lo: ../include/net-snmp/system/linux.h
 ./inet_pton.lo: ../include/net-snmp/system/sysv.h
 ./inet_pton.lo: ../include/net-snmp/system/generic.h
-./inet_pton.lo: ../include/net-snmp/machine/generic.h
+./inet_pton.lo: ../include/net-snmp/machine/generic.h 
+./inet_pton.lo: ../include/net-snmp/types.h 
+./inet_pton.lo: ../include/net-snmp/definitions.h
+./inet_pton.lo: ../include/net-snmp/library/snmp_api.h
+./inet_pton.lo: ../include/net-snmp/library/asn1.h
+./inet_pton.lo: ../include/net-snmp/library/snmp_impl.h
+./inet_pton.lo: ../include/net-snmp/library/snmp.h
+./inet_pton.lo: ../include/net-snmp/library/snmp-tc.h
 ./int64.lo: ../include/net-snmp/net-snmp-config.h
 ./int64.lo: ../include/net-snmp/system/linux.h
 ./int64.lo: ../include/net-snmp/system/sysv.h
 ./int64.lo: ../include/net-snmp/system/generic.h
 ./int64.lo: ../include/net-snmp/machine/generic.h 
 ./int64.lo:  ../include/net-snmp/types.h
-./int64.lo: ../include/net-snmp/definitions.h
+./int64.lo:  ../include/net-snmp/definitions.h
 ./int64.lo: ../include/net-snmp/library/snmp_api.h
 ./int64.lo: ../include/net-snmp/library/asn1.h
 ./int64.lo: ../include/net-snmp/library/snmp_impl.h
@@ -736,8 +753,8 @@
 ./keytools.lo: ../include/net-snmp/system/sysv.h
 ./keytools.lo: ../include/net-snmp/system/generic.h
 ./keytools.lo: ../include/net-snmp/machine/generic.h 
-./keytools.lo:  ../include/net-snmp/types.h
-./keytools.lo: ../include/net-snmp/definitions.h
+./keytools.lo: ../include/net-snmp/types.h 
+./keytools.lo:  ../include/net-snmp/definitions.h
 ./keytools.lo: ../include/net-snmp/library/snmp_api.h
 ./keytools.lo: ../include/net-snmp/library/asn1.h
 ./keytools.lo: ../include/net-snmp/library/snmp_impl.h
@@ -764,7 +781,7 @@
 ./keytools.lo: ../include/net-snmp/library/container_iterator.h
 ./keytools.lo: ../include/net-snmp/library/container.h
 ./keytools.lo: ../include/net-snmp/library/snmp_assert.h
-./keytools.lo: ../include/net-snmp/version.h
+./keytools.lo: ../include/net-snmp/version.h 
 ./keytools.lo: ../include/net-snmp/library/scapi.h
 ./keytools.lo: ../include/net-snmp/library/keytools.h
 ./keytools.lo: ../include/net-snmp/library/transform_oids.h
@@ -773,8 +790,8 @@
 ./lcd_time.lo: ../include/net-snmp/system/sysv.h
 ./lcd_time.lo: ../include/net-snmp/system/generic.h
 ./lcd_time.lo: ../include/net-snmp/machine/generic.h 
-./lcd_time.lo: ../include/net-snmp/types.h 
-./lcd_time.lo: ../include/net-snmp/definitions.h
+./lcd_time.lo:  ../include/net-snmp/types.h
+./lcd_time.lo:  ../include/net-snmp/definitions.h
 ./lcd_time.lo: ../include/net-snmp/library/snmp_api.h
 ./lcd_time.lo: ../include/net-snmp/library/asn1.h
 ./lcd_time.lo: ../include/net-snmp/library/snmp_impl.h
@@ -814,7 +831,8 @@
 ./md5.lo: ../include/net-snmp/system/sysv.h
 ./md5.lo: ../include/net-snmp/system/generic.h
 ./md5.lo: ../include/net-snmp/machine/generic.h 
-./md5.lo: ../include/net-snmp/utilities.h ../include/net-snmp/types.h
+./md5.lo:  ../include/net-snmp/utilities.h
+./md5.lo: ../include/net-snmp/types.h 
 ./md5.lo: ../include/net-snmp/definitions.h
 ./md5.lo: ../include/net-snmp/library/snmp_api.h
 ./md5.lo: ../include/net-snmp/library/asn1.h
@@ -892,8 +910,7 @@
 ./oid_stash.lo: ../include/net-snmp/system/generic.h
 ./oid_stash.lo: ../include/net-snmp/machine/generic.h 
 ./oid_stash.lo:  ../include/net-snmp/net-snmp-includes.h
-./oid_stash.lo:  ../include/net-snmp/definitions.h
-./oid_stash.lo: ../include/net-snmp/types.h 
+./oid_stash.lo: ../include/net-snmp/definitions.h ../include/net-snmp/types.h
 ./oid_stash.lo: ../include/net-snmp/library/snmp_api.h
 ./oid_stash.lo: ../include/net-snmp/library/asn1.h
 ./oid_stash.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1080,35 +1097,6 @@
 ./scapi.lo: ../include/net-snmp/library/scapi.h
 ./scapi.lo: ../include/net-snmp/library/mib.h
 ./scapi.lo: ../include/net-snmp/library/transform_oids.h
-./snmp-tc.lo: ../include/net-snmp/net-snmp-config.h
-./snmp-tc.lo: ../include/net-snmp/system/linux.h
-./snmp-tc.lo: ../include/net-snmp/system/sysv.h
-./snmp-tc.lo: ../include/net-snmp/system/generic.h
-./snmp-tc.lo: ../include/net-snmp/machine/generic.h 
-./snmp-tc.lo:  ../include/net-snmp/types.h
-./snmp-tc.lo:  ../include/net-snmp/definitions.h
-./snmp-tc.lo: ../include/net-snmp/library/snmp_api.h
-./snmp-tc.lo: ../include/net-snmp/library/asn1.h
-./snmp-tc.lo: ../include/net-snmp/library/snmp_impl.h
-./snmp-tc.lo: ../include/net-snmp/library/snmp.h
-./snmp-tc.lo: ../include/net-snmp/library/snmp-tc.h
-./snmp.lo: ../include/net-snmp/net-snmp-config.h
-./snmp.lo: ../include/net-snmp/system/linux.h
-./snmp.lo: ../include/net-snmp/system/sysv.h
-./snmp.lo: ../include/net-snmp/system/generic.h
-./snmp.lo: ../include/net-snmp/machine/generic.h 
-./snmp.lo: ../include/net-snmp/types.h 
-./snmp.lo:  ../include/net-snmp/definitions.h
-./snmp.lo: ../include/net-snmp/library/snmp_api.h
-./snmp.lo: ../include/net-snmp/library/asn1.h
-./snmp.lo: ../include/net-snmp/library/snmp_impl.h
-./snmp.lo: ../include/net-snmp/library/snmp.h
-./snmp.lo: ../include/net-snmp/library/snmp-tc.h
-./snmp.lo: ../include/net-snmp/output_api.h
-./snmp.lo: ../include/net-snmp/library/snmp_client.h
-./snmp.lo: ../include/net-snmp/library/snmp_debug.h
-./snmp.lo: ../include/net-snmp/library/snmp_logging.h 
-./snmp.lo: ../include/net-snmp/library/mib.h
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/net-snmp-config.h
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/system/linux.h
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/system/sysv.h
@@ -1133,218 +1121,12 @@
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/library/vacm.h
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/library/snmp_transport.h
 ./snmpAAL5PVCDomain.lo: ../include/net-snmp/library/snmpAAL5PVCDomain.h
-./snmpCallbackDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpCallbackDomain.lo: ../include/net-snmp/system/linux.h
-./snmpCallbackDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpCallbackDomain.lo: ../include/net-snmp/system/generic.h
-./snmpCallbackDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpCallbackDomain.lo: ../include/net-snmp/types.h 
-./snmpCallbackDomain.lo: ../include/net-snmp/definitions.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpCallbackDomain.lo: ../include/net-snmp/output_api.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpCallbackDomain.lo: ../include/net-snmp/config_api.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/read_config.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/default_store.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/vacm.h
-./snmpCallbackDomain.lo: ../include/net-snmp/utilities.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/system.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/tools.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/int64.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/mt_support.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/callback.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/data_list.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/oid_stash.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/check_varbind.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/container.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/factory.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/container_binary_array.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/container_iterator.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/container.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_assert.h
-./snmpCallbackDomain.lo: ../include/net-snmp/version.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./snmpCallbackDomain.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./snmpIPXDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpIPXDomain.lo: ../include/net-snmp/system/linux.h
-./snmpIPXDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpIPXDomain.lo: ../include/net-snmp/system/generic.h
-./snmpIPXDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpIPXDomain.lo: ../include/net-snmp/types.h 
-./snmpIPXDomain.lo:  ../include/net-snmp/definitions.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpIPXDomain.lo: ../include/net-snmp/output_api.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpIPXDomain.lo: ../include/net-snmp/config_api.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/read_config.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/default_store.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/vacm.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpIPXDomain.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./snmpSTDDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpSTDDomain.lo: ../include/net-snmp/system/linux.h
-./snmpSTDDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpSTDDomain.lo: ../include/net-snmp/system/generic.h
-./snmpSTDDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpSTDDomain.lo: ../include/net-snmp/types.h 
-./snmpSTDDomain.lo: ../include/net-snmp/definitions.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpSTDDomain.lo: ../include/net-snmp/output_api.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/snmpSTDDomain.h
-./snmpSTDDomain.lo: ../include/net-snmp/library/tools.h
-./snmpTCPDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpTCPDomain.lo: ../include/net-snmp/system/linux.h
-./snmpTCPDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpTCPDomain.lo: ../include/net-snmp/system/generic.h
-./snmpTCPDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpTCPDomain.lo:  ../include/net-snmp/types.h
-./snmpTCPDomain.lo: ../include/net-snmp/definitions.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpTCPDomain.lo: ../include/net-snmp/output_api.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmpTCPDomain.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/linux.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/sysv.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/generic.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/machine/generic.h
-./snmpTCPIPv6Domain.lo:  ../include/net-snmp/types.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/definitions.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/asn1.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/output_api.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/config_api.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/read_config.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/default_store.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/vacm.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./snmpUDPDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpUDPDomain.lo: ../include/net-snmp/system/linux.h
-./snmpUDPDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpUDPDomain.lo: ../include/net-snmp/system/generic.h
-./snmpUDPDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpUDPDomain.lo: ../include/net-snmp/types.h 
-./snmpUDPDomain.lo:  ../include/net-snmp/definitions.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpUDPDomain.lo: ../include/net-snmp/output_api.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpUDPDomain.lo: ../include/net-snmp/config_api.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/read_config.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/default_store.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/vacm.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/system.h
-./snmpUDPDomain.lo: ../include/net-snmp/library/tools.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/linux.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/sysv.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/generic.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/machine/generic.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/types.h 
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/definitions.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/asn1.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/output_api.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/config_api.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/read_config.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/default_store.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/vacm.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmpUnixDomain.lo: ../include/net-snmp/net-snmp-config.h
-./snmpUnixDomain.lo: ../include/net-snmp/system/linux.h
-./snmpUnixDomain.lo: ../include/net-snmp/system/sysv.h
-./snmpUnixDomain.lo: ../include/net-snmp/system/generic.h
-./snmpUnixDomain.lo: ../include/net-snmp/machine/generic.h
-./snmpUnixDomain.lo: ../include/net-snmp/types.h 
-./snmpUnixDomain.lo: ../include/net-snmp/definitions.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_api.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/asn1.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpUnixDomain.lo: ../include/net-snmp/output_api.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_client.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpUnixDomain.lo: ../include/net-snmp/config_api.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/read_config.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/default_store.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/vacm.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmpUnixDomain.lo: ../include/net-snmp/library/snmpUnixDomain.h
 ./snmp_alarm.lo: ../include/net-snmp/net-snmp-config.h
 ./snmp_alarm.lo: ../include/net-snmp/system/linux.h
 ./snmp_alarm.lo: ../include/net-snmp/system/sysv.h
 ./snmp_alarm.lo: ../include/net-snmp/system/generic.h
 ./snmp_alarm.lo: ../include/net-snmp/machine/generic.h 
-./snmp_alarm.lo: ../include/net-snmp/types.h 
+./snmp_alarm.lo:  ../include/net-snmp/types.h
 ./snmp_alarm.lo: ../include/net-snmp/definitions.h
 ./snmp_alarm.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_alarm.lo: ../include/net-snmp/library/asn1.h
@@ -1435,8 +1217,8 @@
 ./snmp_auth.lo: ../include/net-snmp/system/sysv.h
 ./snmp_auth.lo: ../include/net-snmp/system/generic.h
 ./snmp_auth.lo: ../include/net-snmp/machine/generic.h 
-./snmp_auth.lo:  ../include/net-snmp/types.h
-./snmp_auth.lo:  ../include/net-snmp/definitions.h
+./snmp_auth.lo: ../include/net-snmp/types.h 
+./snmp_auth.lo: ../include/net-snmp/definitions.h
 ./snmp_auth.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_auth.lo: ../include/net-snmp/library/asn1.h
 ./snmp_auth.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1467,13 +1249,73 @@
 ./snmp_auth.lo: ../include/net-snmp/library/mib.h
 ./snmp_auth.lo: ../include/net-snmp/library/md5.h
 ./snmp_auth.lo: ../include/net-snmp/library/scapi.h
+./snmp.lo: ../include/net-snmp/net-snmp-config.h
+./snmp.lo: ../include/net-snmp/system/linux.h
+./snmp.lo: ../include/net-snmp/system/sysv.h
+./snmp.lo: ../include/net-snmp/system/generic.h
+./snmp.lo: ../include/net-snmp/machine/generic.h 
+./snmp.lo:  ../include/net-snmp/types.h
+./snmp.lo: ../include/net-snmp/definitions.h
+./snmp.lo: ../include/net-snmp/library/snmp_api.h
+./snmp.lo: ../include/net-snmp/library/asn1.h
+./snmp.lo: ../include/net-snmp/library/snmp_impl.h
+./snmp.lo: ../include/net-snmp/library/snmp.h
+./snmp.lo: ../include/net-snmp/library/snmp-tc.h
+./snmp.lo: ../include/net-snmp/output_api.h
+./snmp.lo: ../include/net-snmp/library/snmp_client.h
+./snmp.lo: ../include/net-snmp/library/snmp_debug.h
+./snmp.lo: ../include/net-snmp/library/snmp_logging.h 
+./snmp.lo: ../include/net-snmp/library/mib.h
+./snmpCallbackDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpCallbackDomain.lo: ../include/net-snmp/system/linux.h
+./snmpCallbackDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpCallbackDomain.lo: ../include/net-snmp/system/generic.h
+./snmpCallbackDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpCallbackDomain.lo: ../include/net-snmp/types.h 
+./snmpCallbackDomain.lo: ../include/net-snmp/definitions.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpCallbackDomain.lo: ../include/net-snmp/output_api.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpCallbackDomain.lo: ../include/net-snmp/config_api.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/read_config.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/default_store.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/vacm.h
+./snmpCallbackDomain.lo: ../include/net-snmp/utilities.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/system.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/tools.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/int64.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/mt_support.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_alarm.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/callback.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/data_list.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/oid_stash.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/check_varbind.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/container.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/factory.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/container_binary_array.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/container_list_ssll.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/container_iterator.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/container.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_assert.h
+./snmpCallbackDomain.lo: ../include/net-snmp/version.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmpUnixDomain.h
+./snmpCallbackDomain.lo: ../include/net-snmp/library/snmpCallbackDomain.h
 ./snmp_client.lo: ../include/net-snmp/net-snmp-config.h
 ./snmp_client.lo: ../include/net-snmp/system/linux.h
 ./snmp_client.lo: ../include/net-snmp/system/sysv.h
 ./snmp_client.lo: ../include/net-snmp/system/generic.h
 ./snmp_client.lo: ../include/net-snmp/machine/generic.h 
-./snmp_client.lo:  ../include/net-snmp/types.h
-./snmp_client.lo:  ../include/net-snmp/definitions.h
+./snmp_client.lo: ../include/net-snmp/types.h 
+./snmp_client.lo: ../include/net-snmp/definitions.h
 ./snmp_client.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_client.lo: ../include/net-snmp/library/asn1.h
 ./snmp_client.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1532,7 +1374,7 @@
 ./snmp_enum.lo: ../include/net-snmp/system/generic.h
 ./snmp_enum.lo: ../include/net-snmp/machine/generic.h 
 ./snmp_enum.lo:  ../include/net-snmp/types.h
-./snmp_enum.lo: ../include/net-snmp/definitions.h
+./snmp_enum.lo:  ../include/net-snmp/definitions.h
 ./snmp_enum.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_enum.lo: ../include/net-snmp/library/asn1.h
 ./snmp_enum.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1545,13 +1387,84 @@
 ./snmp_enum.lo: ../include/net-snmp/library/snmp_enum.h
 ./snmp_enum.lo: ../include/net-snmp/library/vacm.h
 ./snmp_enum.lo: ../include/net-snmp/library/tools.h
+./snmpIPXDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpIPXDomain.lo: ../include/net-snmp/system/linux.h
+./snmpIPXDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpIPXDomain.lo: ../include/net-snmp/system/generic.h
+./snmpIPXDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpIPXDomain.lo:  ../include/net-snmp/types.h
+./snmpIPXDomain.lo: ../include/net-snmp/definitions.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpIPXDomain.lo: ../include/net-snmp/output_api.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpIPXDomain.lo: ../include/net-snmp/config_api.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/read_config.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/default_store.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/vacm.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpIPXDomain.lo: ../include/net-snmp/library/snmpIPXDomain.h
+./snmpksm.lo: ../include/net-snmp/net-snmp-config.h
+./snmpksm.lo: ../include/net-snmp/system/linux.h
+./snmpksm.lo: ../include/net-snmp/system/sysv.h
+./snmpksm.lo: ../include/net-snmp/system/generic.h
+./snmpksm.lo: ../include/net-snmp/machine/generic.h 
+./snmpksm.lo:  ../include/net-snmp/output_api.h
+./snmpksm.lo: ../include/net-snmp/types.h 
+./snmpksm.lo: ../include/net-snmp/definitions.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_api.h
+./snmpksm.lo: ../include/net-snmp/library/asn1.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpksm.lo: ../include/net-snmp/library/snmp.h
+./snmpksm.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_client.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpksm.lo: ../include/net-snmp/config_api.h
+./snmpksm.lo: ../include/net-snmp/library/read_config.h
+./snmpksm.lo: ../include/net-snmp/library/default_store.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpksm.lo: ../include/net-snmp/library/vacm.h
+./snmpksm.lo: ../include/net-snmp/utilities.h 
+./snmpksm.lo: ../include/net-snmp/library/system.h
+./snmpksm.lo: ../include/net-snmp/library/tools.h
+./snmpksm.lo: ../include/net-snmp/library/int64.h
+./snmpksm.lo: ../include/net-snmp/library/mt_support.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_alarm.h
+./snmpksm.lo: ../include/net-snmp/library/callback.h
+./snmpksm.lo: ../include/net-snmp/library/data_list.h
+./snmpksm.lo: ../include/net-snmp/library/oid_stash.h
+./snmpksm.lo: ../include/net-snmp/library/check_varbind.h
+./snmpksm.lo: ../include/net-snmp/library/container.h
+./snmpksm.lo: ../include/net-snmp/library/factory.h
+./snmpksm.lo: ../include/net-snmp/library/container_binary_array.h
+./snmpksm.lo: ../include/net-snmp/library/container_list_ssll.h
+./snmpksm.lo: ../include/net-snmp/library/container_iterator.h
+./snmpksm.lo: ../include/net-snmp/library/container.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_assert.h
+./snmpksm.lo: ../include/net-snmp/version.h
+./snmpksm.lo: ../include/net-snmp/library/keytools.h
+./snmpksm.lo: ../include/net-snmp/library/snmpv3.h
+./snmpksm.lo: ../include/net-snmp/library/lcd_time.h
+./snmpksm.lo: ../include/net-snmp/library/scapi.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_secmod.h
+./snmpksm.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpksm.lo: ../include/net-snmp/library/snmpksm.h
 ./snmp_logging.lo: ../include/net-snmp/net-snmp-config.h
 ./snmp_logging.lo: ../include/net-snmp/system/linux.h
 ./snmp_logging.lo: ../include/net-snmp/system/sysv.h
 ./snmp_logging.lo: ../include/net-snmp/system/generic.h
 ./snmp_logging.lo: ../include/net-snmp/machine/generic.h 
-./snmp_logging.lo: ../include/net-snmp/types.h 
-./snmp_logging.lo: ../include/net-snmp/definitions.h
+./snmp_logging.lo:  ../include/net-snmp/types.h
+./snmp_logging.lo:  ../include/net-snmp/definitions.h
 ./snmp_logging.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_logging.lo: ../include/net-snmp/library/asn1.h
 ./snmp_logging.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1590,7 +1503,7 @@
 ./snmp_parse_args.lo: ../include/net-snmp/system/sysv.h
 ./snmp_parse_args.lo: ../include/net-snmp/system/generic.h
 ./snmp_parse_args.lo: ../include/net-snmp/machine/generic.h
-./snmp_parse_args.lo:  ../include/net-snmp/types.h
+./snmp_parse_args.lo: ../include/net-snmp/types.h 
 ./snmp_parse_args.lo: ../include/net-snmp/definitions.h
 ./snmp_parse_args.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_parse_args.lo: ../include/net-snmp/library/asn1.h
@@ -1637,7 +1550,7 @@
 ./snmp_secmod.lo: ../include/net-snmp/system/generic.h
 ./snmp_secmod.lo: ../include/net-snmp/machine/generic.h 
 ./snmp_secmod.lo:  ../include/net-snmp/types.h
-./snmp_secmod.lo: ../include/net-snmp/definitions.h
+./snmp_secmod.lo:  ../include/net-snmp/definitions.h
 ./snmp_secmod.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_secmod.lo: ../include/net-snmp/library/asn1.h
 ./snmp_secmod.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1680,7 +1593,7 @@
 ./snmp_service.lo: ../include/net-snmp/system/generic.h
 ./snmp_service.lo: ../include/net-snmp/machine/generic.h
 ./snmp_service.lo: ../include/net-snmp/net-snmp-includes.h
-./snmp_service.lo: ../include/net-snmp/definitions.h
+./snmp_service.lo:  ../include/net-snmp/definitions.h
 ./snmp_service.lo: ../include/net-snmp/types.h 
 ./snmp_service.lo: ../include/net-snmp/library/snmp_api.h
 ./snmp_service.lo: ../include/net-snmp/library/asn1.h
@@ -1740,6 +1653,82 @@
 ./snmp_service.lo: ../include/net-snmp/library/snmp_secmod.h
 ./snmp_service.lo: ../include/net-snmp/library/snmpv3-security-includes.h
 ./snmp_service.lo: ../include/net-snmp/library/snmpusm.h
+./snmpSTDDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpSTDDomain.lo: ../include/net-snmp/system/linux.h
+./snmpSTDDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpSTDDomain.lo: ../include/net-snmp/system/generic.h
+./snmpSTDDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpSTDDomain.lo: ../include/net-snmp/types.h 
+./snmpSTDDomain.lo: ../include/net-snmp/definitions.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpSTDDomain.lo: ../include/net-snmp/output_api.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/snmpSTDDomain.h
+./snmpSTDDomain.lo: ../include/net-snmp/library/tools.h
+./snmp-tc.lo: ../include/net-snmp/net-snmp-config.h
+./snmp-tc.lo: ../include/net-snmp/system/linux.h
+./snmp-tc.lo: ../include/net-snmp/system/sysv.h
+./snmp-tc.lo: ../include/net-snmp/system/generic.h
+./snmp-tc.lo: ../include/net-snmp/machine/generic.h 
+./snmp-tc.lo: ../include/net-snmp/types.h 
+./snmp-tc.lo: ../include/net-snmp/definitions.h
+./snmp-tc.lo: ../include/net-snmp/library/snmp_api.h
+./snmp-tc.lo: ../include/net-snmp/library/asn1.h
+./snmp-tc.lo: ../include/net-snmp/library/snmp_impl.h
+./snmp-tc.lo: ../include/net-snmp/library/snmp.h
+./snmp-tc.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpTCPDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpTCPDomain.lo: ../include/net-snmp/system/linux.h
+./snmpTCPDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpTCPDomain.lo: ../include/net-snmp/system/generic.h
+./snmpTCPDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpTCPDomain.lo: ../include/net-snmp/types.h 
+./snmpTCPDomain.lo:  ../include/net-snmp/definitions.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpTCPDomain.lo: ../include/net-snmp/output_api.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmpTCPDomain.lo: ../include/net-snmp/library/snmpTCPDomain.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/linux.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/sysv.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/system/generic.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/machine/generic.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/types.h 
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/definitions.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/asn1.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/output_api.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/config_api.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/read_config.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/default_store.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/vacm.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./snmpTCPIPv6Domain.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
 ./snmp_transport.lo: ../include/net-snmp/net-snmp-config.h
 ./snmp_transport.lo: ../include/net-snmp/system/linux.h
 ./snmp_transport.lo: ../include/net-snmp/system/sysv.h
@@ -1782,132 +1771,88 @@
 ./snmp_transport.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
 ./snmp_transport.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
 ./snmp_transport.lo: ../include/net-snmp/library/snmp_service.h
-./snmp_version.lo: ../include/net-snmp/net-snmp-config.h
-./snmp_version.lo: ../include/net-snmp/system/linux.h
-./snmp_version.lo: ../include/net-snmp/system/sysv.h
-./snmp_version.lo: ../include/net-snmp/system/generic.h
-./snmp_version.lo: ../include/net-snmp/machine/generic.h
-./snmp_version.lo: ../include/net-snmp/version.h
-./snmpksm.lo: ../include/net-snmp/net-snmp-config.h
-./snmpksm.lo: ../include/net-snmp/system/linux.h
-./snmpksm.lo: ../include/net-snmp/system/sysv.h
-./snmpksm.lo: ../include/net-snmp/system/generic.h
-./snmpksm.lo: ../include/net-snmp/machine/generic.h 
-./snmpksm.lo:  ../include/net-snmp/output_api.h
-./snmpksm.lo: ../include/net-snmp/types.h 
-./snmpksm.lo: ../include/net-snmp/definitions.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_api.h
-./snmpksm.lo: ../include/net-snmp/library/asn1.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_impl.h
-./snmpksm.lo: ../include/net-snmp/library/snmp.h
-./snmpksm.lo: ../include/net-snmp/library/snmp-tc.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_client.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_debug.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_logging.h
-./snmpksm.lo: ../include/net-snmp/config_api.h
-./snmpksm.lo: ../include/net-snmp/library/read_config.h
-./snmpksm.lo: ../include/net-snmp/library/default_store.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_enum.h
-./snmpksm.lo: ../include/net-snmp/library/vacm.h
-./snmpksm.lo: ../include/net-snmp/utilities.h 
-./snmpksm.lo: ../include/net-snmp/library/system.h
-./snmpksm.lo: ../include/net-snmp/library/tools.h
-./snmpksm.lo: ../include/net-snmp/library/int64.h
-./snmpksm.lo: ../include/net-snmp/library/mt_support.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmpksm.lo: ../include/net-snmp/library/callback.h
-./snmpksm.lo: ../include/net-snmp/library/data_list.h
-./snmpksm.lo: ../include/net-snmp/library/oid_stash.h
-./snmpksm.lo: ../include/net-snmp/library/check_varbind.h
-./snmpksm.lo: ../include/net-snmp/library/container.h
-./snmpksm.lo: ../include/net-snmp/library/factory.h
-./snmpksm.lo: ../include/net-snmp/library/container_binary_array.h
-./snmpksm.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmpksm.lo: ../include/net-snmp/library/container_iterator.h
-./snmpksm.lo: ../include/net-snmp/library/container.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_assert.h
-./snmpksm.lo: ../include/net-snmp/version.h
-./snmpksm.lo: ../include/net-snmp/library/keytools.h
-./snmpksm.lo: ../include/net-snmp/library/snmpv3.h
-./snmpksm.lo: ../include/net-snmp/library/lcd_time.h
-./snmpksm.lo: ../include/net-snmp/library/scapi.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_secmod.h
-./snmpksm.lo: ../include/net-snmp/library/snmp_transport.h
-./snmpksm.lo: ../include/net-snmp/library/snmpksm.h
-./snmplocalsm.lo: ../include/net-snmp/net-snmp-config.h
-./snmplocalsm.lo: ../include/net-snmp/system/linux.h
-./snmplocalsm.lo: ../include/net-snmp/system/sysv.h
-./snmplocalsm.lo: ../include/net-snmp/system/generic.h
-./snmplocalsm.lo: ../include/net-snmp/machine/generic.h
-./snmplocalsm.lo: ../include/net-snmp/net-snmp-includes.h
-./snmplocalsm.lo:  ../include/net-snmp/definitions.h
-./snmplocalsm.lo: ../include/net-snmp/types.h 
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/asn1.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_impl.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp-tc.h
-./snmplocalsm.lo: ../include/net-snmp/utilities.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_client.h
-./snmplocalsm.lo: ../include/net-snmp/library/system.h
-./snmplocalsm.lo: ../include/net-snmp/library/tools.h
-./snmplocalsm.lo: ../include/net-snmp/library/int64.h
-./snmplocalsm.lo: ../include/net-snmp/library/mt_support.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_alarm.h
-./snmplocalsm.lo: ../include/net-snmp/library/callback.h
-./snmplocalsm.lo: ../include/net-snmp/library/data_list.h
-./snmplocalsm.lo: ../include/net-snmp/library/oid_stash.h
-./snmplocalsm.lo: ../include/net-snmp/library/check_varbind.h
-./snmplocalsm.lo: ../include/net-snmp/library/container.h
-./snmplocalsm.lo: ../include/net-snmp/library/factory.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_logging.h
-./snmplocalsm.lo: ../include/net-snmp/library/container_binary_array.h
-./snmplocalsm.lo: ../include/net-snmp/library/container_list_ssll.h
-./snmplocalsm.lo: ../include/net-snmp/library/container_iterator.h
-./snmplocalsm.lo: ../include/net-snmp/library/container.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_assert.h
-./snmplocalsm.lo: ../include/net-snmp/version.h
-./snmplocalsm.lo: ../include/net-snmp/session_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_transport.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_service.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpCallbackDomain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpUnixDomain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpUDPDomain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpTCPDomain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpTCPIPv6Domain.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpIPXDomain.h
-./snmplocalsm.lo: ../include/net-snmp/library/ucd_compat.h
-./snmplocalsm.lo: ../include/net-snmp/pdu_api.h ../include/net-snmp/mib_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/mib.h
-./snmplocalsm.lo: ../include/net-snmp/library/parse.h
-./snmplocalsm.lo: ../include/net-snmp/varbind_api.h
-./snmplocalsm.lo: ../include/net-snmp/config_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/read_config.h
-./snmplocalsm.lo: ../include/net-snmp/library/default_store.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_parse_args.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_enum.h
-./snmplocalsm.lo: ../include/net-snmp/library/vacm.h
-./snmplocalsm.lo: ../include/net-snmp/output_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_debug.h
-./snmplocalsm.lo: ../include/net-snmp/snmpv3_api.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpv3.h
-./snmplocalsm.lo: ../include/net-snmp/library/transform_oids.h
-./snmplocalsm.lo: ../include/net-snmp/library/keytools.h
-./snmplocalsm.lo: ../include/net-snmp/library/scapi.h
-./snmplocalsm.lo: ../include/net-snmp/library/lcd_time.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmp_secmod.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpv3-security-includes.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmpusm.h
-./snmplocalsm.lo: ../include/net-snmp/library/snmplocalsm.h
+./snmpUDPDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpUDPDomain.lo: ../include/net-snmp/system/linux.h
+./snmpUDPDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpUDPDomain.lo: ../include/net-snmp/system/generic.h
+./snmpUDPDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpUDPDomain.lo:  ../include/net-snmp/types.h
+./snmpUDPDomain.lo: ../include/net-snmp/definitions.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpUDPDomain.lo: ../include/net-snmp/output_api.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpUDPDomain.lo: ../include/net-snmp/config_api.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/read_config.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/default_store.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/vacm.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/system.h
+./snmpUDPDomain.lo: ../include/net-snmp/library/tools.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/linux.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/sysv.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/system/generic.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/machine/generic.h
+./snmpUDPIPv6Domain.lo:  ../include/net-snmp/types.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/definitions.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/asn1.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/output_api.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/config_api.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/read_config.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/default_store.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/vacm.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpUDPIPv6Domain.lo: ../include/net-snmp/library/snmpUDPIPv6Domain.h
+./snmpUnixDomain.lo: ../include/net-snmp/net-snmp-config.h
+./snmpUnixDomain.lo: ../include/net-snmp/system/linux.h
+./snmpUnixDomain.lo: ../include/net-snmp/system/sysv.h
+./snmpUnixDomain.lo: ../include/net-snmp/system/generic.h
+./snmpUnixDomain.lo: ../include/net-snmp/machine/generic.h
+./snmpUnixDomain.lo: ../include/net-snmp/types.h 
+./snmpUnixDomain.lo:  ../include/net-snmp/definitions.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_api.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/asn1.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_impl.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp-tc.h
+./snmpUnixDomain.lo: ../include/net-snmp/output_api.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_client.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_debug.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_logging.h
+./snmpUnixDomain.lo: ../include/net-snmp/config_api.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/read_config.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/default_store.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_parse_args.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_enum.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/vacm.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmp_transport.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmpUDPDomain.h
+./snmpUnixDomain.lo: ../include/net-snmp/library/snmpUnixDomain.h
 ./snmpusm.lo: ../include/net-snmp/net-snmp-config.h
 ./snmpusm.lo: ../include/net-snmp/system/linux.h
 ./snmpusm.lo: ../include/net-snmp/system/sysv.h
 ./snmpusm.lo: ../include/net-snmp/system/generic.h
 ./snmpusm.lo: ../include/net-snmp/machine/generic.h 
-./snmpusm.lo: ../include/net-snmp/types.h 
-./snmpusm.lo: ../include/net-snmp/definitions.h
+./snmpusm.lo:  ../include/net-snmp/types.h
+./snmpusm.lo:  ../include/net-snmp/definitions.h
 ./snmpusm.lo: ../include/net-snmp/library/snmp_api.h
 ./snmpusm.lo: ../include/net-snmp/library/asn1.h
 ./snmpusm.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1953,8 +1898,8 @@
 ./snmpv3.lo: ../include/net-snmp/system/sysv.h
 ./snmpv3.lo: ../include/net-snmp/system/generic.h
 ./snmpv3.lo: ../include/net-snmp/machine/generic.h 
-./snmpv3.lo:  ../include/net-snmp/types.h
-./snmpv3.lo:  ../include/net-snmp/definitions.h
+./snmpv3.lo: ../include/net-snmp/types.h 
+./snmpv3.lo: ../include/net-snmp/definitions.h
 ./snmpv3.lo: ../include/net-snmp/library/snmp_api.h
 ./snmpv3.lo: ../include/net-snmp/library/asn1.h
 ./snmpv3.lo: ../include/net-snmp/library/snmp_impl.h
@@ -1996,6 +1941,12 @@
 ./snmpv3.lo: ../include/net-snmp/library/snmp_transport.h
 ./snmpv3.lo: ../include/net-snmp/library/snmpusm.h
 ./snmpv3.lo: ../include/net-snmp/library/transform_oids.h
+./snmp_version.lo: ../include/net-snmp/net-snmp-config.h
+./snmp_version.lo: ../include/net-snmp/system/linux.h
+./snmp_version.lo: ../include/net-snmp/system/sysv.h
+./snmp_version.lo: ../include/net-snmp/system/generic.h
+./snmp_version.lo: ../include/net-snmp/machine/generic.h
+./snmp_version.lo: ../include/net-snmp/version.h
 ./snprintf.lo: ../include/net-snmp/net-snmp-config.h
 ./snprintf.lo: ../include/net-snmp/system/linux.h
 ./snprintf.lo: ../include/net-snmp/system/sysv.h
@@ -2021,13 +1972,26 @@
 ./strtoul.lo: ../include/net-snmp/system/sysv.h
 ./strtoul.lo: ../include/net-snmp/system/generic.h
 ./strtoul.lo: ../include/net-snmp/machine/generic.h
+./strtoull.lo: ../include/net-snmp/net-snmp-config.h
+./strtoull.lo: ../include/net-snmp/system/linux.h
+./strtoull.lo: ../include/net-snmp/system/sysv.h
+./strtoull.lo: ../include/net-snmp/system/generic.h
+./strtoull.lo: ../include/net-snmp/machine/generic.h 
+./strtoull.lo: ../include/net-snmp/types.h 
+./strtoull.lo:  ../include/net-snmp/definitions.h
+./strtoull.lo: ../include/net-snmp/library/snmp_api.h
+./strtoull.lo: ../include/net-snmp/library/asn1.h
+./strtoull.lo: ../include/net-snmp/library/snmp_impl.h
+./strtoull.lo: ../include/net-snmp/library/snmp.h
+./strtoull.lo: ../include/net-snmp/library/snmp-tc.h
+./strtoull.lo: ../include/net-snmp/library/system.h
 ./system.lo: ../include/net-snmp/net-snmp-config.h
 ./system.lo: ../include/net-snmp/system/linux.h
 ./system.lo: ../include/net-snmp/system/sysv.h
 ./system.lo: ../include/net-snmp/system/generic.h
 ./system.lo: ../include/net-snmp/machine/generic.h 
-./system.lo:  ../include/net-snmp/types.h
-./system.lo:  ../include/net-snmp/definitions.h
+./system.lo: ../include/net-snmp/types.h 
+./system.lo: ../include/net-snmp/definitions.h
 ./system.lo: ../include/net-snmp/library/snmp_api.h
 ./system.lo: ../include/net-snmp/library/asn1.h
 ./system.lo: ../include/net-snmp/library/snmp_impl.h
@@ -2194,8 +2158,8 @@
 ./tools.lo: ../include/net-snmp/system/sysv.h
 ./tools.lo: ../include/net-snmp/system/generic.h
 ./tools.lo: ../include/net-snmp/machine/generic.h 
-./tools.lo: ../include/net-snmp/types.h 
-./tools.lo: ../include/net-snmp/definitions.h
+./tools.lo:  ../include/net-snmp/types.h
+./tools.lo:  ../include/net-snmp/definitions.h
 ./tools.lo: ../include/net-snmp/library/snmp_api.h
 ./tools.lo: ../include/net-snmp/library/asn1.h
 ./tools.lo: ../include/net-snmp/library/snmp_impl.h

=== modified file 'snmplib/asn1.c'
--- snmplib/asn1.c	2009-11-12 16:17:40 +0000
+++ snmplib/asn1.c	2010-06-10 18:02:54 +0000
@@ -1328,6 +1328,14 @@
             length--;
         } while ((*(u_char *) bufp++ & ASN_BIT8) && (length > 0));        /* last byte has high bit clear */
 
+	if (length == 0) {
+            u_char *last_byte = bufp - 1;
+            if (*last_byte & ASN_BIT8) {
+                /* last byte has high bit set -> wrong BER encoded OID */
+                ERROR_MSG("subidentifier syntax error");
+                return NULL;
+            }
+        }
 #if defined(EIGHTBIT_SUBIDS) || (SIZEOF_LONG != 4)
         if (subidentifier > (u_long) MAX_SUBID) {
             ERROR_MSG("subidentifier too large");

=== modified file 'snmplib/callback.c'
--- snmplib/callback.c	2009-11-12 16:17:40 +0000
+++ snmplib/callback.c	2010-06-10 18:02:54 +0000
@@ -41,7 +41,7 @@
 #if HAVE_SYS_SOCKET_H
 #include <sys/socket.h>
 #endif
-#if HAVE_SYS_TIME_H
+#if !defined(mingw32) && defined(HAVE_SYS_TIME_H)
 #include <sys/time.h>
 #endif
 

=== modified file 'snmplib/container.c'
--- snmplib/container.c	2009-11-12 16:17:40 +0000
+++ snmplib/container.c	2010-06-10 18:02:54 +0000
@@ -104,6 +104,9 @@
 {
     container_type *ct, tmp;
 
+    if (NULL==containers)
+        return -1;
+
     tmp.name = (char *)name;
     ct = (container_type *)CONTAINER_FIND(containers, &tmp);
     if (NULL!=ct) {
@@ -139,6 +142,9 @@
 {
     container_type ct, *found;
     
+    if (NULL==containers)
+        return NULL;
+
     ct.name = type;
     found = (container_type *)CONTAINER_FIND(containers, &ct);
 
@@ -174,6 +180,9 @@
 netsnmp_container_get_ct(const char *type)
 {
     container_type ct;
+
+    if (NULL == containers)
+        return NULL;
     
     ct.name = type;
     return (container_type *)CONTAINER_FIND(containers, &ct);
@@ -275,7 +284,7 @@
     if(x) {
         int rc = x->insert(x,k);
         if(rc)
-            snmp_log(LOG_ERR,"error on subcontainer '%s' insert (%d)\n",
+            snmp_log(LOG_DEBUG,"error on subcontainer '%s' insert (%d)\n",
                      x->container_name ? x->container_name : "", rc);
         else {
             rc = CONTAINER_INSERT_HELPER(x->next, k);

=== modified file 'snmplib/container_binary_array.c'
--- snmplib/container_binary_array.c	2009-11-12 16:17:40 +0000
+++ snmplib/container_binary_array.c	2010-06-10 18:02:54 +0000
@@ -1,6 +1,6 @@
 /*
  * container_binary_array.c
- * $Id: container_binary_array.c 16772 2008-01-09 21:58:49Z magfr $
+ * $Id: container_binary_array.c 17543 2009-04-23 15:58:53Z hardaker $
  *
  * see comments in header file.
  *
@@ -531,8 +531,11 @@
     
     va = SNMP_MALLOC_TYPEDEF(netsnmp_void_array);
     if (NULL==va)
+    {
+        free (rtn);
         return NULL;
-
+    }
+    
     va->size = len;
     va->array = rtn;
 

=== modified file 'snmplib/file_utils.c'
--- snmplib/file_utils.c	2007-05-10 22:20:23 +0000
+++ snmplib/file_utils.c	2010-06-10 18:02:54 +0000
@@ -126,6 +126,8 @@
     if (NULL != filei->extras)
         netsnmp_free_all_list_data(filei->extras);
 
+    SNMP_FREE(filei);
+
     return rc;
 }
 

=== modified file 'snmplib/inet_ntop.c'
--- snmplib/inet_ntop.c	2007-12-08 14:59:50 +0000
+++ snmplib/inet_ntop.c	2010-06-10 18:02:54 +0000
@@ -25,22 +25,23 @@
 #include <arpa/nameser.h>
 #endif
 
-  /*
-   * Net-SNMP Win32 additions
-   */
-#if defined(HAVE_WINSOCK_H) || defined(cygwin)
+#if defined(HAVE_WINSOCK_H)
 #include <winsock2.h>
 #include <ws2tcpip.h>
+#endif
 #include <errno.h>
 #include <stdio.h>
+#if HAVE_STRING_H
+#include <string.h>
+#else
+#include <strings.h>
 #endif
 
+#include <net-snmp/types.h>
+
 #ifndef EAFNOSUPPORT
 #define EAFNOSUPPORT            WSAEAFNOSUPPORT
 #endif
-  /*
-   * End of Net-SNMP Win32 additions
-   */
 
 #ifndef IN6ADDRSZ
 #define	IN6ADDRSZ	16

=== modified file 'snmplib/inet_pton.c'
--- snmplib/inet_pton.c	2007-12-08 14:59:50 +0000
+++ snmplib/inet_pton.c	2010-06-10 18:02:54 +0000
@@ -21,20 +21,26 @@
 
 #ifndef HAVE_INET_PTON
 
+#include <ctype.h>
+
 #if HAVE_ARPA_NAMESER_H
 #include <arpa/nameser.h>
 #endif
 
-  /*
-   * Net-SNMP Win32 additions
-   */
-#if defined(HAVE_WINSOCK_H) || defined(cygwin)
+#if defined(HAVE_WINSOCK_H)
 #include <winsock2.h>
 #include <ws2tcpip.h>
+#endif
 #include <errno.h>
 #include <stdio.h>
+#if HAVE_STRING_H
+#include <string.h>
+#else
+#include <strings.h>
 #endif
 
+#include <net-snmp/types.h>
+
 #ifndef EAFNOSUPPORT
 #define EAFNOSUPPORT            WSAEAFNOSUPPORT
 #endif

=== modified file 'snmplib/keytools.c'
--- snmplib/keytools.c	2007-12-08 14:59:50 +0000
+++ snmplib/keytools.c	2010-06-10 18:02:54 +0000
@@ -401,6 +401,9 @@
     /*
      * Sanity check.
      */
+    if (!kcstring || !kcstring_len)
+	return SNMPERR_GENERR;
+
     if (!hashtype || !oldkey || !newkey || !kcstring || !kcstring_len
         || (oldkey_len <= 0) || (newkey_len <= 0) || (*kcstring_len <= 0)
         || (hashtype_len != USM_LENGTH_OID_TRANSFORM)) {

=== modified file 'snmplib/mib.c'
--- snmplib/mib.c	2009-11-12 16:17:40 +0000
+++ snmplib/mib.c	2010-06-10 18:02:54 +0000
@@ -1,7 +1,7 @@
 /*
  * mib.c
  *
- * $Id: mib.c 17137 2008-07-30 07:57:19Z dts12 $
+ * $Id: mib.c 18251 2010-03-11 11:43:31Z dts12 $
  *
  * Update: 1998-07-17 <jhy@gsu.edu>
  * Added print_oid_report* functions.
@@ -1489,7 +1489,7 @@
             return 0;
         }
     } else {
-        sprintf(tmp, "%lu", *var->val.integer);
+        sprintf(tmp, "%u", (unsigned int)(*var->val.integer & 0xffffffff));
         if (!snmp_strcat
             (buf, buf_len, out_len, allow_realloc, (const u_char *) tmp)) {
             return 0;
@@ -1553,7 +1553,7 @@
             return 0;
         }
     }
-    sprintf(tmp, "%lu", *var->val.integer);
+    sprintf(tmp, "%u", (unsigned int)(*var->val.integer & 0xffffffff));
     if (!snmp_strcat
         (buf, buf_len, out_len, allow_realloc, (const u_char *) tmp)) {
         return 0;
@@ -2109,9 +2109,10 @@
     char       *st;
 
     value = strtok_r(line, " \t\n", &st);
-    if ((strcasecmp(value, "yes")  == 0) || 
-	(strcasecmp(value, "true") == 0) ||
-	(*value == '1')) {
+    if (value && (
+	    (strcasecmp(value, "yes")  == 0) || 
+	    (strcasecmp(value, "true") == 0) ||
+	    (*value == '1') )) {
 
         netsnmp_ds_set_int(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_OID_OUTPUT_FORMAT,
                                                   NETSNMP_OID_OUTPUT_NUMERIC);
@@ -3366,17 +3367,19 @@
                                             NETSNMP_DS_LIB_DONT_PRINT_UNITS)) {
             units = subtree->units;
         }
-        if (subtree && subtree->printomat) {
+        if (subtree) {
+	    if(subtree->printomat) {
             return (*subtree->printomat) (buf, buf_len, out_len,
                                           allow_realloc, variable,
                                           subtree->enums, subtree->hint,
                                           units);
-        } else {
-            return sprint_realloc_by_type(buf, buf_len, out_len,
-                                          allow_realloc, variable,
-                                          subtree->enums, subtree->hint,
-                                          units);
-        }
+	    } else {
+		return sprint_realloc_by_type(buf, buf_len, out_len,
+					      allow_realloc, variable,
+					      subtree->enums, subtree->hint,
+					      units);
+	    }
+	}
 #else
         return sprint_realloc_by_type(buf, buf_len, out_len,
                                       allow_realloc, variable,
@@ -3825,6 +3828,7 @@
     if (buf) {
         int             i, len;
         char            intbuf[64], * p;
+        unsigned char  *zc;
         unsigned long   zone;
 
         memset(intbuf, 0, 64);
@@ -3842,7 +3846,12 @@
                 len = sprintf(p, "%lu.%lu.%lu.%lu", objid[0], objid[1], objid[2], objid[3]);
                 p += len;
                 if (addr_type == IPV4Z) {
-                    zone = ntohl((long)objid[4]);
+                    zc = (unsigned char*)&zone;
+                    zc[0] = (u_char)(objid[4]);
+                    zc[1] = (u_char)(objid[5]);
+                    zc[2] = (u_char)(objid[6]);
+                    zc[3] = (u_char)(objid[7]);
+                    zone = ntohl(zone);
                     len = sprintf(p, "%%%lu", zone);
                     p += len;
                 }
@@ -3863,7 +3872,12 @@
                 p-- ; /* do not include the last ':' */
 
                 if (addr_type == IPV6Z) {
-                    zone = ntohl((long)objid[16]);
+                    zc = (unsigned char*)&zone;
+                    zc[0] = (u_char)(objid[16]);
+                    zc[1] = (u_char)(objid[17]);
+                    zc[2] = (u_char)(objid[18]);
+                    zc[3] = (u_char)(objid[19]);
+                    zone = ntohl(zone);
                     len = sprintf(p, "%%%lu", zone);
                     p += len;
                 }
@@ -4696,11 +4710,30 @@
             if (!snmp_cstrcat(buf, buf_len, out_len, allow_realloc, " ("))
                 return 0;
             while (rp) {
-                if (rp->low == rp->high)
-                    sprintf(str, "%s%d", (first ? "" : " | "), rp->low );
-                else
-                    sprintf(str, "%s%d..%d", (first ? "" : " | "),
-                                              rp->low, rp->high);
+                switch (tp->type) {
+                case TYPE_INTEGER:
+                case TYPE_INTEGER32:
+                    if (rp->low == rp->high)
+                        sprintf(str, "%s%d", (first ? "" : " | "), rp->low );
+                    else
+                        sprintf(str, "%s%d..%d", (first ? "" : " | "),
+                                rp->low, rp->high);
+                    break;
+                case TYPE_UNSIGNED32:
+                case TYPE_OCTETSTR:
+                case TYPE_GAUGE:
+                case TYPE_UINTEGER:
+                    if (rp->low == rp->high)
+                        sprintf(str, "%s%u", (first ? "" : " | "),
+                                (unsigned)rp->low );
+                    else
+                        sprintf(str, "%s%u..%u", (first ? "" : " | "),
+                                (unsigned)rp->low, (unsigned)rp->high);
+                    break;
+                default:
+                    /* No other range types allowed */
+                    break;
+                }
                 if (!snmp_cstrcat(buf, buf_len, out_len, allow_realloc, str))
                     return 0;
                 if (first)
@@ -5406,14 +5439,14 @@
                 (*objidlen)++;
             }
 
+            if (!cp)
+                goto bad_id;
             while (*cp && *cp != doingquote) {
                 if (*objidlen >= maxlen)
                     goto bad_id;
                 objid[*objidlen] = *cp++;
                 (*objidlen)++;
             }
-            if (!cp)
-                goto bad_id;
             cp2 = cp + 1;
             if (!*cp2)
                 cp2 = NULL;

=== modified file 'snmplib/parse.c'
--- snmplib/parse.c	2009-11-12 16:17:40 +0000
+++ snmplib/parse.c	2010-06-10 18:02:54 +0000
@@ -528,6 +528,7 @@
 
 static int      current_module = 0;
 static int      max_module = 0;
+static int      first_err_module = 1;
 static char    *last_err_module = 0;    /* no repeats on "Cannot find module..." */
 
 static void     tree_from_node(struct tree *tp, struct node *np);
@@ -774,6 +775,11 @@
 static void
 print_module_not_found(const char *cp)
 {
+    if (first_err_module) {
+        snmp_log(LOG_ERR, "MIB search path: %s\n",
+                           netsnmp_get_mib_directory());
+        first_err_module = 0;
+    }
     if (!last_err_module || strcmp(cp, last_err_module))
         print_error("Cannot find module", cp, CONTINUE);
     if (last_err_module)
@@ -912,6 +918,32 @@
     free((char *) np);
 }
 
+static void
+print_range_value(FILE * fp, int type, struct range_list * rp)
+{
+    switch (type) {
+    case TYPE_INTEGER:
+    case TYPE_INTEGER32:
+        if (rp->low == rp->high)
+            fprintf(fp, "%d", rp->low);
+        else
+            fprintf(fp, "%d..%d", rp->low, rp->high);
+        break;
+    case TYPE_UNSIGNED32:
+    case TYPE_OCTETSTR:
+    case TYPE_GAUGE:
+    case TYPE_UINTEGER:
+        if (rp->low == rp->high)
+            fprintf(fp, "%u", (unsigned)rp->low);
+        else
+            fprintf(fp, "%u..%u", (unsigned)rp->low, (unsigned)rp->high);
+        break;
+    default:
+        /* No other range types allowed */
+        break;
+    }
+}
+
 #ifdef TEST
 static void
 print_nodes(FILE * fp, struct node *root)
@@ -935,10 +967,12 @@
             }
         }
         if (np->ranges) {
-            fprintf(fp, "  Ranges: \n");
+            fprintf(fp, "  Ranges: ");
             for (rp = np->ranges; rp; rp = rp->next) {
-                fprintf(fp, "    %d..%d\n", rp->low, rp->high);
+                fprintf(fp, "\n    ");
+                print_range_value(fp, np->type, rp);
             }
+            fprintf(fp, "\n");
         }
         if (np->indexes) {
             fprintf(fp, "  Indexes: \n");
@@ -2169,12 +2203,12 @@
             nexttype = get_token(fp, nexttoken, MAXTOKEN);
         else
             taken = 0;
-        high = low = strtol(nexttoken, NULL, 10);
+        high = low = strtoul(nexttoken, NULL, 10);
         nexttype = get_token(fp, nexttoken, MAXTOKEN);
         if (nexttype == RANGE) {
             nexttype = get_token(fp, nexttoken, MAXTOKEN);
             errno = 0;
-            high = strtol(nexttoken, NULL, 10);
+            high = strtoul(nexttoken, NULL, 10);
             if ( errno == ERANGE ) {
                 if (netsnmp_ds_get_int(NETSNMP_DS_LIBRARY_ID, 
                                        NETSNMP_DS_LIB_MIB_WARNINGS))
@@ -2937,6 +2971,7 @@
     strcpy(np->parent, np->next->parent);
     strcat(np->parent, "#");
     np->next->label = strdup(np->parent);
+    np->type = TRAPTYPE;
     return np;
 }
 
@@ -2952,6 +2987,9 @@
     struct node    *np = alloc_node(current_module);
     char            nexttoken[MAXTOKEN];
 
+    if (!np)
+	return 0;
+
     type = get_token(fp, token, maxtoken);
     nexttype = get_token(fp, nexttoken, MAXTOKEN);
     switch (type) {
@@ -4191,7 +4229,7 @@
 parse(FILE * fp, struct node *root)
 {
     char            token[MAXTOKEN];
-    char            name[MAXTOKEN];
+    char            name[MAXTOKEN+1];
     int             type = LABEL;
     int             lasttype = LABEL;
 
@@ -4283,7 +4321,8 @@
         case ENDOFFILE:
             continue;
         default:
-            strcpy(name, token);
+            strncpy(name, token, sizeof(name));
+            name[sizeof(name)-1] = '\0';
             type = get_token(fp, token, MAXTOKEN);
             nnp = NULL;
             if (type == MACRO) {
@@ -4300,7 +4339,8 @@
                 print_error(name, "is a reserved word", lasttype);
             continue;           /* see if we can parse the rest of the file */
         }
-        strcpy(name, token);
+        strncpy(name, token, sizeof(name));
+        name[sizeof(name)-1] = '\0';
         type = get_token(fp, token, MAXTOKEN);
         nnp = NULL;
 
@@ -5332,10 +5372,7 @@
             while (rp) {
                 if (rp != tp->ranges)
                     fprintf(f, " | ");
-                if (rp->low == rp->high)
-                    fprintf(f, "%d", rp->low);
-                else
-                    fprintf(f, "%d..%d", rp->low, rp->high);
+                print_range_value(f, tp->type, rp);
                 rp = rp->next;
             }
             fprintf(f, "\n");

=== modified file 'snmplib/read_config.c'
--- snmplib/read_config.c	2009-11-12 16:17:40 +0000
+++ snmplib/read_config.c	2010-06-10 18:02:54 +0000
@@ -1162,7 +1162,8 @@
 void
 read_config_files(int when)
 {
-    const char     *confpath, *perspath, *persfile, *envconfpath;
+    const char     *confpath, *persfile, *envconfpath;
+    char           *perspath;
     struct config_files *ctmp = config_files;
 
     if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID,
@@ -1188,9 +1189,11 @@
     for (; ctmp != NULL; ctmp = ctmp->next) {
 
         /*
-         * read the config files 
+         * read the config files. strdup() the result of
+         * get_persistent_directory() to avoid that parsing the "persistentDir"
+         * keyword transforms the perspath pointer into a dangling pointer.
          */
-        perspath = get_persistent_directory();
+        perspath = strdup(get_persistent_directory());
         if (envconfpath == NULL) {
             /*
              * read just the config files (no persistent stuff), since
@@ -1199,7 +1202,8 @@
              */
             read_config_files_in_path(confpath, ctmp, when, perspath,
                                       persfile);
-            perspath = get_persistent_directory();
+            free(perspath);
+            perspath = strdup(get_persistent_directory());
             read_config_files_in_path(perspath, ctmp, when, perspath,
                                       persfile);
         }
@@ -1210,6 +1214,7 @@
             read_config_files_in_path(envconfpath, ctmp, when, perspath,
                                       persfile);
         }
+        free(perspath);
     }
 
     if (config_errors) {
@@ -1468,7 +1473,7 @@
 {
     if (ptr == NULL)
         return (NULL);
-    while (*ptr != 0 && isspace(*ptr))
+    while (*ptr != 0 && isspace((unsigned char)*ptr))
         ptr++;
     if (*ptr == 0 || *ptr == '#')
         return (NULL);
@@ -1480,7 +1485,7 @@
 {
     if (ptr == NULL)
         return (NULL);
-    while (*ptr != 0 && !isspace(*ptr))
+    while (*ptr != 0 && !isspace((unsigned char)*ptr))
         ptr++;
     if (*ptr == 0 || *ptr == '#')
         return (NULL);

=== modified file 'snmplib/scapi.c'
--- snmplib/scapi.c	2009-11-12 16:17:40 +0000
+++ snmplib/scapi.c	2010-06-10 18:02:54 +0000
@@ -404,13 +404,13 @@
 {
 #if defined(NETSNMP_USE_OPENSSL) || defined(NETSNMP_USE_PKCS11)
     int            rval = SNMPERR_SUCCESS;
+    unsigned int   tmp_len;
 #endif
     int            ret;
 
 #ifdef NETSNMP_USE_OPENSSL
     const EVP_MD   *hashfn;
     EVP_MD_CTX     ctx, *cptr;
-    unsigned int   tmp_len;
 #endif
 
     DEBUGTRACE;

=== modified file 'snmplib/snmpCallbackDomain.c'
--- snmplib/snmpCallbackDomain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpCallbackDomain.c	2010-06-10 18:02:54 +0000
@@ -611,8 +611,8 @@
 
 	if (tr != NULL) {
 	    tr->f_close(tr);
-  	    netsnmp_transport_remove_from_list(&trlist, list->transport);
-	    netsnmp_transport_free(list->transport);
+  	    netsnmp_transport_remove_from_list(&trlist, tr);
+	    netsnmp_transport_free(tr);
 	}
 	list = next;
     }

=== modified file 'snmplib/snmpSTDDomain.c'
--- snmplib/snmpSTDDomain.c	2007-12-08 14:59:50 +0000
+++ snmplib/snmpSTDDomain.c	2010-06-10 18:02:54 +0000
@@ -212,7 +212,7 @@
 
             data = SNMP_MALLOC_TYPEDEF(netsnmp_std_data);
             if (!data) {
-                snmp_log(LOG_ERR, "snmpSTDDomain: memdup failed");
+                snmp_log(LOG_ERR, "snmpSTDDomain: malloc failed");
                 netsnmp_transport_free(t);
                 return NULL;
             }

=== modified file 'snmplib/snmpTCPDomain.c'
--- snmplib/snmpTCPDomain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpTCPDomain.c	2010-06-10 18:02:54 +0000
@@ -87,7 +87,7 @@
             return strdup("TCP: unknown");
         }
 
-        sprintf(tmp, "TCP: [%s]:%hd",
+        sprintf(tmp, "TCP: [%s]:%hu",
                 inet_ntoa(to->sin_addr), ntohs(to->sin_port));
         return strdup(tmp);
     }

=== modified file 'snmplib/snmpTCPIPv6Domain.c'
--- snmplib/snmpTCPIPv6Domain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpTCPIPv6Domain.c	2010-06-10 18:02:54 +0000
@@ -2,21 +2,6 @@
 
 #ifdef NETSNMP_TRANSPORT_TCPIPV6_DOMAIN
 
-/*
- * hack-o-matic for Cygwin to use winsock2
-*/
-#if defined(cygwin)
-#undef HAVE_UNISTD_H
-#undef HAVE_NETINET_IN_H
-#undef HAVE_ARPA_INET_H
-#undef HAVE_NET_IF_H
-#undef HAVE_NETDB_H
-#undef HAVE_SYS_PARAM_H
-#undef HAVE_SYS_SELECT_H
-#undef HAVE_SYS_SOCKET_H
-#undef HAVE_IN_ADDR_T
-#endif
-
 #include <stdio.h>
 #include <sys/types.h>
 #include <errno.h>
@@ -36,7 +21,7 @@
 #include <sys/socket.h>
 #endif
 
-#if defined(HAVE_WINSOCK_H) || defined(cygwin)
+#if defined(HAVE_WINSOCK_H)
     /*
      * Windows IPv6 support is part of WinSock2 only
      */
@@ -99,7 +84,7 @@
         char addr[INET6_ADDRSTRLEN];
         char tmp[INET6_ADDRSTRLEN + 18];
 
-        sprintf(tmp, "TCP/IPv6: [%s]:%hd",
+        sprintf(tmp, "TCP/IPv6: [%s]:%hu",
                 inet_ntop(AF_INET6, (void *) &(to->sin6_addr), addr,
                           INET6_ADDRSTRLEN), ntohs(to->sin6_port));
         return strdup(tmp);

=== modified file 'snmplib/snmpUDPDomain.c'
--- snmplib/snmpUDPDomain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpUDPDomain.c	2010-06-10 18:02:54 +0000
@@ -65,6 +65,12 @@
 #define INADDR_NONE	-1
 #endif
 
+#ifdef  MSG_DONTWAIT
+#define NETSNMP_DONTWAIT MSG_DONTWAIT
+#else
+#define NETSNMP_DONTWAIT 0
+#endif
+
 static netsnmp_tdomain udpDomain;
 
 typedef struct netsnmp_udp_addr_pair_s {
@@ -104,12 +110,12 @@
 	char tmp[64];
         to = (struct sockaddr_in *) &(addr_pair->remote_addr);
         if (to == NULL) {
-            sprintf(tmp, "UDP: [%s]->unknown",
+            sprintf(tmp, "UDP: unknown->[%s]",
                     inet_ntoa(addr_pair->local_addr));
         } else {
-            sprintf(tmp, "UDP: [%s]->", inet_ntoa(addr_pair->local_addr));
-            sprintf(tmp + strlen(tmp), "[%s]:%hd",
+            sprintf(tmp, "UDP: [%s]:%hu->",
                     inet_ntoa(to->sin_addr), ntohs(to->sin_port));
+            sprintf(tmp + strlen(tmp), "[%s]", inet_ntoa(addr_pair->local_addr));
         }
         return strdup(tmp);
     }
@@ -140,7 +146,7 @@
     msg.msg_control = &cmsg;
     msg.msg_controllen = sizeof(cmsg);
 
-    r = recvmsg(s, &msg, 0);
+    r = recvmsg(s, &msg, NETSNMP_DONTWAIT);
 
     if (r == -1) {
         return -1;
@@ -167,6 +173,7 @@
     } cmsg;
     struct msghdr m;
 
+    memset(&cmsg, 0, sizeof(cmsg));
     cmsg.cm.cmsg_len = sizeof(struct cmsghdr) + sizeof(struct in_pktinfo);
     cmsg.cm.cmsg_level = SOL_IP;
     cmsg.cm.cmsg_type = IP_PKTINFO;
@@ -215,7 +222,7 @@
 #if defined(linux) && defined(IP_PKTINFO)
             rc = netsnmp_udp_recvfrom(t->sock, buf, size, from, &fromlen, &(addr_pair->local_addr));
 #else
-            rc = recvfrom(t->sock, buf, size, 0, from, &fromlen);
+            rc = recvfrom(t->sock, buf, size, NETSNMP_DONTWAIT, from, &fromlen);
 #endif /* linux && IP_PKTINFO */
 	    if (rc < 0 && errno != EINTR) {
 		break;
@@ -671,7 +678,6 @@
             struct sockaddr_in client_addr;
             netsnmp_sockaddr_in2(&client_addr, client_socket, NULL);
             addr_pair.local_addr = client_addr.sin_addr;
-            client_addr.sin_port = 0;
             rc = bind(t->sock, (struct sockaddr *)&client_addr,
                   sizeof(struct sockaddr));
             if ( rc != 0 ) {

=== modified file 'snmplib/snmpUDPIPv6Domain.c'
--- snmplib/snmpUDPIPv6Domain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpUDPIPv6Domain.c	2010-06-10 18:02:54 +0000
@@ -2,21 +2,6 @@
 
 #ifdef NETSNMP_TRANSPORT_UDPIPV6_DOMAIN
 
-/*
- * hack-o-matic for Cygwin to use winsock2
-*/
-#if defined(cygwin)
-#undef HAVE_UNISTD_H
-#undef HAVE_NETINET_IN_H
-#undef HAVE_ARPA_INET_H
-#undef HAVE_NET_IF_H
-#undef HAVE_NETDB_H
-#undef HAVE_SYS_PARAM_H
-#undef HAVE_SYS_SELECT_H
-#undef HAVE_SYS_SOCKET_H
-#undef HAVE_IN_ADDR_T
-#endif
-
 #include <stdio.h>
 #include <sys/types.h>
 #include <ctype.h>
@@ -37,7 +22,7 @@
 #include <sys/socket.h>
 #endif
 
-#if defined(HAVE_WINSOCK_H) || defined(cygwin)
+#if defined(HAVE_WINSOCK_H)
     /*
      *  Windows IPv6 support is part of WinSock2 only
      */
@@ -395,7 +380,7 @@
             return 0;
         }
 
-        for (cp = peername; *cp && isdigit((int) *cp); cp++);
+        for (cp = peername; *cp && isdigit((unsigned char) *cp); cp++);
         if (!*cp && atoi(peername) != 0) {
             /*
              * Okay, it looks like JUST a port number.  
@@ -690,7 +675,11 @@
             mask |= maskbit;
             maskbit >>= 1;
         }
-        (*(u_char *) (&((struct in6_addr *) dst)->s6_addr[j])) = mask;
+
+	if (j < sizeof (((struct in6_addr *) dst)->s6_addr)){
+	    (*(u_char *) (&((struct in6_addr *) dst)->s6_addr[j])) = mask;
+	}
+
         break;
     default:
         return -1;              /* unsupported protocol family */
@@ -1066,39 +1055,39 @@
      * Deal with the network part first.  
      */
     if ((strcmp(source, "default") == 0) || (strcmp(source, "::") == 0)) {
-        strnetwork = strdup("0::0");
-        strmask = strdup("0::0");
-
-        inet_pton(AF_INET6, strnetwork, &net.sin6_addr);
-        inet_pton(AF_INET6, strmask, &mask.sin6_addr);
-
-        e = (com2Sec6Entry *) malloc(sizeof(com2Sec6Entry));
-        if (e == NULL) {
-            config_perror("memory error");
-            return;
-        }
-        /*
-         * Everything is okay.  Copy the parameters to the structure allocated
-         * above and add it to END of the list.  
-         */
-        if (strmask != NULL && strnetwork != NULL) {
-            DEBUGMSGTL(("netsnmp_udp6_parse_security",
-                        "<\"%s\", %s/%s> => \"%s\"\n", community,
-                        strnetwork, strmask, secName));
-            free(strmask);
-            free(strnetwork);
-        } else {
-            DEBUGMSGTL(("netsnmp_udp6_parse_security",
-                        "Couldn't allocate enough memory\n"));
-        }
-        memmove_com2Sec6Entry(e, secName, community, net, mask, contextName);
-        if (com2Sec6ListLast != NULL) {
-            com2Sec6ListLast->next = e;
-            com2Sec6ListLast = e;
-        } else {
-            com2Sec6ListLast = com2Sec6List = e;
-        }
-
+        if ((strnetwork = strdup("0::0")) != NULL)
+	{
+	    if ((strmask = strdup("0::0")) != NULL)
+	    {
+	
+		inet_pton(AF_INET6, strnetwork, &net.sin6_addr);
+		inet_pton(AF_INET6, strmask, &mask.sin6_addr);
+		
+		e = (com2Sec6Entry *) malloc(sizeof(com2Sec6Entry));
+		if (e != NULL) {
+		    memmove_com2Sec6Entry(e, secName, community, net, mask, contextName);
+		    if (com2Sec6ListLast != NULL) {
+			com2Sec6ListLast->next = e;
+			com2Sec6ListLast = e;
+		    } else {
+			com2Sec6ListLast = com2Sec6List = e;
+		    }
+		}
+		else {
+		    config_perror ("memory error");
+		}
+		free (strmask);
+	    }
+	    else {
+		DEBUGMSGTL(("netsnmp_udp6_parse_security",
+			    "Couldn't allocate enough memory\n"));
+	    }
+	    free (strnetwork);
+	}
+	else {
+	    DEBUGMSGTL(("netsnmp_udp6_parse_security",
+			"Couldn't allocate enough memory\n"));
+	}
     } else {
         /*
          * Try interpreting as IPv6 address.  
@@ -1183,8 +1172,8 @@
                      0, NI_NUMERICHOST)) {
                     config_perror("getnameinfo failed");
                 }
-                memmove(ai->ai_addr, &net, sizeof(struct sockaddr_in6));
-                inet_make_mask_addr(AF_INET6, &mask.sin6_addr, 127);
+                memmove(&net, ai->ai_addr, sizeof(struct sockaddr_in6));
+                inet_make_mask_addr(PF_INET6, &mask.sin6_addr, 128);
 
                 e = (com2Sec6Entry *) malloc(sizeof(com2Sec6Entry));
                 if (e == NULL) {
@@ -1302,7 +1291,7 @@
 
     for (c = com2Sec6List; c != NULL; c = c->next) {
         DEBUGMSGTL(("netsnmp_udp6_getSecName",
-                    "compare <\"%s\", 0x%032/0x%032x>", c->community,
+                    "compare <\"%s\", 0x%032x/0x%032x>", c->community,
                     c->network, c->mask));
 
         if ((community_len == (int)strlen(c->community)) &&

=== modified file 'snmplib/snmpUnixDomain.c'
--- snmplib/snmpUnixDomain.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpUnixDomain.c	2010-06-10 18:02:54 +0000
@@ -563,12 +563,12 @@
 
     param = copy_nword(param, secName, VACMSTRINGLEN);
     if (strcmp(secName, "-Cn") == 0) {
-        if (!secName) {
+        param = copy_nword( param, contextName, sizeof(contextName));
+        param = copy_nword( param, secName, sizeof(secName));
+        if (contextName[0] == '\0') {
             config_perror("missing CONTEXT_NAME parameter");
             return;
         }
-        param = copy_nword( param, contextName, sizeof(contextName));
-        param = copy_nword( param, secName, sizeof(secName));
     } else {
         contextName[0] = '\0';
     }

=== modified file 'snmplib/snmp_alarm.c'
--- snmplib/snmp_alarm.c	2007-05-10 22:20:23 +0000
+++ snmplib/snmp_alarm.c	2010-06-10 18:02:54 +0000
@@ -197,8 +197,18 @@
 sa_find_next(void)
 {
     struct snmp_alarm *a, *lowest = NULL;
+    struct timeval  t_now;
+
+    gettimeofday(&t_now, NULL);
 
     for (a = thealarms; a != NULL; a = a->next) {
+        /* check for time delta skew */
+        if ((a->t_next.tv_sec - t_now.tv_sec) > a->t.tv_sec)
+        {
+            DEBUGMSGTL(("time_skew", "Time delta too big (%d seconds), should be %d seconds - fixing\n", (a->t_next.tv_sec - t_now.tv_sec), a->t.tv_sec));
+            a->t_next.tv_sec = t_now.tv_sec + a->t.tv_sec;
+            a->t_next.tv_usec = t_now.tv_usec + a->t.tv_usec;
+        }
         if (lowest == NULL) {
             lowest = a;
         } else if (a->t_next.tv_sec == lowest->t_next.tv_sec) {
@@ -370,7 +380,7 @@
 
 
 /**
- * This function registers function callbacks to occur at a speciifc time
+ * This function registers function callbacks to occur at a specific time
  * in the future.
  *
  * @param when is an unsigned integer specifying when the callback function

=== modified file 'snmplib/snmp_api.c'
--- snmplib/snmp_api.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmp_api.c	2010-06-10 18:02:54 +0000
@@ -415,11 +415,16 @@
     if (!retVal)
         retVal = 2;
     Reqid = retVal;
+    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
+        retVal &= 0x7fff;	/* mask to 15 bits */
+    else
+        retVal &= 0x7fffffff;	/* mask to 31 bits */
+
+    if (!retVal) {
+        Reqid = retVal = 2;
+    }
     snmp_res_unlock(MT_LIBRARY_ID, MT_LIB_REQUESTID);
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
-        return (retVal & 0x7fff);	/* mask to 15 bits */
-    else
-        return (retVal & 0x7fffffff);	/* mask to 31 bits */
+    return retVal;
 }
 
 long
@@ -431,11 +436,16 @@
     if (!retVal)
         retVal = 2;
     Msgid = retVal;
+    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
+        retVal &= 0x7fff;	/* mask to 15 bits */
+    else
+        retVal &= 0x7fffffff;	/* mask to 31 bits */
+
+    if (!retVal) {
+        Msgid = retVal = 2;
+    }
     snmp_res_unlock(MT_LIBRARY_ID, MT_LIB_MESSAGEID);
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
-        return (retVal & 0x7fff);	/* mask to 15 bits */
-    else
-        return (retVal & 0x7fffffff);	/* mask to 31 bits */
+    return retVal;
 }
 
 long
@@ -447,11 +457,16 @@
     if (!retVal)
         retVal = 2;
     Sessid = retVal;
+    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
+        retVal &= 0x7fff;	/* mask to 15 bits */
+    else
+        retVal &= 0x7fffffff;	/* mask to 31 bits */
+
+    if (!retVal) {
+        Sessid = retVal = 2;
+    }
     snmp_res_unlock(MT_LIBRARY_ID, MT_LIB_SESSIONID);
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
-        return (retVal & 0x7fff);	/* mask to 15 bits */
-    else
-        return (retVal & 0x7fffffff);	/* mask to 31 bits */
+    return retVal;
 }
 
 long
@@ -463,11 +478,16 @@
     if (!retVal)
         retVal = 2;
     Transid = retVal;
+    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
+        retVal &= 0x7fff;	/* mask to 15 bits */
+    else
+        retVal &= 0x7fffffff;	/* mask to 31 bits */
+
+    if (!retVal) {
+        Transid = retVal = 2;
+    }
     snmp_res_unlock(MT_LIBRARY_ID, MT_LIB_TRANSID);
-    if (netsnmp_ds_get_boolean(NETSNMP_DS_LIBRARY_ID, NETSNMP_DS_LIB_16BIT_IDS))
-        return (retVal & 0x7fff);	/* mask to 15 bits */
-    else
-        return (retVal & 0x7fffffff);	/* mask to 31 bits */
+    return retVal;
 }
 
 void
@@ -614,17 +634,17 @@
  *
  * Warning: no debug messages here.
  */
+static char _init_snmp_init_done = 0;
 static void
 _init_snmp(void)
 {
-    static char     have_done_init = 0;
 
     struct timeval  tv;
     long            tmpReqid, tmpMsgid;
 
-    if (have_done_init)
+    if (_init_snmp_init_done)
         return;
-    have_done_init = 1;
+    _init_snmp_init_done = 1;
     Reqid = 1;
 
     snmp_res_init();            /* initialize the mt locking structures */
@@ -752,6 +772,7 @@
     netsnmp_register_service_handlers();
 }
 
+static int init_snmp_init_done = 0; /* To prevent double init's. */
 /**
  * Calls the functions to do config file loading and  mib module parsing
  * in the correct order.
@@ -765,13 +786,11 @@
 void
 init_snmp(const char *type)
 {
-    static int      done_init = 0;      /* To prevent double init's. */
-
-    if (done_init) {
+    if (init_snmp_init_done) {
         return;
     }
 
-    done_init = 1;
+    init_snmp_init_done = 1;
 
     /*
      * make the type available everywhere else 
@@ -852,6 +871,9 @@
     netsnmp_clear_default_target();
     netsnmp_clear_default_domain();
     free_etimelist();
+
+    init_snmp_init_done  = 0;
+    _init_snmp_init_done = 0;
 }
 
 
@@ -6592,6 +6614,7 @@
  * may set these error types :
  * SNMPERR_RANGE - type, value, or length not found or out of range
  * SNMPERR_VALUE - value is not correct
+ * SNMPERR_VAR_TYPE - type is not correct
  * SNMPERR_BAD_NAME - name is not found
  *
  * returns 0 if success, error if failure.
@@ -6699,7 +6722,7 @@
             }
             if (!ep) {
 #endif /* NETSNMP_DISABLE_MIB_LOADING */
-                result = SNMPERR_BAD_NAME;
+                result = SNMPERR_RANGE;   /* ?? or SNMPERR_VALUE; */
                 snmp_set_detail(value);
                 break;
 #ifndef NETSNMP_DISABLE_MIB_LOADING
@@ -6925,7 +6948,7 @@
                     ltmp = ep->value;
                 } else {
 #endif /* NETSNMP_DISABLE_MIB_LOADING */
-                    result = SNMPERR_BAD_NAME;
+                    result = SNMPERR_RANGE;   /* ?? or SNMPERR_VALUE; */
                     snmp_set_detail(cp);
                     SNMP_FREE(buf);
 		    SNMP_FREE(vp);

=== modified file 'snmplib/snmp_client.c'
--- snmplib/snmp_client.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmp_client.c	2010-06-10 18:02:54 +0000
@@ -580,7 +580,8 @@
  * The command is set to the input command and the reqid, errstat, and
  * errindex are set to default values.
  * If the error status didn't indicate an error, the error index didn't
- * indicate a variable, the pdu wasn't a get response message, or there
+ * indicate a variable, the pdu wasn't a get response message, the
+ * marked variable was not present in the initial request, or there
  * would be no remaining variables, this function will return 0.
  * If everything was successful, a pointer to the fixed cloned pdu will
  * be returned.
@@ -593,6 +594,7 @@
     if ((pdu->command != SNMP_MSG_RESPONSE)
         || (pdu->errstat == SNMP_ERR_NOERROR)
         || (0 == pdu->variables)
+        || (pdu->errindex > snmp_varbind_len(pdu))
         || (pdu->errindex <= 0)) {
         return 0;               /* pre-condition tests fail */
     }
@@ -642,8 +644,7 @@
 {
     size_t          len = sizeof(oid) * name_length;
 
-    if (vp->name != vp->name_loc && vp->name != NULL &&
-        vp->name_length > (sizeof(vp->name_loc) / sizeof(oid))) {
+    if (vp->name != vp->name_loc && vp->name != NULL) {
         /*
          * Probably previously-allocated "big storage".  Better free it
          * else memory leaks possible.  
@@ -1042,7 +1043,7 @@
             }
         }
 
-        if ( ss->flags &= SNMP_FLAGS_RESP_CALLBACK ) {
+        if ( ss->flags & SNMP_FLAGS_RESP_CALLBACK ) {
             void (*cb)(void);
             cb = ss->myvoid;
             cb();        /* Used to invoke 'netsnmp_check_outstanding_agent_requests();'

=== modified file 'snmplib/snmp_logging.c'
--- snmplib/snmp_logging.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmp_logging.c	2010-06-10 18:02:54 +0000
@@ -174,15 +174,21 @@
 #define LOG_USER	0
 #endif
 
+/*
+ * Decodes log priority.
+ * @param optarg - IN - priority to decode, "0" or "0-7"
+ *                 OUT - points to last character after the decoded priority
+ * @param pri_max - OUT - maximum priority (i.e. 0x7 from "0-7")
+ */
 int
-decode_priority( char *optarg, int *pri_max )
+decode_priority( char **optarg, int *pri_max )
 {
     int pri_low = LOG_DEBUG;
 
-    if (optarg == NULL)
+    if (*optarg == NULL)
         return -1;
 
-    switch (*optarg) {
+    switch (**optarg) {
         case '0': 
         case '!': 
             pri_low = LOG_EMERG;
@@ -223,13 +229,21 @@
             pri_low = LOG_DEBUG;
             break;
         default: 
-            fprintf(stderr, "invalid priority: %c\n",*optarg);
+            fprintf(stderr, "invalid priority: %c\n",**optarg);
             return -1;
     }
+    *optarg = *optarg+1;
 
-    if (pri_max && *(optarg+1)=='-') {
-        *pri_max = decode_priority( optarg+2, NULL );
+    if (pri_max && **optarg=='-') {
+        *optarg = *optarg + 1; /* skip '-' */
+        *pri_max = decode_priority( optarg, NULL );
         if (*pri_max == -1) return -1;
+        if (pri_low < *pri_max) { 
+            int tmp = pri_low; 
+            pri_low = *pri_max; 
+            *pri_max = tmp; 
+        }
+
     }
     return pri_low;
 }
@@ -325,7 +339,7 @@
      * Log to Standard Error
      */
     case 'E':
-        priority = decode_priority( optarg, &pri_max );
+        priority = decode_priority( &optarg, &pri_max );
         if (priority == -1)  return -1;
         if (inc_optind)
             optind++;
@@ -342,7 +356,7 @@
      * Log to Standard Output
      */
     case 'O':
-        priority = decode_priority( optarg, &pri_max );
+        priority = decode_priority( &optarg, &pri_max );
         if (priority == -1)  return -1;
         if (inc_optind)
             optind++;
@@ -360,7 +374,7 @@
      * Log to a named file
      */
     case 'F':
-        priority = decode_priority( optarg, &pri_max );
+        priority = decode_priority( &optarg, &pri_max );
         if (priority == -1 || !argv)  return -1;
         optarg = argv[++optind];
         /* Fallthrough */
@@ -385,9 +399,15 @@
      * Log to syslog
      */
     case 'S':
-        priority = decode_priority( optarg, &pri_max );
+        priority = decode_priority( &optarg, &pri_max );
         if (priority == -1 || !argv)  return -1;
-        optarg++;
+        if (!optarg[0]) {
+            /* The command line argument with priority does not contain log
+             * facility. The facility must be in next argument then. */
+            optind++;
+            if (optind < argc)
+                optarg = argv[optind];
+        }
         /* Fallthrough */
     case 's':
         if (inc_optind)
@@ -411,7 +431,7 @@
      * Don't log 
      */
     case 'N':
-        priority = decode_priority( optarg, &pri_max );
+        priority = decode_priority( &optarg, &pri_max );
         if (priority == -1)  return -1;
         if (inc_optind)
             optind++;
@@ -777,8 +797,8 @@
     netsnmp_log_handler *logh;
     int                  found = 0;
 
-    for (logh = logh_head; logh; logh = logh->next) {
-        if (logh->type == NETSNMP_LOGHANDLER_CALLBACK)
+    for (logh = logh_head; logh; logh = logh->next)
+        if (logh->type == NETSNMP_LOGHANDLER_CALLBACK) {
             logh->enabled = 1;
             found         = 1;
 	}

=== modified file 'snmplib/snmp_version.c'
--- snmplib/snmp_version.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmp_version.c	2010-06-10 18:02:54 +0000
@@ -5,7 +5,7 @@
 #ifndef UCD_COMPATIBLE
 static
 #endif
-const char     *NetSnmpVersionInfo = "5.4.2.1";
+const char     *NetSnmpVersionInfo = "5.4.3";
 
 const char     *
 netsnmp_get_version()

=== removed file 'snmplib/snmplocalsm.c'
--- snmplib/snmplocalsm.c	2007-05-10 22:20:23 +0000
+++ snmplib/snmplocalsm.c	1970-01-01 00:00:00 +0000
@@ -1,259 +0,0 @@
-/*
- * snmplocalsm.c
- *
- * This code implements a security model that assumes the local user
- * that executed the agent is the user who's attributes called
- */
-
-#include <net-snmp/net-snmp-config.h>
-
-#include <net-snmp/net-snmp-includes.h>
-
-#include <net-snmp/library/snmplocalsm.h>
-
-#include <unistd.h>
-
-static int      localsm_session_init(netsnmp_session *);
-static void     localsm_free_state_ref(void *);
-static int      localsm_free_pdu(netsnmp_pdu *);
-static int      localsm_clone_pdu(netsnmp_pdu *, netsnmp_pdu *);
-
-u_int next_sess_id = 1;
-
-/** Initialize the LOCALSM security module */
-void
-init_localsm(void)
-{
-    struct snmp_secmod_def *def;
-    int ret;
-
-    def = SNMP_MALLOC_STRUCT(snmp_secmod_def);
-
-    if (!def) {
-        snmp_log(LOG_ERR,
-                 "Unable to malloc snmp_secmod struct, not registering LOCALSM\n");
-        return;
-    }
-
-    def->encode_reverse = localsm_rgenerate_out_msg;
-    def->decode = localsm_process_in_msg;
-    def->session_open = localsm_session_init;
-    def->pdu_free_state_ref = localsm_free_state_ref;
-    def->pdu_free = localsm_free_pdu;
-    def->pdu_clone = localsm_clone_pdu;
-
-    DEBUGMSGTL(("localsm","registering ourselves\n"));
-    ret = register_sec_mod(NETSNMP_LOCALSM_SECURITY_MODEL, "localsm", def);
-    DEBUGMSGTL(("localsm"," returned %d\n", ret));
-}
-
-/*
- * Initialize specific session information (right now, just set up things to
- * not do an engineID probe)
- */
-
-static int
-localsm_session_init(netsnmp_session * sess)
-{
-    DEBUGMSGTL(("localsm",
-                "LOCALSM: Reached our session initialization callback\n"));
-
-    sess->flags |= SNMP_FLAGS_DONT_PROBE;
-
-    /* XXX: likely needed for something: */
-    /*
-    localsmsession = sess->securityInfo =
-    if (!localsmsession)
-        return SNMPERR_GENERR;
-    */
-
-    return SNMPERR_SUCCESS;
-}
-
-/** Free our state information (this is only done on the agent side) */
-static void
-localsm_free_state_ref(void *ptr)
-{
-    free(ptr);
-}
-
-/** This is called when the PDU is freed. */
-static int
-localsm_free_pdu(netsnmp_pdu *pdu)
-{
-    return SNMPERR_SUCCESS;
-}
-
-/** This is called when a PDU is cloned (to increase reference counts) */
-static int
-localsm_clone_pdu(netsnmp_pdu *pdu, netsnmp_pdu *pdu2)
-{
-    return SNMPERR_SUCCESS;
-}
-
-/* asn.1 easing definitions */
-#define LOCALSMBUILD_OR_ERR(fun, args, msg, desc)       \
-    DEBUGDUMPHEADER("send", desc); \
-    rc = fun args;            \
-    DEBUGINDENTLESS();        \
-    if (rc == 0) { \
-        DEBUGMSGTL(("localsm",msg)); \
-        retval = SNMPERR_TOO_LONG; \
-        goto outerr; \
-    }
-
-#define BUILD_START_SEQ tmpoffset = *offset;
-
-#define BUILD_END_SEQ(x) LOCALSMBUILD_OR_ERR(asn_realloc_rbuild_sequence, \
-                         (wholeMsg, wholeMsgLen, offset, 1, \
-                          (u_char) (ASN_SEQUENCE | ASN_CONSTRUCTOR), \
-                          *offset - tmpoffset), \
-                                          x, "sequence");
-
-/****************************************************************************
- *
- * localsm_generate_out_msg
- *
- * Parameters:
- *	(See list below...)
- *
- * Returns:
- *	SNMPERR_SUCCESS                        On success.
- *	... and others
- *
- *
- * Generate an outgoing message.
- *
- ****************************************************************************/
-
-int
-localsm_rgenerate_out_msg(struct snmp_secmod_outgoing_params *parms)
-{
-    u_char         **wholeMsg = parms->wholeMsg;
-    size_t	   *offset = parms->wholeMsgOffset;
-    int rc;
-    
-    size_t         *wholeMsgLen = parms->wholeMsgLen;
-
-
-    DEBUGMSGTL(("localsm", "Starting LOCALSM processing\n"));
-
-
-    /*
-     * We define here what the security message section will look like:
-     * 04 00 -- null string
-     * XXX: need to actually negotiate a context engine ID?
-     * XXX: leave room for future expansion just in case?
-     */
-    DEBUGDUMPHEADER("send", "localsm security parameters");
-    rc = asn_realloc_rbuild_header(wholeMsg, wholeMsgLen, offset, 1,
-                                     (u_char) (ASN_UNIVERSAL | ASN_PRIMITIVE
-                                             | ASN_OCTET_STR), 0);
-    DEBUGINDENTLESS();
-    if (rc == 0) {
-        DEBUGMSGTL(("localsm", "building msgSecurityParameters failed.\n"));
-        return SNMPERR_TOO_LONG;
-    }
-    
-    /*
-     * Copy in the msgGlobalData and msgVersion.  
-     */
-    while ((*wholeMsgLen - *offset) < parms->globalDataLen) {
-        if (!asn_realloc(wholeMsg, wholeMsgLen)) {
-            DEBUGMSGTL(("localsm", "building global data failed.\n"));
-            return SNMPERR_TOO_LONG;
-        }
-    }
-
-    *offset += parms->globalDataLen;
-    memcpy(*wholeMsg + *wholeMsgLen - *offset,
-           parms->globalData, parms->globalDataLen);
-
-    /*
-     * Total packet sequence.  
-     */
-    rc = asn_realloc_rbuild_sequence(wholeMsg, wholeMsgLen, offset, 1,
-                                     (u_char) (ASN_SEQUENCE |
-                                               ASN_CONSTRUCTOR), *offset);
-    if (rc == 0) {
-        DEBUGMSGTL(("localsm", "building master packet sequence failed.\n"));
-        return SNMPERR_TOO_LONG;
-    }
-
-    DEBUGMSGTL(("localsm", "LOCALSM processing completed.\n"));
-    return SNMPERR_SUCCESS;
-}
-
-/****************************************************************************
- *
- * localsm_process_in_msg
- *
- * Parameters:
- *	(See list below...)
- *
- * Returns:
- *	LOCALSM_ERR_NO_ERROR                        On success.
- *	LOCALSM_ERR_GENERIC_ERROR
- *	LOCALSM_ERR_UNSUPPORTED_SECURITY_LEVEL
- *
- *
- * Processes an incoming message.
- *
- ****************************************************************************/
-
-int
-localsm_process_in_msg(struct snmp_secmod_incoming_params *parms)
-{
-    u_char type_value;
-    size_t octet_string_length;
-    u_char *data_ptr;
-
-    /* we don't have one, so set it to 0 */
-    parms->secEngineID = strdup("");
-    *parms->secEngineIDLen = 0;
-
-    /* if this did not come through a tunneled connection, this
-       security model is in appropriate (and would be a HUGE security
-       hole to assume otherwise) */
-    DEBUGMSGTL(("localsm","checking how we got here\n"));
-    if (!(parms->pdu->flags & UCD_MSG_FLAG_TUNNELED)) {
-        DEBUGMSGTL(("localsm","  not tunneled\n"));
-        return SNMPERR_USM_AUTHENTICATIONFAILURE;
-    } else {
-        DEBUGMSGTL(("localsm","  tunneled\n"));
-    }
-
-
-    /*
-     * Eat the first octet header.
-     */
-    if ((data_ptr = asn_parse_sequence(parms->secParams, &octet_string_length,
-                                        &type_value,
-                                        (ASN_UNIVERSAL | ASN_PRIMITIVE |
-                                         ASN_OCTET_STR),
-                                        "usm first octet")) == NULL) {
-        /*
-         * RETURN parse error 
-         */
-        return -1;
-    }
-    strncpy(parms->secName, strdup(getenv("USER")), *parms->secNameLen);
-    *parms->secNameLen = strlen(parms->secName);
-    DEBUGMSGTL(("localsm", "user: %s/%d\n", parms->secName, parms->secNameLen));
-    
-    *parms->scopedPdu = data_ptr;
-    *parms->scopedPduLen = parms->wholeMsgLen - (data_ptr - parms->wholeMsg);
-    *parms->maxSizeResponse = parms->maxMsgSize; /* XXX */
-    parms->secEngineID = strdup("");
-    *parms->secEngineIDLen = 0;
-    parms->secLevel = SNMP_SEC_LEVEL_NOAUTH;
-/*
- * maybe set this based on the transport in the future:
- *
-*/
-
-    if (octet_string_length != 0)
-        return -1;
-
-    return SNMPERR_SUCCESS;
-}

=== modified file 'snmplib/snmpusm.c'
--- snmplib/snmpusm.c	2009-11-12 16:17:40 +0000
+++ snmplib/snmpusm.c	2010-06-10 18:02:54 +0000
@@ -2594,6 +2594,17 @@
 
             end_of_overhead = value_ptr;
 
+            if ( !user->privKey ) {
+                DEBUGMSGTL(("usm", "No privacy pass phrase for %s\n", user->secName));
+                if (snmp_increment_statistic(STAT_USMSTATSDECRYPTIONERRORS) ==
+                    0) {
+                    DEBUGMSGTL(("usm", "%s\n", "Failed increment statistic."));
+                }
+                usm_free_usmStateReference(*secStateRef);
+                *secStateRef = NULL;
+                return SNMPERR_USM_DECRYPTIONERROR;
+            }
+
             /*
              * XOR the salt with the last (iv_length) bytes
              * of the priv_key to obtain the IV.
@@ -3028,9 +3039,6 @@
  * to facilitate getNext calls on a usmUser table which is indexed by
  * these values.
  * 
- * Note: userList must not be NULL (obviously), as thats a rather trivial
- * addition and is left to the API user.
- * 
  * returns the head of the list (which could change due to this add).
  */
 

=== modified file 'snmplib/snmpv3.c'
--- snmplib/snmpv3.c	2007-12-08 14:59:50 +0000
+++ snmplib/snmpv3.c	2010-06-10 18:02:54 +0000
@@ -747,6 +747,7 @@
     SNMP_FREE(engineID);
     SNMP_FREE(engineIDNic);
     SNMP_FREE(oldEngineID);
+    engineIDIsSet = 0;
     return 0;
 }
 
@@ -882,6 +883,7 @@
                                newuser->authProtocolLen);
     if (ret2 <= 0) {
         config_perror("Could not get proper authentication protocol key length");
+	usm_free_user(newuser);
         return;
     }
     newuser->authKey = (u_char *) malloc(ret2);

=== added file 'snmplib/strtoull.c'
--- snmplib/strtoull.c	1970-01-01 00:00:00 +0000
+++ snmplib/strtoull.c	2010-06-10 18:02:54 +0000
@@ -0,0 +1,283 @@
+/*
+ * An implementation of strtoull() for compilers that do not have this
+ * function, e.g. MSVC.
+ * See also http://www.opengroup.org/onlinepubs/000095399/functions/strtoul.html
+ * for more information about strtoull().
+ */
+
+
+/*
+ * For MSVC, disable the warning "unary minus operator applied to unsigned
+ * type, result still unsigned"
+ */
+#ifdef _MSC_VER
+#pragma warning (disable: 4146)
+#endif
+
+
+#define __STDC_CONSTANT_MACROS  /* Enable UINT64_C in <stdint.h> */
+#define __STDC_FORMAT_MACROS    /* Enable PRIu64 in <inttypes.h> */
+
+#include <net-snmp/net-snmp-config.h>
+
+#include <errno.h>
+#include <ctype.h>
+#include <limits.h>
+#ifdef HAVE_INTTYPES_H
+#include <inttypes.h>
+#endif
+
+#include <net-snmp/types.h>
+#include <net-snmp/library/system.h>
+
+/*
+ * UINT64_C: C99 macro for the suffix for uint64_t constants. 
+ */
+#ifndef UINT64_C
+#ifdef _MSC_VER
+#define UINT64_C(c) c##ui64
+#else
+#define UINT64_C(c) c##ULL
+#endif
+#endif
+
+/*
+ * According to the C99 standard, the constant ULLONG_MAX must be defined in
+ * <limits.h>. Define it here for pre-C99 compilers.
+ */
+#ifndef ULLONG_MAX
+#define ULLONG_MAX UINT64_C(0xffffffffffffffff)
+#endif
+
+#ifdef STRTOULL_UNIT_TEST
+uint64_t
+my_strtoull(const char *nptr, char **endptr, int base)
+#else
+uint64_t
+strtoull(const char *nptr, char **endptr, int base)
+#endif
+{
+    uint64_t        result = 0;
+    const char     *p;
+    const char     *first_nonspace;
+    const char     *digits_start;
+    int             sign = 1;
+    int             out_of_range = 0;
+
+    if (base != 0 && (base < 2 || base > 36))
+        goto invalid_input;
+
+    p = nptr;
+
+    /*
+     * Process the initial, possibly empty, sequence of white-space characters.
+     */
+    while (isspace((unsigned char) (*p)))
+        p++;
+
+    first_nonspace = p;
+
+    /*
+     * Determine sign.
+     */
+    if (*p == '+')
+        p++;
+    else if (*p == '-') {
+        p++;
+        sign = -1;
+    }
+
+    if (base == 0) {
+        /*
+         * Determine base.
+         */
+        if (*p == '0') {
+            if ((p[1] == 'x' || p[1] == 'X')) {
+                if (isxdigit((unsigned char)(p[2]))) {
+                    base = 16;
+                    p += 2;
+                } else {
+                    /*
+                     * Special case: treat the string "0x" without any further
+                     * hex digits as a decimal number.
+                     */
+                    base = 10;
+                }
+            } else {
+                base = 8;
+                p++;
+            }
+        } else {
+            base = 10;
+        }
+    } else if (base == 16) {
+        /*
+         * For base 16, skip the optional "0x" / "0X" prefix.
+         */
+        if (*p == '0' && (p[1] == 'x' || p[1] == 'X')
+            && isxdigit((unsigned char)(p[2]))) {
+            p += 2;
+        }
+    }
+
+    digits_start = p;
+
+    for (; *p; p++) {
+        int             digit;
+        digit = ('0' <= *p && *p <= '9') ? *p - '0'
+            : ('a' <= *p && *p <= 'z') ? (*p - 'a' + 10)
+            : ('A' <= *p && *p <= 'Z') ? (*p - 'A' + 10) : 36;
+        if (digit < base) {
+            if (! out_of_range) {
+                if (result > ULLONG_MAX / base
+                    || result * base > ULLONG_MAX - digit) {
+                    out_of_range = 1;
+                }
+                result = result * base + digit;
+            }
+        } else
+            break;
+    }
+
+    if (p > first_nonspace && p == digits_start)
+        goto invalid_input;
+
+    if (p == first_nonspace)
+        p = nptr;
+
+    if (endptr)
+        *endptr = (char *) p;
+
+    if (out_of_range) {
+        errno = ERANGE;
+        return ULLONG_MAX;
+    }
+
+    return sign > 0 ? result : -result;
+
+  invalid_input:
+    errno = EINVAL;
+    if (endptr)
+        *endptr = (char *) nptr;
+    return 0;
+}
+
+#if defined(STRTOULL_UNIT_TEST)
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#ifndef PRIu64
+#ifdef _MSC_VER
+#define PRIu64 "I64u"
+#else
+#define PRIu64 "llu"
+#endif
+#endif
+
+struct strtoull_testcase {
+    /*
+     * inputs 
+     */
+    const char     *nptr;
+    int             base;
+    /*
+     * expected outputs 
+     */
+    int             expected_errno;
+    int             expected_end;
+    uint64_t        expected_result;
+};
+
+static const struct strtoull_testcase test_input[] = {
+    {"0x0", 0, 0, 3, 0},
+    {"1", 0, 0, 1, 1},
+    {"0x1", 0, 0, 3, 1},
+    {"  -0666", 0, 0, 7, -0666},
+    {"  -0x666", 0, 0, 8, -0x666},
+    {"18446744073709551614", 0, 0, 20, UINT64_C(0xfffffffffffffffe)},
+    {"0xfffffffffffffffe", 0, 0, 18, UINT64_C(0xfffffffffffffffe)},
+    {"18446744073709551615", 0, 0, 20, UINT64_C(0xffffffffffffffff)},
+    {"0xffffffffffffffff", 0, 0, 18, UINT64_C(0xffffffffffffffff)},
+    {"18446744073709551616", 0, ERANGE, 20, UINT64_C(0xffffffffffffffff)},
+    {"0x10000000000000000", 0, ERANGE, 19, UINT64_C(0xffffffffffffffff)},
+    {"ff", 16, 0, 2, 255},
+    {"0xff", 16, 0, 4, 255},
+    {" ", 0, 0, 0, 0},
+    {"0x", 0, 0, 1, 0},
+    {"0x", 8, 0, 1, 0},
+    {"0x", 16, 0, 1, 0},
+    {"zyyy", 0, 0, 0, 0},
+    {"0xfffffffffffffffff", 0, ERANGE, 19, ULLONG_MAX},
+    {"0xfffffffffffffffffz", 0, ERANGE, 19, ULLONG_MAX}
+};
+
+int
+main(void)
+{
+    int             failure_count = 0;
+    unsigned int    i;
+
+    for (i = 0; i < sizeof(test_input) / sizeof(test_input[0]); i++) {
+        const struct strtoull_testcase *const p = &test_input[i];
+        char           *endptr;
+        uint64_t        result;
+
+        errno = 0;
+        result = my_strtoull(p->nptr, &endptr, p->base);
+        if (errno != p->expected_errno) {
+            failure_count++;
+            printf("test %d failed (input \"%s\"): expected errno %d"
+                   ", got errno %d\n",
+                   i, p->nptr, p->expected_errno, errno);
+        }
+        if (result != p->expected_result) {
+            failure_count++;
+            printf("test %d failed (input \"%s\"): expected result %" PRIu64
+                   ", got result %" PRIu64 "\n",
+                   i, p->nptr, p->expected_result, result);
+        }
+        if (endptr - p->nptr != p->expected_end) {
+            failure_count++;
+            printf("test %d failed (input \"%s\"): expected end %d,"
+                   " got end %d\n",
+                   i, p->nptr, p->expected_end, (int) (endptr - p->nptr));
+        }
+
+#if HAVE_STRTOULL
+        errno = 0;
+        result = strtoull(p->nptr, &endptr, p->base);
+        if (errno != p->expected_errno) {
+            failure_count++;
+            printf("test %d (input \"%s\"): expected errno %d"
+                   ", libc strtoull() returned errno %d\n",
+                   i, p->nptr, p->expected_errno, errno);
+        }
+        if (result != p->expected_result) {
+            failure_count++;
+            printf("test %d (input \"%s\"): expected result %" PRIu64
+                   ", libc strtoull() returned result %" PRIu64 "\n",
+                   i, p->nptr, p->expected_result, result);
+        }
+        if (endptr - p->nptr != p->expected_end) {
+            failure_count++;
+            printf("test %d (input \"%s\"): expected end %d,"
+                   " libc strtoull() returned end %d\n",
+                   i, p->nptr, p->expected_end, (int) (endptr - p->nptr));
+        }
+#endif
+    }
+    if (failure_count == 0)
+        printf("All %d tests passed.\n", i);
+    return 0;
+}
+
+#endif /* defined(STRTOULL_UNIT_TEST) */
+
+/*
+ * Local variables:
+ * c-basic-offset: 4
+ * indent-tabs-mode: nil
+ * compile-command: "gcc -Wall -Werror -DSTRTOULL_UNIT_TEST=1 -I../include -g -o strtoull-unit-test strtoull.c && ./strtoull-unit-test"
+ * End:
+ */

=== modified file 'snmplib/system.c'
--- snmplib/system.c	2009-11-12 16:17:40 +0000
+++ snmplib/system.c	2010-06-10 18:02:54 +0000
@@ -40,6 +40,12 @@
 #include <ctype.h>
 #include <errno.h>
 
+#if HAVE_IO_H
+#include <io.h>
+#endif
+#if HAVE_DIRECT_H
+#include <direct.h>
+#endif
 #if HAVE_UNISTD_H
 #include <unistd.h>
 #endif
@@ -1096,14 +1102,13 @@
 #else
     if (mktemp(name)) {
 # ifndef WIN32
-        fd = open(name, O_CREAT | O_EXCL | O_WRONLY);
+        fd = open(name, O_CREAT | O_EXCL | O_WRONLY, S_IRUSR | S_IWUSR);
 # else
         /*
          * Win32 needs _S_IREAD | _S_IWRITE to set permissions on file
          * after closing
          */
-        fd = _open(name, _O_CREAT,
-                   _S_IREAD | _S_IWRITE | _O_EXCL | _O_WRONLY);
+        fd = _open(name, _O_CREAT | _O_EXCL | _O_WRONLY, _S_IREAD | _S_IWRITE);
 # endif
     }
 #endif

=== modified file 'snmplib/tools.c'
--- snmplib/tools.c	2007-12-08 14:59:50 +0000
+++ snmplib/tools.c	2010-06-10 18:02:54 +0000
@@ -696,7 +696,7 @@
         /*
          * s += snprintf(s, remaining_len+3, "\"%s\"", esp); 
          */
-        s += sprintf(s, "\"%s\"", esp);
+        s += sprintf(s, "\"%.*s\"", sizeof(buf)-strlen(buf)-3, esp);
         goto dump_snmpEngineID_quit;
         break;
      /*NOTREACHED*/ case 5:    /* Octets. */

=== modified file 'snmplib/vacm.c'
--- snmplib/vacm.c	2007-12-08 14:59:50 +0000
+++ snmplib/vacm.c	2010-06-10 18:02:54 +0000
@@ -627,7 +627,7 @@
             }
         }
     }
-    DEBUGMSGTL(("9:vacm:checkSubtree", " %s matched\n", vp->viewName));
+    DEBUGMSGTL(("9:vacm:checkSubtree", " %s matched\n", viewName));
 
     /*
      * If we found a matching view subtree with a longer OID than the provided
@@ -887,11 +887,50 @@
 }
 
 struct vacm_accessEntry *
+_vacm_choose_best( struct vacm_accessEntry *current,
+                   struct vacm_accessEntry *candidate)
+{
+    /*
+     * RFC 3415: vacmAccessTable:
+     *    2) if this set has [more than] one member, ...
+     *       it comes down to deciding how to weight the
+     *       preferences between ContextPrefixes,
+     *       SecurityModels, and SecurityLevels
+     */
+    if (( !current ) ||
+        /* a) if the subset of entries with securityModel
+         *    matching the securityModel in the message is
+         *    not empty, then discard the rest
+         */
+        (  current->securityModel == SNMP_SEC_MODEL_ANY &&
+         candidate->securityModel != SNMP_SEC_MODEL_ANY ) ||
+        /* b) if the subset of entries with vacmAccessContextPrefix
+         *    matching the contextName in the message is
+         *    not empty, then discard the rest
+         */
+        (  current->contextMatch  == CONTEXT_MATCH_PREFIX &&
+         candidate->contextMatch  == CONTEXT_MATCH_EXACT ) ||
+        /* c) discard all entries with ContextPrefixes shorter
+         *    than the longest one remaining in the set
+         */
+        (  current->contextMatch  == CONTEXT_MATCH_PREFIX &&
+           current->contextPrefix[0] < candidate->contextPrefix[0] ) ||
+        /* d) select the entry with the highest securityLevel
+         */
+        (  current->securityLevel < candidate->securityLevel )) {
+
+        return candidate;
+    }
+
+    return current;
+}
+
+struct vacm_accessEntry *
 vacm_getAccessEntry(const char *groupName,
                     const char *contextPrefix,
                     int securityModel, int securityLevel)
 {
-    struct vacm_accessEntry *vp;
+    struct vacm_accessEntry *vp, *best=NULL;
     char            group[VACMSTRINGLEN];
     char            context[VACMSTRINGLEN];
     int             glen, clen;
@@ -920,9 +959,9 @@
                  && clen >= vp->contextPrefix[0]
                  && (memcmp(vp->contextPrefix + 1, context + 1,
                             vp->contextPrefix[0]) == 0))))
-            return vp;
+            best = _vacm_choose_best( best, vp );
     }
-    return NULL;
+    return best;
 }
 
 void

=== modified file 'snmplib/winpipe.c'
--- snmplib/winpipe.c	2009-11-12 16:17:40 +0000
+++ snmplib/winpipe.c	2010-06-10 18:02:54 +0000
@@ -32,6 +32,8 @@
 
 #ifdef WIN32
 
+#include <net-snmp/net-snmp-config.h>
+#include <net-snmp/library/snmp_assert.h>
 #include <io.h>
 #include <winsock.h>
 
@@ -42,6 +44,7 @@
 
 	if( (*sock = socket(AF_INET, SOCK_DGRAM, 0)) == SOCKET_ERROR)
 	{
+		netsnmp_assert(GetLastError() != WSANOTINITIALISED);
 		return -1;
 	}
 	socketaddress->sin_family = AF_INET;

=== modified file 'snmplib/winservice.c'
--- snmplib/winservice.c	2007-05-10 22:20:23 +0000
+++ snmplib/winservice.c	2010-06-10 18:02:54 +0000
@@ -31,6 +31,10 @@
 
 #endif /* mingw32 */
 
+
+#define CountOf(arr) ( sizeof(arr) / sizeof(arr[0]) )
+
+
     /*
      * External global variables used here
      */
@@ -105,7 +109,7 @@
   SC_HANDLE hSCManager = NULL;
   SC_HANDLE hService = NULL;
   TCHAR szRegAppLogKey[] =
-    "SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\";
+    _T("SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\");
   TCHAR szRegKey[512];
   HKEY hKey = NULL;		/* Key to registry entry */
   HKEY hParamKey = NULL;	/* To store startup parameters */
@@ -130,7 +134,7 @@
     /*
      * Generate the Command to be executed by SCM 
      */
-    _snprintf (szServiceCommand, sizeof(szServiceCommand), "%s %s", szServicePath, _T ("-service"));
+    _sntprintf (szServiceCommand, CountOf(szServiceCommand), _T("%s %s"), szServicePath, _T ("-service"));
 
     /*
      * Create the Desired service 
@@ -145,7 +149,7 @@
 			      NULL);	/* password */
     if (hService == NULL)
       {
-	_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+	_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 		   _T ("Can't create service"), lpszServiceDisplayName);
         ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
 
@@ -167,7 +171,7 @@
      */
     if (RegCreateKey (HKEY_LOCAL_MACHINE, szRegKey, &hKey) != ERROR_SUCCESS)
       {
-	_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+	_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 		   _T ("is unable to create registry entries"), lpszServiceDisplayName);
         ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
         exitStatus = SERVICE_ERROR_CREATE_REGISTRY_ENTRIES;
@@ -177,7 +181,7 @@
     /*
      * Add Event ID message file name to the 'EventMessageFile' subkey 
      */
-    RegSetValueEx (hKey, "EventMessageFile", 0, REG_EXPAND_SZ,
+    RegSetValueEx (hKey, _T("EventMessageFile"), 0, REG_EXPAND_SZ,
 		   (CONST BYTE *) szServicePath,
 		   _tcslen (szServicePath) + sizeof (TCHAR));
 
@@ -185,7 +189,7 @@
      * Set the supported types flags. 
      */
     dwData = EVENTLOG_ERROR_TYPE | EVENTLOG_WARNING_TYPE | EVENTLOG_INFORMATION_TYPE;
-    RegSetValueEx (hKey, "TypesSupported", 0, REG_DWORD,
+    RegSetValueEx (hKey, _T("TypesSupported"), 0, REG_DWORD,
 		   (CONST BYTE *) & dwData, sizeof (DWORD));
 
     /*
@@ -211,7 +215,7 @@
 	if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, szRegKey, 0, KEY_WRITE,
 			  &hKey) != ERROR_SUCCESS)
 	  {
-	    _snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+	    _sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 		       _T ("is unable to create registry entries"),
 		       lpszServiceDisplayName);
             ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
@@ -224,12 +228,12 @@
 	 */
 	if (lpszServiceDescription != NULL)
 	  {
-	    if (RegSetValueEx (hKey, "Description", 0, REG_SZ,
+	    if (RegSetValueEx (hKey, _T("Description"), 0, REG_SZ,
 			       (CONST BYTE *) lpszServiceDescription,
 			       _tcslen (lpszServiceDescription) +
 			       sizeof (TCHAR)) != ERROR_SUCCESS)
 	      {
-		_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+		_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 			   _T ("is unable to create registry entries"),
 			   lpszServiceDisplayName);
                 ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
@@ -247,11 +251,11 @@
 	     * Create Subkey parameters 
 	     */
 	    if (RegCreateKeyEx
-		(hKey, "Parameters", 0, NULL,
+		(hKey, _T("Parameters"), 0, NULL,
 		 REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL,
 		 &hParamKey, NULL) != ERROR_SUCCESS)
 	      {
-		_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+		_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 			   _T ("is unable to create registry entries"),
 			   lpszServiceDisplayName);
                 ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
@@ -273,7 +277,7 @@
 
 	    for (j = 1; i < StartUpArg->Argc; i++, j++)
 	      {
-		_snprintf (szRegKey, sizeof(szRegKey), "%s%d", _T ("Param"), j);
+		_sntprintf (szRegKey, CountOf(szRegKey), _T("%s%d"), _T ("Param"), j);
 
 		/*
 		 * Create registry key 
@@ -284,7 +288,7 @@
 		     _tcslen (StartUpArg->Argv[i]) +
 		     sizeof (TCHAR)) != ERROR_SUCCESS)
 		  {
-		    _snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s",
+		    _sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"),
 			       _T ("is unable to create registry entries"),
 			       lpszServiceDisplayName);
                     ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
@@ -308,7 +312,7 @@
     /*
      * Successfully registered as service 
      */
-    _snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s", lpszServiceName,
+    _sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"), lpszServiceName,
 	       _T ("successfully registered as a service"));
 
     /*
@@ -336,14 +340,14 @@
      * Input - ServiceName
      */
 int
-UnregisterService (LPCSTR lpszServiceName, int quiet)
+UnregisterService (LPCTSTR lpszServiceName, int quiet)
 {
   TCHAR MsgErrorString[MAX_STR_SIZE];	/* Message or Error string */
   SC_HANDLE hSCManager = NULL;	/* SCM handle */
   SC_HANDLE hService = NULL;	/* Service Handle */
   SERVICE_STATUS sStatus;
   TCHAR szRegAppLogKey[] =
-    "SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\";
+    _T("SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\");
   TCHAR szRegKey[512];
   int exitStatus = 0;
 /*  HKEY hKey = NULL;		?* Key to registry entry */
@@ -366,7 +370,7 @@
     hService = OpenService (hSCManager, lpszServiceName, SERVICE_ALL_ACCESS);
     if (hService == NULL)
       {
-	_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s", _T ("Can't open service"),
+	_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"), _T ("Can't open service"),
 		   lpszServiceName);
         ProcessError (EVENTLOG_ERROR_TYPE, MsgErrorString, 1, quiet);
         exitStatus = SERVICE_ERROR_OPEN_SERVICE;       
@@ -391,7 +395,7 @@
      */
     if (DeleteService (hService) == FALSE)
       {
-	_snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s", _T ("Can't delete service"),
+	_sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"), _T ("Can't delete service"),
 		   lpszServiceName);
 
 	/*
@@ -404,7 +408,7 @@
     /*
      * Log "Service deleted successfully " message to eventlog
      */
-    _snprintf (MsgErrorString, sizeof(MsgErrorString), "%s %s", lpszServiceName, _T ("service deleted"));
+    _sntprintf (MsgErrorString, CountOf(MsgErrorString), _T("%s %s"), lpszServiceName, _T ("service deleted"));
     ProcessError (EVENTLOG_INFORMATION_TYPE, MsgErrorString, 0, quiet);
 
     /*
@@ -440,7 +444,7 @@
   va_list ArgList;
   HANDLE hEventSource = NULL;
   va_start (ArgList, pszFormat);
-  _vsnprintf (szMessage, sizeof(szMessage), pszFormat, ArgList);
+  _vsntprintf (szMessage, CountOf(szMessage), pszFormat, ArgList);
   va_end (ArgList);
   LogStr[0] = szMessage;
   hEventSource = RegisterEventSource (NULL, app_name_long);
@@ -533,14 +537,14 @@
 		 MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) & pErrorMsgTemp, 0, NULL);
 
-    _snprintf (pszMessageFull, sizeof(pszMessageFull), "%s: %s", pszMessage, pErrorMsgTemp);
+    _sntprintf (pszMessageFull, CountOf(pszMessageFull), _T("%s: %s"), pszMessage, pErrorMsgTemp);
     if (pErrorMsgTemp) {
       LocalFree (pErrorMsgTemp);
       pErrorMsgTemp = NULL;
     }
   }
   else {
-    _snprintf (pszMessageFull, sizeof(pszMessageFull), "%s", pszMessage);
+    _sntprintf (pszMessageFull, CountOf(pszMessageFull), _T("%s"), pszMessage);
   }
   
   hEventSource = RegisterEventSource (NULL, app_name_long);
@@ -562,8 +566,7 @@
           FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError (),
           MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT),
           (LPTSTR) & pErrorMsgTemp, 0, NULL);
-      
-      fprintf(stderr,"Could NOT lot to Event Log.  Error returned from ReportEvent(): %s\n",pErrorMsgTemp);
+      _ftprintf(stderr,_T("Could NOT lot to Event Log.  Error returned from ReportEvent(): %s\n"),pErrorMsgTemp);
       if (pErrorMsgTemp) {
         LocalFree (pErrorMsgTemp);
         pErrorMsgTemp = NULL;
@@ -573,7 +576,7 @@
     }
 
       if (quiet) {
-    fprintf(stderr,"%s\n",pszMessageFull);
+    _ftprintf(stderr,_T("%s\n"),pszMessageFull);
       }
       else {
     switch (eventLogType) {
@@ -651,7 +654,7 @@
 ServiceMain (DWORD argc, LPTSTR argv[])
 {
   SECURITY_ATTRIBUTES SecurityAttributes;
-  DWORD dwThreadId;
+  unsigned threadId;
 
   /*
    * Input Arguments to function startup 
@@ -683,9 +686,9 @@
   /*
    * Create Registry Key path 
    */
-  _snprintf (szRegKey, sizeof(szRegKey), "%s%s\\%s",
+  _sntprintf (szRegKey, CountOf(szRegKey), _T("%s%s\\%s"),
 	     _T ("SYSTEM\\CurrentControlSet\\Services\\"), app_name_long,
-	     "Parameters");
+	     _T("Parameters"));
   if (RegOpenKeyEx
       (HKEY_LOCAL_MACHINE, szRegKey, 0, KEY_ALL_ACCESS, &hParamKey) == ERROR_SUCCESS)
     {
@@ -725,7 +728,7 @@
 		  /*
 		   * Create Subkey value name 
 		   */
-		  _snprintf (szRegKey, sizeof(szRegKey), "%s%d", "Param", i);
+		  _sntprintf (szRegKey, CountOf(szRegKey), _T("%s%d"), _T("Param"), i);
 
 		  /*
 		   * Set size 
@@ -785,7 +788,7 @@
     hServiceThread =
       (void *) _beginthreadex (&SecurityAttributes, 0,
 			       ThreadFunction,
-			       (void *) &ThreadInputParams, 0, &dwThreadId);
+			       (void *) &ThreadInputParams, 0, &threadId);
     if (hServiceThread == NULL)
       {
 	WriteToEventLog (EVENTLOG_ERROR_TYPE, _T ("Couldn't start worker thread"));
@@ -998,7 +1001,7 @@
      * Input:
      *   lpParam contains argc and argv, pass to service main function 
      */
-DWORD WINAPI
+unsigned WINAPI
 ThreadFunction (LPVOID lpParam)
 {
   InputParams * pInputArg = (InputParams *) lpParam;

=== modified file 'testing/TESTCONF.sh'
--- testing/TESTCONF.sh	2007-12-08 14:59:50 +0000
+++ testing/TESTCONF.sh	2010-06-10 18:02:54 +0000
@@ -79,6 +79,7 @@
     export SNMP_TMP_PERSISTENTDIR
     mkdir $SNMP_TMPDIR
     mkdir $SNMP_TMP_PERSISTENTDIR
+    chmod 0700 $SNMP_TMPDIR $SNMP_TMP_PERSISTENTDIR
 fi
 
 if [ "x$SNMP_SAVE_TMPDIR" = "x" ]; then
@@ -86,6 +87,7 @@
     export SNMP_SAVE_TMPDIR
 fi
 
+SNMP_ENV_SEPARATOR="`$SNMP_UPDIR/net-snmp-config --env-separator`"
 SNMP_PERLPROG="`$SNMP_UPDIR/net-snmp-config --perlprog`"
 SNMP_TESTDIR="$SNMP_BASEDIR/tests"
 SNMP_CONFIG_FILE="$SNMP_TMPDIR/snmpd.conf"
@@ -97,7 +99,7 @@
 SNMP_SNMPD_LOG_FILE="$SNMP_TMPDIR/snmpd.log"
 SNMP_AGENTX_PID_FILE="$SNMP_TMPDIR/agentx.pid"
 SNMP_AGENTX_LOG_FILE="$SNMP_TMPDIR/agentx.log"
-SNMPCONFPATH=${SNMP_TMPDIR}:${SNMP_TMP_PERSISTENTDIR}
+SNMPCONFPATH="${SNMP_TMPDIR}${SNMP_ENV_SEPARATOR}${SNMP_TMP_PERSISTENTDIR}"
 export SNMPCONFPATH
 SNMP_PERSISTENT_DIR=$SNMP_TMP_PERSISTENTDIR
 export SNMP_PERSISTENT_DIR
@@ -118,6 +120,12 @@
 elif test -x /usr/etc/netstat ; then
     # e.g. IRIX
     NETSTAT=/usr/etc/netstat
+elif test -x /cygdrive/c/windows/system32/netstat ; then
+    # Cygwin
+    NETSTAT=/cygdrive/c/windows/system32/netstat
+elif test -x /c/Windows/System32/netstat ; then
+    # MinGW + MSYS
+    NETSTAT=/c/Windows/System32/netstat
 else
     NETSTAT=""
 fi

=== modified file 'testing/eval_suite.sh'
--- testing/eval_suite.sh	2004-09-13 12:06:21 +0000
+++ testing/eval_suite.sh	2010-06-10 18:02:54 +0000
@@ -79,7 +79,12 @@
 PROGRAM=
 ARGUMENTS="$*"
 
-TMPFILE=/tmp/eval_suite.sh$$
+umask 0077 # just to be on the safe side
+SNMP_TMPDIR=/tmp/net-snmpd-eval-dir.$$
+rm -rf $SNMP_TMPDIR
+mkdir $SNMP_TMPDIR || exit -1
+chmod 0700 $SNMP_TMPDIR
+TMPFILE=$SNMP_TMPDIR/eval_suite.sh$$
 
 TESTLISTFILE=eval_testlist
 
@@ -205,6 +210,7 @@
 # Cleanup, exit.
 #
 rm -f $TMPFILE
+rm -rf $SNMP_TMPDIR
 
 exit $TESTFAILURE
 

=== modified file 'testing/tests/T030snmpv3usercreation'
--- testing/tests/T030snmpv3usercreation	2009-11-12 16:17:40 +0000
+++ testing/tests/T030snmpv3usercreation	2010-06-10 18:02:54 +0000
@@ -99,7 +99,7 @@
 STOPAGENT
 DELAY
 # make sure it picks up persistent config and uses a new logfile
-SNMPCONFPATH=${SNMP_TMPDIR}:${SNMP_TMP_PERSISTENTDIR}
+SNMPCONFPATH="${SNMP_TMPDIR}${SNMP_ENV_SEPARATOR}${SNMP_TMP_PERSISTENTDIR}"
 export SNMPCONFPATH
 SNMP_CONFIG_FILE="does-not-exist"
 SNMP_SNMPD_LOG_FILE=${SNMP_TMPDIR}/snmpd2.log

=== modified file 'testing/tests/T053agentv1trap'
--- testing/tests/T053agentv1trap	2007-05-10 22:20:23 +0000
+++ testing/tests/T053agentv1trap	2010-06-10 18:02:54 +0000
@@ -12,7 +12,7 @@
 
 # standard V1 configuration: testcomunnity
 . ./Sv3config
-CONFIGAGENT trapsink localhost public $SNMP_SNMPTRAPD_PORT
+CONFIGAGENT trapsink ${SNMP_TRANSPORT_SPEC}:${SNMP_TEST_DEST}${SNMP_SNMPTRAPD_PORT} public
 
 CONFIGTRAPD authcommunity log public
 CONFIGTRAPD agentxsocket /dev/null

=== modified file 'testing/tests/T054agentv2ctrap'
--- testing/tests/T054agentv2ctrap	2007-05-10 22:20:23 +0000
+++ testing/tests/T054agentv2ctrap	2010-06-10 18:02:54 +0000
@@ -12,7 +12,7 @@
 
 # standard V1 configuration: testcommunity
 . ./Sv3config
-CONFIGAGENT trap2sink localhost public $SNMP_SNMPTRAPD_PORT
+CONFIGAGENT trap2sink ${SNMP_TRANSPORT_SPEC}:${SNMP_TEST_DEST}${SNMP_SNMPTRAPD_PORT} public
 CONFIGTRAPD authcommunity log public
 CONFIGTRAPD agentxsocket /dev/null
 

=== modified file 'testing/tests/T055agentv1mintrap'
--- testing/tests/T055agentv1mintrap	2007-05-10 22:20:23 +0000
+++ testing/tests/T055agentv1mintrap	2010-06-10 18:02:54 +0000
@@ -12,7 +12,7 @@
 
 # standard V1 configuration: testcommunity
 . ./Sv3config
-CONFIGAGENT trapsink localhost public $SNMP_SNMPTRAPD_PORT
+CONFIGAGENT trapsink ${SNMP_TRANSPORT_SPEC}:${SNMP_TEST_DEST}${SNMP_SNMPTRAPD_PORT} public
 CONFIGTRAPD authcommunity log public
 CONFIGTRAPD agentxsocket /dev/null
 

=== modified file 'testing/tests/T056agentv2cmintrap'
--- testing/tests/T056agentv2cmintrap	2007-05-10 22:20:23 +0000
+++ testing/tests/T056agentv2cmintrap	2010-06-10 18:02:54 +0000
@@ -12,7 +12,7 @@
 
 # standard V1 configuration: testcommunity
 . ./Sv3config
-CONFIGAGENT trap2sink localhost public $SNMP_SNMPTRAPD_PORT
+CONFIGAGENT trap2sink ${SNMP_TRANSPORT_SPEC}:${SNMP_TEST_DEST}${SNMP_SNMPTRAPD_PORT} public
 CONFIGTRAPD authcommunity log public
 CONFIGTRAPD agentxsocket /dev/null
 

=== modified file 'testing/tests/T059trapdtraphandle'
--- testing/tests/T059trapdtraphandle	2009-11-12 16:17:40 +0000
+++ testing/tests/T059trapdtraphandle	2010-06-10 18:02:54 +0000
@@ -22,6 +22,7 @@
 TESTCOMMUNITY=testcommunity
 
 CONFIGTRAPD [snmp] persistentDir $SNMP_TMP_PERSISTENTDIR
+CONFIGTRAPD [snmp] tempFilePattern /tmp/snmpd-tmp-XXXXXX
 CONFIGTRAPD authcommunity execute $TESTCOMMUNITY
 CONFIGTRAPD doNotLogTraps true
 CONFIGTRAPD traphandle default $0 $1 traphandle

=== modified file 'testing/tests/T113agentxtrap'
--- testing/tests/T113agentxtrap	2007-05-10 22:20:23 +0000
+++ testing/tests/T113agentxtrap	2010-06-10 18:02:54 +0000
@@ -19,7 +19,7 @@
 # standard V3 configuration for initial user
 . ./Sv3config
 # configure the trap receiver.
-CONFIGAGENT trapsink localhost public $SNMP_SNMPTRAPD_PORT
+CONFIGAGENT trapsink ${SNMP_TRANSPORT_SPEC}:${SNMP_TEST_DEST}${SNMP_SNMPTRAPD_PORT} public
 
 # Start the agent without initializing the example mib.
 if [ "x$SNMP_TRANSPORT_SPEC" = "xunix" ];then

=== modified file 'testing/tests/T115agentxperl'
--- testing/tests/T115agentxperl	2009-11-12 16:17:40 +0000
+++ testing/tests/T115agentxperl	2010-06-10 18:02:54 +0000
@@ -114,7 +114,7 @@
 export LD_LIBRARY_PATH DYLD_LIBRARY_PATH SHLIB_PATH
 
 # start perl subagent
-/usr/bin/env SNMPCONFPATH="${SNMP_TMPDIR}:${SNMP_TMP_PERSISTENTDIR}" $SNMP_PERLPROG $PERL_SUBAGENT $SNMP_AGENTX_PID_FILE >$SNMP_AGENTX_LOG_FILE 2>&1
+/usr/bin/env SNMPCONFPATH="${SNMP_TMPDIR}${SNMP_ENV_SEPARATOR}${SNMP_TMP_PERSISTENTDIR}" $SNMP_PERLPROG $PERL_SUBAGENT $SNMP_AGENTX_PID_FILE >$SNMP_AGENTX_LOG_FILE 2>&1
 DELAY
 
 ## 1) SNMP GET against mib object implemented by the perl subagent

=== modified file 'win32/Configure'
--- win32/Configure	2009-11-12 16:17:40 +0000
+++ win32/Configure	2010-06-10 18:02:54 +0000
@@ -258,8 +258,10 @@
     s/^OUTDIR=/OUTDIR=.\\$outdir/;
     s/^INTDIR=/INTDIR=.\\$intdir/;
     s/^SSL=.*/SSL=$openssl/;
-    s/#(.*?)\s+# uncomment for winExtDLL.*/$1/;
-    s/^LIB32_FLAGS=(.*)/LIB32_FLAGS=MgmtAPI.lib snmpapi.lib $1/;
+    if ($b_winextdll == 1) {
+      s/#(.*?)\s+# uncomment for winExtDLL.*/$1/;
+      s/^LIB32_FLAGS=(.*)/LIB32_FLAGS=MgmtAPI.lib snmpapi.lib $1/;
+    }
     print MAKE_OUT $_ . "\n";
   }
 }

=== added file 'win32/MgmtApi-winExtDLL.h'
--- win32/MgmtApi-winExtDLL.h	1970-01-01 00:00:00 +0000
+++ win32/MgmtApi-winExtDLL.h	2010-06-10 18:02:54 +0000
@@ -0,0 +1,77 @@
+/*
+ * This file is a copy of the header file <snmp.h> from the MinGW project.
+ * The licensing for the Win32 API is defined in the
+ * MinGW file README.w32api, which states:
+
+   "Unless otherwise stated in individual source files,
+
+    THIS SOFTWARE IS NOT COPYRIGHTED
+
+    This source code is offered for use in the public domain.  You may use,
+    modify or distribute it freely.
+
+    This source code is distributed in the hope that it will be useful but
+    WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
+    DISCLAIMED.  This includes but is not limited to warranties of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
+
+ */
+
+/*
+  mgmtapi.h - Header file for the SNMP Management API
+
+  Written by Filip Navara <xnavara@volny.cz>
+
+  References (2003-08-25):
+    http://msdn.microsoft.com/library/en-us/snmp/snmp/snmp_reference.asp
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+*/
+
+#ifndef _MGMTAPI_H
+#define _MGMTAPI_H
+#if __GNUC__ >= 3
+#pragma GCC system_header
+#endif
+
+#ifndef _SNMP_H
+#include <snmp.h>
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define SNMP_MGMTAPI_TIMEOUT	40
+#define SNMP_MGMTAPI_SELECT_FDERRORS	41
+#define SNMP_MGMTAPI_TRAP_ERRORS	42
+#define SNMP_MGMTAPI_TRAP_DUPINIT	43
+#define SNMP_MGMTAPI_NOTRAPS	44
+#define SNMP_MGMTAPI_AGAIN	45
+#define SNMP_MGMTAPI_INVALID_CTL	46
+#define SNMP_MGMTAPI_INVALID_SESSION	47
+#define SNMP_MGMTAPI_INVALID_BUFFER	48
+#define MGMCTL_SETAGENTPORT	1
+
+#ifndef RC_INVOKED
+
+typedef PVOID LPSNMP_MGR_SESSION;
+
+BOOL WINSNMPAPI SnmpMgrClose(LPSNMP_MGR_SESSION);
+BOOL WINSNMPAPI SnmpMgrCtl(LPSNMP_MGR_SESSION,DWORD,LPVOID,DWORD,LPVOID,DWORD,LPDWORD);
+BOOL WINSNMPAPI SnmpMgrGetTrap(AsnObjectIdentifier*,AsnNetworkAddress*,AsnInteger*,AsnInteger*,AsnTimeticks*,SnmpVarBindList*);
+BOOL WINSNMPAPI SnmpMgrGetTrapEx(AsnObjectIdentifier*,AsnNetworkAddress*,AsnNetworkAddress*,AsnInteger*,AsnInteger*,AsnOctetString*,AsnTimeticks*,SnmpVarBindList*);
+BOOL WINSNMPAPI SnmpMgrOidToStr(AsnObjectIdentifier*,LPSTR*);
+LPSNMP_MGR_SESSION WINSNMPAPI SnmpMgrOpen(LPSTR,LPSTR,INT,INT);
+INT WINSNMPAPI SnmpMgrRequest(LPSNMP_MGR_SESSION,BYTE,SnmpVarBindList*,AsnInteger*,AsnInteger*);
+BOOL WINSNMPAPI SnmpMgrStrToOid(LPSTR,AsnObjectIdentifier*);
+BOOL WINSNMPAPI SnmpMgrTrapListen(HANDLE*);
+
+#endif /* RC_INVOKED */
+
+#ifdef __cplusplus
+}
+#endif
+#endif

=== added file 'win32/Snmp-winExtDLL.h'
--- win32/Snmp-winExtDLL.h	1970-01-01 00:00:00 +0000
+++ win32/Snmp-winExtDLL.h	2010-06-10 18:02:54 +0000
@@ -0,0 +1,278 @@
+/*
+ * This file is a copy of the header file <snmp.h> from the MinGW project.
+ * The licensing for the Win32 API is defined in the
+ * MinGW file README.w32api, which states:
+
+   "Unless otherwise stated in individual source files,
+
+    THIS SOFTWARE IS NOT COPYRIGHTED
+
+    This source code is offered for use in the public domain.  You may use,
+    modify or distribute it freely.
+
+    This source code is distributed in the hope that it will be useful but
+    WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
+    DISCLAIMED.  This includes but is not limited to warranties of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
+
+ */
+
+/*
+  snmp.h - Header file for the Windows SNMP API
+
+  Written by Filip Navara <xnavara@volny.cz>
+
+  References (2003-08-25):
+    http://msdn.microsoft.com/library/en-us/snmp/snmp/snmp_reference.asp
+
+  This library is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+*/
+
+#ifndef _SNMP_H
+#define _SNMP_H
+#if __GNUC__ >= 3
+#pragma GCC system_header
+#endif
+
+#ifndef _WINDOWS_H
+#include <windows.h>
+#endif
+
+#include <pshpack4.h>
+
+#ifndef WINSNMPAPI
+#define WINSNMPAPI WINAPI
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define DEFAULT_SNMP_PORT_UDP	161
+#define DEFAULT_SNMP_PORT_IPX	36879
+#define DEFAULT_SNMPTRAP_PORT_UDP	162
+#define DEFAULT_SNMPTRAP_PORT_IPX	36880
+#ifndef _SNMP_ASN_DEFINED
+#define _SNMP_ASN_DEFINED
+#define MS_ASN_UNIVERSAL	0x00
+#define MS_ASN_PRIMITIVE	0x00
+#define MS_ASN_CONSTRUCTOR	0x20
+#define MS_ASN_APPLICATION	0x40
+#define MS_ASN_CONTEXT	0x80
+#define MS_ASN_PRIVATE	0xC0
+#define SNMP_PDU_GET	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 0)
+#define SNMP_PDU_GETNEXT	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 1)
+#define SNMP_PDU_RESPONSE	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 2)
+#define SNMP_PDU_SET	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 3)
+#define SNMP_PDU_GETBULK	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 4)
+#define SNMP_PDU_V1TRAP	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 4)
+#define SNMP_PDU_INFORM	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 6)
+#define SNMP_PDU_TRAP	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 7) 
+#define SNMP_PDU_REPORT	(ASN_CONTEXT | MS_ASN_CONSTRUCTOR | 8)
+#endif /* _SNMP_ASN_DEFINED */
+#define MS_ASN_INTEGER	(ASN_UNIVERSAL | MS_ASN_PRIMITIVE | 2)
+#define MS_ASN_BITS	(ASN_UNIVERSAL | MS_ASN_PRIMITIVE | 3)
+#define MS_ASN_OCTETSTRING	(ASN_UNIVERSAL | MS_ASN_PRIMITIVE | 4)
+#define MS_ASN_NULL	(ASN_UNIVERSAL | MS_ASN_PRIMITIVE | 5)
+#define MS_ASN_OBJECTIDENTIFIER	(ASN_UNIVERSAL | MS_ASN_PRIMITIVE | 6)
+#define MS_ASN_INTEGER32	ASN_INTEGER
+#define MS_ASN_SEQUENCE	(ASN_UNIVERSAL | MS_ASN_CONSTRUCTOR | 0x10)
+#define MS_ASN_SEQUENCEOF	ASN_SEQUENCE
+#define MS_ASN_IPADDRESS	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x00)
+#define MS_ASN_COUNTER32	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x01)
+#define MS_ASN_GAUGE32	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x02)
+#define MS_ASN_TIMETICKS	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x03)
+#define MS_ASN_OPAQUE	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x04)
+#define MS_ASN_COUNTER64	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x06)
+#define MS_ASN_UNSIGNED32	(ASN_APPLICATION | MS_ASN_PRIMITIVE | 0x07)
+#define SNMP_EXCEPTION_NOSUCHOBJECT	(ASN_CONTEXT | MS_ASN_PRIMITIVE | 0x00)
+#define SNMP_EXCEPTION_NOSUCHINSTANCE	(ASN_CONTEXT | MS_ASN_PRIMITIVE | 0x01)
+#define SNMP_EXCEPTION_ENDOFMIBVIEW	(ASN_CONTEXT | MS_ASN_PRIMITIVE | 0x02)
+#define SNMP_EXTENSION_GET	SNMP_PDU_GET
+#define SNMP_EXTENSION_GET_NEXT	SNMP_PDU_GETNEXT
+#define SNMP_EXTENSION_GET_BULK	SNMP_PDU_GETBULK
+#define SNMP_EXTENSION_SET_TEST	(ASN_PRIVATE | MS_ASN_CONSTRUCTOR | 0x0)
+#define SNMP_EXTENSION_SET_COMMIT	SNMP_PDU_SET
+#define SNMP_EXTENSION_SET_UNDO	(ASN_PRIVATE | MS_ASN_CONSTRUCTOR | 0x1)
+#define SNMP_EXTENSION_SET_CLEANUP	(ASN_PRIVATE | MS_ASN_CONSTRUCTOR | 0x2)
+#define SNMP_ERRORSTATUS_NOERROR	0
+#define SNMP_ERRORSTATUS_TOOBIG	1
+#define SNMP_ERRORSTATUS_NOSUCHNAME	2
+#define SNMP_ERRORSTATUS_BADVALUE	3
+#define SNMP_ERRORSTATUS_READONLY	4
+#define SNMP_ERRORSTATUS_GENERR	5
+#define SNMP_ERRORSTATUS_NOACCESS	6
+#define SNMP_ERRORSTATUS_WRONGTYPE	7
+#define SNMP_ERRORSTATUS_WRONGLENGTH	8
+#define SNMP_ERRORSTATUS_WRONGENCODING	9
+#define SNMP_ERRORSTATUS_WRONGVALUE	10
+#define SNMP_ERRORSTATUS_NOCREATION	11
+#define SNMP_ERRORSTATUS_INCONSISTENTVALUE	12
+#define SNMP_ERRORSTATUS_RESOURCEUNAVAILABLE	13
+#define SNMP_ERRORSTATUS_COMMITFAILED	14
+#define SNMP_ERRORSTATUS_UNDOFAILED	15
+#define SNMP_ERRORSTATUS_AUTHORIZATIONERROR	16
+#define SNMP_ERRORSTATUS_NOTWRITABLE	17
+#define SNMP_ERRORSTATUS_INCONSISTENTNAME	18
+#define SNMP_GENERICTRAP_COLDSTART	0
+#define SNMP_GENERICTRAP_WARMSTART	1
+#define SNMP_GENERICTRAP_LINKDOWN	2
+#define SNMP_GENERICTRAP_LINKUP	3
+#define SNMP_GENERICTRAP_AUTHFAILURE	4
+#define SNMP_GENERICTRAP_EGPNEIGHLOSS	5
+#define SNMP_GENERICTRAP_ENTERSPECIFIC	6
+#define SNMP_ACCESS_NONE	0
+#define SNMP_ACCESS_NOTIFY	1
+#define SNMP_ACCESS_READ_ONLY	2
+#define SNMP_ACCESS_READ_WRITE	3
+#define SNMP_ACCESS_READ_CREATE	4
+#define SNMPAPI_ERROR	FALSE
+#define SNMPAPI_NOERROR	TRUE
+#define SNMP_LOG_SILENT	0
+#define SNMP_LOG_FATAL	1
+#define SNMP_LOG_ERROR	2
+#define SNMP_LOG_WARNING	3
+#define SNMP_LOG_TRACE	4
+#define SNMP_LOG_VERBOSE	5
+#define SNMP_OUTPUT_TO_CONSOLE	1
+#define SNMP_OUTPUT_TO_LOGFILE	2
+#define SNMP_OUTPUT_TO_EVENTLOG	4 
+#define SNMP_OUTPUT_TO_DEBUGGER	8
+#define SNMP_MAX_OID_LEN	128
+#define SNMP_MEM_ALLOC_ERROR	1
+#define SNMP_BERAPI_INVALID_LENGTH	10
+#define SNMP_BERAPI_INVALID_TAG	11
+#define SNMP_BERAPI_OVERFLOW	12
+#define SNMP_BERAPI_SHORT_BUFFER	13
+#define SNMP_BERAPI_INVALID_OBJELEM	14
+#define SNMP_PDUAPI_UNRECOGNIZED_PDU	20
+#define SNMP_PDUAPI_INVALID_ES	21
+#define SNMP_PDUAPI_INVALID_GT	22
+#define SNMP_AUTHAPI_INVALID_VERSION	30
+#define SNMP_AUTHAPI_INVALID_MSG_TYPE	31
+#define SNMP_AUTHAPI_TRIV_AUTH_FAILED	32
+
+#ifndef RC_INVOKED
+
+typedef INT SNMPAPI;
+typedef LONG AsnInteger32;
+typedef ULONG AsnUnsigned32;
+typedef ULARGE_INTEGER AsnCounter64;
+typedef AsnUnsigned32 AsnCounter32;
+typedef AsnUnsigned32 AsnGauge32;
+typedef AsnUnsigned32 AsnTimeticks;
+typedef struct {
+	BYTE *stream;
+	UINT length;
+	BOOL dynamic;
+} AsnOctetString, AsnBits, AsnSequence, AsnImplicitSequence, AsnIPAddress, AsnNetworkAddress, AsnDisplayString, AsnOpaque;
+typedef struct {
+	UINT idLength;
+	UINT *ids;
+} AsnObjectIdentifier, AsnObjectName;
+typedef struct {
+	BYTE asnType;
+	union {
+		AsnInteger32 number; 
+		AsnUnsigned32 unsigned32; 
+		AsnCounter64 counter64; 
+		AsnOctetString string; 
+		AsnBits bits; 
+		AsnObjectIdentifier object; 
+		AsnSequence sequence; 
+		AsnIPAddress address; 
+		AsnCounter32 counter; 
+		AsnGauge32 gauge; 
+		AsnTimeticks ticks; 
+		AsnOpaque arbitrary; 
+	} asnValue;
+} AsnAny, AsnObjectSyntax;
+typedef struct {
+	AsnObjectName name;
+	AsnObjectSyntax value;
+} SnmpVarBind;
+typedef struct {
+	SnmpVarBind *list;
+	UINT len;
+} SnmpVarBindList;
+
+VOID WINSNMPAPI SnmpExtensionClose(void);
+BOOL WINSNMPAPI SnmpExtensionInit(DWORD,HANDLE*,AsnObjectIdentifier*);
+BOOL WINSNMPAPI SnmpExtensionInitEx(AsnObjectIdentifier*);
+BOOL WINSNMPAPI SnmpExtensionMonitor(LPVOID);
+BOOL WINSNMPAPI SnmpExtensionQuery(BYTE,SnmpVarBindList*,AsnInteger32*,AsnInteger32*);
+BOOL WINSNMPAPI SnmpExtensionQueryEx(DWORD,DWORD,SnmpVarBindList*,AsnOctetString*,AsnInteger32*,AsnInteger32*);
+BOOL WINSNMPAPI SnmpExtensionTrap(AsnObjectIdentifier*,AsnInteger32*,AsnInteger32*,AsnTimeticks*,SnmpVarBindList*);
+DWORD WINSNMPAPI SnmpSvcGetUptime(void);
+VOID WINSNMPAPI SnmpSvcSetLogLevel(INT);
+VOID WINSNMPAPI SnmpSvcSetLogType(INT);
+SNMPAPI WINSNMPAPI SnmpUtilAsnAnyCpy(AsnAny*,AsnAny*);
+VOID WINSNMPAPI SnmpUtilAsnAnyFree(AsnAny*);
+VOID WINSNMPAPI SnmpUtilDbgPrint(INT,LPSTR,...);
+LPSTR WINSNMPAPI SnmpUtilIdsToA(UINT*,UINT);
+LPVOID WINSNMPAPI SnmpUtilMemAlloc(UINT);
+VOID WINSNMPAPI SnmpUtilMemFree(LPVOID);
+LPVOID WINSNMPAPI SnmpUtilMemReAlloc(LPVOID,UINT);
+SNMPAPI WINSNMPAPI SnmpUtilOctetsCmp(AsnOctetString*,AsnOctetString*);
+SNMPAPI WINSNMPAPI SnmpUtilOctetsCpy(AsnOctetString*,AsnOctetString*);
+VOID WINSNMPAPI SnmpUtilOctetsFree(AsnOctetString*);
+SNMPAPI WINSNMPAPI SnmpUtilOctetsNCmp(AsnOctetString*,AsnOctetString*,UINT);
+SNMPAPI WINSNMPAPI SnmpUtilOidAppend(AsnObjectIdentifier*,AsnObjectIdentifier*);
+SNMPAPI WINSNMPAPI SnmpUtilOidCmp(AsnObjectIdentifier*,AsnObjectIdentifier*);
+SNMPAPI WINSNMPAPI SnmpUtilOidCpy(AsnObjectIdentifier*,AsnObjectIdentifier*);
+VOID WINSNMPAPI SnmpUtilOidFree(AsnObjectIdentifier*);
+SNMPAPI WINSNMPAPI SnmpUtilOidNCmp(AsnObjectIdentifier*,AsnObjectIdentifier*,UINT);
+LPSTR WINSNMPAPI SnmpUtilOidToA(AsnObjectIdentifier*);
+VOID WINSNMPAPI SnmpUtilPrintAsnAny(AsnAny*);
+VOID WINSNMPAPI SnmpUtilPrintOid(AsnObjectIdentifier*);
+SNMPAPI WINSNMPAPI SnmpUtilVarBindCpy(  SnmpVarBind*,SnmpVarBind*);
+SNMPAPI WINSNMPAPI SnmpUtilVarBindListCpy(SnmpVarBindList*,SnmpVarBindList*);
+VOID WINSNMPAPI SnmpUtilVarBindFree(SnmpVarBind*);
+VOID WINSNMPAPI SnmpUtilVarBindListFree(SnmpVarBindList*);
+
+#ifndef SNMPSTRICT
+#define SNMP_malloc SnmpUtilMemAlloc
+#define SNMP_free SnmpUtilMemFree
+#define SNMP_realloc SnmpUtilMemReAlloc
+#define SNMP_DBG_malloc SnmpUtilMemAlloc
+#define SNMP_DBG_free SnmpUtilMemFree
+#define SNMP_DBG_realloc SnmpUtilMemReAlloc
+#define SNMP_oidappend SnmpUtilOidAppend
+#define SNMP_oidcmp SnmpUtilOidCmp
+#define SNMP_oidcpy SnmpUtilOidCpy
+#define SNMP_oidfree SnmpUtilOidFree
+#define SNMP_oidncmp SnmpUtilOidNCmp
+#define SNMP_printany SnmpUtilPrintAsnAny
+#define SNMP_CopyVarBind SnmpUtilVarBindCpy
+#define SNMP_CopyVarBindList SnmpUtilVarBindListCpy
+#define SNMP_FreeVarBind SnmpUtilVarBindFree
+#define SNMP_FreeVarBindList SnmpUtilVarBindListFree
+#define MS_ASN_RFC1155_IPADDRESS MS_ASN_IPADDRESS
+#define MS_ASN_RFC1155_COUNTER MS_ASN_COUNTER32
+#define MS_ASN_RFC1155_GAUGE MS_ASN_GAUGE32
+#define MS_ASN_RFC1155_TIMETICKS MS_ASN_TIMETICKS
+#define MS_ASN_RFC1155_OPAQUE MS_ASN_OPAQUE
+#define MS_ASN_RFC1213_DISPSTRING MS_ASN_OCTETSTRING
+#define MS_ASN_RFC1157_GETREQUEST SNMP_PDU_GET
+#define MS_ASN_RFC1157_GETNEXTREQUEST SNMP_PDU_GETNEXT
+#define MS_ASN_RFC1157_GETRESPONSE SNMP_PDU_RESPONSE
+#define MS_ASN_RFC1157_SETREQUEST SNMP_PDU_SET
+#define MS_ASN_RFC1157_TRAP SNMP_PDU_V1TRAP
+#define MS_ASN_CONTEXTSPECIFIC MS_ASN_CONTEXT
+#define MS_ASN_PRIMATIVE MS_ASN_PRIMITIVE
+#define RFC1157VarBindList SnmpVarBindList
+#define RFC1157VarBind SnmpVarBind
+#define AsnInteger AsnInteger32
+#define AsnCounter AsnCounter32
+#define AsnGauge AsnGauge32
+#endif /* SNMPSTRICT */
+
+#endif /* RC_INVOKED */
+
+#ifdef __cplusplus
+}
+#endif
+#include <poppack.h>
+#endif

=== modified file 'win32/build.pl'
--- win32/build.pl	2009-11-12 16:17:40 +0000
+++ win32/build.pl	2010-06-10 18:02:54 +0000
@@ -31,7 +31,9 @@
   chomp $current_pwd;
 }
 
-if (! (-d $ENV{MSVCDir})) {
+if ( -d $ENV{MSVCDir} || -d $ENV{VCINSTALLDIR}) {
+}
+else {
   print "\nPlease run VCVARS32.BAT first to set up the Visual Studio build\n" .
         "environment.\n\n";
   system("pause");

=== modified file 'win32/encode_keychange/encode_keychange.dsp'
--- win32/encode_keychange/encode_keychange.dsp	2005-03-31 04:21:37 +0000
+++ win32/encode_keychange/encode_keychange.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/libagent/libagent.dsp'
--- win32/libagent/libagent.dsp	2004-09-13 12:06:21 +0000
+++ win32/libagent/libagent.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe

=== modified file 'win32/libhelpers/libhelpers.dsp'
--- win32/libhelpers/libhelpers.dsp	2007-05-10 22:20:23 +0000
+++ win32/libhelpers/libhelpers.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe

=== modified file 'win32/libnetsnmptrapd/libnetsnmptrapd.dsp'
--- win32/libnetsnmptrapd/libnetsnmptrapd.dsp	2007-05-10 22:20:23 +0000
+++ win32/libnetsnmptrapd/libnetsnmptrapd.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -99,10 +99,6 @@
 
 SOURCE=..\..\apps\snmptrapd_auth.c
 # End Source File
-# Begin Source File
-
-SOURCE=..\..\agent\mibgroup\notification-log-mib\notification_log.c
-# End Source File
 # End Group
 # Begin Group "Header Files"
 

=== modified file 'win32/libsnmp/libsnmp.dsp'
--- win32/libsnmp/libsnmp.dsp	2007-12-08 14:59:50 +0000
+++ win32/libsnmp/libsnmp.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe

=== modified file 'win32/libsnmp_dll/libsnmp.def'
--- win32/libsnmp_dll/libsnmp.def	2009-11-12 16:17:40 +0000
+++ win32/libsnmp_dll/libsnmp.def	2010-06-10 18:02:54 +0000
@@ -52,6 +52,7 @@
 	clear_tree_flags
 	get_tree
 	read_module
+	netsnmp_read_module
 	read_mib
 	read_all_mibs
 	add_mibdir
@@ -248,6 +249,7 @@
 	copy_nword
 	calculate_time_diff
 	vacm_is_configured
+	get_configuration_directory
 	vacm_createGroupEntry
 	vacm_destroyGroupEntry
 	vacm_destroyAllGroupEntries
@@ -381,6 +383,7 @@
 	netsnmp_ds_get_void
 	netsnmp_ds_set_void
 	netsnmp_ds_shutdown
+	netsnmp_sprint_realloc_objid
 	netsnmp_sprint_realloc_objid_tree
 	module_name
 	Mib                     DATA
@@ -447,6 +450,7 @@
         netsnmp_query_getnext
         netsnmp_query_get
 	netsnmp_mktemp
+        debugmsg_suboid
 ;IPv6        netsnmp_udp6_parse_security
 ;IPv6        netsnmp_udp6_getSecName
 ;IPv6        netsnmp_TCPIPv6Domain

=== modified file 'win32/libsnmp_dll/libsnmp.def.in'
--- win32/libsnmp_dll/libsnmp.def.in	2009-11-12 16:17:40 +0000
+++ win32/libsnmp_dll/libsnmp.def.in	2010-06-10 18:02:54 +0000
@@ -52,6 +52,7 @@
 	clear_tree_flags
 	get_tree
 	read_module
+	netsnmp_read_module
 	read_mib
 	read_all_mibs
 	add_mibdir
@@ -248,6 +249,7 @@
 	copy_nword
 	calculate_time_diff
 	vacm_is_configured
+	get_configuration_directory
 	vacm_createGroupEntry
 	vacm_destroyGroupEntry
 	vacm_destroyAllGroupEntries
@@ -381,6 +383,7 @@
 	netsnmp_ds_get_void
 	netsnmp_ds_set_void
 	netsnmp_ds_shutdown
+	netsnmp_sprint_realloc_objid
 	netsnmp_sprint_realloc_objid_tree
 	module_name
 	Mib                     DATA
@@ -447,6 +450,7 @@
         netsnmp_query_getnext
         netsnmp_query_get
 	netsnmp_mktemp
+        debugmsg_suboid
 ;IPv6        netsnmp_udp6_parse_security
 ;IPv6        netsnmp_udp6_getSecName
 ;IPv6        netsnmp_TCPIPv6Domain

=== modified file 'win32/libsnmp_dll/libsnmp_dll.dsp'
--- win32/libsnmp_dll/libsnmp_dll.dsp	2007-12-08 14:59:50 +0000
+++ win32/libsnmp_dll/libsnmp_dll.dsp	2010-06-10 18:02:54 +0000
@@ -42,8 +42,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
 # ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /o "NUL" /win32
 # ADD MTL /nologo /D "NDEBUG" /mktyplib203 /o "NUL" /win32
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
@@ -68,8 +68,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "NETSNMP_DLL" /YX /FD /c
 # ADD BASE MTL /nologo /D "_DEBUG" /mktyplib203 /o "NUL" /win32
 # ADD MTL /nologo /D "_DEBUG" /mktyplib203 /o "NUL" /win32
 # ADD BASE RSC /l 0x409 /d "_DEBUG"

=== modified file 'win32/net-snmp/agent/mib_module_config.h'
--- win32/net-snmp/agent/mib_module_config.h	2007-05-10 22:20:23 +0000
+++ win32/net-snmp/agent/mib_module_config.h	2010-06-10 18:02:54 +0000
@@ -15,6 +15,13 @@
 /* Define if compiling with the notification module files.  */
 #define USING_NOTIFICATION_MODULE 1
  
+/* Define if compiling with the notification-log-mib module files. */
+#ifdef HAVE_WIN32_PLATFORM_SDK
+#define USING_NOTIFICATION_LOG_MIB_NOTIFICATION_LOG_MODULE 1
+#else
+/* #undef USING_NOTIFICATION_LOG_MIB_NOTIFICATION_LOG_MODULE */
+#endif
+
 /* Define if compiling with the target module files.  */
 #define USING_TARGET_MODULE 1
  
@@ -133,7 +140,7 @@
  
 /* Define if compiling with the snmpv3/usmUser module files.  */
 #define USING_SNMPV3_USMUSER_MODULE 1
- 
+
 /* Define if compiling with the notification/snmpNotifyTable module files.  */
 #define USING_NOTIFICATION_SNMPNOTIFYTABLE_MODULE 1
  

=== modified file 'win32/net-snmp/net-snmp-config.h'
--- win32/net-snmp/net-snmp-config.h	2007-12-08 14:59:50 +0000
+++ win32/net-snmp/net-snmp-config.h	2010-06-10 18:02:54 +0000
@@ -4,6 +4,14 @@
 #ifndef NET_SNMP_CONFIG_H
 #define NET_SNMP_CONFIG_H
 
+/* _MSC_VER values
+   1500 = 9.0 (2008)
+   1400 = 8.0 (2005)
+   1310 = 7.1 (2003)
+   1300 = 7.0 (2002)
+   1200 = 6.0
+*/
+
 /* Define HAVE_WIN32_PLATFORM_SDK if you have:
  * Microsoft Visual Studio MSVC 6.0 and the Platform SDK (PSDK)
  * Microsoft Visual Studio.Net 2002
@@ -13,6 +21,17 @@
  */
 /* #undef HAVE_WIN32_PLATFORM_SDK */
 
+/* Only use Windows API functions available on Windows 2000 SP4 or later.
+ * We need at least SP1 for some IPv6 defines in ws2ipdef.h.
+ * Only define _WIN32_WINNT when not being compiled with MSVC 6 without PSDK
+ * because there is a bug in the MSVC 6 header <winsock.h> that causes
+ * inclusion of <winsock2.h>.
+ */
+#if defined(HAVE_WIN32_PLATFORM_SDK) || !defined(_MSC_VER) || _MSC_VER > 1200
+#define _WIN32_WINNT 0x500 /*_WIN32_WINNT_WIN2K*/
+#define NTDDI_VERSION 0x05000400 /* NTDDI_WIN2KSP4 */
+#endif
+
 #define INSTALL_BASE "c:/usr"
 
 /* config.h:  a general config file */
@@ -210,6 +229,9 @@
 /* Define to 1 if you have the `cgetnext' function. */
 /* #undef HAVE_CGETNEXT */
 
+/* Define to 1 if you have the <direct.h> header file. */
+/* #undef HAVE_DIRECT_H */
+
 /* Define to 1 if you have the `chown' function. */
 /* #undef HAVE_CHOWN */
 
@@ -1553,7 +1575,10 @@
 /* define to 1 if you do not want to set global snmp_errno */
 #define DONT_SHARE_ERROR_WITH_OTHER_THREADS 1
 
+/* Not needed for MSVC 2008 */
+#if _MSC_VER < 1500
 #define vsnprintf _vsnprintf
+#endif
 #define snprintf  _snprintf
 
 #define EADDRINUSE	WSAEADDRINUSE
@@ -1628,21 +1653,21 @@
 #define EXTENSIBLEMIB NETSNMP_UCDAVIS_MIB
 #endif
 
-#if defined(_MSC_VER)
-/* this bit of magic enables or disables IPv6 transports */
-  #if NETSNMP_ENABLE_IPV6
-    /* "dont have" implies "compile here" for snmplib/inet_?to?.c */
-    #undef HAVE_INET_NTOP
-    #undef HAVE_INET_PTON
-    #define NETSNMP_TRANSPORT_TCPIPV6_DOMAIN 1
-    #define NETSNMP_TRANSPORT_UDPIPV6_DOMAIN 1
-  #else
-    /* "have" implies "dont compile here" for snmplib/inet_?to?.c */
-    #define HAVE_INET_NTOP 1
-    #define HAVE_INET_PTON 1
-    #undef NETSNMP_TRANSPORT_TCPIPV6_DOMAIN
-    #undef NETSNMP_TRANSPORT_UDPIPV6_DOMAIN
+/* Windows Vista and higher have inet_ntop but older Windows does not.
+ * We'll use the Net-SNMP version instead. */
+#undef HAVE_INET_NTOP
+#undef HAVE_INET_PTON
+
+#if NETSNMP_ENABLE_IPV6
+  #ifndef IPPROTO_IPV6
+    /* Only defined in Windows XP or higher, so we need it here */
+    #define IPPROTO_IPV6 41
   #endif
+  #define NETSNMP_TRANSPORT_TCPIPV6_DOMAIN 1
+  #define NETSNMP_TRANSPORT_UDPIPV6_DOMAIN 1
+#else
+  #undef NETSNMP_TRANSPORT_TCPIPV6_DOMAIN
+  #undef NETSNMP_TRANSPORT_UDPIPV6_DOMAIN
 #endif
 
 #ifndef NI_MAXHOST

=== modified file 'win32/net-snmp/net-snmp-config.h.in'
--- win32/net-snmp/net-snmp-config.h.in	2007-12-08 14:59:50 +0000
+++ win32/net-snmp/net-snmp-config.h.in	2010-06-10 18:02:54 +0000
@@ -4,6 +4,14 @@
 #ifndef NET_SNMP_CONFIG_H
 #define NET_SNMP_CONFIG_H
 
+/* _MSC_VER values
+   1500 = 9.0 (2008)
+   1400 = 8.0 (2005)
+   1310 = 7.1 (2003)
+   1300 = 7.0 (2002)
+   1200 = 6.0
+*/
+
 /* Define HAVE_WIN32_PLATFORM_SDK if you have:
  * Microsoft Visual Studio MSVC 6.0 and the Platform SDK (PSDK)
  * Microsoft Visual Studio.Net 2002
@@ -13,6 +21,17 @@
  */
 /* #undef HAVE_WIN32_PLATFORM_SDK */
 
+/* Only use Windows API functions available on Windows 2000 SP4 or later.
+ * We need at least SP1 for some IPv6 defines in ws2ipdef.h.
+ * Only define _WIN32_WINNT when not being compiled with MSVC 6 without PSDK
+ * because there is a bug in the MSVC 6 header <winsock.h> that causes
+ * inclusion of <winsock2.h>.
+ */
+#if defined(HAVE_WIN32_PLATFORM_SDK) || !defined(_MSC_VER) || _MSC_VER > 1200
+#define _WIN32_WINNT 0x500 /*_WIN32_WINNT_WIN2K*/
+#define NTDDI_VERSION 0x05000400 /* NTDDI_WIN2KSP4 */
+#endif
+
 #define INSTALL_BASE "c:/usr"
 
 /* config.h:  a general config file */
@@ -210,6 +229,9 @@
 /* Define to 1 if you have the `cgetnext' function. */
 /* #undef HAVE_CGETNEXT */
 
+/* Define to 1 if you have the <direct.h> header file. */
+/* #undef HAVE_DIRECT_H */
+
 /* Define to 1 if you have the `chown' function. */
 /* #undef HAVE_CHOWN */
 
@@ -1553,7 +1575,10 @@
 /* define to 1 if you do not want to set global snmp_errno */
 #define DONT_SHARE_ERROR_WITH_OTHER_THREADS 1
 
+/* Not needed for MSVC 2008 */
+#if _MSC_VER < 1500
 #define vsnprintf _vsnprintf
+#endif
 #define snprintf  _snprintf
 
 #define EADDRINUSE	WSAEADDRINUSE
@@ -1628,21 +1653,21 @@
 #define EXTENSIBLEMIB NETSNMP_UCDAVIS_MIB
 #endif
 
-#if defined(_MSC_VER)
-/* this bit of magic enables or disables IPv6 transports */
-  #if NETSNMP_ENABLE_IPV6
-    /* "dont have" implies "compile here" for snmplib/inet_?to?.c */
-    #undef HAVE_INET_NTOP
-    #undef HAVE_INET_PTON
-    #define NETSNMP_TRANSPORT_TCPIPV6_DOMAIN 1
-    #define NETSNMP_TRANSPORT_UDPIPV6_DOMAIN 1
-  #else
-    /* "have" implies "dont compile here" for snmplib/inet_?to?.c */
-    #define HAVE_INET_NTOP 1
-    #define HAVE_INET_PTON 1
-    #undef NETSNMP_TRANSPORT_TCPIPV6_DOMAIN
-    #undef NETSNMP_TRANSPORT_UDPIPV6_DOMAIN
+/* Windows Vista and higher have inet_ntop but older Windows does not.
+ * We'll use the Net-SNMP version instead. */
+#undef HAVE_INET_NTOP
+#undef HAVE_INET_PTON
+
+#if NETSNMP_ENABLE_IPV6
+  #ifndef IPPROTO_IPV6
+    /* Only defined in Windows XP or higher, so we need it here */
+    #define IPPROTO_IPV6 41
   #endif
+  #define NETSNMP_TRANSPORT_TCPIPV6_DOMAIN 1
+  #define NETSNMP_TRANSPORT_UDPIPV6_DOMAIN 1
+#else
+  #undef NETSNMP_TRANSPORT_TCPIPV6_DOMAIN
+  #undef NETSNMP_TRANSPORT_UDPIPV6_DOMAIN
 #endif
 
 #ifndef NI_MAXHOST

=== modified file 'win32/netsnmpmibs/netsnmpmibs.dsp'
--- win32/netsnmpmibs/netsnmpmibs.dsp	2007-05-10 22:20:23 +0000
+++ win32/netsnmpmibs/netsnmpmibs.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe

=== modified file 'win32/netsnmpmibssdk/Makefile.in'
--- win32/netsnmpmibssdk/Makefile.in	2009-11-12 16:17:40 +0000
+++ win32/netsnmpmibssdk/Makefile.in	2010-06-10 18:02:54 +0000
@@ -62,6 +62,7 @@
 	-@erase "$(INTDIR)\snmpEngine.obj"
 	-@erase "$(INTDIR)\snmpMPDStats.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterProfileTable.obj"
+	-@erase "$(INTDIR)\notification_log.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable_data_access.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable_interface.obj"
@@ -161,6 +162,7 @@
 	"$(INTDIR)\usmStats.obj" \
 	"$(INTDIR)\usmUser.obj" \
 	"$(INTDIR)\snmpNotifyFilterProfileTable.obj" \
+	"$(INTDIR)\notification_log.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable_data_access.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable_interface.obj" \
@@ -269,6 +271,7 @@
 	-@erase "$(INTDIR)\snmpEngine.obj"
 	-@erase "$(INTDIR)\snmpMPDStats.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterProfileTable.obj"
+	-@erase "$(INTDIR)\notification_log.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable_data_access.obj"
 	-@erase "$(INTDIR)\snmpNotifyFilterTable_interface.obj"
@@ -369,6 +372,7 @@
 	"$(INTDIR)\usmStats.obj" \
 	"$(INTDIR)\usmUser.obj" \
 	"$(INTDIR)\snmpNotifyFilterProfileTable.obj" \
+	"$(INTDIR)\notification_log.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable_data_access.obj" \
 	"$(INTDIR)\snmpNotifyFilterTable_interface.obj" \
@@ -576,6 +580,12 @@
 	$(CPP) $(CPP_PROJ) $(SOURCE)
 
 
+SOURCE=..\..\agent\mibgroup\notification-log-mib\notification_log.c
+
+"$(INTDIR)\notification_log.obj" : $(SOURCE) "$(INTDIR)"
+	$(CPP) $(CPP_PROJ) $(SOURCE)
+
+
 SOURCE=..\..\agent\mibgroup\snmp-notification-mib\snmpNotifyFilterTable\snmpNotifyFilterTable.c
 
 "$(INTDIR)\snmpNotifyFilterTable.obj" : $(SOURCE) "$(INTDIR)"

=== modified file 'win32/netsnmpmibssdk/netsnmpmibssdk.dsp'
--- win32/netsnmpmibssdk/netsnmpmibssdk.dsp	2007-05-10 22:20:23 +0000
+++ win32/netsnmpmibssdk/netsnmpmibssdk.dsp	2010-06-10 18:02:54 +0000
@@ -40,8 +40,8 @@
 # PROP Output_Dir "../lib/release"
 # PROP Intermediate_Dir "Release"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -49,7 +49,7 @@
 # ADD BSC32 /nologo
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 iphlpapi.lib /nologo /out:"../lib/release/netsnmpmibs.lib"
+# ADD LIB32 iphlpapi.lib mgmtapi.lib snmpapi.lib /nologo /out:"../lib/release/netsnmpmibs.lib"
 
 !ELSEIF  "$(CFG)" == "netsnmpmibssdk - Win32 Debug"
 
@@ -63,8 +63,8 @@
 # PROP Output_Dir "../lib/debug"
 # PROP Intermediate_Dir "Debug"
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
 # ADD BASE RSC /l 0x409
 # ADD RSC /l 0x409
 BSC32=bscmake.exe
@@ -72,7 +72,7 @@
 # ADD BSC32 /nologo
 LIB32=link.exe -lib
 # ADD BASE LIB32 /nologo
-# ADD LIB32 iphlpapi.lib /nologo /out:"../lib/debug/netsnmpmibs.lib"
+# ADD LIB32 iphlpapi.lib mgmtapi.lib snmpapi.lib /nologo /out:"../lib/debug/netsnmpmibs.lib"
 
 !ENDIF 
 
@@ -193,6 +193,10 @@
 # End Source File
 # Begin Source File
 
+SOURCE=..\..\agent\mibgroup\notification-log-mib\notification_log.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\..\agent\mibgroup\snmp-notification-mib\snmpNotifyFilterTable\snmpNotifyFilterTable.c
 # End Source File
 # Begin Source File
@@ -408,5 +412,9 @@
 
 SOURCE=..\..\agent\mibgroup\smux\smux.c
 # End Source File
+# Begin Source File
+
+SOURCE=..\..\agent\mibgroup\winExtDLL.c
+# End Source File
 # End Target
 # End Project

=== modified file 'win32/snmpbulkget/snmpbulkget.dsp'
--- win32/snmpbulkget/snmpbulkget.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpbulkget/snmpbulkget.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpbulkwalk/snmpbulkwalk.dsp'
--- win32/snmpbulkwalk/snmpbulkwalk.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpbulkwalk/snmpbulkwalk.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpd/snmpd.dsp'
--- win32/snmpd/snmpd.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpd/snmpd.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpdelta/snmpdelta.dsp'
--- win32/snmpdelta/snmpdelta.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpdelta/snmpdelta.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpdf/snmpdf.dsp'
--- win32/snmpdf/snmpdf.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpdf/snmpdf.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpdsdk/snmpd.dsp'
--- win32/snmpdsdk/snmpd.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpdsdk/snmpd.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /D "HAVE_WIN32_PLATFORM_SDK" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpget/snmpget.dsp'
--- win32/snmpget/snmpget.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpget/snmpget.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpgetnext/snmpgetnext.dsp'
--- win32/snmpgetnext/snmpgetnext.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpgetnext/snmpgetnext.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpnetstat/snmpnetstat.dsp'
--- win32/snmpnetstat/snmpnetstat.dsp	2007-05-10 22:20:23 +0000
+++ win32/snmpnetstat/snmpnetstat.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpset/snmpset.dsp'
--- win32/snmpset/snmpset.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpset/snmpset.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpstatus/snmpstatus.dsp'
--- win32/snmpstatus/snmpstatus.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpstatus/snmpstatus.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmptable/snmptable.dsp'
--- win32/snmptable/snmptable.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmptable/snmptable.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmptest/snmptest.dsp'
--- win32/snmptest/snmptest.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmptest/snmptest.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmptranslate/snmptranslate.dsp'
--- win32/snmptranslate/snmptranslate.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmptranslate/snmptranslate.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmptrap/snmptrap.dsp'
--- win32/snmptrap/snmptrap.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmptrap/snmptrap.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmptrapd/snmptrapd.dsp'
--- win32/snmptrapd/snmptrapd.dsp	2007-05-10 22:20:23 +0000
+++ win32/snmptrapd/snmptrapd.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent\mibgroup" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /I "..\..\agent\mibgroup" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpusm/snmpusm.dsp'
--- win32/snmpusm/snmpusm.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpusm/snmpusm.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpvacm/snmpvacm.dsp'
--- win32/snmpvacm/snmpvacm.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpvacm/snmpvacm.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/snmpwalk/snmpwalk.dsp'
--- win32/snmpwalk/snmpwalk.dsp	2005-03-31 04:21:37 +0000
+++ win32/snmpwalk/snmpwalk.dsp	2010-06-10 18:02:54 +0000
@@ -41,8 +41,8 @@
 # PROP Intermediate_Dir "Release"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
 # ADD RSC /l 0x409 /d "NDEBUG"
 BSC32=bscmake.exe
@@ -65,8 +65,8 @@
 # PROP Intermediate_Dir "Debug"
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /FR /YX /FD /c
+# ADD BASE CPP /nologo /W3 /Gm /GX /Zi /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /Zi /Od /I "." /I ".." /I "..\..\snmplib" /I "..\.." /I "..\..\include" /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_CRT_SECURE_NO_WARNINGS" /D "_CRT_NONSTDC_NO_WARNINGS" /D "_MBCS" /FR /YX /FD /c
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
 # ADD RSC /l 0x409 /d "_DEBUG"
 BSC32=bscmake.exe

=== modified file 'win32/win32.dsw'
--- win32/win32.dsw	2005-03-31 04:21:37 +0000
+++ win32/win32.dsw	2010-06-10 18:02:54 +0000
@@ -71,6 +71,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -83,6 +86,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -95,6 +101,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -107,6 +116,18 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libagent
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libhelpers
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name netsnmpmibs
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -119,6 +140,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -131,6 +155,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -143,6 +170,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -155,6 +185,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -167,6 +200,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -179,6 +215,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -191,6 +230,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -203,6 +245,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -215,6 +260,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -227,6 +275,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -239,6 +290,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -251,6 +305,21 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libagent
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libhelpers
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name netsnmpmibs
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libnetsnmptrapd
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -263,6 +332,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -275,6 +347,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -287,6 +362,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################

=== modified file 'win32/win32sdk.dsw'
--- win32/win32sdk.dsw	2005-03-31 04:21:37 +0000
+++ win32/win32sdk.dsw	2010-06-10 18:02:54 +0000
@@ -71,6 +71,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -83,6 +86,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -95,6 +101,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -107,6 +116,18 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libagent
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libhelpers
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name netsnmpmibssdk
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -119,6 +140,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -131,6 +155,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -143,6 +170,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -155,6 +185,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -167,6 +200,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -179,6 +215,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -191,6 +230,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -203,6 +245,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -215,6 +260,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -227,6 +275,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -239,6 +290,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -251,6 +305,21 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libagent
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libhelpers
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name netsnmpmibssdk
+  End Project Dependency
+  Begin Project Dependency
+  Project_Dep_Name libnetsnmptrapd
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -263,6 +332,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -275,6 +347,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################
@@ -287,6 +362,9 @@
 
 Package=<4>
 {{{
+  Begin Project Dependency
+  Project_Dep_Name libsnmp
+  End Project Dependency
 }}}
 
 ###############################################################################

